#import <Foundation/NSDate.h>
#import <AppKit/NSActionCell.h>

/* Date Picker Style

The NSDatePickerStyle constants define the visual appearance of the NSDatePickerCell. These values are used by datePickerStyle and setDatePickerStyle:.

   
enum {
   NSTextFieldAndStepperDatePickerStyle    = 0,
   NSClockAndCalendarDatePickerStyle       = 1,
   NSTextFieldDatePickerStyle              = 2
};
typedef NSUInteger NSDatePickerStyle;

Constants

NSTextFieldAndStepperDatePickerStyle

    Provide a text field and stepper style interface.
NSClockAndCalendarDatePickerStyle

    Provide a visual clock and calendar style interface.
NSTextFieldDatePickerStyle

    Provide a text field interface.

Declared In
NSDatePickerCell.h */
enum {
   NSTextFieldAndStepperDatePickerStyle    = 0,
   NSClockAndCalendarDatePickerStyle       = 1,
   NSTextFieldDatePickerStyle              = 2
};
typedef NSUInteger NSDatePickerStyle;

/* Date Picker Elements

The NSDatePickerElementFlag constants allow you to specify the date and time elements that the NSDatePickerCell can edit by combining these constants using the C bitwise OR operator. These values are used by datePickerElements and setDatePickerElements::

   
enum {
   NSHourMinuteDatePickerElementFlag       = 0x000c,
   NSHourMinuteSecondDatePickerElementFlag = 0x000e,
   NSTimeZoneDatePickerElementFlag        = 0x0010,
   
   NSYearMonthDatePickerElementFlag        = 0x00c0,
   NSYearMonthDayDatePickerElementFlag        = 0x00e0,
   NSEraDatePickerElementFlag            = 0x0100,
};
typedef NSUInteger NSDatePickerElementFlags;

Constants

NSHourMinuteDatePickerElementFlag

    Display and allow editing of the hour and minute elements of the date.
NSHourMinuteSecondDatePickerElementFlag

    Display and allow editing of the hour, minute and second elements of the date.
NSTimeZoneDatePickerElementFlag

    Display and allow editing of the time zone.

    This flag has been declared for possible future use, and does not yet have any effect.
NSYearMonthDatePickerElementFlag

    Display and allow editing of the year and month elements of the date.
NSYearMonthDayDatePickerElementFlag

    Display and allow editing of the year, month and day elements of the date.
NSEraDatePickerElementFlag

    Display and allow editing of the era of the date, if applicable.

    This flag has been declared for possible future use, and does not yet have any effect.

Declared In
NSDatePickerCell.h  */
enum {
   NSHourMinuteDatePickerElementFlag       = 0x000c,
   NSHourMinuteSecondDatePickerElementFlag = 0x000e,
   NSTimeZoneDatePickerElementFlag        = 0x0010,
   
   NSYearMonthDatePickerElementFlag        = 0x00c0,
   NSYearMonthDayDatePickerElementFlag        = 0x00e0,
   NSEraDatePickerElementFlag            = 0x0100,
};
typedef NSUInteger NSDatePickerElementFlags;

/* Date Picker Mode

The NSDatePickerMode constants define whether the control provides a single date, or a range of dates. These values are used by datePickerMode and setDatePickerMode:. Currently only NSSingleDateMode is implemented.

   
enum {
   NSSingleDateMode = 0,
   NSRangeDateMode = 1
};
typedef NSUInteger NSDatePickerMode;

Constants

NSSingleDateMode

    Allow selection of a single date.
NSRangeDateMode

    Allow selection of a range of dates. (Not currently implemented.)

Declared In
NSDatePickerCell.h */
enum {
   NSSingleDateMode = 0,
   NSRangeDateMode = 1
};
typedef NSUInteger NSDatePickerMode;

@class NSCalendar, NSLocale, NSTimeZone;

@interface NSDatePickerCell : NSActionCell

/* delegate

Returns the receivers delegate.

- (id)delegate
Return Value

The receivers delegate.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? setDelegate:

Declared In
NSDatePickerCell.h */
- (id)delegate;

@end

@interface NSObject (NSDatePickerCellDelegate)

@end

