#ifndef LOWMEM_H
#define LOWMEM_H

#include <CarbonCore/MacTypes.h>
#include <CarbonCore/Files.h>
#include <CarbonCore/MacMemory.h>
#include <CarbonCore/OSUtils.h>
#include <CarbonCore/Resources.h>
#include <AvailabilityMacros.h>
//#include <QD/Quickdraw.h>//hys
//#include <QD/QD.h>//hys

#include <HYS/CarbonCore/LowMem.h>

#ifdef __cplusplus
extern "C" {
#endif

/*LMGetHeapEnd

(Deprecated in Mac OS X v10.4. There is no replacement; this function was included to facilitate porting legacy applications to Carbon, but it serves no useful purpose in Mac OS X.)

Ptr LMGetHeapEnd (void);
Availability
Available in Mac OS X v10.0 and later.
Deprecated in Mac OS X v10.4.
Declared In
LowMem.h*/
Ptr LMGetHeapEnd (void);

/*LMSetHeapEnd

(Deprecated in Mac OS X v10.4. There is no replacement; this function was included to facilitate porting legacy applications to Carbon, but it serves no useful purpose in Mac OS X.)

void LMSetHeapEnd (
   Ptr value
);
Availability
Available in Mac OS X v10.0 and later.
Deprecated in Mac OS X v10.4.
Declared In
LowMem.h*/
void LMSetHeapEnd (
   Ptr value
);

/*LMGetSysFontFam

(Deprecated in Mac OS X v10.4. Use GetSysFont instead.)

SInt16 LMGetSysFontFam (void);
Availability
Available in Mac OS X v10.0 and later.
Deprecated in Mac OS X v10.4.
Declared In
LowMem.h*/
SInt16 LMGetSysFontFam (void);

/*LMGetSysFontSize

(Deprecated in Mac OS X v10.4. Use GetDefFontSize instead.)

SInt16 LMGetSysFontSize (void);
Availability
Available in Mac OS X v10.0 and later.
Deprecated in Mac OS X v10.4.
Declared In
LowMem.h*/
SInt16 LMGetSysFontSize (void);

/*LMSetSysFontFam

(Deprecated in Mac OS X v10.4. There is no replacement; this function was included to facilitate porting legacy applications to Carbon, but it serves no useful purpose in Mac OS X.)

void LMSetSysFontFam (
   SInt16 value
);
Availability
Available in Mac OS X v10.0 and later.
Deprecated in Mac OS X v10.4.
Declared In
LowMem.h*/
void LMSetSysFontFam (
   SInt16 value
);

/*LMSetSysFontSize


void LMSetSysFontSize (
   SInt16 value
);
Availability
Available in Mac OS X v10.0 and later.
Declared In
LowMem.h*/

void LMSetSysFontSize (
   SInt16 value
);

/*LMGetCurApName


StringPtr LMGetCurApName (void);
Availability
Available in Mac OS X v10.0 and later.
Declared In
LowMem.h*/
StringPtr LMGetCurApName (void);

#ifdef __cplusplus
}
#endif
#endif
