

#if !defined(OC__COREFOUNDATION_CFATTRIBUTEDSTRING__)
#define OC__COREFOUNDATION_CFATTRIBUTEDSTRING__ 1

#include <CoreFoundation/CFBase.h>
#include <CoreFoundation/CFString.h>
#include <CoreFoundation/CFDictionary.h>
#include <stdarg.h>

#if defined(__cplusplus)
extern "C" {
#endif

/*CFAttributedStringRef

A reference to a CFAttributedString object.

typedef const struct __CFAttributedString *CFAttributedStringRef;

Discussion

The CFAttributedStringRef type refers to an object that combines a CFString object with a collection of attributes that specify how the characters in the string should be displayed. CFAttributedString is an opaque type that defines the characteristics and behavior of CFAttributedString objects. 

Values of type CFAttributedStringRef may refer to immutable or mutable strings, as CFMutableAttributedString objects respond to all functions intended for immutable CFAttributedString objects. Functions which accept CFAttributedStringRef values, and which need to hold on to the values immutably, should call CFAttributedStringCreateWithSubstring (instead of CFRetain) to do so.
Availability
Available in Mac OS X v10.4 and later.
Declared In
CFAttributedString.h*/
typedef const struct __CFAttributedString *CFAttributedStringRef;

#if defined(__cplusplus)
}
#endif

#endif //__COREFOUNDATION_CFATTRIBUTEDSTRING__



