
#if !defined(OC__COREFOUNDATION_CFBASE__)
#define OC__COREFOUNDATION_CFBASE__ 1

#if defined(__WIN32__)
#include <windows.h>
#endif

#if defined(__GNUC__)
#include <stdint.h>
#include <stdbool.h>
#elif defined(__WIN32__)
#include <GNUCompatibility/stdint.h>
#include <GNUCompatibility/stdbool.h>
#endif

#include <AvailabilityMacros.h>

//#ifndef CF_OPEN_SOURCE
//   #if defined(__CF_USE_FRAMEWORK_INCLUDES__) || (defined(__MACH__) && !defined(__MWERKS__)) 
	#include <CarbonCore/MacTypes.h>
    //#elif defined(__MWERKS__)
	//#include <MacTypes.h>
    //#endif
//#else // CF_OPEN_SOURCE
   // #if defined(__MACH__)
        #include <libkern/OSTypes.h>
    //#endif
//#endif // CF_OPEN_SOURCE


#ifndef OC_CF

#ifndef __MACH__
	#define __MACH__
	#define __MACH__DEFS
#endif

#ifdef __private_extern__
#undef __private_extern__ 
#define __private_extern__DEF
#endif

#include "/usr/include/CoreFoundation/CFBase.h"

#ifdef __private_extern__DEF
#ifndef __private_extern__
	#define __private_extern__ 
#endif	
#endif

#ifdef __MACH__DEFS
	#undef __MACH__DEFS
	#undef __MACH__
#endif

#endif //OC_CF

#if defined(__cplusplus)
extern "C" {
#endif

#include <HYS/CoreFoundation/CFBase.h>

#ifndef TRUE
    #define TRUE   1
#endif

#ifndef FALSE
    #define FALSE   0
#endif

#ifndef	UTF32Char
#define	UTF32Char	uint32_t
#endif//GNUStepBase/GSConfig_h
#ifndef __uint32_t_defined
#define __uint32_t_defined
typedef unsigned long uint32_t;
#endif//cygwin-sys-stdint.h

/*Value Not Found

Special value returned when a Core Foundation function cannot locate a requested value.

enum {
   kCFNotFound = -1
};
Constants
kCFNotFound

A constant that indicates that a search operation did not succeed in locating the target value.

Available in Mac OS X v10.0 and later.*/

#ifdef OC_CF
enum {
   kCFNotFound = -1
};
#endif

/*CFTypeRef

An untyped "generic" reference to any Core Foundation object.

typedef const void * CFTypeRef;
Discussion

The CFTypeRef type is the base type defined in Core Foundation. It is used as the type and return value in several polymorphic functions. It is a generic object reference that acts as a placeholder for other true Core Foundation objects. 
Availability
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
typedef const void * CFTypeRef;
#endif

/*CFAllocatorReleaseCallBack

A prototype for a function callback that releases the given data.

typedef void (*CFAllocatorReleaseCallBack) (
   const void *info
);

If you name your function MyCallBack, you would declare it like this:

void MyCallBack (
   const void *info
);
Parameters
info

The data to be released.
Discussion

A prototype for a function callback that releases the data pointed to by the info field. In implementing this function, release (or free) the data you have defined for the allocator context.*/
#ifdef OC_CF
typedef void (*CFAllocatorReleaseCallBack) (
   const void *info
);
#endif

/*CFOptionFlags

A bitfield used for passing special allocation and other requests into Core Foundation functions.

typedef UInt32 CFOptionFlags;
Discussion

The flag bits are specific to particular opaque types and functions in Core Foundation.
Availability
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
typedef UInt32 CFOptionFlags;
#endif

/*CFAllocatorRetainCallBack

A prototype for a function callback that retains the given data.

typedef const void *(*CFAllocatorRetainCallBack) (
   const void *info
);

If you name your function MyCallBack, you would declare it like this:

const void *MyCallBack (
   const void *info
);
Parameters
info

The data to be retained.
Discussion

A prototype for a function callback that retains the data pointed to by the info field. In implementing this function, retain the data you have defined for the allocator context in this field. (This might make sense only if the data is a Core Foundation object.)*/
#ifdef OC_CF
typedef const void *(*CFAllocatorRetainCallBack) (
   const void *info
);
#endif

/*CFHashCode

A type for hash codes returned by the CFHash function.

typedef UInt32 CFHashCode;
Availability
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
typedef UInt32 CFHashCode;
#endif

/*Comparison Results

Constants returned by comparison functions, indicating whether a value is equal to, less than, or greater than another value.

enum CFComparisonResult {
   kCFCompareLessThan = -1,
   kCFCompareEqualTo = 0,
   kCFCompareGreaterThan = 1
};
typedef enum CFComparisonResult CFComparisonResult;
Constants
kCFCompareLessThan

Returned by a comparison function if the first value is less than the second value.

Available in Mac OS X v10.0 and later.
kCFCompareEqualTo

Returned by a comparison function if the first value is equal to the second value.

Available in Mac OS X v10.0 and later.
kCFCompareGreaterThan

Returned by a comparison function if the first value is greater than the second value.

Available in Mac OS X v10.0 and later.*/

#ifdef OC_CF
enum CFComparisonResult {
   kCFCompareLessThan = -1,
   kCFCompareEqualTo = 0,
   kCFCompareGreaterThan = 1
};
typedef enum CFComparisonResult CFComparisonResult;
#endif

/*CFTypeID
A type for unique, constant integer values that identify particular Core Foundation opaque types.

typedef UInt32 CFTypeID;
Discussion

Defines a type identifier in Core Foundation. A type ID is an integer that identifies the opaque type to which a Core Foundation object “belongs.” You use type IDs in various contexts, such as when you are operating on heterogeneous collections. Core Foundation provides programmatic interfaces for obtaining and evaluating type IDs. 

Because the value for a type ID can change from release to release, your code should not rely on stored or hard-coded type IDs nor should it hard-code any observed properties of a type ID (such as, for example, it being a small integer). 
Availability
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
typedef UInt32 CFTypeID;
#endif

/*CFIndex

An integer type used throughout Core Foundation in several programmatic roles: as an array index and for count, size, and length parameters and return values. 

typedef SInt32 CFIndex;
Discussion

Core Foundation types as CFIndex all parameters and return values that might grow over time as the processor's address size changes. On architectures where pointer sizes are a different size (say, 64 bits) CFIndex might be declared to be also 64 bits, independent of the size of int. If you type your own variables that interact with Core Foundation as CFIndex, your code will have a higher degree of source compatibility in the future. 
Availability
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
typedef SInt32 CFIndex;
#endif

/*CFStringRef

A reference to a CFString object.

typedef const struct __CFString *CFStringRef;
Discussion

The CFStringRef type refers to a CFString object, which “encapsulates” a Unicode string along with its length. CFString is an opaque type that defines the characteristics and behavior of CFString objects. 

Values of type CFStringRef may refer to immutable or mutable strings, as CFMutableString objects respond to all functions intended for immutable CFString objects. Functions which accept CFStringRef values, and which need to hold on to the values immutably, should call CFStringCreateCopy (instead of CFRetain) to do so.
Availability
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
typedef const struct __CFString *CFStringRef;
#endif

/*CFAllocatorRef

A reference to a CFAllocator object. 

typedef const struct __CFAllocator *CFAllocatorRef;
Discussion

The CFAllocatorRef type is a reference type used in many Core Foundation parameters and function results. It refers to a CFAllocator object, which allocates, reallocates, and deallocates memory for Core Foundation objects. 
Availability
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
typedef const struct __CFAllocator *CFAllocatorRef;
#endif

/*CFRange

A structure representing a range of sequential items in a container, such as characters in a buffer or elements in a collection.

struct CFRange {
   CFIndex location;
   CFIndex length;
};
typedef struct CFRange CFRange;
Fields
location

An integer representing the starting location of the range. 
length

An integer representing the number of items in the range.*/
#ifdef OC_CF
struct CFRange {
   CFIndex location;
   CFIndex length;
};
typedef struct CFRange CFRange;
#endif

/*CFComparatorFunction

Callback function that compares two values. You provide a pointer to this callback in certain Core Foundation sorting functions.

typedef CFComparisonResult (*CFComparatorFunction) (
   const void *val1,
   const void *val2,
   void *context
);

If you name your function MyCallBack, you would declare it like this:

CFComparisonResult MyCallBack (
   const void *val1,
   const void *val2,
   void *context
);
Parameters
val1

The first value to compare.
val2

The second value to compare.
context

An untyped pointer to the context of the evaluation. The meaning of this value and its use are defined by each comparator function. This value is usually passed to a sort function, such as CFArraySortValues, which then passes it, unchanged, to the comparator function.
Return Value

An integer value of type CFComparisonResult that indicates whether the val1 is equal to, less than, or greater than val2. See “Comparison Results” for a list of possible return values.
Discussion

If you need to sort the elements in a collection using special criteria, you can implement a comparator function with the signature defined by this prototype. You pass a pointer to this function in one of the “sort” functions, such as CFArray's CFArraySortValues. 

You can also pass pointers to standard Core Foundation comparator functions such as CFStringCompare and CFDateCompare.*/
#ifdef OC_CF
typedef CFComparisonResult (*CFComparatorFunction) (
   const void *val1,
   const void *val2,
   void *context
);
#endif

/*CFMutableStringRef

A reference to a CFMutableString object. 

typedef CFStringRef CFMutableStringRef;
Discussion

The type refers to a CFMutableString object, which “encapsulates” a Unicode string along with its length; the object has the attribute of being mutable, which means that its character contents can be modified. CFString is an opaque type that defines the characteristics and behavior of CFString objects, both immutable and mutable. 

CFMutableString derives from CFString. Therefore, you can pass CFMutableString objects into functions accepting CFString objects.
Availability
Available in Mac OS X v10.0 and later.*/
//typedef CFStringRef CFMutableStringRef;
#ifdef OC_CF
typedef struct __CFString * CFMutableStringRef;
#endif

/*CFPropertyListRef

A reference to a CFPropertyList object.

typedef CFTypeRef CFPropertyListRef;
Discussion

This is an abstract type for property list objects. The return value of the CFPropertyListCreateFromXMLData function depends on the contents of the given XML data. CFPropertyListRef can be a reference to any of the property list objects: CFData, CFString, CFArray, CFDictionary, CFDate, CFBoolean, and CFNumber. 
Availability
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
typedef CFTypeRef CFPropertyListRef;
#endif

/*Predefined Allocators

CFAllocator provides the following predefined allocators. In general, you should use kCFAllocatorDefault unless one of the special circumstances exist below.

const CFAllocatorRef kCFAllocatorDefault;
const CFAllocatorRef kCFAllocatorSystemDefault;
const CFAllocatorRef kCFAllocatorMalloc;
const CFAllocatorRef kCFAllocatorMallocZone;
const CFAllocatorRef kCFAllocatorNull;
const CFAllocatorRef kCFAllocatorUseContext;
Constants
kCFAllocatorDefault

This is a synonym for NULL. 

Available in Mac OS X v10.0 and later.
extern  const CFAllocatorRef kCFAllocatorDefault;extern  const CFAllocatorRef kCFAllocatorDefault;kCFAllocatorSystemDefault

Default system allocator.

You rarely need to use this.

Available in Mac OS X v10.0 and later.
kCFAllocatorMalloc

This allocator uses malloc(), realloc(), and free(). 

Typically you should not use this allocator, use kCFAllocatorDefault instead. This allocator is useful as the bytesDeallocator in CFData or contentsDeallocator in CFString where the memory was obtained as a result of malloc type functions.

Available in Mac OS X v10.0 and later.
kCFAllocatorMallocZone

This allocator explicitly uses the default malloc zone, returned by malloc_default_zone().

You should only use this when an object is safe to be allocated in non-scanned memory.

Available in Mac OS X v10.4 and later.
kCFAllocatorNull

This allocator does nothing?it allocates no memory. 

This allocator is useful as the bytesDeallocator in CFData or contentsDeallocator in CFString where the memory should not be freed.

Available in Mac OS X v10.0 and later.
kCFAllocatorUseContext

Special allocator argument to CFAllocatorCreate?it uses the functions given in the context to allocate the allocator.

Available in Mac OS X v10.0 and later.
Declared In
CFBase.h*/

#ifdef OC_CF
extern  const CFAllocatorRef kCFAllocatorDefault;
extern const CFAllocatorRef kCFAllocatorSystemDefault;
extern const CFAllocatorRef kCFAllocatorMalloc;
extern const CFAllocatorRef kCFAllocatorMallocZone;
extern const CFAllocatorRef kCFAllocatorNull;
extern const CFAllocatorRef kCFAllocatorUseContext;
#endif

/*CFAllocatorCopyDescriptionCallBack

A prototype for a function callback that provides a description of the specified data.

typedef CFStringRef (*CFAllocatorCopyDescriptionCallBack) (
   const void *info
);


If you name your function MyCallBack, you would declare it like this:

CFStringRef MyCallBack (
   const void *info
);
Parameters
info

An untyped pointer to program-defined data.
Return Value

A CFString object that describes the allocator. The caller is responsible for releasing this object.
Discussion

A prototype for a function callback that provides a description of the data pointed to by the info field. In implementing this function, return a reference to a CFString object that describes your allocator, particularly some characteristics of your program-defined data.
Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
typedef CFStringRef (*CFAllocatorCopyDescriptionCallBack) (
   const void *info
);
#endif

/*CFAllocatorAllocateCallBack

A prototype for a function callback that allocates memory of a requested size.

typedef void *(*CFAllocatorAllocateCallBack) (
   CFIndex allocSize,
   CFOptionFlags hint,
   void *info
);


If you name your function MyCallBack, you would declare it like this:

void *MyCallBack (
   CFIndex allocSize,
   CFOptionFlags hint,
   void *info
);
Parameters
allocSize

This function allocates a block of memory of at least allocSize bytes (always greater than 0).
hint

A bitfield that is currently not used (always set to 0).
info

An untyped pointer to program-defined data. Allocate memory for the data and assign a pointer to it. This data is often control information for the allocator. It may be NULL.
Return Value

A pointer to the start of the block.
Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
typedef void *(*CFAllocatorAllocateCallBack) (
   CFIndex allocSize,
   CFOptionFlags hint,
   void *info
);
#endif

/*CFAllocatorReallocateCallBack

A prototype for a function callback that reallocates memory of a requested size for an existing block of memory.

typedef void *(*CFAllocatorReallocateCallBack) (
   void *ptr,
   CFIndex newsize,
   CFOptionFlags hint,
   void *info
);


If you name your function MyCallBack, you would declare it like this:

void *MyCallBack (
   void *ptr,
   CFIndex newsize,
   CFOptionFlags hint,
   void *info
);
Parameters
ptr

The block of memory to resize.
newsize

The size of the new allocation.
hint

A bitfield that is currently not used (always set to 0).
info

An untyped pointer to program-defined data.
Return Value

Pointer to the new block of memory.
Discussion

In implementing this function, change the size of the block of memory pointed to by ptr to the size specified by newsize and return the pointer to the larger block of memory. Return NULL on any reallocation failure, leaving the old block of memory untouched. Also return NULL immediately if any of the following conditions if the ptr parameter is NULL or the newsize parameter is not greater than 0. Leave the contents of the old block of memory unchanged up to the lesser of the new or old sizes. If the ptr parameter is not a block of memory that has been previously allocated by the allocator, the results are undefined; abnormal program termination can occur. The hint argument is a bitfield that you should currently not use (that is, assign 0).
Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
typedef void *(*CFAllocatorReallocateCallBack) (
   void *ptr,
   CFIndex newsize,
   CFOptionFlags hint,
   void *info
);
#endif

/*CFAllocatorDeallocateCallBack

A prototype for a function callback that deallocates a block of memory.

typedef void (*CFAllocatorDeallocateCallBack) (
   void *ptr,
   void *info
);


If you name your function MyCallBack, you would declare it like this:

void MyCallBack (
   void *ptr,
   void *info
);
Parameters
ptr

The block of memory to deallocate.
info

An untyped pointer to program-defined data.
Discussion

A prototype for a function callback that deallocates a given block of memory. In implementing this function, make the block of memory pointed to by ptr available for subsequent reuse by the allocator but unavailable for continued use by the program. The ptr parameter cannot be NULL and if the ptr parameter is not a block of memory that has been previously allocated by the allocator, the results are undefined; abnormal program termination can occur.
Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
typedef void (*CFAllocatorDeallocateCallBack) (
   void *ptr,
   void *info
);
#endif

/*CFAllocatorPreferredSizeCallBack

A prototype for a function callback that gives the size of memory likely to be allocated, given a certain request.

typedef CFIndex (*CFAllocatorPreferredSizeCallBack) (
   CFIndex size,
   CFOptionFlags hint,
   void *info
);


If you name your function MyCallBack, you would declare it like this:

CFIndex MyCallBack (
   CFIndex size,
   CFOptionFlags hint,
   void *info
);
Parameters
size

The amount of memory requested.
hint

A bitfield that is currently not used (always set to 0).
info

An untyped pointer to program-defined data.
Return Value

The actual size the allocator is likely to allocate given this request.
Discussion

A prototype for a function callback that determines whether there is enough free memory to satisfy a request. In implementing this function, return the actual size the allocator is likely to allocate given a request for a block of memory of size size. The hint argument is a bitfield that you should currently not use.
Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBase.h
CFAllocatorRe*/
#ifdef OC_CF
typedef CFIndex (*CFAllocatorPreferredSizeCallBack) (
   CFIndex size,
   CFOptionFlags hint,
   void *info
);
#endif

/*CFNullRef

A reference to a CFNull object.

typedef const struct __CFNull *CFNullRef;
Availability
Available in Mac OS X v10.2 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
typedef const struct __CFNull *CFNullRef;
#endif

/*CFAllocatorContext

A structure that defines the context or operating environment for an allocator (CFAllocator) object. Every Core Foundation allocator object must have a context defined for it.

struct CFAllocatorContext {
   CFIndex version;
   void *info;
   CFAllocatorRetainCallBack retain;
   CFAllocatorReleaseCallBack release;
   CFAllocatorCopyDescriptionCallBack copyDescription;
   CFAllocatorAllocateCallBack allocate;
   CFAllocatorReallocateCallBack reallocate;
   CFAllocatorDeallocateCallBack deallocate;
   CFAllocatorPreferredSizeCallBack preferredSize;
};
typedef struct CFAllocatorContext CFAllocatorContext;

Fields
version

An integer of type CFIndex. Assign the version number of the allocator. Currently the only valid value is 0. 
info

An untyped pointer to program-defined data. Allocate memory for this data and assign a pointer to it. This data is often control information for the allocator. You may assign NULL.
retain

A prototype for a function callback that retains the data pointed to by the info field. In implementing this function, retain the data you have defined for the allocator context in this field. (This might make sense only if the data is a Core Foundation object.) You may set this function pointer to NULL. 
release

A prototype for a function callback that releases the data pointed to by the info field. In implementing this function, release (or free) the data you have defined for the allocator context. You may set this function pointer to NULL, but doing so might result in memory leaks. 
copyDescription

A prototype for a function callback that provides a description of the data pointed to by the info field. In implementing this function, return a reference to a CFString object that describes your allocator, particularly some characteristics of your program-defined data. You may set this function pointer to NULL, in which case Core Foundation will provide a rudimentary description. 
allocate

A prototype for a function callback that allocates memory of a requested size. In implementing this function, allocate a block of memory of at least size bytes and return a pointer to the start of the block. The hint argument is a bitfield that you should currently not use (that is, assign 0). The size parameter should always be greater than 0. If it is not, or if problems in allocation occur, return NULL. This function pointer may not be assigned NULL. 
reallocate

A prototype for a function callback that reallocates memory of a requested size for an existing block of memory. In implementing this function, change the size of the block of memory pointed to by ptr to the size specified by newsize and return the pointer to the larger block of memory. Return NULL on any reallocation failure, leaving the old block of memory untouched. Also return NULL immediately if any of the following conditions apply:
The ptr parameter is NULL.
The newsize parameter is not greater than 0. 

Leave the contents of the old block of memory unchanged up to the lesser of the new or old sizes. If the ptr parameter is not a block of memory that has been previously allocated by the allocator, the results are undefined; abnormal program termination can occur. The hint argument is a bitfield that you should currently not use (that is, assign 0). If you set this callback to NULL the CFAllocatorReallocate function returns NULL in most cases when it attempts to use this allocator.
deallocate

A prototype for a function callback that deallocates a given block of memory. In implementing this function, make the block of memory pointed to by ptr available for subsequent reuse by the allocator but unavailable for continued use by the program. The ptr parameter cannot be NULL and if the ptr parameter is not a block of memory that has been previously allocated by the allocator, the results are undefined; abnormal program termination can occur. You can set this callback to NULL, in which case the CFAllocatorDeallocate function has no effect. 
preferredSize

A prototype for a function callback that determines whether there is enough free memory to satisfy a request. In implementing this function, return the actual size the allocator is likely to allocate given a request for a block of memory of size size. The hint argument is a bitfield that you should currently not use. 
Discussion

See the “Memory Management” topic for information on creating a custom CFAllocator object and, as part of that procedure, the steps for creating a properly initialized CFAllocatorContext structure. 
Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
struct CFAllocatorContext {
   CFIndex version;
   void *info;
   CFAllocatorRetainCallBack retain;
   CFAllocatorReleaseCallBack release;
   CFAllocatorCopyDescriptionCallBack copyDescription;
   CFAllocatorAllocateCallBack allocate;
   CFAllocatorReallocateCallBack reallocate;
   CFAllocatorDeallocateCallBack deallocate;
   CFAllocatorPreferredSizeCallBack preferredSize;
};
typedef struct CFAllocatorContext CFAllocatorContext;
#endif

/*Predefined Value

Predefined CFNull object.

const CFNullRef kCFNull;

Constants
kCFNull

The singleton CFNull object.

Available in Mac OS X v10.2 and later.

Declared in CFBase.h*/
#ifdef OC_CF
extern const CFNullRef kCFNull;
#endif

//functions

/*CFGetTypeID

Returns the unique identifier of an opaque type to which a Core Foundation object belongs.

CFTypeID CFGetTypeID (
   CFTypeRef cf
);
Parameters
cf

The CFType object to examine. 
Return Value

A value of type CFTypeID that identifies the opaque type of cf. 
Discussion

This function returns a value that uniquely identifies the opaque type of any Core Foundation object. You can compare this value with the known CFTypeID identifier obtained with a “GetTypeID” function specific to a type, for example CFDateGetTypeID. These values might change from release to release or platform to platform.
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
CFTypeID CFGetTypeID (
   CFTypeRef cf
);
#endif

/*CFRelease

Releases a Core Foundation object.

void CFRelease (
   CFTypeRef cf
);
Parameters
cf

A CFType object to release. This value must not be NULL. 
Discussion

If the retain count of cf becomes zero the memory allocated to the object is deallocated and the object is destroyed. If you create, copy, or explicitly retain (see the CFRetain function) a Core Foundation object, you are responsible for releasing it when you no longer need it (see Memory Management Programming Guide for Core Foundation).
Special Considerations

If cf is NULL, this will cause a runtime error and your application will crash. 
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
void CFRelease (
   CFTypeRef cf
);
#endif

/*CFRetain

Retains a Core Foundation object.

CFTypeRef CFRetain (
   CFTypeRef cf
);
Parameters
cf

The CFType object to retain. This value must not be NULL
Return Value

The input value, cf. 
Discussion

You should retain a Core Foundation object when you receive it from elsewhere (that is, you did not create or copy it) and you want it to persist. If you retain a Core Foundation object you are responsible for releasing it (see Memory Management Programming Guide for Core Foundation). 
Special Considerations

If cf is NULL, this will cause a runtime error and your application will crash. 
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
CFTypeRef CFRetain (
   CFTypeRef cf
);
#endif

/*CFCopyDescription

Returns a textual description of a Core Foundation object.

CFStringRef CFCopyDescription (
   CFTypeRef cf
);
Parameters
cf

The CFType object (a generic reference of type CFTypeRef) from which to derive a description.
Return Value

A string that contains a description of cf. Ownership follows the Create Rule.
Discussion

The nature of the description differs by object. For example, a description of a CFArray object would include descriptions of each of the elements in the collection.

You can use this function for debugging Core Foundation objects in your code. Note, however, that the description for a given object may be different in different releases of the operating system. Do not create dependencies in your code on the content or format of the information returned by this function. 
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
CFStringRef CFCopyDescription (
   CFTypeRef cf
);
#endif

/*CFRangeMake

Declares and initializes a CFRange structure.

CFRange CFRangeMake (
   CFIndex loc,
   CFIndex len
);
Parameters
loc

The starting location of the range. 
len

The length of the range.
Return Value

An initialized structure of type CFRange. 
Discussion

This is an in-line convenience function for creating initialized CFRange structures. 
Availability
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
CFRange CFRangeMake (
   CFIndex loc,
   CFIndex len
);
#endif

/*CFEqual

Determines whether two Core Foundation objects are considered equal.

Boolean CFEqual (
   CFTypeRef cf1,
   CFTypeRef cf2
);
Parameters
cf1

A CFType object to compare to cf2.
cf2

A CFType object to compare to cf1.
Return Value

true if cf1 and cf2 are of the same type and considered equal, otherwise false. 
Discussion

Equality is something specific to each Core Foundation opaque type. For example, two CFNumber objects are equal if the numeric values they represent are equal. Two CFString objects are equal if they represent identical sequences of characters, regardless of encoding. 
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
Boolean CFEqual (
   CFTypeRef cf1,
   CFTypeRef cf2
);
#endif

/*CFGetRetainCount

Returns the reference count of a Core Foundation object.

CFIndex CFGetRetainCount (
   CFTypeRef cf
);
Parameters
cf

The CFType object to examine. 
Return Value

A number representing the reference count of cf. 
Discussion

You increment the reference count using the CFRetain function, and decrement the reference count using the CFRelease function.

This function may useful for debugging memory leaks. You normally do not use this function, otherwise.
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
CFIndex CFGetRetainCount (
   CFTypeRef cf
);
#endif

/*CFAllocatorAllocate

Allocates memory using the specified allocator.

void *CFAllocatorAllocate (
   CFAllocatorRef allocator,
   CFIndex size,
   CFOptionFlags hint
);
Parameters
allocator

The allocator to use to allocate the memory. Pass NULL or kCFAllocatorDefault to use the current default allocator.
size

The size of the memory to allocate. 
hint

A bitfield containing flags that suggest how memory is to be allocated. 0 indicates no hints. No hints are currently defined, so only 0 should be passed for this value.
Return Value

A pointer to the newly allocated memory. 
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
void *CFAllocatorAllocate (
   CFAllocatorRef allocator,
   CFIndex size,
   CFOptionFlags hint
);
#endif

/*CFAllocatorDeallocate

Deallocates a block of memory with a given allocator.

void CFAllocatorDeallocate (
   CFAllocatorRef allocator,
   void *ptr
);
Parameters
allocator

The allocator that was used to allocate the block of memory pointed to by ptr. 
ptr

An untyped pointer to a block of memory to deallocate using allocator.
Discussion

If the allocator does not specify a deallocate callback function, the memory is not deallocated. 
Special Considerations

You must use the same allocator to deallocate memory as was used to allocate it.
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
void CFAllocatorDeallocate (
   CFAllocatorRef allocator,
   void *ptr
);
#endif

/*CFAllocatorGetDefault

Gets the default allocator object for the current thread.

CFAllocatorRef CFAllocatorGetDefault ();

Return Value

A reference to the default allocator for the current thread. If none has been explicitly set, returns the generic system allocator, kCFAllocatorSystemDefault. Ownership follows the Get Rule.
Discussion

See the discussion for CFAllocatorSetDefault for more detail on the default allocator and for advice on how and when to set a custom allocator as the default. 
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
CFAllocatorRef CFAllocatorGetDefault ();
#endif

/*CFCopyTypeIDDescription

Returns a textual description of a Core Foundation type, as identified by its type ID, which can be used when debugging.

CFStringRef CFCopyTypeIDDescription (
   CFTypeID theType
);
Parameters
theType

An integer of type CFTypeID that uniquely identifies a Core Foundation opaque type. 
Return Value

A string containing a type description. Ownership follows the Create Rule.
Discussion

You can use this function for debugging Core Foundation objects in your code. Note, however, that the description for a given object may be different in different releases of the operating system. Do not create dependencies in your code on the content or format of the information returned by this function.
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
CFStringRef CFCopyTypeIDDescription (
   CFTypeID theType
);
#endif

/*CFGetAllocator

Returns the allocator used to allocate a Core Foundation object.

CFAllocatorRef CFGetAllocator (
   CFTypeRef cf
);
Parameters
cf

The CFType object to examine. 
Return Value

The allocator used to allocate memory for cf. 
Discussion

When you are creating a Core Foundation object sometimes you want to ensure that the block of memory allocated for the object is from the same allocator used for another object. One way to do this is to reuse the allocator assigned to an existing Core Foundation object when you call a “creation” function. 
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.*/
#ifdef OC_CF
CFAllocatorRef CFGetAllocator (
   CFTypeRef cf
);
#endif

/*CFHash

Returns a code that can be used to identify an object in a hashing structure.

CFHashCode CFHash (
   CFTypeRef cf
);

Parameters
cf

A CFType object to examine. 
Return Value

An integer of type CFHashCode that represents a hashing value for cf. 
Discussion

Two objects that are equal (as determined by the CFEqual function) have the same hashing value. However, the converse is not true: two objects with the same hashing value might not be equal. That is, hashing values are not necessarily unique.

The hashing value for an object might change from release to release or from platform to platform.
Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
CFHashCode CFHash (
   CFTypeRef cf
);
#endif

/*CFMakeCollectable

Makes a newly-allocated Core Foundation object eligible for garbage collection.

CFTypeRef CFMakeCollectable (
   CFTypeRef cf
);
Parameters
cf

A CFType object to make collectable. This value must not be NULL. 
Return Value

cf.
Discussion

For more details, see Garbage Collection Programming Guide.
Special Considerations

If cf is NULL, this will cause a runtime error and your application will crash. 
Availability
Available in Mac OS X v10.4 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
CFTypeRef CFMakeCollectable (
   CFTypeRef cf
);
#endif

/*CFAllocatorReallocate

Reallocates memory using the specified allocator.

void * CFAllocatorReallocate (
   CFAllocatorRef allocator,
   void *ptr,
   CFIndex newsize,
   CFOptionFlags hint
);
Parameters
allocator

The allocator to use for reallocating memory. Pass NULL to request the default allocator. 
ptr

An untyped pointer to a block of memory to reallocate to a new size. If ptr is NULL and newsize is greater than 0, memory is allocated (using the allocate function callback of the allocator's context). If ptr is NULL and newsize is 0, the result is NULL.
newsize

The number of bytes to allocate. If you pass 0 and the ptr parameter is non-NULL, the block of memory that ptr points to is typically deallocated. If you pass 0 for this parameter and the ptr parameter is NULL, nothing happens and the result returned is NULL. 
hint

A bitfield of type CFOptionsFlags. Pass flags to the allocator that suggest how memory is to be allocated. Zero indicates no hints. No hints are currently defined, only 0 should be passed for this argument.
Discussion

The CFAllocatorReallocate function's primary purpose is to reallocate a block of memory to a new (and usually larger) size. However, based on the values passed in certain of the parameters, this function can also allocate memory afresh or deallocate a given block of memory. The following summarizes the semantic combinations:
If the ptr parameter is non- NULL and the newsize parameter is greater than 0, the behavior is to reallocate.
If the ptr parameter is NULL and the newsize parameter is greater than 0, the behavior is to allocate.
If the ptr parameter is non- NULL and the newsize parameter is 0, the behavior is to deallocate.

The result of the CFAllocatorReallocate function is either an untyped pointer to a block of memory or NULL. A NULL result indicates either a failure to allocate memory or some other outcome, the precise interpretation of which is determined by the values of certain parameters and the presence or absence of callbacks in the allocator context. To summarize, a NULL result can mean one of the following:
An error occurred in the attempt to allocate memory, such as insufficient free space.
No allocate, reallocate, or deallocate function callback (depending on parameters) was defined in the allocator context.
The semantic operation is "deallocate" (that is, there is no need to return anything). 
The ptr parameter is NULL and the requested size is 0. 
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
void * CFAllocatorReallocate (
   CFAllocatorRef allocator,
   void *ptr,
   CFIndex newsize,
   CFOptionFlags hint
);
#endif

/*CFNullGetTypeID

Returns the type identifier for the CFNull opaque type.

CFTypeID CFNullGetTypeID (
   void
);

Return Value

The type identifier for the CFNull opaque type.
Availability
Available in Mac OS X v10.2 and later. 
Declared In
CFBase.h*/
#ifdef OC_CF
CFTypeID CFNullGetTypeID (
   void
);
#endif

/*CFAllocatorGetPreferredSizeForSize

Obtains the number of bytes likely to be allocated upon a specific request.

CFIndex CFAllocatorGetPreferredSizeForSize (
   CFAllocatorRef allocator,
   CFIndex size,
   CFOptionFlags hint
);
Parameters
allocator

The allocator to use, or NULL for the default allocator. 
size

The number of bytes to allocate. If the value is 0 or less, the result is the same value.
hint

A bitfield of type CFOptionsFlags. Pass flags to the allocator that suggest how memory is to be allocated. 0 indicates no hints. No hints are currently defined, only 0 should be passed for this argument.
Return Value

The number of bytes likely to be allocated upon a specific request. 
Discussion

The return value depends on the allocator's internal allocation strategy, and will be equal to or larger than size. Calling this function may help you better match your memory allocation or reallocation strategy to that of the allocator. 

Note that the return value depends on the internal implementation of the allocator and the results may change from release to release or from platform to platform.

If no function callback is assigned to the preferredSize field of the allocator's context (see the CFAllocatorContext structure), then the value of size is returned. 
Availability
Available in CarbonLib v1.0 and later.
Available in Mac OS X v10.0 and later.
Declared In
CFBase.h*/
#ifdef OC_CF
CFIndex CFAllocatorGetPreferredSizeForSize (
   CFAllocatorRef allocator,
   CFIndex size,
   CFOptionFlags hint
);
#endif

#if defined(__cplusplus)
}
#endif

#endif //__COREFOUNDATION_CFBASE__


