#ifndef OC_CFBITVECTOR_H
#define OC_CFBITVECTOR_H

#include <CoreFoundation/CFBase.h>

#ifndef OC_CF
#include "/usr/include/CoreFoundation/CFBitVector.h"
#endif //OC_CF

#if defined(__cplusplus)
extern "C" {
#endif

/*CFBitVectorRef

A reference to an immutable bit vector object.

typedef const struct __CFBitVector *CFBitVectorRef;
Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBitVector.h*/
#ifdef OC_CF
typedef const struct __CFBitVector *CFBitVectorRef;
#endif

/*CFMutableBitVectorRef

A reference to a mutable bit vector object.

typedef struct __CFBitVector *CFMutableBitVectorRef;

Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBitVector.h*/
#ifdef OC_CF
typedef struct __CFBitVector *CFMutableBitVectorRef;
#endif

/*CFBit

A binary value of either 0 or 1.

typedef UInt32 CFBit;

Availability
Available in Mac OS X v10.0 and later.
Declared In
CFBitVector.h*/
#ifdef OC_CF
typedef UInt32 CFBit;
#endif

#ifdef __cplusplus
}
#endif

#endif//CFBITVECTOR_H
