#if !defined(OC__COREFOUNDATION_CFFILEDESCRIPTOR__)
#define OC__COREFOUNDATION_CFFILEDESCRIPTOR__ 1

#include <CoreFoundation/CFRunLoop.h>
//#include <HYS/CoreFoundation/CFFileDescriptor.h>

//#if MAC_OS_X_VERSION_10_5 <= MAC_OS_X_VERSION_MAX_ALLOWED

//#if defined(__MACH__)

//CF_EXTERN_C_BEGIN

/*CFFileDescriptorRef

A reference to an CFFileDescriptor object.

typedef struct __CFFileDescriptor * CFFileDescriptorRef;

Availability
Available in Mac OS X v10.5 and later.
Declared In
CFFileDescriptor.h*/
typedef struct __CFFileDescriptor * CFFileDescriptorRef;

/*CFFileDescriptorNativeDescriptor

Defines a type for the native file descriptor.

typedef int CFFileDescriptorNativeDescriptor;
Availability
Available in Mac OS X v10.5 and later.
Declared In
CFFileDescriptor.h*/
typedef int CFFileDescriptorNativeDescriptor;

/*CFFileDescriptorCallBack

Defines a structure for a callback for a CFFileDescriptor.

typedef void (*CFFileDescriptorCallBack) (
   CFFileDescriptorRef f,
   CFOptionFlags callBackTypes,
   void *info
);

Declared In
CFFileDescriptor.h*/
typedef void (*CFFileDescriptorCallBack) (
   CFFileDescriptorRef f,
   CFOptionFlags callBackTypes,
   void *info
);

/*CFFileDescriptorContext

Defines a structure for the context of a CFFileDescriptor.

typedef struct {
   CFIndex    version;
   void *    info;
   void *    (*retain)(void *info);
   void    (*release)(void *info);
   CFStringRef    (*copyDescription)(void *info);
} CFFileDescriptorContext;
Fields
version

The version number of this structure. If not one of the defined version numbers for this opaque type, the behavior is undefined. The current version of this structure is 0. 
info

retain

The retain callback used by the CFFileDescriptor. 
release

The release callback used by the CFFileDescriptor. 
copyDescription

The callback used to create a descriptive string representation of the CFFileDescriptor. 
Availability
Available in Mac OS X v10.5 and later.
Declared In
CFFileDescriptor.h*/
typedef struct {
   CFIndex    version;
   void *    info;
   void *    (*retain)(void *info);
   void    (*release)(void *info);
   CFStringRef    (*copyDescription)(void *info);
} CFFileDescriptorContext;

/*Callback Identifiers

Constants that identify the read and write callbacks.

enum {
   kCFFileDescriptorReadCallBack = 1 << 0,
   kCFFileDescriptorWriteCallBack = 1 << 1
};
Constants
kCFFileDescriptorReadCallBack

Identifies the read callback.

Available in Mac OS X v10.5 and later.

Declared in CFFileDescriptor.h
kCFFileDescriptorWriteCallBack

Identifies the write callback.

Available in Mac OS X v10.5 and later.

Declared in CFFileDescriptor.h
Declared In
CFFileDescriptor.h*/
enum {
   kCFFileDescriptorReadCallBack = 1 << 0,
   kCFFileDescriptorWriteCallBack = 1 << 1
};

//func
/*CFFileDescriptorCreate

Creates a new CFFileDescriptor.

CFFileDescriptorRef CFFileDescriptorCreate (
   CFAllocatorRef allocator,
   CFFileDescriptorNativeDescriptor fd,
   Boolean closeOnInvalidate,
   CFFileDescriptorCallBack callout,
   const CFFileDescriptorContext *context
);

Parameters
allocator

The allocator to use to allocate memory for the new bag and its storage for values. Pass NULL or kCFAllocatorDefault to use the current default allocator. 
fd

The file descriptor for the new CFFileDescriptor.
closeOnInvalidate

true if the new CFFileDescriptor should close fd when it is invalidated, otherwise false.
callout

The CFFileDescriptorCallBack for the new CFFileDescriptor.
context

Contextual information for the new CFFileDescriptor.
Return Value

A new CFFileDescriptor or NULL if there was a problem creating the object. Ownership follows the Create Rule.
Availability
Available in Mac OS X v10.5 and later.
See Also
CFFileDescriptorGetContext
CFFileDescriptorInvalidate
Declared In
CFFileDescriptor.h*/
CFFileDescriptorRef CFFileDescriptorCreate (
   CFAllocatorRef allocator,
   CFFileDescriptorNativeDescriptor fd,
   Boolean closeOnInvalidate,
   CFFileDescriptorCallBack callout,
   const CFFileDescriptorContext *context
);

/*CFFileDescriptorCreateRunLoopSource

Creates a new runloop source for a given CFFileDescriptor.

CFRunLoopSourceRef CFFileDescriptorCreateRunLoopSource (
   CFAllocatorRef allocator,
   CFFileDescriptorRef f,
   CFIndex order
);
Parameters
allocator

The allocator to use to allocate memory for the new bag and its storage for values. Pass NULL or kCFAllocatorDefault to use the current default allocator. 
f

A CFFileDescriptor.
order

The order for the new run loop (see CFRunLoopSourceCreate).
Return Value

A new runloop source for f, or NULL if there was a problem creating the object. Ownership follows the Create Rule.
Discussion

The context for the new runloop (see CFRunLoopSourceCreate) is the same as the context passed in when the CFFileDescriptor was created (see CFFileDescriptorCreate). 
Availability
Available in Mac OS X v10.5 and later.
Declared In
CFFileDescriptor.h*/
CFRunLoopSourceRef CFFileDescriptorCreateRunLoopSource (
   CFAllocatorRef allocator,
   CFFileDescriptorRef f,
   CFIndex order
);

/*CFFileDescriptorEnableCallBacks

Enables callbacks for a given CFFileDescriptor.

void CFFileDescriptorEnableCallBacks (
   CFFileDescriptorRef f,
   CFOptionFlags callBackTypes
);
Parameters
f

A CFFileDescriptor.
callBackTypes

A bitmask that specifies which callbacks to enable (see “Callback Identifiers” for possible components). 
Availability
Available in Mac OS X v10.5 and later.
See Also
CFFileDescriptorDisableCallBacks
Declared In
CFFileDescriptor.h*/
void CFFileDescriptorEnableCallBacks (
   CFFileDescriptorRef f,
   CFOptionFlags callBackTypes
);

/*CFFileDescriptorGetNativeDescriptor

Returns the native file descriptor for a given CFFileDescriptor.

CFFileDescriptorNativeDescriptor CFFileDescriptorGetNativeDescriptor (
   CFFileDescriptorRef f
);
Parameters
f

A CFFileDescriptor.
Return Value

The native file descriptor for f.
Availability
Available in Mac OS X v10.5 and later.
See Also
CFFileDescriptorInvalidate
Declared In
CFFileDescriptor.h*/
CFFileDescriptorNativeDescriptor CFFileDescriptorGetNativeDescriptor (
   CFFileDescriptorRef f
);

//CF_EXTERN_C_END

//#endif

//#endif

#endif /* ! __COREFOUNDATION_CFFILEDESCRIPTOR__ */

