

#ifndef __CTLINE__
#define __CTLINE__

#include <CoreFoundation/CFArray.h>
#include <CoreFoundation/CFAttributedString.h>
#include <CoreGraphics/CGContext.h>
#include <AvailabilityMacros.h>

#if defined(__cplusplus)
extern "C" {
#endif

/*CTLineRef

A reference to a line object.

typedef const struct __CTLine *CTLineRef;

Availability
Available in Mac OS X v10.5 and later.
Declared In
CTLine.h*/
typedef const struct __CTLine *CTLineRef;
///////////func

/*CTLineGetImageBounds

Calculates the image bounds for a line.

CGRect CTLineGetImageBounds( CTLineRef line, CGContextRef context );

Parameters
line

The line whose image bounds are calculated.
context

The context for which the image bounds are calculated. This is required because the context could have settings in it that would cause changes in the image bounds.
Return Value

A rectangle that tightly encloses the paths of the line's glyphs, or, if the line or context is invalid, CGRectNull.
Availability
Available in Mac OS X v10.5 and later.
Declared In
CTLine.h*/
CGRect CTLineGetImageBounds( CTLineRef line, CGContextRef context );

#if defined(__cplusplus)
}
#endif

#endif
