#ifndef __PrivateTypes_h__
#define	__PrivateTypes_h__	1

#include <DirectoryService/DirServicesTypes.h>

#ifdef DSDEBUGLOGFW
	#include <syslog.h>
#else
	#ifdef DEBUG
		#include <stdio.h>
	#else//DEBUG
	#endif//DEBUG
#endif//DSDEBUGLOGFW

#include <HYS/DirectoryServiceCore/PrivateTypes.h>

/*DSRegisterNode

Registers a node.

long DSRegisterNode (
   unsigned long inSignature,
   tDataList *inNode,
   eDirNodeType inNodeType);
Parameters
inSignature

Value of type unsigned long obtained by the plug-in when its Validate routine was called and that uniquely identifies the plug-in.
inNode

Pointer to a value of type tDataList that specifies the name of the node that is to be registered.
inNodeType

Value of type eDirNodeType that specifies the type of the node that is to be registered. See the Discussion section below for possible values.
return result

Value of type unsigned long. If the DSRegisterNode callback routine completes successfully, it returns eDSNoErr. If the DSRegisterNode callback routine cannot complete successfully (for example, if the specified node is already registered or if inNode contains a node name that has invalid characters), it returns an appropriate result code as described in “Result Codes.”
Discussion

The DSRegisterNode callback routine registers the specified node. 

The eDirNodeType enumeration defines values for the inNodeType parameter:typedef enum {     kUnknownNodeType= 0x00000000,     kDirNodeType    = 0x00000001,     kLocalNodeType  = 0x00000002 } eDirNodeType;


The local node (kLocalNodeType) is queried by default in response to an Open Directory request and is always the first node that is queried. Only one node can be registered as the local node at any one time. A directory node (kDirNodeType) is any other node that is to be registered for Open Directory.

Registrations are valid for the period of time that Open Directory is running. If Open Directory stops and is started again, the node must be registered again.

The plug-in is responsible for keeping the list of registered nodes accurate. It can use the PeriodicTask entry point to update the list on a regular basis.*/
typedef enum {    
	 kUnknownNodeType= 0x00000000, 
    	kDirNodeType    = 0x00000001,   
  	kLocalNodeType  = 0x00000002 ,
	eDirNodeType_ETC
} eDirNodeType;

#endif//__PrivateTypes_h__

