#ifndef __DISKARBITRATIOND_DADISSENTER__
#define __DISKARBITRATIOND_DADISSENTER__

#ifndef DISKARBITRATION_DADISSENTER_H
#define DISKARBITRATION_DADISSENTER_H

#include <mach/error.h>
#include <CoreFoundation/CoreFoundation.h>

#include <HYS/DiskArbitration/DADissenter.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*DADissenterRef


typedef const struct __DADissenter * DADissenterRef;  
Discussion 

Type of a reference to DADissenter instances.*/
typedef const struct __DADissenter * DADissenterRef;  

/*DAReturn


A return code. 

enum { 
    kDAReturnSuccess = 0, 
    kDAReturnError = err_local | err_local_diskarbitration | 0x01, // 
        ( 0xF8DA0001 ) //
    kDAReturnBusy = err_local | err_local_diskarbitration | 0x02, // 
        ( 0xF8DA0002 ) //
    kDAReturnBadArgument = err_local | err_local_diskarbitration | 0x03, // 
        ( 0xF8DA0003 ) //
    kDAReturnExclusiveAccess = err_local | err_local_diskarbitration | 0x04, // 
        ( 0xF8DA0004 ) //
    kDAReturnNoResources = err_local | err_local_diskarbitration | 0x05, // 
        ( 0xF8DA0005 ) //
    kDAReturnNotFound = err_local | err_local_diskarbitration | 0x06, // 
        ( 0xF8DA0006 ) //
    kDAReturnNotMounted = err_local | err_local_diskarbitration | 0x07, // 
        ( 0xF8DA0007 ) //
    kDAReturnNotPermitted = err_local | err_local_diskarbitration | 0x08, // 
        ( 0xF8DA0008 ) //
    kDAReturnNotPrivileged = err_local | err_local_diskarbitration | 0x09, // 
        ( 0xF8DA0009 ) //
    kDAReturnNotReady = err_local | err_local_diskarbitration | 0x0A, // 
        ( 0xF8DA000A ) //
    kDAReturnNotWritable = err_local | err_local_diskarbitration | 0x0B, // 
        ( 0xF8DA000B ) //
    kDAReturnUnsupported = err_local | err_local_diskarbitration | 0x0C // 
        ( 0xF8DA000C ) //
};  */

enum { 
    kDAReturnSuccess = 0, 
    kDAReturnError = err_local | err_local_diskarbitration | 0x01, /* 
        ( 0xF8DA0001 ) */
    kDAReturnBusy = err_local | err_local_diskarbitration | 0x02, /* 
        ( 0xF8DA0002 ) */
    kDAReturnBadArgument = err_local | err_local_diskarbitration | 0x03, /* 
        ( 0xF8DA0003 ) */
    kDAReturnExclusiveAccess = err_local | err_local_diskarbitration | 0x04, /* 
        ( 0xF8DA0004 ) */
    kDAReturnNoResources = err_local | err_local_diskarbitration | 0x05, /* 
        ( 0xF8DA0005 ) */
    kDAReturnNotFound = err_local | err_local_diskarbitration | 0x06, /* 
        ( 0xF8DA0006 ) */
    kDAReturnNotMounted = err_local | err_local_diskarbitration | 0x07, /* 
        ( 0xF8DA0007 ) */
    kDAReturnNotPermitted = err_local | err_local_diskarbitration | 0x08, /* 
        ( 0xF8DA0008 ) */
    kDAReturnNotPrivileged = err_local | err_local_diskarbitration | 0x09, /* 
        ( 0xF8DA0009 ) */
    kDAReturnNotReady = err_local | err_local_diskarbitration | 0x0A, /* 
        ( 0xF8DA000A ) */
    kDAReturnNotWritable = err_local | err_local_diskarbitration | 0x0B, /* 
        ( 0xF8DA000B ) */
    kDAReturnUnsupported = err_local | err_local_diskarbitration | 0x0C /* 
        ( 0xF8DA000C ) */
};

#ifdef __cplusplus
}
#endif 

#endif //DISKARBITRATION_DADISSENTER_H
#endif //__DISKARBITRATIOND_DADISSENTER__
