#ifndef __DISKARBITRATION_DISKARBITRATION__
#define __DISKARBITRATION_DISKARBITRATION__

#ifndef DISKARBITRATION_H
#define DISKARBITRATION_H

#include <CoreFoundation/CoreFoundation.h>

#include <DiskArbitration/DADisk.h>
#include <DiskArbitration/DADissenter.h>
#include <DiskArbitration/DASession.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <HYS/DiskArbitration/DiskArbitration.h>

/*DADiskClaimOptions


Options for DADiskClaim(). 

enum { 
    kDADiskClaimOptionDefault = 0x00000000 
};  */
enum { 
    kDADiskClaimOptionDefault = 0x00000000 
}; 

/*DADiskEjectOptions


Options for DADiskEject(). 

enum { 
    kDADiskEjectOptionDefault = 0x00000000 
};  */
enum { 
    kDADiskEjectOptionDefault = 0x00000000 
}; 

/*DADiskRenameOptions


Options for DADiskRename(). 

enum { 
    kDADiskRenameOptionDefault = 0x00000000 
};  */
enum { 
    kDADiskRenameOptionDefault = 0x00000000 
};

/*DADiskMountOptions


Options for DADiskMount(). 

enum { 
    kDADiskMountOptionDefault = 0x00000000, 
    kDADiskMountOptionWhole = 0x00000001 
};  
Constants
kDADiskMountOptionWhole
Mount the volumes tied to the whole disk object*/
enum { 
    kDADiskMountOptionDefault = 0x00000000, 
    kDADiskMountOptionWhole = 0x00000001 
};  

/*DADiskUnmountOptions


Options for DADiskUnmount(). 

enum { 
    kDADiskUnmountOptionDefault = 0x00000000, 
    kDADiskUnmountOptionForce = 0x00080000, 
    kDADiskUnmountOptionWhole = 0x00000001 
};  
Constants
kDADiskUnmountOptionForce
Unmount the volume even if files are still active.
kDADiskUnmountOptionWhole
Unmount the volumes tied to the whole disk object.*/
enum { 
    kDADiskUnmountOptionDefault = 0x00000000, 
    kDADiskUnmountOptionForce = 0x00080000, 
    kDADiskUnmountOptionWhole = 0x00000001 
};  

/*DADiskOptions


Options for DADiskGetOptions() and DADiskSetOptions(). 

enum { 
    kDADiskOptionDefault = 0x00000000, 
    kDADiskOptionEjectUponLogout = 0x00000001, 
    kDADiskOptionMountAutomatic = 0x00000010, 
    kDADiskOptionMountAutomaticNoDefer = 0x00000020, 
    kDADiskOptionPrivate = 0x00000100 
};  
Constants
kDADiskOptionEjectUponLogout
Eject the disk upon logout.
kDADiskOptionMountAutomatic
Mount the disk upon appearance.
kDADiskOptionMountAutomaticNoDefer
Mount the disk upon appearance, even if no login.
kDADiskOptionPrivate
Hides the disk from callbacks.*/

enum { 
    kDADiskOptionDefault = 0x00000000, 
    kDADiskOptionEjectUponLogout = 0x00000001, 
    kDADiskOptionMountAutomatic = 0x00000010, 
    kDADiskOptionMountAutomaticNoDefer = 0x00000020, 
    kDADiskOptionPrivate = 0x00000100 
};  

//func
/*kDADiskDescriptionMatchVolumeUnrecognized


extern CFDictionaryRef kDADiskDescriptionMatchVolumeUnrecognized;  
Discussion 

Predefined CFDictionary object containing a set of disk description keys and values appropriate for matching unrecognized volumes using DARegister*Callback().*/
extern CFDictionaryRef kDADiskDescriptionMatchVolumeUnrecognized;  

/*DADiskSetOptions


Sets the options for the specified disk. 

extern DAReturn DADiskSetOptions(
    DADiskRef disk,
    DADiskOptions options,
    Boolean value );  
Parameters
disk
The disk object for which to set the options.
options
The options to set or clear.
value
Pass TRUE to set options; otherwise pass FALSE to clear options.
Return Value

A result code.*/

extern DAReturn DADiskSetOptions(
    DADiskRef disk,
    DADiskOptions options,
    Boolean value );  


/*kDADiskDescriptionMatchVolumeMountable


extern CFDictionaryRef kDADiskDescriptionMatchVolumeMountable;  
Discussion 

Predefined CFDictionary object containing a set of disk description keys and values appropriate for matching mountable volumes using DARegister*Callback().*/

extern CFDictionaryRef kDADiskDescriptionMatchVolumeMountable;

/*kDADiskDescriptionWatchVolumePath


extern CFArrayRef kDADiskDescriptionWatchVolumePath;  
Discussion 

Predefined CFArray object containing a set of disk description keys appropriate for watching volume mount changes using DARegisterDiskDescriptionChangedCallback().*/
extern CFArrayRef kDADiskDescriptionWatchVolumePath;  

#ifdef __cplusplus
}
#endif

#endif//DISKARBITRATION_H
#endif//__DISKARBITRATION_DISKARBITRATION__
