#ifndef OC__EPPC__
#define OC__EPPC__

#include <MacErrors.h>
#include <AppleTalk.h>
#include <Files.h>
#include <PPCToolbox.h>
#include <Processes.h>
#include <Events.h>


#ifdef __cplusplus
extern "C" {
#endif

/* Data Types

   
struct EventRecord { 
      short    what;                   //event code//
      long     message;                //event message//
      long     when;                   //ticks since startup//
      Point    where;                  //mouse location//
      short    modifiers;              //modifier flags//
   };
typedef struct EventRecord EventRecord;

typedef long KeyMap[4];                //records state of keyboard//

struct TargetID {
      long              sessionID;     //session reference number (not //
                                       // used if posting an event)//
      PPCPortRec        name;          //port name//
      LocationNameRec   location;      //location name//
      PPCPortRec        recvrName;     //reserved//
   };

typedef struct TargetID TargetID;
typedef TargetID *TargetIDPtr, **TargetIDHdl;
struct HighLevelEventMsg {
      unsigned short    HighLevelEventMsgHeaderLength;   //reserved//
      unsigned short    version;                         //reserved//
      unsigned long     reserved1;                       //reserved//
      EventRecord       theMsgEvent;                     //event record//
      unsigned long     userRefCon;                      //ref constant//
      unsigned long     postingOptions;                  //reserved//
      unsigned long     msgLength;                       //reserved//
   };

typedef struct HighLevelEventMsg HighLevelEventMsg;
typedef HighLevelEventMsg *HighLevelEventMsgPtr, **HighLevelEventMsgHdl;
   struct EvQEl {       //event queue entry//
      QElemPtr    qLink;            //next queue entry//
      short       qType;            //queue type (evType)//
      short       evtQWhat;         //event code//
      long        evtQMessage;      //event message//
      long        evtQWhen;         //ticks since startup//
      Point       evtQWhere;        //mouse location//
      short       evtQModifiers;    //modifier flags//
   };
   typedef struct EvQEl EvQEl;
   typedef EvQEl *EvQElPtr;
typedef pascal Boolean (*GetSpecificFilterProcPtr) 
(void *yourDataPtr, 
HighLevelEventMsgPtr msgBuff, 
const TargetID *sender);
 */

struct TargetID {
      long              sessionID;     //session reference number (not //
                                       // used if posting an event)//
      PPCPortRec        name;          //port name//
      LocationNameRec   location;      //location name//
      PPCPortRec        recvrName;     //reserved//
   };

typedef struct TargetID TargetID;

#ifdef __cplusplus
}
#endif

#endif //OC__EPPC__

