#ifndef NSEXCEPTIONHANDLER_H
#define NSEXCEPTIONHANDLER_H

#import "ExceptionHandlingDefines.h"
#import <Foundation/NSObject.h>
@class NSString, NSException;



@interface NSExceptionHandler : NSObject

/*defaultExceptionHandler

Returns the singleton NSExceptionHandler instance.

+ (NSExceptionHandler *)defaultExceptionHandler
Availability
Available in Mac OS X v10.0 and later.*/
+ (NSExceptionHandler *)defaultExceptionHandler;

/*exceptionHandlingMask

Returns a bit mask representing the types of exceptions monitored by the receiver and its handling and logging behavior. 

- (unsigned int)exceptionHandlingMask
Return Value

A bit mask composed of one or more constants specifying the types of exceptions monitored and whether they are handled or logged (or both). See Logging and Handling Constants for information about the constants.
Availability
Available in Mac OS X v10.0 and later.*/
- (unsigned int)exceptionHandlingMask;

/*setExceptionHandlingMask:

Sets the bit mask of constants specifying the types of exceptions monitored by the receiver and its handling and logging behavior. 

- (void)setExceptionHandlingMask:(unsigned int)aMask
Parameters
aMask

A bit mask composed of one or more constants specifying the types of exceptions monitored and whether they are handled or logged (or both). You specify multiple constants by performing a bitwise-OR operation. See Logging and Handling Constants for information about the constants.
Availability
Available in Mac OS X v10.0 and later.*/
- (void)setExceptionHandlingMask:(unsigned int)aMask;

@end

@interface NSObject(NSExceptionHandlerDelegate)
@end



#endif
