#ifndef OC_FOUNDATION_NSZONE_H
#define OC_FOUNDATION_NSZONE_H

#import <Foundation/NSObjCRuntime.h>
#include <CoreFoundation/CFBase.h>

#import "/usr/GNUstep/System/Library/Headers/Foundation/NSZone.h"


////////////

/*NSMakeCollectable

Makes a newly allocated Core Foundation object eligible for collection.

NS_INLINE id NSMakeCollectable(CFTypeRef cf) {
   return cf ? (id)CFMakeCollectable(cf) : nil;
}
Discussion

This function is a wrapper for CFMakeCollectable, but its return type is id—avoiding the need for casting when using Cocoa objects.

This function may be useful when returning Core Foundation objects in code that must support both garbage-collected and non-garbage-collected environments, as illustrated in the following example.- (CFDateRef)foo {
    CFDateRef aCFDate;
    // ...
    return [NSMakeCollectable(aCFDate) autorelease];
}


CFTypeRef style objects are garbage collected, yet only sometime after the last CFRelease is performed. Particularly for fully-bridged CFTypeRef objects such as CFStrings and collections (such as CFDictionary), you must call either CFMakeCollectable or the more type safe NSMakeCollectable, preferably right upon allocation.
Declared In
NSZone.h*/
NS_INLINE id NSMakeCollectable(CFTypeRef cf) {
   return cf ? (id)CFMakeCollectable(cf) : nil;
}

#endif//OC_FOUNDATION_NSZONE_H
