#ifndef HYS_COMMONOCRYPTO_COMMONDIGEST_H
#define HYS_COMMONOCRYPTO_COMMONDIGEST_H

#define CC_SHA1_DIGEST_LENGTH 1//?
#define CC_MD4_BLOCK_BYTES 2//?
#define CC_MD5_BLOCK_BYTES 3//?
#define CC_SHA512_BLOCK_BYTES 4//?
#define CC_SHA512_DIGEST_LENGTH 5//?
#define CC_MD5_DIGEST_LENGTH 6//?
#define CC_SHA1_BLOCK_BYTES 7//?
#define CC_SHA224_DIGEST_LENGTH 8//?
#define CC_SHA224_BLOCK_BYTES 9//?
#define CC_SHA256_DIGEST_LENGTH 10//?
#define CC_SHA256_BLOCK_BYTES 11//?
#define CC_SHA384_DIGEST_LENGTH 12//?
#define CC_SHA384_BLOCK_BYTES 13//?
#define CC_MD4_DIGEST_LENGTH 16//?
#define CC_MD2_BLOCK_BYTES 17//?
#define CC_MD2_DIGEST_LENGTH 18//?

/////////////////////

#ifdef	COMMON_DIGEST_FOR_OPENSSL
	#define MD5_CTX						CC_MD5_CTX//c
	#define SHA_CTX						CC_SHA1_CTX//c
#endif	/* COMMON_DIGEST_FOR_OPENSSL */

#ifdef	COMMON_DIGEST_FOR_RFC_1321
	#define MD5_CTX						CC_MD5_CTX.//c
#endif	/* COMMON_DIGEST_FOR_RFC_1321 */


#define CC_SHA1_BLOCK_LONG      (CC_SHA1_BLOCK_BYTES / sizeof(CC_LONG))//c
#define CC_MD2_BLOCK_LONG       (CC_MD2_BLOCK_BYTES / sizeof(CC_LONG))//c
#define CC_MD4_BLOCK_LONG       (CC_MD4_BLOCK_BYTES / sizeof(CC_LONG))//c
#define CC_MD5_BLOCK_LONG       (CC_MD5_BLOCK_BYTES / sizeof(CC_LONG))//c

///////////////////

typedef uint32_t CC_LONG;//c
typedef uint64_t CC_LONG64;//c
//////////////
struct CC_SHA1state_st {
	CC_LONG h0,h1,h2,h3,h4;//c
	CC_LONG Nl,Nh;//c
	int num;//c
	CC_LONG data[CC_SHA1_BLOCK_LONG];//c
};
typedef struct CC_SHA1state_st CC_SHA1_CTX;

struct CC_MD2state_st {
	int num;//c
	CC_LONG state[CC_MD2_BLOCK_LONG];//c
    	CC_LONG cksm[CC_MD2_BLOCK_LONG];//c
    	unsigned char data[CC_MD2_DIGEST_LENGTH];//c
};
typedef struct CC_MD2state_st  CC_MD2_CTX;

struct CC_MD4state_st {
	CC_LONG Nl,Nh;//c
	int num;//c
	CC_LONG data[CC_MD4_BLOCK_LONG];//c
	CC_LONG A,B,C,D;//c
};
typedef struct CC_MD4state_st  CC_MD4_CTX;

struct CC_MD5state_st {
	CC_LONG Nl,Nh;//c
	int num;//c
	CC_LONG data[CC_MD5_BLOCK_LONG];//c
	CC_LONG A,B,C,D;//c
};
typedef struct CC_MD5state_st  CC_MD5_CTX;

struct CC_SHA256state_st {
    	CC_LONG wbuf[16];//c
    	CC_LONG hash[8];//c
	CC_LONG count[2];//c
};
typedef struct CC_SHA256state_st  CC_SHA256_CTX;

struct CC_SHA512state_st { 
    	CC_LONG64 hash[8];//c
  	CC_LONG64 count[2];//c
    	CC_LONG64 wbuf[16];//c
};
typedef struct CC_SHA512state_st  CC_SHA512_CTX;

#endif //HYS_COMMONOCRYPTO_COMMONDIGEST_H
