#ifndef HYS_COREFOUNDATION_CFSTREAMABSTRACT_H
#define HYS_COREFOUNDATION_CFSTREAMABSTRACT_H

typedef struct {
   	CFIndex version;//c
    	void *(*create)(CFReadStreamRef stream, void *info);//c
    	void (*finalize)(CFReadStreamRef stream, void *info);//c
    	CFStringRef (*copyDescription)(CFReadStreamRef stream, void *info);//c
    	Boolean (*open)(CFReadStreamRef stream, CFErrorRef *error, Boolean *openComplete, void *info);//c
    	Boolean (*openCompleted)(CFReadStreamRef stream, CFErrorRef *error, void *info);//c
    	CFIndex (*read)(CFReadStreamRef stream, UInt8 *buffer, CFIndex bufferLength, CFErrorRef *error, Boolean *atEOF, void *info);//c
    	const UInt8 *(*getBuffer)(CFReadStreamRef stream, CFIndex maxBytesToRead, CFIndex *numBytesRead, CFErrorRef *error, Boolean *atEOF, void *info);//c
    	Boolean (*canRead)(CFReadStreamRef stream, CFErrorRef *error, void *info);//c
    	void (*close)(CFReadStreamRef stream, void *info);//c
    	CFTypeRef (*copyProperty)(CFReadStreamRef stream, CFStringRef propertyName, void *info);//c
    	Boolean (*setProperty)(CFReadStreamRef stream, CFStringRef propertyName, CFTypeRef 	propertyValue, void *info);//c
	    void (*requestEvents)(CFReadStreamRef stream, CFOptionFlags streamEvents, void *info);//c
    	void (*schedule)(CFReadStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
    	void (*unschedule)(CFReadStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
} CFReadStreamCallBacks;

typedef struct {
    	Boolean (*open)(CFWriteStreamRef stream, CFStreamError *error, Boolean *openComplete, void *info);//
	Boolean (*openCompleted)(CFWriteStreamRef stream, CFStreamError *error, void *info);//c
    	CFIndex (*read)(CFReadStreamRef stream, UInt8 *buffer, CFIndex bufferLength, CFStreamError *error, Boolean *atEOF, void *info);//c
  	const UInt8 *(*getBuffer)(CFReadStreamRef stream, CFIndex maxBytesToRead, CFIndex *numBytesRead, CFStreamError *error, Boolean *atEOF, void *info);//c
    	Boolean (*canRead)(CFReadStreamRef stream, void *info);//c
    	void (*close)(CFReadStreamRef stream, void *info);//c
    	CFTypeRef (*copyProperty)(CFReadStreamRef stream, CFStringRef propertyName, void *info);//c
  	void (*schedule)(CFReadStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
    	void (*unschedule)(CFReadStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
} CFReadStreamCallBacksV0;

typedef struct {
    	void *(*create)(CFReadStreamRef stream, void *info);//c
    	void (*finalize)(CFReadStreamRef stream, void *info);//c
    	CFStringRef (*copyDescription)(CFReadStreamRef stream, void *info);//c
    	Boolean (*open)(CFReadStreamRef stream, CFStreamError *error, Boolean *openComplete, void *info);//c
    	Boolean (*openCompleted)(CFReadStreamRef stream, CFStreamError *error, void *info);//c
    	CFIndex (*read)(CFReadStreamRef stream, UInt8 *buffer, CFIndex bufferLength, CFStreamError *error, Boolean *atEOF, void *info);//c
    	const UInt8 *(*getBuffer)(CFReadStreamRef stream, CFIndex maxBytesToRead, CFIndex *numBytesRead, CFStreamError *error, Boolean *atEOF, void *info);//c
    	Boolean (*canRead)(CFReadStreamRef stream, void *info);//c
    	void (*close)(CFReadStreamRef stream, void *info);//c
    	CFTypeRef (*copyProperty)(CFReadStreamRef stream, CFStringRef propertyName, void *info);//c
    	Boolean (*setProperty)(CFReadStreamRef stream, CFStringRef propertyName, CFTypeRef propertyValue, void *info);//c
    	void (*requestEvents)(CFReadStreamRef stream, CFOptionFlags streamEvents, void *info);//c
    	void (*schedule)(CFReadStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
    	void (*unschedule)(CFReadStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
} CFReadStreamCallBacksV1;

typedef struct {
    	CFIndex version;//c
   	void *(*create)(CFWriteStreamRef stream, void *info);//c
    	void (*finalize)(CFWriteStreamRef stream, void *info);//c
    	CFStringRef (*copyDescription)(CFWriteStreamRef stream, void *info);//c
    	Boolean (*open)(CFWriteStreamRef stream, CFErrorRef *error, Boolean *openComplete, void *info);//c
   	Boolean (*openCompleted)(CFWriteStreamRef stream, CFErrorRef *error, void *info);//c
    	CFIndex (*write)(CFWriteStreamRef stream, const UInt8 *buffer, CFIndex bufferLength, CFErrorRef *error, void *info);//c
    	Boolean (*canWrite)(CFWriteStreamRef stream, CFErrorRef *error, void *info); //c
    	void (*close)(CFWriteStreamRef stream, void *info);//c
    	CFTypeRef (*copyProperty)(CFWriteStreamRef stream, CFStringRef propertyName, void *info);//c
    	Boolean (*setProperty)(CFWriteStreamRef stream, CFStringRef propertyName, CFTypeRef propertyValue, void *info);//c
    	void (*requestEvents)(CFWriteStreamRef stream, CFOptionFlags streamEvents, void *info);//c
    	void (*schedule)(CFWriteStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
    	void (*unschedule)(CFWriteStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
} CFWriteStreamCallBacks;

typedef struct {
    	Boolean (*open)(CFWriteStreamRef stream, CFStreamError *error, Boolean *openComplete, void *info);//c
    	Boolean (*openCompleted)(CFWriteStreamRef stream, CFStreamError *error, void *info);//c
    	CFIndex (*write)(CFWriteStreamRef stream, const UInt8 *buffer, CFIndex bufferLength, CFStreamError *error, void *info);//c
    	Boolean (*canWrite)(CFWriteStreamRef stream, void *info); //c
    	void (*close)(CFWriteStreamRef stream, void *info);//c
    	CFTypeRef (*copyProperty)(CFWriteStreamRef stream, CFStringRef propertyName, void *info);//c
    	void (*schedule)(CFWriteStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
    	void (*unschedule)(CFWriteStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
} CFWriteStreamCallBacksV0;

typedef struct {
	void *(*create)(CFWriteStreamRef stream, void *info);//c
    	void (*finalize)(CFWriteStreamRef stream, void *info);//c
    	CFStringRef (*copyDescription)(CFWriteStreamRef stream, void *info);//c
    	Boolean (*open)(CFWriteStreamRef stream, CFStreamError *error, Boolean *openComplete, void *info);//c
    	Boolean (*openCompleted)(CFWriteStreamRef stream, CFStreamError *error, void *info);//c
    	CFIndex (*write)(CFWriteStreamRef stream, const UInt8 *buffer, CFIndex bufferLength, CFStreamError *error, void *info);//c
    	Boolean (*canWrite)(CFWriteStreamRef stream, void *info); //c
    	void (*close)(CFWriteStreamRef stream, void *info);//c
    	CFTypeRef (*copyProperty)(CFWriteStreamRef stream, CFStringRef propertyName, void *info);//c
    	Boolean (*setProperty)(CFWriteStreamRef stream, CFStringRef propertyName, CFTypeRef propertyValue, void *info);//c
    	void (*requestEvents)(CFWriteStreamRef stream, CFOptionFlags streamEvents, void *info);//c
    	void (*schedule)(CFWriteStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
    	void (*unschedule)(CFWriteStreamRef stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
} CFWriteStreamCallBacksV1;

/////////////////////
CF_EXPORT void *CFReadStreamGetInfoPointer(CFReadStreamRef stream);//c
CF_EXPORT void *CFWriteStreamGetInfoPointer(CFWriteStreamRef stream);//c

CF_EXPORT void CFWriteStreamSignalEvent(CFWriteStreamRef stream, CFStreamEventType event, const void *error);//c

CF_EXPORT void CFReadStreamSignalEvent(CFReadStreamRef stream, CFStreamEventType event, const void *error);//c

#endif//HYS_COREFOUNDATION_CFSTREAMABSTRACT_H
