#ifndef HYS_COREFOUNDATION_CFSTREAMPRIV_H
#define HYS_COREFOUNDATION_CFSTREAMPRIV_H

struct _CFStream;

struct _CFStreamClient {
    	CFOptionFlags when;//c
	CFRunLoopSourceRef rlSource;//c
    	CFOptionFlags whatToSignal;//c
    	CFStreamClientContext cbContext;//c
    	CFMutableArrayRef runLoopsAndModes;//c
    	void (*cb)(struct _CFStream *, CFStreamEventType, void *);//c
};

struct _CFStreamCallBacks {
    	CFStringRef (*copyDescription)(struct _CFStream *stream, void *info);//c
    	CFIndex version;//c
    	void (*close)(struct _CFStream *stream, void *info);//c
    	void (*finalize)(struct _CFStream *stream, void *info);//c
    	void *(*create)(struct _CFStream *stream, void *info);//c
    	Boolean (*open)(struct _CFStream *stream, CFErrorRef *error, Boolean *openComplete, void *info);//c
    	Boolean (*openCompleted)(struct _CFStream *stream, CFErrorRef *error, void *info);//c
    	CFIndex (*read)(CFReadStreamRef stream, UInt8 *buffer, CFIndex bufferLength, CFErrorRef *error, Boolean *atEOF, void *info);//c
    	const UInt8 *(*getBuffer)(CFReadStreamRef sream, CFIndex maxBytesToRead, CFIndex *numBytesRead, CFErrorRef *error, Boolean *atEOF, void *info);//c
    	Boolean (*canRead)(CFReadStreamRef, CFErrorRef *error, void *info);//c
    	CFIndex (*write)(CFWriteStreamRef, const UInt8 *buffer, CFIndex bufferLength, CFErrorRef *error, void *info);//c
    	Boolean (*canWrite)(CFWriteStreamRef, CFErrorRef *error, void *info); //c
    	CFTypeRef (*copyProperty)(struct _CFStream *stream, CFStringRef propertyName, void *info);//c
    	Boolean (*setProperty)(struct _CFStream *stream, CFStringRef propertyName, CFTypeRef propertyValue, void *info);//c
    	void (*requestEvents)(struct _CFStream *stream, CFOptionFlags events, void *info);//c
    	void (*schedule)(struct _CFStream *stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
    	void (*unschedule)(struct _CFStream *stream, CFRunLoopRef runLoop, CFStringRef runLoopMode, void *info);//c
};

struct _CFStream {
    	const struct _CFStreamCallBacks *callBacks; //c
  	CFOptionFlags flags;//c
    	struct _CFStreamClient *client;//c
    	CFErrorRef error;//c
   	void *info;//c
};

//////////////////
CF_EXPORT struct _CFStream *_CFStreamCreateWithConstantCallbacks(CFAllocatorRef alloc, void *info, const struct _CFStreamCallBacks *cb, Boolean isReading);//c

CF_INLINE void *_CFStreamGetInfoPointer(struct _CFStream *stream) {};//?

#endif//HYS_COREFOUNDATION_CFSTREAMPRIV_H
