#ifndef HYS_COREGOUNDATION_CFSTRINGENCODINGCONVERTER_H
#define HYS_COREGOUNDATION_CFSTRINGENCODINGCONVERTER_H

#define CFStringEncodingLossyByteToMask(lossByte)	((uint32_t)(lossByte << 24)|kCFStringEncodingAllowLossyConversion)//c

#define CFStringEncodingMaskToLossyByte(flags)		((uint8_t)(flags >> 24))//c

///////////////////////////////
enum {
	kCFStringEncodingAllowLossyConversion,//?
	kCFStringEncodingConversionSuccess,//?
	kCFStringEncodingInvalidInputStream,//?
	kCFStringEncodingInsufficientOutputBufferLength,//?
	kCFStringEncodingConverterUnavailable,//?
};

enum {
    	kCFStringEncodingUseHFSPlusCanonical = (1 << 7),//c
  	kCFStringEncodingUseCanonical = (1 << 6), //c
	kCFStringEncodingLenientUTF8Conversion = (1 << 11),//c
    	kCFStringEncodingASCIICompatibleConversion = (1 << 10),//c
   	kCFStringEncodingPrependBOM = (1 << 8),//c
 	kCFStringEncodingSubstituteCombinings = (1 << 3),//c
  	kCFStringEncodingIgnoreCombinings = (1 << 5),//c
 	kCFStringEncodingComposeCombinings = (1 << 4),//c
};

/////////////////

typedef CFIndex (*CFStringEncodingToBytesFallbackProc)(const UniChar *characters, CFIndex numChars, uint8_t *bytes, CFIndex maxByteLen, CFIndex *usedByteLen);//c

typedef CFIndex (*CFStringEncodingToUnicodeFallbackProc)(const uint8_t *bytes, CFIndex numBytes, UniChar *characters, CFIndex maxCharLen, CFIndex *usedCharLen);//c
////////////

extern bool CFStringEncodingIsValidEncoding(uint32_t encoding);//c

extern CFIndex CFStringEncodingCharLengthForBytes(uint32_t encoding, uint32_t flags, const uint8_t *bytes, CFIndex numBytes);//c

extern uint32_t CFStringEncodingBytesToUnicode(uint32_t encoding, uint32_t flags, const uint8_t *bytes, CFIndex numBytes, CFIndex *usedByteLen, UniChar *characters, CFIndex maxCharLen, CFIndex *usedCharLen);//c

extern uint32_t CFStringEncodingUnicodeToBytes(uint32_t encoding, uint32_t flags, const UniChar *characters, CFIndex numChars, CFIndex *usedCharLen, uint8_t *bytes, CFIndex maxByteLen, CFIndex *usedByteLen);//c

extern const uint32_t *CFStringEncodingListOfAvailableEncodings(void);//c
extern const char *CFStringEncodingName(uint32_t encoding);//c
extern const char **CFStringEncodingCanonicalCharsetNames(uint32_t encoding);//c

extern CFIndex CFStringEncodingByteLengthForCharacters(uint32_t encoding, uint32_t flags, const UniChar *characters, CFIndex numChars);//c

#endif//HYS_COREGOUNDATION_CFSTRINGENCODINGCONVERTER_H
