#ifndef HYS_DIRECTORYSERVOCECORE_DSMUTEXSEMAPHORE_H
#define HYS_DIRECTORYSERVOCECORE_DSMUTEXSEMAPHORE_H

/////////

#if defined(DEBUG_LOCKS) && defined(DEBUG_LOCKS_HISTORY)
	#error cannot define both DEBUG_LOCKS and DEBUG_LOCKS_HISTORY
#elif defined(DEBUG_LOCKS_HISTORY)
	#define WaitLock()				WaitDebugHistory( __FILE__, __LINE__ )
	#define WaitTryLock()			WaitTryDebugHistory( __FILE__, __LINE__ )
	#define SignalLock()			SignalDebugHistory( __FILE__, __LINE__ )
#else
	#define WaitLock()				WaitDebug( __FILE__, __LINE__ )
	#define WaitTryLock()			WaitTryDebug(__FILE__, __LINE__ )
	#define SignalLock()			SignalDebug( __FILE__, __LINE__ )
#endif//c

class DSMutexSemaphore_HYS
{
public:
#define DSMutexSemaphore_INIT \
		DSMutexSemaphore	( const char *mutexName = NULL, bool bShouldDTrace = true );//c

	#define DSMutexSemaphore_Wait \
void		Wait				( void );//c
			
	#define DSMutexSemaphore_Signal \
void		Signal				( void );//c

	#define DSMutexSemaphore_WaitDebug \
	void		WaitDebug			( char *file, int line );//c
	
		#define DSMutexSemaphore_SignalDebug \
void		SignalDebug			( char *file, int line );//c
		
				#define DSMutexSemaphore_WaitTry \
	bool		WaitTry				( void );//c

};

#endif //HYS_DIRECTORYSERVOCECORE_DSMUTEXSEMAPHORE_H
