#ifndef HYS_EAP8021X_EAPCLIEBTPLUGIN_H
#define HYS_EAP8021X_EAPCLIEBTPLUGIN_H

enum {
	kEAPClientStateAuthenticating,//?
	kEAPClientStateFailure,//?
	kEAPClientStateSuccess,//?
};
/////////////////////
#define kEAPClientPluginFuncNamePacketDump	"packet_dump"//c
#define kEAPClientPluginVersion		((EAPClientPluginVersion)1)//c
#define kEAPClientPluginFuncNameVersion		"version"//c
#define kEAPClientPluginFuncNameEAPType		"eap_type"//c
#define kEAPClientPluginFuncNameEAPName		"eap_name"//c
#define kEAPClientPluginFuncNameInit		"init"//c
#define kEAPClientPluginFuncNameFree		"free"//c
#define kEAPClientPluginFuncNameProcess		"process"//c
#define kEAPClientPluginFuncNameFreePacket	"free_packet"//c
#define kEAPClientPluginFuncNameFailureString	"failure_string"//c
#define kEAPClientPluginFuncNameSessionKey	"session_key"//c
#define kEAPClientPluginFuncNameServerKey	"server_key"//c
#define kEAPClientPluginFuncNameRequireProperties	"require_properties"//c
#define kEAPClientPluginFuncNamePublishProperties	"publish_properties"//c
#define kEAPClientPluginFuncNameIntrospect	"introspect"//c
#define kEAPClientPluginFuncNameUserName	"user_name"//c

////////////
typedef const char * EAPClientPluginFuncName;//c
typedef void * (*EAPClientPluginFuncRef)();//c
typedef uint32_t EAPClientPluginVersion;//c
typedef const char * (EAPClientPluginFuncEAPName)(void);//;c
typedef uint32_t EAPClientState;//c
typedef void * EAPClientPluginPrivateData;//c

//////////////

struct EAPClientPluginData_s { 
    	EAPClientPluginPrivateData	private;//c
    	const void *		unique_id;//c
    	const uint32_t		unique_id_length;//c
    	const uint32_t		mtu;//c
 	const CFDictionaryRef	properties;//c
    	const uint32_t		password_length;//c
   	const uint32_t		username_length;//c
    	const uint8_t *		username;//c
	const uint8_t *		password;//c
   	const uint32_t		generation;//c
    	const bool		log_enabled;//c
    	const bool		system_mode;//c
};
typedef struct EAPClientPluginData_s EAPClientPluginData;
typedef struct EAPClientPluginData_s *EAPClientPluginDataRef;

typedef void (EAPClientPluginFuncFree)(EAPClientPluginDataRef plugin);//c

typedef EAPClientPluginFuncRef (EAPClientPluginFuncIntrospect)(EAPClientPluginFuncName name);//c

typedef EAPClientPluginVersion (EAPClientPluginFuncVersion)(void);//c
typedef EAPType (EAPClientPluginFuncEAPType)(void);//c

typedef EAPClientStatus (EAPClientPluginFuncInit)(EAPClientPluginDataRef plugin,
						  CFArrayRef * require_props,
						  EAPClientDomainSpecificError * error);//c

typedef EAPClientState
(EAPClientPluginFuncProcess)(EAPClientPluginDataRef plugin,
			     const EAPPacketRef in_pkt,
			     EAPPacketRef * out_pkt_p,
			     EAPClientStatus * status,
			     EAPClientDomainSpecificError * error);//c

typedef void 
(EAPClientPluginFuncFreePacket)(EAPClientPluginDataRef plugin,
				EAPPacketRef out_pkt);//c

typedef void * 
(EAPClientPluginFuncSessionKey)(EAPClientPluginDataRef plugin, int * key_length);//c

typedef void * 
(EAPClientPluginFuncServerKey)(EAPClientPluginDataRef plugin, int * key_length);//c

typedef CFArrayRef
(EAPClientPluginFuncRequireProperties)(EAPClientPluginDataRef plugin);//c

typedef CFDictionaryRef
(EAPClientPluginFuncPublishProperties)(EAPClientPluginDataRef plugin);//c

typedef bool
(EAPClientPluginFuncPacketDump)(FILE * out_f, const EAPPacketRef packet);//c

typedef const char * 
(EAPClientPluginFuncFailureString)(EAPClientPluginDataRef plugin);//c

typedef CFStringRef
(EAPClientPluginFuncUserName)(CFDictionaryRef properties);//c

#endif//HYS_EAP8021X_EAPCLIEBTPLUGIN_H
