#ifndef HYS_EAP8021X_EAPOL_H
#define HYS_EAP8021X_EAPOL_H

#define EAPOL_802_1_X_GROUP_ADDRESS	{ 0x01, 0x80, 0xc2, 0x00, 0x00, 0x03 }//c

//////////////
#define EAPOL_802_1_X_ETHERTYPE 1//?
#define EAPOL_802_1_X_PROTOCOL_VERSION 2//?

/////////////
enum {
	kEAPOLKeyDescriptorTypeRC4,//?
    	kEAPOLPacketTypeEAPPacket,//?
	kEAPOLPacketTypeEncapsulatedASFAlert,//?
	kEAPOLKeyDescriptorIndexUnicastFlag,//?
	kEAPOLKeyDescriptorIndexMask,//?
	kEAPOLPacketTypeKey,//?
	kEAPOLPacketTypeStart,//?
	kEAPOLPacketTypeLogoff,//?
};
////////////
typedef uint32_t EAPOLPacketType;//c
typedef uint32_t EAPOLKeyDescriptorType;//c

/////////////
struct EAPOLPacket{ 
    	uint8_t	packet_type;//c
    	uint8_t	body[0];//c
    	uint8_t	protocol_version;//c
};
typedef struct EAPOLPacket EAPOLPacket;
typedef struct EAPOLPacket* EAPOLPacketRef;

struct EAPOLKeyDescriptor {
    	uint8_t		key_index;//c
    	uint8_t		descriptor_type;//c
    	uint8_t		replay_counter[8];//c
    	uint8_t		key_IV[16];//c
    	uint8_t		key_signature[16];//c
    	uint8_t		key[0];//c
};
typedef struct EAPOLKeyDescriptor EAPOLKeyDescriptor;
typedef struct EAPOLKeyDescriptor * EAPOLKeyDescriptorRef;

#endif//HYS_EAP8021X_EAPOL_H
