#ifndef HYS_EAP8021X_MSCHAP_H
#define HYS_EAP8021X_MSCHAP_H

#define MSCHAP2_RESPONSE_LENGTH		(MSCHAP2_CHALLENGE_SIZE \
			 		 + MSCHAP2_RESERVED_SIZE \
				 	 + MSCHAP_NT_RESPONSE_SIZE \
					 + MSCHAP_FLAGS_SIZE)//c
//////////////////////////////
#define MSCHAP2_CHALLENGE_SIZE 1//?
#define MSCHAP_NT_RESPONSE_SIZE 2//?
#define MSCHAP_NT_CHALLENGE_SIZE 3//?
#define MSCHAP_IDENT_SIZE 4//?
#define MSCHAP_LM_RESPONSE_SIZE 5//?
#define MSCHAP_FLAGS_SIZE 6//?
#define MSCHAP2_RESERVED_SIZE 7//?
#define MSCHAP2_AUTH_RESPONSE_SIZE 8//?
#define NT_PASSWORD_HASH_SIZE 9//?
#define NT_MAXPWLEN 10//?
#define NT_SESSION_KEY_SIZE 11//?
#define NT_MASTER_KEY_SIZE 12//?
#define NT_PASSWORD_BLOCK_SIZE 13//?

/////////////////////

struct NTPasswordBlock_s {
    	uint8_t		password[NT_MAXPWLEN * 2];//c
    	uint32_t		password_length;//c
 };
typedef struct NTPasswordBlock_s NTPasswordBlock;
typedef struct NTPasswordBlock_s * NTPasswordBlockRef;

struct MSCHAP2Response {
  	uint8_t		peer_challenge[MSCHAP2_CHALLENGE_SIZE];//c
    	uint8_t		reserved[MSCHAP2_RESERVED_SIZE];//c
  	uint8_t		nt_response[MSCHAP_NT_RESPONSE_SIZE];//c
    	uint8_t		flags[MSCHAP_FLAGS_SIZE];//c
};
typedef struct  MSCHAP2Response MSCHAP2Response;
typedef struct  MSCHAP2Response * MSCHAP2ResponseRef;

///////////////
void MSChapFillWithRandom(void * buf, uint32_t len);//c

#endif//HYS_EAP8021X_MSCHAP_H
