#ifndef HYS_IOI2C_IOI2CDEFS_H
#define HYS_IOI2C_IOI2CDEFS_H

#define isI2C10BitAddress(a) a//?

#define kLockI2Cbus "kLockI2Cbus"//?
#define kUnlockI2Cbus "kUnlockI2Cbus"//?
#define kWriteI2Cbus "kWriteI2Cbus"//?
#define kReadI2Cbus "kReadI2Cbus"//?
#define kIOI2CGetMaxI2CDataLength "kIOI2CGetMaxI2CDataLength"//?
#define kIOI2CClientWrite "kIOI2CClientWrite"//?
#define kIOI2CClientRead "kIOI2CClientRead"//?

#define kIOI2CUserClientType 1//?
#define kI2CUCBufSize 2//?
#define kIOI2C_CLIENT_KEY_INVALID 3//?

enum {
	kI2COption_NoInterrupts,//?
	kI2COption_VerboseLog,//?
	kI2CMode_Unspecified,//?
	kI2CUCWrite,//?
	kI2CUCRead,//?
	kI2CUCUnlock,//?
	kI2CUCLock,//?
	kI2CMode_Combined,//?
	kIOI2C_CLIENT_KEY_DEFAULT,//?
	kI2CMode_Standard,//?
	kI2CMode_StandardSub,//?
	kI2CUCRMW,//?
	kI2CCommand_Write,//?
	kI2CCommand_Read,//?
	kI2CUCNumMethods,//?
};

struct I2CReadInput {
	int busNo;//?
	int addr;//?
	int subAddr;//?
	int count;//?
	int mode;//?
};
typedef struct I2CReadInput I2CReadInput;

struct I2CReadOutput {
	int realCount;//?
	int buf[1];//?
};
typedef struct I2CReadOutput I2CReadOutput;

struct I2CWriteInput {
	int mode;//?
	int busNo;//?
	int addr;//?
	int subAddr;//?
	int count;//?
	int buf[1];//?
};
typedef struct I2CWriteInput I2CWriteInput;

struct I2CWriteOutput {
	int realCount;//?
};
typedef struct I2CWriteOutput I2CWriteOutput;

struct I2CRMWInput {};
typedef struct I2CRMWInput I2CRMWInput;

struct I2CUserReadInput {
	int count;//?
	int mode;//?
	int subAddr;//?
	int key;//?
	int options;//?
	int busNo;//?
 	int addr;//?
};
typedef struct I2CUserReadInput I2CUserReadInput;

struct I2CUserReadOutput {
	int realCount;//?
	UInt8 buf[1];//?
};
typedef struct I2CUserReadOutput I2CUserReadOutput;

struct I2CUserWriteInput {
	int count;//?
	int mode;//?
	int subAddr;//?
	int key;//?
	UInt8 buf[1];//?
 	int options;//?
	int busNo;//?
	int addr;//?
};
typedef struct I2CUserWriteInput I2CUserWriteInput;

struct I2CUserWriteOutput {
	int realCount;//?
};
typedef struct I2CUserWriteOutput I2CUserWriteOutput;

struct IOI2CCommand {
	int bus;//?
	int address;//?
	int subAddress;//?
	UInt8* buffer;//c
	int count;//?
	int mode;//?
	int bytesTransfered;//?
	int timeout_uS;//?
	int retries;//?
	int options;//?
 	int command;//?
};
typedef struct IOI2CCommand IOI2CCommand;

#endif//HYS_IOI2C_IOI2CDEFS_H
