#ifndef HYS_IOKIT_IOINTERRUPTCONTROLLER_H
#define HYS_IOKIT_IOINTERRUPTCONTROLLER_H

class IOSharedInterruptController;
struct IOInterruptVector {
  volatile char               interruptActive;
  volatile char               interruptDisabledSoft;
  volatile char               interruptDisabledHard;
  volatile char               interruptRegistered;
  IOLock *                    interruptLock;
  IOService *                 nub;
  long                        source;
  void *                      target;
  IOInterruptHandler          handler;
  void *                      refCon;
  IOSharedInterruptController *sharedController;
};//c


class IOInterruptController_HYS
{
  OSDeclareAbstractStructors(IOInterruptController_HYS);

public://data
IOInterruptVector *vectors;//c

public://func

#define IOInterruptController_registerInterrupt \
  virtual IOReturn registerInterrupt(IOService *nub, int source,void *target,IOInterruptHandler handler,void *refCon);//c

#define IOInterruptController_unregisterInterrupt \
  virtual IOReturn unregisterInterrupt(IOService *nub, int source);//c


};

#endif//HYS_IOKIT_IOINTERRUPTCONTROLLER_H
