#ifndef  HYS_IOKIT_IOMEMORYDESCRIPTOR_H
#define HYS_IOKIT_IOMEMORYDESCRIPTOR_H


enum {
	kIOMemoryDirectionMask,//?
	kIOMemoryTypeUPL,//?
	kIOMemoryAsReference,//?
	kIOMemoryTypeUIO,//?
};

///////////////////////
enum IODirection {
    kIODirectionNone,//?
    kIODirectionIn ,//?
    kIODirectionOut,//?
    kIODirectionOutIn = kIODirectionOut | kIODirectionIn,//c
    kIODirectionInOut = kIODirectionIn  | kIODirectionOut,//c
};

///////////////////////////////////////////////////

struct IOPhysicalRange
{
    IOPhysicalAddress	address;
    IOByteCount		length;
};//c

#ifdef __cplusplus
//class IOMemoryDescriptor;//add

class  IOMemoryDescriptor_HYS
{
   OSDeclareDefaultStructors(IOMemoryDescriptor_HYS)
public://data

IOByteCount         _length; //c
IODirection         _direction; //c

public://func

#define IOMemoryDescriptor_getPhysicalSegment64 \
virtual addr64_t getPhysicalSegment64( IOByteCount offset,IOByteCount * length );//c

#define IOMemoryDescriptor_getVirtualSegment \
virtual void * getVirtualSegment(IOByteCount offset, IOByteCount * length) = 0;//c

#define IOMemoryDescriptor_redirect \
IOReturn redirect( task_t safeTask, bool redirect );//c

};

class IOSubMemoryDescriptor_HYS
{
  OSDeclareDefaultStructors(IOSubMemoryDescriptor_HYS);

public://data
    IOByteCount 	 _start;//c

public://define

#define IOSubMemoryDescriptor_initWithRanges \
    virtual bool initWithRanges(        IOVirtualRange * ranges, \
                                        UInt32           withCount, \
                                        IODirection      withDirection, \
                                        task_t           withTask, \
                                        bool             asReference = false);//c

#define IOSubMemoryDescriptor_initWithAddress  \
    virtual bool initWithAddress(void *       address, \
                                 IOByteCount    withLength, \
                                 IODirection  withDirection);//c

#define IOSubMemoryDescriptor_initWithAddress_vm_address_t \
    virtual bool initWithAddress(vm_address_t address, \
                                 IOByteCount    withLength, \
                                 IODirection  withDirection,\
                                 task_t       withTask);//c

#define IOSubMemoryDescriptor_prepare \
virtual IOReturn prepare(IODirection forDirection = kIODirectionNone);//c

#define IOSubMemoryDescriptor_complete \
    virtual IOReturn complete(IODirection forDirection = kIODirectionNone);//c

#define IOSubMemoryDescriptor_getPhysicalSegment \
    virtual IOPhysicalAddress getPhysicalSegment(IOByteCount offset, IOByteCount * length);//c

#define IOSubMemoryDescriptor_initSubRange \
 virtual bool initSubRange( IOMemoryDescriptor * parent,IOByteCount offset, IOByteCount length,	IODirection withDirection );//c

};

class IOGeneralMemoryDescriptor_HYS
{
    OSDeclareDefaultStructors(IOGeneralMemoryDescriptor_HYS);

public://define

#define IOGeneralMemoryDescriptor_getPhysicalSegment \
    virtual IOPhysicalAddress getPhysicalSegment(IOByteCount offset,IOByteCount * length);//c

#define IOGeneralMemoryDescriptor_prepare \
 virtual IOReturn prepare(IODirection forDirection = kIODirectionNone);//c

#define IOGeneralMemoryDescriptor_complete \
 virtual IOReturn complete(IODirection forDirection = kIODirectionNone);//c

#define IOGeneralMemoryDescriptor_initWithPhysicalRanges \
virtual bool initWithPhysicalRanges(IOPhysicalRange * ranges, UInt32  withCount, IODirection withDirection, bool  asReference = false);//c

};
 
class  IOMemoryMap_HYS
{
   OSDeclareDefaultStructors(IOMemoryMap_HYS)
public:

#define IOMemoryMap_getAddress \
virtual mach_vm_address_t 	getAddress() = 0;//c


};

#endif //__cplusplus

#endif//HYS_IOKIT_IOMEMORYDESCRIPTOR_H
