#ifndef HYS_IOKIT_IOSERVICE_H
#define HYS_IOKIT_IOSERVICE_H

//add start
///////////////////////////
//AppleOnboardAudio-AppleDallasDriver.cpp
//kern-clock.h

#ifdef __cplusplus
static inline void clock_get_uptime(AbsoluteTime *result){
void clock_get_uptime(uint64_t *result);
};

static inline void nanoseconds_to_absolutetime(uint64_t nanoseconds, AbsoluteTime *result){
void nanoseconds_to_absolutetime(uint64_t nanoseconds, uint64_t  *result);
};

//AppleOnboardAudio-PlatformInterface.cpp
static inline void absolutetime_to_nanoseconds(AbsoluteTime abstime, uint64_t *result){
void absolutetime_to_nanoseconds(uint64_t abstime, uint64_t *result);
};

///////////////////////////////////////////////////
//AppleRS232Serial-SccChip.cpp
//kern-clock.h

static inline void  clock_interval_to_deadline(uint32_t a,uint32_t  b,AbsoluteTime *c){
void  clock_interval_to_deadline(uint32_t a,uint32_t  b,uint64_t *c);//c
};

//kern-thread_call.h

static inline boolean_t thread_call_enter_delayed(	thread_call_t		call, 	AbsoluteTime			deadline){ 
boolean_t thread_call_enter_delayed(	thread_call_t		call, 	uint64_t			deadline);//c
};

///////////////////////
#endif//__cplusplus
//add end

enum {
	kIOServiceRegisteredState,//?
	kIOServiceRequired,//?
	kIOServiceTerminate,//?
	kIOServiceSynchronous,//?
	kIODefaultProbeScore,//?
	kIOServiceSeize,//?
	kIOServiceMatchedState,//?
	kIOServiceInactiveState,//?
	kIOServiceAsynchronous,//?
};
//////////////////////////////////////////////////////////////////////////
typedef void* IONotificationRef;//c

#ifdef __cplusplus
class IOService;//add IOInterruptAction

typedef void (*IOInterruptAction)( OSObject * target, void * refCon,IOService * nub, int source );//c
typedef void (*IOServiceApplierFunction)(IOService * service, void * context);//c


extern const IORegistryPlane* gIOServicePlane;//c
extern const OSSymbol* gIOPublishNotification;//c
extern const OSSymbol* gIOTerminatedNotification;//c
extern const OSSymbol*gIOFirstMatchNotification;//c
extern const OSSymbol *gIOMatchedNotification;//c
extern const IORegistryPlane  * gIOPowerPlane;//c
extern const OSSymbol *gIOGeneralInterest;//c
extern const OSSymbol *gIOInterruptControllersKey;//c
extern const OSSymbol *gIOInterruptSpecifiersKey;//c
extern const OSSymbol *gIOPriorityPowerStateInterest;//c
extern const OSSymbol *gIOFirstPublishNotification;//c
extern const OSSymbol *gIODeviceMemoryKey;//c

class IOService_HYS
{
OSDeclareDefaultStructors(IOService_HYS)

public://data
IOInterruptSource *_interruptSources;//c

int initialized;//?

public://define

#define  IOService_PM_idle_timer_expiration \
virtual void PM_idle_timer_expiration ( void );//c

#define  IOService_requireMaxBusStall \
void   requireMaxBusStall(UInt32 ns);//c

#define  IOService_callPlatformFunction  \
    virtual IOReturn callPlatformFunction( const char * functionName,bool waitForFunction,void *param1, void *param2,void *param3, void *param4 );//c

#define  IOService_registerInterest \
    virtual IONotifier * registerInterest( const OSSymbol * typeOfInterest,IOServiceInterestHandler handler,void * target, void * ref = 0 );//c

#define  IOService_matchPropertyTable \
    virtual bool matchPropertyTable( OSDictionary * table );//c

#define  IOService_allowPowerChange \
    virtual IOReturn allowPowerChange ( unsigned long refcon );//c

#define  IOService_getClientWithCategory \
    virtual IOService * getClientWithCategory( const OSSymbol * category );//c

#define  IOService_start_PM_idle_time \
    virtual void start_PM_idle_timer ( void );//c

#define  IOService_acknowledgeNotification \
    virtual IOReturn acknowledgeNotification( IONotificationRef notification,IOOptionBits response );//c

#define  IOService_applyToClients \
    virtual void applyToClients( IOServiceApplierFunction applier, void * context );//c

public://add
//kern/clock.h
void  clock_interval_to_absolutetime_interval(uint32_t a,uint32_t  b,AbsoluteTime *  c) {
void  clock_interval_to_absolutetime_interval(uint32_t a,uint32_t  b,uint64_t *c);
};//AppleHWSensor

void clock_absolutetime_interval_to_deadline(AbsoluteTime abstime,  AbsoluteTime *result) {
void clock_absolutetime_interval_to_deadline(uint64_t abstime,  uint64_t *result);
};//AppleHWSensor

//lkern/thread_call.h

boolean_t thread_call_enter_delayed(	thread_call_t		call, AbsoluteTime			deadline) {
boolean_t thread_call_enter_delayed(	thread_call_t		call, 	uint64_t			deadline);
};//AppleHWSensor
///////////
};


#endif //__cplusplus

#endif//HYS_IOKIT_IOSERVICE_H
