#ifndef HYS_IOKIT_IOTYPES_H
#define HYS_IOKIT_IOTYPES_H


#ifdef __cplusplus
extern "C" {
#endif

#define IOPhysical32( hi, lo )		(lo)//c
//////////////////////
#define IO_OBJECT_NULL 0//?
////////////////////////////

enum {
	kIOMapAnywhere,//?
	kIOMapReadOnly,//?
	kIOCopybackCache,//?
	kIODefaultCache,//?
	kIOMapCacheShift,//?
	kIOInhibitCache,//?
	kIOWriteCombineCache,//?
};

enum {
    	kIOMapCopybackCache		= kIOCopybackCache     << kIOMapCacheShift,//c
    	kIOMapDefaultCache		= kIODefaultCache      << kIOMapCacheShift,//c
    	kIOMapInhibitCache		= kIOInhibitCache      << kIOMapCacheShift,//c
    	kIOMapWriteCombineCache	= kIOWriteCombineCache << kIOMapCacheShift,//c
};
////////////////////////////////////////

typedef vm_address_t IOVirtualAddress;//c
typedef UInt32 IOByteCount;//c

#if __cplusplus
struct IOVirtualRange
{
    IOVirtualAddress	address;
    IOByteCount		length;
};//c
struct IOAddressRange
{
    mach_vm_address_t	address;
    mach_vm_size_t	length;
};//c
#else
typedef struct 
{
    IOVirtualAddress	address;
    IOByteCount		length;
} IOVirtualRange;//c

typedef struct 
{
    mach_vm_address_t	address;
    mach_vm_size_t	length;
} IOAddressRange;//c
#endif

typedef struct {
	int value;
	const char *name;
} IONamedValue;//c


#ifndef __IOKIT_PORTS_DEFINED__
#define __IOKIT_PORTS_DEFINED__
typedef mach_port_t	io_object_t;//c
#endif //__IOKIT_PORTS_DEFINED__

typedef UInt32  IOOptionBits;//c
typedef UInt32  IOPhysicalAddress;//c
typedef UInt32  IOPhysicalLength;//c
typedef SInt32 IOFixed;//c
typedef UInt32 IOItemCount;//c
typedef IOVirtualAddress IOLogicalAddress;//c

#ifdef __cplusplus
}
#endif

#endif//HYS_IOKIT_IOTYPES_H
