#ifndef HYS_IOKIT_IOUSERCLIENT_H
#define HYS_IOKIT_IOUSERCLIENT_H

#define kIOClientPrivilegeAdministrator	"root"//c
#define kIOClientPrivilegeLocalUser	"local"//c
////////////////////////////
struct IOExternalMethodArguments{
	#ifdef __cplusplus
	IOMemoryDescriptor * structureInputDescriptor;//c
	IOMemoryDescriptor* structureOutputDescriptor;//c
	#endif
	const void*  structureInput;//c
	void* structureOutput;//c
	uint32_t  structureOutputSize;//c
	uint32_t structureInputSize;//c
	const uint64_t * scalarInput;//c
	uint64_t * scalarOutput;//c
	io_user_reference_t *asyncReference;//c
	uint32_t scalarInputCount;//c
	uint32_t scalarOutputCount;//c
	mach_port_t asyncWakePort;//c
	uint32_t structureOutputDescriptorSize;//c
	uint32_t asyncReferenceCount;//c
};

typedef IOReturn (*IOExternalMethodAction)(OSObject * target, void * reference, IOExternalMethodArguments * arguments);//c

struct IOExternalMethodDispatch
{
    IOExternalMethodAction function;
    uint32_t		   checkScalarInputCount;
    uint32_t		   checkStructureInputSize;
    uint32_t		   checkScalarOutputCount;
    uint32_t		   checkStructureOutputSize;
};//c


#ifdef __cplusplus
typedef IOReturn (IOService::*IOTrap)(void * a, void * b, void * c,void * d, void * e, void * f );//c
#endif

struct IOExternalTrap {
#ifdef __cplusplus
	IOService * object;//c
	IOTrap func;//c
#endif
};
struct IOExternalAsyncMethod {};

#ifdef __cplusplus
typedef IOReturn (IOService::*IOMethod)(void * p1, void * p2, void * p3,void * p4, void * p5, void * p6 );//c
#endif


#ifdef __cplusplus
class IOUserClient_HYS
{
   OSDeclareAbstractStructors(IOUserClient_HYS)

public://data
    OSSet * mappings;//c

public://func

#define IOUserClient_clientHasPrivilege \
static IOReturn clientHasPrivilege( void *a, const char * b);//c

#define IOUserClient_initWithTask \
   virtual bool initWithTask(task_t owningTask, void * securityToken, UInt32 type,OSDictionary * properties);//c

#define IOUserClient_externalMethod \
virtual IOReturn externalMethod( uint32_t selector, IOExternalMethodArguments * arguments,IOExternalMethodDispatch * dispatch = 0, OSObject * target = 0, void * reference = 0 );//c

#define IOUserClient_initWithTask_task_t \
virtual bool initWithTask(task_t owningTask, void * securityToken, UInt32 type);//c

#define IOUserClient_sendAsyncResult64 \
static IOReturn sendAsyncResult64(OSAsyncReference64 reference,IOReturn result, io_user_reference_t args[], UInt32 numArgs);//c

#define IOUserClient_setAsyncReference64 \
   static void setAsyncReference64(OSAsyncReference64 asyncRef,mach_port_t wakePort,mach_vm_address_t callback, io_user_reference_t refcon);//c

#define IOUserClient_getService \
 virtual IOService * getService( void );//c

#define IOUserClient_clientDied \
    virtual IOReturn clientDied( void );//c


public://func

#ifndef KERNEL
#define IOUserClient_clientHasPrivilege1 \
 static IOReturn clientHasPrivilege(task_t, const char*) { \
 IOReturn clientHasPrivilege( void *a, const char * b); \
};//add-AppleGMACEthernet
#else
#define IOUserClient_clientHasPrivilege1
#endif


};
#endif //__cplusplus

#endif //HYS_IOKIT_IOUSERCLIENT_H

