#ifndef HYS_IOKIT_ATA_IOATACONTROLLER_H
#define HYS_IOKIT_ATA_IOATACONTROLLER_H


class IOATAController_HYS
{
    OSDeclareDefaultStructors(IOATAController_HYS)
public://data

enum {
	kQueueOpen = '!lck',//c
	kBusFree = 'free',//c
	kImmediateOK	=  'Immd' ,//c
	kQueueLocked = 'LOCK',//c
};

enum  transState {
	kATADone,//?
	kATAComplete,//?
	kATAStatus,//?
	kATADataTx,//?
	kATAStarted,//?
	kATAPICmd,//?
};
///////////////////////

struct ataDevInfo {
	ataDeviceType   type;       
	atapiConfig		packetSend; 
};//c

struct ataDoubleBuffer {
	IOPhysicalAddress	physicalBuffer;
	IOLogicalAddress	logicalBuffer;
	IOByteCount	bufferSize;	
};//c
/////////////////////////////////
IOATABusCommand  *_currentCommand;//c
UInt32						_queueState;//c
UInt32						_busState;//c
ataUnitID					_selectedUnit;//c
ataDevInfo					_devInfo[2];//c
UInt32						_immediateGate;//c
IOATARegPtr8 _tfAltSDevCReg;//c
IOATARegPtr8 _tfStatusCmdReg;//c
IOATARegPtr8 _tfSDHReg;//c
IOWorkLoop  *_workLoop;//c
IOATADevice*				_nub[2];//c
IOATARegPtr16 _tfDataReg;//c
IOATARegPtr8 _tfFeatureReg;//c
IOATARegPtr8 _tfSCountReg;//c
IOATARegPtr8 _tfSectorNReg;//c
IOATARegPtr8 _tfCylLoReg;//c
IOATARegPtr8 _tfCylHiReg;//c\
IOCommandGate *_cmdGate;//c
IOService  *_provider;//c
ATATimerEventSource * _timer;//c

public://define

#define IOATAController__cmdGate \
IOCommandGate *_cmdGate;//c

#define IOATAController__doubleBuffer \
ataDoubleBuffer  _doubleBuffer;//c

#define IOATAController_determineATAPIState \
	virtual IOATAController::transState	determineATAPIState(void);//c

#define IOATAController_scanForDrive \
	virtual UInt32 scanForDrives( void );//c

#define IOATAController_synchronousIO \
	virtual IOReturn synchronousIO(void);	//c

#define IOATAController_bitSigToNumeric \
virtual UInt16 bitSigToNumeric( UInt16 binary);//c

#define IOATAController_dequeueFirstCommand \
	virtual IOATABusCommand* dequeueFirstCommand( void );//c

#define IOATAController_ATAPISlaveExists \
virtual bool ATAPISlaveExists( void );//c

#define IOATAController_completeIO \
	virtual void completeIO( IOReturn commandResult );//c

#define IOATAController_handleDeviceInterrupt \
	virtual IOReturn handleDeviceInterrupt( void );//c

#define IOATAController_issueCommand \
	virtual IOReturn issueCommand( void );//c

#define IOATAController_selectDevice \
	virtual IOReturn selectDevice( ataUnitID unit );//c

#define IOATAController_handleExecIO \
virtual IOReturn handleExecIO( void );//c

#define IOATAController_executeEventCallouts \
	virtual void executeEventCallouts(  ataEventCode event, ataUnitID unit);//c

#define IOATAController_startTimer \
	virtual IOReturn startTimer( UInt32 inMS);//c

#define IOATAController_stopTimer \
	virtual void stopTimer( void );//c

#define IOATAController_handleTimeout \
	virtual void handleTimeout( void );//c

#define IOATAController_asyncStatus \
	virtual IOReturn asyncStatus(void);//c

#define IOATAController_checkTimeout \
virtual bool checkTimeout( void );//c

#define IOATAController_executeCommand \
virtual IOReturn executeCommand( IOATADevice* nub, IOATABusCommand* cmd);	//c
	
#define IOATAController_asyncData \
	virtual IOReturn asyncData(void);//c

#define IOATAController_asyncCommand \
	virtual IOReturn asyncCommand(void);//c

#define IOATAController_waitForU8Status \
	virtual bool waitForU8Status (UInt8 mask, UInt8 value);//c
	
#define IOATAController_softResetBus \
virtual IOReturn softResetBus( bool doATAPI = false );//c

public://func

};

#endif//HYS_IOKIT_ATA_IOATACONTROLLER_H
