#ifndef HYS_IOKIT_AUDIO_IOAUDIODEVICE_H
#define HYS_IOKIT_AUDIO_IOAUDIODEVICE_H



////////

typedef enum _IOAudioDevicePowerState {
    kIOAudioDeviceSleep 	= 0,	
    kIOAudioDeviceIdle		= 1,	
    kIOAudioDeviceActive 	= 2	
} IOAudioDevicePowerState;//c

class IOAudioDevice_HYS
{

    OSDeclareDefaultStructors(IOAudioDevice_HYS)

public://data

    struct ExpansionData {
		unsigned long long			idleSleepDelayTime;
		IOTimerEventSource *		idleTimer;
	};//c
 
ExpansionData *reserved;//c

public://func

#define IOAudioDevice_setDeviceTransportType \
	virtual void setDeviceTransportType(const UInt32 transportType);//c

#define IOAudioDevice_setDeviceModelName \
	virtual void setDeviceModelName(const char * modelName);//c
#define IOAudioDevice_scheduleIdleAudioSleep \
	virtual void scheduleIdleAudioSleep(void);//c

#define IOAudioDevice_idleAudioSleepHandlerTimer \
	static void idleAudioSleepHandlerTimer(OSObject *owner, IOTimerEventSource *sender);//c

#define IOAudioDevice_setAggressiveness \
	virtual IOReturn setAggressiveness(unsigned long type, unsigned long newLevel);//c

#define IOAudioDevice_willTerminate \
    virtual bool willTerminate(IOService *provider, IOOptionBits options);//c

public://add
//AppleOnboardAudio-Apple02Audio.cpp
//kern-clock.h

static inline void clock_get_uptime(AbsoluteTime *result) {
void clock_get_uptime(uint64_t *result);
};

static inline void absolutetime_to_nanoseconds(AbsoluteTime abstime, uint64_t *result) {
void absolutetime_to_nanoseconds(uint64_t abstime, uint64_t *result);
};

static inline void nanoseconds_to_absolutetime(uint64_t nanoseconds, AbsoluteTime *result){
void nanoseconds_to_absolutetime(uint64_t nanoseconds, uint64_t  *result);
};

/////////////////
};

#endif//HYS_IOKIT_AUDIO_IOAUDIODEVICE_H
