#ifndef HYS_IOKIT_IOAUDIOENGINE_H
#define HYS_IOKIT_IOAUDIOENGINE_H


///////////////

#define IOAUDIOENGINE_DEFAULT_NUM_ERASES_PER_BUFFER 1//?
/////////////////////
#define CMP_IOAUDIOENGINEPOSITION(p1, p2) \
    (((p1)->fLoopCount > (p2)->fLoopCount) ? 1 :	\
        ((p1)->fLoopCount == (p2)->fLoopCount) && ((p1)->fSampleFrame > (p2)->fSampleFrame) ? 1 :	\
            ((p1)->fLoopCount == (p2)->fLoopCount) && ((p1)->fSampleFrame == (p2)->fSampleFrame) ? 0 : -1)//c

#define IOAUDIOENGINEPOSITION_IS_ZERO(p1) (((p1)->fLoopCount == 0) && ((p1)->fSampleFrame == 0))//c

class  IOAudioEngine_HYS
{
  //  OSDeclareAbstractStructors(IOAudioEngine_HYS)
public://data

    struct ExpansionData {
		UInt32								pauseCount;
		IOBufferMemoryDescriptor			*statusDescriptor;
		IOBufferMemoryDescriptor			*bytesInInputBufferArrayDescriptor;
		IOBufferMemoryDescriptor			*bytesInOutputBufferArrayDescriptor;
		UInt32								mixClipOverhead;
		OSArray								*streams;
	    UInt32								inputSampleOffset;
	};//c

ExpansionData   *reserved;//c

UInt32 sampleOffset;//c
bool duringStartup;//c
UInt32  maxNumOutputChannels;//c
UInt32  maxNumInputChannels;//c
UInt32 index;//c

public://func//

#define IOAudioEngine_mixOutputSamples \
    virtual IOReturn mixOutputSamples(const void *sourceBuf, void *mixBuf, UInt32 firstSampleFrame, UInt32 numSampleFrames, const IOAudioStreamFormat *streamFormat, IOAudioStream *audioStream);//c

#define IOAudioEngine_removeDefaultAudioControl \
    virtual IOReturn removeDefaultAudioControl(IOAudioControl *defaultAudioControl);//c

#define IOAudioEngine_calculateSampleTimeout \
    virtual IOReturn calculateSampleTimeout(AbsoluteTime *sampleInterval, UInt32 numSampleFrames, IOAudioEnginePosition *startingPosition, AbsoluteTime *wakeupTime);//c

#define IOAudioEngine_completeConfigurationChange \
    virtual void completeConfigurationChange();//c

#define IOAudioEngine_createUserClient \
virtual IOReturn createUserClient(task_t task, void *securityID, UInt32 type, IOAudioEngineUserClient **newUserClient, OSDictionary *properties);//c

#define IOAudioEngine_unlockStreamForIO \
	static inline void unlockStreamForIO(IOAudioStream *stream);//c

#define IOAudioEngine_cancelConfigurationChange \
    virtual void cancelConfigurationChange();//c

#define IOAudioEngine_lockStreamForIO \
	static inline void lockStreamForIO(IOAudioStream *stream);//c

#define IOAudioEngine_sendNotification \
    virtual void sendNotification(UInt32 notificationType);//c

#define IOAudioEngine_resetClipPosition \
    virtual void resetClipPosition(IOAudioStream *audioStream, UInt32 clipSampleFrame);//c

#define IOAudioEngine_sendFormatChangeNotification \
    virtual void sendFormatChangeNotification(IOAudioStream *audioStream);//c

#define IOAudioEngine_getNextStreamID \
	UInt32 getNextStreamID(IOAudioStream * newStream);//c

#define IOAudioEngine_unlockAllStreams \
    virtual void unlockAllStreams();//c

#define IOAudioEngine_removeAllDefaultAudioControls \
    virtual void removeAllDefaultAudioControls();//c

#define IOAudioEngine_stopEngineAtPosition \
    virtual void stopEngineAtPosition(IOAudioEnginePosition *endingPosition);//c

#define IOAudioEngine_beginConfigurationChange \
    virtual void beginConfigurationChange();//c

#define IOAudioEngine_setIndex \
    virtual void setIndex(UInt32 index);//c

#define IOAudioEngine_setWorkLoopOnAllAudioControls \
	void setWorkLoopOnAllAudioControls(IOWorkLoop *wl);//c

#define IOAudioEngine_setAudioDevice \
virtual void setAudioDevice(IOAudioDevice *device);//c

#define IOAudioEngine_addDefaultAudioControl \
    virtual IOReturn addDefaultAudioControl(IOAudioControl *defaultAudioControl);//c

#define IOAudioEngine_detachAudioStreams \
    virtual void detachAudioStreams();//c

#define IOAudioEngine_getStreamForID \
	IOAudioStream * getStreamForID(UInt32 streamID);//c

#define IOAudioEngine_startClient \
    virtual IOReturn startClient(IOAudioEngineUserClient *userClient);//c

#define IOAudioEngine_getStatusDescriptor \
	virtual IOBufferMemoryDescriptor * getStatusDescriptor();//c

#define IOAudioEngine_removeUserClientAction \
    static IOReturn removeUserClientAction(OSObject *owner, void *arg1, void *arg2, void *arg3, void *arg4);//c

#define IOAudioEngine_incrementActiveUserClients \
    virtual IOReturn incrementActiveUserClients();//c

#define IOAudioEngine_getNearestStartTime \
	virtual IOReturn getNearestStartTime(IOAudioStream *audioStream, IOAudioTimeStamp *ioTimeStamp, bool isInput);//c

#define IOAudioEngine_lockAllStreams \
    virtual void lockAllStreams();//c

#define IOAudioEngine_resumeAudioEngine \
    virtual IOReturn resumeAudioEngine();//c

#define IOAudioEngine_getBytesInInputBufferArrayDescriptor \
	virtual IOBufferMemoryDescriptor * getBytesInInputBufferArrayDescriptor();//c

#define IOAudioEngine_pauseAudioEngine \
    virtual IOReturn pauseAudioEngine();//c

#define IOAudioEngine_newUserClient_OSDictionary \
    virtual IOReturn newUserClient(task_t task, void *securityID, UInt32 type, OSDictionary *properties, IOUserClient **handler);//c

#define IOAudioEngine_getBytesInOutputBufferArrayDescriptor \
	virtual IOBufferMemoryDescriptor * getBytesInOutputBufferArrayDescriptor();//c

#define IOAudioEngine_updateChannelNumbers \
    virtual void updateChannelNumbers();//c

#define IOAudioEngine_decrementActiveUserClients \
    virtual IOReturn decrementActiveUserClients();//c

#define IOAudioEngine_getAudioStream \
  virtual IOAudioStream *getAudioStream(IOAudioStreamDirection direction, UInt32 channelID);//c

#define IOAudioEngine_detachUserClients \
    virtual IOReturn detachUserClients();//c

#define IOAudioEngine_removeUserClient \
    virtual IOReturn removeUserClient(IOAudioEngineUserClient *userClient);//c

#define IOAudioEngine_createUserClient_IOAudioEngineUserClient \
    virtual IOReturn createUserClient(task_t task, void *securityID, UInt32 type, IOAudioEngineUserClient **newUserClient);//c

#define IOAudioEngine_getGlobalUniqueID \
    virtual OSString *getGlobalUniqueID();//c

#define IOAudioEngine_getLocalUniqueID \
    virtual OSString *getLocalUniqueID();//c

#define IOAudioEngine_stopClient \
    virtual IOReturn stopClient(IOAudioEngineUserClient *userClient);//c

#define IOAudioEngine_addUserClientAction \
    static IOReturn addUserClientAction(OSObject *owner, void *arg1, void *arg2, void *arg3, void *arg4);//c

#define IOAudioEngine_detachUserClientsAction \
    static IOReturn detachUserClientsAction(OSObject *owner, void *arg1, void *arg2, void *arg3, void *arg4);//c

#define IOAudioEngine_addUserClient \
    virtual IOReturn addUserClient(IOAudioEngineUserClient *newUserClient);//c

#define IOAudioEngine_hardwareSampleRateChanged \
    virtual IOReturn hardwareSampleRateChanged(const IOAudioSampleRate *sampleRate);//c

public://add
//AppleOnboardAudio-AppleDBDMAAudio.cpp
//kern-clock.h

void clock_get_uptime(AbsoluteTime *result){
void clock_get_uptime(uint64_t *result);
};

void absolutetime_to_nanoseconds(AbsoluteTime abstime, uint64_t *result){
void absolutetime_to_nanoseconds(uint64_t abstime, uint64_t *result);
};

////////////////////
};

#endif //HYS_IOKIT_IOAUDIOENGINE_H
