#ifndef HYS_IOKIT_AVC_IOFIREWIREAVCTARGETSPACE_H
#define HYS_IOKIT_AVC_IOFIREWIREAVCTARGETSPACE_H

typedef void (*IOFireWireAVCTargetCommandHandlerCallback)(const AVCCommandHandlerInfo *pCmdInfo,
														  UInt32 generation,
														  UInt16 nodeID,
														  const void *command,
														  UInt32 cmdLen,
														  IOFWSpeed &speed,
														  UInt32 handlerSearchIndex);//c

typedef void (*IOFireWireAVCSubunitPlugHandlerCallback)(const AVCSubunitInfo *pSubunitInfo,
														IOFWAVCSubunitPlugMessages plugMessage,
														IOFWAVCPlugTypes plugType,
														UInt32 plugNum,
														UInt32 messageParams,
														UInt32 generation,
														UInt16 nodeID);//c										
/////////////////////////////////////////
class AVCCommandHandlerInfo_HYS
{
    OSDeclareDefaultStructors(AVCCommandHandlerInfo_HYS)
public:

OSAsyncReference asyncRef;//c
IOFireWireAVCProtocolUserClient *userClient;//c
IOFireWireAVCTargetCommandHandlerCallback callBack;//c
uint64_t userCallBack;//c
uint64_t userRefCon;//c
UInt32 subUnitTypeAndID;//c
UInt32 opCode;//c

};

typedef struct _AVCSubunitPlugRecord
{
	UInt32 plugSignalFormat;
	UInt32 connectionCount;
}AVCSubunitPlugRecord;//c
class  AVCSubunitInfo_HYS
{
    OSDeclareDefaultStructors(AVCSubunitInfo_HYS)
public://data

OSAsyncReference asyncRef;//c
IOFireWireAVCProtocolUserClient * userClient;//c
AVCSubunitPlugRecord *sourcePlugRecords;//c
AVCSubunitPlugRecord* destPlugRecords;//c
IOFireWireAVCSubunitPlugHandlerCallback callBack;//c
UInt32 subunitTypeAndID;//?
uint64_t userCallBack;//c
uint64_t userRefCon;//c
UInt32 numSourcePlugs;//c
UInt32 numDestPlugs;//c

public://func

 
#define AVCSubunitInfo_init \
bool init();//c

#define AVCSubunitInfo_free \
void free();//c

};

typedef struct _AVCUnitPlugRecord {
	UInt32 connectionCount;
}AVCUnitPlugRecord;//c

typedef struct _AVCUnitPlugs
{
	UInt32 numIsochInPlugs;
	UInt32 numIsochOutPlugs;
	UInt32 numExternalInPlugs;
	UInt32 numExternalOutPlugs;
	AVCUnitPlugRecord isochInPlugRecord[kAVCMaxNumPlugs];
	AVCUnitPlugRecord isochOutPlugRecord[kAVCMaxNumPlugs];
	AVCUnitPlugRecord externalInPlugRecord[kAVCMaxNumPlugs];
	AVCUnitPlugRecord externalOutPlugRecord[kAVCMaxNumPlugs];
}AVCUnitPlugs;//c

class  IOFireWireAVCTargetSpace_HYS
{
    OSDeclareDefaultStructors(IOFireWireAVCTargetSpace_HYS)

public://data
IOFireWireController *fController;//c
OSArray* fCommandHandlers;//c
OSArray* fUserClients;//c
OSArray* fSubunits;//c
OSArray* fConnectionRecords;//c
AVCUnitPlugs fUnitPlugs;//c
IOLocalConfigDirectory *  fAVCLocalConfigDirectory;//c
UInt32 fActivations;//c

public://func-define

#define IOFireWireAVCTargetSpace_targetSendAVCResponse \
IOReturn targetSendAVCResponse(UInt32 generation, UInt16 nodeID, IOBufferMemoryDescriptor *pBufMemDesc, UInt32 size);//c

#define IOFireWireAVCTargetSpace_doWrite \
    virtual UInt32 doWrite(UInt16 nodeID, IOFWSpeed &speed, FWAddress addr, UInt32 len,const void *buf, IOFWRequestRefCon refcon);//c

#define IOFireWireAVCTargetSpac_findAVCRequestHandler \
 virtual IOReturn findAVCRequestHandler(IOFireWireAVCProtocolUserClient *userClient,UInt32 generation,UInt16 nodeID,IOFWSpeed speed,UInt32 handlerSearchIndex,const char *pCmdBuf,UInt32 cmdLen);//c

#define IOFireWireAVCTargetSpace_activateWithUser \
	virtual IOReturn activateWithUserClient(IOFireWireAVCProtocolUserClient *userClient);//c

#define IOFireWireAVCTargetSpace_deactivateWithUserClient \
    virtual void deactivateWithUserClient(IOFireWireAVCProtocolUserClient *userClient);//c

#define IOFireWireAVCTargetSpace_pcrModified \
	virtual void pcrModified(IOFWAVCPlugTypes plugType,UInt32 plugNum,UInt32 newValue);//c


#define IOFireWireAVCTargetSpace_canConnectDestPlug \
	bool canConnectDestPlug(UInt32 destSubunitTypeAndID,IOFWAVCPlugTypes destPlugType,UInt32 *destPlugNum);//c

#define IOFireWireAVCTargetSpace_subUnitOfTypeCount \
UInt32 subUnitOfTypeCount(UInt32 type);//c

#define IOFireWireAVCTargetSpace_handleConnectCommand \
IOReturn handleConnectCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_setSubunitPlugSignalFormat \
virtual IOReturn setSubunitPlugSignalFormat(IOFireWireAVCProtocolUserClient *userClient,UInt32 subunitTypeAndID,IOFWAVCPlugTypes plugType,UInt32 plugNum,UInt32 signalFormat);//c

#define IOFireWireAVCTargetSpace_connectTargetPlugs \
	virtual IOReturn connectTargetPlugs(IOFireWireAVCProtocolUserClient *userClient,AVCConnectTargetPlugsInParams *inParams,AVCConnectTargetPlugsOutParams *outParams);//c

#define IOFireWireAVCTargetSpace_addSubunit \
virtual IOReturn addSubunit(IOFireWireAVCProtocolUserClient *userClient,IOFireWireAVCSubunitPlugHandlerCallback callBack,OSAsyncReference64 asyncRef,UInt32 subunitType,UInt32 numSourcePlugs,UInt32 numDestPlugs,uint64_t userCallBack,uint64_t userRefCon,UInt32 *subUnitID);//c

#define IOFireWireAVCTargetSpace_installAVCCommandHandler \
virtual IOReturn installAVCCommandHandler(IOFireWireAVCProtocolUserClient *userClient,IOFireWireAVCTargetCommandHandlerCallback callBack,OSAsyncReference64 asyncRef,UInt32 subUnitTypeAndID,UInt32 opCode,uint64_t userCallBack,  uint64_t userRefCon);//c

#define IOFireWireAVCTargetSpace_getSubunitPlugSignalFormat \
	virtual IOReturn getSubunitPlugSignalFormat(IOFireWireAVCProtocolUserClient *userClient,UInt32 subunitTypeAndID,IOFWAVCPlugTypes plugType,UInt32 plugNum,UInt32 *pSignalFormat);//c

#define IOFireWireAVCTargetSpace_disconnectTargetPlugs \
	virtual IOReturn disconnectTargetPlugs(IOFireWireAVCProtocolUserClient *userClient,UInt32 sourceSubunitTypeAndID,IOFWAVCPlugTypes sourcePlugType,UInt32 sourcePlugNum,UInt32 destSubunitTypeAndID,IOFWAVCPlugTypes destPlugType,UInt32 destPlugNum);//c

#define IOFireWireAVCTargetSpace_getSubunitInfo \
AVCSubunitInfo *getSubunitInfo(UInt32 subunitTypeAndID);//c

#define IOFireWireAVCTargetSpace_handleSignalSourceCommand \
IOReturn handleSignalSourceCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_handleConnectionsCommand \
IOReturn handleConnectionsCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_handleOutputPlugSignalFormatCommand \
IOReturn handleOutputPlugSignalFormatCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_handleInputPlugSignalFormatCommand \
IOReturn handleInputPlugSignalFormatCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_handleDisconnectCommand \
IOReturn handleDisconnectCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_handlePowerCommand \
IOReturn handlePowerCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_handlePlugInfoCommand \
IOReturn handlePlugInfoCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_handleSubUnitInfoCommand \
IOReturn handleSubUnitInfoCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_handleUnitInfoCommand \
IOReturn handleUnitInfoCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len);//c

#define IOFireWireAVCTargetSpace_getTargetPlugConnection \
virtual IOReturn getTargetPlugConnection(IOFireWireAVCProtocolUserClient *userClient,AVCGetTargetPlugConnectionInParams *inParams,AVCGetTargetPlugConnectionOutParams *outParams);//c

//IOFireWireAVCTargetSpace
public://func

};

class UCInfo_HYS
{
    OSDeclareDefaultStructors(UCInfo_HYS)
public:
IOFireWireAVCProtocolUserClient *fUserClient;//c

};

class  AVCConnectionRecord_HYS
{
    OSDeclareDefaultStructors(AVCConnectionRecord_HYS)
public:
UInt32 sourceSubunitTypeAndID;//c
UInt32 destSubunitTypeAndID;//c
UInt32 sourcePlugNum;//c
IOFWAVCPlugTypes sourcePlugType;//c
IOFWAVCPlugTypes destPlugType;//c
UInt32 destPlugNum;//c
bool lockConnection;//c
bool permConnection;//c
	
};


#endif//HYS_IOKIT_AVC_IOFIREWIREAVCTARGETSPACE_H
