#ifndef HYS_IOKIT_AVC_IOFIREWIREAVCUNIT_H
#define HYS_IOKIT_AVC_IOFIREWIREAVCUNIT_H

typedef void (*IOFireWireAVCAsynchronousCommandCallback)(void *a,IOFireWireAVCAsynchronousCommand *b);//c

class  IOFireWireAVCAsynchronousCommand_HYS
{
    OSDeclareDefaultStructors(IOFireWireAVCAsynchronousCommand_HYS)

public://data
IOFWAVCAsyncCommandState cmdState;//c
UInt8	* pInterimResponseBuf;//c
UInt8	* pFinalResponseBuf;//c
IOFWCommand * fWriteCmd;//c
IOFWDelayCommand * fDelayCmd;//c
IOMemoryDescriptor *fMem;//c
UInt8* pCommandBuf;//c
IOFireWireAVCAsynchronousCommandCallback fCallback;//c
void	*pRefCon;//c
IOFireWireAVCUnit *fAVCUnit;//c

int interimResponseLen;//?
int finalResponseLen;//?
int cmdLen;//?
int fWriteNodeID;//?
int fWriteGen;//?

public://func-define

#define IOFireWireAVCAsynchronousCommand_isPending \
bool isPending();//?

#define IOFireWireAVCAsynchronousCommand_free \
void free();//?;

#define IOFireWireAVCAsynchronousCommand_reinit  \
IOReturn reinit(const UInt8 * a, UInt32 b);//c

#define IOFireWireAVCAsynchronousCommand_submit \
IOReturn submit(IOFireWireAVCNub *a);//c

#define IOFireWireAVCAsynchronousCommand_init \
IOReturn init(const UInt8 * a, UInt32 b, IOFireWireAVCAsynchronousCommandCallback c, void *d);//c

#define IOFireWireAVCAsynchronousCommand_cancel \
IOReturn cancel();//c

public://func

};
class IOFireWireAVCSubUnit_HYS
{
    OSDeclareDefaultStructors(IOFireWireAVCSubUnit_HYS)
	
public:
IOFireWireAVCUnit *fAVCUnit;//c

public://func

#define IOFireWireAVCSubUnit_message \
 IOReturn message(UInt32 a, IOService *b, void *c);//?

#define IOFireWireAVCSubUnit_init \
bool init(OSDictionary *a, IOFireWireAVCUnit *b);//?

};

class  IOFireWireAVCNub_HYS
{
    OSDeclareDefaultStructors(IOFireWireAVCNub_HYS)

public:
IOFireWireNub * fDevice;//c


};
class IOFireWireAVCUnit_HYS
{
    OSDeclareDefaultStructors(IOFireWireAVCUnit_HYS)

public://data
IOFireWireAVCCommand *fCommand;//c
IOLock *avcLock;//c
IOLock *cmdLock;//c
IOFWPseudoAddressSpace *fFCPResponseSpace;//c

int fSubUnitCount[1];//?
int fStarted;//?

public://func
#define IOFireWireAVCUnit_AVCAsynchRequestWriteDone \
static void AVCAsynchRequestWriteDone(void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//c

#define IOFireWireAVCUnit_AVCAsynchDelayDone \
static void AVCAsynchDelayDone(void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//c

#define IOFireWireAVCUnit_lockAVCAsynchronousCommandLock \
void lockAVCAsynchronousCommandLock();//c

#define IOFireWireAVCUnit_rescanSubUnits \
static void rescanSubUnits(void *a);//c

#define IOFireWireAVCUnit_AVCResponse \
static UInt32 AVCResponse(void *a, UInt16 b, IOFWSpeed &c, FWAddress d, UInt32 e, const void *f, IOFWRequestRefCon g);//c

#define IOFireWireAVCUnit_updateSubUnits \
void updateSubUnits(bool a);//?

#define IOFireWireAVCUnit_start \
bool start(IOService *a);//?

#define IOFireWireAVCUnit_free \
void free();//?

#define IOFireWireAVCUnit_message \
IOReturn message(UInt32 a, IOService *b, void *c);//?

#define IOFireWireAVCUnit_unlockAVCAsynchronousCommandLock \
void unlockAVCAsynchronousCommandLock();//c

#define IOFireWireAVCUnit_indexOfAVCAsynchronousCommandObject \
UInt32 indexOfAVCAsynchronousCommandObject(IOFireWireAVCAsynchronousCommand *a);//c

#define IOFireWireAVCUnit_removeAVCAsynchronousCommandObjectAtIndex \
void removeAVCAsynchronousCommandObjectAtIndex(UInt32 a);//c

#define IOFireWireAVCUnit_setProperties \
IOReturn setProperties (OSObject * a);//?

};

#endif//HYS_IOKIT_AVC_IOFIREWIREAVCUNIT_H
