#ifndef HYS_IOKIT_FIREWIRE_IOFWCOMMAND_H
#define HYS_IOKIT_FIREWIRE_IOFWCOMMAND_H

typedef void (*FWDeviceCallback)(void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//c

typedef void (*FWBusCallback)(void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//c

typedef void (*FWAsyncPHYCallback)(void *a, IOReturn b, IOFireWireBus *c, IOFWAsyncPHYCommand *d );//c

typedef void (*FWAsyncStreamCallback)(void *a, IOReturn b, IOFireWireBus *c, IOFWAsyncStreamCommand *d);//c

typedef void (*FWAsyncStreamReceiveCallback)(void *a, const void *b);//c

class  IOFWCommand_HYS
{
//    OSDeclareAbstractStructors(IOFWCommand_HYS);

public://data
IOFWSyncer *fSyncWakeup;//c
IOFireWireController * fControl;//c
IOFWCmdQ *fQueue;//c
IOFWCommand* fQueueNext;//c
IOFWCommand *fQueuePrev;//c
AbsoluteTime fDeadline;//c

int fTimeout;//?
int fStatus;//?
int fSync;//?
int fCancelOnReset;//?

public://func-define

#define IOFWCommand_initWithController  \
bool	initWithController(IOFireWireController *a);//?

#define IOFWCommand_cancel \
IOReturn	cancel(IOReturn a);//?

#define IOFWCommand_free \
void	free();//?

#define IOFWCommand_submit \
IOReturn 	submit(bool a = 0);//?

#define IOFWCommand_complete \
IOReturn	complete(IOReturn a);//?

#define IOFWCommand_startExecution \
IOReturn	startExecution();//?

#define IOFWCommand_checkProgress \
IOReturn checkProgress();//?

#define IOFWCommand_updateTimer \
void	updateTimer();//?

public://func
int Busy();//?
int cancel(int a);//?
IOFWCommand *getNext();//?
int execute();//?
IOFWCommand * getPrevious();//?
const AbsoluteTime &getDeadline();//?
int cancelOnReset();//?
int getStatus();//?
int setTimeout(int a);//?
int setFlush(int a);//?

};//IOFWCommand_HYS


class IOFWWriteCommand_HYS
{

    OSDeclareDefaultStructors(IOFWWriteCommand_HYS)

public://func-define
	
#define IOFWWriteCommand_MemberVariables \
typedef struct {  \
	bool 	fDeferredNotify; \
	bool	fFastRetryOnBusy; \
} MemberVariables;

#define IOFWWriteCommand_reinit \
IOReturn	reinit(FWAddress a, IOMemoryDescriptor *b, FWDeviceCallback c = 0, void *e = 0,bool f= 0 );//?

#define IOFWWriteCommand_execute \
IOReturn	execute();//?

#define IOFWWriteCommand_gotPacket \
void 	gotPacket( int a, const void* b, int c);//?

#define IOFWWriteCommand_initWithController \
bool initWithController(IOFireWireController *a);//?

#define IOFWWriteCommand_free \
void free();//.?

#define IOFWWriteCommand_initAll_IOFireWireNub \
bool	initAll(IOFireWireNub *a,FWAddress b, IOMemoryDescriptor *c, FWDeviceCallback d, void *e, bool f);//?

#define IOFWWriteCommand_initAll_IOFireWireController \
bool	initAll(IOFireWireController *a, UInt32 b, FWAddress c, IOMemoryDescriptor *d, FWDeviceCallback e,void *f);//?

#define IOFWWriteCommand_reinit_UInt32 \
IOReturn	reinit(UInt32 a, FWAddress b, IOMemoryDescriptor *c, FWDeviceCallback		d = 0, void *f=0 );//?

#define IOFWWriteCommand_createMemberVariables \
bool createMemberVariables();

#define IOFWWriteCommand_destroyMemberVariables \
void destroyMemberVariables();

public://data
int fPackSize;//c

public://func
int setDeferredNotify(int a);//?
int setFastRetryOnBusy(int a);//?

};

class  IOFWWriteQuadCommand_HYS
{

    OSDeclareDefaultStructors(IOFWWriteQuadCommand_HYS)

public://func-define

#define IOFWWriteQuadCommand_MemberVariables \
typedef struct { \
	bool fDeferredNotify; \
	IOMemoryDescriptor* fMemory; \
} MemberVariables;

#define IOFWWriteQuadCommand_reinit \
IOReturn	reinit(FWAddress a, UInt32 *b,int c, FWDeviceCallback d =0, void *e =0, bool f = 0 );//?

#define IOFWWriteQuadCommand_gotPacket \
void 	gotPacket( int a, const void* b, int c);//?

#define IOFWWriteQuadCommand_initAll \
bool	initAll(IOFireWireController * a,  UInt32 b, FWAddress c, UInt32 *d, int e, FWDeviceCallback f, void *g);//?

#define IOFWWriteQuadCommand_initWithController \
bool	initWithController(IOFireWireController *a);//?

#define IOFWWriteQuadCommand_createMemberVariables \
bool createMemberVariables();//?

#define IOFWWriteQuadCommand_destroyMemberVariables \
void destroyMemberVariables( );//?

#define IOFWWriteQuadCommand_destroyMemoryDescriptor \
void destroyMemoryDescriptor();//?

#define IOFWWriteQuadCommand_createMemoryDescriptor \
bool createMemoryDescriptor();

#define IOFWWriteQuadCommand_initAll_IOFireWireNub \
bool	initAll(IOFireWireNub *a, FWAddress b, UInt32 *c, int d, FWDeviceCallback e,void *f, bool g );//?

#define IOFWWriteQuadCommand_setQuads \
void setQuads( UInt32 * a, int b);//?

#define IOFWWriteQuadCommand_free \
void free();//?

#define IOFWWriteQuadCommand_reinit_UInt32 \
IOReturn	reinit(UInt32 a, FWAddress b, UInt32 *c, int d, FWDeviceCallback e =0, void *f=0);//?

#define IOFWWriteQuadCommand_execute \
IOReturn	execute();//?

public://data

enum {
	kMaxWriteQuads,//?
};

UInt32* fQPtr;//c
int fPackSize;//c

UInt32 fQuads[1];//?

public://func

};
		
class  IOFWCompareAndSwapCommand_HYS
{
    OSDeclareDefaultStructors(IOFWCompareAndSwapCommand_HYS)

public://data

#define IOFWCompareAndSwapCommand_MemberVariables \
typedef struct { \
	IOMemoryDescriptor *fMemory;  \
} MemberVariables;

#define IOFWCompareAndSwapCommand_fMembersfMembers \
MemberVariables * fMembers;

int fInputVals[1];//?
int fOldVal[1];//?

public://func=define

#define IOFWCompareAndSwapCommand_initWithController \
bool	initWithController(IOFireWireController *a);//?

#define IOFWCompareAndSwapCommand_createMemoryDescriptor \
bool createMemoryDescriptor( );//?

#define IOFWCompareAndSwapCommand_destroyMemberVariables \
void destroyMemberVariables(  );//?

#define IOFWCompareAndSwapCommand_locked \
bool	locked(UInt32 *a);//?

#define IOFWCompareAndSwapCommand_createMemberVariables \
bool createMemberVariables();//?

#define IOFWCompareAndSwapCommand_initAll \
bool	initAll(IOFireWireNub *a, FWAddress b, const UInt32 *c, const UInt32 *d, int e, FWDeviceCallback f, void *g, bool h);//?

#define IOFWCompareAndSwapCommand_setInputVals \
void setInputVals( const UInt32 *a, const UInt32 *b, int c);//c

#define IOFWCompareAndSwapCommand_initAll_IOFireWireController \
bool	initAll(IOFireWireController *a,UInt32 b, FWAddress c, const UInt32 *d, const UInt32 *e, int f, FWDeviceCallback g, void *h);//?

#define IOFWCompareAndSwapCommand_execute \
IOReturn	execute();//?

#define IOFWCompareAndSwapCommand_gotPacket \
void 	gotPacket(int a, const void* b, int c);//?

#define IOFWCompareAndSwapCommand_free \
void free( );//?

#define IOFWCompareAndSwapCommand_destroyMemoryDescriptor \
void destroyMemoryDescriptor( );//?

#define IOFWCompareAndSwapCommand_reinit \
IOReturn	reinit(FWAddress a, const UInt32 *b, const UInt32 *c, int d, FWDeviceCallback e=0, void *f=0, bool g=0);//?

#define IOFWCompareAndSwapCommand_reinit_UInt32 \
IOReturn	reinit(UInt32 a, FWAddress b, const UInt32 *c, const UInt32 *d, int e, FWDeviceCallback f=0, void *g=0);//?

};

class IOFWAsyncCommand_HYS
{
	//OSDeclareAbstractStructors(IOFWAsyncCommand_HYS)


public://data

int fMaxRetries;//c
int fCurRetries;//?
IOMemoryDescriptor *fMemDesc;//c
FWDeviceCallback	fComplete;//c
void *fRefCon;//c
int fSize;//c
IOFireWireNub *fDevice;//c
int fMaxPack;//c
int fSpeed;//c
AsyncPendingTrans *fTrans;//c
UInt32 fGeneration;//c
UInt16 fNodeID;//c
bool  fWrite;//c

int fBytesTransferred;//?
int fAddressHi;//?
int fAddressLo;;//?
int fFailOnReset;//?

#define IOFWAsyncCommand_MemberVariables \
typedef struct { \
		void *			fSubclassMembers; \
		int				fMaxSpeed; \
		int				fAckCode; \
		UInt32			fResponseCode;\
		UInt32			fFastRetryCount;\
		int				fResponseSpeed;\
		bool			fForceBlockRequests;\
} MemberVariables;

#define IOFWAsyncCommand_fMembers \
MemberVariables * fMembers;

public://func
int gotPacket(int a ,const void* b,int );//?
int setMaxPacket(int a);//?
int getBytesTransferred();//?
int setGeneration(int a);//?
int setForceBlockRequests(int a);//?
int getAddress();//?
int setResponseSpeed(int a);//?
int getFastRetryCount();//?

public://func-define

#define IOFWAsyncCommand_initAll \
bool	initAll(IOFireWireNub *a, FWAddress b,IOMemoryDescriptor *c, FWDeviceCallback d, void *e, bool f);//?

#define IOFWAsyncCommand_initWithController \
bool	initWithController(IOFireWireController *a);//?

#define IOFWAsyncCommand_initAll_IOFireWireController \
bool	initAll(IOFireWireController *a, UInt32 b, FWAddress c, IOMemoryDescriptor *d, FWDeviceCallback e, void *f);//?

#define IOFWAsyncCommand_createMemberVariables \
bool createMemberVariables( );//c

#define IOFWAsyncCommand_destroyMemberVariables \
void destroyMemberVariables();//C

#define IOFWAsyncCommand_reinit \
IOReturn	reinit(FWAddress a, IOMemoryDescriptor *b,FWDeviceCallback c, void *d, bool e);//?

#define IOFWAsyncCommand_free \
void free();//?

#define IOFWAsyncCommand_reinit_Uint32 \
IOReturn	reinit(UInt32 a, FWAddress b, IOMemoryDescriptor *c, FWDeviceCallback d, void *e);//?

#define IOFWAsyncCommand_updateGeneration \
IOReturn updateGeneration();//c

#define IOFWAsyncCommand_updateNodeID \
IOReturn	 updateNodeID(UInt32 a, UInt16 b);//c

#define IOFWAsyncCommand_complete \
IOReturn	complete(IOReturn a);//?

#define IOFWAsyncCommand_checkProgress \
IOReturn checkProgress(  );//?

#define IOFWAsyncCommand_getAckCode \
int getAckCode();//c

#define IOFWAsyncCommand_gotAck \
void	gotAck(int a);//?

#define IOFWAsyncCommand_getResponseCode \
UInt32 getResponseCode() const;//c

#define IOFWAsyncCommand_setAckCode \
void setAckCode( int a );//c

#define IOFWAsyncCommand_setRetries \
void setRetries( int a);//c

#define IOFWAsyncCommand_setResponseCode \
void setResponseCode( UInt32 a );//c

#define IOFWAsyncCommand_getMaxRetries \
int getMaxRetries();//c

#define IOFWAsyncCommand_setMaxSpeed \
void setMaxSpeed( int a);//c

};//IOFWAsyncCommand_HYS

class  IOFWAsyncPHYCommand_HYS
{
	OSDeclareDefaultStructors( IOFWAsyncPHYCommand_HYS )


public://data
int fMaxRetries;//c
int fCurRetries;//c
AsyncPendingTrans *fTrans;//c
FWAsyncPHYCallback fComplete;//c
void* fRefCon;//c
int fAckCode;//c

int fData1;//?
int fData2;//?
int fGeneration;//?
int fFailOnReset;//?
int fResponseCode;//?

public://func

#define IOFWAsyncPHYCommand_initAll \
bool	 initAll(IOFireWireController* a, UInt32 b, UInt32	c,UInt32 d, FWAsyncPHYCallback e, void 	*f, bool g);//?

#define IOFWAsyncPHYCommand_reinit \
IOReturn	reinit(UInt32 a, UInt32 b, UInt32 c, FWAsyncPHYCallback d, void* e,	bool	f);//?

#define IOFWAsyncPHYCommand_free \
void free();//?

#define IOFWAsyncPHYCommand_complete \
IOReturn	complete(IOReturn a);//?

#define IOFWAsyncPHYCommand_setRetries \
void setRetries( int a);//c

#define IOFWAsyncPHYCommand_gotAck \
void gotAck(int a);//?

#define IOFWAsyncPHYCommand_getResponseCode \
UInt32 getResponseCode(  ) const;//?

#define IOFWAsyncPHYCommand_execute \
IOReturn	execute();//?

#define IOFWAsyncPHYCommand_setAckCode \
void setAckCode( int a);//c

#define IOFWAsyncPHYCommand_getAckCode \
int getAckCode();//c

#define IOFWAsyncPHYCommand_setResponseCode \
void setResponseCode( UInt32 a);//c

#define IOFWAsyncPHYCommand_gotPacket \
void gotPacket( int a );//?

};

class  IOFWAsyncStreamCommand_HYS
{

	OSDeclareDefaultStructors(IOFWAsyncStreamCommand_HYS)

public://data
int fMaxRetries;//c
int fCurRetries;//c
IOMemoryDescriptor* fMemDesc;//c
FWAsyncStreamCallback	fComplete;//c
void *fRefCon;//c
int fSize;//c
int fChannel;//c
int fSyncBits;//c
int fTag;//c
int fSpeed;//c

int fGeneration;//?
int fFailOnReset;//?

public://func

#define IOFWAsyncStreamCommand_execute \
IOReturn	execute();//?

#define IOFWAsyncStreamCommand_initAll \
bool	initAll( IOFireWireController* a, UInt32 b, UInt32 c, UInt32 d, UInt32 e, IOMemoryDescriptor *f,UInt32 g, int h,  FWAsyncStreamCallback i,  void* j);//?

#define IOFWAsyncStreamCommand_gotAck \
void gotAck(int a);//?

#define IOFWAsyncStreamCommand_reinit \
IOReturn	reinit(UInt32 a, UInt32 b, UInt32 c, UInt32 d, IOMemoryDescriptor* e, UInt32 f, int g, FWAsyncStreamCallback	h, void* i);//?

#define IOFWAsyncStreamCommand_free \
void free( );//?

#define IOFWAsyncStreamCommand_complete \
IOReturn	complete(IOReturn a);//?

};


class  IOFWBusCommand_HYS
{
  //  OSDeclareAbstractStructors(IOFWBusCommand_HYS)

public://data
FWBusCallback fComplete;//c
void* fRefCon;//c

public://func

#define IOFWBusCommand_initWithController \
bool	initWithController(IOFireWireController *a, FWBusCallback b=0, void *c=0);//?

#define IOFWBusCommand_reinit \
IOReturn	reinit(FWBusCallback a, void *b);//?

#define IOFWBusCommand_complete \
IOReturn	complete(IOReturn a);//?

};

class IOFWDelayCommand_HYS
{
    OSDeclareDefaultStructors(IOFWDelayCommand_HYS)

public:

#define IOFWDelayCommand_execute \
IOReturn	execute();//?

#define IOFWDelayCommand_initWithDelay \
bool	initWithDelay(IOFireWireController *a, UInt32 b, FWBusCallback c, void *d);//?

#define IOFWDelayCommand_reinit \
IOReturn	reinit(UInt32 a, FWBusCallback b, void *c);//?

};

class  IOFWReadQuadCommand_HYS
{
    OSDeclareDefaultStructors(IOFWReadQuadCommand_HYS)

public://data

UInt32* fQuads;//c

public://func

#define IOFWReadQuadCommand_initAll \
bool	initAll(IOFireWireController *a, UInt32 b, FWAddress c, UInt32 *d, int e, FWDeviceCallback f, void *g);//?

#define IOFWReadQuadCommand_reinit \
IOReturn	reinit(UInt32 a, FWAddress b,UInt32 *c,int d, FWDeviceCallback e =0,void *f =0 );//?

#define IOFWReadQuadCommand_gotPacket \
void 	gotPacket(int a, const void* b ,int c);//?

#define IOFWReadQuadCommand_execute \
IOReturn	execute();//?

#define IOFWReadQuadCommand_initAll_IOFireWireNub \
bool	initAll(IOFireWireNub *a, FWAddress b, UInt32 *c, int d, FWDeviceCallback e, void *f, bool g);//?

#define IOFWReadQuadCommand_reinit_FWAddress \
IOReturn	reinit(FWAddress a, UInt32 *b, int c, FWDeviceCallback d=0, void *e=0, bool f=0);//?


};


class  IOFWReadCommand_HYS
{
    OSDeclareDefaultStructors(IOFWReadCommand_HYS)

public:

#define IOFWReadCommand_reinit \
IOReturn	reinit(UInt32 a, FWAddress b, IOMemoryDescriptor *c, FWDeviceCallback d=0, void *e=0);//?

#define IOFWReadCommand_execute \
IOReturn	execute();//?

#define IOFWReadCommand_gotPacket \
void 	gotPacket(int a, const void* b, int c);//?

#define IOFWReadCommand_initAll \
bool	initAll(IOFireWireNub *a, FWAddress b, IOMemoryDescriptor *c, FWDeviceCallback d, void *e, bool f);//?

#define IOFWReadCommand_initAll_IOFireWireController \
bool	initAll(IOFireWireController *a, UInt32 b, FWAddress c, IOMemoryDescriptor *d, FWDeviceCallback e, void *f);//?

#define IOFWReadCommand_reinit_FWAddress \
IOReturn	reinit(FWAddress a, IOMemoryDescriptor *b, FWDeviceCallback c=0, void *d=0, bool e=0);//?

};


#endif//HYS_IOKIT_FIREWIRE_IOFWCOMMAND_H
