#ifndef  HYS_IOKIT_FIREWIRE_IOFWISOCHCHANNEL_H
#define HYS_IOKIT_FIREWIRE_IOFWISOCHCHANNEL_H


class IOFWIsochChannel_HYS
{
    OSDeclareDefaultStructors(IOFWIsochChannel_HYS)



public://type

typedef IOReturn (ForceStopNotificationProc)(void* a, IOFWIsochChannel* b, UInt32 c );//c


public://data
IOFireWireController* fControl;//c
ForceStopNotificationProc* fStopProc;//c
void* fStopRefCon;//c
IOLock* fLock;//c
OSSet *fListeners;//c
IOFWReadQuadCommand* fReadCmd;//c
IOFWCompareAndSwapCommand* 	fLockCmd;//c
IOFWIsochPort *fTalker;//c

int fDoIRM;//?
int fPacketSize;//?
int fPrefSpeed;//?
int fChannel;//?
int fBandwidth;//?
int fSpeed;//?
int fGeneration;//?

public://func-define

#define IOFWIsochChannel_init \
bool 	init( IOFireWireController *a, bool b, UInt32 c, IOFWSpeed d, ForceStopNotificationProc* e, void *f);//?

#define IOFWIsochChannel_free \
void free();//?

#define IOFWIsochChannel_checkMemoryInRange \
IOReturn	checkMemoryInRange( IOMemoryDescriptor *a );//?

#define IOFWIsochChannel_start \
IOReturn start();//?

#define IOFWIsochChannel_setTalker \
IOReturn setTalker(IOFWIsochPort *a);//?

#define IOFWIsochChannel_addListener \
IOReturn addListener(IOFWIsochPort *a);//?

#define IOFWIsochChannel_stop \
IOReturn	stop();//?

#define IOFWIsochChannel_allocateChannel \
IOReturn allocateChannel();//?

#define IOFWIsochChannel_allocateChannelBegin \
IOReturn allocateChannelBegin( IOFWSpeed a, UInt64 b, UInt32 * c =0 ) ;//?

#define IOFWIsochChannel_updateBandwidth \
IOReturn updateBandwidth(bool a);//?

#define IOFWIsochChannel_releaseChannelComplete \
IOReturn releaseChannelComplete() ;//?

#define IOFWIsochChannel_releaseChannel \
IOReturn releaseChannel();//?

#define IOFWIsochChannel_reallocBandwidth \
void reallocBandwidth( UInt32 a);	//?

#define IOFWIsochChannel_handleBusReset \
void 	handleBusReset();//?

#define IOFWIsochChannel_threadFunc \
static void threadFunc( void *a);//?

public://func

};

typedef IOFWIsochChannel_HYS::ForceStopNotificationProc 	FWIsochChannelForceStopNotificationProc ;//?

#endif//HYS_IOKIT_FIREWIRE_IOFWISOCHCHANNEL_H
