#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIRECONTROLLER_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIRECONTROLLER_H

class IOFireWireDuplicateGUIDList;//add

#define kMaxPendingTransfers kFWAsynchTTotal //c

const UInt32 kMaxWaitForValidSelfID = 1;//?

enum {
	kFWPacketTCodePhase=0,//?
	kFWAsynchTLabelPhase=1,//?
	kFWAsynchSourceIDPhase=2,//?
	kFWAsynchDestinationIDPhase=3,//?
	kFWSelfID0SPPhase=4,//?
	kFWAsynchRCodePhase=5,//?
	kFWSelfID0GapCntPhase=6,//?
	kFWAsynchDestinationOffsetHighPhase=7,//?
};

enum {
	kFWAsynchExtendedTCodePhase,//?
	kFWTCodeIsochronousBlock,//?
	kFWTCodeLock,//?
	kFWPhyPacketPhyIDPhase,//?
	kFWTCodeLockResponse,//?
	kFWTCodeReadBlockResponse,//?
	kFWTCodeReadQuadletResponse,//?
	kFWAsynchDestinationOffsetHigh,//?
	kFWAsynchRCode,//?
	kFWAsynchDataLengthPhase,//?
	kFWTCodeWriteResponse,//?
	kFWTCodeReadBlock,//?
	kFWAsynchDataLength,//?
	kFWTCodeWriteBlock,//?
	kFWAsynchSourceID,//?
	kFWAsynchTLabel,//?
	kFWTCodeWriteQuadlet,//?
	kFWTCodeReadQuadlet,//?
	kFWSelfIDNPaPhase,//?
	kFWSelfIDNPa,//?
	kFWSelfIDPortStatusParent,//?
	kFWExtendedTCodeCompareSwap,//?
	kFWAsynchTTotal,//?
	kFWDebugIgnoreNodeNone,//?
	kFWPhyPacketIDPhase,//?
	kFWPhyConfigurationGapCntPhase,//?
	kFWSelfIDPhyID,//?
	kFWPhyConfigurationR,//?
	kFWPhyConfigurationT,//?
	kFWPhyPacketPhyID,//?
	kFWSelfID0C,//?
	kFWConfigurationPacketID,//?
	kFWSelfID0GapCnt,//?
	kFWAsynchDestinationID,//?
	kFWAsynchExtendedTCode,//?
	kFWSelfIDPacketType,//?
	kFWSelfID0SP,//?
	kFWSelfID0L,//?
	kFWSelfID0P0Phase,//?
	kFWSelfID0P0,//?
	kFWSelfIDPortStatusChild,//?
	kFWPacketTCode,//?
	kFWTCodePHYPacket,//?
};

enum {
	kFWSelfIDPhyIDPhase = kFWPhyPacketPhyIDPhase,//c
};

struct AsyncPendingTrans {
	int fTCode;//c
	IOFWAsyncCommand * fHandler;//c
	IOFWCommand * fAltHandler;//c
	int fInUse;//?
};

typedef struct IOFWDuplicateGUIDStruct IOFWDuplicateGUIDRec;
struct IOFWDuplicateGUIDStruct {
	IOFWDuplicateGUIDRec* fNextGUID;//c
	int fGUID;//?
	int fLastGenSeen;//?
};
	
struct IOFWNodeScan {
	IOFWReadQuadCommand* fCmd;//c
	IOFWCompareAndSwapCommand *fLockCmd;//c
	int fMustNotBeRoot;//?
	int fIRMisBad;//?
	IOFireWireController* fControl;//c
	FWAddress fAddr;//c
	UInt32* fSelfIDs;//c
	int fNumSelfIDs;//?
	int fRead;//?
	int generation;//?
	int fRetriesBumped;//?
	int fContenderNeedsChecking;//?
	int fIRMCheckingRead;//?
	int fIRMCheckingLock;//?
	int speedChecking;//?
	UInt32 fBuf[1];//?
	UInt32 fIRMBitBucketNew;//c
	UInt32 fIRMBitBucketOld;//c
	int fROMSize;//?
};

class IOFireWireController_HYS
{
  //  OSDeclareAbstractStructors(IOFireWireController_HYS)

public://data-1
struct pendingQ: public IOFWCmdQ {
	void headChanged(IOFWCommand *a);//?
        IOFWQEventSource *fSource;//c
};

struct timeoutQ: public IOFWCmdQ {
	IOTimerEventSource *fTimer;//c
	void headChanged(IOFWCommand *a);//c
 	void busReset();//c
};
	
enum {
	kWaitingScan,//?
	kWaitingSelfIDs,//?
	kAsleep,//?
	kRunning,//?
	kResetStateResetting,//?
	kResetStateArbitrated,//?
	kScanning,//?
	kResetStateDisabled,//?
	kWaitingBusResetStart,//?
	kWaitingBusReset,//?
	kWaitingPrune,//?
};

public://data

IOFireWireLink *fFWIM;//c
pendingQ	 fPendingQ;//c
IOFWWorkLoop *fWorkLoop;//c
IOTimerEventSource *fTimer;//c
timeoutQ fTimeoutQ;//c
OSSet* fLocalAddresses;//c
OSIterator *fSpaceIterator;//c
OSSet* fPHYPacketListeners;//c
OSIterator* fPHYPacketListenersIterator;//c
OSSet* fLocalAsyncStreamReceivers;//c
OSIterator *fAsyncStreamReceiverIterator;//c
OSSet* fAllocatedChannels;//c
OSIterator* fAllocChannelIterator;//c
OSSet* fIRMAllocations;//c
OSIterator* fIRMAllocationsIterator;//c
int fLastTrans;//c
IOMemoryDescriptor *fBadReadResponse;//c
IOFWDelayCommand * fDelayedStateChangeCmd;//c
IOFWDelayCommand *fBusResetStateChangeCmd;//c
IOFireWireDuplicateGUIDList* fGUIDDups;//c
IOFireWirePowerManager *fBusPowerManager;//c
IOFireWireIRM *fIRM;//c
IOFWAddressSpace *fROMAddrSpace;//c
IOLocalConfigDirectory *fRootDir;//c
int fMaxSendLog;//c
int fMaxRecvLog;//c
AbsoluteTime fResetTime;//c
IOFWCmdQ  fAfterResetHandledQ;//c
int fNumSelfIDs;//c
int fNumROMReads;//c
IONotifier * fKeyswitchNotifier;//c
OSData*  fAllocatedAddresses;//c

int fSecurityMode;//?
int fPhysicalAccessMode;//?
int fStartStatus;//?
int fDebugIgnoreNode;//?
int fStarted;//?
int fInstantiated;//?
int fForcedGapFlag;//?
int fNodeMustNotBeRootFlag;//?
int fNodeMustBeRootFlag;//?
int fDelayedStateChangeCmdNeedAbort;//?
int fDevicePruneDelay;//?
int fHubPort;//?
int fOutOfTLabels;//?
int fOutOfTLabels10S;//?
int fOutOfTLabelsThreshold;//?
int fWaitingForSelfID;//?
int fDelegateCycleMaster;//?
int fROMHeader[1];//?
int fBusState;//?
int fBusResetState;//?
int fBusResetScheduled;//?
int fBusResetDisabledCount;//?
int fDelayedPhyPacket;//?
int fGapCountMismatch;//?
int fIOCriticalSectionCount;//?
int fRequestedHalfSizePackets;//?
int fBusGeneration;//?
int fSpeedVector[1];//?
AsyncPendingTrans fTrans[1];//?
IORegistryEntry * fNodes[1];//?
int fRootNodeID;//?
IOFWNodeScan * fScans[1];//?
int fLocalNodeID;//?
UInt32 fSelfIDs[1];//?
UInt32* fNodeIDs[1];//?
int fIRMNodeID;//?
int fBusMgr;//?
int fForcedRootNodeID;//?
int fBadIRMsKnown;//?
int fDSLimited;//?
int fGapCount;//?
int fPreviousGap;//?
int fForcedGapCount;//?
int fUseHalfSizePackets;//?

public://func-define

#define IOFireWireController_getGeneration \
UInt32 getGeneration() const;//c

#define IOFireWireController_setNodeSpeed_IOFWSpeed \
void setNodeSpeed( UInt16 a, IOFWSpeed b);//?

#define IOFireWireController_hopCount_UInt16 \
UInt32 hopCount(UInt16 a);//?

#define IOFireWireController_getLocalNode \
static IOFireWireLocalNode * getLocalNode(IOFireWireController *a);//?

#define IOFireWireController_deactivatePHYPacketListener \
void deactivatePHYPacketListener( IOFWPHYPacketListener *a);//?

#define IOFireWireController_releaseIRMBandwidthInGeneration \
IOReturn releaseIRMBandwidthInGeneration(UInt32 a, UInt32 b) ;//?

#define IOFireWireController_addIRMAllocation \
void addIRMAllocation(IOFireWireIRMAllocation *a);//?

#define IOFireWireController_removeAllocatedChannel \
void removeAllocatedChannel(IOFWIsochChannel *a);//?

#define IOFireWireController_addAllocatedChannel \
void addAllocatedChannel(IOFWIsochChannel *a);//?

#define IOFireWireController_createLocalIsochPort \
IOFWLocalIsochPort *createLocalIsochPort(bool a, DCLCommand* b, DCLTaskInfo *c= 0, UInt32 d = 0, UInt32 e = 0, UInt32 f = 0);//?

#define IOFireWireController_createIsochChannel \
IOFWIsochChannel *createIsochChannel(bool a, UInt32 b, IOFWSpeed c, FWIsochChannelForceStopNotificationProc d=0, void *e=0);//?

#define IOFireWireController_createDelayedCmd \
IOFWDelayCommand * createDelayedCmd(UInt32 a, FWBusCallback b, void *c);//?

#define IOFireWireController_asyncLockResponse \
IOReturn asyncLockResponse(UInt32 a, UInt16 b, int c, IOMemoryDescriptor *d, IOByteCount e, int f, IOFWRequestRefCon g);//?

#define IOFireWireController_getExtendedTCode \
UInt32 getExtendedTCode(IOFWRequestRefCon a);//?

#define IOFireWireController_isCompleteRequest \
bool isCompleteRequest(IOFWRequestRefCon a);//?

#define IOFireWireController_isQuadRequest \
bool isQuadRequest(IOFWRequestRefCon a);//?

#define IOFireWireController_deactivateAsyncStreamReceivers \
void deactivateAsyncStreamReceivers();//c

#define IOFireWireController_isLockRequest \
bool isLockRequest(IOFWRequestRefCon a);//?

#define IOFireWireController_allocateIRMChannelInGeneration \
IOReturn allocateIRMChannelInGeneration(UInt8 a, UInt32 b) ;//c

#define IOFireWireController_createPHYPacketListener \
IOFWPHYPacketListener * createPHYPacketListener( FWPHYPacketCallback a, void * b);//?

#define IOFireWireController_activatePHYPacketListener \
IOReturn activatePHYPacketListener(IOFWPHYPacketListener* a );//?

#define IOFireWireController_createIRMAllocation \
IOFireWireIRMAllocation *createIRMAllocation(Boolean a= 0, IOFireWireIRMAllocation::AllocationLostNotificationProc b = 0, void *c=0);//?

#define IOFireWireController_releaseIRMChannelInGeneration \
IOReturn releaseIRMChannelInGeneration(UInt8 a, UInt32 b) ;//c

#define IOFireWireController_getLink \
IOFireWireLink * getLink() const;//c

#define IOFireWireController_getBusPowerManager \
IOFireWirePowerManager * getBusPowerManager();//?

#define IOFireWireController_maxPackLog_UInt16 \
int maxPackLog(UInt16 a, UInt16 b) const;//?

#define IOFireWireController_maxPackLog \
int maxPackLog(bool a, UInt16 b) const;//?

#define IOFireWireController_nodeIDtoDevice \
IOFireWireDevice * nodeIDtoDevice(UInt32 a, UInt16 b);//?

#define IOFireWireController_getIRMNodeID \
IOReturn getIRMNodeID(UInt32 &a, UInt16 &b);//c

#define IOFireWireController_freePseudoAddress \
void freePseudoAddress(FWAddress a, UInt32 b);//?

#define IOFireWireController_allocAddress \
IOReturn allocAddress(IOFWAddressSpace *a);//?

#define IOFireWireController_freeAddress \
void freeAddress(IOFWAddressSpace *a);//?

#define IOFireWireController_allocatePseudoAddress \
IOReturn allocatePseudoAddress(FWAddress *a, UInt32 b);//?

#define IOFireWireController_getAddressSpace \
IOFWAddressSpace *getAddressSpace(FWAddress a);//?

#define IOFireWireController_createInitialAddressSpace \
IOFWPseudoAddressSpace *createInitialAddressSpace(UInt32 a, UInt32 b, FWReadCallback c, FWWriteCallback d, void *e);//?

#define IOFireWireController_createPseudoAddressSpace \
IOFWPseudoAddressSpace *createPseudoAddressSpace(FWAddress *a, UInt32 b,  FWReadCallback c, FWWriteCallback d, void *e);//?

#define IOFireWireController_removeAsyncStreamListener \
void removeAsyncStreamListener( IOFWAsyncStreamListener *a);//c

#define IOFireWireController_asyncReadResponse \
IOReturn asyncReadResponse(UInt32 a, UInt16 b, int c, IOMemoryDescriptor *d, IOByteCount e, int f, IOFWRequestRefCon g);//?

#define IOFireWireController_FWSpeed \
IOFWSpeed FWSpeed(UInt16 a) const;

#define IOFireWireController_FWSpeed_UInt16 \
IOFWSpeed FWSpeed(UInt16 a, UInt16 b) const;

#define IOFireWireController_clipMaxRec2K \
IOReturn clipMaxRec2K(Boolean a );//?

#define IOFireWireController_removeAsyncStreamReceiver \
void removeAsyncStreamReceiver( IOFWAsyncStreamReceiver *a );//?

#define IOFireWireController_getAsyncStreamReceiver \
IOFWAsyncStreamReceiver *getAsyncStreamReceiver( UInt32 a );//?

#define IOFireWireController_allocAsyncStreamReceiver \
IOFWAsyncStreamReceiver *allocAsyncStreamReceiver( UInt32 a, FWAsyncStreamReceiveCallback b, void *c );//?

#define IOFireWireController_makeRoot \
IOReturn makeRoot(UInt32 a, UInt16 b) ;//?

#define IOFireWireController_createAsyncStreamListener \
IOFWAsyncStreamListener *createAsyncStreamListener( UInt32 a, FWAsyncStreamReceiveCallback b, void *c);//?

#define IOFireWireController_createPhysicalAddressSpace \
IOFWPhysicalAddressSpace *createPhysicalAddressSpace(IOMemoryDescriptor *a);//?

#define IOFireWireController_processPHYPacket \
void processPHYPacket( UInt32 a, UInt32 b);//?

#define IOFireWireController_processRcvPacket \
void processRcvPacket( UInt32 *a, int b, IOFWSpeed c);//?

#define IOFireWireController_createAsyncPHYCommand \
IOFWAsyncPHYCommand * createAsyncPHYCommand(UInt32 a, UInt32 b, UInt32 c, FWAsyncPHYCallback d, void *e, bool f);//c
	
#define IOFireWireController_createAsyncStreamCommand \
IOFWAsyncStreamCommand * createAsyncStreamCommand(UInt32  a, UInt32  b, UInt32 c, UInt32 d, IOMemoryDescriptor *e, UInt32 f, int g,FWAsyncStreamCallback h, void *i);//?

#define IOFireWireController_handleAsyncCompletion \
IOReturn handleAsyncCompletion( IOFWCommand *a, IOReturn b);//c

#define IOFireWireController_handleAsyncTimeout \
IOReturn handleAsyncTimeout(IOFWAsyncCommand *a);//?

#define IOFireWireController_asyncLock_UInt32 \
IOReturn asyncLock(UInt32 a, UInt16 b, UInt16 c, UInt32 d, int e, int f, int g, void *h, int i, IOFWAsyncCommand *j);//?

#define IOFireWireController_doWriteSpace \
UInt32 doWriteSpace(UInt16 a, IOFWSpeed &b, FWAddress c, UInt32 d, const void *e, IOFWRequestRefCon f);//?

#define IOFireWireController_asyncWrite \
IOReturn asyncWrite(UInt32 a, UInt16 b, UInt16 c, UInt32 d, int e, int f, IOMemoryDescriptor *	g, IOByteCount h, int i, IOFWAsyncCommand *j, IOFWWriteFlags k);//?

#define IOFireWireController_asyncWrite_IOMemoryDescriptor \
IOReturn asyncWrite(UInt32 a, UInt16 b, UInt16 c, UInt32 d, int e, int f, IOMemoryDescriptor *	g, IOByteCount h, int i, IOFWAsyncCommand *j);//?

#define IOFireWireController_asyncWrite_UInt32 \
IOReturn asyncWrite(UInt32 a, UInt16 b, UInt16 c, UInt32 d, int e, int f, void *g, int h, IOFWAsyncCommand *i);//?

#define  IOFireWireController_doReadSpace \
UInt32 doReadSpace(UInt16 a, IOFWSpeed &b, FWAddress c, UInt32 d, IOMemoryDescriptor **e, IOByteCount * f, IODMACommand **g, IOFWRequestRefCon h);//?

#define IOFireWireController_checkGeneration \
bool checkGeneration(UInt32 a) const;//?

#define IOFireWireController_getSecurityMode \
IOFWSecurityMode getSecurityMode();//?

#define IOFireWireController_setSecurityMode \
void setSecurityMode( IOFWSecurityMode a);//?

#define IOFireWireController_serverKeyswitchCallback \
static bool serverKeyswitchCallback( void * a, void * b, IOService * c);//?

#define IOFireWireController_findKeyswitchDevice \
IOService *findKeyswitchDevice();//?

#define IOFireWireController_isPhysicalAccessEnabledForNodeID \
bool isPhysicalAccessEnabledForNodeID( UInt16 a);//?

#define IOFireWireController_getPhysicalAccessMode \
IOFWPhysicalAccessMode getPhysicalAccessMode();//?

#define IOFireWireController_countNodeIDChildren \
UInt32 countNodeIDChildren( UInt16 a, int b = 0, int * c = 0, bool * d = 0 );//?

#define IOFireWireController_createDummyRegistryEntry \
IORegistryEntry * createDummyRegistryEntry( IOFWNodeScan *a);//?

#define IOFireWireController_finishedBusScan \
void finishedBusScan();//c

#define IOFireWireController_setNodeSpeed_UInt16 \
void setNodeSpeed( UInt16 a, UInt8 b);//c

#define IOFireWireController_setNodeSpeed \
void setNodeSpeed( UInt16 a, UInt16 b, UInt8 c );//c

#define IOFireWireController_asyncPHYPacket \
IOReturn asyncPHYPacket(UInt32 a, UInt32 b, UInt32 c, IOFWAsyncPHYCommand *d);//?

#define IOFireWireController_getLocalNodeID \
UInt16 getLocalNodeID() const;//?

#define IOFireWireController_removeIRMAllocation \
void removeIRMAllocation(IOFireWireIRMAllocation *a);//?

#define IOFireWireController_allocateIRMBandwidthInGeneration \
IOReturn allocateIRMBandwidthInGeneration(UInt32 a, UInt32 b) ;//?

#define IOFireWireController_processLockRequest  \
void processLockRequest(UInt16 a, UInt32 b, UInt32 *c, void *d, int e, IOFWSpeed f);//?

#define IOFireWireController_setNodeIDPhysicalFilter \
void setNodeIDPhysicalFilter( UInt16 a, bool b);//?

#define IOFireWireController_nodeMustBeRoot \
void nodeMustBeRoot( UInt32 a);//c

#define IOFireWireController_getTimeoutQ \
IOFWCmdQ &getTimeoutQ();//c

#define IOFireWireController_inGate \
bool inGate();//c

#define IOFireWireController_openGate \
void openGate();//c

#define IOFireWireController_setGapCount \
void setGapCount( UInt32	a);//c

#define IOFireWireController_nodeMustNotBeRoot \
void nodeMustNotBeRoot( UInt32 a);	//c

#define IOFireWireController_getAfterResetHandledQ \
IOFWCmdQ &getAfterResetHandledQ();//c

#define IOFireWireController_checkForDuplicateGUID \
bool checkForDuplicateGUID(IOFWNodeScan *a, CSRNodeUniqueID *b);//?

#define IOFireWireController_asyncRead_IOFWReadFlags \
IOReturn asyncRead(UInt32  a, UInt16 b, UInt16 c, UInt32 d, int e, int f, int g, IOFWAsyncCommand *h,IOFWReadFlags i);

#define IOFireWireController_asyncRead \
IOReturn asyncRead(UInt32 a, UInt16 b, UInt16  c, UInt32 d, int e, int f, int g, IOFWAsyncCommand *h);//?

#define IOFireWireController_freeTrans \
void freeTrans(AsyncPendingTrans *a);//?

#define IOFireWireController_getRootDir \
IOLocalConfigDirectory *getRootDir() const;//c

#define IOFireWireController_RemoveUnitDirectory \
IOReturn RemoveUnitDirectory(IOLocalConfigDirectory *a);//?

#define IOFireWireController_AddUnitDirectory \
IOReturn AddUnitDirectory(IOLocalConfigDirectory *a);//?

#define IOFireWireController_doLockSpace \
UInt32 doLockSpace(UInt16 a, IOFWSpeed &b, FWAddress c, UInt32 d, const UInt32 *e, UInt32 &f, UInt32 *g, UInt32 h, IOFWRequestRefCon i);//c

#define IOFireWireController_handleARxReqIntComplete \
void handleARxReqIntComplete();//?

#define IOFireWireController_buildTopology \
void buildTopology(bool a);//?

#define IOFireWireController_AssignCycleMaster \
bool AssignCycleMaster();//?

#define IOFireWireController_processCycle64Int \
void processCycle64Int();//c

#define IOFireWireController_processWriteRequest \
void processWriteRequest(UInt16 a, UInt32 b, UInt32 *c, void *d, int e, IOFWSpeed f);//?

#define IOFireWireController_disablePhyPortOnSleepForNodeID \
void disablePhyPortOnSleepForNodeID( UInt32 a );//?

#define IOFireWireController_getPendingQ \
IOFWCmdQ &getPendingQ();//c

#define IOFireWireController_closeGate \
void closeGate();//?

#define IOFireWireController_processSelfI \
void processSelfIDs(UInt32 *a, int b, UInt32 *c, int d);//?

#define IOFireWireController_physicalAccessProcessBusReset \
void physicalAccessProcessBusReset();//?

#define IOFireWireController_readROMGlue \
static void readROMGlue(void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireController_readDeviceROM \
void readDeviceROM(IOFWNodeScan *a, IOReturn b);//?

#define IOFireWireController_startBusScan \
void startBusScan();//?

#define IOFireWireController_doBusReset \
void doBusReset( );//?

#define IOFireWireController_beginIOCriticalSection \
IOReturn beginIOCriticalSection( );//?

#define IOFireWireController_scanningBus \
bool scanningBus() const;//?

#define IOFireWireController_UpdateROM \
IOReturn UpdateROM();//?

#define IOFireWireController_resetBus \
IOReturn resetBus();//?

#define IOFireWireController_activateAsyncStreamReceivers \
void activateAsyncStreamReceivers();//?

#define IOFireWireController_freeAllAsyncStreamReceiver \
void freeAllAsyncStreamReceiver();//?

#define IOFireWireController_freeSecurity \
void freeSecurity();//?

#define IOFireWireController_processBusReset \
void processBusReset();//?

#define IOFireWireController_systemWillShutdown \
void systemWillShutdown( IOOptionBits a);//?

#define IOFireWireController_setPowerState \
IOReturn setPowerState ( unsigned long a, IOService* b );//?

#define IOFireWireController_stop \
void stop( IOService * a );//?

#define IOFireWireController_finalize \
bool finalize( IOOptionBits a);//?

#define IOFireWireController_getCycleTimeAndUpTime \
IOReturn getCycleTimeAndUpTime( UInt32 &a, UInt64 &b);//?

#define IOFireWireController_hopCount \
UInt32 hopCount(UInt16 a, UInt16 b);//?

#define IOFireWireController_getBusCycleTime \
IOReturn getBusCycleTime(UInt32 &a, UInt32 &b);//?

#define IOFireWireController_initSecurity \
void initSecurity();//?

#define IOFireWireController_requestTerminate \
bool requestTerminate( IOService * a, IOOptionBits b);//?

#define IOFireWireController_poweredStart \
IOReturn poweredStart();//?

#define IOFireWireController_setPhysicalAccessMode \
void setPhysicalAccessMode( IOFWPhysicalAccessMode a );//?

#define IOFireWireController_terminateDevice \
void terminateDevice( IOFireWireDevice *a);//?

#define IOFireWireController_updatePlane \
void updatePlane();//?

#define IOFireWireController_updateDevice \
void updateDevice(IOFWNodeScan *a);//?

#define IOFireWireController_asyncLock \
IOReturn asyncLock(UInt32 a,UInt16 b, UInt16 c, UInt32 d, int e, int f, int g, IOMemoryDescriptor *h, IOByteCount i, int j,IOFWAsyncCommand *k);//?

#define IOFireWireController_asyncStreamWrite \
IOReturn asyncStreamWrite(UInt32 a, int b, int c, int d, int e, IOMemoryDescriptor *f, IOByteCount g, int h, IOFWAsyncStreamCommand *i);//?

#define IOFireWireController_getPortNumberFromIndex \
UInt32 getPortNumberFromIndex( UInt16 a);//?

#define IOFireWireController_start \
bool start(IOService *a);//?

#define IOFireWireController_resetStateChange \
static void resetStateChange( void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//?

#define IOFireWireController_delayedStateChange \
static void delayedStateChange(void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//?

#define IOFireWireController_enableSoftwareBusResets \
void enableSoftwareBusResets( );//?

#define IOFireWireController_free \
void free();//?

#define IOFireWireController_createAuxiliary \
IOFireWireBusAux * createAuxiliary();//?

#define IOFireWireController_enterBusResetDisabledState \
void enterBusResetDisabledState( );//?

#define IOFireWireController_endIOCriticalSection \
void endIOCriticalSection();//?

#define IOFireWireController_createPendingQ \
IOReturn createPendingQ();//?

#define IOFireWireController_destroyPendingQ \
void destroyPendingQ();//?

#define IOFireWireController_processTimeout \
void processTimeout(IOTimerEventSource *a);//?

#define IOFireWireController_destroyTimeoutQ \
void destroyTimeoutQ();//?

#define IOFireWireController_createTimeoutQ \
IOReturn createTimeoutQ();//?

#define IOFireWireController_clockTick \
static void clockTick(OSObject * a, IOTimerEventSource * b);//c

#define IOFireWireController_allocTrans \
AsyncPendingTrans * allocTrans( IOFWAsyncCommand *a, IOFWCommand * b);//c

#define IOFireWireController_allocTrans_IOFWAsyncCommand \
AsyncPendingTrans *allocTrans(IOFWAsyncCommand *a=0);//?

#define IOFireWireController_getResetTime \
const AbsoluteTime * getResetTime() const;//c

#define IOFireWireController_delayedStateCommandInUse \
bool delayedStateCommandInUse() const;

#define IOFireWireController_checkProgress \
void checkProgress();

#define IOFireWireController_enterLoggingMode \
void enterLoggingMode();

#define IOFireWireController_useHalfSizePackets \
void useHalfSizePackets ();//?

#define IOFireWireController_getWorkLoop \
IOWorkLoop *getWorkLoop() const;//?

#define IOFireWireController_getCycleTime \
IOReturn getCycleTime(UInt32 &a);//?

#define IOFireWireControlle_disableSoftwareBusResets \
IOReturn disableSoftwareBusResets();//?

#define IOFireWireController_suspendBus \
void suspendBus();//?

#define IOFireWireController_init \
bool init(IOFireWireLink *a);//?


public://func

int getMaxRec();//?
int getBroadcastSpeed();//?
int getFireWirePhysicalBufferMask();//?
int getFireWirePhysicalAddressMask();//?
int getFireWirePhysicalAddressBits();//?

};

class  IOFireWireDuplicateGUIDList_HYS
{
    OSDeclareDefaultStructors(IOFireWireDuplicateGUIDList_HYS);

public://define

#define IOFireWireDuplicateGUIDList_removeDuplicateGUID \
void removeDuplicateGUID( CSRNodeUniqueID a);//?

#define IOFireWireDuplicateGUIDList_create \
static IOFireWireDuplicateGUIDList * create( );//?

#define IOFireWireDuplicateGUIDList_free \
void free();//?

#define IOFireWireDuplicateGUIDList_addDuplicateGUID \
void addDuplicateGUID( CSRNodeUniqueID a, UInt32 b);//?

#define  IOFireWireDuplicateGUIDList_findDuplicateGUID \
bool findDuplicateGUID( CSRNodeUniqueID a, UInt32 b);//?

public://data

IOFWDuplicateGUIDRec* fFirstGUID;//c

};

class  IOFireWireControllerAux_HYS
{
    OSDeclareDefaultStructors(IOFireWireControllerAux_HYS)
public://define

#define IOFireWireControllerAux_init  \
bool init (IOFireWireController *a);//?

#define IOFireWireControllerAux_free  \
void free ();//?

#define IOFireWireControllerAux_createDCLPool  \
IOFWDCLPool *createDCLPool ( unsigned a ) const;//?

#define IOFireWireControllerAux_getMaxRec \
UInt8	 getMaxRec();//?

#define IOFireWireControllerAux_createSimpleContiguousPhysicalAddressSpace \
IOFWSimpleContiguousPhysicalAddressSpace * createSimpleContiguousPhysicalAddressSpace(vm_size_t a, IODirection db);//?

#define IOFireWireControllerAux_getFireWirePhysicalAddressBits \
UInt32 getFireWirePhysicalAddressBits();//?

#define IOFireWireControllerAux_createBufferFillIsochPort \
IOFWBufferFillIsochPort *createBufferFillIsochPort() const ;//?

#define IOFireWireControllerAux_getFireWirePhysicalAddressMask \
UInt64 getFireWirePhysicalAddressMask();//?

#define IOFireWireControllerAux_getFireWirePhysicalBufferMask \
UInt64 getFireWirePhysicalBufferMask( );//?

#define IOFireWireControllerAux_getFireWirePhysicalBufferBits \
UInt32 getFireWirePhysicalBufferBits( );

#define IOFireWireControllerAux_createSimplePhysicalAddressSpace \
IOFWSimplePhysicalAddressSpace * createSimplePhysicalAddressSpace( vm_size_t a, IODirection b);//?

public://data

IOFireWireController *fPrimary;//c

int fMaxRec;//?

public://func


};

#endif//HYS_IOKIT_FIREWIRE_IOFIREWIRECONTROLLER_H
