#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIREDEVICE_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIREDEVICE_H

class IOFireWireDevice_HYS
{
    OSDeclareDefaultStructors(IOFireWireDevice_HYS)

public://data

typedef int RegistrationState;//?

enum {
	kDeviceNeedsRegisterService,//?
	kDeviceNotRegistered,//?
	kDeviceRegistered,//?
};

IORecursiveLock* fROMLock;//c
IOFireWireROMCache* fDeviceROM;//c

int fROMReadRetry;//?
int fROMGeneration;//?
int fRegistrationState;//?
int fOpenFromDevice;//?

public://func

OSSet* getOpenUnitSet() const ;//?
AbsoluteTime getResumeTime();//c
int latchResumeTime();//?
int setUnitCount(int a);//?
int isPhysicalAccessEnabled();//?
int setMaxSpeed(int a);//?

public://define

#define IOFireWireDevice_handleOpen \
bool handleOpen( IOService * a, IOOptionBits b, void *c );//?

#define IOFireWireDevice_handleIsOpen \
bool handleIsOpen( const IOService * a) const;//?

#define IOFireWireDevice_matchPropertyTable \
bool matchPropertyTable(OSDictionary * a);//?

#define IOFireWireDevice_setRegistrationState \
void setRegistrationState( RegistrationState a);//?

#define IOFireWireDevice_getROMBase \
const UInt32 * getROMBase();//?

#define IOFireWireDevice_handleClose \
void handleClose( IOService *a, IOOptionBits b);//?

#define IOFireWireDevice_message \
IOReturn message( UInt32 a, IOService * b, void * c );//?

#define IOFireWireDevice_cacheROM \
IOReturn cacheROM(OSData *a, UInt32 b, const UInt32 *&c);//?

#define IOFireWireDevice_processUnitDirectories \
IOReturn processUnitDirectories( OSSet *a);//?

#define IOFireWireDevice_processRootDirectory \
IOReturn processRootDirectory( OSDictionary *a);//?

#define IOFireWireDevice_preprocessDirectories \
void preprocessDirectories( OSDictionary *a, OSSet *b);//?
	
#define IOFireWireDevice_readUnitDirectories \
IOReturn readUnitDirectories( IOConfigDirectory *a, OSSet *b);//?

#define IOFireWireDevice_configurePhysicalFilter \
void configurePhysicalFilter();//?

#define IOFireWireDevice_readRootDirectory \
IOReturn readRootDirectory( IOConfigDirectory *a, OSDictionary *b);//?

#define IOFireWireDevice_processROM \
void processROM(RomScan *a);//?

#define IOFireWireDevice_readROMDirGlue \
static void readROMDirGlue(void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireDevice_readROMThreadFunc \
static void readROMThreadFunc(void *a);//?

#define IOFireWireDevice_setNodeROM \
void setNodeROM(UInt32 a, UInt16 b, const IOFWNodeScan *c);//?

#define IOFireWireDevice_finalize \
bool finalize( IOOptionBits a);//?

#define IOFireWireDevice_attach \
bool attach(IOService * a);//?

#define IOFireWireDevice_free \
void free();//?

#define IOFireWireDevice_terminateDevice \
static void terminateDevice(void *a);//?

#define IOFireWireDevice_createAuxiliary \
IOFireWireNubAux * createAuxiliary();//?

#define IOFireWireDevice_configureNode \
IOReturn configureNode();//?

};


class IOFireWireDeviceAux_HYS
{
    OSDeclareDefaultStructors(IOFireWireDeviceAux_HYS)

public://data

OSSet* fOpenUnitSet;//c
AbsoluteTime fResumeTime;//c

int fUnitCount;//?
int fMaxSpeed;//?

public://func-define

#define IOFireWireDeviceAux_getResumeTime \
AbsoluteTime getResumeTime();//?

#define IOFireWireDeviceAux_createSimplePhysicalAddressSpace \
IOFWSimplePhysicalAddressSpace * createSimplePhysicalAddressSpace( vm_size_t a, IODirection b);//?

#define IOFireWireDeviceAux_latchResumeTime \
void  latchResumeTime( );//?

#define IOFireWireDeviceAux_getOpenUnitSet \
OSSet * getOpenUnitSet() const;//c

#define IOFireWireDeviceAux_free \
void free();//?

#define IOFireWireDeviceAux_createSimpleContiguousPhysicalAddressSpace \
IOFWSimpleContiguousPhysicalAddressSpace *createSimpleContiguousPhysicalAddressSpace( vm_size_t a, IODirection db);//?

#define IOFireWireDeviceAux_isPhysicalAccessEnabled \
bool isPhysicalAccessEnabled( );//?

#define IOFireWireDeviceAux_getUnitCount \
UInt32 getUnitCount();//?

#define IOFireWireDeviceAux_setTerminationState \
void setTerminationState( TerminationState a );//?

#define IOFireWireDeviceAux_setMaxSpeed \
void setMaxSpeed( IOFWSpeed a );//?

#define IOFireWireDeviceAux_setUnitCount \
void setUnitCount( UInt32 a );//?

#define IOFireWireDeviceAux_isTerminated \
bool isTerminated();//?

#define IOFireWireDeviceAux_init \
bool init( IOFireWireDevice * a);//?

};

#endif//HYS_IOKIT_FIREWIRE_IOFIREWIREDEVICE_H
