#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIREFAMILYCOMMON_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIREFAMILYCOMMON_H

#include <IOKit/IOMemoryDescriptor.h>
//IOFireWireFamily-IOFireWireFamily.kmodproj/IOFWDCL.cpp

#define BIT(a) a//?
#define FWBitRange(a, b)	 (a)-(b) //?
#define FWBitRangePhase(a,b) (b) //?
#define FW_BIT(a) (a) //?

#define kIOFireWireResponseBase 1//?
#define kIOFireWireInvalidResponseLength 2//?
#define kIOFireWireIsochBandwidthNotAvailable 3//?
#define kBroadcastChannelInitialValues 4//?
#define kBroadcastChannelValidMask 5//?

enum {
	kFWIsochDataLength=0,//?
	kFWIsochDataLengthPhase=1,//?
	kFWBIBMaxRecPhase=2,//?
	kConfigEntryKeyValuePhase=3,//?
	kConfigEntryKeyTypePhase=4,//?
	kConfigLeafDirLengthPhase=5,//?
	kFWIsochTagPhase=6,//?
	kFWIsochSyPhase=7,//?
	kFWIsochChanNumPhase=8,//?
	kCSRNodeIDPhase=9,//?
	kConfigBusInfoBlockLengthPhase=10,//?
	kConfigROMCRCLengthPhase=11,//?
	kConfigROMCRCValuePhase=12,//?
};

enum {
	kFWAckDataError,//?
	kFWSpeed200MBit,//?
	kFWDCLUpdateNotification,//?
	kFWIsochPortDefaultOptions,//?
	kIOFWSWVers_KPF,//?
	kIOFWSpecID_AAPL,//?
	kFWBIBHeaderAddress,//?
	kCSRBroadcastChannel,//?
	kConfigSBP2MAO,//?
	kConfigSBP2Revision,//?
	kConfigSBP2LUN,//?
	kConfigUnitSWVersIIDC102,//?
	kConfigUnitSWVersIIDC101,//?
	kConfigUnitSWVersIIDC100,//?
	kConfigUnitSpec1394TA1,//?
	kConfigUnitDependentInfoKey,//?
	kConfigUnitSwVersionKey,//?
	kConfigUnitSpecIdKey,//?
	kConfigRootDirectoryKey,//?
	kFWBIBMaxROMPhase,//?
	kFWBIBMaxROM,//?
	kCSRBusManagerID,//?
	kIOFWPhysicalAccessDisabledForGeneration,//?
	kIOFWPhysicalAccessDisabled,//?
	kIOFWPhysicalAccessEnabled,//?
	kConfigROMCRCValue,//?
	kConfigROMCRCLength,//?
	kConfigBusInfoBlockLength,//?
	kFWBIBGenerationPhase,//?
	kConfigUnitDirectoryKey,//?
	kConfigBIBHeaderAddress,//?
	kFWSpeedReserved,//?
	kIOFWSecurityModeSecure,//?
	kIOFWSecurityModeSecurePermanent,//?
	kFWSpeed800MBit,//?
	kFWBIBBmc,//?
	kFWLocalBusAddress,//?
	kFWSpeedUnknownMask,//?
	kConfigModuleVendorIdKey,//?
	kConfigUnitSWVersMacintosh10,//?
	kConfigUnitSpecAppleA27,//?
	kConfigModelIdKey,//?
	kConfigNodeUniqueIdKey,//?
	kConfigGenerationKey,//?
	kFWBIBMaxRec,//?
	kFWBIBBusName,//?
	kConfigNodeCapabilitiesKey,//?
	kFWBIBGeneration,//?
	kIOFWWriteFlagsNone,//?
	kIOFWWriteFlagsDeferredNotify,//?
	kIOFWWriteFastRetryOnBusy,//?
	kFWResponsePending,//?
	kFWNuDCLModifyJumpNotification,//?
	kFWNuDCLModifyNotification,//?
	kFWIsochPortUseSeparateKernelThread,//?
	kFWNuDCLUpdateNotification,//?
	kIOFWWriteBlockRequest,//?
	kIOFWReadFlagsNone,//?
	kCSRBandwidthAvailable,//?
	kCSRChannelsAvailable31_0,//?
	kCSRChannelsAvailable63_32,//?
	kFWMaxNodesPerBus,//?
	kDCLSkipCycleOp,//?
	kDCLSendPacketWithHeaderStartOp,//?
	kFWIsochSy,//?
	kFWIsochTag,//?
	kDCLSendBufferOp,//?
	kDCLReceiveBufferOp,//?
	kFWDefaultIsochResourceFlags,//?
	kDCLReceivePacketOp,//?
	kDCLNuDCLLeaderOp,//?
	kFWDCLModifyNotification,//?
	kFWAckPending,//?
	kFWAckComplete,//?
	kFWAckTimeout,//?
	kFWAckBusyB,//?
	kFWAckBusyA,//?
	kFWAckBusyX,//?
	kFWSpeedMaximum,//?
	kIOFWSecurityModeNormal,//?
	kCSRRegisterSpaceBaseAddressLo,//?
	kConfigImmediateKeyType,//?
	kConfigTextualDescriptorKey,//?
	kInvalidConfigROMEntryType,//?
	kDCLCallProcOp,//?
	kFWSpeedInvalid,//?
	kFWSpeed400MBit,//?
	kFWSpeed100MBit,//?
	kFWDCLOpDynamicFlag,//?
	kFWDCLCycleEvent,//?
	kFWDCLOpFlagMask,//?
	kDCLSendPacketStartOp,//?
	kDCLSendPacketOp,//?
	kDCLSetTagSyncBitsOp,//?
	kDCLLabelOp,//?
	kDCLJumpOp,//?
	kDCLUpdateDCLListOp,//?
	kDCLPtrTimeStampOp,//?
	kDCLReceivePacketStartOp,//?
	kFWResponseAddressError,//?
	kFWResponseComplete,//?
	kFWResponseBusResetError,//?
	kCSRRegisterSpaceBaseAddressHi,//?
	kFCPCommandAddress,//?
	kFWBadNodeID,//?
	kFCPResponseAddress,//?
	kPCRBaseAddress,//?
	kFWResponseTypeError,//?
	kFWResponseDataError,//?
	kFWResponseConflictError,//?
	kConfigEntryKeyType,//?
	kConfigEntryKeyValue,//?
	kConfigLeafDirLength,//?
	kConfigLeafKeyType,//?
	kConfigDirectoryKeyType,//?
	kConfigROMBaseAddress,//?
	kConfigOffsetKeyType,//?
	kConfigEntryValue,//?
};

struct FWAddressStruct {
	UInt16 nodeID;//c
	int addressHi;//?
	int addressLo;//?

	#ifdef __cplusplus
	FWAddressStruct(int a, int b, UInt16 c) ;//?
    	FWAddressStruct(int a=0, int b=0);//?
	#endif
};
typedef struct FWAddressStruct  FWAddress;
typedef FWAddress *FWAddressPtr ;

struct DCLCommandStruct {
	int opcode;//?
	struct DCLCommandStruct * pNextDCLCommand;//c
	int compilerData;//?
	int operands[1];//?
};
typedef struct DCLCommandStruct DCLCommand;

struct DCLTransferPacketStruct {
	void* buffer;//c
	int size;//?
	int opcode;//?
	DCLCommand * pNextDCLCommand;//c
	int compilerData;//?
};
typedef struct DCLTransferPacketStruct DCLTransferPacket;

typedef void (DCLCallCommandProc)(DCLCommand *a);//c

struct DCLCallProcStruct {
	int procData;//?
	DCLCallCommandProc * proc;//c
	int opcode;//?
	DCLCommand* pNextDCLCommand;//c
	int compilerData;//?
};
typedef struct DCLCallProcStruct DCLCallProc;

struct DCLUpdateDCLListStruct {
	int numDCLCommands;//?
	DCLCommand ** dclCommandList;//c
	int opcode;//?
	DCLCommand* pNextDCLCommand;//c
	int compilerData;//?
};
typedef struct DCLUpdateDCLListStruct DCLUpdateDCLList;

struct DCLLabelStruct {
	int opcode;//?
	DCLCommand * pNextDCLCommand;//c
	int compilerData;//?
};
typedef struct DCLLabelStruct DCLLabel;

struct DCLJumpStruct {
	DCLLabel * pJumpDCLLabel;//c
	int opcode;//?
	DCLCommand* pNextDCLCommand;//c
	int compilerData;//?
};
typedef struct DCLJumpStruct DCLJump;

struct DCLPtrTimeStampStruct {
	UInt32* timeStampPtr;//c
	int opcode;//?
	DCLCommand* pNextDCLCommand;//c
	int compilerData;//?
};
typedef struct DCLPtrTimeStampStruct  DCLPtrTimeStamp;

struct DCLSetTagSyncBitsStruct {
	int opcode;//?
	int tagBits;//?
	int syncBits;//?
	int compilerData;//?
	int pNextDCLCommand;//?
};
typedef struct DCLSetTagSyncBitsStruct DCLSetTagSyncBits;

struct UserExportDCLUpdateDCLListStruct {
	int numDCLCommands;//?
	int pClientDCLStruct;//?
	int pNextDCLCommand;//?
	int compilerData;//?
	int opcode;//?
	int dclCommandList;//?
};
typedef struct UserExportDCLUpdateDCLListStruct UserExportDCLUpdateDCLList;

struct UserExportDCLJumpStruct {
	int pJumpDCLLabel;//?
	int pClientDCLStruct;//?
	int pNextDCLCommand;//?
	int compilerData;//?
	int opcode;//?
};
typedef struct UserExportDCLJumpStruct  UserExportDCLJump;

struct UserExportDCLCallProcStruct {
	int proc;//?
	int procData;//?
	int pClientDCLStruct;//?
	int pNextDCLCommand;//?
	int compilerData;//?
	int opcode;//?
};
typedef struct UserExportDCLCallProcStruct   UserExportDCLCallProc;

struct DCLNuDCLLeader {
	int opcode;//?
	int* pNextDCLCommand;//?
	void* program;//c
};
typedef struct DCLNuDCLLeader DCLNuDCLLeader;

struct DCLTransferBufferStruct {
	void* buffer;//c
	int bufferOffset;//?
	int size;//?
	DCLCommand * pNextDCLCommand;//c
	int packetSize;//?
	int opcode;//?
	int compilerData;//?
	int reserved;//?
};
typedef struct DCLTransferBufferStruct DCLTransferBuffer;

struct UserExportDCLCommandStruct {
	int opcode;//?
	int operands[1];//?
	int pNextDCLCommand;//?
	int pClientDCLStruct;//?
	int compilerData;//?
};
typedef struct UserExportDCLCommandStruct UserExportDCLCommand;

struct UserExportDCLTransferPacketStruct {
	mach_vm_address_t buffer;//c
	int size;//?
	int pClientDCLStruct;//?
	int pNextDCLCommand;//?
	int compilerData;//?
	int opcode;//?
};
typedef struct UserExportDCLTransferPacketStruct UserExportDCLTransferPacket;

struct UserExportDCLPtrTimeStampStruct {
	int timeStampPtr;//?
	int pClientDCLStruct;//?
	int pNextDCLCommand;//?
	int compilerData;//?
	int opcode;//?
};
typedef struct UserExportDCLPtrTimeStampStruct UserExportDCLPtrTimeStamp;

struct UserExportDCLTransferBufferStruct {
	int packetSize;//?
	int reserved;//?
	int bufferOffset;//?
	int pClientDCLStruct;//?
	int pNextDCLCommand;//?
	int compilerData;//?
	int opcode;//?
	int buffer;//?
	int size;//?
};
typedef struct UserExportDCLTransferBufferStruct UserExportDCLTransferBuffer;

struct UserExportDCLLabelStruct {
	int pClientDCLStruct;//?
	int pNextDCLCommand;//?
	int compilerData;//?
	int opcode;//?
};
typedef struct UserExportDCLLabelStruct UserExportDCLLabel;

struct UserExportDCLSetTagSyncBitsStruct {
	int tagBits;//?
	int syncBits;//?
	int pClientDCLStruct;//?
	int pNextDCLCommand;//?
	int compilerData;//?
	int opcode;//?
};
typedef struct UserExportDCLSetTagSyncBitsStruct  UserExportDCLSetTagSyncBits;

typedef DCLPtrTimeStamp* DCLPtrTimeStampPtr ;//c
typedef DCLCommand*	DCLCommandPtr ;//c
typedef DCLTransferPacket*	DCLTransferPacketPtr ;//c
typedef DCLCallProc* DCLCallProcPtr ;//c
typedef DCLUpdateDCLList* DCLUpdateDCLListPtr ;//c
typedef DCLSetTagSyncBits*	DCLSetTagSyncBitsPtr ;//c
typedef DCLLabel*	DCLLabelPtr ;//c
typedef DCLJump*	DCLJumpPtr ;//c
typedef struct __NuDCL *NuDCLRef ;//c
typedef void (*NuDCLCallback)( void* a, NuDCLRef b );//c

#ifdef __LP64__		
typedef void* DCLCallProcDataType;//c
#else
typedef UInt32 DCLCallProcDataType;//c
#endif

typedef void* FWClientCommandID;//c

typedef int IOFireWireSessionRef;//?
typedef int IOFWSpeed;//?
typedef UInt64 CSRNodeUniqueID;//c
typedef int IOConfigKeyType;//?
typedef int IOFWDCLNotificationType;//?
typedef int IOFWIsochResourceFlags;//?
typedef int IOFWIsochPortOptions;//?
typedef int IOFWPhysicalAccessMode;//?
typedef int IOFWSecurityMode;//?
typedef int IOFWWriteFlags;//?
typedef int IOFWReadFlags;//?
typedef int NuDCLSendPacketRef ;//?
typedef int NuDCLSkipCycleRef;//?
typedef int NuDCLReceivePacketRef;//?

#endif//HYS_IOKIT_FIREWIRE_IOFIREWIREFAMILYCOMMON_H
