#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIRELIB_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIRELIB_H

#define IOFIREWIRELIBCOMMAND_C_GUTS \
	IOReturn			(*GetStatus)(IOFireWireLibCommandRef	self) ;	\
	UInt32				(*GetTransferredBytes)(IOFireWireLibCommandRef self) ; \
	void				(*GetTargetAddress)(IOFireWireLibCommandRef self, FWAddress* outAddr) ; \
	void				(*SetTarget)(IOFireWireLibCommandRef self, const FWAddress* addr) ;	\
	void				(*SetGeneration)(IOFireWireLibCommandRef self, UInt32 generation) ;	\
	void				(*SetCallback)(IOFireWireLibCommandRef self, IOFireWireLibCommandCallback inCallback) ;	\
	void				(*SetRefCon)(IOFireWireLibCommandRef self, void* refCon) ;	\
	const Boolean		(*IsExecuting)(IOFireWireLibCommandRef self) ;	\
	IOReturn			(*Submit)(IOFireWireLibCommandRef self) ;	\
	IOReturn			(*SubmitWithRefconAndCallback)(IOFireWireLibCommandRef self, void* refCon, IOFireWireLibCommandCallback inCallback) ;\
	IOReturn			(*Cancel)(IOFireWireLibCommandRef self, IOReturn reason)

#define IOFIREWIRELIBCOMMAND_C_GUTS_v2	\
	void 				(*SetBuffer)(IOFireWireLibCommandRef self, UInt32 size, void* buf) ;	\
	void 				(*GetBuffer)(IOFireWireLibCommandRef self, UInt32* outSize, void** outBuf) ;	\
	IOReturn			(*SetMaxPacket)(IOFireWireLibCommandRef self, IOByteCount maxPacketSize) ;	\
	void				(*SetFlags)(IOFireWireLibCommandRef self, UInt32 inFlags)

#define IOFIREWIRELIBCOMMAND_C_GUTS_v3 \
	void				(*SetTimeoutDuration)(IOFireWireLibCommandRef self, UInt32 duration ); \
	void				(*SetMaxRetryCount)(IOFireWireLibCommandRef self, UInt32 count ); \
	UInt32				(*GetAckCode)( IOFireWireLibCommandRef self ); \
	UInt32				(*GetResponseCode)( IOFireWireLibCommandRef self ); \
	void				(*SetMaxPacketSpeed)( IOFireWireLibCommandRef self, IOFWSpeed speed ); \
	void *				(*GetRefCon)( IOFireWireLibCommandRef self )

#define kIOFireWireLibTypeID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13, 14,15,16)//?

#define kIOFireWireDeviceInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11, 12,13,14,15,16)//?

#define kIOFireWirePseudoAddressSpaceInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1, 2, 3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define  kIOFireWireCommandInterfaceID  CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireReadCommandInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireReadCommandInterfaceID_v2 CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireReadCommandInterfaceID_v3 CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireReadQuadletCommandInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireWriteCommandInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireWriteCommandInterfaceID_v2 CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireWriteCommandInterfaceID_v3 CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWirePHYCommandInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireWriteQuadletCommandInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireCompareSwapCommandInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireCompareSwapCommandInterfaceID_v2 CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireAsyncStreamCommandInterfaceID  CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireCompareSwapCommandInterfaceID_v3 CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWirePHYPacketListenerInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireVectorCommandInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireUnitInterfaceID_v3 2//?
#define kFireWireCommandUserFlagsMask 3//?
#define kFWUserCommandSubmitWithCopyMaxBufferBytes 4//?

	
/////////////////////
enum {
	kFWAddressSpaceNoFlags,//?
	kFireWireCommandUseCopy,//?
	kFireWireCommandAbsolute,//?
	kFWCommandInterfaceSyncExecute,//?
	kFWCommandInterfaceForceCopyAlways,//?
	kFWCommandInterfaceForceNoCopy,//?
	kFWCommandInterfaceAbsolute,//?
};

//////////////////////////////////////////

typedef void	(*IOFireWireLibCommandCallback)(void* a,IOReturn b) ;//c

typedef struct IOFireWirePseudoAddressSpaceInterface_t**	IOFireWireLibPseudoAddressSpaceRef ;//c

typedef struct IOFireWireDeviceInterface_t** IOFireWireLibDeviceRef ;//c
typedef struct IOFireWireIsochPortInterface_t** IOFireWireLibIsochPortRef ;//c
typedef struct IOFireWireRemoteIsochPortInterface_t** IOFireWireLibRemoteIsochPortRef;//c
typedef struct IOFireWireIsochChannelInterface_t** IOFireWireLibIsochChannelRef ;//c
typedef struct IOFireWireLocalIsochPortInterface_t** IOFireWireLibLocalIsochPortRef ;//c
typedef struct IOFireWireNuDCLPoolInterface_t**	IOFireWireLibNuDCLPoolRef ;//c

typedef struct  IOFireWireDCLCommandPoolInterface_t** IOFireWireLibDCLCommandPoolRef ;//c

typedef struct  IOFWAsyncStreamListenerInterface_t** IOFWAsyncStreamListenerInterfaceRef;//c

typedef struct IOFireWireCommandInterface_t** IOFireWireLibCommandRef ;//c

typedef struct IOFireWirePhysicalAddressSpaceInterface_t**	IOFireWireLibPhysicalAddressSpaceRef ;//c

typedef struct IOFireWireConfigDirectoryInterface_t** IOFireWireLibConfigDirectoryRef ;//c
typedef struct  IOFireWireLibIRMAllocationInterface_t**	IOFireWireLibIRMAllocationRef ; //c

typedef struct IOFireWireLocalUnitDirectoryInterface_t**	IOFireWireLibLocalUnitDirectoryRef ;//c

typedef struct IOFireWireLibVectorCommandInterface_t** IOFireWireLibVectorCommandRef;//c

typedef struct  IOFireWireLibPHYPacketListenerInterface_t**	IOFireWireLibPHYPacketListenerRef;//c

typedef struct IOFireWireBufferFillIsochPortInterface_t** 
IOFireWireLibBufferFillIsochPortRef ;//c

typedef struct IOFireWireReadCommandInterface_t** IOFireWireLibReadCommandRef ;//c

typedef struct IOFireWireReadQuadletCommandInterface_t**	IOFireWireLibReadQuadletCommandRef ;//c

typedef struct IOFireWireWriteCommandInterface_t** IOFireWireLibWriteCommandRef ;//c
typedef struct IOFireWirePHYCommandInterface_t** IOFireWireLibPHYCommandRef;//c

typedef struct 	IOFireWireWriteQuadletCommandInterface_t**	IOFireWireLibWriteQuadletCommandRef ;//c

typedef struct 	IOFireWireCompareSwapCommandInterface_t**	IOFireWireLibCompareSwapCommandRef ;//c

typedef struct	IOFireWireAsyncStreamCommandInterface_t**	IOFireWireLibAsyncStreamCommandRef;//c

typedef struct 	IOFireWireCommandInterface_t**				IOFireWireLibCommandRef ;//c

typedef void(*IOFireWireLibPHYPacketCallback)(IOFireWireLibPHYPacketListenerRef a, FWClientCommandID b, UInt32 c, UInt32 d, void *e);//c

typedef void (*IOFireWireLibPHYPacketSkippedCallback)(IOFireWireLibPHYPacketListenerRef a, FWClientCommandID b, UInt32 c, void *d);//c

//struct 

struct IOFireWireLibVectorCommandInterface_t {	
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy
	IOReturn					(*Submit)(IOFireWireLibVectorCommandRef a);//c

	IOReturn					(*SubmitWithRefconAndCallback)(IOFireWireLibVectorCommandRef a, void* b, IOFireWireLibCommandCallback c);//c
	
	Boolean				(*IsExecuting)(IOFireWireLibVectorCommandRef a);//c
	void	(*SetCallback)(IOFireWireLibVectorCommandRef a, IOFireWireLibCommandCallback b);//c

	void (*SetRefCon)(IOFireWireLibVectorCommandRef a, void* b);//c		
	void *(*GetRefCon)(IOFireWireLibVectorCommandRef a);//c
	void	(*SetFlags)(IOFireWireLibVectorCommandRef a, UInt32 b);//c		
	UInt32 (*GetFlags)(IOFireWireLibVectorCommandRef a);//c
	IOReturn	(*EnsureCapacity)(IOFireWireLibVectorCommandRef a, UInt32 b);//c

	void 	(*AddCommand)(IOFireWireLibVectorCommandRef a, IOFireWireLibCommandRef b);//c

	void (*RemoveCommand)(IOFireWireLibVectorCommandRef a, IOFireWireLibCommandRef b);//c
		
	void	(*InsertCommandAtIndex)(IOFireWireLibVectorCommandRef a, IOFireWireLibCommandRef b, UInt32 c);//c
		
	IOFireWireLibCommandRef	(*GetCommandAtIndex)(IOFireWireLibVectorCommandRef a, UInt32 b);//c

	UInt32 (*GetIndexOfCommand)(IOFireWireLibVectorCommandRef a, IOFireWireLibCommandRef b);//c
		
	void (*RemoveCommandAtIndex)(IOFireWireLibVectorCommandRef a, UInt32 b);//c
	void (*RemoveAllCommands)(IOFireWireLibVectorCommandRef a);//c
	UInt32 (*GetCommandCount)(IOFireWireLibVectorCommandRef a);//c
	
};
typedef  struct IOFireWireLibVectorCommandInterface_t IOFireWireLibVectorCommandInterface;

struct IOFireWireLibPHYPacketListenerInterface_t {
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy

	void (*SetListenerCallback)( IOFireWireLibPHYPacketListenerRef a, IOFireWireLibPHYPacketCallback b );//c

	void (*SetSkippedPacketCallback)( IOFireWireLibPHYPacketListenerRef a, IOFireWireLibPHYPacketSkippedCallback b );//c

	Boolean (*NotificationIsOn)( IOFireWireLibPHYPacketListenerRef a);//c
	IOReturn (*TurnOnNotification)( IOFireWireLibPHYPacketListenerRef a );//c
	void (*TurnOffNotification)( IOFireWireLibPHYPacketListenerRef a );//c

	void (*ClientCommandIsComplete)(IOFireWireLibPHYPacketListenerRef a, FWClientCommandID b);//c

	void (*SetRefCon)( IOFireWireLibPHYPacketListenerRef a, void * b );//c
	void* (*GetRefCon)( IOFireWireLibPHYPacketListenerRef a );//c
	void (*SetFlags)( IOFireWireLibPHYPacketListenerRef a, UInt32 b );//c
	UInt32 (*GetFlags)( IOFireWireLibPHYPacketListenerRef a );//c
};
typedef struct IOFireWireLibPHYPacketListenerInterface_t IOFireWireLibPHYPacketListenerInterface;

struct IOFireWireCommandInterface_t {
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy 
	IOFIREWIRELIBCOMMAND_C_GUTS ;
	IOFIREWIRELIBCOMMAND_C_GUTS_v2 ;
	IOFIREWIRELIBCOMMAND_C_GUTS_v3 ;
};
typedef struct  IOFireWireCommandInterface_t  IOFireWireCommandInterface;

struct IOFireWireReadCommandInterface_t{
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBCOMMAND_C_GUTS ;
	IOFIREWIRELIBCOMMAND_C_GUTS_v2 ;
	IOFIREWIRELIBCOMMAND_C_GUTS_v3 ;
};
typedef struct IOFireWireReadCommandInterface_t IOFireWireReadCommandInterface;

struct IOFireWireReadQuadletCommandInterface_t {
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBCOMMAND_C_GUTS ;
	void (*c)(IOFireWireLibReadQuadletCommandRef a, UInt32 b[], UInt32 c) ;//dummy
};
typedef struct IOFireWireReadQuadletCommandInterface_t IOFireWireReadQuadletCommandInterface;

struct IOFireWireWriteCommandInterface_t {
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBCOMMAND_C_GUTS ;
	IOFIREWIRELIBCOMMAND_C_GUTS_v2 ;	
	IOFIREWIRELIBCOMMAND_C_GUTS_v3 ;
};
typedef struct IOFireWireWriteCommandInterface_t IOFireWireWriteCommandInterface;

struct IOFireWirePHYCommandInterface_t {
	IUNKNOWN_C_GUTS;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBCOMMAND_C_GUTS;
	IOFIREWIRELIBCOMMAND_C_GUTS_v2;
	IOFIREWIRELIBCOMMAND_C_GUTS_v3;
	void	(*c)( IOFireWireLibPHYCommandRef a, UInt32 b, UInt32 c);//dummy
};
typedef struct IOFireWirePHYCommandInterface_t IOFireWirePHYCommandInterface;

struct IOFireWireWriteQuadletCommandInterface_t {
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBCOMMAND_C_GUTS ;
	void (*c)(IOFireWireLibWriteQuadletCommandRef a, UInt32 b[], UInt32 c) ;//dummy
};
typedef struct IOFireWireWriteQuadletCommandInterface_t IOFireWireWriteQuadletCommandInterface;

struct IOFireWireCompareSwapCommandInterface_t {
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBCOMMAND_C_GUTS ;
	void	(*c)(IOFireWireLibCompareSwapCommandRef a, UInt32 b, UInt32 c) ;//dummy
	void	(*d)(IOFireWireLibCompareSwapCommandRef a, UInt64 b, UInt64 c) ;//dummy
	Boolean	(*e)(IOFireWireLibCompareSwapCommandRef a) ;//dummy
	IOReturn (*f)(IOFireWireLibCompareSwapCommandRef a, UInt32* b) ;//dummy
	IOReturn (*g)(IOFireWireLibCompareSwapCommandRef a, UInt64* b) ;//dummy
	void (*h)(IOFireWireLibCompareSwapCommandRef a, UInt32 b) ;//dummy
};
typedef struct IOFireWireCompareSwapCommandInterface_t IOFireWireCompareSwapCommandInterface;

struct IOFireWireCompareSwapCommandInterface_v3_t {
	IUNKNOWN_C_GUTS;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBCOMMAND_C_GUTS;
	IOFIREWIRELIBCOMMAND_C_GUTS_v2;
	IOFIREWIRELIBCOMMAND_C_GUTS_v3;
	void	(*c)(IOFireWireLibCompareSwapCommandRef a, UInt32 b, UInt32 c) ;//dummy
	void	(*d)(IOFireWireLibCompareSwapCommandRef a, UInt64 b, UInt64 c) ;//dummy
	Boolean	(*e)(IOFireWireLibCompareSwapCommandRef a) ;//dummy
	IOReturn (*f)(IOFireWireLibCompareSwapCommandRef a, UInt32* b) ;//dummy
	IOReturn (*g)(IOFireWireLibCompareSwapCommandRef a, UInt64* b) ;//dummy	
};
typedef struct IOFireWireCompareSwapCommandInterface_v3_t IOFireWireCompareSwapCommandInterface_v3;

struct IOFireWireAsyncStreamCommandInterface_t {
	IUNKNOWN_C_GUTS;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBCOMMAND_C_GUTS;
	IOFIREWIRELIBCOMMAND_C_GUTS_v2;
	IOFIREWIRELIBCOMMAND_C_GUTS_v3;
};
typedef struct IOFireWireAsyncStreamCommandInterface_t  IOFireWireAsyncStreamCommandInterface;

#endif//HYS_IOKIT_FIREWIRE_IOFIREWIRELIB_H
