#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIRENUB_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIRENUB_H

class IOFireWireNubAux;//add

typedef int TerminationState;//?

enum {
	kNotTerminated,//?
	kTerminated,//?
	kNeedsTermination,//?
};

class IOFireWireNub_HYS
{
  //  OSDeclareAbstractStructors(IOFireWireNub_HYS)

public://data

IOFireWireController *fControl;//c
int fMaxReadROMPackLog;//c
int fMaxReadPackLog;//c
int fMaxWritePackLog;//c
CSRNodeUniqueID fUniqueID;//c
IOConfigDirectory *fDirectory;//c
IOFireWireNubAux * fAuxiliary;//c
OSSet*  fConfigDirectorySet;//c
UInt16  fNodeID;//c
UInt32 fGeneration;//c
UInt16 fLocalNodeID;//c

int fNodeFlags;//?

public://define

#define IOFireWireNub_createCompareAndSwapCommand \
IOFWCompareAndSwapCommand *createCompareAndSwapCommand(FWAddress a, const UInt32 *b, const UInt32 *c, int d, FWDeviceCallback e=0, void *f=0, bool g=0);//?

#define IOFireWireNub_getBus \
IOFireWireBus * getBus() const;//?

#define IOFireWireNub_getController \
IOFireWireController * getController() const;//?

#define IOFireWireNub_createWriteCommand \
IOFWWriteCommand *createWriteCommand(FWAddress a, IOMemoryDescriptor *b, FWDeviceCallback c=0, void *e=0, bool f=0);//?

#define IOFireWireNub_setNodeFlags \
void setNodeFlags( UInt32 a );//?

#define IOFireWireNub_setConfigDirectory \
IOReturn setConfigDirectory( IOConfigDirectory *a);//?

#define IOFireWireNub_createPseudoAddressSpace \
IOFWPseudoAddressSpace *createPseudoAddressSpace(FWAddress *a, UInt32 b, FWReadCallback c, FWWriteCallback d, void *e);//?

#define IOFireWireNub_createReadQuadCommand \
IOFWReadQuadCommand *createReadQuadCommand(FWAddress a, UInt32 *b, int c, FWDeviceCallback d=0, void *e=0, bool f=0);//?

#define IOFireWireNub_createWriteQuadCommand \
IOFWWriteQuadCommand *createWriteQuadCommand(FWAddress a, UInt32 *b, int c, FWDeviceCallback d=0, void *e=0, bool f=0);//?

#define IOFireWireNub_createPhysicalAddressSpace \
IOFWPhysicalAddressSpace *createPhysicalAddressSpace(IOMemoryDescriptor *a);//?

#define IOFireWireNub_getConfigDirectoryRef \
IOReturn getConfigDirectoryRef( IOConfigDirectory *&a);//?

#define IOFireWireNub_getConfigDirectory \
IOReturn getConfigDirectory(IOConfigDirectory *&a);//?

#define IOFireWireNub_createReadCommand \
IOFWReadCommand *createReadCommand(FWAddress a, IOMemoryDescriptor *b, FWDeviceCallback c=0, void *d=0, bool e=0);//?

#define IOFireWireNub_setMaxPackLog \
void setMaxPackLog(bool a, bool b, int c);//?

#define IOFireWireNub_maxPackLog \
int maxPackLog(bool a) const;

#define IOFireWireNub_maxPackLog_FWAddress \
int maxPackLog(bool a, FWAddress b) const;

#define IOFireWireNub_maxPackLog_const_IOFireWireNub \
int maxPackLog(bool a, const IOFireWireNub *b) const;

#define IOFireWireNub_FWSpeed \
IOFWSpeed FWSpeed() const;//?

#define IOFireWireNub_FWSpeed_const_IOFireWireNub \
IOFWSpeed FWSpeed(const IOFireWireNub *a) const;//?

#define IOFireWireNub_getNodeIDGeneration \
IOReturn getNodeIDGeneration(UInt32 &a, UInt16 &b) const;//c

#define IOFireWireNub_getNodeIDGeneration_UInt16 \
IOReturn getNodeIDGeneration(UInt32 &a, UInt16 &b, UInt16 &c) const;//c

#define IOFireWireNub_free \
void free();//?

#define IOFireWireNub_createAuxiliary \
IOFireWireNubAux * createAuxiliary();//?

#define IOFireWireNub_clearNodeFlags \
void clearNodeFlags( UInt32 a);//?

#define IOFireWireNub_init \
bool init(OSDictionary * a);//?

#define IOFireWireNub_getUniqueID \
const CSRNodeUniqueID &getUniqueID() const;//?

#define IOFireWireNub_getNodeFlags \
UInt32 getNodeFlags( );//?

public://func

int hopCount();//?
int getTerminationState();//?
int setTerminationState(int a);//?

};

class IOFireWireNubAux_HYS
{
    OSDeclareDefaultStructors(IOFireWireNubAux_HYS)

public://define

#define IOFireWireNubAux_isPhysicalAccessEnabled \
bool isPhysicalAccessEnabled();//?

#define IOFireWireNubAux_getTerminationState \
TerminationState getTerminationState();//?

#define IOFireWireNubAux_hopCount_ \
UInt32 hopCount();//?

#define IOFireWireNubAux_free \
void free();//?

#define IOFireWireNubAux_hopCount \
UInt32 hopCount( IOFireWireNub * a);//?

#define IOFireWireNubAux_setTerminationState \
void setTerminationState( TerminationState a );//?

#define IOFireWireNubAux_createSimplePhysicalAddressSpace \
IOFWSimplePhysicalAddressSpace * createSimplePhysicalAddressSpace( vm_size_t a, IODirection b);//?

#define IOFireWireNubAux_createSimpleContiguousPhysicalAddressSpace \
IOFWSimpleContiguousPhysicalAddressSpace * createSimpleContiguousPhysicalAddressSpace( vm_size_t a, IODirection b);//?

#define IOFireWireNubAux_init \
bool init( IOFireWireNub * a);//?

public://data

IOFireWireNub * fPrimary;//c

int fTerminationState;//?

public://func

};



#endif//HYS_IOKIT_FIREWIRE_IOFIREWIRENUB_H
