#ifndef HYS_IOKIT_DISPLAY_IODISPLAY_H
#define HYS_IOKIT_DISPLAY_IODISPLAY_H

class IODisplayConnect;//add
class IODisplay;//add

extern const OSSymbol * gIODisplayParametersKey;//c
extern const OSSymbol * gIODisplayGUIDKey;//c
extern const OSSymbol * gIODisplayContrastKey;//c
extern const OSSymbol * gIODisplayBrightnessKey;//c
extern const OSSymbol *gIODisplayHorizontalPositionKey;//
extern const OSSymbol *gIODisplayHorizontalSizeKey;//c
extern const OSSymbol *gIODisplayVerticalPositionKey;//c
extern const OSSymbol *gIODisplayVerticalSizeKey;//c
extern const OSSymbol *gIODisplayTrapezoidKey;//c
extern const OSSymbol *gIODisplayPincushionKey;//c
extern const OSSymbol *gIODisplayParallelogramKey;//c
extern const OSSymbol *gIODisplayRotationKey;//c
extern const OSSymbol *gIODisplayParametersTheatreModeKey;
extern const OSSymbol *gIODisplayParametersTheatreModeWindowKey;//c
extern const OSSymbol *gIODisplayParametersDefaultKey;//c
extern const OSSymbol *gIODisplayParametersCommitKey;//c
extern const OSSymbol * gIODisplayOverscanKey;//c

enum {
	kIODisplayNumPowerStates=4,//c
};

enum {
	kIODisplayMaxPowerState,//?
};

struct DisplayPMVars {
	int currentState;//?
	int maxState;//?
	int displayIdle;//?
};

class IODisplay_HYS
{
  //  OSDeclareAbstractStructors(IODisplay_HYS)

public://data

struct DisplayPMVars * fDisplayPMVars;//c
IODisplayConnect * fConnection;//c
IONotifier * fNotifier;//c
class IODisplayParameterHandler * fParameterHandler;//c

public://define

#define IODisplay_makeDisplayUsable \
void makeDisplayUsable( void );//?

#define IODisplay_maxCapabilityForDomainState \
unsigned long maxCapabilityForDomainState( IOPMPowerFlags a);//?

#define IODisplay_initialPowerStateForDomainState \
unsigned long initialPowerStateForDomainState( IOPMPowerFlags a );//?

#define IODisplay_powerStateForDomainState \
unsigned long powerStateForDomainState( IOPMPowerFlags  a);//?

#define IODisplay_setPowerState \
IOReturn setPowerState( unsigned long a, IOService *b );//?

#define IODisplay_dropOneLevel \
void dropOneLevel( void );//?

#define IODisplay_doDataSet \
bool doDataSet( const OSSymbol *a, OSData *b);//?

#define IODisplay_setProperties \
IOReturn setProperties( OSObject *a);//?

#define IODisplay_updateNumber \
static bool updateNumber( OSDictionary *a, const OSSymbol *b, SInt32 c);//c

#define IODisplay_setForKey \
bool setForKey( OSDictionary *a, const OSSymbol *b, SInt32 c, SInt32 d, SInt32 e);//?

#define IODisplay_getConnectFlagsForDisplayMode \
IOReturn getConnectFlagsForDisplayMode(IODisplayModeID a, UInt32 *b);//?

#define IODisplay_free \
void free();//?

#define IODisplay_removeParameterHandler \
bool removeParameterHandler( IODisplayParameterHandler *a);//?

#define IODisplay__framebufferEvent \
static IOReturn _framebufferEvent( OSObject *a, void *b, IOFramebuffer *c, IOIndex d, void * e);//?

#define IODisplay_initPowerManagement \
void initPowerManagement( IOService *a);//?

#define IODisplay_doUpdate \
bool doUpdate( void );//?

#define IODisplay_addParameterHandler \
bool addParameterHandler( IODisplayParameterHandler *a);//c

#define IODisplay_readFramebufferEDID \
IOReturn readFramebufferEDID( void );//?

#define IODisplay_stop \
void stop( IOService *a);//?

#define IODisplay_start \
bool start( IOService *a);//?

#define IODisplay_getGammaTableByIndex \
IOReturn getGammaTableByIndex(UInt32 *a, UInt32 *b, UInt32 *c, void **d);//?

#define IODisplay_doIntegerSet \
bool doIntegerSet( OSDictionary *a, const OSSymbol *b, UInt32 c);//?

#define IODisplay_getIntegerRange \
static OSDictionary * getIntegerRange( OSDictionary *a, const OSSymbol *b, SInt32 *c, SInt32 * d, SInt32 *e);//?

#define IODisplay_getConnection \
IODisplayConnect * getConnection( void );//?

#define IODisplay_addParameter \
static bool addParameter( OSDictionary *a, const OSSymbol *b, SInt32 c, SInt32 d);//?

#define IODisplay_setParameter \
static bool setParameter( OSDictionary *a, const OSSymbol *b, SInt32 c);//?

#define IODisplay_probe \
IOService * probe(	IOService *a, SInt32 *b);//?

#define IODisplay_initialize \
static void initialize( void );//c

#define IODisplay_framebufferEvent \
IOReturn framebufferEvent( IOFramebuffer *a, IOIndex b, void *c);//?

public: //func

};


class  IOBacklightDisplay_HYS
{
    OSDeclareDefaultStructors(IOBacklightDisplay_HYS)

public://data

OSObject * fPMSettingNotificationHandle;//c
SInt32 fCurrentBrightness;//c
SInt32 fMinBrightness;//c
SInt32 fMaxBrightness;//c
OSSymbol* fDisplaySleepUsesDimSettingKey;//c

int fCurrentUserBrightness;//?
int fCurrentPowerState;//?
int fMaxBrightnessLevel[1];//?

public://func

#define IOBacklightDisplay_powerStateForDomainState \
unsigned long powerStateForDomainState( IOPMPowerFlags a);//?

#define IOBacklightDisplay_initialPowerStateForDomainState \
unsigned long initialPowerStateForDomainState( IOPMPowerFlags a);//?

#define IOBacklightDisplay_doIntegerSet \
bool doIntegerSet( OSDictionary *a, const OSSymbol *b, UInt32 c);//?

#define IOBacklightDisplay_handlePMSettingCallback \
void handlePMSettingCallback(const OSSymbol *a, OSObject *b, uintptr_t c);//c

#define IOBacklightDisplay_setBrightness \
bool setBrightness( SInt32 a);//?

#define IOBacklightDisplay_initPowerManagement \
void initPowerManagement( IOService *a );//?

#define IOBacklightDisplay_setPowerState \
IOReturn setPowerState( unsigned long a, IOService *b );//?

#define IOBacklightDisplay_maxCapabilityForDomainState \
unsigned long maxCapabilityForDomainState( IOPMPowerFlags a);//?

#define IOBacklightDisplay_stop \
void stop( IOService *a);//?

#define IOBacklightDisplay_probe \
IOService * probe( IOService * a, SInt32 * b);//?

};


class IODisplayConnect_HYS
{
    OSDeclareDefaultStructors(IODisplayConnect_HYS)

public://data

int connection;//?

public://define

#define IODisplayConnect_joinPMtree \
void joinPMtree ( IOService *a);//?

#define IODisplayConnect_initWithConnection \
bool initWithConnection( IOIndex a);//?

#define IODisplayConnect_getFramebuffer \
IOFramebuffer * getFramebuffer( void );//?

#define IODisplayConnect_setAttributeForConnection \
IOReturn setAttributeForConnection( IOSelect a, UInt32 b);//?

#define IODisplayConnect_getAttributeForConnection \
IOReturn getAttributeForConnection( IOSelect a, UInt32 *b);//?

#define IODisplayConnect_getConnection \
IOIndex getConnection( void );//?

public://func

};

class  IODisplayParameterHandler_HYS
{
    OSDeclareDefaultStructors(IODisplayParameterHandler_HYS)

public:

int setDisplay(IODisplay * a);//?
int doIntegerSet( OSDictionary *  a,const OSSymbol * b,int c);//?
int doDataSet( const OSSymbol * a,OSData * b);//?
int doUpdate();//?

};

#endif//HYS_IOKIT_DISPLAY_IODISPLAY_H
