#ifndef HYS_IOKIT_GRAPHICS_IOFRAMEBUFFER_H
#define HYS_IOKIT_GRAPHICS_IOFRAMEBUFFER_H

#define kIOFBDependentIDKey "kIOFBDependentIDKey"//?
#define kIOFBDependentIndexKey "kIOFBDependentIndexKey"//?

enum {
	kIOFBNotifyDidChangeSpeed,//?
	kIOFBNotifyWillChangeSpeed,//?
	kIODDCBlockTypeEDID,//?
	kFBDisplayUsablePowerState,//?
	kIOFBNotifyDisplayModeWillChange,//?
	kIOFBNotifyDisplayModeDidChange,//?
	kIOFBNotifyWillPowerOff,//?
	kIOFBNotifyDidPowerOn,//?
	kIOFBNotifyWillPowerOn,//?
	kIOFBNotifyDidPowerOff,//?
	kIOFBNotifyOnlineChange,//?
	kIOFBNotifyWillSleep,//?
	kIOFBNotifyDidWake,//?
	kIODDCHigh,//?
	kIODDCLow,//?
	kIOFBNotifyCaptureChange,//?
	kIODDCTristate,//?
	kIOFBNotifyClamshellChange,//?
};

//////////////////
typedef void* IOFBCursorRef;//c

struct IOFBCursorControlCallouts {
	IOReturn (*setCursorImage) (void *a, void *b, IOHardwareCursorDescriptor * c, IOFBCursorRef d);//c

	IOReturn (*setCursorState) (void *a, void *b, SInt32 c, SInt32 d, bool e);//c

};
typedef struct IOFBCursorControlCallouts IOFBCursorControlCallouts;

struct IOFBCursorControlAttribute {
	const IOFBCursorControlCallouts*  callouts;//c
	void* self;//c
	void* ref;//c
};
typedef struct IOFBCursorControlAttribute IOFBCursorControlAttribute;

typedef IOReturn (*IOFramebufferNotificationHandler)(OSObject * a, void *b, IOFramebuffer * c, IOIndex d,void * e);//c

typedef void (*CursorBlitProc)(IOFramebuffer *a, void *b, volatile unsigned char *c, unsigned int d, unsigned int e, unsigned int f, int g, int h);//c

typedef void (*CursorRemoveProc)(IOFramebuffer *a, void *b, volatile unsigned char *c, unsigned int d, int e, int f);//c

typedef void (*IOFBInterruptProc)( OSObject * a, void * b);//c

///////////////////
class IOFramebuffer_HYS
{
    OSDeclareDefaultStructors(IOFramebuffer_HYS)

private:

#define IOFramebuffer___private \
struct IOFramebufferPrivate * __private;//c

public://data

union {
	struct {
		unsigned char* _bm34To35SampleTable;//c
		unsigned char* _bm35To34SampleTable;//c
		unsigned int* _bm256To38SampleTable;//c
		unsigned char* _bm38To256SampleTable;//c
	} t;
	UInt8* tables[1];//?
} colorConvert;

unsigned int bytesPerPixel;//c
unsigned int rowBytes;//c
volatile unsigned char *  frameBuffer;//c
CursorBlitProc cursorBlitProc;//c
CursorRemoveProc cursorRemoveProc;//c
IOMemoryMap * vramMap;//c
IOGSize maxCursorSize;//c
volatile unsigned char * cursorSave;//c
int shmemClientVersion;//?
IOBufferMemoryDescriptor * sharedCursor;//c
StdFBShmem_t * priv;//c
class IOFramebufferSharedUserClient * sharedConnect;//c
semaphore_t vblSemaphore;//c
OSArray * userAccessRanges;//c
void * serverMsg;//c
IOGPoint nextCursorLoc;// c
int nextCursorFrame;//c
SInt32 connectChange;//c
IOInterruptEventSource * deferredEvents;//c
IOFramebuffer * nextDependent;//c
OSSet *fbNotifications;//c
class IOFramebufferUserClient * serverConnect;//c

int mirrorPrimary;//?
int mirrored;//?
int mirrorSWCursor;//?
int clutValid;//?
int _IOFramebuffer_reserved[1];//?
int messaged;//?
int serverPendingAck;//?
int pendingPowerState;//?
int pendingPowerChange;//?
int captured;//?
int sleepConnectCheck;//?
int serverNotified;//?
int haveVBLService;//?
int suspended;//?
int opened;//?
int vramMapOffset;//?
int dead;//?
int haveHWCursor;//?
int pagingState;//?
int totalWidth;//?
int white;//?
int isUsable;//?
int configPending;//?
int serverState;//?
int needCursorService;//?

public://define

#define IOFramebuffer_enableDDCRaster \
IOReturn enableDDCRaster( bool a);//?

#define IOFramebuffer_setNumber \
bool setNumber( OSDictionary *a, const char *b,UInt32 c);//?

#define IOFramebuffer_close \
void close( void );//?

#define IOFramebuffer_callPlatformFunction \
IOReturn callPlatformFunction( const OSSymbol *a,	 bool b, void *c, void *d, void *e, void *f );//?

#define IOFramebuffer_requestProbe \
IOReturn requestProbe( IOOptionBits a);//?

#define IOFramebuffer_setupForCurrentConfig \
IOReturn setupForCurrentConfig( void );//?

#define IOFramebuffer_isConsoleDevice \
bool isConsoleDevice( void );//?

#define IOFramebuffer_getAggressiveness \
IOReturn getAggressiveness( unsigned long a, unsigned long *b);//?

#define IOFramebuffer_powerStateDidChangeTo \
IOReturn powerStateDidChangeTo ( IOPMPowerFlags a, unsigned long b, IOService*c);//?

#define IOFramebuffer_setPowerState \
IOReturn setPowerState( unsigned long a, IOService *b);//?

#define IOFramebuffer_setAggressiveness \
IOReturn setAggressiveness( unsigned long a, unsigned long b);//?

#define IOFramebuffer_powerStateWillChangeTo \
IOReturn powerStateWillChangeTo ( IOPMPowerFlags a, unsigned long b, IOService*c);//?

#define IOFramebuffer_deliverFramebufferNotification \
IOReturn deliverFramebufferNotification(IOIndex a, void *b = 0 );//?

#define IOFramebuffer_getVBLTime \
void getVBLTime( AbsoluteTime *a, AbsoluteTime *b);//?

#define IOFramebuffer_resetCursor \
 void resetCursor( void );//c

#define IOFramebuffer_showCursor \
void showCursor( IOGPoint *a, int b );//?

#define IOFramebuffer_moveCursor \
void moveCursor( IOGPoint *a, int b);//?

#define IOFramebuffer_hideCursor \
void hideCursor( void );//?

#define IOFramebuffer_start \
bool start( IOService *a);//?

#define IOFramebuffer_initialize \
static void initialize();//?

#define IOFramebuffer_probe \
IOService * probe( IOService *a, SInt32 *b);//?

#define IOFramebuffer_free \
void free();//?

#define IOFramebuffer_setAttribute \
IOReturn setAttribute( IOSelect a, UInt32 b);//?

#define IOFramebuffer_stop \
void stop( IOService *a );//?

#define IOFramebuffer_getNotificationSemaphore \
IOReturn getNotificationSemaphore( IOSelect a, semaphore_t *b);//?

#define IOFramebuffer_getBoundingRect \
void getBoundingRect ( IOGBounds **a);//?

#define IOFramebuffer_serializeInfo \
bool serializeInfo( OSSerialize *a);//?

#define IOFramebuffer_requestTerminate \
bool requestTerminate( IOService *a, IOOptionBits b);//?

#define IOFramebuffer_open \
IOReturn open( void );;//?

#define IOFramebuffer_newUserClient \
IOReturn newUserClient( task_t a, void *b, UInt32 c, IOUserClient **d);//?

#define IOFramebuffer_addFramebufferNotification \
IONotifier *addFramebufferNotification(IOFramebufferNotificationHandler a, OSObject *b, void *c);//?

public://func


};


#endif//HYS_IOKIT_GRAPHICS_IOFRAMEBUFFER_H
