#ifndef HYS_IOKIT_HID_IOHIDLIB_H
#define HYS_IOKIT_HID_IOHIDLIB_H

#define kIOHIDDeviceUserClientTypeID CFUUIDGetConstantUUIDWithBytes(0,1, 2,3,4,5,6,7,8,9, 10,11,12,13,14,15,16)//c

#define IOHIDDEVICEINTERFACE_FUNCS_100 							\
    IOReturn (*createAsyncEventSource)(void * self, CFRunLoopSourceRef * source); 	\
    CFRunLoopSourceRef (*getAsyncEventSource)(void * self);				\
    IOReturn (*createAsyncPort)(void * self, mach_port_t * port);			\
    mach_port_t (*getAsyncPort)(void * self);						\
    IOReturn (*open)(void * self, UInt32 flags);					\
    IOReturn (*close)(void * self);							\
    IOReturn (*setRemovalCallback)(void * self, IOHIDCallbackFunction removalCallback,	\
                                   void * removalTarget, void * removalRefcon);		\
    IOReturn (*getElementValue)(void * self, IOHIDElementCookie	elementCookie,		\
                                IOHIDEventStruct * valueEvent);				\
    IOReturn (*setElementValue)(void * self, IOHIDElementCookie elementCookie,		\
                                IOHIDEventStruct * valueEvent, UInt32 timeoutMS,	\
                                IOHIDElementCallbackFunction callback,			\
                                void * callbackTarget, void * callbackRefcon);		\
    IOReturn (*queryElementValue)(void * self, IOHIDElementCookie elementCookie,	\
                                IOHIDEventStruct * valueEvent, UInt32 timeoutMS,	\
                                IOHIDElementCallbackFunction callback,			\
                                void * callbackTarget, void * callbackRefcon);		\
    IOReturn (*startAllQueues)(void * self);						\
    IOReturn (*stopAllQueues)(void * self);						\
    IOHIDQueueInterface ** (*allocQueue) (void *self);					\
    IOHIDOutputTransactionInterface ** (*allocOutputTransaction) (void *self)

#define IOHIDDEVICEINTERFACE_FUNCS_121	 						\
    IOReturn (*setReport)(void * self, IOHIDReportType reportType, UInt32 reportID,	\
                                void * reportBuffer, UInt32 reportBufferSize,		\
                                UInt32 timeoutMS, IOHIDReportCallbackFunction callback,	\
                                void * callbackTarget, void * callbackRefcon);		\
    IOReturn (*getReport)(void * self, IOHIDReportType reportType,			\
                                UInt32 reportID, void * reportBuffer,			\
                                UInt32 * reportBufferSize, UInt32 timeoutMS,		\
                                IOHIDReportCallbackFunction callback,			\
                                void * callbackTarget, void * callbackRefcon)

#define IOHIDDEVICEINTERFACE_FUNCS_122	 						\
    IOReturn (*copyMatchingElements)(void * self, CFDictionaryRef matchingDict, 	\
                                CFArrayRef * elements);					\
    IOReturn (*setInterruptReportHandlerCallback)(void * self, void * reportBuffer, 		\
                                UInt32 reportBufferSize, 				\
                                IOHIDReportCallbackFunction callback,			\
                                void * callbackTarget, void * callbackRefcon)	


#endif//HYS_IOKIT_HID_IOHIDLIB_H

