
#ifndef HYS_IOKIT_HIDSYSTEM_IOHIDDESCRIPTORPARSER_H
#define HYS_IOKIT_HIDSYSTEM_IOHIDDESCRIPTORPARSER_H

#ifndef OC_noErr
	#define OC_noEr
enum {
	noErr,//?
};
#endif

#ifndef OC_Byte
	#define OC_Byte
typedef UInt8		Byte;//c
#endif

#ifndef OC_SignedByte
	#define OC_SignedByte
typedef SInt8		SignedByte;//c
#endif

#ifndef OC_FourCharCode
	#define OC_FourCharCode
typedef unsigned long	FourCharCode;//c
#endif

#ifndef OC_OSType
	#define OC_OSType
	typedef FourCharCode	OSType;//c
#endif

#ifndef OC_ByteCount
	#define OC_ByteCount
typedef UInt32		ByteCount;//c
#endif

enum {
	kHIDUnknownReport,//?
	kHIDFlag_StrictErrorChecking,//?
	kHIDInvertedPhysicalRangeErr,//?
	kHIDUnmatchedDesignatorRangeErr,//?
	kHIDUnmatchedStringRangeErr,//?
	kHIDUnmatchedUsageRangeErr,//?
	kHIDInvertedLogicalRangeErr,
	kHIDBadLogicalMaximumErr,//?
	kHIDBadLogicalMinimumErr,//?
	kHIDInvertedUsageRangeErr,//?
	kHIDInvalidRangePageErr,//?
	kHIDNotValueArrayErr,//?
	kHIDUsageNotFoundErr,//?
	kHIDReportSizeZeroErr,//?
	kHIDEndOfDescriptorErr,//?
	kHIDNotEnoughMemoryErr,//?
	kHIDValueOutOfRangeErr,//?
	kHIDBadLogPhysValuesErr,//?
	kHIDNullStateErr,//?
	kHIDInvalidReportLengthErr,//?
	kHIDInvalidReportTypeErr,//?
	kHIDFeatureReport,//?
	kHIDOutputReport,//?
	kHIDInputReport,//?
	kHIDIncompatibleReportErr,//?
	kHIDSuccess,//?
	kHIDBufferTooSmallErr,//?
	kHIDBadParameterErr,//?
	kHIDInvalidPreparsedDataErr,//?
	HIDNullPointerErr,//?
	kHIDNullPointerErr,//?
};

struct HIDValueCaps {
	int collection;//?
	int collectionUsagePage;//?
	int collectionUsage;//?
	int bitField;//?
	int reportID;//?
	int usagePage;//?
	int isAbsolute;//?
	int isRange;//?
	int isStringRange;//?
	int isDesignatorRange;//?
	int bitSize;//?
	int logicalMin;//?
	int logicalMax;//?
	int physicalMin;//?
	int physicalMax;//?
	int reportCount;//?
	int startBit;//?

	union {
		struct {
			int usageMin;//?
			int usageMax;//?
			int stringMin;//?
			int stringMax;//?
			int designatorMin;//?
			int designatorMax;//?
		} range;

		struct {
			int usage;//?
			int stringIndex;//?
			int designatorIndex;//?
		} notRange;
	}u;
};
typedef struct HIDValueCaps HIDValueCaps, * HIDValueCapsPtr;

struct HIDValueCapabilities {
	int collection;//?
	int collectionUsagePage;//?
	int collectionUsage;//?
	int bitField;//?
	int reportID;//?
	int usagePage;//?
	int unitExponent;//?
	int units;//?
	int startBit;//?
	int pbVersion;//?
	int isAbsolute;//?
	int isRange;//?
	int isStringRange;//?
	int isDesignatorRange;//?
	int reportCount;//?
	int bitSize;//?
	int physicalMax;//?
	int physicalMin;//?
	int logicalMax;//?
	int logicalMin;//?

	union {
		struct {
 			int usageMin;//?
			int usageMax;//?
			int stringMin;//?
			int stringMax;//?
			int designatorMin;//?
			int designatorMax;//?
		} range;

		struct {
			int usage;//?
			int stringIndex;//?
			int designatorIndex;//?
		} notRange;
	} u;
};
typedef struct HIDValueCapabilities HIDValueCapabilities, * HIDValueCapabilitiesPtr;

struct HIDButtonCaps {
	int collection;//?
	int startBit;//?
	int collectionUsagePage;//?
 	int collectionUsage;//?
	int bitField;//?
	int isDesignatorRange;//?
	int reportID;//?
	int usagePage;//?
	int isStringRange;//?
 	int isAbsolute;//?
 	int isRange;//?

	union {
		struct {
			int usageMin;//?
			int usageMax;//?
			int stringMin;//?
			int stringMax;//?
			int designatorMin;//?
			int designatorMax;//?
		} range;

		struct {
			int usage;//?
			int stringIndex;//?
 			int designatorIndex;//?
		} notRange;
	} u;
};
typedef struct HIDButtonCaps HIDButtonCaps, * HIDButtonCapsPtr;

struct HIDButtonCapabilities {
	int collection;//?
	int collectionUsagePage;//?
 	int unitExponent;//?
	int collectionUsage;//?
	int bitField;//?
	int startBit;//?
	int isDesignatorRange;//?
 	int isStringRange;//?
 	int reportID;//?
	int usagePage;//?
	int units;//?
 	int isRange;//?
 	int isAbsolute;//?
 	int pbVersion;//?

	union {
		struct {
			int designatorMax;//?
			int designatorMin;//?
			int stringMax;//?
 			int stringMin;//?
			int usageMax;//?
			int usageMin;//?
		} range;

		struct {
			int reserved2;//?
			int designatorIndex;//?
			int stringIndex;//?
			int reserved3;//?
			int usage;//?
		} notRange;
	} u;
};
typedef struct HIDButtonCapabilities HIDButtonCapabilities, * HIDButtonCapabilitiesPtr;

struct HIDCapabilities {
	int usagePage;//?
	int usage;//?
	int numberCollectionNodes;//?
	int inputReportByteLength;//?
	int outputReportByteLength;//?
	int featureReportByteLength;//?
	int numberInputButtonCaps;//?
	int numberOutputButtonCaps;//?
	int numberInputValueCaps;//?
	int numberOutputValueCaps;//?
	int numberFeatureButtonCaps;//?
	int numberFeatureValueCaps;//?
};
typedef struct HIDCapabilities HIDCapabilities, * HIDCapabilitiesPtr;

struct HIDCollectionNode {
	int collectionUsage;//?
	int collectionUsagePage;//?
	int parent;//?
	int numberOfChildren;//?
	int nextSibling;//?
 	int firstChild;//?
};
typedef struct HIDCollectionNode HIDCollectionNode, * HIDCollectionNodePtr;

typedef int HIDUsage;//?
typedef int HIDReportType;//?
typedef int HIDPreparsedDataRef;//?

#endif//HYS_IOKIT_HIDSYSTEM_IOHIDDESCRIPTORPARSER_H
