#ifndef HYS_IOKIT_HIDSYSTEM_IOHIKEYBOARDMAPPER_H
#define HYS_IOKIT_HIDSYSTEM_IOHIKEYBOARDMAPPER_H


#define EVK_KEYUP(a, b) //?
#define EVK_IS_KEYDOWN(a, b) b//?
#define EVK_KEYDOWN(a,b) //?

#define EVK_BITS_SHIFT 1//?
#define EVK_BITS_MASK 2//?
#define kNUM_SHIFTS_TO_ACTIVATE 3//?
#define kDEFAULT_SHIFTEXPIREINTERVAL 4//?
#define kMAX_MODIFIERS 5//?
#define EVK_BITS_PER_UNIT 6//?

enum {
	kState_Disabled_Flag,//?
	kState_On,//?
	kState_ShiftActivates_Flag,//?
	kModifier_DidPerformModifiy,//?
	kModifier_DidKeyUp,//?
	kModifier_Locked,//?
	kState_On_ModifiersDown,//?
};

struct StickyKeys_ToggleInfo {
	int toggleModifier;//?
	int repetitionsToToggle;//?
	AbsoluteTime expireInterval;//c
	int currentCount;//?
	int size;//?
 	AbsoluteTime deadlines[1];//?
};
typedef struct StickyKeys_ToggleInfo StickyKeys_ToggleInfo;

struct StickyKeys_ModifierInfo {
	int state;//?
 	int key;//?
	int leftModBit;//?
};
typedef struct StickyKeys_ModifierInfo StickyKeys_ModifierInfo;

typedef UInt32* kbdBitVector;//c

class  IOHIKeyboardMapper_HYS
{
  OSDeclareDefaultStructors(IOHIKeyboardMapper_HYS);

public://data

struct ExpansionData {
	IOTimerEventSource * ejectTimerEventSource;//c
	int f12Eject_State;//?
	int eject_Delay_MS;//?
	int slowKeys_State;//?
	int slowKeys_Delay_MS;//?
	IOTimerEventSource* slowKeysTimerEventSource;//c
	int specialKeyModifierFlags;//?
	int supportsF12Eject;//?
	kbdBitVector cached_KeyBits;//c
	unsigned char* cachedAlphaLockModDefs;//c
	int modifierSwap_Modifiers[1];//?
	OSDictionary* offFnParamDict;//c
	IOInterruptEventSource  *stickyKeysMouseClickEventSource;//c
	IOInterruptEventSource* stickyKeysSetFnStateEventSource;//c
	OSDictionary* onFnParamDict;//c
	StickyKeys_ModifierInfo stickyKeys_StuckModifiers[1];//?
	int slowKeys_Current_Key;//?
	int slowKeys_Aborted_Key;//?
};

IOHIKeyboard *_delegate;//c
NXParsedKeyMapping _parsedMapping;//c
ExpansionData * _reserved;//c
IOHIDSystem* _hidSystem;//c
int _stickyKeys_NumModifiersDown;//c
StickyKeys_ToggleInfo * _stickyKeys_ShiftToggle;//c
StickyKeys_ToggleInfo *  _stickyKeys_OptionToggle;//c
OSDictionary* _onParamDict;//c
OSDictionary* _offParamDict;//c

int slowKeys_Current_Key;//?
int _mappingShouldBeFreed;//?
int _stateDirty;//?
int _stickyKeys_State;//?

public:	//define

#define IOHIKeyboardMapper_message \
IOReturn message( UInt32 a, IOService *b, void *c = 0 );//?

#define IOHIKeyboardMapper_slowKeysPostProcess \
static void slowKeysPostProcess (IOHIKeyboardMapper *a, IOTimerEventSource *b);//c

#define IOHIKeyboardMapper_performF12Eject \
static void performF12Eject(IOHIKeyboardMapper *a, IOTimerEventSource *b);//c

#define IOHIKeyboardMapper_keyEventPostProcess \
void 	    keyEventPostProcess (void);//?

#define IOHIKeyboardMapper_stickyKeysSetFnState \
static void stickyKeysSetFnState(IOHIKeyboardMapper *a, IOEventSource *b);//c

#define IOHIKeyboardMapper_stickyKeysMouseUp \
static void stickyKeysMouseUp(IOHIKeyboardMapper *a, IOEventSource *b);//c

#define IOHIKeyboardMapper_stickyKeysModifierKey \
bool stickyKeysModifierKey (UInt8 a, bool b, kbdBitVector c);//c

#define IOHIKeyboardMapper_stickyKeysNonModifierKey \
void stickyKeysNonModifierKey (UInt8 a, bool b, kbdBitVector c, bool d = 0);//?

#define IOHIKeyboardMapper_stickyKeysModifierToggleCheck \
bool stickyKeysModifierToggleCheck(StickyKeys_ToggleInfo *a, UInt8 b, bool c, kbdBitVector d, bool e = 0);//?

#define IOHIKeyboardMapper_postKeyboardSpecialEvent \
void postKeyboardSpecialEvent (unsigned a, unsigned b=0);//?

#define IOHIKeyboardMapper_stickyKeysAllocToggleInfo \
static StickyKeys_ToggleInfo * stickyKeysAllocToggleInfo (unsigned a);//?

#define IOHIKeyboardMapper_stickyKeysFreeToggleInfo \
static void stickyKeysFreeToggleInfo (StickyKeys_ToggleInfo * a);//c

#define IOHIKeyboardMapper_createParamDicts \
bool createParamDicts (void);//c

#define IOHIKeyboardMapper_setParamProperties \
IOReturn  	setParamProperties (OSDictionary *a);//?

#define IOHIKeyboardMapper_updateProperties \
bool 	    updateProperties (void);//?

#define IOHIKeyboardMapper_makeNumberParamProperty \
static void makeNumberParamProperty( OSDictionary *a, const char *b, unsigned long long c, unsigned int d );//?

#define IOHIKeyboardMapper_setKeyboardTarget \
void	setKeyboardTarget (IOService *a);//?

#define IOHIKeyboardMapper_calcModBit \
void calcModBit(int a, kbdBitVector b);//?

#define IOHIKeyboardMapper_getParsedSpecialKey \
UInt8  getParsedSpecialKey(UInt8 a);//?

#define IOHIKeyboardMapper_doCharGen \
void doCharGen(int a, bool b);//?

#define IOHIKeyboardMapper_doModCalc \
void doModCalc(int a, kbdBitVector b);//?

#define IOHIKeyboardMapper_rawTranslateKeyCode \
void rawTranslateKeyCode (UInt8 a, bool b, kbdBitVector c);//c

#define IOHIKeyboardMapper_modifierSwapFilterKey \
bool modifierSwapFilterKey(UInt8 *a);//c

#define IOHIKeyboardMapper_mapping \
const UInt8 *   mapping();//?

#define IOHIKeyboardMapper_stickyKeysfree \
void stickyKeysfree (void);//c

#define IOHIKeyboardMapper_serialize \
bool  serialize(OSSerialize *a) const;//?

#define IOHIKeyboardMapper_translateKeyCode \
void translateKeyCode(UInt8 a, bool b, kbdBitVector c);//?

#define IOHIKeyboardMapper_mappingLength \
UInt32  mappingLength();//?

#define IOHIKeyboardMapper_free \
void free();//?

#define IOHIKeyboardMapper_stickyKeysinit \
bool stickyKeysinit (void);//c

#define IOHIKeyboardMapper_parseKeyMapping \
bool parseKeyMapping(const UInt8 *a, UInt32 b, NXParsedKeyMapping *c) const;//?

#define IOHIKeyboardMapper_init \
bool init(IOHIKeyboard *a, const UInt8 *b, UInt32 c,	bool d);//?

#define IOHIKeyboardMapper_keyboardMapper \
static IOHIKeyboardMapper * keyboardMapper(IOHIKeyboard *a, const UInt8 *b, UInt32 c, bool d);//?

#define IOHIKeyboardMapper_stickyKeysCleanup \
void stickyKeysCleanup();//c

#define IOHIKeyboardMapper_slowKeysFilterKey \
bool slowKeysFilterKey (UInt8 a, bool b, kbdBitVector c);//?

#define IOHIKeyboardMapper_f12EjectFilterKey \
bool f12EjectFilterKey (UInt8 a, bool b, kbdBitVector c);//c

#define IOHIKeyboardMapper_stickyKeysFilterKey \
bool stickyKeysFilterKey (UInt8 a, bool b, kbdBitVector c, bool d = 0);//?

public://func

};

#endif//HYS_IOKIT_HIDSYSTEM_IOHIKEYBOARDMAPPER_H

