#ifndef HYS_IOKIT_HIDSYSTEM_IOHIPOINTING_H
#define HYS_IOKIT_HIDSYSTEM_IOHIPOINTING_H

#define EV_DEFAULTPOINTERACCELLEVEL 1//?
#define EV_DEFAULTSCROLLACCELLEVEL 2//?

typedef void (*RelativePointerEventAction)(OSObject *a,int b, int c, int d, AbsoluteTime e);//c

typedef void (*AbsolutePointerEventAction)(OSObject *a, int b, Point *c, Bounds *d, bool e, int f, int g, AbsoluteTime h);//c

typedef void (*ScrollWheelEventAction)(OSObject *a, short b, short c, short d, AbsoluteTime e);//c

typedef void (*RelativePointerEventCallback)(OSObject *a, int b, int c, int d, AbsoluteTime e, OSObject *f, void *g);//c

typedef void (*AbsolutePointerEventCallback)(OSObject *a, int b, Point *c, Bounds *d, bool e, int f, int g, AbsoluteTime h,  OSObject *i,  void *j);//c

typedef void (*ScrollWheelEventCallback)(OSObject *a, short b, short c, short d, IOFixed e, IOFixed f, IOFixed g, SInt32  h, SInt32 i, SInt32 j, SInt32 k, AbsoluteTime l, OSObject *m, void *    n );//c


class  IOHIPointing_HYS
{
    OSDeclareDefaultStructors(IOHIPointing_HYS);

public://data

struct ExpansionData {
	int accelerateMode;//?
	IOHIDPointingDevice* hidPointingNub;//c
	ScrollAccelInfo * scrollWheelInfo;//c
	int isSeized;//?
	ScrollAccelInfo* scrollPointerInfo;//c
	int scrollButtonMask;//?
	IOService* openClient;//c
	int scrollZoomMask;//?
	int scrollType;//?
	int scrollOff;//?
	IOFixed scrollFixedDeltaAxis1;//c
	IOFixed scrollFixedDeltaAxis2;//c
	IOFixed scrollFixedDeltaAxis3;//c
	SInt32 scrollPointDeltaAxis1;//c
	SInt32 scrollPointDeltaAxis2;//c
	SInt32 scrollPointDeltaAxis3;//c
};
ExpansionData* _reserved;//c
IOGPoint _previousLocation;//c
int _buttonMode;//c
IOLock*  _deviceLock;//c
OSObject* _relativePointerEventTarget;//c
RelativePointerEventAction _relativePointerEventAction;//c
OSObject* _absolutePointerEventTarget;//c
AbsolutePointerEventAction _absolutePointerEventAction;//c
OSObject* _scrollWheelEventTarget;//c
ScrollWheelEventAction _scrollWheelEventAction;//c
void*  _scaleSegments;//c
IOItemCount _scaleSegCount;//c
IOFixed _fractX;//c
IOFixed _fractY;//c

int _pressureThresholdToClick;//?
int _acceleration;//?
int _convertAbsoluteToRelative;//?
int _contactToMove;//?
int _hadContact;//?

public://define

#define IOHIPointing_copyScrollAccelerationTable \
OSData * copyScrollAccelerationTable();//c

#define IOHIPointing_setParamProperties \
IOReturn  setParamProperties( OSDictionary * a );//?

#define IOHIPointing_dispatchScrollWheelEventWithAccelInfo \
void dispatchScrollWheelEventWithAccelInfo(SInt32 a, SInt32 b, SInt32 c, ScrollAccelInfo *d, AbsoluteTime e);//?

#define IOHIPointing_resetScroll \
bool 	resetScroll();//c

#define IOHIPointing_updateProperties \
bool 	    updateProperties( void );//?

#define IOHIPointing_copyScrollAccelerationTableForType \
OSData *  copyScrollAccelerationTableForType(SInt32 a=0);//?

#define IOHIPointing_scrollResolutionForType \
IOFixed	scrollResolutionForType(SInt32 a=0);//?

#define IOHIPointing_resetPointer \
bool resetPointer();//?

#define IOHIPointing_scrollReportRate \
IOFixed   scrollReportRate();//c

#define IOHIPointing_setupScrollForAcceleration \
void 	setupScrollForAcceleration(IOFixed a);//c

#define IOHIPointing_setupForAcceleration \
void setupForAcceleration(IOFixed a);//?

#define IOHIPointing_scalePointer \
void scalePointer(int *a, int *b);//?

#define IOHIPointing_hidKind \
IOHIDKind hidKind();

#define IOHIPointing_powerStateDidChangeTo \
IOReturn  powerStateDidChangeTo( IOPMPowerFlags a, unsigned long b, IOService * c);//?

#define IOHIPointing_powerStateWillChangeTo \
IOReturn  powerStateWillChangeTo( IOPMPowerFlags a, unsigned long b, IOService *c);//?

#define IOHIPointing_message \
IOReturn message( UInt32 a, IOService *b, void *c= 0 );//?

#define IOHIPointing_close \
void close(IOService *a, IOOptionBits b );//?

#define IOHIPointing__scrollWheelEvent \
static void _scrollWheelEvent(IOHIPointing *a, short b, short c, short d, AbsoluteTime e);//c

#define IOHIPointing__absolutePointerEvent \
static void _absolutePointerEvent(IOHIPointing *a, int b, IOGPoint *c, IOGBounds *d, bool e, int f, int g, AbsoluteTime h);//?

#define IOHIPointing__relativePointerEvent \
static void _relativePointerEvent( IOHIPointing *a, int b, int c, int d, AbsoluteTime e);//?

#define IOHIPointing_resolution \
IOFixed     resolution();//?

#define IOHIPointing_buttonCount \
IOItemCount buttonCount();//?

#define IOHIPointing_open_void \
bool open(IOService *a, IOOptionBits b, void *c, RelativePointerEventCallback d, AbsolutePointerEventCallback	e, ScrollWheelEventCallback f);//?

#define IOHIPointing_free \
void free();//?

#define IOHIPointing_start \
bool start(IOService *a);

#define IOHIPointing_init \
bool init(OSDictionary *a = 0);//?

#define IOHIPointing_dispatchRelativePointerEvent \
void dispatchRelativePointerEvent(int a, int b, UInt32 c,  AbsoluteTime d);//?

#define IOHIPointing_copyAccelerationTable \
OSData *    copyAccelerationTable();//?

#define IOHIPointing_open \
bool open(IOService *a, IOOptionBits b, RelativePointerEventAction c, AbsolutePointerEventAction d, ScrollWheelEventAction e);//?

#define IOHIPointing_getPointingMode \
UInt32  getPointingMode ();//c

#define IOHIPointing_setPointingMode \
void    setPointingMode(UInt32 a);//c

#define IOHIPointing_dispatchAbsolutePointerEvent \
void dispatchAbsolutePointerEvent(IOGPoint *a, IOGBounds *b, UInt32 c, bool d, int e, int f, int g, int h, AbsoluteTime i);//?

#define IOHIPointing_dispatchScrollWheelEvent \
void dispatchScrollWheelEvent(short a, short b, short c, AbsoluteTime d);//?

public://func
};

#endif//HYS_IOKIT_HIDSYSTEM_IOHIPOINTING_H

