#ifndef HYS_IOKIT_PCCARD_IOPCCARDBRIDGE_H
#define HYS_IOKIT_PCCARD_IOPCCARDBRIDGE_H

#define kIOPCCardVersionOneMatchKey "kIOPCCardVersionOneMatchKey"//?
#define kIOPCCardVendorIDMatchKey "kIOPCCardVendorIDMatchKey"//?
#define kIOPCCardDeviceIDMatchKey "kIOPCCardDeviceIDMatchKey"//?
#define kIOPCCardFunctionIDMatchKey "kIOPCCardFunctionIDMatchKey"//?
#define kIOPCCardFunctionNameMatchKey "kIOPCCardFunctionNameMatchKey"//?
#define kIOPCCardFunctionExtensionMatchKey "kIOPCCardFunctionExtensionMatchKey"//?
#define kIOPCCardMemoryDeviceNameMatchKey "kIOPCCardMemoryDeviceNameMatchKey"//?

#define kIOPCCardCSEventMessage 1//?
#define kCSGateProbeBridge 2//?
#define kCSGateTimerCallout 3//?
#define kCSGateSetBridgePower 4//?
#define kIOPCCardBridgeRegCount 5//?

struct interrupt_handler {
    	int (*top_handler)(int);//c
	int socket;//?
	struct interrupt_handler * next;//c
 	int irq;//?
   	 int (*bottom_handler)(int);//c
	int (*enable_functional)(int);//c
    	int (*disable_functional)(int);//c
	const char* name;//c
   	 IOInterruptEventSource *interruptSource;//c
};
typedef struct interrupt_handler  interrupt_handler_t;

extern IOWorkLoop *		gIOPCCardWorkLoop;//c
extern void *			gCardServicesGate;//c

class  IOPCCardBridge_HYS
{
    OSDeclareDefaultStructors(IOPCCardBridge_HYS)

public://data

IOPCIDevice *bridgeDevice;//c
IOPCCardInterruptController * interruptController;//c
OSSymbol * 		 interruptControllerName;//c
IOInterruptEventSource * interruptSource;//c
IOMemoryMap *	 cardBusRegisterMap;//c
interrupt_handler_t * interruptHandlers;//c

int bridgeConfig[1];//?
int pciExpansionChassis;//?
int bridgeStateSaved;//?

public:

#define IOPCCardBridge_requestCardEjection \
static int			requestCardEjection(IOService * a);//c

#define IOPCCardBridge_getWorkLoop \
IOWorkLoop *	getWorkLoop() const;//?

#define IOPCCardBridge_unconfigureSocket \
int			unconfigureSocket(IOService * a);//?

#define IOPCCardBridge_configureSocket \
int			configureSocket(IOService * a, config_req_t *b);//?

#define IOPCCardBridge_restoreBridgeState \
void		restoreBridgeState(void);//?

#define IOPCCardBridge_saveBridgeState \
void		saveBridgeState(void);//?

#define IOPCCardBridge_setPowerState \
IOReturn		setPowerState(unsigned long a, IOService *b);//?

#define IOPCCardBridge_addCSCInterruptHandler \
bool 	addCSCInterruptHandler(unsigned int a, unsigned int b,  int (*c)(int), int (*d)(int),  int (*e)(int), int (*f)(int), const char *g);//?

#define IOPCCardBridge_createCardBusNub \
IOCardBusDevice *	createCardBusNub(UInt8 a, UInt8 b);//?

#define IOPCCardBridge_setBridgePowerState \
IOReturn		setBridgePowerState(unsigned long a, IOService *b);//?

#define IOPCCardBridge_createPCCard16Nub \
IOPCCard16Device *	createPCCard16Nub(UInt8 a, UInt8 b);//?

#define IOPCCardBridge_releaseBridgeRanges \
static bool			releaseBridgeRanges(IOService * a);//c

#define IOPCCardBridge_publishCardBusNub \
bool	   	publishCardBusNub(IOCardBusDevice *a, UInt32 b, UInt32 c);//?

#define IOPCCardBridge_publishPCCard16Nub \
bool	   	publishPCCard16Nub(IOPCCard16Device *a, UInt32 b, UInt32 c);//?

#define IOPCCardBridge_cardEventHandler \
static int cardEventHandler(cs_event_t a, int b, event_callback_args_t *c);//c

#define IOPCCardBridge_cardRemovalHandler \
static void			cardRemovalHandler(u_long a);//c

#define IOPCCardBridge_interruptDispatcher \
void		interruptDispatcher(void);//?

#define IOPCCardBridge_addNubInterruptProperties \
void           	addNubInterruptProperties(OSDictionary * a);//?

#define IOPCCardBridge_constructCardBusProperties \
OSDictionary *	constructCardBusProperties(IOPCIAddressSpace a);//?

#define IOPCCardBridge_constructPCCard16Properties \
OSDictionary *	constructPCCard16Properties(IOPCCard16Device * a);//?

#define IOPCCardBridge_initializeDriverServices \
bool 		initializeDriverServices(void);//?

#define IOPCCardBridge_initializeSocketServices \
bool 		initializeSocketServices(void);//?

#define IOPCCardBridge_configureInterruptController \
bool 		configureInterruptController(void);//?

#define IOPCCardBridge_configureBridgeRanges \
bool 		configureBridgeRanges(void);//?

#define IOPCCardBridge_getConfigurationSettings \
bool 		getConfigurationSettings(void);//?

#define IOPCCardBridge_getOFConfigurationSettings \
bool		getOFConfigurationSettings(OSArray **a, OSArray **b);//?

#define IOPCCardBridge_getModuleParameters \
bool 		getModuleParameters(void);//?

#define IOPCCardBridge_getNubResources \
IOReturn		getNubResources(IOService * a);//?

#define IOPCCardBridge_probeBus \
void		probeBus(IOService *a, UInt8 b);//?

#define IOPCCardBridge_lastBusNum \
UInt8		lastBusNum(void);//?

#define IOPCCardBridge_constructCardBusCISProperties \
void           	constructCardBusCISProperties(IOCardBusDevice * a);//?

#define IOPCCardBridge_firstBusNum \
UInt8		firstBusNum(void);//?

#define IOPCCardBridge_free \
void		free();//?

#define IOPCCardBridge_cardServicesGate \
static int cardServicesGate(IOService *a, void *b, void *c, void *d, void *e);//c

#define IOPCCardBridge_metaInit \
static  void metaInit(void);//c

#define IOPCCardBridge_removeCSCInterruptHandler \
bool		removeCSCInterruptHandler(unsigned int a);//?

#define IOPCCardBridge_probe \
IOService *		probe(IOService * a, SInt32 *b);//?

#define IOPCCardBridge_start \
bool		start(IOService * a);//?

#define IOPCCardBridge_configure \
bool		configure(IOService *a);//?

#define IOPCCardBridge_stop \
void		stop(IOService * a);//?

};

class  IOPCCardInterruptController_HYS
{
    OSDeclareDefaultStructors(IOPCCardInterruptController_HYS);

public://data

interrupt_handler_t* interruptHandlers;//c
IOPCIDevice* bridgeDevice;//c

int pendingEvents;//?

public://define

#define IOPCCardInterruptController_getInterruptType \
IOReturn		getInterruptType(int a, int * b);//?

#define IOPCCardInterruptController_causeVector \
void		causeVector(long a, IOInterruptVector * b);//?

#define  IOPCCardInterruptController_enableVector \
void		enableVector(long a, IOInterruptVector * b);//?

#define IOPCCardInterruptController_getVectorType \
int			getVectorType(long a, IOInterruptVector *b);//?

#define IOPCCardInterruptController_vectorCanBeShared \
bool		vectorCanBeShared(long a, IOInterruptVector * b);//?

#define IOPCCardInterruptController_disableVectorHard \
void		disableVectorHard(long a, IOInterruptVector *b);//?

#define IOPCCardInterruptController_handleInterrupt \
IOReturn		handleInterrupt(void * a, IOService * b, int c);//?

#define IOPCCardInterruptController_updateCSCInterruptHandlers \
bool		updateCSCInterruptHandlers(interrupt_handler_t * a);//?

#define IOPCCardInterruptController_getInterruptHandlerAddress \
IOInterruptAction	getInterruptHandlerAddress(void);//?

#define IOPCCardInterruptController_initInterruptController \
IOReturn		initInterruptController(IOService * a);//?

};

#endif//HYS_IOKIT_PCCARD_IOPCCARDBRIDGE_H

