#ifndef HYS_IOKIT_PCCARD_BULKMEM_H
#define HYS_IOKIT_PCCARD_BULKMEM_H

#define MTD_WAITREQ 1//?
#define MTD_WAITTIMER 2//?
#define MTD_WAITRDY 3//?
#define MTD_REQ_TIMEOUT 4//?
#define MTD_WAITPOWER 5//?
#define MTD_REQ_ERASE 6//?
#define ERASE_PASSED 7//?
#define ERASE_MEDIA_WRPROT 8//?
#define ERASE_BAD_OFFSET 9//?
#define ERASE_BAD_SIZE 10//?
#define ERASE_BAD_SOCKET 11//?
#define ERASE_FAILED 12//?
#define MTD_REQ_KERNEL 13//?
#define REGION_TYPE_AM 14//?
#define MEM_OP_BUFFER_KERNEL 15//?
#define ERASE_QUEUED 16//?
#define MEMORY_TYPE_AM 17//?
#define MTD_REQ_READ 18//?
#define MTD_REQ_WRITE 19//?

enum {
	MTDRequestWindow,//?
	MTDReleaseWindow,//?
	MTDModifyWindow,//?
	MTDSetVpp,//?
	MTDRDYMask,//?
};

struct eraseq_entry_t {
	int Size;//?
	int Offset;//?
	memory_handle_t  Handle;//c
	int State;//?
};
typedef struct eraseq_entry_t eraseq_entry_t;

struct region_info_t {
	int CardOffset;//?
	int RegionSize;//?
	int BlockSize;//?
	int Attributes;//?
	int AccessSpeed;//?
	int JedecMfr;//?
	int JedecInfo;//?
	int PartMultiple;//?
	 memory_handle_t	next;//c
};
typedef struct region_info_t region_info_t;

struct mtd_reg_t {
	int Attributes;//?
	int Offset;//?
	int MediaID;//?
};
typedef struct mtd_reg_t mtd_reg_t;

struct eraseq_hdr_t {
	int QueueEntryCnt;//c
	eraseq_entry_t	* QueueEntryArray;//c
};
typedef struct eraseq_hdr_t eraseq_hdr_t;

struct open_mem_t {
	int Attributes;//?
	int Offset;//?
};
typedef struct open_mem_t open_mem_t;

struct mem_op_t {
	int Offset;//?
	int Count;//?
	int Attributes;//?
};
typedef struct mem_op_t mem_op_t;

struct copy_op_t {};
typedef struct copy_op_t copy_op_t;

struct mtd_request_t {
	int Status;//?
	int Timeout;//?
	int Function;//?
	int TransferLength;//?
	int DestCardOffset;//?
	int MediaID;//?
	int SrcCardOffset;//?
};
typedef struct mtd_request_t mtd_request_t;

struct mtd_vpp_req_t {
	int Vpp1;//?
	int Vpp2;//?
};
typedef struct mtd_vpp_req_t mtd_vpp_req_t;

struct mtd_mod_win_t {
	int Attributes;//?
	int AccessSpeed;//?
	int CardOffset;//?
};
typedef struct mtd_mod_win_t mtd_mod_win_t;

struct mtd_rdy_req_t {
	int Mask;//?
};
typedef struct mtd_rdy_req_t mtd_rdy_req_t;

#endif//HYS_IOKIT_PCCARD_BULKMEM_H
