#ifndef HYS_IOKIT_PCCARD_CISTPL_H
#define HYS_IOKIT_PCCARD_CISTPL_H

#define CISTPL_POWER_VNOM 0//c

#define CISTPL_DEVICE_A 1//?
#define CISTPL_FUNCE 2//?
#define CISTPL_FUNCE_SERIAL_IF 3//?
#define CISTPL_FUNCE_SERIAL_CAP 4//?
#define CISTPL_FUNCE_SERIAL_IF_DATA 5//?
#define CISTPL_FUNCE_SERIAL_CAP_DATA 6//?
#define CISTPL_FUNCE_SERIAL_SERV_DATA 7//?
#define CISTPL_FUNCE_SERIAL_IF_FAX 8//?
#define CISTPL_FUNCE_SERIAL_CAP_FAX 9//?
#define CISTPL_FUNCE_SERIAL_SERV_FAX 10//?
#define CISTPL_FUNCE_SERIAL_IF_VOICE 11//?
#define CISTPL_FUNCE_SERIAL_CAP_VOICE 12//?
#define CISTPL_FUNCE_SERIAL_SERV_VOICE 13//?
#define CISTPL_DEVICE 14//?
#define CISTPL_JEDEC_A 15//?
#define CISTPL_JEDEC_C 16//?
#define CISTPL_DEVICE_GEO_A 17//?
#define CISTPL_DEVICE_GEO 18//?
#define CISTPL_DTYPE_NULL 19//?
#define CISTPL_MAX_CIS_SIZE 20//?
#define TUPLE_RETURN_COMMON 21//?
#define CISTPL_LONGLINK_MFC 22//?
#define CISTPL_LINKTARGET 23//?
#define CISTPL_MFC_ATTR 24//?
#define CISTPL_END 25//?
#define CISTPL_NULL 26//?
#define CISTPL_LONGLINK_A 26//?
#define CISTPL_LONGLINK_C 27//?
#define CISTPL_INDIRECT 28//?
#define CISTPL_NO_LINK 29//?
#define TUPLE_RETURN_LINK 30//?
#define RETURN_FIRST_TUPLE 31//?
#define CISTPL_MAX_DEVICES 32//?
#define CISTPL_VERS_1_MAX_PROD_STRINGS 33//?
#define CISTPL_MAX_ALTSTR_STRINGS 34//?
#define CISTPL_POWER_HIGHZ_OK 35//?
#define CISTPL_POWER_HIGHZ_REQ 36//?
#define CISTPL_IO_LINES_MASK 37//?
#define CISTPL_CFTABLE_DEFAULT 38//?
#define CISTPL_CFTABLE_BVDS 39//?
#define CISTPL_CFTABLE_WP 40//?
#define CISTPL_CFTABLE_RDYBSY 41//?
#define CISTPL_CFTABLE_MWAIT 42//?
#define CISTPL_CFTABLE_IF_PRESENT 43//?
#define CISTPL_BAR 44//?
#define CISTPL_CONFIG_CB 45//?
#define CISTPL_CFTABLE_ENTRY_CB 46//?
#define CISTPL_CHECKSUM 47//?
#define CISTPL_VERS_1 48//?
#define CISTPL_ALTSTR 49//?
#define CISTPL_MANFID 50//?
#define CISTPL_FUNCID 51//
#define CISTPL_CONFIG 52//?
#define CISTPL_CFTABLE_ENTRY 53//?
#define CISTPL_VERS_2 54//?
#define CISTPL_ORG 55//?
#define CISTPL_FORMAT 56//?
#define CISTPL_FORMAT_A 57//?
#define CISTPL_FUNCID_INVALID 58//?
#define CISTPL_FUNCID_MAX_ID 59//?
#define CISTPL_FUNCID_VENDOR 60//?
#define CISTPL_FUNCID_MEMORY 61//?
#define CISTPL_MEM_MAX_WIN 62//?
#define CISTPL_CFTABLE_AUDIO 63//?
#define CISTPL_IO_8BIT 64//?
#define CISTPL_IO_16BIT 65//?

struct tuple_t{
	int DesiredTuple;//?
	int Attributes;//?
	cisdata_t	* TupleData;//c
	int TupleDataMax;//?
	int TupleOffset;//?
	int TupleLink;//?
	int Flags;//?
	int CISOffset;//?
	int LinkOffset;//?
	int TupleCode;//?
	int TupleDataLen;//?
};
typedef struct tuple_t  tuple_t;

struct cisparse_t_funce{
	int type;//?
};

struct cistpl_device_t {
	int ndev;//?
	struct {
		int type;//?
		int size;//?
		int speed;//?
		int wp;//?
	}dev[1];//?
};
typedef struct cistpl_device_t cistpl_device_t;

struct cistpl_bar_t {
	int attr;//?
	int size;//?
};
typedef struct cistpl_bar_t cistpl_bar_t;

struct cistpl_power_t {
	int present;//?
	int flags;//?
 	int param[0];//?
};
typedef struct cistpl_power_t cistpl_power_t;

struct cistpl_irq_t {
	int IRQInfo1;//?
	int IRQInfo2;//?
};
typedef struct cistpl_irq_t cistpl_irq_t;

struct cistpl_cftable_entry_cb_t {
	int index;//?
	int flags;//?
	cistpl_power_t vcc;//c	
	cistpl_power_t vpp1;//c
	cistpl_power_t vpp2;//c
	int io;//?
	cistpl_irq_t irq;//c
	int mem;//?
	int subtuples;//?
};
typedef struct cistpl_cftable_entry_cb_t cistpl_cftable_entry_cb_t;

struct cistpl_config_t {
	int last_idx;//?
	int base;//?
	int rmask[0];//?
	int subtuples;//?
};
typedef struct cistpl_config_t cistpl_config_t;

struct cistpl_checksum_t {
 	int addr;//?
	int len;//?
	int sum;//?
};
typedef struct cistpl_checksum_t cistpl_checksum_t;


struct cisinfo_t {
	int Chains;//?
};
typedef struct cisinfo_t cisinfo_t;

struct cisdump_t {
	int Length;//?
	int Data[1];//?
};
typedef struct cisdump_t cisdump_t;

struct cistpl_jedec_t {
	int nid;//?
	struct {
		int mfr;//?
		int info;//?
	}id[1];//?
};
typedef struct cistpl_jedec_t cistpl_jedec_t;

struct cistpl_device_geo_t {
	int ngeo;//?
	struct {
		int buswidth;//?
		int erase_block;//?
		int interleave;//?
		int partition;//?
		int read_block;//?
		int write_block;//?
	} geo[1];//?
};
typedef struct cistpl_device_geo_t cistpl_device_geo_t;

struct cistpl_longlink_t {
	int addr;//?
};
typedef struct cistpl_longlink_t cistpl_longlink_t;

struct cistpl_longlink_mfc_t {
	int nfn;//?
	struct {
		int space;//?
		int addr;//?
	} fn[1];//?
};
typedef struct cistpl_longlink_mfc_t cistpl_longlink_mfc_t;

struct cistpl_vers_1_t {
	int major;//?
	int minor;//?
	char str[1];//?
	u_char ofs[1];//?
	u_char ns;//c
};
typedef struct cistpl_vers_1_t cistpl_vers_1_t;

struct cistpl_altstr_t {
	char str[1];//?
	u_char ofs[1];//?
	u_char ns;//c
};
typedef struct cistpl_altstr_t cistpl_altstr_t;

struct cistpl_manfid_t {
	int manf;//?
	int card;//?
};
typedef struct cistpl_manfid_t cistpl_manfid_t;

struct cistpl_funcid_t {
	int func;//?
	int sysinit;//?
};
typedef struct cistpl_funcid_t cistpl_funcid_t;

struct cistpl_funce_t {
	int type;//?
	int data[0];//?
};
typedef struct cistpl_funce_t cistpl_funce_t;

struct cistpl_timing_t {
	int wait;//?
	int waitscale;//?
	int ready;//?
	int rdyscale;//?
	int reserved;//?
	int rsvscale;//?
};
typedef struct cistpl_timing_t cistpl_timing_t;

struct cistpl_io_t {
	int flags;//?
	int nwin;//?
	struct {
		int base;//?
 		int len;//?
	} win [0];//?
};
typedef struct cistpl_io_t cistpl_io_t;

struct cistpl_mem_t {
	int nwin;//?
	int flags;//?
	struct {
		int len;//?
		int card_addr;//?
		int host_addr;//?
	} win [0];//?
};
typedef struct cistpl_mem_t cistpl_mem_t;

struct cistpl_cftable_entry_t {
	int index;//?
	int flags;//?
	int interface;//?
	cistpl_power_t vcc;//c
	cistpl_power_t vpp1;//c
	cistpl_power_t vpp2;//c
 	cistpl_timing_t	timing;//c
	cistpl_io_t io;//c
	cistpl_irq_t irq;//c
	cistpl_mem_t mem;//c
	int subtuples;//?
};
typedef struct cistpl_cftable_entry_t cistpl_cftable_entry_t;

struct cistpl_vers_2_t {
	int vers;//?
	int comply;//?
	int dindex;//?
	int vspec8;//?
	int vspec9;//?
	int nhdr;//?
	char str[0];//?
	u_char vendor;//c
};
typedef struct cistpl_vers_2_t cistpl_vers_2_t;

struct cistpl_org_t {
	int data_org;//?
 	char desc[0];//?
};
typedef struct cistpl_org_t cistpl_org_t;

struct cistpl_format_t {
	int type;//?
	int edc;//?
	int offset;//?
	int length;//?
};
typedef struct cistpl_format_t cistpl_format_t;

union  cisparse_t{
	cistpl_device_t device;//c
	cistpl_bar_t	bar;//c
	cistpl_cftable_entry_cb_t cftable_entry_cb;//c
	cistpl_config_t config;//c
	cistpl_checksum_t checksum;//c
	cistpl_longlink_t longlink;//c
	cistpl_longlink_mfc_t longlink_mfc;//c
	cistpl_vers_1_t version_1;//c
	cistpl_altstr_t altstr;//c
	cistpl_jedec_t jedec;//c
	cistpl_manfid_t manfid;//c
	cistpl_funcid_t funcid;//c
    	cistpl_funce_t funce;//c
	cistpl_cftable_entry_t	 cftable_entry;//c
	cistpl_device_geo_t device_geo;//c
	cistpl_vers_2_t	 vers_2;//c
	cistpl_org_t	 org;//c
 	cistpl_format_t format;//c
};
typedef union cisparse_t cisparse_t;

#endif//HYS_IOKIT_PCCARD_CISTPL_H
