#ifndef HYS_IOKIT_PCCARD_K_COMPAT_H
#define HYS_IOKIT_PCCARD_K_COMPAT_H


#define kmalloc(a, b) kern_os_malloc(a)//c
#define ioremap(a, b)	IOPCCardIORemap(a, b)//c
#define MODULE_PARM(a,b)//c
#define MODULE_AUTHOR(a)//c
#define MODULE_DESCRIPTION(a)//c
#define __init//c
#define MOD_DEC_USE_COUNT//c
#define MOD_INC_USE_COUNT//c
#define ACQUIRE_RESOURCE_LOCK //c
#define RELEASE_RESOURCE_LOCK//c
#define printk IOLog//c
#define krealloc(a, b, c) kern_os_realloc(a, b)//c
#define add_timer(a)	IOPCCardAddTimer(a)//c
#define kfree(a) kern_os_free(a)//c

#define KERN_NOTICE "KERN_NOTICE"//?
#define KERN_INFO "KERN_INFO"//?

#define jiffies 0//?
#define PCI_BASE_ADDRESS_SPACE_IO 1//?
#define PCI_BASE_ADDRESS_SPACE_MEMORY 2//?
#define PCI_BASE_ADDRESS_MEM_PREFETCH 3//?
#define PCI_BASE_ADDRESS_0 4//?
#define PCI_BASE_ADDRESS_MEM_MASK 5//?
#define PCI_COMMAND 6//?
#define PCI_COMMAND_MEMORY 7//?
#define PCI_DEVICE_ID 8//?
#define PCI_VENDOR_ID 9//?
#define PCI_HEADER_TYPE 10//?
#define PCI_BASE_ADDRESS_SPACE 11//?
#define PCI_BASE_ADDRESS_IO_MASK 12//?
#define PCI_INTERRUPT_PIN 13//?
#define PCI_COMMAND_MASTER 14//?
#define PCI_COMMAND_IO 15//?
#define PCI_CACHE_LINE_SIZE 16//?
#define PCI_LATENCY_TIMER 17//?
#define PCI_INTERRUPT_LINE 18//?
#define NR_IRQS 19//?
#define PCI_COMMAND_WAIT 20//?
#define PCI_CLASS_REVISION 21//?
#define PCI_CLASS_BRIDGE_CARDBUS 22//?
#define DEV_PRESENT 23//?
#define DEV_SUSPEND 24//?
#define DEV_CONFIG_PENDING 25//?
#define DEV_CONFIG 26//?

struct timer_list {
	int data;//?
        void (*function)(unsigned long);//c
	int expires;//?
};

typedef unsigned int	u32;//c
typedef unsigned char	u8;//c

//function
void *kern_os_malloc(size_t a);//c


__BEGIN_DECLS

void *IOPCCardIORemap(u_long a, u_long b);//c
IOCardBusDevice *IOPCCardCreateCardBusNub(IOPCCardBridge *a, unsigned int b, unsigned int c);//c

void IOPCCardAddTimer(struct timer_list * a);//c

__END_DECLS

int init_pcmcia_cs(void);//c
void *kern_os_realloc(void * a, size_t b);//c
int init_i82365(IOPCCardBridge *a, IOPCIDevice *b, IOVirtualAddress c);//c
void kern_os_free(void * a);//c

#endif//HYS_IOKIT_PCCARD_K_COMPAT_H
