#ifndef HYS_IOKIT_PCI_IOPCIBRIDGE_H
#define HYS_IOKIT_PCI_IOPCIBRIDGE_H

#define kIOPCIBridgeRegs 1//?

enum {
	kIOPCIResourceTypeMemory ,//?
	kIOPCIResourceTypePrefetchMemory,//?
	kIOPCIResourceTypeIO,//?
	kIOPCIResourceTypeBusNumber,//?
	kIOPCIResourceTypeCount,//?
};

typedef uint64_t IOPCIScalar;//c

struct IOPCIRange {
	struct IOPCIRange * next;//c
	IOPCIScalar start;//c
	IOPCIScalar  size;//c
	int alignment;//?
	int type;//?
	int flags;//?
	struct IOPCIRange *subRange;//c
	struct IOPCIRange *nextSubRange;//c
};

class IOPCIBridge_HYS
{
  //  OSDeclareAbstractStructors(IOPCIBridge_HYS)

public://data


IORangeAllocator * bridgeMemoryRanges;//c
IORangeAllocator* bridgeIORanges;//c

public://define

#define IOPCIBridge_probeBus \
void probeBus( IOService * a, UInt8 b);//?

#define IOPCIBridge_initialize \
static void initialize(void);//c

#define IOPCIBridge_setDevicePowerState \
IOReturn setDevicePowerState( IOPCIDevice *a, unsigned long b);//?

#define IOPCIBridge_configWrite32 \
void configWrite32( IOPCIAddressSpace a, UInt8 b, UInt32 c) ;//?

#define IOPCIBridge_start \
bool start( IOService * a);//?

#define IOPCIBridge_firstBusNum \
UInt8 firstBusNum( void );//?

#define IOPCIBridge_free \
void free( void );//?

#define IOPCIBridge_stop \
void stop( IOService * a);//?

#define IOPCIBridge_saveDeviceState \
IOReturn saveDeviceState( IOPCIDevice * a, IOOptionBits b = 0 );//?

#define IOPCIBridge__restoreDeviceState \
IOReturn _restoreDeviceState( IOPCIDevice * a, IOOptionBits b);//?

#define IOPCIBridge_restoreMachineState \
IOReturn restoreMachineState( IOOptionBits  a= 0);//c

#define IOPCIBridge_restoreDeviceState \
virtual IOReturn restoreDeviceState( IOPCIDevice *a, IOOptionBits b = 0 );//c

#define IOPCIBridge_configure \
virtual bool configure( IOService * a);//c

#define IOPCIBridge_compareAddressCell \
static SInt32 compareAddressCell( UInt32 a, UInt32 b[], UInt32 c[] );//c

#define IOPCIBridge_nvLocation \
static void nvLocation( IORegistryEntry *a, UInt8 *b, UInt8 *c, UInt8 *d);//c

#define IOPCIBridge_spaceFromProperties \
virtual void spaceFromProperties( OSDictionary * a, IOPCIAddressSpace * b);//c

#define IOPCIBridge_findMatching \
IORegistryEntry * findMatching( OSIterator * a, IOPCIAddressSpace b);//c

#define IOPCIBridge_checkProperties \
bool checkProperties( IOPCIDevice * a);//c

#define IOPCIBridge_constructProperties \
virtual OSDictionary * constructProperties( IOPCIAddressSpace a);//c

#define IOPCIBridge_configRead32 \
virtual UInt32 configRead32( IOPCIAddressSpace a, UInt8 b ) = 0;//c

#define IOPCIBridge_createNub \
virtual IOPCIDevice * createNub( OSDictionary * a);//c

#define IOPCIBridge_initializeNub \
virtual bool initializeNub( IOPCIDevice * a, OSDictionary * b);//c

#define IOPCIBridge_removeDevice \
void removeDevice( IOPCIDevice * a, IOOptionBits b = 0 );//c

#define IOPCIBridge_publishNub \
virtual bool publishNub( IOPCIDevice * a, UInt32 b);//c

#define IOPCIBridge_lastBusNum \
virtual UInt8 lastBusNum( void );//x

#define IOPCIBridge_addBridgeMemoryRange \
virtual bool addBridgeMemoryRange( IOPhysicalAddress a, IOPhysicalLength b, bool c);//c

#define IOPCIBridge_addBridgePrefetchableMemoryRange \
virtual bool addBridgePrefetchableMemoryRange( IOPhysicalAddress a, IOPhysicalLength b, bool c);//c

#define IOPCIBridge_addBridgeIORange \
virtual bool addBridgeIORange( IOByteCount a, IOByteCount b);//c

#define IOPCIBridge_constructRange \
virtual bool constructRange( IOPCIAddressSpace *a, IOPhysicalAddress b, IOPhysicalLength c, OSArray *d );//c

#define IOPCIBridge_getDTNubAddressing \
virtual IOReturn getDTNubAddressing( IOPCIDevice *a );//c

#define IOPCIBridge_getNubAddressing \
virtual IOReturn getNubAddressing( IOPCIDevice *a );//c

#define IOPCIBridge_isDTNub \
virtual bool isDTNub( IOPCIDevice * a);//c

#define IOPCIBridge_getNubResources \
virtual IOReturn getNubResources( IOService * a);//c

#define IOPCIBridge_resolveMSIInterrupts \
IOReturn resolveMSIInterrupts   ( IOService * a, IOPCIDevice * b);//c

#define IOPCIBridge_resolveLegacyInterrupts \
IOReturn resolveLegacyInterrupts( IOService * a, IOPCIDevice *b);//c

#define IOPCIBridge_matchKeys \
virtual bool matchKeys( IOPCIDevice * a, const char * b, UInt32 c, UInt8 d);//c

#define IOPCIBridge_pciMatchNub \
virtual bool pciMatchNub( IOPCIDevice * a, OSDictionary *b, SInt32 *c);//c

#define IOPCIBridge_matchNubWithPropertyTable \
virtual bool matchNubWithPropertyTable( IOService *a, OSDictionary *b, SInt32 *c);//c

#define IOPCIBridge_compareNubName \
virtual bool compareNubName( const IOService * a, OSString * b, OSString ** c= 0 ) const;//c

#define IOPCIBridge_findPCICapability \
virtual UInt32 findPCICapability( IOPCIAddressSpace a, UInt8 b, UInt8 * c = 0);//c

#define IOPCIBridge_extendedFindPCICapability \
virtual UInt32 extendedFindPCICapability( IOPCIAddressSpace a, UInt32 b, IOByteCount *c = 0 );//c

#define IOPCIBridge_createAGPSpace \
virtual IOReturn createAGPSpace( IOAGPDevice *a, IOOptionBits b, IOPhysicalAddress *c, IOPhysicalLength *d);//c

#define IOPCIBridge_destroyAGPSpace \
virtual IOReturn destroyAGPSpace( IOAGPDevice *a);//c

#define IOPCIBridge_getAGPRangeAllocator \
virtual IORangeAllocator * getAGPRangeAllocator( IOAGPDevice * a);//c

#define IOPCIBridge_getAGPStatus \
virtual IOOptionBits getAGPStatus( IOAGPDevice *a, IOOptionBits b = 0 );//c

#define IOPCIBridge_commitAGPMemory \
virtual IOReturn commitAGPMemory( IOAGPDevice *a, IOMemoryDescriptor *b, IOByteCount c,  IOOptionBits d);//c

#define IOPCIBridge_releaseAGPMemory \
virtual IOReturn releaseAGPMemory(  IOAGPDevice *a,	IOMemoryDescriptor *b, IOByteCount c, IOOptionBits d);//c

#define IOPCIBridge_resetAGPDevice \
virtual IOReturn resetAGPDevice( IOAGPDevice *a, IOOptionBits b = 0 );//c

#define IOPCIBridge_getAGPSpace \
virtual IOReturn getAGPSpace( IOAGPDevice *a, IOPhysicalAddress *b,IOPhysicalLength *c);//c

public://func

IOPCIAddressSpace getBridgeSpace();//?
IODeviceMemory *  ioDeviceMemory();//?
int configRead16( IOPCIAddressSpace a,int b);//?
int configWrite16(IOPCIAddressSpace a,int b,int c);//?
int configRead8(IOPCIAddressSpace a,int b);//?
int configWrite8(IOPCIAddressSpace a,int b,int c);//?

};

class  IOPCI2PCIBridge_HYS
{
    OSDeclareDefaultStructors(IOPCI2PCIBridge_HYS)

public://data

IOPCIDevice * bridgeDevice;//c

int bridgeState[1];//?

public://define

#define IOPCI2PCIBridge_saveBridgeState \
virtual void saveBridgeState( void );//c

#define IOPCI2PCIBridge_restoreBridgeState \
virtual void restoreBridgeState( void );//c

#define IOPCI2PCIBridge_configRead32 \
virtual UInt32 configRead32( IOPCIAddressSpace a, UInt8 b);//c

#define IOPCI2PCIBridge_ioDeviceMemory \
virtual IODeviceMemory * ioDeviceMemory( void );//c

#define IOPCI2PCIBridge_probe \
virtual IOService * probe(	IOService *a, SInt32 *b );//c

#define IOPCI2PCIBridge_serializeProperties \
virtual bool serializeProperties( OSSerialize * a ) const;//c

#define IOPCI2PCIBridge_filterInterrupt \
bool filterInterrupt( IOFilterInterruptEventSource * a);//c

#define IOPCI2PCIBridge_handleInterrupt \
void handleInterrupt( IOInterruptEventSource *a,  int b);//c

#define IOPCI2PCIBridge_probeBus \
virtual void probeBus( IOService * a, UInt8 b);//c

#define IOPCI2PCIBridge_start \
virtual bool start( IOService * a);//c

#define IOPCI2PCIBridge_configure \
virtual bool configure( IOService * a);//c

#define IOPCI2PCIBridge_requestProbe \
virtual IOReturn requestProbe( IOOptionBits a);//c

#define IOPCI2PCIBridge_setPowerState \
IOReturn setPowerState( unsigned long a, IOService * b);//c

#define IOPCI2PCIBridge_stop  \
virtual void stop( IOService * a);//c

#define IOPCI2PCIBridge_free \
virtual void free();//'c

#define IOPCI2PCIBridge_firstBusNum \
virtual UInt8 firstBusNum( void );//c

#define IOPCI2PCIBridge_lastBusNum \
virtual UInt8 lastBusNum( void );//c

#define IOPCI2PCIBridge_getBridgeSpace \
virtual IOPCIAddressSpace getBridgeSpace( void );//c

#define IOPCI2PCIBridge_configWrite32 \
virtual void configWrite32( IOPCIAddressSpace a, UInt8 b, UInt32 c );//c

#define IOPCI2PCIBridge_configRead16 \
virtual UInt16 configRead16( IOPCIAddressSpace a, UInt8 b);//c

#define IOPCI2PCIBridge_configWrite16 \
virtual void configWrite16( IOPCIAddressSpace a, UInt8 b, UInt16 c);//c

#define IOPCI2PCIBridge_configRead8 \
virtual UInt8 configRead8( IOPCIAddressSpace a, UInt8 b);//c

#define IOPCI2PCIBridge_configWrite8 \
virtual void configWrite8( IOPCIAddressSpace a, UInt8 b, UInt8 c );//c

#define  IOPCI2PCIBridge_publishNub \
virtual bool publishNub( IOPCIDevice * a, UInt32 b);//c

public://func


};

#endif//HYS_IOKIT_PCI_IOPCIBRIDGE_H


