#ifndef HYS_IOKIT_PCI_IOPCICONFIGURATOR_H
#define HYS_IOKIT_PCI_IOPCICONFIGURATOR_H

#define FOREACH_CHILD(a,b) for(pci_dev_t (b) = (a)->b; (b); (b) = (b)->peer)//c
#define BRIDGE_RANGE_NUM(a)      ((a) + kIOPCIRangeBridgeMemory)//c

#define PCI_ADDRESS_TUPLE(a)   \
        a->space.s.busNum,     \
        a->space.s.deviceNum,  \
        a->space.s.functionNum//c

#define kPCIBridgeMaxCount 1//?
#define kPCIBridgeMemoryAlignment 2//?
#define kPCIBridgeIOAlignment 3//?
#define kPCIBridgeBusNumberAlignment 4//?

enum {
	kPCI2PCISecondaryLT,//?
	kPCI2PCIBridgeControl,//?
	kPCI2PCIPrefetchUpperLimit,//?
	kPCI2PCIPrefetchUpperBase,//?
	kPCI2PCIUpperIORange,//?
	kIOPCIRangeBAR1,//?
	kIOPCIRangeBAR5,//?
	kIOPCIRangeBAR0,//?
	kPCIHeaderType0,//?
	kIOPCIRangeBridgeBusNumber,//?
	kIOPCIRangeBridgePFMemory,//?
	kIOPCIRangeBridgeMemory,//?
	kPCIDeviceStateConfigurationDone,//?
	kIOPCIRangeBridgeIO,//?
	kIOPCIRangeFlagMaximizeSize,//?
	kPCIDeviceStateResourceAssigned,//?
	kPCI2PCIPrimaryBus,//?
	kPCIDeviceStateBIOSConfig,//?
	kPCIHeaderType1,//?
	kPCIHeaderType2,//?
	kPCIStatic,//?
	kPCILinkChange,//?
	kPCIHotPlug,//?
	kIOPCIConfiguratorEnable,//?
	kIOPCIConfiguratorReset,//?
	kPCI2PCISecondaryBus,//?
	kPCI2PCIMemoryRange,//?
	kPCI2PCIPrefetchMemoryRange,//?
	kPCI2PCIIORange,//?
	kPCI2PCISubordinateBus,//?
	kIOPCIConfiguratorAllocate,//?
	kIOPCIConfiguratorIOLog,//?
	kIOPCIConfiguratorKPrintf,//?
	kPCIDeviceStateResourceWait,//?
	kIOPCIRangeCount,//?
	kIOPCIRangeExpansionROM,//?
};

struct pci_dev {
	int supportsHotPlug;//?
	struct pci_dev * child;//c
	struct pci_dev * peer;//c
	int secBusNum;//?
	IOPCIRange  ranges[1];//?
	IOPCIAddressSpace space;//c
	IORegistryEntry *dtNub;//c
	int subBusNum;//?
 	int isBridge;//?
	int deviceState;//?
	IORegistryEntry* acpiDevice;//c
	int headerType;//?
	int classCode;//?
	int isHostBridge;//?
};
typedef struct pci_dev * pci_dev_t;

class  IOPCIConfigurator_HYS
{
    OSDeclareDefaultStructors( IOPCIConfigurator_HYS );

public://data

IOPCIBridge * fRootBridge;//c
int fBridgeConfigCount;//c
int fDeviceConfigCount;//c
int fYentaConfigCount;//c
int fPCIBridgeIndex;//c
int fPCIBridgeTailIndex;//c

pci_dev_t   fPCIBridgeList[1];//?
int fFlags;//?
int fCacheLineSize;//?

public://define

#define IOPCIConfigurator_pciBridgeProbeBusRange \
void    pciBridgeProbeBusRange( pci_dev_t a);//c

#define IOPCIConfigurator_pciSafeProbeBaseAddressRegister  \
void    pciSafeProbeBaseAddressRegister( pci_dev_t a, UInt32 b);//c

#define IOPCIConfigurator_pciProbeBaseAddressRegister \
void    pciProbeBaseAddressRegister( pci_dev_t a, UInt32 b);//c

#define IOPCIConfigurator_safeProbeCallback \
static void safeProbeCallback( void * a );//c

#define IOPCIConfigurator_pciCheckCacheLineSize \
void    pciCheckCacheLineSize( pci_dev_t a);//c

#define IOPCIConfigurator_pciYentaProbeRanges \
void    pciYentaProbeRanges( pci_dev_t a);//c

#define IOPCIConfigurator_pciBridgeProbeRanges \
void    pciBridgeProbeRanges( pci_dev_t a);//c

#define IOPCIConfigurator_pciBridgeAddChild \
void    pciBridgeAddChild( pci_dev_t a, pci_dev_t b);//c

#define IOPCIConfigurator_configRead8 \
virtual UInt8   configRead8(  IOPCIAddressSpace a, UInt32 b);//c

#define IOPCIConfigurator_pciWriteLatencyTimer \
void    pciWriteLatencyTimer( pci_dev_t a);//c

#define IOPCIConfigurator_pciBridgeApplyConfiguration \
void    pciBridgeApplyConfiguration( pci_dev_t a);//c

#define IOPCIConfigurator_pciDeviceApplyConfiguration \
void    pciDeviceApplyConfiguration( pci_dev_t a);//c

#define IOPCIConfigurator_pciRestoreAccess \
void    pciRestoreAccess( pci_dev_t a, UInt16 b);//c

#define IOPCIConfigurator_configWrite16 \
virtual void    configWrite16( IOPCIAddressSpace a, UInt32 b, UInt16 c);//c

#define IOPCIConfigurator_configRead16 \
virtual UInt16  configRead16( IOPCIAddressSpace a, UInt32 b);//c

#define IOPCIConfigurator_pciDisableAccess \
UInt16  pciDisableAccess( pci_dev_t a);//c

#define IOPCIConfigurator_pciApplyConfiguration \
void    pciApplyConfiguration( pci_dev_t a);//c

#define IOPCIConfigurator_pciBridgeClipRanges \
void    pciBridgeClipRanges( IOPCIRange *a, IOPCIScalar b, IOPCIScalar c );//c

#define IOPCIConfigurator_pciDeviceProbeRanges \
void    pciDeviceProbeRanges( pci_dev_t a);//c

#define IOPCIConfigurator_pciBridgeDistributeResourceType \
void    pciBridgeDistributeResourceType( pci_dev_t a, UInt32 b);//c

#define IOPCIConfigurator_pciRangeAppendSubRange \
void    pciRangeAppendSubRange( IOPCIRange * a, IOPCIRange * b);//c

#define IOPCIConfigurator_configWrite8 \
virtual void    configWrite8(  IOPCIAddressSpace a, UInt32 b, UInt8 c);//c

#define IOPCIConfigurator_configWrite32 \
virtual void    configWrite32( IOPCIAddressSpace a, UInt32 b, UInt32 c);//c

#define IOPCIConfigurator_pciBridgeProbeChild \
void    pciBridgeProbeChild( pci_dev_t a, IOPCIAddressSpace b );//c

#define IOPCIConfigurator_pciBridgeConnectDeviceTree \
void    pciBridgeConnectDeviceTree( pci_dev_t a);//c

#define IOPCIConfigurator_matchACPIEntry \
static void matchACPIEntry( IORegistryEntry * a, void *b);//c

#define IOPCIConfigurator_matchDTEntry \
static void matchDTEntry( IORegistryEntry * a, void *b);//c

#define IOPCIConfigurator_configRead32 \
virtual UInt32  configRead32( IOPCIAddressSpace a, UInt32 b);//c

#define IOPCIConfigurator_constructProperties \
OSDictionary * constructProperties( pci_dev_t a);//c

#define IOPCIConfigurator_constructAddressingProperties \
void    constructAddressingProperties( pci_dev_t a, OSDictionary * b);//c

#define IOPCIConfigurator_pciBridgeConstructDeviceTree \
void    pciBridgeConstructDeviceTree( pci_dev_t a);//c

#define IOPCIConfigurator_pciBridgeDistributeResource \
void    pciBridgeDistributeResource( pci_dev_t a);//c

#define IOPCIConfigurator_pciBridgeAllocateResource \
void    pciBridgeAllocateResource( pci_dev_t a);//c

#define IOPCIConfigurator_pciBridgeCheckConfiguration \
void    pciBridgeCheckConfiguration( pci_dev_t a);//c

#define IOPCIConfigurator_pciBridgeScanBus \
void    pciBridgeScanBus( pci_dev_t a, UInt8 b, UInt8 *c, UInt8 d);//c

#define IOPCIConfigurator_free \
virtual void    free( void );//c

#define IOPCIConfigurator_checkPCIConfiguration \
void    checkPCIConfiguration( void );//c

#define  IOPCIConfigurator_createRoot \
virtual bool    createRoot( IOService * a);//c

#define IOPCIConfigurator_start \
virtual bool    start( IOService * a );//c

};

#endif//HYS_IOKIT_PCI_IOPCICONFIGURATOR_H
