#ifndef HYS_IOKIT_PCI_IOPCIDEVICE_H
#define HYS_IOKIT_PCI_IOPCIDEVICE_H

#define kIOPMPCIConfigSpaceVolatileKey "kIOPMPCIConfigSpaceVolatileKey"//?
#define kIOPCIExpressLinkStatusKey "kIOPCIExpressLinkStatusKey"//?
#define kIOPCIExpressLinkCapabilitiesKey "kIOPCIExpressLinkCapabilitiesKey"//?
#define kIOPCIMatchKey "kIOPCIMatchKey"//?
#define kIOPCIPrimaryMatchKey "kIOPCIPrimaryMatchKey"//c
#define kIOPCISecondaryMatchKey "kIOPCISecondaryMatchKey"//?
#define kIOPCIClassMatchKey "kIOPCIClassMatchKey"//?

enum {
	kPCIPMCPMESupportFromD2,//?
	kPCIPMCSPowerStateD2,//?
	kPCIPMCPMESupportFromD1,//?
	kPCIPMCSPowerStateD1,//?
	kPCIPMCSPMEEnable,//?
	kPCIPMCPMESupportFromD3Hot,//?
	kPCIPMCSPMEStatus,//?
	kPCIPMCSPowerStateD0,//?
	kPCIPMCSPowerStateMask,//?
	kIOPCIDeviceDozeState,//?
	kIOPCIConfigCapabilitiesPtr,//?
	kIOPCIStatusCapabilities,//?
	kIOPCIConfigHeaderType,//?
	kIOPCI64BitMemorySpace,//?
	kIOPCIMSICapability,//?
	kIOPCIConfigExpansionROMBase,//?
	kIOPCIPCIExpressCapability,//?
	kIOPCIConfigSubSystemVendorID,//?
	kIOPCIDeviceOffState,//?
	kIOPCIDeviceOnState,//?
	kIOPCIConfigClassCode,//?
	kIOPCI32BitMemorySpace,//?
	kIOInterruptTypePCIMessaged,//?
	kIOPCIConfigBaseAddress0,//?
	kIOPCIConfigCommand,//?
	kIOPCICommandIOSpace,//?
	kIOPCICommandBusMaster,//?
	kIOPCICommandMemWrInvalidate,//?
	kIOPCICommandParityError,//?
	kIOPCICommandSERR,//?
	kIOPCICommandMemorySpace,//?
	kPCIPMCPMESupportFromD3Cold,//?
	kPCIPMCSPowerStateD3,//?
	kIOPCIConfigVendorID,//?
	kIOPCIConfigRevisionID,//?
	kIOPCIConfigInterruptLine,//?
	kPCIPMCD3Support,//?
	kIOPCIConfigBaseAddress1,//?
	kIOPCIPowerManagementCapability,//?
	kIOPCIConfigBaseAddress2,//?
	kIOPCIConfigBaseAddress3,//?
	kIOPCILDTCapability,//?
	kIOPCIConfigCacheLineSize,//?
	kIOPCIConfigDeviceID,//?
	kIOPCIConfigBaseAddress5,//?
	kIOPCIIOSpace,//?
	kIOPCIAGPCapability,//?
	kIOPCIConfigLatencyTimer,//?
	kIOPCIDevicePowerStateCount,//?
};

union  IOPCIAddressSpace{
	int bits;//?

	struct {
		int deviceNum;//?
		int space;//?
		int busNum;//?
		int functionNum;//?
		int registerNum;//?
		int prefetch;//?
		int t;//?
		int reloc;//?
	}s;

	struct {
		int registerNumExtended;//?
		int busNum;//?
		int deviceNum;//?
		int functionNum;//?
	}es;

};

struct  IOPCIPhysicalAddress{
	IOPCIAddressSpace physHi;//c
	int physMid;//?
	int physLo;//?
	int lengthHi;//?
	int lengthLo;//?
};//c

class IOPCIDevice_HYS
{
    OSDeclareDefaultStructors(IOPCIDevice_HYS)

public://data

IOPCIAddressSpace space;//c
UInt32 * savedConfig;//c
IOPCIBridge * parent;//c
IOMemoryMap * ioMap;//c

public://define

#define IOPCIDevice_attach \
virtual bool attach( IOService * a);//c

#define IOPCIDevice_detach \
virtual void detach( IOService * a);//c

#define IOPCIDevice_init \
virtual bool init( OSDictionary * a);//c

#define IOPCIDevice_init_IORegistryEntry \
virtual bool init( IORegistryEntry *a,	 const IORegistryPlane * b );//c

#define IOPCIDevice_free \
virtual void free();//c

#define IOPCIDevice_setPowerState \
virtual IOReturn setPowerState( unsigned long a,  IOService * b);//c

#define IOPCIDevice_matchPropertyTable \
virtual bool matchPropertyTable( OSDictionary *a, SInt32  *b);//c

#define IOPCIDevice_compareName \
virtual bool compareName( OSString *a, OSString ** b = 0 ) const;//c

#define IOPCIDevice_getResources \
virtual IOReturn getResources( void );//c

#define IOPCIDevice_configRead32 \
virtual UInt32 configRead32( IOPCIAddressSpace a, UInt8 b);//c

#define IOPCIDevice_configWrite32 \
virtual void configWrite32( IOPCIAddressSpace a, UInt8 b, UInt32 c);//c

#define IOPCIDevice_configRead16 \
virtual UInt16 configRead16( IOPCIAddressSpace a, UInt8 b);//c

#define IOPCIDevice_configWrite16 \
virtual void configWrite16( IOPCIAddressSpace a, UInt8 b, UInt16 c);//c

#define IOPCIDevice_configRead8 \
virtual UInt8 configRead8( IOPCIAddressSpace a, UInt8 b);//c

#define IOPCIDevice_configWrite8 \
virtual void configWrite8( IOPCIAddressSpace a, UInt8 b, UInt8 c);//c

#define IOPCIDevice_setProperties \
virtual IOReturn setProperties(OSObject * a);//c

#define IOPCIDevice_saveDeviceState \
virtual IOReturn saveDeviceState( IOOptionBits a = 0 );//c

#define IOPCIDevice_restoreDeviceState \
virtual IOReturn restoreDeviceState( IOOptionBits a = 0 );//c

#define IOPCIDevice_matchLocation \
virtual IOService * matchLocation( IOService * a);//c

public://function


};

#endif//HYS_IOKIT_PCI_IOPCIDEVICE_H



