#ifndef HYS_IOKIT_PPC_IODBDMA_H
#define HYS_IOKIT_PPC_IODBDMA_H

#define	IOSetDBDMAChannelControlBits(mask)	( ((mask) | (mask) << 16) )//c

#define IOGetDBDMAChannelRegister(registerSetPtr, field)	OSReadSwapInt32(registerSetPtr,offsetof(IODBDMAChannelRegisters, field))//c
#define IOSetCCResult(descPtr,resultValue)		IOSetDBDMADescriptor(descPtr,result,resultValue)//c

#define IOMakeDBDMADescriptorDep(descPtr,cmd,key,interrupt,branch,wait,count,addr,dep) \
do {									       \
    IOSetDBDMADescriptor(descPtr, address, addr);			       \
    IOSetDBDMADescriptor(descPtr, cmdDep, dep);				       \
    IOSetDBDMADescriptor(descPtr, result, 0);				       \
    eieio();								       \
    IOSetDBDMADescriptor(descPtr, operation,				       \
        IOMakeDBDMAOperation(cmd, key, interrupt, branch, wait, count));       \
    eieio();								       \
} while(0)//c

#define IOGetDBDMAChannelStatus(registerSetPtr)			IOGetDBDMAChannelRegister(registerSetPtr,channelStatus)//c
	
#define IOSetDBDMAChannelRegister(registerSetPtr,field,value) OSWriteSwapInt32(registerSetPtr,offsetof(IODBDMAChannelRegisters,field),value)//c

#define IOSetDBDMABranchSelect(registerSetPtr,braSelValue)		\
do {									\
    IOSetDBDMAChannelRegister(registerSetPtr,branchSelect,braSelValue);	\
    eieio();								\
} while(0)//c

#define IOSetDBDMACommandPtr(registerSetPtr,cclPtr)			\
do {									\
    IOSetDBDMAChannelRegister(registerSetPtr,commandPtrHi,0);		\
    eieio();								\
    IOSetDBDMAChannelRegister(registerSetPtr,commandPtrLo,cclPtr);	\
    eieio();								\
} while(0)//c

#define IOSetDBDMAInterruptSelect(registerSetPtr,intSelValue)		   \
do {									   \
    IOSetDBDMAChannelRegister(registerSetPtr,interruptSelect,intSelValue); \
    eieio();								   \
} while(0)//c

#define IOSetDBDMAWaitSelect(registerSetPtr,waitSelValue)		\
do {									\
    IOSetDBDMAChannelRegister(registerSetPtr,waitSelect,waitSelValue);	\
    eieio();								\
} while(0)//c

#define IOGetDBDMAWaitSelect(registerSetPtr)				IOGetDBDMAChannelRegister(registerSetPtr,waitSelect)//c

#define IOSetDBDMAChannelControl(registerSetPtr,ctlValue)		\
do {									\
    eieio();								\
    IOSetDBDMAChannelRegister(registerSetPtr,channelControl,ctlValue);	\
    eieio();								\
} while(0)//c

#define IOGetDBDMABranchSelect(registerSetPtr)			IOGetDBDMAChannelRegister(registerSetPtr,branchSelect)//c
	
#define IOSetDBDMADescriptor(descPtr,field,value)		OSWriteSwapInt32( descPtr, offsetof( IODBDMADescriptor, field), value)//c

#define	IOMakeDBDMAOperation(cmd,key,interrupt,branch,wait,count)	\
    ( ((cmd) << 28) | ((key) << 24) | ((interrupt) << 20)		\
      | ((branch) << 18) | ( (wait) << 16) | (count) )//c
	  
#define IOMakeDBDMADescriptor(descPtr,cmd,key,interrupt,branch,wait,count,addr)\
do {									       \
    IOSetDBDMADescriptor(descPtr, address, addr);			       \
    IOSetDBDMADescriptor(descPtr, cmdDep,  0);				       \
    IOSetDBDMADescriptor(descPtr, result,  0);				       \
    eieio();								       \
    IOSetDBDMADescriptor(descPtr, operation,				       \
        IOMakeDBDMAOperation(cmd,key,interrupt,branch,wait,count));	       \
    eieio();								       \
} while(0)//c
	  
#define IOGetDBDMADescriptor(descPtr,field)	OSReadSwapInt32( descPtr, offsetof( IODBDMADescriptor, field))//c
#define IOGetCCAddress(descPtr)				IOGetDBDMADescriptor(descPtr,address)//c
#define IOGetCCOperation(descPtr)			IOGetDBDMADescriptor(descPtr,operation)//c
#define IOGetCCResult(descPtr)					IOGetDBDMADescriptor(descPtr,result)//c
#define IOGetDBDMACommandPtr(registerSetPtr)				IOGetDBDMAChannelRegister(registerSetPtr,commandPtrLo)//c
#define IOGetDBDMAInterruptSelect(registerSetPtr)		        IOGetDBDMAChannelRegister(registerSetPtr,interruptSelect)//c
#define	IOClearDBDMAChannelControlBits(mask)	( (mask) << 16)//c

//////////////////////
enum {
	kdbdmaActive,//?
	kdbdmaS7,//?
	kdbdmaRun,//?
	kdbdmaWake,//?
	kdbdmaNop,//?
	kdbdmaIntNever,//?
	kdbdmaKeyStream0,//?
	kdbdmaWaitNever,//?
	kdbdmaStop,//?
	kdbdmaInputMore,//?
	kdbdmaOutputMore,//?
	kdbdmaWaitIfTrue,//?
	kdbdmaIntAlways,//?
	kdbdmaOutputLast,//?
	kdbdmaInputLast,//?
	kdbdmaBranchNever,//?
	kdbdmaS0,//?
	kdbdmaBranchAlways,//?
	kdbdmaDead,//?
	kdbdmaBranchIfTrue,//?
	kdbdmaPause,//?
};
enum {
	kdbdmaResCountMask	= 0x0000FFFF,//c
	kdbdmaReqCountMask	= 0x0000FFFF,//c
	kdbdmaStatusRun		= kdbdmaRun << 16,//c
	kdbdmaStatusActive	= kdbdmaActive << 16,//c
	kdbdmaStatusDead	= kdbdmaDead << 16,//c
};
	
/////////////////////////////

struct IODBDMADescriptor {
	unsigned long            operation;   
	unsigned long            address;
	volatile unsigned long   cmdDep;
	volatile unsigned long   result;    
};//c
typedef struct IODBDMADescriptor IODBDMADescriptor;

struct IODBDMAChannelRegisters {
    volatile unsigned long 	channelControl;
    volatile unsigned long 	channelStatus;
    volatile unsigned long 	commandPtrHi;	
    volatile unsigned long 	commandPtrLo;
    volatile unsigned long 	interruptSelect;
    volatile unsigned long 	branchSelect;	
    volatile unsigned long 	waitSelect;		
    volatile unsigned long 	transferModes;	
    volatile unsigned long 	data2PtrHi;		
    volatile unsigned long 	data2PtrLo;		
    volatile unsigned long 	reserved1;
    volatile unsigned long 	addressHi;		
    volatile unsigned long 	reserved2[4];
    volatile unsigned long 	unimplemented[16];
    volatile unsigned long 	undefined[32];
};//c
typedef struct IODBDMAChannelRegisters IODBDMAChannelRegisters;


//func

extern void	IODBDMAFlush( volatile IODBDMAChannelRegisters *registerSetPtr);//c
extern void	IODBDMAPause( volatile IODBDMAChannelRegisters *registerSetPtr);//c
extern void	IODBDMAContinue( volatile IODBDMAChannelRegisters *registerSetPtr);//c
extern void	IODBDMAStop( volatile IODBDMAChannelRegisters *registerSetPtr);//c
extern void	IODBDMAStart( volatile IODBDMAChannelRegisters *registerSetPtr, volatile IODBDMADescriptor *physicalDescPtr);//c
extern void	IODBDMAReset( volatile IODBDMAChannelRegisters *registerSetPtr);//c

#endif//HYS_IOKIT_PPC_IODBDMA_H
