#ifndef HYS_IOKIT_SBP2_IOFIREWIRESBP2LOGIN_H
#define HYS_IOKIT_SBP2_IOFIREWIRESBP2LOGIN_H

#define kIOMessageFWSBP2ReconnectFailed 1//? 
#define kIOMessageFWSBP2ReconnectComplete 2//?

enum {
	kFWSBP2ExclusiveLogin,//?
	kFWSBP2DontSynchronizeMgmtAgent,//?
	kFWSBP2UnsolicitedStatus,//?
	kFWSBP2NormalCommandStatus,//?
	kFWSBP2NormalCommandReset,//?
	kFWSBP2NormalCommandTimeout,//?
};

class  IOFireWireSBP2Login_HYS
{
    OSDeclareDefaultStructors( IOFireWireSBP2Login_HYS)

public://data

enum {
	kLoginStateIdle,//?
	kLoginStateLoggingIn,//?
	kLoginStateConnected,//?
	kLoginStateLoggingOut,//?
	kFWSBP2RequestComplete,//?
	kFWSBP2NoSense,//?
	kLoginStateReconnect,//?
	kLoginStateTerminated,//?
	kFWSBP2UnspecifiedError,//?
};

struct FWSBP2LoginORB {
	int loginResponseAddressHi;//?
	int loginResponseAddressLo;//?
	int loginResponseLength;//?
	int lun;//?
	int statusFIFOAddressHi;//?
	int statusFIFOAddressLo;//?
	int password[1];//?
	int passwordLength;//?
	int options;//?
};
typedef struct FWSBP2LoginORB FWSBP2LoginORB;

struct FWSBP2ReconnectORB {
	int options;//?
	int statusFIFOAddressHi;//?
	int statusFIFOAddressLo;//?
	int loginID;//?
};
typedef struct FWSBP2ReconnectORB FWSBP2ReconnectORB;

struct FWSBP2LogoutORB {
	int options;//?
	int statusFIFOAddressHi;//?
	int statusFIFOAddressLo;//?
	int loginID;//?
};
typedef struct FWSBP2LogoutORB FWSBP2LogoutORB;

IOFireWireSBP2LUN *  fLUN;//c
IOFireWireSBP2Target *  fTarget;//c
IOFireWireUnit * fUnit;//c
IOFireWireController *fControl;//c
FWAddress fSetBusyTimeoutAddress;//c
FWAddress fLastORBAddress;//c
IOCommandGate *fGate;//c
OSSet * fORBSet;//c
OSIterator *fORBSetIterator;//c
IOFWAddressSpace *fLoginORBAddressSpace;//c
FWAddress fLoginORBAddress;//c
FWSBP2LoginResponse fLoginResponse;//c
FWAddress fLoginResponseAddress;//c
IOFWAddressSpace *fLoginResponseAddressSpace;//c
IOFWAddressSpace *fReconnectORBAddressSpace;//c
FWAddress fReconnectORBAddress;//c
IOFWAddressSpace *fStatusBlockAddressSpace;//c
FWAddress fStatusBlockAddress;//c
FWAddress fReconnectStatusBlockAddress;//c
IOFWAddressSpace *fReconnectStatusBlockAddressSpace;//c
IOFWAddressSpace *fLogoutORBAddressSpace;//c
FWAddress fLogoutORBAddress;//c
FWSBP2LoginORB fLoginORB;//c
FWSBP2ReconnectORB fReconnectORB;//c
FWSBP2LogoutORB fLogoutORB;//c
IOMemoryDescriptor * fLoginWriteCommandMemory;//c
IOFWWriteCommand * fLoginWriteCommand;//c
IOFWCommand *fLoginTimeoutCommand;//c
IOFWDelayCommand * fLoginRetryTimeoutCommand;//c
IOFWDelayCommand * fReconnectRetryTimeoutCommand;//c
IOMemoryDescriptor *fReconnectWriteCommandMemory;//c
IOFWWriteCommand *fReconnectWriteCommand;//c
IOFWDelayCommand * fReconnectTimeoutCommand;//c
IOMemoryDescriptor *	fLogoutWriteCommandMemory;//c
IOFWWriteCommand *fLogoutWriteCommand;//c
IOFWCommand *	 fLogoutTimeoutCommand;//c
IOFWDelayCommand * fFetchAgentRetryTimerCommand;//c
IOMemoryDescriptor * fFetchAgentWriteCommandMemory;//c
IOFWWriteCommand *	 fFetchAgentWriteCommand;//c
IOFWWriteQuadCommand * fFetchAgentResetCommand;//c
UInt32 fFetchAgentResetBuffer;//c
UInt32 fDoorbellBuffer;//c
IOFWWriteQuadCommand *fDoorbellCommand;//c
UInt32 fSetBusyTimeoutBuffer;//c
IOFWWriteQuadCommand * fSetBusyTimeoutCommand;//c
UInt32 fUnsolicitedStatusEnableBuffer;//c
IOFWWriteQuadCommand *fUnsolicitedStatusEnableCommand;//c
IOFWAddressSpace * fPasswordAddressSpace;//c
IOMemoryDescriptor * fPasswordDescriptor;//c
int fCriticalSectionCount;//c
void* fRefCon;//c
void* fLoginCompletionRefCon;//c
FWSBP2LoginCallback  fLoginCompletionCallback;//c
void *fLogoutCompletionRefCon;//c
FWSBP2LogoutCallback fLogoutCompletionCallback;//c
FWSBP2NotifyCallback fStatusNotifyCallback;//c
void* fStatusNotifyRefCon;//c
FWSBP2NotifyCallback fUnsolicitedStatusNotifyCallback;//c
void* fUnsolicitedStatusNotifyRefCon;//c
FWAddress fPasswordAddress;//c
void* fPasswordBuf;//c
UInt32 fLoginGeneration;//c
UInt16 fLoginNodeID;//c
UInt16 fLocalNodeID;//c
FWSBP2StatusBlock fStatusBlock;//c
FWSBP2StatusBlock	 fLoginStatusBlock;//c
FWAddress fFetchAgentResetAddress;//c
FWAddress fFetchAgentAddress;//c
FWAddress fDoorbellAddress;//c
FWAddress fUnsolicitedStatusEnableAddress;//c
FWSBP2StatusBlock fReconnectStatusBlock;//c
IOFireWireSBP2ORB * fORBToWrite;//c
IOFireWireSBP2ORB * fLastORB;//c
FWSBP2FetchAgentWriteCallback fFetchAgentWriteCompletion;//c
void* fFetchAgentWriteRefCon;//c
FWSBP2StatusCallback  fFetchAgentResetCompletion;//c
void* fFetchAgentResetRefCon;//?

int fReconnectRetryTimeoutTimerSet;//?
int fReconnectHold;//?
int fLoginStatusReceived;//?
int fUserLoginGenerationSet;//?
int fUserLoginGeneration;//?
int fFastStartOffset;//?
int fManagementOffset;//?
int fMaxORBSize;//?
int fFastStartSupported;//?
int fARDMAMax;//?
int fSuspended;//?
int fPasswordLen;//?
int fDoorbellInProgress;//?
int fLoginRetryDelay;//?
int fUnsolicitedStatusEnableInProgress;//?
int fFetchAgentWriteCommandInUse;//?
int fLoginRetryMax;//?
int fReconnectWriteInProgress;//?
int fLoginTimeoutTimerSet;//?
int fLoginWriteInProgress;//?
int fFetchAgentResetInProgress;//?
int fReconnectTime;//?
int fLoginFlags;//?
int fMaxPayloadSize;//?
int fReconnectTimeoutTimerSet;//?
int fReconnectWriteInterrupted;//?
int fLogoutWriteInProgress;//?
int fUnsolicitedStatusEnableRequested;//?
int fLogoutTimeoutTimerSet;//?
int fLoginState;//?
int fSetBusyTimeoutInProgress;//?
int fDoorbellRingAgain;//?
int fManagementTimeout;//?
int LastORBAddress;//?
int fMaxCommandBlockSize;//?
int fFastStartMaxPayload;//?
int fInCriticalSection;//?
int fLoginID;//?
int fLoginRetryTimeoutTimerSet;//?
int fLoginRetryCount;//?
int fLoginStatusBlockLen;//?
int fPhysicalAccessEnabled;//?
int fLogoutPending;//?
int fFetchAgentRetryTimerSet;//?

public://func define

#define IOFireWireSBP2Login_setBusyTimeoutComplete \
void setBusyTimeoutComplete( IOReturn a, IOFireWireNub *b, IOFWCommand *c);//?

#define IOFireWireSBP2Login_unsolicitedStatusEnableComplete \
void unsolicitedStatusEnableComplete( IOReturn a, IOFireWireNub *b, IOFWCommand *c);//?

#define IOFireWireSBP2Login_staticExecuteUnsolicitedStatusEnable \
static IOReturn staticExecuteUnsolicitedStatusEnable( OSObject *a, void *b, void *c, void *d, void *e);//?

#define IOFireWireSBP2Login_doorbellComplete \
void doorbellComplete( IOReturn a, IOFireWireNub *b, IOFWCommand *c);//?

#define IOFireWireSBP2Login_executeDoorbell \
IOReturn executeDoorbell( void );//?

#define IOFireWireSBP2Login_staticExecuteDoorbell \
static IOReturn staticExecuteDoorbell( OSObject *a, void *b, void *c, void *d, void *e);//?

#define IOFireWireSBP2Login_fetchAgentResetComplete \
void fetchAgentResetComplete( IOReturn a, IOFireWireNub *b, IOFWCommand *c);//?

#define IOFireWireSBP2Login_executeFetchAgentReset \
IOReturn executeFetchAgentReset( void );//?

#define IOFireWireSBP2Login_staticExecuteFetchAgentReset \
static IOReturn staticExecuteFetchAgentReset( OSObject *a, void *b, void *c, void *d, void * e);//?

#define IOFireWireSBP2Login_isFetchAgentWriteInProgress \
bool isFetchAgentWriteInProgress( void );//?

#define IOFireWireSBP2Login_fetchAgentRetryTimer \
void fetchAgentRetryTimer( IOReturn a, IOFireWireBus *b, IOFWBusCommand *c);//?

#define IOFireWireSBP2Login_startFetchAgentRetryTimer \
void startFetchAgentRetryTimer( UInt32 a);//?

#define IOFireWireSBP2Login_appendORB \
IOReturn appendORB( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2Login_appendORBImmediate \
IOReturn appendORBImmediate( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2Login_startORBTimer \
void startORBTimer( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2Login_executeORB \
IOReturn executeORB( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2Login_staticExecuteORB \
static IOReturn staticExecuteORB( OSObject *a, void *b, void *c, void *d, void *e);//?

#define IOFireWireSBP2Login_isConnected \
bool isConnected( void );//?

#define IOFireWireSBP2Login_staticExecuteRemoveORB \
static IOReturn staticExecuteRemoveORB( OSObject *a, void *b, void *c, void *d, void *e);//?

#define IOFireWireSBP2Login_executeAddORB \
IOReturn executeAddORB( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2Login_executeRemoveORB \
IOReturn executeRemoveORB( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2Login_enableUnsolicitedStatus \
IOReturn enableUnsolicitedStatus( void );//?

#define IOFireWireSBP2Login_ringDoorbell \
IOReturn ringDoorbell( void );//?

#define IOFireWireSBP2Login_staticExecuteAddORB \
static IOReturn staticExecuteAddORB( OSObject *a, void *b, void *c, void *d, void *e);//?

#define IOFireWireSBP2Login_submitFetchAgentReset \
IOReturn submitFetchAgentReset( void );//?

#define IOFireWireSBP2Login_addORB \
IOReturn addORB( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2Login_setBusyTimeoutRegisterValue \
void setBusyTimeoutRegisterValue( UInt32 a);//?

#define IOFireWireSBP2Login_createORB \
IOFireWireSBP2ORB * createORB( void );//?

#define IOFireWireSBP2Login_submitORB \
IOReturn submitORB( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2Login_clearAllTasksInSet \
void clearAllTasksInSet( void );//?

#define IOFireWireSBP2Login_logoutTimeout \
void logoutTimeout( IOReturn a, IOFireWireBus *b, IOFWBusCommand *c);//?

#define IOFireWireSBP2Login_logoutWriteComplete \
void logoutWriteComplete( IOReturn a, IOFireWireNub *b, IOFWCommand *c);//?

#define IOFireWireSBP2Login_staticExecuteLogout \
static IOReturn staticExecuteLogout( OSObject *a, void *b, void *c, void *d, void *e );

#define IOFireWireSBP2Login_reconnectRetryTimeout \
void reconnectRetryTimeout( IOReturn a, IOFireWireBus *b, IOFWBusCommand *c);//?

#define IOFireWireSBP2Login_sendReconnectNotificationWithStatusBlock \
void sendReconnectNotificationWithStatusBlock( UInt32 a);//?

#define IOFireWireSBP2Login_reconnectStatusBlockWrite \
UInt32 reconnectStatusBlockWrite( UInt16 a, IOFWSpeed &b, FWAddress c, UInt32 d, const void *e, IOFWRequestRefCon f);//?

#define IOFireWireSBP2Login_reconnectTimeout \
void reconnectTimeout( IOReturn a, IOFireWireBus *b, IOFWBusCommand *c);//?

#define IOFireWireSBP2Login_startReconnectRetryTimer \
void startReconnectRetryTimer( void );//?

#define IOFireWireSBP2Login_reconnectWriteComplete \
void reconnectWriteComplete( IOReturn a, IOFireWireNub *b, IOFWCommand *c);//?

#define IOFireWireSBP2Login_sendReconnectNotification \
void sendReconnectNotification( UInt32 a);//?

#define IOFireWireSBP2Login_doReconnect \
void doReconnect( void );//?

#define IOFireWireSBP2Login_terminateNotify \
void terminateNotify( void );//?

#define IOFireWireSBP2Login_restartReconnect \
void restartReconnect( void );//?

#define IOFireWireSBP2Login_executeLogout \
IOReturn executeLogout( void );//?

#define IOFireWireSBP2Login_executeSetBusyTimeout \
IOReturn executeSetBusyTimeout( void );//?

#define IOFireWireSBP2Login_resumeNotify \
void resumeNotify( void );//?

#define IOFireWireSBP2Login_startReconnectTimer \
void startReconnectTimer( void );//?

#define IOFireWireSBP2Login_suspendedNotify \
void suspendedNotify( void );//?

#define IOFireWireSBP2Login_completeLogout \
void completeLogout( IOReturn a, const void *b = 0, UInt32 c = 0);//?

#define IOFireWireSBP2Login_isORBAppended \
bool isORBAppended( IOFireWireSBP2ORB * a );//?

#define IOFireWireSBP2Login_cancelORBTimer \
void cancelORBTimer( IOFireWireSBP2ORB * a );//?

#define IOFireWireSBP2Login_statusBlockWrite \
UInt32 statusBlockWrite( UInt16 a, IOFWSpeed &b, FWAddress c, UInt32 d, const void *e, IOFWRequestRefCon f);//?

#define IOFireWireSBP2Login_executeUnsolicitedStatusEnable \
IOReturn executeUnsolicitedStatusEnable( void );//?

#define IOFireWireSBP2Login_loginRetryTimeout \
void loginRetryTimeout( IOReturn a, IOFireWireBus *b, IOFWBusCommand *c);//?

#define IOFireWireSBP2Login_loginTimeout \
void loginTimeout( IOReturn a, IOFireWireBus *b, IOFWBusCommand *c);//?

#define IOFireWireSBP2Login_completeLogin \
void completeLogin( IOReturn a, const void *b =0, UInt32 c = 0, void *d = 0 );//?

#define IOFireWireSBP2Login_setFetchAgentResetCompletion \
void setFetchAgentResetCompletion( void *a, FWSBP2StatusCallback b);//?

#define IOFireWireSBP2Login_submitLogout \
IOReturn submitLogout( void );//?

#define IOFireWireSBP2Login_sendTimeoutNotification \
void sendTimeoutNotification( IOFireWireSBP2ORB *a );//?

#define IOFireWireSBP2Login_removeORB \
IOReturn removeORB( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2Login_processLoginWrite \
void processLoginWrite( void );//?

#define IOFireWireSBP2Login_loginWriteComplete \
void loginWriteComplete( IOReturn a, IOFireWireNub *b, IOFWCommand *c);//?

#define IOFireWireSBP2Login_isPhysicalAccessEnabled \
bool	isPhysicalAccessEnabled( void );//?

#define IOFireWireSBP2Login_setAddressLoForLoginORBAndResponse \
void setAddressLoForLoginORBAndResponse(UInt32 a, UInt32 b);//?

#define IOFireWireSBP2Login_startLoginRetryTimer \
void startLoginRetryTimer( void );//?

#define IOFireWireSBP2Login_executeLogin \
IOReturn executeLogin( void );//?

#define IOFireWireSBP2Login_initialExecuteLogin \
IOReturn initialExecuteLogin( void );//?

#define IOFireWireSBP2Login_staticExecuteLogin \
static IOReturn staticExecuteLogin( OSObject *a, void *b, void *c, void *d, void *e );//?

#define IOFireWireSBP2Login_clearLoginGeneration \
void clearLoginGeneration( void );//?

#define IOFireWireSBP2Login_submitLogin \
IOReturn submitLogin( void );//?

#define IOFireWireSBP2Login_setPassword_void \
IOReturn setPassword( void *a, UInt32 b );//?

#define IOFireWireSBP2Login_setPassword \
IOReturn setPassword( IOMemoryDescriptor *a);//?

#define IOFireWireSBP2Login_setLoginRetryCountAndDelayTime \
void setLoginRetryCountAndDelayTime( UInt32 a, UInt32 b);//?

#define IOFireWireSBP2Login_getMaxPayloadSize \
UInt32 getMaxPayloadSize( void );//?

#define IOFireWireSBP2Login_setMaxPayloadSize \
void setMaxPayloadSize( UInt32 a );//?

#define IOFireWireSBP2Login_getUnsolicitedStatusNotifyProc \
void getUnsolicitedStatusNotifyProc( void ** a, FWSBP2NotifyCallback * b);//?

#define IOFireWireSBP2Login_setUnsolicitedStatusNotifyProc \
void setUnsolicitedStatusNotifyProc( void *a, FWSBP2NotifyCallback b);//?

#define IOFireWireSBP2Login_setStatusNotifyProc \
void setStatusNotifyProc( void *a, FWSBP2NotifyCallback b);//?

#define IOFireWireSBP2Login_getReconnectTime \
UInt32 getReconnectTime( void );//?

#define IOFireWireSBP2Login_setReconnectTime \
void setReconnectTime( UInt32 a);//?

#define IOFireWireSBP2Login_setLogoutCompletion \
void setLogoutCompletion( void *a, FWSBP2LogoutCallback b);//?

#define IOFireWireSBP2Login_setLoginCompletion \
void setLoginCompletion( void *a, FWSBP2LoginCallback b );//?

#define IOFireWireSBP2Login_getLoginFlags \
UInt32 getLoginFlags( void );//?

#define IOFireWireSBP2Login_setLoginFlags \
void setLoginFlags( UInt32 a );//?

#define IOFireWireSBP2Login_getRefCon \
void * getRefCon( void );//?

#define IOFireWireSBP2Login_setRefCon \
void setRefCon( void *a);//?

#define IOFireWireSBP2Login_getMaxCommandBlockSize \
UInt32 getMaxCommandBlockSize( void );//?

#define IOFireWireSBP2Login_getStatusNotifyProc \
void getStatusNotifyProc( void ** a, FWSBP2NotifyCallback * b);//?

#define IOFireWireSBP2Login_getFireWireLUN \
IOFireWireSBP2LUN * getFireWireLUN( void );//?

#define IOFireWireSBP2Login_setLoginGeneration \
void setLoginGeneration( UInt32 a );//?

#define IOFireWireSBP2Login_getLoginID \
UInt32 getLoginID( void );//?

#define IOFireWireSBP2Login_getFireWireUnit \
IOFireWireUnit * getFireWireUnit( void );//?

#define IOFireWireSBP2Login_stopFetchAgentRetryTimer \
void stopFetchAgentRetryTimer( void );//?

#define IOFireWireSBP2Login_stopReconnectRetryTimer \
void stopReconnectRetryTimer( void );//?

#define IOFireWireSBP2Login_stopLoginRetryTimer \
void stopLoginRetryTimer( void );//?

#define IOFireWireSBP2Login_free \
void free( void );//?

#define IOFireWireSBP2Login_setBusyTimeoutCompleteStatic \
static void setBusyTimeoutCompleteStatic( void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//:?

#define IOFireWireSBP2Login_doorbellCompleteStatic \
static void doorbellCompleteStatic( void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireSBP2Login_fetchAgentResetCompleteStatic \
static void fetchAgentResetCompleteStatic( void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireSBP2Login_fetchAgentRetryTimerStatic \
static void fetchAgentRetryTimerStatic( void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//?

#define IOFireWireSBP2Login_logoutTimeoutStatic \
static void logoutTimeoutStatic( void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//?

#define IOFireWireSBP2Login_logoutWriteCompleteStatic \
static void logoutWriteCompleteStatic( void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireSBP2Login_reconnectTimeoutStatic \
static void reconnectTimeoutStatic( void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//?

#define IOFireWireSBP2Login_reconnectWriteCompleteStatic \
static void reconnectWriteCompleteStatic( void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireSBP2Login_reconnectRetryTimeoutStatic \
static void reconnectRetryTimeoutStatic( void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//?

#define IOFireWireSBP2Login_loginRetryTimeoutStatic \
static void loginRetryTimeoutStatic(void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//?

#define IOFireWireSBP2Login_loginTimeoutStatic \
static void loginTimeoutStatic( void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d );//?

#define IOFireWireSBP2Login_loginWriteCompleteStatic \
static void loginWriteCompleteStatic( void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireSBP2Login_isORBTimerSet \
bool isORBTimerSet( IOFireWireSBP2ORB *a );//?

#define IOFireWireSBP2Login_unsolicitedStatusEnableCompleteStatic \
static void unsolicitedStatusEnableCompleteStatic( void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireSBP2Login_release \
void release() const;//?

#define IOFireWireSBP2Login_removeLogin \
void removeLogin( void );//?

#define IOFireWireSBP2Login_reconnectStatusBlockWriteStatic \
static UInt32 reconnectStatusBlockWriteStatic(void *a, UInt16 b, IOFWSpeed &c, FWAddress d, UInt32 e, const void *f, IOFWRequestRefCon g);//?

#define IOFireWireSBP2Login_setORBIsAppended \
void setORBIsAppended( IOFireWireSBP2ORB * a, bool b);//?

#define IOFireWireSBP2Login_abortLogin \
void abortLogin( void );//?

#define IOFireWireSBP2Login_statusBlockWriteStatic \
static UInt32 statusBlockWriteStatic(void *a, UInt16 b, IOFWSpeed &c, FWAddress d, UInt32 e, const void *f, IOFWRequestRefCon g);//?

#define IOFireWireSBP2Login_allocateResources \
IOReturn allocateResources( void );//?

#define IOFireWireSBP2Login_getUnitInformation \
IOReturn getUnitInformation( void );//?

#define IOFireWireSBP2Login_setFetchAgentWriteCompletion \
void setFetchAgentWriteCompletion( void *a, FWSBP2FetchAgentWriteCallback b);//?

#define IOFireWireSBP2Login_fetchAgentWriteCompleteStatic \
static void fetchAgentWriteCompleteStatic( void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d );//?

#define IOFireWireSBP2Login_fetchAgentWriteComplete_IOReturn \
void fetchAgentWriteComplete( IOReturn a, IOFireWireNub *b, IOFWCommand *c);//?

#define IOFireWireSBP2Login_setNextORBAddress \
void setNextORBAddress( IOFireWireSBP2ORB *a, FWAddress b);//?

#define IOFireWireSBP2Login_initORBWithLogin \
bool initORBWithLogin( IOFireWireSBP2ORB *a, IOFireWireSBP2Login *b);//?

#define IOFireWireSBP2Login_getARDMMax \
UInt32	getARDMMax( void);//?

#define IOFireWireSBP2Login_fetchAgentWriteComplete \
void fetchAgentWriteComplete( IOFireWireSBP2ORB *a, IOReturn b);//?

#define IOFireWireSBP2Login_getTarget \
IOFireWireSBP2Target * getTarget( void );//?

#define IOFireWireSBP2Login_prepareORBForExecution \
void prepareORBForExecution( IOFireWireSBP2ORB *a );//?

#define IOFireWireSBP2Login_initWithLUN \
bool initWithLUN( IOFireWireSBP2LUN *a );//?

public://func

};

#endif//HYS_IOKIT_SBP2_IOFIREWIRESBP2LOGIN_H
