#ifndef HYS_IOKIT_SBP2_IOFIREWIRESBP2ORB_H
#define HYS_IOKIT_SBP2_IOFIREWIRESBP2ORB_H

enum  {
	kFWSBP2CommandNormalORB,//?
	kFWSBP2MaxPageClusterSize,//?
	kFWSBP2CommandReservedORB,//?
	kFWSBP2CommandCompleteNotify,//?
	kFWSBP2CommandVendorORB,//?
	kFWSBP2CommandDummyORB,//?
	kFWSBP2CommandTransferDataFromTarget,//?
	kFWSBP2ConstraintForceDoubleBuffer,//?
	kFWSBP2CommandFixedSize,//?
	kFWSBP2CommandVirtualORBs,//?
	kFWSBP2CommandImmediate,//?
	kFWSBP2CommandCheckGeneration,//?
};

typedef struct FWSBP2VirtualRange FWSBP2VirtualRange;

class  IOFireWireSBP2ORB_HYS
{
    OSDeclareDefaultStructors( IOFireWireSBP2ORB_HYS )

public://data

struct FWSBP2PTE{
	int segmentLength;//?
	int segmentBaseAddressHi;//?
	int segmentBaseAddressLo;//?
};
typedef struct FWSBP2PTE FWSBP2PTE;

struct FWSBP2ORB {
	int nextORBAddressHi;//?
	int nextORBAddressLo;//?
	int dataDescriptorHi;//?
	int options;//?
	int dataDescriptorLo;//?
	int dataSize;//?
	int commandBlock[1];//?
};
typedef struct FWSBP2ORB FWSBP2ORB;

IOFireWireSBP2Login *fLogin;//c
IOFireWireSBP2LUN * fLUN;//c
IOFireWireUnit * fUnit;//c
IOFireWireController * fControl;//c
IOFWAddressSpace * fORBPhysicalAddressSpace;//c
IOMemoryDescriptor * fORBDescriptor;//c
FWSBP2ORB * fORBBuffer;//c
FWAddress fORBPseudoAddress;//c
IOFWAddressSpace *fORBPseudoAddressSpace;//c
IOBufferMemoryDescriptor *fPageTableDescriptor;//c
IOFWDelayCommand * fTimeoutCommand;//c
FWAddress fPageTablePhysicalAddress;//c
IOFWAddressSpace *fPageTablePhysicalAddressSpace;//c
IOFWAddressSpace *fPageTablePseudoAddressSpace;//c
FWAddress fPageTablePseudoAddress;//c
IODMACommand * fDMACommand;//c
IOFWAddressSpace * fBufferAddressSpace;//c
IOMemoryDescriptor * fBufferDescriptor;//c

int fTimeoutTimerSet;//?
int fRefCon;//?
int fBufferAddressSpaceAllocated;//?
int fMaxPayloadSize;//?
int fCommandFlags;//?
int fTimeoutDuration;//?
int fConstraintOptions;//?
int fORBPhysicalAddress;//?
int fPTECount;//?
int fInProgress;//?
int fPageTableSize;//?
int fPageTablePhysicalLength;//?
int fGeneration;//?
int fIsAppended;//?
int fFetchAgentWriteRetries;//?
int fFetchAgentWriteRetryInterval;//?

public:	//func

#define IOFireWireSBP2ORB_getFetchAgentWriteRetryInterval \
UInt32 getFetchAgentWriteRetryInterval( void );//?

#define IOFireWireSBP2ORB_getFetchAgentWriteRetries \
UInt32 getFetchAgentWriteRetries( void );//?

#define IOFireWireSBP2ORB_setIsAppended \
void setIsAppended( bool a);//?

#define IOFireWireSBP2ORB_setNextORBAddress \
void setNextORBAddress( FWAddress a );//?

#define IOFireWireSBP2ORB_completeBufferAddressSpace \
IOReturn completeBufferAddressSpace( void );//?

#define IOFireWireSBP2ORB_orbTimeout \
void orbTimeout( IOReturn a, IOFireWireBus *b, IOFWBusCommand *c);//?

#define IOFireWireSBP2ORB_isTimerSet \
bool isTimerSet( void );//?

#define IOFireWireSBP2ORB_startTimer \
void startTimer( void );//?

#define IOFireWireSBP2ORB_orbTimeoutStatic \
static void orbTimeoutStatic( void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//?

#define IOFireWireSBP2ORB_prepareFastStartPacket \
void prepareFastStartPacket( IOBufferMemoryDescriptor * a);//?

#define IOFireWireSBP2ORB_setFetchAgentWriteRetries \
void setFetchAgentWriteRetries( UInt32 a);//?

#define IOFireWireSBP2ORB_setToDummy \
void setToDummy( void );//?

#define IOFireWireSBP2ORB_isAppended \
bool isAppended( void );//?

#define IOFireWireSBP2ORB_setFetchAgentWriteRetryInterval \
void setFetchAgentWriteRetryInterval( UInt32 a);//?

#define IOFireWireSBP2ORB_sendTimeoutNotification \
void sendTimeoutNotification( IOFireWireSBP2ORB * a);//?

#define IOFireWireSBP2ORB_prepareBufferAddressSpace \
IOReturn prepareBufferAddressSpace( IOMemoryDescriptor *a);//?

#define IOFireWireSBP2ORB_cancelTimer \
void cancelTimer( void );//?

#define IOFireWireSBP2ORB_deallocateBufferAddressSpace \
void deallocateBufferAddressSpace( void );//?

#define IOFireWireSBP2ORB_removeORB \
IOReturn removeORB( IOFireWireSBP2ORB * a);//?

#define IOFireWireSBP2ORB_deallocateORB \
void deallocateORB( void );//?

#define IOFireWireSBP2ORB_deallocateTimer \
void deallocateTimer( void );//?

#define IOFireWireSBP2ORB_allocateTimer \
IOReturn allocateTimer( void );//?

#define IOFireWireSBP2ORB_allocateORBallocateORB \
IOReturn allocateORB( UInt32 a);//?

#define IOFireWireSBP2ORB_free \
void free( void );//?

#define IOFireWireSBP2ORB_prepareORBForExecution \
void prepareORBForExecution( void );//?

#define IOFireWireSBP2ORB_allocateResources \
IOReturn allocateResources( void );//?

#define IOFireWireSBP2ORB_getFireWireUnit \
IOFireWireUnit * getFireWireUnit( void );//?

#define IOFireWireSBP2ORB_initWithLogin \
bool initWithLogin( IOFireWireSBP2Login * a);//?

#define IOFireWireSBP2ORB_getFireWireLUN \
IOFireWireSBP2LUN * getFireWireLUN( void );//?

};

#endif//HYS_IOKIT_SBP2_IOFIREWIRESBP2ORB_H
