#ifndef HYS_IOKIT_SBP2_IOFIREWIRESBP2TARGET_H
#define HYS_IOKIT_SBP2_IOFIREWIRESBP2TARGET_H

enum {
	kIOFWSBP2FailsOnBusResetsDuringIO,//?
	kIOFWSBP2FailsOnAckBusy,//?
};

class  IOFireWireSBP2Target_HYS
{
    OSDeclareDefaultStructors(IOFireWireSBP2Target_HYS);


public://data

enum {
	kRevisionKey,//?
	kCmdSpecIDKey,//?
	kCmdSetKey,//?
	kUnitCharacteristicsKey,//?
	kManagementAgentOffsetKey,//?
	kFastStartKey,//?
	kSoftwareRevKey,//?
	kFirmwareRevKey,//?
	kLUNKey,//?
	kLUNDirectoryKey,//?
};

struct ExpansionData {
	int fStarted;//?
	OSArray *	fPendingMgtAgentCommands;//c
	int fNumLUNs;//?
	int fNumberPendingMgtAgentOrbs;//?
};

struct LUNInfo {
	UInt32 cmdSpecID;//c
	UInt32 cmdSet;//c
	UInt32 vendorID;//c
	UInt32 softwareRev;//c
	UInt32 firmwareRev;//c
	int lun;//?
	int devType;//?
	UInt32 unitCharacteristics;//c
	UInt32 managementOffset;//c
	UInt32 revision;//c
	int fastStartSupported;//?
	UInt32 fastStart;//c
};
typedef struct LUNInfo LUNInfo;

ExpansionData *  fExpansionData;//c
IOFireWireUnit *  fProviderUnit;//c
IOFireWireController * fControl;//c

int fFlags;//?
int fOpenFromTarget;//?
int fOpenFromLUNCount;//?
int fIOCriticalSectionCount;//?

public://func-define

#define IOFireWireSBP2Target_clearMgmtAgentAccess \
void 		clearMgmtAgentAccess( );//?

#define IOFireWireSBP2Target_cancelMgmtAgentAccess \
void		cancelMgmtAgentAccess( IOFWCommand *a );//?

#define IOFireWireSBP2Target_completeMgmtAgentAccess \
void		completeMgmtAgentAccess( );//?

#define IOFireWireSBP2Target_beginIOCriticalSection \
IOReturn beginIOCriticalSection( void );//?

#define IOFireWireSBP2Target_configurePhysicalFilter \
void configurePhysicalFilter( void );//?

#define IOFireWireSBP2Target_synchMgmtAgentAccess \
IOReturn 	synchMgmtAgentAccess( IOFWCommand * a);//?

#define IOFireWireSBP2Target_clearTargetFlags \
void clearTargetFlags( UInt32 a);//?

#define IOFireWireSBP2Target_setTargetFlags \
void setTargetFlags( UInt32 a);//?

#define IOFireWireSBP2Target_matchPropertyTable \
bool matchPropertyTable( OSDictionary * a);//?

#define IOFireWireSBP2Target_endIOCriticalSection \
void endIOCriticalSection( void );//?

#define IOFireWireSBP2Target_getTargetFlags \
UInt32 getTargetFlags( void );//?

#define IOFireWireSBP2Target_createLUN \
IOReturn createLUN( LUNInfo * a);//?

#define IOFireWireSBP2Target_handleIsOpen \
bool handleIsOpen(  const IOService * a ) const;//?

#define IOFireWireSBP2Target_handleClose \
void handleClose( IOService * a, IOOptionBits b);//?

#define IOFireWireSBP2Target_handleOpen \
bool handleOpen( IOService * a, IOOptionBits b, void *c);//?

#define IOFireWireSBP2Target_message \
IOReturn message( UInt32 a, IOService *b,void * c=0);//? 

#define IOFireWireSBP2Target_free \
void free( void );//?

#define IOFireWireSBP2Target_finalize \
bool finalize( IOOptionBits a);//?

#define IOFireWireSBP2Target_stop \
void stop( IOService *a );//?

#define IOFireWireSBP2Target_scanForLUNs \
void scanForLUNs( void );//?

#define IOFireWireSBP2Target_getFireWireUnit \
IOFireWireUnit * getFireWireUnit( void );//?

#define IOFireWireSBP2Target_start \
bool start( IOService *a);//?

public://func

int clearMgmtAgentAccess();//?
int configurePhysicalFilter();//?

};

#endif//HYS_IOKIT_SBP2_IOFIREWIRESBP2TARGET_H
