#ifndef HYS_IOKIT_SCSI_IOSCSPARALLELCOMMAND_H
#define HYS_IOKIT_SCSI_IOSCSPARALLELCOMMAND_H


class IOSCSIParallelController;//add

class IOSCSIParallelCommand_HYS
{
    OSDeclareDefaultStructors(IOSCSIParallelCommand_HYS)


public://data

union {
	struct {
		void* target;//?
		CallbackFn callback;//c
		void* refcon;//c
	} async;
	struct {
		IOSyncer* lock;//c
	} sync;
} completionInfo;

IOSCSIParallelDevice	* device;//c
void* clientData;//c
void* commandPrivateData;//c
IOSCSIParallelCommand	* origCommand;//c
SCSIResults	 results;//c
IOMemoryDescriptor	* xferDesc;//c
IOMemoryDescriptor* senseData;//c
SCSICDBInfo	 scsiCmd;//c
IOSCSIParallelController* controller;//c
queue_head_t	* list;//c
void* dataArea;//c
queue_chain_t	nextCommand;//c

int dataSize;//?
int timer;//?
int cmdType;//?
int sequenceNumber;//?
int timeout;//?
int xferCount;//?
int queueType;//?
int queuePosition;//?
int xferDirection;//?
int senseLength;//?

public://define

#define IOSCSIParallelCommand_free \
   void 			free();//c

#define IOSCSIParallelCommand_zeroCommand \
void 			zeroCommand();  //c

#define IOSCSIParallelCommand_getResults_CDBResults \
IOReturn			getResults( CDBResults *a);//c

#define IOSCSIParallelCommand_setCDB_CDBInfo \
void 			setCDB( CDBInfo *a );//c

#define IOSCSIParallelCommand_getCDB_CDBInfo \
void 			getCDB( CDBInfo *a);//c

#define IOSCSIParallelCommand_abort \
void			abort( UInt32 a);//c

#define IOSCSIParallelCommand_execute \
bool 			execute( UInt32 *a= 0 );//c

#define IOSCSIParallelCommand_setCDB \
void 			setCDB( SCSICDBInfo *a);//c

#define IOSCSIParallelCommand_setCallback \
void 			setCallback( void *a = 0, CallbackFn b = 0, void *c = 0 );//c

#define IOSCSIParallelCommand_setPointers \
void 		setPointers( IOMemoryDescriptor 	*a, UInt32 b, bool c, bool d = false );//c

#define IOSCSIParallelCommand_getQueueInfo \
 void			getQueueInfo(  UInt32 *a, UInt32 *b = 0 );//c

#define IOSCSIParallelCommand_setQueueInfo \
void			setQueueInfo(  UInt32 a = kQTypeNormalQ, UInt32 b = kQPositionTail );//c

#define IOSCSIParallelCommand_getResults \
IOReturn			getResults( SCSIResults *a);//c

#define IOSCSIParallelCommand_getDevice_IOCDBDevice \
IOCDBDevice 		*getDevice( IOCDBDevice *a);//c

#define IOSCSIParallelCommand_getDevice_IOSCSIDevice \
IOSCSIDevice 		*getDevice( IOSCSIDevice *a );//c

#define IOSCSIParallelCommand_getDevice \
IOSCSIParallelDevice 	*getDevice( IOSCSIParallelDevice *a );//c

#define IOSCSIParallelCommand_getClientData \
void			*getClientData();//c

#define IOSCSIParallelCommand_getCommandData \
void			*getCommandData();//c

#define IOSCSIParallelCommand_getCmdType \
UInt32			getCmdType();//c

#define IOSCSIParallelCommand_getOriginalCmd \
IOSCSIParallelCommand	*getOriginalCmd();//c

#define IOSCSIParallelCommand_getSequenceNumber \
UInt32			getSequenceNumber();//c

#define IOSCSIParallelCommand_getTargetLun \
void			getTargetLun( SCSITargetLun *a);//c

#define IOSCSIParallelCommand_setTimeout  \
void 			setTimeout( UInt32  a);	//c

#define IOSCSIParallelCommand_getTimeout \
UInt32 			getTimeout();//c

#define IOSCSIParallelCommand_setResults \
void			setResults( SCSIResults *a );//c

#define IOSCSIParallelCommand_setResults_SCSIResults \
 void		setResults( SCSIResults *a, SCSINegotiationResults *b);//c

#define IOSCSIParallelCommand_adapterStatusToIOReturnCode \
IOReturn 			adapterStatusToIOReturnCode( SCSIAdapterStatus a);//c

#define IOSCSIParallelCommand_getCDB \
void			getCDB( SCSICDBInfo *a);//c

#define IOSCSIParallelCommand_complete \
 void	 		complete();//c

#define IOSCSIParallelCommand_getPointers \
void	getPointers( IOMemoryDescriptor 	**a, UInt32 *b, bool 	*c, bool d = false );//c

#define IOSCSIParallelCommand_scsiStatusToIOReturnCode \
IOReturn 			scsiStatusToIOReturnCode( UInt8 a );//c

public://func


};

#endif //HYS_IOKIT_SCSI_IOSCSPARALLELCOMMAND_H
