#ifndef HYS_IOKIT_SCSI_IOSCSIPARALLELCONTROLLER_H
#define HYS_IOKIT_SCSI_IOSCSIPARALLELCONTROLLER_H

class IOSCSIParallelController_HYS
{
    OSDeclareDefaultStructors(IOSCSIParallelController_HYS)

public://data

IOService* provider;//c
SCSIControllerInfo controllerInfo;//c
SCSITarget*  targets;//c
IOCommandGate	* controllerGate;//c
IOSCSIParallelCommand	* resetCmd;//c
IOTimerEventSource* timerEvent;//c
IOWorkLoop	* workLoop;//c
IOInterruptEventSource	* dispatchEvent;//c
UInt32* tagArray;//c
IOSCSIParallelCommand	* noDisconnectCmd;//c

int commandCount;//?
int commandDisable;//?
int commandLimitSave;//?
int commandLimit;//?
int disableTimer;//?
int resetTimer;//?
int tagArraySize;//?
int sequenceNumber;//?
int busResetState;//?

public://data-define

#define IOSCSIParallelController_sDomainCount \
static SInt32	sDomainCount;

public://fund-define

#define IOSCSIParallelController_free \
    void 			free();//c

#define IOSCSIParallelController_dispatchRequest \
    void			dispatchRequest();//c

#define IOSCSIParallelController_disableCommands_UInt32 \
void			disableCommands( UInt32 a);//c

#define IOSCSIParallelController_getWorkLoop \
virtual IOWorkLoop  	*getWorkLoop() const;//c

#define IOSCSIParallelController_setCommandLimit \
void			setCommandLimit( UInt32 a );//c

#define IOSCSIParallelController_findDeviceWithTargetLun \
IOSCSIParallelDevice        *findDeviceWithTargetLun( SCSITargetLun a );//c

#define IOSCSIParallelController_findCommandWithNexus \
IOSCSIParallelCommand       *findCommandWithNexus( SCSITargetLun a, UInt32 b = (UInt32)-1 );//c

#define IOSCSIParallelController_dispatch \
    void			dispatch();//c

#define IOSCSIParallelController_disableTimeoutOccurred \
virtual void		disableTimeoutOccurred();	//c

#define IOSCSIParallelController_checkBusReset \
bool			checkBusReset();//c

#define IOSCSIParallelController_reset \
void			reset();//c

#define IOSCSIParallelController_timer \
    void			timer( IOTimerEventSource *a);//c

#define IOSCSIParallelController_allocCommand \
  IOSCSIParallelCommand 	*allocCommand( UInt32 a );//c

#define IOSCSIParallelController_getLunData \
  void 			*getLunData( SCSITargetLun a );//c

#define IOSCSIParallelController_getTargetData \
    void 			*getTargetData( SCSITargetLun a);//c

#define IOSCSIParallelController_start \
bool 			start( IOService *a);//c

#define IOSCSIParallelController_createWorkLoop \
bool 	createWorkLoop();

#define IOSCSIParallelController_initTargetGated \
bool 			initTargetGated( SCSITargetLun *a);//c

#define IOSCSIParallelController_configureController \
bool 			configureController();//c

#define IOSCSIParallelController_initQueues  \
void			initQueues();//c

#define IOSCSIParallelController_scanSCSIBus \
bool 			scanSCSIBus();//c

#define IOSCSIParallelController_probeTarget \
bool			probeTarget( SCSITargetLun a);//c

#define IOSCSIParallelController_initTarget \
bool 			initTarget( SCSITargetLun a);//c

#define IOSCSIParallelController_releaseTarget \
void			releaseTarget( SCSITargetLun a);//?

#define IOSCSIParallelController_createDevice \
IOSCSIParallelDevice 	*createDevice();//c

#define IOSCSIParallelController_releaseDevice \
void 			releaseDevice( IOSCSIParallelDevice *a );//c

#define IOSCSIParallelController_initDevice \
bool			initDevice( IOSCSIParallelDevice *a);//c

#define IOSCSIParallelController_releaseTargetGated \
void			releaseTargetGated( SCSITargetLun *a );//c

#define IOSCSIParallelController_initDeviceGated \
bool			initDeviceGated( IOSCSIParallelDevice *a);//c

#define IOSCSIParallelController_releaseDeviceGated  \
 void 			releaseDeviceGated( IOSCSIParallelDevice *a);//c

#define IOSCSIParallelController_addDevice \
 void 			addDevice( IOSCSIParallelDevice * a);//c

#define IOSCSIParallelController_allocateTarget \
virtual bool		allocateTarget( SCSITargetLun a);//c

#define IOSCSIParallelController_deallocateTarget \
virtual void		deallocateTarget( SCSITargetLun a );//c

#define IOSCSIParallelController_rescheduleCommand \
void			rescheduleCommand( IOSCSIParallelCommand *a);//c

#define IOSCSIParallelController_disableCommands \
 void			disableCommands();//c

#define IOSCSIParallelController_enableCommands \
void			enableCommands();//c

#define IOSCSIParallelController_resetOccurred \
void			resetOccurred();//c

#define IOSCSIParallelController_allocateLun \
 virtual bool		allocateLun( SCSITargetLun a);//c

#define IOSCSIParallelController_completeCommand \
void			completeCommand( IOSCSIParallelCommand *a);//c

#define IOSCSIParallelController_deleteDevice \
 void 			deleteDevice( IOSCSIParallelDevice *a);//c

#define  IOSCSIParallelController_deallocateLun \
virtual void		deallocateLun( SCSITargetLun a );//c

public://func
int resetCommand( IOSCSIParallelCommand * a);//?
int configure(IOService *a, SCSIControllerInfo * b);//?
int executeCommand(IOSCSIParallelCommand* a);//?
int cancelCommand(IOSCSIParallelCommand* a);//?

};

#endif//HYS_IOKIT_SCSI_IOSCSIPARALLELCONTROLLER_H
