#ifndef HYS_IOKIT_SCSI_IOSCSIPARALLELDEVICE_H
#define HYS_IOKIT_SCSI_IOSCSIPARALLELDEVICE_H

class IOSCSIParallelCommand;//add
class IOSCSIParallelDevice;//add

#define kIOSCSIParallelDevice	((IOSCSIParallelDevice *)0)//c

class IOSCSIParallelDevice_HYS
{
    OSDeclareDefaultStructors(IOSCSIParallelDevice_HYS)

public://data

SCSITargetLun targetLun;//c
SCSITarget	* target;//c
IOCommandGate     * deviceGate;//c
queue_chain_t nextDevice;//c
void* devicePrivateData;//c
IOService* client;//c
queue_head_t activeList;//c
IOSCSIParallelController* controller;//c
queue_head_t deviceList;//c
queue_head_t bypassList;//c
queue_head_t abortList;//c
queue_head_t cancelList;//c
IORWLock * clientSem;//c
IOSCSIParallelCommand* abortCmd;//c
IOSCSIParallelCommand* cancelCmd;//c
IOSCSIParallelCommand* reqSenseCmd;//c
UInt32* tagArray;//c
IOSCSIParallelCommand* probeCmd;//c
SCSIInquiry* inquiryData;//c
void* idleNotifyTarget;//c
CallbackFn	 idleNotifyCallback;//c
void* idleNotifyRefcon;//c
IOSCSIParallelCommand* reqSenseOrigCmd;//c
OSNumber* regObjCmdQueue;//c
SCSILunParms lunParmsNew;//c
OSNumber* regObjTransferPeriod;//c
OSNumber* regObjTransferOffset;//c
OSNumber* regObjTransferWidth;//c
OSNumber* regObjTransferOptions;//c

int commandCount;//?
int disableDisconnect;//?
int negotiateState;//?
int reqSenseState;//?
int abortState;//?
int abortCmdPending;//?
int inquiryDataSize;//?
int bypassQHeld;//?
int normalQHeld;//?
int idleNotifyActive;//?
int commandLimit;//?
int commandLimitSave;//?
int lunAllocated;//?
int cancelState;//?

public://define

#define IOSCSIParallelDevice_probeTargetLun \
    IOReturn	 		probeTargetLun();//c

#define IOSCSIParallelDevice_receiveCommand \
void 	receiveCommand( UInt32 a, IOSCSIParallelCommand *b, UInt32 c, void *d);//c

#define IOSCSIParallelDevice_init \
bool 		init( IOSCSIParallelController *a, SCSITargetLun b);//c

#define IOSCSIParallelDevice_setupTarget \
    void			setupTarget();//c

#define IOSCSIParallelDevice_checkCmdQueEnabled \
    bool			checkCmdQueEnabled();//c

#define IOSCSIParallelDevice_setTargetParms \
     bool                	setTargetParms( SCSITargetParms *a );//c

#define IOSCSIParallelDevice_getInquiryData \
 void	getInquiryData( void    *a, UInt32  b, UInt32  *c );//c

#define IOSCSIParallelDevice_abort \
     void			abort();//c

#define IOSCSIParallelDevice_reset \
     void			reset();//c

#define IOSCSIParallelDevice_holdQueue \
    void			holdQueue( UInt32 a);//c

#define IOSCSIParallelDevice_releaseQueue \
    void			releaseQueue( UInt32 a);//c

#define IOSCSIParallelDevice_notifyIdle \
    void			notifyIdle(  void *a = 0, CallbackFn b = 0, void *c = 0 );//c

#define IOSCSIParallelDevice_submitCommand \
   void			submitCommand(  UInt32 a, IOSCSIParallelCommand *b, UInt32 c = 0 );//c

#define IOSCSIParallelDevice_abortAllCommands \
    void			abortAllCommands( SCSICommandType a );//c

#define IOSCSIParallelDevice_abortCommand \
    void			abortCommand( IOSCSIParallelCommand *a, UInt32 b );//c

#define IOSCSIParallelDevice_resetOccurred \
    void			resetOccurred( SCSIClientMessage a );//c

#define IOSCSIParallelDevice_resetComplete \
    void			resetComplete();//c

#define IOSCSIParallelDevice_checkAbortQueue \
    bool			checkAbortQueue();//c

#define IOSCSIParallelDevice_checkCancelQueue \
  void			checkCancelQueue();//c

#define IOSCSIParallelDevice_checkReqSense \
    bool			checkReqSense();//c

#define IOSCSIParallelDevice_checkDeviceQueue \
    bool			checkDeviceQueue( UInt32 *a);//c

#define IOSCSIParallelDevice_rescheduleCommand \
    void			rescheduleCommand( IOSCSIParallelCommand *a);//c

#define IOSCSIParallelDevice_getTargetParms \
     void               	getTargetParms( SCSITargetParms *a);//c

#define IOSCSIParallelDevice_setLunParms \
 bool			setLunParms( SCSILunParms *a);//c

#define IOSCSIParallelDevice_checkIdleNotify \
    void			checkIdleNotify();//c

#define IOSCSIParallelDevice_dispatchRequest \
    void 			dispatchRequest();//c

#define IOSCSIParallelDevice_open \
  bool			open(  IOService *a, IOOptionBits b= 0, void *c = 0 );//c

#define IOSCSIParallelDevice_getLunParms \
     void			getLunParms( SCSILunParms *a);//c

#define IOSCSIParallelDevice_checkNegotiate \
  void			checkNegotiate( IOSCSIParallelCommand * a);//c

#define IOSCSIParallelDevice_negotiationComplete \
    void			negotiationComplete();//c

#define IOSCSIParallelDevice_checkTag \
   bool			checkTag( IOSCSIParallelCommand * a);//c

#define IOSCSIParallelDevice_allocTag \
    bool 			allocTag( UInt32 *a );//c

#define IOSCSIParallelDevice_freeTag \
    void 			freeTag( UInt32 tagId );//c

#define IOSCSIParallelDevice_findCommandWithNexus \
    IOSCSIParallelCommand       *findCommandWithNexus( UInt32 a );//c

#define IOSCSIParallelDevice_timer \
    void			timer();//c

#define IOSCSIParallelDevice_dispatch \
    bool			dispatch( UInt32 *a );//c

#define IOSCSIParallelDevice_completeCommand \
    void      	          	completeCommand( IOSCSIParallelCommand *a );//c

#define IOSCSIParallelDevice_executeCommandDone \
    void			executeCommandDone(  IOSCSIParallelCommand *a );//c

#define IOSCSIParallelDevice_allocCommand \
IOSCSIParallelCommand	*allocCommand( IOSCSIParallelDevice *a, UInt32 b = 0 );//c

#define IOSCSIParallelDevice_executeReqSenseDone \
    void			executeReqSenseDone( IOSCSIParallelCommand *a );//c

#define IOSCSIParallelDevice_abortCommandDone \
    void 			abortCommandDone(    IOSCSIParallelCommand *a);//c

#define IOSCSIParallelDevice_cancelCommandDone \
    void			cancelCommandDone(   IOSCSIParallelCommand *a );//c

#define IOSCSIParallelDevice_flushQueue \
    void			flushQueue( UInt32 a, IOReturn b);//c

#define IOSCSIParallelDevice_finishCommand \
    void			finishCommand(       IOSCSIParallelCommand *a );//c

#define IOSCSIParallelDevice_createProperties \
    OSDictionary 		*createProperties();//c

#define IOSCSIParallelDevice_addToRegistry \
    bool addToRegistry( OSDictionary *a, OSObject *b, char *c, bool d =0 );//?

#define IOSCSIParallelDevice_stripBlanks \
    void 			stripBlanks( char *a, char *b, UInt32 c);//c

#define IOSCSIParallelDevice_matchPropertyTable \
    bool 			matchPropertyTable( OSDictionary * a);//c

#define IOSCSIParallelDevice_matchLocation \
    IOService 			*matchLocation( IOService * a );//c

#define IOSCSIParallelDevice_allocCommand_IOCDBDevice \
     IOCDBCommand 		*allocCommand( IOCDBDevice *a, UInt32 b = 0 );//c

#define IOSCSIParallelDevice_allocCommand_IOSCSIDevice \
    IOSCSICommand		*allocCommand( IOSCSIDevice *a, UInt32 b = 0 );//c

#define IOSCSIParallelDevice_getWorkLoop \
     IOWorkLoop			*getWorkLoop() const; //c

#define IOSCSIParallelDevice_close \
    void			close( IOService *a, IOOptionBits b = 0 );//c

#define IOSCSIParallelDevice_message \
    IOReturn 			message( UInt32 a, IOService *b, void *c = 0 );//c

#define IOSCSIParallelDevice_free \
    void			free();//c

#define IOSCSIParallelDevice_addCommand \
void 			addCommand( queue_head_t *a, IOSCSIParallelCommand *b );//c

#define IOSCSIParallelDevice_deleteCommand \
void 	deleteCommand( queue_head_t *a, IOSCSIParallelCommand *b, IOReturn c =0);//?

#define IOSCSIParallelDevice_checkCommand \
 IOSCSIParallelCommand 	*checkCommand( queue_head_t *a );//c

#define IOSCSIParallelDevice_getCommand \
IOSCSIParallelCommand 	*getCommand( queue_head_t *a);//c

#define IOSCSIParallelDevice_stackCommand \
void 			stackCommand( queue_head_t *a, IOSCSIParallelCommand *b );//c

#define IOSCSIParallelDevice_moveCommand \
void  moveCommand(queue_head_t  *a, queue_head_t *b,IOSCSIParallelCommand *c,  IOReturn 		d=0);//?

#define IOSCSIParallelDevice_moveAllCommands \
void 	moveAllCommands( queue_head_t *a, queue_head_t *b, IOReturn c =0);//?

#define IOSCSIParallelDevice_findCommand \
  bool findCommand( queue_head_t *a, IOSCSIParallelCommand *b);//c

#define IOSCSIParallelDevice_purgeAllCommands \
    void 			purgeAllCommands( queue_head_t *a, IOReturn b );//c

public://func


};



#endif //HYS_IOKIT_SCSI_IOSCSIPARALLELDEVICE_H
