#ifndef HYS_IOKIT_SCSI_SCSIDEVICE_H
#define HYS_IOKIT_SCSI_SCSIDEVICE_H

#define kSCSITransferOptionsSCSI3	(kSCSITransferOptionClockDT | kSCSITransferOptionQAS | kSCSITransferOptionIUS | kSCSITransferOptionPPR)//c

//////////////////////////////////
#define kSCSIPropertyTarget "kSCSIPropertyTarget"//?
#define kSCSIPropertyLun "kSCSIPropertyLun"//?
#define kSCSIPropertyIOUnit "kSCSIPropertyIOUnit"//?
#define kSCSIPropertyVendorName "kSCSIPropertyVendorName"//?
#define kSCSIPropertyProductName "kSCSIPropertyProductName"//?
#define kSCSIPropertyProductRevision "kSCSIPropertyProductRevision"//?
#define kSCSIPropertyRemovableMedia "kSCSIPropertyRemovableMedia"//?
#define kSCSIPropertyDeviceTypeID "kSCSIPropertyDeviceTypeID"//?
#define kSCSIPropertyTransferPeriod "kSCSIPropertyTransferPeriod"//?
#define kSCSIPropertyTransferOffset "kSCSIPropertyTransferOffset"//?
#define kSCSIPropertyTransferWidth "kSCSIPropertyTransferWidth"//?
#define kSCSIPropertyTransferOptions "kSCSIPropertyTransferOptions"//?
#define kSCSIPropertyCmdQueue "kSCSIPropertyCmdQueue"//?

///////////////////////
#define kSCSIMaxProperties 1//?

enum {
	kSCSIClientMsgDeviceReset,//?
	kSCSIClientMsgDeviceAbort,//?
	kQPositionHead,//?
	kQTypeBypassQ,//?
	kSCSIProbeTimeoutmS,//?
	kSCSIReqSenseTimeoutmS,//?
	kSCSIAbortTimeoutmS,//?
	kSCSITimerIntervalmS=2,//?
	kSCSIResetIntervalmS,//?
	kSCSIClientMsgNone,//?
	kSCSIClientMsgDone=1,//?
	kSCSIClientMsgBusReset,//?
	kQTypeNormalQ,//?
    	kQPositionTail,//?
	kSCSITransferOptionClockDT,//?
	kSCSITransferOptionPPR,//?
	kSCSITransferOptionIUS,//?
	kSCSITransferOptionQAS,//?
};

struct SCSITargetLun{
	int target;//?
	int lun;//?
};
typedef struct SCSITargetLun SCSITargetLun;

struct SCSITargetParms{
	int transferWidth;//?
	int transferOffset;//?
	int transferPeriodpS;//?
	int enableTagQueuing;//?
	int transferOptions;//?
};
typedef struct SCSITargetParms  SCSITargetParms;

struct SCSILunParms {
	int disableDisconnect;//?
};
typedef struct SCSILunParms SCSILunParms;

typedef int SCSIClientMessage;//?

/////////////////

#ifdef __OBJC__
@interface SCSIDevice(hys)
//data
NSString * physicalInterconnect;//c
NSString* manufacturer;//c
NSString* model;//c
NSString* revision;//c
NSString* peripheralDeviceType;//c
NSNumber *domainIdentifier;//c
NSNumber *deviceIdentifier;//c
NSArray *	features;//c
NSImage *image;//c
BOOL devicePresent;//c
BOOL isInitiator;//c

//func
- ( void ) clearInformation;//c
- ( void ) setPhysicalInterconnect: ( NSString * )a;//c
- ( void ) setDomainIdentifier: ( NSNumber * ) a;//c
- ( void ) setDeviceIdentifier: ( NSNumber * ) a;//c
- ( void ) setDevicePresent: ( BOOL ) a;//c
- ( void ) setImage: ( NSImage * ) a;//c
- ( void ) setIsInitiator: ( BOOL ) a;//c
- ( void ) setPeripheralDeviceType: ( NSString * ) a;//c
- ( void ) setManufacturer: ( NSString * ) a;//c
- ( void ) setModel: ( NSString * ) a;//c
- ( void ) setRevision: ( NSString * ) a;//c
- ( NSArray * ) buildFeatureList: ( NSNumber * ) a;//c
- ( void ) setFeatures: ( NSArray * ) a;//c
- ( NSString * ) title;//c
- ( NSNumber * ) deviceIdentifier;//c
- ( NSNumber * ) domainIdentifier;//c
+ ( int ) domainIDForService: ( io_service_t ) a;//c
+ ( int ) targetIDForService: ( io_service_t ) a;//c

@end
#endif //__OBJC__

#endif //HYS_IOKIT_SCSI_SCSIDEVICE_H
