#ifndef HYS_IOKIT_SPI_IOSCSIPARALLELINTERFACECONTROLLER_H
#define HYS_IOKIT_SPI_IOSCSIPARALLELINTERFACECONTROLLER_H

#define kIOMinimumHBADataAlignmentMaskKey "kIOMinimumHBADataAlignmentMaskKey"//?
#define kIOPropertySCSIDeviceFeaturesKey "kIOPropertySCSIDeviceFeaturesKey"//?
#define kIOPropertySCSI_I_T_NexusFeaturesKey "kIOPropertySCSI_I_T_NexusFeaturesKey"//?

enum {
	kSCSIParallelFeature_TotalFeatureCount,//?
	kSCSIParallelFeature_NoNegotiation,//?
	kSCSIParallelFeature_NegotitiationUnchanged,//?
	kSCSIControllerNotificationBusReset=1,//?
	kSCSIParallelFeature_SynchronousDataTransfer,//?
	kSCSIParallelFeature_WideDataTransfer,//?
	kSCSIParallelFeature_InformationUnitTransfers,//?
	kSCSIParallelFeature_QuickArbitrationAndSelection,//?
	kSCSIParallelFeature_DoubleTransitionDataTransfers,//?
	kSCSIParallelTaskControllerIDQueueHead,//?
	kSCSIParallelFeature_AttemptNegotiation,//?
	kSCSIParallelFeature_NegotitiationSuccess,//?
};

typedef OSObject* SCSIParallelTaskIdentifier;//c

typedef int SCSIParallelFeature;//?
typedef int SCSIParallelFeatureRequest;//?
typedef int SCSIParallelFeatureResult;//?

class  IOSCSIParallelInterfaceController_HYS
{
	
	//OSDeclareAbstractStructors ( IOSCSIParallelInterfaceController_HYS )
	
public://data

enum {
	kSCSIParallelDeviceListArrayCount,//?
	kSCSIParallelDeviceListIndexMask,//?
	kSCSIControllerNotificationBusReset,//?
};

OSSet* fClients;//c
IOService* fProvider;//c
IOSimpleLock *  fDeviceLock;//c
SCSIDeviceIdentifier	 fHighestSupportedDeviceID;//c
SCSIInitiatorIdentifier fInitiatorIdentifier;//c
IOWorkLoop *	 fWorkLoop;//c
IOCommandGate * fControllerGate;//c
IOTimerEventSource * fTimerEvent;//c
IOInterruptEventSource * fDispatchEvent;//c
IOCommandPool * fParallelTaskPool;//c

IOSCSIParallelInterfaceDevice * fParallelDeviceList[1];//?
int fSupportedTaskCount;//?
int fHBACanAcceptClientRequests;//?
int fHBAHasBeenInitialized;//?
int fSCSIDomainIdentifier;//?

public://define

#define IOSCSIParallelInterfaceController_GetControllerTaskIdentifier  \
UInt64	GetControllerTaskIdentifier (SCSIParallelTaskIdentifier a);//c
	
#define IOSCSIParallelInterfaceController_RemoveDeviceFromTargetList \
void			RemoveDeviceFromTargetList (IOSCSIParallelInterfaceDevice *a );//c

#define IOSCSIParallelInterfaceController_AddDeviceToTargetList \
void			AddDeviceToTargetList (IOSCSIParallelInterfaceDevice *a );//c

#define IOSCSIParallelInterfaceController_CompleteTargetReset \
void 	CompleteTargetReset (SCSITargetIdentifier a,	SCSIServiceResponse b);//c
	
#define IOSCSIParallelInterfaceController_CompleteLogicalUnitReset \
void 	CompleteLogicalUnitReset (SCSITargetIdentifier  a, SCSILogicalUnitNumber b, SCSIServiceResponse 		c );//c

#define IOSCSIParallelInterfaceController_CompleteClearTaskSet  \
void 	CompleteClearTaskSet (SCSITargetIdentifier  a, SCSILogicalUnitNumber b, SCSIServiceResponse 		c );//c
	
#define IOSCSIParallelInterfaceController_CompleteClearACA \
void 	CompleteClearACA (	SCSITargetIdentifier a, SCSILogicalUnitNumber b, SCSIServiceResponse c );//c

#define IOSCSIParallelInterfaceController_CompleteAbortTaskSet \
void 	CompleteAbortTaskSet (SCSITargetIdentifier a, SCSILogicalUnitNumber b, SCSIServiceResponse c);//c

#define IOSCSIParallelInterfaceController_CompleteAbortTask  \
void	CompleteAbortTask (SCSITargetIdentifier a, SCSILogicalUnitNumber b, SCSITaggedTaskIdentifier c, SCSIServiceResponse d);//c

#define IOSCSIParallelInterfaceController_FilterInterrupt \
static bool		FilterInterrupt (OSObject *a, IOFilterInterruptEventSource *b);//c

#define IOSCSIParallelInterfaceController_ServiceInterrupt  \
static void		ServiceInterrupt (OSObject *a,	IOInterruptEventSource *b, int );//c

#define IOSCSIParallelInterfaceController_TimeoutOccurred \
static void		TimeoutOccurred ( OSObject * a, IOTimerEventSource * b);//c

#define IOSCSIParallelInterfaceController_didTerminate \
bool	didTerminate ( IOService * a, IOOptionBits b, bool *c );//c

#define IOSCSIParallelInterfaceController_willTerminate \
bool	willTerminate ( IOService * a, IOOptionBits b );//?

#define IOSCSIParallelInterfaceController_getWorkLoop \
IOWorkLoop *				getWorkLoop ( void ) const;//c

#define IOSCSIParallelInterfaceController_stop  \
	void			stop ( 	IOService *  		a );//c

#define IOSCSIParallelInterfaceController_ReleaseWorkLoop \
	void 						ReleaseWorkLoop ( void );//c

#define IOSCSIParallelInterfaceController_DeallocateSCSIParallelTasks \
void						DeallocateSCSIParallelTasks ( void );//c

#define IOSCSIParallelInterfaceController_AllocateSCSIParallelTasks \
bool						AllocateSCSIParallelTasks ( void );//c

#define IOSCSIParallelInterfaceController_InitializeDeviceList \
void			InitializeDeviceList ( void );//c

#define IOSCSIParallelInterfaceController_CreateWorkLoop  \
	bool 						CreateWorkLoop ( IOService * a );//c

#define IOSCSIParallelInterfaceController_start \
	bool			start ( IOService * 		a );//c

#define IOSCSIParallelInterfaceController_handleIsOpen \
bool	handleIsOpen (const IOService * 			a ) const;//?

#define IOSCSIParallelInterfaceController_handleClose \
void	handleClose (IOService *a, IOOptionBits b);//?

#define IOSCSIParallelInterfaceController_fSCSIParallelDomainCount \
static SInt32 fSCSIParallelDomainCount;//c

#define IOSCSIParallelInterfaceController_handleOpen \
bool	handleOpen (IOService *a, IOOptionBits b, void *c);//?

public://func

int AbortTaskRequest(int a,int b,int c);//?
int AbortTaskSetRequest(int a, int b);//?
int ClearACARequest(int a,int b);//?
int ClearTaskSetRequest(int a,int b);//?
int LogicalUnitResetRequest(int a,int b);//?
int TargetResetRequest(int a);//?

};

#endif//HYS_IOKIT_SPI_IOSCSIPARALLELINTERFACECONTROLLER_H
