#ifndef HYS_IOKIT_SERIAL_IOSERIALSTREAMSYNC_H
#define HYS_IOKIT_SERIAL_IOSERIALSTREAMSYNC_H

#define PD_OP(x)	((x) << 2)//c
///////////////////////
#define PD_S_ACTIVE		0x40000000UL//c
#define PD_S_MASK		0xffff0000UL//c
#define PD_S_TX_ENABLE		0x20000000UL//c
#define PD_S_ACQUIRED		0x80000000UL//c
#define PD_S_TXQ_HIGH_WATER 	0x01000000UL//c
#define PD_S_TXQ_LOW_WATER 	0x02000000UL//c
#define PD_S_TXQ_EMPTY 		0x04000000UL//c
#define PD_S_RX_OFFSET		7//c
#define PD_S_TX_EVENT 		0x08000000UL//c
#define PD_DATA_MASK 0x03UL//c
#define PD_S_TXQ_FULL 		0x00800000UL//c
#define PD_S_TX_BUSY		0x10000000UL//c
#define PD_DATA_LONG 0x03UL//c
#define PD_DATA_VOID 0x00UL//c
#define PD_DATA_BYTE 0x01UL//c
///////////////////////////////////////////////////////
#define PD_E_FRAMING_BYTE 	(PD_DATA_BYTE|PD_E_FRAMING_ERROR)//c
#define PD_E_SPECIAL_BYTE 	(PD_DATA_BYTE|PD_E_SPECIAL)//c
#define PD_S_RXQ_FULL 		(PD_S_TXQ_FULL       >> PD_S_RX_OFFSET)//c
#define PD_S_RXQ_LOW_WATER	(PD_S_TXQ_LOW_WATER  >> PD_S_RX_OFFSET)//c
#define PD_S_RXQ_HIGH_WATER	(PD_S_TXQ_HIGH_WATER >> PD_S_RX_OFFSET)//c
#define PD_E_EXTERNAL_CLOCK_MODE (PD_DATA_LONG|PD_OP(28))//c
#define PD_S_RXQ_MASK		(PD_S_TXQ_MASK       >> PD_S_RX_OFFSET)//c
#define PD_E_INTEGRITY_ERROR 	(PD_DATA_VOID|PD_OP(24))//c
#define PD_E_FRAMING_ERROR 	(PD_DATA_VOID|PD_OP(23))//c
#define PD_E_MASK	(~PD_DATA_MASK)//c
#define PD_S_RX_EVENT		(PD_S_TX_EVENT       >> PD_S_RX_OFFSET)//c
#define PD_E_SW_OVERRUN_ERROR 	(PD_DATA_VOID|PD_OP(27))//c
#define PD_E_EOQ		(PD_DATA_VOID|PD_OP( 0))//c
#define PD_E_SW_OVERRUN_ERROR 	(PD_DATA_VOID|PD_OP(27))//c
#define PD_E_DATA_SIZE 		(PD_DATA_LONG|PD_OP(14))	//c
#define PD_E_HW_OVERRUN_ERROR 	(PD_DATA_VOID|PD_OP(26))//c
#define PD_E_INTEGRITY_BYTE 	(PD_DATA_BYTE|PD_E_INTEGRITY_ERROR)//c
#define PD_S_RXQ_EMPTY 		(PD_S_TXQ_EMPTY      >> PD_S_RX_OFFSET)//c
#define PD_E_RXQ_AVAILABLE	(PD_DATA_LONG|PD_OP( 9))//c
#define PD_E_RX_DATA_SIZE	(PD_DATA_LONG|PD_OP(15))//c
#define PD_E_DATA_INTEGRITY	(PD_DATA_LONG|PD_OP(16))//c
#define PD_E_TXQ_AVAILABLE	(PD_DATA_LONG|PD_OP( 8))//c
#define PD_E_TXQ_FLUSH 		(PD_DATA_VOID|PD_OP(10))//c
#define PD_E_TXQ_LOW_WATER	(PD_DATA_LONG|PD_OP( 4))//c
#define PD_E_RXQ_SIZE		(PD_DATA_LONG|PD_OP( 3))//c
#define PD_E_TXQ_HIGH_WATER	(PD_DATA_LONG|PD_OP( 6))//c
#define PD_E_RXQ_LOW_WATER	(PD_DATA_LONG|PD_OP( 5))//c
#define PD_E_RXQ_HIGH_WATER	(PD_DATA_LONG|PD_OP( 7))//c
#define PD_E_RXQ_FLUSH		(PD_DATA_LONG|PD_OP(11))//c
#define PD_E_DELAY		(PD_DATA_LONG|PD_OP(18))//c
#define PD_E_RX_DATA_RATE	(PD_DATA_LONG|PD_OP(13))//c
#define PD_S_RX_ENABLE		(PD_S_TX_ENABLE      >> PD_S_RX_OFFSET)//c
#define PD_S_TXQ_MASK		( PD_S_TXQ_EMPTY | PD_S_TXQ_LOW_WATER  | PD_S_TXQ_FULL  | PD_S_TXQ_HIGH_WATER )//c
#define PD_E_RX_DATA_INTEGRITY	(PD_DATA_LONG|PD_OP(17))//c
#define PD_E_DATA_LATENCY	(PD_DATA_LONG|PD_OP(19))	//c
#define PD_E_DATA_RATE 		(PD_DATA_LONG|PD_OP(12))//c
#define PD_E_ACTIVE		(PD_DATA_BYTE|PD_OP( 1))//c
#define PD_E_VALID_DATA_BYTE 	(PD_DATA_BYTE|PD_E_VALID_DATA)//c
#define PD_E_TXQ_SIZE 		(PD_DATA_LONG|PD_OP( 2))//c
#define PD_E_FLOW_CONTROL       (PD_DATA_LONG|PD_OP(20)) //c
#define PD_E_SPECIAL		(PD_DATA_VOID|PD_OP(22))//c
#define PD_E_VALID_DATA 	(PD_DATA_VOID|PD_OP(21))//c

////////////////
class IOSerialStreamSync;//add

class  IOSerialStreamSync_HYS
{
 OSDeclareDefaultStructors(IOSerialStreamSync_HYS);

public://data
void* fRefCon;//?
IOSerialDriverSync *fProvider;//c

public://define

#define IOSerialStreamSync_init \
virtual bool init(OSDictionary *a = 0, void *b = 0);//c

#define IOSerialStreamSync_attach \
 virtual bool attach(IOService *a);//c

#define IOSerialStreamSync_acquirePort \
    virtual IOReturn acquirePort(bool a);//c

#define IOSerialStreamSync_releasePort \
    virtual IOReturn releasePort();//c

#define IOSerialStreamSync_setState \
    virtual IOReturn setState(UInt32 a, UInt32 b);//c

#define IOSerialStreamSync_enqueueEvent \
    virtual IOReturn enqueueEvent(UInt32 a, UInt32 b, bool c);//c

#define IOSerialStreamSync_getState  \
    virtual UInt32 getState();//c

#define IOSerialStreamSync_watchState \
    virtual IOReturn watchState(UInt32 *a, UInt32 b);//c

#define IOSerialStreamSync_nextEvent \
    virtual UInt32 nextEvent();//c

#define IOSerialStreamSync_executeEvent \
    virtual IOReturn executeEvent(UInt32 a, UInt32 b);//c

#define IOSerialStreamSync_enqueueData \
    virtual IOReturn enqueueData(UInt8 *a,  UInt32 b, UInt32 *c, bool d);//c

#define IOSerialStreamSync_requestEvent \
    virtual IOReturn requestEvent(UInt32 a, UInt32 *b);//c

#define IOSerialStreamSync_dequeueEvent \
    virtual IOReturn dequeueEvent(UInt32 *a, UInt32 *b, bool c);//c

#define IOSerialStreamSync_dequeueData \
 virtual IOReturn dequeueData(UInt8 *a, UInt32 b, UInt32 *c, UInt32 d);//c;

public://func

};


#endif

