#ifndef HYS_IOKIT_STORAGE_IOBLOCKSTORAGEDRIVER_H
#define HYS_IOKIT_STORAGE_IOBLOCKSTORAGEDRIVER_H

class IOBlockStorageDriver_HYS
{
    OSDeclareDefaultStructors(IOBlockStorageDriver_HYS);

public://data-define

#define IOBlockStorageDriver_ExpansionData \
    struct ExpansionData  {  \
        bool         mediaDirtied; \
        UInt64       maxReadBlockTransfer; \
        UInt64       maxWriteBlockTransfer; \
        IONotifier * powerEventNotifier; \
        UInt32       deblockRequestWriteLockCount; \
        UInt64       maxReadSegmentTransfer; \
        UInt64       maxWriteSegmentTransfer; \
        UInt64       maxReadSegmentByteTransfer; \
        UInt64       maxWriteSegmentByteTransfer; \
        UInt64       minSegmentAlignmentByteTransfer; \
        UInt64       maxSegmentWidthByteTransfer; \
    };

#define IOBlockStorageDriver__expansionData \
 ExpansionData * _expansionData;//c

public://data
struct Context {
	struct {
		int size;//?
		int type;//?
		int typeSub[1];//?
	} block;
	struct {
		int byteStart;//?
		IOMemoryDescriptor *buffer;//c
		IOStorageCompletion completion;//c
	} original;
	struct {
		IOStorageAttributes attributes;//c
	} request;

	AbsoluteTime timeStart;//c
};

 static const int  kBlockTypeStandard = 0;//?
static const int kStatisticsCount =0;//?

/////////////
IOLock * _deblockRequestWriteLock;//c
OSSet*  _openClients;//c
thread_call_t _pollerCall;//c

OSNumber *  _statistics[1];//?

///////////////////////////

    #define _deblockRequestWriteLockCount    \
              IOBlockStorageDriver::_expansionData->deblockRequestWriteLockCount//c

    #define _maxReadBlockTransfer            \
              IOBlockStorageDriver::_expansionData->maxReadBlockTransfer//c

    #define _maxWriteBlockTransfer           \
              IOBlockStorageDriver::_expansionData->maxWriteBlockTransfer //c

   #define _maxReadSegmentTransfer          \
              IOBlockStorageDriver::_expansionData->maxReadSegmentTransfer//c

    #define _maxWriteSegmentTransfer         \
              IOBlockStorageDriver::_expansionData->maxWriteSegmentTransfer//c

    #define _maxReadSegmentByteTransfer      \
              IOBlockStorageDriver::_expansionData->maxReadSegmentByteTransfer//c

    #define _maxWriteSegmentByteTransfer     \
              IOBlockStorageDriver::_expansionData->maxWriteSegmentByteTransfer//c

    #define _minSegmentAlignmentByteTransfer \
              IOBlockStorageDriver::_expansionData->minSegmentAlignmentByteTransfer//c

    #define _maxSegmentWidthByteTransfer     \
              IOBlockStorageDriver::_expansionData->maxSegmentWidthByteTransfer//c

    #define _powerEventNotifier              \
              IOBlockStorageDriver::_expansionData->powerEventNotifier//v

    #define _mediaDirtied                    \
              IOBlockStorageDriver::_expansionData->mediaDirtied//c

public://define

#define IOBlockStorageDriver_init  \
     bool init(OSDictionary * a = 0);//?

#define IOBlockStorageDriver_getProvider \
     IOBlockStorageDevice * getProvider() const;//?

#define IOBlockStorageDriver_start \
 bool start(IOService * a);//?

#define IOBlockStorageDriver_schedulePoller \
void schedulePoller();//?

#define IOBlockStorageDriver_yield \
bool yield(IOService * a, IOOptionBits b  = 0, void * c = 0);//?

#define IOBlockStorageDriver_free \
   void free();//c

#define IOBlockStorageDriver_unschedulePoller \
void unschedulePoller();//?

#define IOBlockStorageDriver_prepareRequestCompletion \
static void prepareRequestCompletion(void *a, void *b, IOReturn c, UInt64 d);//c

#define IOBlockStorageDriver_poller \
    static void poller(void *a, void *b);//c

#define IOBlockStorageDriver_message \
 IOReturn message(UInt32 a, IOService * b, void * c);//?

#define IOBlockStorageDriver_handlePowerEvent \
static IOReturn handlePowerEvent(void *a, void *b, UInt32 c, IOService *d, void *e, vm_size_t  f);//c

#define IOBlockStorageDriver_isMediaWritable \
bool isMediaWritable() const;//?

#define IOBlockStorageDriver_stop \
void stop(IOService * a);//?

#define IOBlockStorageDriver_deblockRequestCompletion \
static void deblockRequestCompletion(void *a, void *b, IOReturn c, UInt64 d);//c

#define IOBlockStorageDriver_breakUpRequestCompletion \
static void breakUpRequestCompletion(void *a, void *b, IOReturn c, UInt64  d);//c

#define IOBlockStorageDriver_prepareRequest \
void prepareRequest(UInt64 a, IOMemoryDescriptor *b, IOStorageAttributes *c, IOStorageCompletion *d);//?

#define IOBlockStorageDriver_getProperty \
OSObject *	getProperty(const OSSymbol * a) const;//?

public://func


};

#endif//HYS_IOKIT_STORAGE_IOBLOCKSTORAGEDRIVER_H
