#ifndef HYS_IOKIT_USB_IOUSBCOMMAND_H
#define HYS_IOKIT_USB_IOUSBCOMMAND_H


enum usbCommand {
	READ,//?
    	WRITE,//?
	DEVICE_REQUEST_BUFFERCOMMAND,//?
	DEVICE_REQUEST,//?
	DEVICE_REQUEST_DESC,//?
};
typedef enum usbCommand usbCommand;

class IOUSBCommand;//add
//////////////////
class  IOUSBCommand_HYS
{
    //OSDeclareAbstractStructors(IOUSBCommand_HYS)

public://data

struct ExpansionData{
	IOUSBCommand*_masterUSBCommand;//c
	int _reqCount;//?
	IOMemoryDescriptor* _requestMemoryDescriptor;//c
	IOMemoryDescriptor* _bufferMemoryDescriptor;//c
	int _multiTransferTransaction;//?
	int _finalTransferInTransaction;//?
	int _useTimeStamp;//?
	AbsoluteTime _timeStamp;//c
	int _isSyncTransfer;//?
	IOUSBCommand* _bufferUSBCommand;//c
};
ExpansionData * 		_expansionData;
////////////////////

IOUSBDeviceRequestPtr _request;//c
IOMemoryDescriptor * _buffer;//c
IOUSBCompletion _uslCompletion;//c
IOUSBCompletion _clientCompletion;//c
IOMemoryDescriptor *_origBuffer;//c
IOUSBCompletion _disjointCompletion;//c
UInt32 _UIMScratch[10];//c
usbCommand _selector;//c

int _completionTimeout;//c
int _noDataTimeout;//?
int _dblBufLength;//?
int _status;//?
int _stage;//?
int _dataRemaining;//?
int _bufferRounding;//?
int _type;//?
int _direction;//?
int _endpoint;//?
int _address;//?

public://define

#define IOUSBCommand_GetUSLCompletion \
    IOUSBCompletion				GetUSLCompletion(void);//c

#define IOUSBCommand_GetBuffer \
    IOMemoryDescriptor *		GetBuffer(void);//c

#define IOUSBCommand_GetBufferRounding \
   bool						GetBufferRounding(void);//c

#define IOUSBCommand_GetType \
    UInt8						GetType(void);//c

#define IOUSBCommand_GetEndpoint \
    UInt8						GetEndpoint(void);//c

#define IOUSBCommand_GetDirection \
    UInt8						GetDirection(void);//c

#define IOUSBCommand_GetAddress \
    USBDeviceAddress			GetAddress(void);//c

#define IOUSBCommand_GetRequest \
    IOUSBDeviceRequestPtr		GetRequest(void);//c

#define IOUSBCommand_GetSelector \
  usbCommand					GetSelector(void);//c

#define IOUSBCommand_SetBufferUSBCommand \
	void					SetBufferUSBCommand(IOUSBCommand *a);//c

#define IOUSBCommand_SetIsSyncTransfer \
	void					SetIsSyncTransfer(bool a);//c

#define IOUSBCommand_SetTimeStamp \
    void					SetTimeStamp(AbsoluteTime a);//c

#define IOUSBCommand_SetUseTimeStamp \
    void					SetUseTimeStamp(bool a);//c

#define IOUSBCommand_SetFinalTransferInTransaction \
    void					SetFinalTransferInTransaction(bool a);//c

#define IOUSBCommand_SetBufferMemoryDescriptor \
    void					SetBufferMemoryDescriptor(IOMemoryDescriptor *a);//c

#define IOUSBCommand_SetRequestMemoryDescriptor \
    void					SetRequestMemoryDescriptor(IOMemoryDescriptor *a);//c

#define IOUSBCommand_SetReqCount \
    void 					SetReqCount(IOByteCount a);//c

#define IOUSBCommand_SetUIMScratch \
  void 					SetUIMScratch(UInt32 a, UInt32 b);//c

#define IOUSBCommand_SetCompletionTimeout \
    void 					SetCompletionTimeout(UInt32 a);//c

#define IOUSBCommand_SetNoDataTimeout \
  void 					SetNoDataTimeout(UInt32 a);//c

#define IOUSBCommand_SetDblBufLength \
void 					SetDblBufLength(IOByteCount a);//c

#define IOUSBCommand_SetDisjointCompletion \
    void 					SetDisjointCompletion(IOUSBCompletion a);//c

#define IOUSBCommand_SetOrigBuffer \
    void 					SetOrigBuffer(IOMemoryDescriptor *a);//c

#define IOUSBCommand_SetStatus \
    void 					SetStatus(IOReturn a);//c

#define IOUSBCommand_SetStage \
    void  					SetStage(UInt8 a);//c

#define IOUSBCommand_SetDataRemaining \
    void  					SetDataRemaining(UInt32 a);//c

#define IOUSBCommand_SetUSLCompletion \
    void  					SetUSLCompletion(IOUSBCompletion a);//c

#define IOUSBCommand_SetClientCompletion \
    void  					SetClientCompletion(IOUSBCompletion a);//c

#define IOUSBCommand_SetBuffer \
    void  					SetBuffer(IOMemoryDescriptor *a);//c

#define IOUSBCommand_SetBufferRounding \
  void  					SetBufferRounding(bool a);//c

#define IOUSBCommand_SetType \
    void  					SetType(UInt8 a);//c

#define IOUSBCommand_NewCommand \
    static IOUSBCommand *	NewCommand(void);//c

#define IOUSBCommand_init \
bool init();//?

#define IOUSBCommand_free \
void free();//?

#define IOUSBCommand_SetSelector \
    void					SetSelector(usbCommand a);//c

#define IOUSBCommand_SetRequest \
void  					SetRequest(IOUSBDeviceRequestPtr a);//c

#define IOUSBCommand_SetAddress \
    void  					SetAddress(USBDeviceAddress a);//c

#define IOUSBCommand_SetEndpoint \
    void  					SetEndpoint(UInt8 a);//c

#define IOUSBCommand_SetDirection \
    void  					SetDirection(UInt8 a);//c

#define IOUSBCommand_GetUIMScratch \
    UInt32						GetUIMScratch(UInt32 a);//c

#define IOUSBCommand_GetCompletionTimeout \
    UInt32						GetCompletionTimeout(void);//c

#define IOUSBCommand_GetNoDataTimeout \
    UInt32						GetNoDataTimeout(void);//c

#define IOUSBCommand_SetMultiTransferTransaction \
 void					SetMultiTransferTransaction(bool a);//c

#define IOUSBCommand_GetClientCompletion \
    IOUSBCompletion				GetClientCompletion(void);//c

#define IOUSBCommand_GetDataRemaining \
    UInt32						GetDataRemaining(void);//c

#define IOUSBCommand_GetStage \
    UInt8						GetStage(void);//c

#define IOUSBCommand_GetStatus \
    IOReturn					GetStatus(void);//c

#define IOUSBCommand_GetOrigBuffer \
    IOMemoryDescriptor *		GetOrigBuffer(void);//c

#define IOUSBCommand_GetDisjointCompletion \
    IOUSBCompletion				GetDisjointCompletion(void);//c

#define IOUSBCommand_GetDblBufLength \
   IOByteCount					GetDblBufLength(void);//c

#define IOUSBCommand_GetReqCount \
    IOByteCount					GetReqCount(void);//c

#define IOUSBCommand_GetRequestMemoryDescriptor \
    IOMemoryDescriptor *		GetRequestMemoryDescriptor(void);//c

#define IOUSBCommand_GetMultiTransferTransaction \
    bool						GetMultiTransferTransaction(void);//c

#define IOUSBCommand_GetFinalTransferInTransaction \
    bool						GetFinalTransferInTransaction(void);//c

#define IOUSBCommand_GetBufferMemoryDescriptor \
    IOMemoryDescriptor *		GetBufferMemoryDescriptor(void);//c

#define IOUSBCommand_GetTimeStamp \
    AbsoluteTime				GetTimeStamp(void);//c

#define IOUSBCommand_GetUseTimeStamp \
    bool						GetUseTimeStamp(void);//c

#define IOUSBCommand_GetIsSyncTransfer \
	bool						GetIsSyncTransfer(void);//c

public:

inline IODMACommand * GetDMACommand(void) {};//c
inline void SetDMACommand(IODMACommand *a){};//c?
inline IOUSBCommand *	GetBufferUSBCommand(void) {};//c

};
///////////////

class  IOUSBIsocCommand_HYS
{
   // OSDeclareAbstractStructors(IOUSBIsocCommand_HYS)

public://data

struct ExpansionData{};
 ExpansionData * 		_expansionData;

public://define

#define IOUSBIsocCommand_init \
 bool init();//?

#define IOUSBIsocCommand_free \
 void free();//?

#define IOUSBIsocCommand_NewCommand \
    static IOUSBIsocCommand *NewCommand(void);//c

public:
void	SetDMACommand(IODMACommand *dmaCommand) {};//?c	
int GetLowLatency();//?
int GetIsRosettaClient();//?
int GetUpdateFrequency();//?
IOUSBIsocFrame* GetFrameList();//?
int GetNumFrames();//?
IOMemoryDescriptor* GetBuffer();//?
int GetStartFrame();//?
IOUSBIsocCompletion GetUSLCompletion();//?
int GetEndpoint();//?
int GetAddress();//?
int GetDirection();//?
int SetUpdateFrequency(int a);//?
int SetLowLatency(int a);//?
int SetFrameList(IOUSBIsocFrame *a);//?
int SetNumFrames(int a);//?
int SetStartFrame(int a);//?
int SetCompletion(IOUSBIsocCompletion a);//?
int SetBuffer(IOMemoryDescriptor* a);//?
int SetEndpoint(int a);//?
int SetAddress(int a);//?
int SetUseTimeStamp(int a);//?
int SetDirection(int a);//?
int SetRosettaClient(int a);//?
IODMACommand * GetDMACommand();//?
int SetIsSyncTransfer(int a);//?
int SetSelector(int a);//?

public://inline func
bool	GetIsSyncTransfer(void) {};//c
IOUSBIsocCompletion GetCompletion(void) {};//c
IOReturn		GetStatus(void)	 {};//c
void		SetUSLCompletion(IOUSBIsocCompletion a)	{};//c
void	SetStatus(IOReturn a) {};//c

};//IOUSBIsocCommand_HYS
#endif//HYS_IOKIT_USB_IOUSBCOMMAND_H
