#ifndef HYS_IOKIT_USB_IOUSBCONTROLLER_H
#define HYS_IOKIT_USB_IOUSBCONTROLLER_H

enum {
	kErrataCMDDisableTestMode,//?
	kErrataOnlySinglePageTransfers,//?
	kErrataLSHSOpti,//?
	kErrataICH6PowerSequencing,//?
	kErrataDisableOvercurrent,//?
	kErrataAgereEHCIAsyncSched,//?
	kErrataUHCISupportsOvercurrent,//?
	kErrataRetryBufferUnderruns,//?
	kErrataNeedsOvercurrentDebounce,//?
	kErrataSupportsPortResumeEnable,//?
	kErrataNECIncompleteWrite,//?
	kErrataNeedsWatchdogTimer,//?
	kErrataLucentSuspendResume,//?
	kErrataNECOHCIIsochWraparound,//?
	kErrataNeedsPortPowerOff,//?
	kErrataICH7ISTBuffer,//?
	kUSBWatchdogTimeoutMS,//?
};

///////////
struct ErrataListEntryStruct {
	int vendID;//?
	int deviceID;//?
	int revisionLo;//?
	int revisionHi;//?
	int errata;//?
};
typedef struct ErrataListEntryStruct  ErrataListEntry, *ErrataListEntryPtr;
///////////////

void IOUSBSyncCompletion(void *a, void *b, IOReturn c, UInt32 d);//c
void  IOUSBSyncIsoCompletion(void *a, void * b, IOReturn c, IOUSBIsocFrame *d);//c

///////////

class  IOUSBController_HYS
{
    //OSDeclareAbstractStructors(IOUSBController_HYS)

public://data
struct ExpansionData {
	int _pcCardEjected;//?
	IOCommandPool* freeUSBCommandPool;//c
	IOCommandPool* freeUSBIsocCommandPool;//c
	int _controllerCanSleep;//?
	int _controllerSpeed;//?
	int _watchdogTimerActive;//?
	IOService* _provider;//c
	IOTimerEventSource	*watchdogUSBTimer;//c
 	thread_call_t _terminatePCCardThread;//c
	int _addressPending[128];//?
	int _currentSizeOfCommandPool;//?
	int _currentSizeOfIsocCommandPool;//?
	int _activeIsochTransfers;//?
	int _needToClose;//?
	int _busNumber;//?
};
ExpansionData *_expansionData;
////////////////////////////////

IOCommandGate * _commandGate;//c
IOUSBWorkLoop* _workLoop;//c
IOUSBRootHubDevice* _rootHubDevice;//c

int _devZeroLock;//?

public://data-define


#define IOUSBController_gUsedBusIDs \
static bool gUsedBusIDs[256];//c

#define IOUSBController__busCount \
static UInt32			_busCount;//c

#define IOUSBController_gIOUSBPlane \
static const IORegistryPlane	*gIOUSBPlane;//c

#define IOUSBController__log \
 static IOUSBLog		*_log;//c

public://define

#define IOUSBController_UIMCreateInterruptTransfer_short_short_IOUSBCompletion_IOMemoryDescriptor_bool_UInt32_short \
IOReturn UIMCreateInterruptTransfer(short a, short b, IOUSBCompletion c, IOMemoryDescriptor* d, bool e, UInt32 f, short g);//??

#define IOUSBController_UIMCreateBulkTransfer_short_short_IOUSBCompletion_IOMemoryDescriptor_bool_UInt32_short \
IOReturn 	UIMCreateBulkTransfer(short a, short b, IOUSBCompletion c, IOMemoryDescriptor *d, bool e, UInt32 f, short g);//??

#define IOUSBController_ParsePCILocation \
    void	ParsePCILocation(const char *a, int *b, int *c);//c

#define IOUSBController_ValueOfHexDigit \
    int		ValueOfHexDigit(char a);//c

#define IOUSBController_free \
void free();//?

#define IOUSBController_finalize \
bool 		finalize(IOOptionBits a);//?

#define IOUSBController_stop \
void 		stop( IOService * a);//?

#define IOUSBController_didTerminate \
bool		didTerminate( IOService * a, IOOptionBits b, bool * c);//?

#define IOUSBController_message \
IOReturn 	message( UInt32 a, IOService *b,  void * c = 0 );//?

#define IOUSBController_PolledRead \
IOReturn PolledRead(short a, short b, IOUSBCompletion	c, IOMemoryDescriptor *d, bool e, UInt32 f);//?

#define IOUSBController_MakeHubDevice \
    IOUSBHubDevice *	MakeHubDevice(USBDeviceAddress *a); //c

#define IOUSBController_MakeDevice \
    IOUSBDevice *		MakeDevice(USBDeviceAddress *a); //c

#define IOUSBController_SetDeviceZeroAddress \
    IOReturn			SetDeviceZeroAddress(USBDeviceAddress a);//c

#define  IOUSBController_GetDeviceZeroDescriptor \
    IOReturn	GetDeviceZeroDescriptor( IOUSBDeviceDescriptor * a , UInt16 b);//c

#define IOUSBController_ConfigureDeviceZero \
    IOReturn			ConfigureDeviceZero( UInt8 a, UInt8 b);//c

#define IOUSBController_WaitForReleaseDeviceZero \
    void				WaitForReleaseDeviceZero( void );//c

#define IOUSBController_ProtectedDevZeroLock \
static IOReturn	ProtectedDevZeroLock(OSObject *a, void*b, void *c, void *d, void*e);//c

#define IOUSBController_UIMCheckForTimeouts \
void UIMCheckForTimeouts(void);//?

#define IOUSBController_USBErrorToString \
	static const char *		USBErrorToString(IOReturn a);//c

#define IOUSBController_IsocCompletionHandler \
static void	 IsocCompletionHandler(OSObject *a, void *b, IOReturn c, IOUSBIsocFrame *d);//c

#define IOUSBController_LowLatencyIsocTransaction \
  IOReturn    		LowLatencyIsocTransaction( IOUSBIsocCommand *  a );//c

#define IOUSBController_IsocTransaction \
  IOReturn    		IsocTransaction( IOUSBIsocCommand *  a);//c

#define IOUSBController_CompleteWithTimeStamp \
void	CompleteWithTimeStamp (IOUSBCompletionWithTimeStamp a, IOReturn	b, UInt32 c, AbsoluteTime	d);//c

#define IOUSBController_BulkPacketHandler \
static void	 BulkPacketHandler(OSObject *a, void *b, IOReturn c, UInt32 d);//c

#define IOUSBController_BulkTransaction \
    IOReturn    		BulkTransaction( IOUSBCommand *a);//c

#define IOUSBController_InterruptPacketHandler \
static void	 InterruptPacketHandler(OSObject *a, void *b, IOReturn c, UInt32 d);//c

#define  IOUSBController_UIMCreateControlTransfer_short_short_IOUSBCommand_void_bool_UInt32_short \
IOReturn UIMCreateControlTransfer(short a, short b, IOUSBCommand*	c, void* d, bool	 e, UInt32 f, short g);//?

#define IOUSBController_UIMCreateControlTransfer_short_short_IOUSBCommand_IOMemoryDescriptor_bool_UInt32_short \
 IOReturn 	UIMCreateControlTransfer(short a, short b, IOUSBCommand* c, IOMemoryDescriptor* d, bool e, UInt32 f,  short g);//?

#define IOUSBController_UIMCreateControlTransfer_short_short_IOUSBCompletion_void_bool_UInt32_short \
 IOReturn 	UIMCreateControlTransfer(short a, short b, IOUSBCompletion	c,  void *d, bool e,  UInt32 f, short	g) ;//??

#define  IOUSBController_InterruptTransaction \
    IOReturn    		InterruptTransaction( IOUSBCommand * a );//c

#define IOUSBController_ControlPacketHandler \
static void	 ControlPacketHandler(OSObject *a, void *b, IOReturn c, UInt32 d);//c

#define IOUSBController_ControlTransaction \
    IOReturn    		ControlTransaction( IOUSBCommand * a);//c

#define IOUSBController_getWorkLoop \
IOWorkLoop *	getWorkLoop() const;//?

#define IOUSBController_CreateRootHubDevice \
IOReturn CreateRootHubDevice( IOService *a, IOUSBRootHubDevice ** b);//?

#define IOUSBController_CreateDevice \
IOReturn	CreateDevice(	IOUSBDevice *a, USBDeviceAddress b, UInt8	c, UInt8 d, UInt32 e);//c

#define IOUSBController_TerminatePCCard \
    static void 		TerminatePCCard(OSObject *a);//c

#define IOUSBController_WatchdogTimer \
static void			WatchdogTimer(OSObject *a, IOTimerEventSource *b);//c

#define IOUSBController_start \
bool 		start( IOService *  a);//?

#define IOUSBController_GetCommandGate \
    IOCommandGate *		GetCommandGate(void);//c

#define DeviceRequest_IOUSBDevRequestDesc_IOUSBCompletion_USBDeviceAddress_UInt8 \
IOReturn 	DeviceRequest(IOUSBDevRequestDesc *a, IOUSBCompletion *b, USBDeviceAddress c, UInt8 d);//?

#define IOUSBController_DeviceRequest_IOUSBDevRequestDesc_IOUSBCompletion_USBDeviceAddress_UInt8_UInt32_UInt32 \
IOReturn DeviceRequest(  IOUSBDevRequestDesc *a, IOUSBCompletion *b,  USBDeviceAddress 	c, UInt8 d,	 UInt32 e, UInt32 f);//?

#define IOUSBController_init \
bool 		init( OSDictionary *  a);//?

#define IOUSBController_CheckForDisjointDescriptor \
IOReturn CheckForDisjointDescriptor(IOUSBCommand *a, UInt16 b);//?

#define IOUSBController_GetErrataBits \
UInt32 GetErrataBits(UInt16 a, UInt16 b,  UInt16 c);//?

#define IOUSBController_Complete \
void 	Complete(IOUSBCompletion a,  IOReturn	b, UInt32	c = 0 );//c

#define IOUSBController_DoCreateEP \
static IOReturn 	DoCreateEP(OSObject *a, void *b,  void *c,  void *d, void *e );//c

#define IOUSBController_DoDeleteEP \
static IOReturn 	DoDeleteEP(OSObject *a, void *b,  void *c,  void *d, void *e );//c

#define IOUSBController_DoAbortEP \
static IOReturn 	DoAbortEP(OSObject *a, void *b,  void *c,  void *d, void *e );//c

#define IOUSBController_DoClearEPStall \
static IOReturn 	DoClearEPStall(OSObject *a, void *b,  void *c,  void *d, void *e );//c

#define IOUSBController_IncreaseCommandPool \
    void 	IncreaseCommandPool();//c

#define IOUSBController_DoIOTransfer \
static IOReturn 	DoIOTransfer(OSObject *a, void *b,  void *c,  void *d, void *e );//c

#define IOUSBController_IncreaseIsocCommandPool \
    void	IncreaseIsocCommandPool();//c

#define IOUSBController_GetNewAddress \
    USBDeviceAddress		GetNewAddress( void );//c

#define IOUSBController_DoIsocTransfer \
static IOReturn 	DoIsocTransfer(OSObject *a, void *b,  void *c,  void *d, void *e );//c

#define IOUSBController_DoLowLatencyIsocTransfer \
static IOReturn 	DoLowLatencyIsocTransfer(OSObject *a, void *b,  void *c,  void *d, void *e );//c

#define IOUSBController_DoControlTransfer \
static IOReturn 	DoControlTransfer(OSObject *a, void *b,  void *c,  void *d, void *e );//c

public://data

IOReturn GetRootHubStringDescriptor(UInt8	a, OSData *b) ;//?c

};

#endif//HYS_IOKIT_USB_IOUSBCONTROLLER_H
