#ifndef HYS_IOKIT_USB_IOUSBCONTROLLERV2_H
#define HYS_IOKIT_USB_IOUSBCONTROLLERV2_H

enum {
	kUSBHSHubCommandAddHub,//?
	kUSBHSHubCommandRemoveHub,//?
	kUSBHSHubFlagsMultiTT,//?
};
/////////////////
class IOUSBControllerV2_HYS
{
   // OSDeclareAbstractStructors(IOUSBControllerV2_HYS)

public://data

struct V2ExpansionData {
	IOUSBControllerIsochEndpoint	* _isochEPList;//c
	thread_call_t _returnIsochDoneQueueThread;//c
	UInt8	 _multiTT[128];//c
	IOUSBControllerIsochEndpoint	*_freeIsochEPList;//c
};
V2ExpansionData *_v2ExpansionData;

UInt8 _highSpeedPort[128];//c
UInt8 _highSpeedHub[128];//c

public://define
#define _pcCardEjected _expansionData->_pcCardEjected//c
#define _controllerSpeed	 _expansionData->_controllerSpeed//c
#define _isochEPList _v2ExpansionData->_isochEPList//c
#define _returnIsochDoneQueueThread	_v2ExpansionData->_returnIsochDoneQueueThread//c
#define _activeIsochTransfers	_expansionData->_activeIsochTransfers//c
#define _freeUSBCommandPool	_expansionData->freeUSBCommandPool//c
#define _freeIsochEPList					_v2ExpansionData->_freeIsochEPList//c
#define _watchdogUSBTimer	_expansionData->watchdogUSBTimer//c
#define _watchdogTimerActive				_expansionData->_watchdogTimerActive//c

public://define

#define IOUSBControllerV2_GetTDfromDoneQueue \
IOUSBControllerIsochListElement *GetTDfromDoneQueue(IOUSBControllerIsochEndpoint* a);//?c
	
#define IOUSBControllerV2_GetTDfromDeferredQueue \
 IOUSBControllerIsochListElement *GetTDfromDeferredQueue(IOUSBControllerIsochEndpoint* a);//?c

#define IOUSBControllerV2_AllocateIsochEP \
IOUSBControllerIsochEndpoint*		AllocateIsochEP(void);	//?c

#define IOUSBControllerV2_DOSetTestMode \
static IOReturn DOSetTestMode(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBControllerV2_UIMHubMaintenance \
IOReturn UIMHubMaintenance(USBDeviceAddress a, UInt32 b, UInt32 c, UInt32 d);//?c

#define IOUSBControllerV2_UIMSetTestMode \
IOReturn		UIMSetTestMode(UInt32 a, UInt32 b);//?c

#define IOUSBControllerV2_DOHSHubMaintenanc \
static IOReturn DOHSHubMaintenance(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBControllerV2_init \
 bool 		init( OSDictionary *  a);//?

#define IOUSBControllerV2_start \
bool 		start( IOService *  a );//?c

#define IOUSBControllerV2_free \
void		free();//?c

#define IOUSBControllerV2_SetTestMode \
IOReturn		SetTestMode(UInt32 a, UInt32 b);//?c

#define IOUSBControllerV2_ReturnIsochDoneQueueEntry \
static void ReturnIsochDoneQueueEntry(OSObject *a, thread_call_param_t b);//c

#define IOUSBControllerV2_AddHSHub \
IOReturn	AddHSHub(USBDeviceAddress a, UInt32 b);//?c

#define IOUSBControllerV2_clearTTHandler \
static void	 clearTTHandler(OSObject *a, void *b, IOReturn c, UInt32	d);//c

#define IOUSBControllerV2_RemoveHSHub \
IOReturn		RemoveHSHub(USBDeviceAddress a);//?c

#define IOUSBControllerV2_ClearTT \
void ClearTT(USBDeviceAddress a, UInt8 b, Boolean c);//?c

#define IOUSBControllerV2_DoCreateEP \
static IOReturn  DoCreateEP(OSObject *a, void *b, void *c,void *d, void *e);//c

#define IOUSBControllerV2_GetNewDMACommand \
IODMACommand						*GetNewDMACommand();//?c

#define IOUSBControllerV2_PutTDonDeferredQueue \
void	PutTDonDeferredQueue(IOUSBControllerIsochEndpoint* a, IOUSBControllerIsochListElement *b);//?c

#define IOUSBControllerV2_GetTDfromToDoList \
IOUSBControllerIsochListElement *GetTDfromToDoList(IOUSBControllerIsochEndpoint* a);//?c

#define IOUSBControllerV2_PutTDonToDoList \
void	PutTDonToDoList(IOUSBControllerIsochEndpoint* a, IOUSBControllerIsochListElement *b);//?c

#define IOUSBControllerV2_DeallocateIsochEP \
IOReturn	DeallocateIsochEP(IOUSBControllerIsochEndpoint *a);//?c

#define IOUSBControllerV2_CreateIsochronousEndpoint \
IOUSBControllerIsochEndpoint* CreateIsochronousEndpoint(short a, short b, short c);//?c

#define IOUSBControllerV2_FindIsochronousEndpoint \
IOUSBControllerIsochEndpoint* FindIsochronousEndpoint(short a, short b, short c, IOUSBControllerIsochEndpoint* *d);//?c

#define IOUSBControllerV2_ReturnIsochDoneQueue \
void		ReturnIsochDoneQueue(IOUSBControllerIsochEndpoint* a);//?c

#define IOUSBControllerV2_PutTDonDoneQueue \
 void	PutTDonDoneQueue(IOUSBControllerIsochEndpoint* a, IOUSBControllerIsochListElement *b, bool c);//?c

#define IOUSBControllerV2_GetMicroFrameNumber \
UInt64		GetMicroFrameNumber( void );//?c

public://func

};

#endif//HYS_IOKIT_USB_IOUSBCONTROLLERV2_H
