#ifndef HYS_IOKIT_USB_IOUSBCONTROLLERV3_H
#define HYS_IOKIT_USB_IOUSBCONTROLLERV3_H

#define kUSBPowerStateStable 1//?
#define kIOUSBMaxRootHubTransactions 2//?

////////////////
enum {
	kUSBBusStateReset,//?
	kUSBPowerStateLowPower,//?
	kUSBPowerStateOn,//?
	kUSBBusStateSuspended,//?
	kUSBBusStateRunning,//?
	kUSBPowerStateSleep,//?
	kUSBPowerStateOff,//?
	kUSBPowerStateRestart,//?
	kUSBNumberBusPowerStates,//?
};
/////////////////

struct IOUSBRootHubInterruptTransaction  {
    	IOMemoryDescriptor *buf;//.c
    	UInt32 bufLen;//c
   	IOUSBCompletion completion;//c
};
typedef struct IOUSBRootHubInterruptTransaction  IOUSBRootHubInterruptTransaction;

//////////////////////
class IOUSBControllerV3;//add

class IOUSBControllerV3_HYS
{	
//OSDeclareAbstractStructors(IOUSBControllerV3_HYS)

public://data

IOPCIDevice* _device;//c
IOPMPowerState* _myPowerStates;//c
SInt32 _powerStateChangingTo;//c
IOTimerEventSource	 *_rootHubTimer;//c
IOUSBControllerV3	*_ehciController;//c
bool	_restarting;//c
bool _poweringDown;//c
bool _needToAckPowerDown;//c
unsigned long	_numPowerStates;//c
UInt8 _rootHubPollingRate;//c
IOUSBRootHubInterruptTransaction	_outstandingRHTrans[kIOUSBMaxRootHubTransactions];//c

int _myPowerState;//?
int _rootHubStatusChangedBitmap;//?
int _wakingFromHibernation;//?
int _rootHubNumPorts;//?
int _controllerAvailable;//?
int _onCardBus;//?
int _myBusState;//?

#define IOUSBControllerV3__gHibernateState \
static uint32_t *		_gHibernateState;//c

public://define

#define IOUSBControllerV3_SetTestMode \
IOReturn		SetTestMode(UInt32 a, UInt32 b);//?c

#define IOUSBControllerV3_ReadV2 \
IOReturn	ReadV2(IOMemoryDescriptor *a, USBDeviceAddress b, Endpoint *c, IOUSBCompletionWithTimeStamp *d, UInt32 e, UInt32 f, IOByteCount g);//?c
	
#define IOUSBControllerV3_AddHSHub \
IOReturn		AddHSHub(USBDeviceAddress a, UInt32 b);//?c

#define IOUSBControllerV3_RemoveHSHub \
IOReturn		RemoveHSHub(USBDeviceAddress a);//?c

#define IOUSBControllerV3_Write \
IOReturn Write(IOMemoryDescriptor *a, USBDeviceAddress b, Endpoint *c, IOUSBCompletion *d, UInt32 e, UInt32 f, IOByteCount g);//?c

#define IOUSBControllerV3_AbortPipe \
IOReturn 		AbortPipe(USBDeviceAddress a, Endpoint *b);//?c

#define IOUSBControllerV3_ClosePipe \
IOReturn 		ClosePipe(USBDeviceAddress a, Endpoint *b);//?c

#define IOUSBControllerV3_DeviceRequest_IOUSBDevRequest \
IOReturn DeviceRequest(IOUSBDevRequest *a, IOUSBCompletion *b, USBDeviceAddress c, UInt8 d, UInt32 e, UInt32 f);//c

#define IOUSBControllerV3_DeviceRequest \
IOReturn DeviceRequest(IOUSBDevRequestDesc *a, IOUSBCompletion *b, USBDeviceAddress c, UInt8 d, UInt32 e, UInt32 f);//?c

#define IOUSBControllerV3_ReleaseDeviceZero \
void			ReleaseDeviceZero( void );//?c

#define IOUSBControllerV3_DozeController \
 IOReturn				DozeController(void) ;//??c

#define IOUSBControllerV3_AcquireDeviceZero \
IOReturn 		AcquireDeviceZero( void );//?c

#define IOUSBControllerV3_RestoreControllerStateFromSleep \
IOReturn				RestoreControllerStateFromSleep(void);//??c

#define IOUSBControllerV3_RootHubStopTimer \
IOReturn				RootHubStopTimer(void);//?c
	
#define IOUSBControllerV3_RestartControllerFromReset \
 IOReturn				RestartControllerFromReset(void);//??c

#define IOUSBControllerV3_ClearPipeStall \
IOReturn 		ClearPipeStall(USBDeviceAddress a, Endpoint *b);//?c

#define IOUSBControllerV3_CheckForRootHubChanges \
 IOReturn				CheckForRootHubChanges(void);//?c

#define IOUSBControllerV3_Read \
IOReturn Read(IOMemoryDescriptor *a, USBDeviceAddress b, Endpoint *c, IOUSBCompletion *d, UInt32 e, UInt32 f, IOByteCount g);//?c

#define IOUSBControllerV3_ResetPipe \
IOReturn 		ResetPipe(USBDeviceAddress a, Endpoint *b);//?c

#define IOUSBControllerV3_SaveControllerStateForSleep \
IOReturn				SaveControllerStateForSleep(void);//??c

#define IOUSBControllerV3_GatedPowerChange \
static IOReturn	GatedPowerChange(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBControllerV3_EnableInterruptsFromController \
IOReturn				EnableInterruptsFromController(bool a);//??c

#define IOUSBControllerV3_ControllerDoze \
void					ControllerDoze(void);//?c

#define IOUSBControllerV3_WakeControllerFromDoze \
IOReturn				WakeControllerFromDoze(void);//??c

#define IOUSBControllerV3_ControllerRestart \
void					ControllerRestart(void);//?c

#define IOUSBControllerV3_ControllerSleep \
void					ControllerSleep(void);//?c

#define IOUSBControllerV3_ControllerOff \
void					ControllerOff(void);//?c

#define IOUSBControllerV3_UIMEnableAllEndpoints \
IOReturn				UIMEnableAllEndpoints(bool a) ;//??c

#define IOUSBControllerV3_ControllerOn \
void					ControllerOn(void);//?c

#define IOUSBControllerV3_IsocIO_IOMemoryDescriptor \
IOReturn IsocIO(IOMemoryDescriptor *a, UInt64 b, UInt32 c, IOUSBIsocFrame *d, USBDeviceAddress e, Endpoint *f, IOUSBIsocCompletion *g);//?c

#define IOUSBControllerV3_IsocIO \
IOReturn	IsocIO(IOMemoryDescriptor *a, UInt64 b, UInt32 c, IOUSBLowLatencyIsocFrame *d, USBDeviceAddress e, Endpoint *f, IOUSBLowLatencyIsocCompletion *g, UInt32 h );//?c	

#define IOUSBControllerV3_OpenPipe \
 IOReturn 	OpenPipe(USBDeviceAddress a, UInt8 b, Endpoint *c);//?c

#define IOUSBControllerV3_DoEnableAllEndpoints \
static IOReturn	DoEnableAllEndpoints(OSObject *a, void *b, void *c, void *d, void *e );//c

#define IOUSBControllerV3_UIMEnableAddressEndpoints \
 IOReturn	UIMEnableAddressEndpoints(USBDeviceAddress a, bool b) ;//??c

#define IOUSBControllerV3_DoEnableAddressEndpoints \
static IOReturn	DoEnableAddressEndpoints(OSObject *a, void *b, void *c, void *d, void *e );//c

#define IOUSBControllerV3_CheckPowerModeBeforeGatedCall \
IOReturn				CheckPowerModeBeforeGatedCall(char *a);//?c

#define IOUSBControllerV3_free \
void					free(void);//?c

#define IOUSBControllerV3_systemWillShutdown \
void					systemWillShutdown( IOOptionBits a );//?c

#define IOUSBControllerV3_powerStateDidChangeTo \
IOReturn	powerStateDidChangeTo ( IOPMPowerFlags a, unsigned long b, IOService* c);//?c

#define IOUSBControllerV3_HandlePowerChange \
 IOReturn				HandlePowerChange(unsigned long a);//?c

#define IOUSBControllerV3_PM_idle_timer_expiration \
void					PM_idle_timer_expiration ( void );//?c

#define IOUSBControllerV3_EnableBusMastering \
IOReturn				EnableBusMastering(bool a);//?c

#define IOUSBControllerV3_setPowerState \
IOReturn	setPowerState( unsigned long a, IOService* b);//?c

#define IOUSBControllerV3_EnableAllEndpoints \
IOReturn				EnableAllEndpoints(bool a);//?c

#define IOUSBControllerV3_powerStateWillChangeTo \
IOReturn	powerStateWillChangeTo ( IOPMPowerFlags a, unsigned long b, IOService* c);//?c

#define IOUSBControllerV3_ResetControllerState \
 IOReturn	ResetControllerState(void) ;//c??

#define IOUSBControllerV3_maxCapabilityForDomainState \
 unsigned long			maxCapabilityForDomainState ( IOPMPowerFlags a );//?c

#define IOUSBControllerV3_InitForPM \
IOReturn				InitForPM(void);//?c

#define IOUSBControllerV3_RootHubTimerFired \
static void	 RootHubTimerFired(OSObject *a, IOTimerEventSource *b);//c
	
#define IOUSBControllerV3_initialPowerStateForDomainState \
unsigned long			initialPowerStateForDomainState ( IOPMPowerFlags a);//?c

#define IOUSBControllerV3_CheckForEHCIController \
 IOReturn				CheckForEHCIController(IOService *a);//?c

#define IOUSBControllerV3_stop \
void					stop( IOService * a );//?c

#define IOUSBControllerV3_start \
bool					start( IOService *  a);//?c

#define IOUSBControllerV3_IsControllerAvailable \
bool					IsControllerAvailable(void);//?c

#define IOUSBControllerV3_powerChangeDone  \
void					powerChangeDone ( unsigned long a);//?

#define IOUSBControllerV3_init \
bool					init( OSDictionary *  a );//?

#define IOUSBControllerV3_ReturnExtraRootHubPortPower \
void		ReturnExtraRootHubPortPower(UInt32 a);//?c

#define IOUSBControllerV3_AllocateExtraRootHubPortPower \
UInt32	AllocateExtraRootHubPortPower(UInt32 a);//?c

#define IOUSBControllerV3_RootHubQueueInterruptRead \
IOReturn	RootHubQueueInterruptRead(IOMemoryDescriptor *a, UInt32 b, IOUSBCompletion c);//?c

#define IOUSBControllerV3_RootHubStartTimer \
 IOReturn				RootHubStartTimer(UInt8 a);//?c
	
#define IOUSBControllerV3_EnsureUsability \
IOReturn				EnsureUsability(void);//?c

#define IOUSBControllerV3_EnableAddressEndpoints \
IOReturn	EnableAddressEndpoints(USBDeviceAddress a, bool b);//?c

#define IOUSBControllerV3_AllocatePowerStateArray \
IOReturn				AllocatePowerStateArray(void);//?c

#define IOUSBControllerV3_RootHubAbortInterruptRead \
IOReturn				RootHubAbortInterruptRead(void);//?c

public://func


};


#endif//HYS_IOKIT_USB_IOUSBCONTROLLERV3_H
