#ifndef HYS_IOKIT_USB_IOUSBDEVICE_H
#define HYS_IOKIT_USB_IOUSBDEVICE_H

#define kAllowNumConfigsOfZero "kAllowNumConfigsOfZero"//?
#define kAllowConfigValueOfZero "kAllowConfigValueOfZero"//?

////////////////
class IOUSBDevice_HYS
{
   
    OSDeclareDefaultStructors(IOUSBDevice_HYS)

public://data

struct ExpansionData {
	thread_call_t _doPortResetThread;//c
	thread_call_t _doPortSuspendThread;//c
	thread_call_t _doPortReEnumerateThread;//c
	int _suspendCommand;//?
	thread_call_t _doMessageClientsThread;//c
	IOTimerEventSource * _notifierHandlerTimer;//c
	IOWorkLoop *_workLoop;//c
	IOCommandGate *_commandGate;//c
	OSSet* _openInterfaces;//c
	int _portNumber;//?
	IOUSBDevice* _usbPlaneParent;//c
	int _suspendInProgress;//?
	int _suspendError;//?
	int _allowConfigValueOfZero;//?
	int _resetError;//?
	int _resetCommand;//?
	int _portHasBeenReset;//?
	int _portHasBeenSuspendedOrResumed;//?
	IORecursiveLock*_getConfigLock;//c
	int _portResetThreadActive;//?
	int _resetInProgress;//?
	int _addExtraResetTime;//?
	int _notificationType;//?
	int _portSuspendThreadActive;//?
};
ExpansionData * _expansionData;
/////////////////
IOUSBController *_controller;//c
IOUSBEndpointDescriptor _endpointZero;//c
IOUSBDeviceDescriptor _descriptor;//c
IOBufferMemoryDescriptor**_configList;//c
IOUSBPipe * _pipeZero;//c
UInt8 _numInterfaces;//c
IOUSBInterface** _interfaceList;//c
void* _port;//c

int _currentConfigValue;//?
int _address;//?
int _busPowerAvailable;//?
int _speed;//?

public://define

#define IOUSBDevice_MakePipe_const_IOUSBEndpointDescriptor \
IOUSBPipe*	MakePipe(const IOUSBEndpointDescriptor *a);//c?

#define IOUSBDevice_GetbcdUSB \
UInt16	GetbcdUSB(void);//c

#define IOUSBDevice_SetBusPowerAvailable \
void	SetBusPowerAvailable(UInt32 a);//c

#define IOUSBDevice_SetPort \
void SetPort(void *a);//?c

#define IOUSBDevice_DoMessageClients \
void 		DoMessageClients( void * a);//c
	
#define IOUSBDevice_DeviceRequest_IOUSBDevRequestDesc_UInt32 \
IOReturn DeviceRequest(IOUSBDevRequestDesc *a, UInt32 b, UInt32 c,IOUSBCompletion *d = 0);//c?

#define IOUSBDevice_ProcessPortReset \
 void 		ProcessPortReset(void);//c

#define IOUSBDevice_DisplayUserNotificationForDevice \
void		DisplayUserNotificationForDevice( );//c

#define IOUSBDevice_DisplayNotEnoughPowerNotice \
void 	DisplayNotEnoughPowerNotice();//?

#define IOUSBDevice_SimpleUnicodeToUTF8 \
UInt32              SimpleUnicodeToUTF8(UInt16 a, UInt8 b[4]);//c

#define IOUSBDevice_ProcessPortReEnumerate \
    void 		ProcessPortReEnumerate(UInt32 a);//c

#define IOUSBDevice_SwapUniWords \
void                SwapUniWords (UInt16  **a, UInt32 b);//c

#define IOUSBDevice_matchPropertyTable \
bool matchPropertyTable(OSDictionary * a, SInt32 *b);//?

#define IOUSBDevice_SetFeature \
IOReturn SetFeature(UInt8 a);//?

#define IOUSBDevice_TerminateInterfaces \
  void 		TerminateInterfaces(void);//c

#define IOUSBDevice_GetConfigDescriptor \
IOReturn GetConfigDescriptor(UInt8 a, void *b, UInt32 c);//?

#define IOUSBDevice_GetInterface \
IOUSBInterface * GetInterface(const IOUSBInterfaceDescriptor *a);//?

#define IOUSBDevice_FindNextDescriptor \
const IOUSBDescriptorHeader* FindNextDescriptor(const void *a, UInt8 b);//;?

#define IOUSBDevice_FindConfig \
const IOUSBConfigurationDescriptor *FindConfig(UInt8 a, UInt8 *b=0);//c

#define IOUSBDevice_SetProperties \
void SetProperties();//?

#define IOUSBDevice_init_USBDeviceAddress \
bool init(USBDeviceAddress a, UInt32 b, UInt8 c, UInt8 d);//?

#define IOUSBDevice_NewDevice \
static IOUSBDevice *NewDevice(void);//c

#define IOUSBDevice_free \
void		free( void );//?

#define IOUSBDevice_stop \
void		stop( IOService *a);//?

#define IOUSBDevice_finalize \
bool		finalize(IOOptionBits a);//?

#define IOUSBDevice_message \
IOReturn 	message( UInt32 a, IOService * b,  void * c = 0 );//?

#define IOUSBDevice_DoMessageClientsEntry \
static void 	DoMessageClientsEntry(OSObject *a, thread_call_param_t b);//c

#define IOUSBDevice_GetProtocol \
UInt8	GetProtocol(void);//c

#define IOUSBDevice_requestTerminate \
bool	requestTerminate( IOService * a, IOOptionBits b);//?c

#define IOUSBDevice_handleOpen \
bool	handleOpen(IOService *a, IOOptionBits b, void *c);//?c

#define IOUSBDevice_terminate \
bool	terminate( IOOptionBits a = 0 );//?c

#define IOUSBDevice_handleClose \
void	handleClose(IOService *a, IOOptionBits b);//?c

#define IOUSBDevice_handleIsOpen \
bool	handleIsOpen(const IOService *a) const;//?c

#define IOUSBDevice_DisplayUserNotificationForDeviceEntry \
static void DisplayUserNotificationForDeviceEntry (OSObject *a, IOTimerEventSource *b);//c

#define IOUSBDevice_ProcessPortReEnumerateEntry \
static void 	ProcessPortReEnumerateEntry(OSObject *a, thread_call_param_t b);//c

#define IOUSBDevice_ProcessPortSuspend \
void 		ProcessPortSuspend( bool a);//c

#define IOUSBDevice_ProcessPortSuspendEntry \
static void 	ProcessPortSuspendEntry(OSObject *a, thread_call_param_t b);//c

#define IOUSBDevice_ProcessPortResetEntry \
static void 	ProcessPortResetEntry(OSObject *a);//c

#define IOUSBDevice_start \
bool 	start( IOService *a);//?

#define IOUSBDevice_init \
bool 	init();//?

#define IOUSBDevice_GetDeviceDescriptor \
IOReturn GetDeviceDescriptor(IOUSBDeviceDescriptor *a, UInt32 b);//?

#define IOUSBDevice_DeviceRequest \
IOReturn DeviceRequest(IOUSBDevRequest	*request, IOUSBCompletion	*b = 0);//?

#define  IOUSBDevice_DeviceRequest_IOUSBDevRequestDesc \
IOReturn DeviceRequest(IOUSBDevRequestDesc *a, IOUSBCompletion	*b = 0);//?

public:

};

#endif //.HYS_IOKIT_USB_IOUSBDEVICE_H
