#ifndef HYS_IOKIT_USB_IOUSBDEVICEUSERCLIENT_H
#define HYS_IOKIT_USB_IOUSBDEVICEUSERCLIENT_H

class  IOUSBDeviceUserClientV2_HYS
{
    OSDeclareDefaultStructors(IOUSBDeviceUserClientV2_HYS)

public://data

IOCommandGate * fGate;//c
IOUSBDevice * fOwner;//c
IOWorkLoop	*fWorkLoop;//c

int fNeedToClose;//?
int fDead;//?
int fWakePort;//?
int fTask;//?
int fOutstandingIO;//?

public://define

#define IOUSBDeviceUserClientV2_sMethods \
   static const IOExternalMethodDispatch sMethods[kIOUSBLibDeviceUserClientNumCommands];//c

public://define

#define IOUSBDeviceUserClientV2_clientClose \
IOReturn					clientClose( void );//?

#define IOUSBDeviceUserClientV2_CreateInterfaceIterator \
IOReturn  CreateInterfaceIterator(IOUSBFindInterfaceRequest *a, io_object_t *b, IOByteCount c, IOByteCount *d);//?

#define IOUSBDeviceUserClientV2_message \
IOReturn	message( UInt32 a, IOService * b,  void * c= 0 );//?

#define  IOUSBDeviceUserClientV2_ReEnumerateDevice \
IOReturn                    ReEnumerateDevice(UInt32 a);//?

#define IOUSBDeviceUserClientV2_didTerminate \
bool      didTerminate( IOService *a, IOOptionBits b, bool * c);//?

#define IOUSBDeviceUserClientV2_SuspendDevice \
IOReturn                    SuspendDevice(bool a);//?

#define IOUSBDeviceUserClientV2_ResetDevice \
IOReturn                    ResetDevice( void );//?
	
#define IOUSBDeviceUserClientV2_ChangeOutstandingIO \
static IOReturn ChangeOutstandingIO(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBDeviceUserClientV2_finalize \
bool                        finalize(IOOptionBits a);//?

#define IOUSBDeviceUserClientV2_GetConfigDescriptor \
IOReturn   GetConfigDescriptor(UInt8 a, IOUSBConfigurationDescriptorPtr b, UInt32 *c);//?

#define IOUSBDeviceUserClientV2_GetConfigDescriptor_UInt8 \
IOReturn  GetConfigDescriptor(UInt8 a, IOMemoryDescriptor * b, uint32_t *c);//?

#define IOUSBDeviceUserClientV2_SetConfiguration \
IOReturn                    SetConfiguration(UInt8 a);//?

#define IOUSBDeviceUserClientV2_IncrementOutstandingIO \
void                        IncrementOutstandingIO(void);//?

#define IOUSBDeviceUserClientV2_start \
bool                        start( IOService * a);//?

#define IOUSBDeviceUserClientV2_DecrementOutstandingIO \
void                        DecrementOutstandingIO(void);//?

#define IOUSBDeviceUserClientV2_GetFrameNumberWithTime \
IOReturn                    GetFrameNumberWithTime(IOUSBGetFrameStruct *a, UInt32 *b);//?

#define IOUSBDeviceUserClientV2_open \
IOReturn                    open(bool a);//?

#define IOUSBDeviceUserClientV2_GetConfiguration \
IOReturn					GetConfiguration(uint64_t *a);//?

#define IOUSBDeviceUserClientV2_DeviceRequestOut \
IOReturn DeviceRequestOut(UInt8 a, UInt8 b, UInt16 c, UInt16 d, mach_vm_size_t e, mach_vm_address_t f, UInt32 g, UInt32 h, IOUSBCompletion *i);//?

#define IOUSBDeviceUserClientV2_DeviceRequestOut_UInt8 \
IOReturn DeviceRequestOut(UInt8 a,  UInt8 b, UInt16 c, UInt16 d, UInt32 e, UInt32 f, const void *g, uint32_t h);//?

#define IOUSBDeviceUserClientV2_DeviceRequestOut_UInt8_UInt8 \
IOReturn DeviceRequestOut(UInt8 a,  UInt8 b, UInt16 c, UInt16 d, UInt32 e, UInt32 f, IOMemoryDescriptor *g);//?
		
#define IOUSBDeviceUserClientV2_DeviceRequestIn \
IOReturn  DeviceRequestIn(UInt8 a,  UInt8 b, UInt16 c, UInt16 d, mach_vm_size_t e, mach_vm_address_t f, UInt32 g, UInt32 h, IOUSBCompletion *i);//?

#define IOUSBDeviceUserClientV2_DeviceRequestIn_UInt8 \
IOReturn DeviceRequestIn(UInt8 a,  UInt8 b, UInt16 c, UInt16 d, UInt32 e, UInt32 f, void *g, uint32_t *h);//?

#define IOUSBDeviceUserClientV2_DeviceRequestIn_UInt8_UInt8 \
IOReturn	DeviceRequestIn(UInt8 a,  UInt8 b, UInt16 c, UInt16 d, UInt32 et, UInt32 e, IOMemoryDescriptor *f, uint32_t *g);//?

#define IOUSBDeviceUserClientV2_initWithTask \
bool	initWithTask(task_t a, void *b, UInt32 c, OSDictionary *d);//?

#define IOUSBDeviceUserClientV2_GetFrameNumber \
IOReturn                    GetFrameNumber(IOUSBGetFrameStruct *a, UInt32 *b);//?
	
#define IOUSBDeviceUserClientV2_AbortPipeZero \
IOReturn                    AbortPipeZero(void);//?

#define IOUSBDeviceUserClientV2_willTerminate \
bool                        willTerminate( IOService * a, IOOptionBits b);//?

#define IOUSBDeviceUserClientV2_stop \
void                        stop(IOService * a);//?

#define IOUSBDeviceUserClientV2_clientDied \
 IOReturn					clientDied( void );//?

#define IOUSBDeviceUserClientV2_free \
void                        free();//?

#define IOUSBDeviceUserClientV2_SetAsyncPort \
IOReturn                    SetAsyncPort(mach_port_t a);//?

#define IOUSBDeviceUserClientV2_GetOutstandingIO \
UInt32                      GetOutstandingIO(void);//?

#define IOUSBDeviceUserClientV2_GetGatedOutstandingIO \
static IOReturn GetGatedOutstandingIO(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBDeviceUserClientV2_ReqComplete \
static void ReqComplete(void *a, void *b, IOReturn c, UInt32 d);//c

#define IOUSBDeviceUserClientV2_close \
IOReturn	close(void);//?c

#define IOUSBDeviceUserClientV2_PrintExternalMethodArgs \
void	PrintExternalMethodArgs( IOExternalMethodArguments * a, UInt32 b);//c

#define IOUSBDeviceUserClientV2_GetMicroFrameNumber \
IOReturn  GetMicroFrameNumber(IOUSBGetFrameStruct *a, UInt32 *b);//?

#define IOUSBDeviceUserClientV2__GetMicroFrameNumber \
static	IOReturn	_GetMicroFrameNumber(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments * c);//c

#define IOUSBDeviceUserClientV2__GetConfigDescriptor \
static	IOReturn	_GetConfigDescriptor(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments * c);//c

#define IOUSBDeviceUserClientV2_externalMethod \
IOReturn externalMethod(	uint32_t a, IOExternalMethodArguments * b, IOExternalMethodDispatch *c, OSObject * d, void * e);//?

#define IOUSBDeviceUserClientV2__close \
static IOReturn _close(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments * c);//c

#define IOUSBDeviceUserClientV2__open \
static	IOReturn	_open(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments * c);//c

#define IOUSBDeviceUserClientV2__SetConfiguration \
static	IOReturn	_SetConfiguration(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments * c);//c

#define IOUSBDeviceUserClientV2__SetAsyncPort \
static	IOReturn	_SetAsyncPort(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments * c);//c

#define IOUSBDeviceUserClientV2__GetConfiguration \
static	IOReturn	_GetConfiguration(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments * c);//c

#define IOUSBDeviceUserClientV2__GetFrameNumber \
static	IOReturn	_GetFrameNumber(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments * c);//c

#define IOUSBDeviceUserClientV2__AbortPipeZero \
static	IOReturn	_AbortPipeZero(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments *c);//c

#define IOUSBDeviceUserClientV2__DeviceRequestOut \
static	IOReturn	_DeviceRequestOut(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments *c);//c

#define IOUSBDeviceUserClientV2__DeviceRequestIn \
static	IOReturn	_DeviceRequestIn(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments *c);//c

#define IOUSBDeviceUserClientV2__CreateInterfaceIterator \
static	IOReturn	_CreateInterfaceIterator(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments *c);//c

#define IOUSBDeviceUserClientV2__SuspendDevice \
static	IOReturn	_SuspendDevice(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments *c);//c

#define IOUSBDeviceUserClientV2__ResetDevice \
static	IOReturn	_ResetDevice(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments *c);//c

#define IOUSBDeviceUserClientV2__ReEnumerateDevice \
static	IOReturn	_ReEnumerateDevice(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments *c);//c

#define IOUSBDeviceUserClientV2__GetFrameNumberWithTime \
static	IOReturn	_GetFrameNumberWithTime(IOUSBDeviceUserClientV2 * a, void * b, IOExternalMethodArguments *c);//c

public://func

};

#endif//HYS_IOKIT_USB_IOUSBDEVICEUSERCLIENT_H
