#ifndef HYS_IOKIT_USB_IOUSBHIDDRIVER_H
#define HYS_IOKIT_USB_IOUSBHIDDRIVER_H

#define HIDMGR2USBREPORTTYPE(a) (a)//?

////////////////////
#define kUSBHIDReportLoggingLevel "kUSBHIDReportLoggingLevel"//?

//////////////
#define kHIDDriverRetryCount 1//?
#define kMaxHIDReportSize 2//?

/////////////////
enum {
	kUSBHIDNumberPowerStates=5,//c
};

enum {
	kUSBHIDPowerStateOn,//?
	kUSBHIDPowerStateLowPower,//?
	kUSBHIDPowerStateSleep,//?
	kUSBHIDPowerStateOff,//?
	kUSBHIDPowerStateRestart,//?
};

//////////////////

class IOUSBHIDDriver_HYS
{
    OSDeclareDefaultStructors(IOUSBHIDDriver_HYS)

public://data

struct IOUSBHIDDriverExpansionData  { 
	IOWorkLoop* _workLoop;//c
	IOTimerEventSource* _suspendPortTimer;//c
	int _suspendTimeoutInMS;//?
	thread_call_t _handleReportThread;//c
 	int _interfaceNumber;//?
	int _hidLoggingLevel;//?
	int _logHIDReports;//?
	int _pendingRead;//?
	int _portSuspended;//?
	int _myPowerState;//?
	IOUSBCompletionWithTimeStamp _completionWithTimeStamp;//c
	int _powerStateChanging;//?
	AbsoluteTime _interruptTimeStamp;//c
	int _needToClearPipeStall;//?
	int _queuedReports;//?
};
IOUSBHIDDriverExpansionData *_usbHIDExpansionData;
////////////

IOCommandGate* _gate;//c
IOUSBInterface * _interface;//c
IOUSBPipe* _interruptOutPipe;//c
IOUSBPipe* _interruptPipe;//c
IOBufferMemoryDescriptor* _buffer;//c
IOUSBDevice*_device;//c
thread_call_t	 _deviceDeadCheckThread;//c
thread_call_t _clearFeatureEndpointHaltThread;//c
IOUSBCompletion	 _completion;//c

int _needToClose;//?
int _outstandingIO;//?
int _deviceHasBeenDisconnected;//?
int _deviceIsDead;//?
int _locationID;//?
int _deviceDeadThreadActive;//?
int _maxReportSize;//?
int _retryCount;//?

public://define

#define IOUSBHIDDriver_getMaxReportSize \
UInt32		getMaxReportSize();//?

#define IOUSBHIDDriver_SuspendPortTimer \
static void			SuspendPortTimer(OSObject *a, IOTimerEventSource *b);//c

#define IOUSBHIDDriver_ClearFeatureEndpointHalt \
void				ClearFeatureEndpointHalt(void);//c

#define IOUSBHIDDriver_newIndexedString \
OSString * 	newIndexedString(UInt8 a) const;//?

#define IOUSBHIDDriver_HandleReport \
void				HandleReport(AbsoluteTime a);//c

#define IOUSBHIDDriver_InterruptReadHandler \
void InterruptReadHandler(IOReturn a, UInt32 b, AbsoluteTime c);//c

#define IOUSBHIDDriver_InterruptReadHandlerEntry \
static void 		InterruptReadHandlerEntry(OSObject *a, void *b, IOReturn c, UInt32 d);//c

#define IOUSBHIDDriver_newVersionNumber \
OSNumber * 	newVersionNumber() const;//?

#define IOUSBHIDDriver_newVendorIDNumber \
OSNumber * 	newVendorIDNumber() const;//?

#define IOUSBHIDDriver_newTransportString \
OSString * 	newTransportString() const;//?

#define IOUSBHIDDriver_newSerialNumberString \
OSString * 	newSerialNumberString() const;//?

#define IOUSBHIDDriver_GetHIDDescriptor \
IOReturn	GetHIDDescriptor(UInt8 a, UInt8 b, UInt8 *c, UInt32 *d);//c

#define IOUSBHIDDriver_newReportDescriptor \
IOReturn 	newReportDescriptor( IOMemoryDescriptor **a ) const;//?

#define IOUSBHIDDriver_newProductString \
OSString * 	newProductString() const;//?

#define IOUSBHIDDriver_newProductIDNumber \
OSNumber * 	newProductIDNumber() const;//?

#define IOUSBHIDDriver_getReport \
IOReturn	getReport( IOMemoryDescriptor *a, IOHIDReportType  b, IOOptionBits c= 0 );//?

#define IOUSBHIDDriver_CheckForDeadDevice \
    void				CheckForDeadDevice();//c

#define IOUSBHIDDriver_newCountryCodeNumber \
OSNumber * 	newCountryCodeNumber() const;//?

#define IOUSBHIDDriver_GetIndexedString \
IOReturn GetIndexedString(UInt8 a, UInt8 *b, UInt32 *c, UInt16 d = 0) const;//c?

#define IOUSBHIDDriver_newManufacturerString \
OSString * 	newManufacturerString() const;//?

#define IOUSBHIDDriver_InterruptReadHandlerWithTimeStampEntry \
static void InterruptReadHandlerWithTimeStampEntry(OSObject *a, void *b, IOReturn c, UInt32 d, AbsoluteTime e);//c

#define IOUSBHIDDriver_setReport \
IOReturn 	setReport( IOMemoryDescriptor *a, IOHIDReportType b, IOOptionBits c = 0 );//?

#define IOUSBHIDDriver_newLocationIDNumber \
OSNumber * 	newLocationIDNumber() const;//?

#define IOUSBHIDDriver_handleStop \
void		handleStop(IOService *a);//?

#define IOUSBHIDDriver_handleStart \
bool		handleStart(IOService * a);//?

#define IOUSBHIDDriver_powerChangeDone \
void			powerChangeDone ( unsigned long a);//?

#define IOUSBHIDDriver_ClaimPendingRead \
static IOReturn ClaimPendingRead(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBHIDDriver_SuspendPort \
 IOReturn	SuspendPort(bool a, UInt32 b = 0);//?

#define IOUSBHIDDriver_processPacket \
void 		processPacket(void *a, UInt32 b);//?

#define IOUSBHIDDriver_AbortAndSuspend \
IOReturn			AbortAndSuspend( bool a );//c

#define IOUSBHIDDriver_powerStateDidChangeTo \
IOReturn	powerStateDidChangeTo ( IOPMPowerFlags a, unsigned long b, IOService* c);//?

#define IOUSBHIDDriver_setPowerState \
IOReturn		setPowerState ( unsigned long a, IOService* b);//?

#define IOUSBHIDDriver_powerStateWillChangeTo \
IOReturn	powerStateWillChangeTo ( IOPMPowerFlags a, unsigned long b, IOService* c);//?

#define IOUSBHIDDriver_maxCapabilityForDomainState \
unsigned long	maxCapabilityForDomainState ( IOPMPowerFlags a );//?

#define IOUSBHIDDriver_didTerminate \
bool			didTerminate( IOService * a, IOOptionBits b, bool * c );//?

#define IOUSBHIDDriver_willTerminate \
 bool			willTerminate( IOService * a, IOOptionBits b);//?

#define IOUSBHIDDriver_RearmInterruptRead \
IOReturn    RearmInterruptRead();//?

#define IOUSBHIDDriver_DecrementOutstandingIO \
void		DecrementOutstandingIO(void);//?

#define IOUSBHIDDriver_StartFinalProcessing \
IOReturn	StartFinalProcessing();//?

#define IOUSBHIDDriver_InitializeUSBHIDPowerManagement \
IOReturn	InitializeUSBHIDPowerManagement(IOService *a);//?

#define IOUSBHIDDriver_HandleReportEntry \
static void			HandleReportEntry(OSObject *a, thread_call_param_t b);//c

#define IOUSBHIDDriver_ClearFeatureEndpointHaltEntry \
static void			ClearFeatureEndpointHaltEntry(OSObject *a);//;c

#define IOUSBHIDDriver_CheckForDeadDeviceEntry \
 static void 		CheckForDeadDeviceEntry(OSObject *a);//c

#define IOUSBHIDDriver_message \
IOReturn		message( UInt32 a, IOService *b,  void * c= 0 );//?

#define IOUSBHIDDriver_SetProtocol \
IOReturn			SetProtocol(UInt32 a);//c

#define IOUSBHIDDriver_SetIdleMillisecs \
IOReturn	SetIdleMillisecs(UInt16 a);//?

#define IOUSBHIDDriver_IncrementOutstandingIO \
void		IncrementOutstandingIO(void);//?

#define IOUSBHIDDriver_start \
bool			start(IOService * a);//?

#define IOUSBHIDDriver_IsPortSuspended \
bool		IsPortSuspended();//?

#define IOUSBHIDDriver_ChangeOutstandingIO \
 static IOReturn	 ChangeOutstandingIO(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBHIDDriver_GetReport \
IOReturn	GetReport(UInt8 a, UInt8 b, UInt8 *c, UInt32 *d);//c

#define IOUSBHIDDriver_LogMemReport \
void		LogMemReport(UInt8 a, IOMemoryDescriptor *b, IOByteCount c);//?

#define IOUSBHIDDriver_GetHexChar \
char				GetHexChar(char a);//c

#define IOUSBHIDDriver_SetReport \
IOReturn	SetReport(UInt8 a, UInt8 b, UInt8 *c, UInt32 d);//c

#define IOUSBHIDDriver_free \
void			free();//?

#define IOUSBHIDDriver_stop \
void			stop(IOService * a);//?

#define IOUSBHIDDriver_init \
bool	init(OSDictionary *a);//?

};


#endif//HYS_IOKIT_USB_IOUSBHIDDRIVER_H
