#ifndef HYS_IOKIT_USB_IOUSBINTERFACE_H
#define HYS_IOKIT_USB_IOUSBINTERFACE_H

class IOUSBInterface_HYS
{
    OSDeclareDefaultStructors(IOUSBInterface_HYS)

public://data
struct ExpansionData {
	IOCommandGate* _gate;//c
	IOWorkLoop*_workLoop;//c
	int _needToClose;//?
 	IOLock *_pipeObjLock;//c
};
ExpansionData * _expansionData;
////////

const IOUSBConfigurationDescriptor *_configDesc;//c
const IOUSBInterfaceDescriptor *_interfaceDesc;//c
IOUSBDevice *_device;//c

int _iInterface;//?
int _bInterfaceProtocol;//?
int _bInterfaceSubClass;//?
int _bInterfaceClass;//?
int _bNumEndpoints;//?
int _bAlternateSetting;//?
int _bInterfaceNumber;//?
IOUSBPipe * _pipeList[1];//?

public://define

#define IOUSBInterface_hex2char \
static UInt8 hex2char( UInt8  a);//c

#define IOUSBInterface_free \
void		free();	//?

#define IOUSBInterface_finalize \
bool		finalize(IOOptionBits a);//?

#define  IOUSBInterface_ClosePipes \
void 	ClosePipes(void);//?

#define IOUSBInterface_stop \
void		stop(IOService *  a);//?

#define IOUSBInterface_terminate \
bool		terminate( IOOptionBits a = 0 );//?

#define IOUSBInterface_message \
IOReturn 	message( UInt32 a, IOService * b,  void *c = 0 );//?

#define IOUSBInterface_handleClose \
void		handleClose(IOService *a, IOOptionBits b = 0);//?

#define IOUSBInterface_matchPropertyTable \
bool matchPropertyTable(OSDictionary * a, SInt32 *b);//?

#define IOUSBInterface_CreatePipes \
 IOReturn	CreatePipes(void);//?

#define IOUSBInterface_CallSuperOpen \
static IOReturn	CallSuperOpen(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBInterface_CallSuperClose \
static IOReturn	CallSuperClose(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBInterface_SetProperties \
void	SetProperties(void);//?

#define IOUSBInterface_open \
 bool		open(IOService *a, IOOptionBits b = 0, void *c = 0 );//?

#define IOUSBInterface_handleOpen \
bool		handleOpen(IOService *a, IOOptionBits b = 0, void *c = 0 );//?

#define IOUSBInterface_init \
bool		init(	const IOUSBConfigurationDescriptor *a, const IOUSBInterfaceDescriptor *b);//?

#define IOUSBInterface_close \
 void		close(IOService *a, IOOptionBits b = 0);//?

#define IOUSBInterface_start \
bool		start(IOService * a);//?

#define IOUSBInterface_DeviceRequest \
IOReturn DeviceRequest(IOUSBDevRequestDesc *a, IOUSBCompletion *b = 0);//?

#define IOUSBInterface_withDescriptors \
static IOUSBInterface *withDescriptors(const IOUSBConfigurationDescriptor *a, const IOUSBInterfaceDescriptor * b);//c

public:

};


#endif//HYS_IOKIT_USB_IOUSBINTERFACE_H
