#ifndef HYS_IOKIT_USB_IOUSBMASSSTORAGWECLASS_H
#define HYS_IOKIT_USB_IOUSBMASSSTORAGWECLASS_H

#define UNUSED(a) ((void)a)//c
/////////////////
#define kIOUSBMassStorageCharacteristics	"kIOUSBMassStorageCharacteristics"//?
#define kIOUSBMassStoragePreferredProtocol "kIOUSBMassStoragePreferredProtocol"//?
#define kIOUSBMassStorageUseStandardUSBReset "kIOUSBMassStorageUseStandardUSBReset"//?
#define kIOUSBMassStorageDoNotOperate "kIOUSBMassStorageDoNotOperate"//?
#define kIOUSBKnownCSWTagIssues "kIOUSBKnownCSWTagIssues"//?
#define kIOUSBMassStoragePreferredSubclass "kIOUSBMassStoragePreferredSubclass"//?
#define kIOPropertyIOUnitKey "kIOPropertyIOUnitKey"//?
#define kIOUSBMassStorageMaxLogicalUnitNumber "kIOUSBMassStorageMaxLogicalUnitNumber"//?
#define kIOUSBMassStorageResetOnResume  "kIOUSBMassStorageResetOnResume"//?

//////////////
struct CBIRequestBlock {
	IOMemoryDescriptor * cbiPhaseDesc;//c
	SCSICommandDescriptorBlock cbiCDB;//c
	SCSITaskIdentifier request;//c
	IOUSBCompletion	cbiCompletion;//c
	int currentState;//?
	IOUSBDevRequest	cbiDevRequest;//c
	int cbiGetStatusBuffer[2];//?
};
typedef struct CBIRequestBlock	CBIRequestBlock;

struct StorageBulkOnlyCBW {
	int cbwSignature;//?
	int cbwTag;//?
	int cbwTransferLength;//?
	int cbwFlags;//?
	int cbwLUN;//?
	int cbwCDBLength;//?
	UInt8 cbwCDB[16];//c
};
typedef struct StorageBulkOnlyCBW StorageBulkOnlyCBW;

struct StorageBulkOnlyCSW {
	int cswTag;//?
	int cswStatus;//?
};
typedef struct StorageBulkOnlyCSW StorageBulkOnlyCSW;

struct BulkOnlyRequestBlock {
	StorageBulkOnlyCBW boCBW;//c
	StorageBulkOnlyCSW boCSW;//c
	SCSITaskIdentifier request;//c
	IOUSBCompletion boCompletion;//c
	int currentState;//?
	IOMemoryDescriptor *boPhaseDesc;//c
	int boGetStatusBuffer[2];//?
};
typedef struct BulkOnlyRequestBlock BulkOnlyRequestBlock;

///////////////////

class IOUSBMassStorageClass_HYS
{
    OSDeclareDefaultStructors(IOUSBMassStorageClass_HYS)

public://data-define

#define IOUSBMassStorageClass_ExpansionData \
bool					fResetInProgress; \
OSSet *					fClients; \
IOUSBPipe *				fPotentiallyStalledPipe; \
bool					fUseUSBResetNotBOReset; \
bool					fAbortCurrentSCSITaskInProgress; \
IOMemoryDescriptor *	fCBIMemoryDescriptor; \
IOMemoryDescriptor *	fBulkOnlyCBWMemoryDescriptor; \
IOMemoryDescriptor *	fBulkOnlyCSWMemoryDescriptor; \
bool                    fDeviceAttached; \
bool                    fWaitingForReconfigurationMessage; \
bool					fTerminating; \
bool                    fKnownCSWTagMismatchIssues; 

public://data

enum {
	kByteCountOfCBW,//?
	kUSBStorageSFF8070iSubclass,//?
	kUSBStorageUFISubclass,//?
	kProtocolControlBulkInterrupt,//?
	kUSBStorageAutoStatusSize,//?
	kProtocolControlBulk,//?
	kProtocolBulkOnly,//?
	kByteCountOfCSW,//?
	kCommandBlockWrapperSignature,//?
	kCBWFlagsDataIn,//?
	kCBWFlagsDataOut,//?
	kCBWLUNMask,//?
	kCSWCommandPassedError,//?
	kCSWCommandFailedError,//?
	kCSWPhaseError,//?
};
//////////////
CBIRequestBlock fCBICommandRequestBlock;//c
IOUSBPipe* fInterruptPipe;//c
BulkOnlyRequestBlock	fBulkOnlyCommandRequestBlock;//c
IOUSBPipe* fBulkInPipe;//c
IOUSBPipe* fBulkOutPipe;//c
IOUSBDevRequest fUSBDeviceRequest;//c
IOUSBInterface * fInterface;//c

int fMaxLogicalUnitNumber;//?
int fPreferredSubclass;//?
int fPreferredProtocol;//?
int fBulkOnlyCommandStructInUse;//?
int fBulkOnlyCommandTag;//?
int fCBICommandStructInUse;//?

public://define

#define IOUSBMassStorageClass_BulkOnlyReceiveCSWPacket \
IOReturn		BulkOnlyReceiveCSWPacket(BulkOnlyRequestBlock *a, UInt32 b);//c
	
#define IOUSBMassStorageClass_BulkOnlyTransferData \
IOReturn		BulkOnlyTransferData(BulkOnlyRequestBlock *a, UInt32 b);//c
	
#define IOUSBMassStorageClass_BulkOnlyExecuteCommandCompletion \
void	BulkOnlyExecuteCommandCompletion (BulkOnlyRequestBlock *a, IOReturn b, UInt32 c);//c

#define IOUSBMassStorageClass_BulkDeviceResetDevice \
IOReturn		BulkDeviceResetDevice(BulkOnlyRequestBlock *a, UInt32 b);//c

#define  IOUSBMassStorageClass_BulkOnlySendCBWPacket \
IOReturn		BulkOnlySendCBWPacket(BulkOnlyRequestBlock *a, UInt32 b);//c
	
#define IOUSBMassStorageClass_BulkOnlyUSBCompletionAction \
static void		BulkOnlyUSBCompletionAction (void *a, void *b, IOReturn c, UInt32 d);//c
	
#define IOUSBMassStorageClass_DeviceRecoveryCompletionAction \
static void	DeviceRecoveryCompletionAction(void *a, void *b, IOReturn c, UInt32 d);//c

#define IOUSBMassStorageClass_StartDeviceRecovery \
IOReturn	StartDeviceRecovery( void );//?c

#define IOUSBMassStorageClass_GatedWaitForTaskAbort \
IOReturn			GatedWaitForTaskAbort( void );//c

#define IOUSBMassStorageClass_GatedWaitForReset \
IOReturn			GatedWaitForReset( void );//c

#define IOUSBMassStorageClass_handleIsOpen \
 bool		handleIsOpen(  const IOService * a) const;//?c

#define IOUSBMassStorageClass_handleClose \
void		handleClose( IOService *	a, IOOptionBits	b);//?c
	
#define IOUSBMassStorageClass_handleOpen \
bool		handleOpen( IOService *a, IOOptionBits	b, void *c);//?c

#define IOUSBMassStorageClass_AbortCurrentSCSITask \
void                AbortCurrentSCSITask( void );//c

#define IOUSBMassStorageClass_ResetDeviceNow \
 void                ResetDeviceNow( bool a);//c

#define IOUSBMassStorageClass_HandlePowerOn \
IOReturn	HandlePowerOn( void );//?c

#define IOUSBMassStorageClass_GetNextBulkOnlyCommandTag \
UInt32			GetNextBulkOnlyCommandTag( void );//c

#define IOUSBMassStorageClass_ReleaseBulkOnlyRequestBlock \
void 			ReleaseBulkOnlyRequestBlock(BulkOnlyRequestBlock *a);//c

#define IOUSBMassStorageClass_GetBulkOnlyRequestBlock \
BulkOnlyRequestBlock *	GetBulkOnlyRequestBlock( void );//c

#define IOUSBMassStorageClass_IsProtocolServiceSupported \
bool	IsProtocolServiceSupported(SCSIProtocolFeature 	a, void *b);//?c

#define IOUSBMassStorageClass_AbortSCSICommandForBulkOnlyProtocol \
IOReturn		AbortSCSICommandForBulkOnlyProtocol(SCSITaskIdentifier a );//?c

#define IOUSBMassStorageClass_AbortSCSICommand \
SCSIServiceResponse    	AbortSCSICommand( SCSITaskIdentifier a);//?c

#define IOUSBMassStorageClass_SendSCSICommandForBulkOnlyProtocol \
IOReturn		SendSCSICommandForBulkOnlyProtocol(SCSITaskIdentifier a );//?c

#define IOUSBMassStorageClass_SendSCSICommand \
bool   SendSCSICommand(SCSITaskIdentifier a, SCSIServiceResponse *b, SCSITaskStatus	*c);//?c

#define IOUSBMassStorageClass_GetMaxLogicalUnitNumber \
UInt8					GetMaxLogicalUnitNumber( void ) const;//c

#define IOUSBMassStorageClass_sWaitForReset \
static IOReturn		sWaitForReset( void * a);//c

#define IOUSBMassStorageClass_didTerminate \
bool        didTerminate(	IOService *a, IOOptionBits   b,  bool *c );//?c

#define IOUSBMassStorageClass_FinishDeviceRecovery \
void		FinishDeviceRecovery( IOReturn	a );//?c

#define IOUSBMassStorageClass_sAbortCurrentSCSITask \
static void			sAbortCurrentSCSITask( void * a);//c

#define IOUSBMassStorageClass_sWaitForTaskAbort \
static IOReturn		sWaitForTaskAbort( void * a);//c

#define IOUSBMassStorageClass_sResetDevice \
static void			sResetDevice( void * a);//c

#define IOUSBMassStorageClass_willTerminate \
bool        willTerminate(  IOService *a, IOOptionBits  b);//?c
	
#define IOUSBMassStorageClass_free \
void		free( void );//?c

#define IOUSBMassStorageClass_message \
IOReturn	message( UInt32 a, IOService * b, void * c = 0 );//?c
	
#define IOUSBMassStorageClass_EndProvidedServices \
bool			EndProvidedServices( void );//?c
	
#define IOUSBMassStorageClass_stop \
void 		stop( IOService * 		a);//?c

#define IOUSBMassStorageClass_HandleProtocolServiceFeature \
bool	HandleProtocolServiceFeature(SCSIProtocolFeature a, void *b);//?c
 
#define IOUSBMassStorageClass_BeginProvidedServices \
bool			BeginProvidedServices( void );//?c

#define IOUSBMassStorageClass_GetInterfaceProtocol \
UInt8					GetInterfaceProtocol( void );//c

#define IOUSBMassStorageClass_SetMaxLogicalUnitNumber \
void					SetMaxLogicalUnitNumber( UInt8 a);//c

#define IOUSBMassStorageClass_SetInterfaceReference \
	void					SetInterfaceReference( IOUSBInterface *a);//c

#define IOUSBMassStorageClass_start \
bool		start( IOService *	 	a);//?c

#define IOUSBMassStorageClass_init \
    bool				init( OSDictionary * 	a );//c

#define IOUSBMassStorageClass_GetInterfaceSubclass \
UInt8					GetInterfaceSubclass( void );//c

#define IOUSBMassStorageClass_GetControlPipe \
IOUSBPipe *				GetControlPipe( void );//c

#define IOUSBMassStorageClass_CompleteSCSICommand \
void 			CompleteSCSICommand(SCSITaskIdentifier a, IOReturn b);//?c

#define IOUSBMassStorageClass_ClearFeatureEndpointStall \
IOReturn		ClearFeatureEndpointStall(IOUSBPipe *a, IOUSBCompletion *b);//?c

#define IOUSBMassStorageClass_CBIClearFeatureEndpointStall \
IOReturn		CBIClearFeatureEndpointStall(IOUSBPipe *a, CBIRequestBlock *b, UInt32 c);//c
						
#define IOUSBMassStorageClass_GetStatusEndpointStatus \
IOReturn	GetStatusEndpointStatus(	IOUSBPipe *a, void *b, IOUSBCompletion *c);//?c
	
#define IOUSBMassStorageClass_CBIGetStatusEndpointStatus \
IOReturn		CBIGetStatusEndpointStatus(IOUSBPipe *a, CBIRequestBlock *b, UInt32	c);//c

#define IOUSBMassStorageClass_CBIProtocolReadInterrupt \
IOReturn		CBIProtocolReadInterrupt(CBIRequestBlock *a, UInt32 b);//c

#define IOUSBMassStorageClass_GetBulkOutPipe \
IOUSBPipe *				GetBulkOutPipe( void );//c

#define IOUSBMassStorageClass_GetBulkInPipe \
IOUSBPipe *				GetBulkInPipe( void );//c

#define IOUSBMassStorageClass_CBIProtocolTransferData \
IOReturn		CBIProtocolTransferData(CBIRequestBlock *a, UInt32 b);//c

#define IOUSBMassStorageClass_CBIProtocolCommandCompletion \
void 	CBIProtocolCommandCompletion(CBIRequestBlock *a, IOReturn b, UInt32 c);//c

#define IOUSBMassStorageClass_ReleaseCBIRequestBlock \
void 	ReleaseCBIRequestBlock(CBIRequestBlock *	a);//c

#define IOUSBMassStorageClass_GetInterfaceReference \
IOUSBInterface *		GetInterfaceReference( void );//c

#define IOUSBMassStorageClass_GetInterruptPipe \
IOUSBPipe *				GetInterruptPipe( void );//c

#define IOUSBMassStorageClass_CBIProtocolUSBCompletionAction \
static void		CBIProtocolUSBCompletionAction(void *a, void *b, IOReturn c,  UInt32 d);//c

#define IOUSBMassStorageClass_GetCBIRequestBlock \
CBIRequestBlock *		GetCBIRequestBlock( void );//c

#define IOUSBMassStorageClass_SendSCSICommandForCBIProtocol \
IOReturn		SendSCSICommandForCBIProtocol(SCSITaskIdentifier a);//?c

#define IOUSBMassStorageClass_AbortSCSICommandForCBIProtocol \
IOReturn		AbortSCSICommandForCBIProtocol(SCSITaskIdentifier a);//?c

};

#endif//HYS_IOKIT_USB_IOUSBMASSSTORAGWECLASS_H
///////////////////
#ifdef _IOKIT_IOUSBMASSSTORAGECLASS_H_end 

class  IOUSBMassStorageClass_HYS1{
public://orig-define

#define fTerminating	 reserved->fTerminating//c
#define fCBIMemoryDescriptor   reserved->fCBIMemoryDescriptor//c
#define fClients		reserved->fClients//c
#define fUseUSBResetNotBOReset		reserved->fUseUSBResetNotBOReset//c
#define fKnownCSWTagMismatchIssues          reserved->fKnownCSWTagMismatchIssues//c
#define fWaitingForReconfigurationMessage	reserved->fWaitingForReconfigurationMessage//c
#define fBulkOnlyCBWMemoryDescriptor		reserved->fBulkOnlyCBWMemoryDescriptor//c
#define fBulkOnlyCSWMemoryDescriptor		reserved->fBulkOnlyCSWMemoryDescriptor//c
#define fDeviceAttached                     reserved->fDeviceAttached//c
#define fResetInProgress					reserved->fResetInProgress//c
#define fAbortCurrentSCSITaskInProgress	reserved->fAbortCurrentSCSITaskInProgress//c
#define fPotentiallyStalledPipe				reserved->fPotentiallyStalledPipe//c

};
#undef _IOKIT_IOUSBMASSSTORAGECLASS_H_end

#endif//_IOKIT_IOUSBMASSSTORAGECLASS_H_end
