#ifndef HYS_PCSC_MSCDEFINES_H
#define HYS_PCSC_MSCDEFINES_H

#define MSC_MAXSIZE_OBJID 1//?
#define MSC_MAXSIZE_TOKENAME 2//?
#define MSC_MAXSIZE_AID 3//?
#define MSC_MAXSIZE_SVCPROV 4//?
#define MSC_MAXSIZE_MAC 5//?

/////////

#define MSC_MAXSIZE_BUFFER     MAX_BUFFER_SIZE//c

/////////////
typedef uint32_t MSCULong32;//c
typedef uint32_t MSC_RV;//c
typedef uint32_t *MSCPULong32;//c
typedef uint8_t *MSCPUChar8;//c
typedef void *MSCPVoid32;//c
typedef uint8_t MSCUChar8;//c
typedef uint16_t *MSCPUShort16;//c
typedef char *MSCString;//c
typedef uint16_t MSCUShort16;//c
typedef int32_t MSCLong32;//c
typedef char MSCChar8;//c
typedef const uint8_t *MSCPCUChar8;//c

////////////////////

struct MSCTokenInfo {
	MSCULong32 tokenType;	//c
	MSCULong32 tokenState;//c
     	MSCChar8 slotName[MAX_READERNAME];//c
  	MSCChar8 tokenName[MSC_MAXSIZE_TOKENAME];//c
	MSCULong32 tokenAppLen;//c
	MSCUChar8 tokenApp[MSC_MAXSIZE_AID];//c
	MSCPVoid32 addParams;//c
	MSCULong32 addParamsSize;//c
	MSCUChar8 tokenId[MAX_ATR_SIZE]; //c
	MSCULong32 tokenIdLength;//c
	MSCChar8 svProvider[MSC_MAXSIZE_SVCPROV];//c
};
typedef struct MSCTokenInfo MSCTokenInfo;
typedef MSCTokenInfo *MSCLPTokenInfo;

struct CFDyLibPointers {
	MSCPVoid32 pvfInitializePlugin;//c
	MSCPVoid32 pvfIdentifyToken;//c
	MSCPVoid32 pvfFinalizePlugin;//c
	MSCPVoid32 pvfWriteFramework;//c
	MSCPVoid32 pvfGetStatus;//c
	MSCPVoid32 pvfGetCapabilities;//c
	MSCPVoid32 pvfExtendedFeature;//c
	MSCPVoid32 pvfGenerateKeys;//c
	MSCPVoid32 pvfImportKey;//c
	MSCPVoid32 pvfExportKey;//c
	MSCPVoid32 pvfComputeCrypt;//c
	MSCPVoid32 pvfExtAuthenticate;//c
	MSCPVoid32 pvfListKeys;//c
	MSCPVoid32 pvfCreatePIN;//c
	MSCPVoid32 pvfVerifyPIN;//c
	MSCPVoid32 pvfChangePIN;//c
	MSCPVoid32 pvfUnblockPIN;//c
	MSCPVoid32 pvfListPINs;//c
	MSCPVoid32 pvfCreateObject;//c
	MSCPVoid32 pvfDeleteObject;//c
	MSCPVoid32 pvfWriteObject;//c
	MSCPVoid32 pvfReadObject;//c
	MSCPVoid32 pvfListObjects;//c
	MSCPVoid32 pvfLogoutAll;//c
	MSCPVoid32 pvfGetChallenge;//c
};
typedef struct CFDyLibPointers CFDyLibPointers;

struct MSCTokenConnection {
	MSCLong32 hCard;//c
	LPSCARD_IO_REQUEST ioType;//c
	MSCTokenInfo tokenInfo;//c
	MSCULong32 shareMode;//c
	MSCUChar8 loggedIDs;//c
	MSCPVoid32 tokenLibHandle;//c
	MSCLong32 hContext;//c
	CFDyLibPointers libPointers;//c
	MSCULong32 macSize;//c
	MSCUChar8 pMac[MSC_MAXSIZE_MAC];//c
};
typedef struct MSCTokenConnection MSCTokenConnection;
typedef MSCTokenConnection  *MSCLPTokenConnection;


///////////
typedef MSCULong32(*MSCCallBack) (MSCLPTokenInfo, MSCULong32,MSCPVoid32);//c
typedef MSC_RV(*LPRWEventCallback) (MSCPVoid32, int);//c

#endif//HYS_PCSC_MSCDEFINES_H
