#ifndef HYS_PCSC_READERFACTORY_H
#define HYS_PCSC_READERFACTORY_H

struct RdrCliHandles {
	SCARDHANDLE hCard;//c
	DWORD dwEventStatus;//c
};
typedef struct RdrCliHandles RDR_CLIHANDLES;//c

struct FctMap_V1 {
	RESPONSECODE (*pvfCreateChannel)(DWORD);//c
	RESPONSECODE (*pvfCloseChannel)(void);//c
	RESPONSECODE (*pvfGetCapabilities)(DWORD, PUCHAR);//c
	RESPONSECODE (*pvfSetCapabilities)(DWORD, PUCHAR);//c
	RESPONSECODE (*pvfPowerICC)(DWORD);//c
	RESPONSECODE (*pvfTransmitToICC)(SCARD_IO_HEADER, PUCHAR, DWORD,PUCHAR, PDWORD, PSCARD_IO_HEADER);//c
	RESPONSECODE (*pvfICCPresence)(void);//c
	RESPONSECODE (*pvfSetProtocolParameters)(DWORD, UCHAR, UCHAR, UCHAR,UCHAR);//c
};
typedef struct FctMap_V1 FCT_MAP_V1;//c

struct FctMap_V2 {
	RESPONSECODE (*pvfCreateChannel)(DWORD, DWORD);//c
	RESPONSECODE (*pvfCloseChannel)(DWORD);//c
	RESPONSECODE (*pvfGetCapabilities)(DWORD, DWORD, PDWORD, PUCHAR);//c
	RESPONSECODE (*pvfSetCapabilities)(DWORD, DWORD, DWORD, PUCHAR);//c
	RESPONSECODE (*pvfPowerICC)(DWORD, DWORD, PUCHAR, PDWORD);//c
	RESPONSECODE (*pvfTransmitToICC)(DWORD, SCARD_IO_HEADER, PUCHAR,DWORD, PUCHAR, PDWORD, PSCARD_IO_HEADER);//c
	RESPONSECODE (*pvfICCPresence)(DWORD);//c
	RESPONSECODE (*pvfSetProtocolParameters)(DWORD, DWORD, UCHAR, UCHAR,UCHAR, UCHAR);//c
	RESPONSECODE (*pvfControl)(DWORD, PUCHAR, DWORD, PUCHAR, PDWORD);//c
};
typedef struct FctMap_V2 FCT_MAP_V2;//c

struct FctMap_V3 {
	RESPONSECODE (*pvfCreateChannelByName)(DWORD, LPSTR);//c
	RESPONSECODE (*pvfControl)(DWORD, DWORD, LPCVOID, DWORD, LPVOID,DWORD, LPDWORD);//c
	RESPONSECODE (*pvfCreateChannel)(DWORD, DWORD);//c
};
typedef struct FctMap_V3 FCT_MAP_V3;//c

struct ReaderContext {
	union {
		FCT_MAP_V1 psFunctions_v1;//c
		FCT_MAP_V2 psFunctions_v2;//c
		FCT_MAP_V3 psFunctions_v3;//c
	} psFunctions;//c

	DWORD dwLockId;//c
	PCSCLITE_THREAD_T pthThread;//c
	char lpcReader[MAX_READERNAME];//c
	int32_t dwContexts;//c
	struct pubReaderStatesList *readerState;//c
	DWORD dwVersion;//c
	DWORD dwSlot;//c
	DWORD dwPort;//c
	char lpcLibrary[MAX_LIBNAME];//c
	char lpcDevice[MAX_DEVICENAME];//c
	LPVOID vHandle;//c
	RDR_CLIHANDLES psHandles[PCSCLITE_MAX_READER_CONTEXT_CHANNELS];//c
	DWORD dwIdentity;//c
	PDWORD pdwFeeds;//c
	DWORD dwBlockStatus;//c
	PCSCLITE_MUTEX_T mMutex;//c
	PDWORD pdwMutex;//c
//old
	DWORD dwPublicID;//c
	UCHAR ucAtr[MAX_ATR_SIZE];//c
 	DWORD dwAtrLen;//c
	DWORD dwStatus;//c
  	DWORD dwProtocol;//c
};
typedef struct ReaderContext READER_CONTEXT;//c
typedef READER_CONTEXT  *PREADER_CONTEXT;//c
////////////

#ifdef OLD_PCSC
 	 LONG RFAddReader( LPSTR, DWORD, LPSTR );
#else
	LONG RFAddReader(LPSTR, DWORD, LPSTR, LPSTR);//c
#endif

LONG RFRemoveReader(LPSTR, DWORD);//c
void RFAwakeAllReaders(void);//c
void RFSuspendAllReaders(void);//c

#endif//HYS_PCSC_READERFACTORY_H
