#ifndef HYS_PASSWORDSERVER_AUTHFILE_H
#define HYS_PASSWORDSERVER_AUTHFILE_H

#define kPWReplicaLocalFile "kPWReplicaLocalFile"//?
#define kPWFilePath "kPWFilePath"//?
#define kPWPolicyStr_newPasswordRequired "kPWPolicyStr_newPasswordRequired"//?
#define kEmptyPasswordAltStr "kEmptyPasswordAltStr"//?

#define kPWFileMaxPublicKeyBytes 1//?
#define kPWFileMaxPrivateKeyBytes 2//?

struct PWAccessFeatures {
	int isAdminUser;//?
	int canModifyPasswordforSelf;//?
	int isDisabled;//?
	int maxMinutesUntilChangePassword;//?
};
typedef struct PWAccessFeatures PWAccessFeatures;

struct PWFileEntry {
	char usernameStr[1];//?
	char passwordStr[1];//?
	PWAccessFeatures access;//?
	int slot;//?
	int time;//?
	int rnd;//?
	int sequenceNumber;//?
};
typedef struct PWFileEntry PWFileEntry;

struct PWFileHeader {
	char replicationName[1];//?
};
typedef struct PWFileHeader PWFileHeader;

struct PWGlobalAccessFeatures {
	int minChars;//?
	int noModifyPasswordforSelf;//?
};
typedef struct PWGlobalAccessFeatures PWGlobalAccessFeatures;

struct PWGlobalMoreAccessFeatures {
	int a;//dummy
};
typedef struct PWGlobalMoreAccessFeatures PWGlobalMoreAccessFeatures;

typedef int PWMoreAccessFeatures;//?

int pwsf_ShadowHashDataToArray(const char* a,CFMutableArrayRef * b);//c
char * pwsf_ShadowHashArrayToData(CFArrayRef a,long * b);//c
int pwsf_stringToPasswordRecRef(const char * a, PWFileEntry * b);//c
int pwsf_passwordRecRefToString(PWFileEntry * a,char * b);//?
int pwsf_slotToOffset(int a);//?
int  pwsf_ConvertCFDateToBSDTime (CFDateRef a,struct tm*b);//?
int ConvertXMLPolicyToSpaceDelimited (const char* a,char** b);//c
int ConvertGlobalSpaceDelimitedPolicyToXML(const char *a,char ** b);//?
int PWGlobalAccessFeaturesToStringExtra(PWGlobalAccessFeatures * a,PWGlobalMoreAccessFeatures *b,int c,char * d);//?
int StringToPWGlobalAccessFeaturesExtra(const char * a,PWGlobalAccessFeatures * b,PWGlobalMoreAccessFeatures * c);//?
int GetDefaultUserPolicies(PWAccessFeatures *a);//?
int StringToPWAccessFeaturesExtra(const char * a,PWAccessFeatures *b,PWMoreAccessFeatures *c);//?
int PWAccessFeaturesToStringWithoutStateInfoExtra(PWAccessFeatures *a,PWMoreAccessFeatures * b,int c, char *d);//?
int pwsf_PreserveUnrepresentedPolicies(const char *a,int b,char *c);//?
int ConvertSpaceDelimitedPolicyToXML(const char * a,char **b);//?
int pwsf_ConvertBSDTimeToCFDate(struct tm *a,CFDateRef *b);//?
int ConvertGlobalXMLPolicyToSpaceDelimited(const char *a,char** b);//?
int pwsf_getHashCramMD5(const unsigned char *a,int b,unsigned char *c,unsigned long *d);//?
int pwsf_RequiredCharacterStatusExtra(PWAccessFeatures *a, PWGlobalAccessFeatures *b, const char *c, const char *d, PWMoreAccessFeatures *e );//c
int pwsf_TestDisabledStatus( PWAccessFeatures *a, PWGlobalAccessFeatures *b, struct tm *c, struct tm *d, UInt16 *e );//c
int pwsf_ChangePasswordStatus( PWAccessFeatures *a, PWGlobalAccessFeatures *b, struct tm *c );//c

#endif //HYS_PASSWORDSERVER_AUTHFILE_H
