#ifndef HYS_SECURITY_CSSMAPPLE_H
#define HYS_SECURITY_CSSMAPPLE_H

#define CSSM_APPLE_TP_SMIME_OPTS_VERSION 1//? 
#define CSSM_APPLE_TP_SSL_OPTS_VERSION 2//?
#define CSSM_APPLE_TP_ACTION_VERSION 3//?

//////////////

enum {
	CSSM_DL_DB_RECORD_X509_CERTIFICATE, //?
	CSSM_ALGID_AES,//?
	CSSM_ALGID_ASC,//?
	CSSM_ERRCODE_DEVICE_FAILED,//?
	CSSM_ALGID_FEE,//?
	CSSM_ACL_KEYCHAIN_PROMPT_REQUIRE_PASSPHRASE,//?
	CSSM_DL_DB_RECORD_INTERNET_PASSWORD,//?
	CSSM_DL_DB_RECORD_GENERIC_PASSWORD,//?
	CSSM_DL_DB_RECORD_APPLESHARE_PASSWORD,//?
	CSSM_TP_ACTION_LEAF_IS_CA,//?
	CSSM_APPLEDL_OPEN_PARAMETERS_VERSION,//?
	CSSM_DB_ACCESS_RESET,//?
	CSSM_ACL_PREAUTH_TRACKING_UNKNOWN,//?
	CSSM_ACL_PREAUTH_TRACKING_AUTHORIZED,//?
	CSSM_ACL_PROCESS_SELECTOR_CURRENT_VERSION,//?
	CSSM_ACL_MATCH_UID,//?
	CSSM_WORDID_PROCESS,//?
};

/////////////////
enum cssm_appledl_open_parameters_mask
{
	kCSSM_APPLEDL_MASK_MODE =			(1 << 0)
};//c

enum {
	CSSM_ACL_SUBJECT_TYPE_COMMENT = CSSM_WORDID_COMMENT,//c
	CSSM_ACL_SUBJECT_TYPE_PROCESS = CSSM_WORDID_PROCESS,//c
};
/////////////

struct CSSM_APPLE_TP_SMIME_OPTIONS {
	uint32 Version;//c
	CE_KeyUsage	IntendedUsage;//c
	uint32      SenderEmailLen;//c
	const char  *SenderEmail; //c

};
typedef struct CSSM_APPLE_TP_SMIME_OPTIONS CSSM_APPLE_TP_SMIME_OPTIONS;

struct cssm_acl_keychain_prompt_selector {
	uint16 flags;//c
};
typedef struct cssm_acl_keychain_prompt_selector  CSSM_ACL_KEYCHAIN_PROMPT_SELECTOR;

struct CSSM_APPLE_TP_SSL_OPTIONS {
	uint32 Version;//c
	const char  *ServerName;//c
	uint32  ServerNameLen;//c
};
typedef struct CSSM_APPLE_TP_SSL_OPTIONS CSSM_APPLE_TP_SSL_OPTIONS;

typedef uint32 CSSM_APPLE_TP_ACTION_FLAGS;//c

struct CSSM_APPLE_TP_ACTION_DATA {
	uint32 Version;//c
	CSSM_APPLE_TP_ACTION_FLAGS	ActionFlags;//c
};
typedef struct CSSM_APPLE_TP_ACTION_DATA CSSM_APPLE_TP_ACTION_DATA;

struct cssm_appledl_open_parameters {
	CSSM_BOOL autoCommit;//c
	uint32 mask;//c
	mode_t mode;//c
	int d;//dummy
	int e;//dummy
};
typedef struct  cssm_appledl_open_parameters CSSM_APPLEDL_OPEN_PARAMETERS;

struct cssm_acl_process_subject_selector { };
typedef struct cssm_acl_process_subject_selector CSSM_ACL_PROCESS_SUBJECT_SELECTOR;

////////////////
extern const CSSM_GUID gGuidAppleCSP;//c
extern const CSSM_GUID gGuidAppleFileDL;//c
extern const CSSM_GUID gGuidAppleCSPDL;//c
extern const CSSM_GUID gGuidAppleSdCSPDL;//c

void cssmPerror(const char *how, CSSM_RETURN error);//c

#endif//HYS_SECURITY_CSSMAPPLE_H

