#ifndef HYS_SECURITY_CSSMERR_H
#define HYS_SECURITY_CSSMERR_H

enum {
	CSSMERR_CSP_INTERNAL_ERROR,//?
	CSSMERR_CSSM_INVALID_POINTER,//?
	CSSMERR_CSP_OUTPUT_LENGTH_ERROR,//?
	CSSM_ERRCODE_FUNCTION_NOT_IMPLEMENTED,//?
	CSSM_ERRCODE_MEMORY_ERROR,//?
	CSSM_DL_BASE_ERROR,//?
	CSSM_ERRCODE_INTERNAL_ERROR,//?
	CSSMERR_CSP_INVALID_ATTR_ALG_PARAMS,//?
	CSSM_ERRCODE_INVALID_DATA,//?
	CSSM_ERRCODE_INVALID_ACL_ENTRY_TAG,//?
	CSSM_ERRCODE_OPERATION_AUTH_DENIED,//?
	CSSM_ERRCODE_OBJECT_USE_AUTH_DENIED,//?
	CSSM_ERRCODE_INVALID_SAMPLE_VALUE,//?
	CSSM_ERRCODE_ACL_SUBJECT_TYPE_NOT_SUPPORTED,//?
	CSSM_ERRCODE_SAMPLE_VALUE_NOT_SUPPORTED,//?
	CSSM_ERRCODE_INVALID_POINTER,//?
	CSSM_ERRCODE_INVALID_PASSTHROUGH_ID,//?
	CSSM_ERRCODE_OBJECT_ACL_NOT_SUPPORTED,//?
	CSSM_ERRCODE_INVALID_ACL_EDIT_MODE,//?
	CSSM_ERRCODE_INVALID_INPUT_POINTER,//?
	CSSM_ERRCODE_ACL_ADD_FAILED,//?
	CSSM_ERRCODE_OBJECT_MANIP_AUTH_DENIED,//?
	CSSM_ERRCODE_ACL_DELETE_FAILED,//?
	CSSM_ERRCODE_INVALID_CONTEXT_HANDLE,//?
};

enum {
	CSSM_BASE_ERROR =	-0x7FFF0000 ,//c
	CSSM_ERRORCODE_MODULE_EXTENT =	0x00000800,//c
	CSSM_ERRORCODE_COMMON_EXTENT =	0x100,//c
};

enum {	
	CSSM_CL_BASE_ERROR =CSSM_DL_BASE_ERROR +CSSM_ERRORCODE_MODULE_EXTENT,//c
	CSSM_TP_BASE_ERROR = CSSM_CL_BASE_ERROR + CSSM_ERRORCODE_MODULE_EXTENT,//c
CSSM_TP_BASE_TP_ERROR = CSSM_TP_BASE_ERROR + CSSM_ERRORCODE_COMMON_EXTENT,//c
	CSSMERR_TP_NOT_TRUSTED =CSSM_TP_BASE_TP_ERROR + 42,//c
	CSSM_DL_BASE_DL_ERROR =CSSM_DL_BASE_ERROR + CSSM_ERRORCODE_COMMON_EXTENT,//c
	CSSMERR_DL_MISSING_VALUE = CSSM_DL_BASE_DL_ERROR + 28,//c
	CSSMERR_DL_INVALID_QUERY =CSSM_DL_BASE_DL_ERROR + 46,//c
	CSSMERR_DL_INVALID_VALUE =CSSM_DL_BASE_DL_ERROR + 47,//c
	CSSMERR_DL_UNSUPPORTED_QUERY =	CSSM_DL_BASE_DL_ERROR + 29,//c
	CSSM_CSSM_BASE_ERROR =	CSSM_BASE_ERROR,//c
	CSSM_CSP_BASE_ERROR =CSSM_CSSM_BASE_ERROR + CSSM_ERRORCODE_MODULE_EXTENT,//c
	CSSM_CSP_BASE_CSP_ERROR =CSSM_CSP_BASE_ERROR + CSSM_ERRORCODE_COMMON_EXTENT,//c
	CSSMERR_CSP_BLOCK_SIZE_MISMATCH =CSSM_CSP_BASE_CSP_ERROR + 77,//c
	CSSMERR_CSP_INVALID_DIGEST_ALGORITHM =CSSM_CSP_BASE_CSP_ERROR + 85,//c
	CSSMERR_CSP_INVALID_ATTR_PADDING = CSSM_CSP_BASE_CSP_ERROR + 60,//c
	CSSMERR_CSP_INVALID_CONTEXT =CSSM_CSP_BASE_CSP_ERROR + 48,//c
	CSSMERR_CSP_INVALID_ALGORITHM =CSSM_CSP_BASE_CSP_ERROR + 49,//c
	CSSMERR_CSP_INPUT_LENGTH_ERROR =CSSM_CSP_BASE_CSP_ERROR + 1,//c
	CSSMERR_CSP_INVALID_DATA =CSSM_CSP_BASE_ERROR + CSSM_ERRCODE_INVALID_DATA,//c
	CSSMERR_CSP_INVALID_KEY_CLASS =CSSM_CSP_BASE_CSP_ERROR + 18,//c
	CSSMERR_CSP_KEY_BLOB_TYPE_INCORRECT =CSSM_CSP_BASE_CSP_ERROR + 21,//c
	CSSMERR_CSP_INVALID_ATTR_WRAPPED_KEY_FORMAT = CSSM_CSP_BASE_CSP_ERROR + 138,//c
	CSSMERR_CSP_INVALID_KEYATTR_MASK =CSSM_CSP_BASE_CSP_ERROR + 28,//c
	CSSMERR_DL_RECORD_NOT_FOUND =CSSM_DL_BASE_DL_ERROR + 27,//c
	CSSMERR_DL_INVALID_RECORDTYPE =CSSM_DL_BASE_DL_ERROR + 9,//c
	CSSMERR_DL_INVALID_UNIQUE_INDEX_DATA =CSSM_DL_BASE_DL_ERROR + 41,//c
	CSSMERR_CSP_KEY_USAGE_INCORRECT =CSSM_CSP_BASE_CSP_ERROR + 20,//c
	CSSMERR_DL_UNSUPPORTED_FIELD_FORMAT =CSSM_DL_BASE_DL_ERROR + 11,//c
	CSSMERR_DL_INCOMPATIBLE_FIELD_FORMAT =CSSM_DL_BASE_DL_ERROR + 19,//c
	CSSMERR_DL_FIELD_SPECIFIED_MULTIPLE =	CSSM_DL_BASE_DL_ERROR + 18,//c
	CSSMERR_DL_INVALID_FIELD_NAME =CSSM_DL_BASE_DL_ERROR + 10,//c
	CSSMERR_CSSM_INVALID_ADDIN_HANDLE =CSSM_CSSM_BASE_ERROR + CSSM_ERRORCODE_COMMON_EXTENT + 1,//c
	CSSMERR_CSP_INVALID_KEY_REFERENCE =CSSM_CSP_BASE_CSP_ERROR + 17,//c
	CSSMERR_DL_DATABASE_CORRUPT =CSSM_DL_BASE_DL_ERROR + 1,//c
	CSSMERR_DL_INTERNAL_ERROR =CSSM_DL_BASE_ERROR + CSSM_ERRCODE_INTERNAL_ERROR,//c
	CSSMERR_TP_INVALID_ANCHOR_CERT =	CSSM_TP_BASE_TP_ERROR + 18,//c
	CSSMERR_TP_CERT_EXPIRED =CSSM_TP_BASE_TP_ERROR + 10,//c
	CSSMERR_TP_CERT_NOT_VALID_YET =	CSSM_TP_BASE_TP_ERROR + 11,//c
};

#endif //HYS_SECURITY_CSSMERR_H
