#ifndef HYS_SECURITY_X509DEFS_H
#define HYS_SECURITY_X509DEFS_H

#define BER_TAG_PRINTABLE_STRING 1//?
#define BER_TAG_T61_STRING 2//?
#define BER_TAG_IA5_STRING 3//?
#define BER_TAG_PKIX_UTF8_STRING 4//?
#define BER_TAG_GENERAL_STRING 5//?
#define BER_TAG_PKIX_UNIVERSAL_STRING 6//?
#define BER_TAG_VIDEOTEX_STRING 7//?
#define BER_TAG_ISO646_STRING 8//?
#define BER_TAG_PKIX_BMP_STRING 9//?
#define BER_TAG_UNKNOWN 10//?
#define BER_TAG_SEQUENCE 11//?
#define BER_TAG_SET 12//?
#define BER_TAG_NUMERIC_STRING 13//?
#define BER_TAG_GRAPHIC_STRING 14//?

////////////////////////////
enum extension_data_format {
	CSSM_X509_DATAFORMAT_ENCODED,//?
	CSSM_X509_DATAFORMAT_PARSED,//?
	CSSM_X509_DATAFORMAT_PAIR,//?
};
typedef enum extension_data_format CSSM_X509EXT_DATA_FORMAT;
//////////////////////
typedef uint8 CSSM_BER_TAG;//c
//////////////////

struct cssm_x509_algorithm_identifier {};
typedef struct cssm_x509_algorithm_identifier CSSM_X509_ALGORITHM_IDENTIFIER; 

struct cssm_x509_extension { 
   	CSSM_X509EXT_DATA_FORMAT format;//c
    	CSSM_DATA BERvalue;//c
    	union cssm_x509ext_value {
        	void *parsedValue;//c
    	} value;
};
typedef struct cssm_x509_extension  CSSM_X509_EXTENSION;

struct cssm_x509_type_value_pair {
   	CSSM_OID type;//c
    	CSSM_BER_TAG valueType; //c
    	CSSM_DATA value;//c
};
typedef struct cssm_x509_type_value_pair CSSM_X509_TYPE_VALUE_PAIR; 
typedef struct cssm_x509_type_value_pair  *CSSM_X509_TYPE_VALUE_PAIR_PTR;

struct cssm_x509_rdn {
    	uint32 numberOfPairs;//c
    	CSSM_X509_TYPE_VALUE_PAIR_PTR AttributeTypeAndValue;//c
};
typedef struct cssm_x509_rdn  CSSM_X509_RDN;
typedef struct cssm_x509_rdn *CSSM_X509_RDN_PTR;

struct cssm_x509_name {
    	uint32 numberOfRDNs;//c
    	CSSM_X509_RDN_PTR RelativeDistinguishedName;//c
};
typedef struct cssm_x509_name CSSM_X509_NAME;
typedef struct cssm_x509_name  *CSSM_X509_NAME_PTR;

#endif//HYS_SECURITY_X509DEFS_H
