#ifndef HYS_SYSTEMCONFIGURATION_SCSCHEMADEFINITIONPRIVATE_H
#define HYS_SYSTEMCONFIGURATION_SCSCHEMADEFINITIONPRIVATE_H

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropVirtualNetworkInterfacesBondInterfaces, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)//c
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropVirtualNetworkInterfacesBondInterfaces                 \
	  SC_SCHEMA_KV(kSCPropVirtualNetworkInterfacesBondInterfaces    \
		      ,"Interfaces"                                     \
		      ,CFArray[CFString]                                )//c
#endif

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropVirtualNetworkInterfacesBondOptions, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropVirtualNetworkInterfacesBondOptions                    \
	  SC_SCHEMA_KV(kSCPropVirtualNetworkInterfacesBondOptions       \
		      ,"Options"                                        \
		      ,CFDictionary                                     )
#endif

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropVirtualNetworkInterfacesBondMode, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropVirtualNetworkInterfacesBondMode                       \
	  SC_SCHEMA_KV(kSCPropVirtualNetworkInterfacesBondMode          \
		      ,"Mode"                                           \
		      ,CFNumber                                         )
#endif

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPrefVirtualNetworkInterfaces, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPrefVirtualNetworkInterfaces                               \
	  SC_SCHEMA_KV(kSCPrefVirtualNetworkInterfaces                  \
		      ,"VirtualNetworkInterfaces"                       \
		      ,CFDictionary                                     )
#endif

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCEntNetEAPOL, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCEntNetEAPOL                                                \
	  SC_SCHEMA_KV(kSCEntNetEAPOL                                   \
		      ,"EAPOL"                                          \
		      ,CFDictionary                                     )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropSystemComputerNameRegion, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropSystemComputerNameRegion                               \
	  SC_SCHEMA_KV(kSCPropSystemComputerNameRegion                  \
		      ,"ComputerNameRegion"                             \
		      ,CFNumber                                         )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropSystemHostName, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropSystemHostName                                         \
	  SC_SCHEMA_KV(kSCPropSystemHostName                            \
		      ,"HostName"                                       \
		      ,CFString                                         )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropVirtualNetworkInterfacesVLANInterface, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropVirtualNetworkInterfacesVLANInterface                  \
	  SC_SCHEMA_KV(kSCPropVirtualNetworkInterfacesVLANInterface     \
		      ,"Interface"                                      \
		      ,CFString                                         )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropVirtualNetworkInterfacesVLANTag, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropVirtualNetworkInterfacesVLANTag                        \
	  SC_SCHEMA_KV(kSCPropVirtualNetworkInterfacesVLANTag           \
		      ,"Tag"                                            \
		      ,CFNumber                                         )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropVirtualNetworkInterfacesVLANOptions, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropVirtualNetworkInterfacesVLANOptions                    \
	  SC_SCHEMA_KV(kSCPropVirtualNetworkInterfacesVLANOptions       \
		      ,"Options"                                        \
		      ,CFDictionary                                     )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropNetPPPOnDemandDomains, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropNetPPPOnDemandDomains                                  \
	  SC_SCHEMA_KV(kSCPropNetPPPOnDemandDomains                     \
		      ,"OnDemandDomains"                                \
		      ,CFArray[CFString]                                )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropNetPPPOnDemandEnabled, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropNetPPPOnDemandEnabled                                  \
	  SC_SCHEMA_KV(kSCPropNetPPPOnDemandEnabled                     \
		      ,"OnDemandEnabled"                                \
		      ,CFNumber (0 or 1)                                )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCValNetPPPOnDemandPriorityDefault, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCValNetPPPOnDemandPriorityDefault                           \
	  SC_SCHEMA_KV(kSCValNetPPPOnDemandPriorityDefault              \
		      ,"Default"                                        \
		      ,                                                 )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropNetPPPOnDemandPriority, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropNetPPPOnDemandPriority                                 \
	  SC_SCHEMA_KV(kSCPropNetPPPOnDemandPriority                    \
		      ,"OnDemandPriority"                               \
		      ,CFString                                         )
#endif//c

#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1050
  SC_SCHEMA_DECLARATION(kSCPropNetPPPOnDemandHostName, AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER)
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1050) || (MAC_OS_X_VERSION_MAX_ALLOWED >= 1050)
  #define kSCPropNetPPPOnDemandHostName                                 \
	  SC_SCHEMA_KV(kSCPropNetPPPOnDemandHostName                    \
		      ,"OnDemandHostName"                               \
		      ,CFString                                         )
#endif//c

#endif//HYS_SYSTEMCONFIGURATION_SCSCHEMADEFINITIONPRIVATE_H
