#ifndef HYS_ARCHITECTURE_I386_MATH_H
#define HYS_ARCHITECTURE_I386_MATH_H

#ifdef __CYGWIN__

#ifndef FLT_EVAL_METHOD
#define FLT_EVAL_METHOD  __FLT_EVAL_METHOD__
#endif

#endif//__CYGWIN__

#if __FLT_EVAL_METHOD__ == 0
	typedef float float_t;
	typedef double double_t;
#elif __FLT_EVAL_METHOD__ == 1
	typedef double float_t;
	typedef double double_t;
#elif __FLT_EVAL_METHOD__ == 2 || __FLT_EVAL_METHOD__ == -1
#ifndef __CYGWIN__
	typedef long double float_t;
	typedef long double double_t;
#endif//__CYGWIN__	
#else /* __FLT_EVAL_METHOD__ */
	#error "Unsupported value of __FLT_EVAL_METHOD__."
#endif /* __FLT_EVAL_METHOD__ *///c

#if defined(__GNUC__) && ! defined( __XLC__ )
	#define __MATH_H_ALWAYS_INLINE__		__attribute__ ((always_inline))
#else
	#define __MATH_H_ALWAYS_INLINE__
#endif//c

////////////////////////////
#if (__WANT_LONG_DOUBLE_FORMAT__ - 0L == 128L)
	#if defined( __GNUC__ ) && ! defined( __XLC__ ) && 0 == __FINITE_MATH_ONLY__
		#define isnan(x)	\
			(	sizeof (x) == sizeof(float )	?	__inline_isnanf((float)(x))	\
			:	sizeof (x) == sizeof(double)	?	__inline_isnand((double)(x))	\
:				__inline_isnan ((long double)(x)))

	#define isinf(x)	\
			(	sizeof (x) == sizeof(float )	?	__inline_isinff((float)(x))	\
			:	sizeof (x) == sizeof(double)	?	__inline_isinfd((double)(x))	\
												:	__inline_isinf ((long double)(x)))
	#else
		#define isnan(x)	\
			(	sizeof (x) == sizeof(float )	?	__isnanf((float)(x))	\
			:	sizeof (x) == sizeof(double)	?	__isnand((double)(x))	\
	: 	__isnan ((long double)(x)))

	#define isinf(x)	\
			(	sizeof (x) == sizeof(float )	?	__isinff((float)(x))	\
			:	sizeof (x) == sizeof(double)	?	__isinfd((double)(x))	\
												:	__isinf ((long double)(x)))
	#endif

#else
	#if defined( __GNUC__ ) && ! defined( __XLC__ ) && 0 == __FINITE_MATH_ONLY__
		#define isnan(x)	\
			(	sizeof (x) == sizeof(float )	?	__inline_isnanf((float)(x))		:	__inline_isnand((double)(x))	)

		#define isinf(x)	\
			(	sizeof (x) == sizeof(float )	?	__inline_isinff((float)(x))		:	__inline_isinfd((double)(x))	)

	static __inline__ int __inline_isnanf	(float      ) __MATH_H_ALWAYS_INLINE__;//c
	static __inline__ int __inline_isnanf( float __x ) {  };//?
	static __inline__ int __inline_isnand		(double     ) __MATH_H_ALWAYS_INLINE__;//c
	static __inline__ int __inline_isnand( double __x ) {};//?
	static __inline__ int __inline_isinff		(float      ) __MATH_H_ALWAYS_INLINE__;//c
	static __inline__ int __inline_isinff( float __x ) {};//?
	static __inline__ int __inline_isinfd		(double     ) __MATH_H_ALWAYS_INLINE__;
	static __inline__ int __inline_isinfd( double __x ) { };//?
	#else
		#define isnan(x)	\
			(	sizeof (x) == sizeof(float )	?	__isnanf((float)(x))	:	__isnand((double)(x))		)

		#define isinf(x)	\
			(	sizeof (x) == sizeof(float )	?	__isinff((float)(x))	:	__isinfd((double)(x))		)

	#endif
							  
#endif /* __WANT_LONG_DOUBLE_FORMAT__ *///c
//////////////////////////////////////////////////////

//////////////////////

extern int __isinff     (float      );//c

#ifndef OC_scalb
extern double scalb ( double, double ); //c
#endif

#endif//HYS_ARCHITECTURE_I386_MATH_H
