#ifndef HYS_ARHITECUURE_M88K_FP_REGS_H
#define HYS_ARHITECUURE_M88K_FP_REGS_H

enum m88k_fpcr_rm_t {
	M88K_RM_NEAREST = 0,//c
	M88K_RM_ZERO	= 1,//c
	M88K_RM_NEGINF = 2,//c
	M88K_RM_POSINF =3	//c
};
typedef enum m88k_fpcr_rm_t m88k_fpcr_rm_t;

union m88k_xrf_t {
#ifdef __GNUC__
	unsigned	x[4] __attribute__(( aligned(16) ));
#else
	unsigned	x[4];
#endif//c
};
typedef union m88k_xrf_t m88k_xrf_t;

struct m88k_fpsr_t {
	unsigned	:BITS_WIDTH(31,17);
	unsigned	xmod:BIT_WIDTH(16);	
	unsigned	:BITS_WIDTH(15,5);
	unsigned	afinv:BIT_WIDTH(4);	
	unsigned	afdvz:BIT_WIDTH(3);
	unsigned	afunf:BIT_WIDTH(2);
	unsigned	afovf:BIT_WIDTH(1);	
	unsigned	afinx:BIT_WIDTH(0);
};//c
typedef struct m88k_fpsr_t m88k_fpsr_t;

struct m88k_fpcr_t {
	unsigned	:BITS_WIDTH(31,16);
	m88k_fpcr_rm_t	rm:BITS_WIDTH(15,14);	
	unsigned	:BITS_WIDTH(13,5);
	unsigned	efinv:BIT_WIDTH(4);	
	unsigned	efdvz:BIT_WIDTH(3);
	unsigned	efunf:BIT_WIDTH(2);	
	unsigned	efovf:BIT_WIDTH(1);	
	unsigned	efinx:BIT_WIDTH(0);	
};//c
typedef struct m88k_fpcr_t m88k_fpcr_t;

#endif//HYS_ARHITECUURE_M88K_FP_REGS_H
