#ifndef HYS_ARCHITECTURE_SPARC_REG_H
#define HYS_ARCHITECTURE_SPARC_REG_H

#define	FPU_FSR_TYPE unsigned//c
#define	FPU_REGS_TYPE unsigned//c

////////////
#define FQ_DEPTH 1//?
//////////////////////////////////
struct regs {
	int	r_pc;//c
	int	r_o6;//c
	int	r_npc;//c
	int	r_y;	//c
	int	r_g1;	//c
	int	r_g2;//c
	int	r_g3;//c
	int	r_g4;//c
	int	r_g5;//c
	int	r_g6;//c
	int	r_g7;//c
	int	r_o0;//c
	int	r_o1;//c
	int	r_o2;//c
	int	r_o3;//c
	int	r_o4;//c
	int	r_o5;//c
	int	r_o7;//c
	int	r_psr;//c
};
#define	r_sp	r_o6//c

struct p_status {
  union {
    unsigned int psr;
    struct {
	unsigned int 
	impl:4,
	ver:4,
	icc:4,
	reserved:6,
	ec:1,
	ef:1,
	pil:4,
	s:1,
	ps:1,
	et:1,
	cwp:5;
      } psr_bits;
  } PSRREG;
};//c

struct fq {
	union {	
		double	whole;//c
	} FQu;
};

struct	fpu {
	union {
		double	Fpu_dregs[16];//c
		FPU_REGS_TYPE Fpu_regs[32];//c
	} fpu_fr;
	struct fq Fpu_q[FQ_DEPTH];//c
	unsigned Fpu_flags;//c
	unsigned Fpu_extra;//c
	unsigned Fpu_qcnt;	//c
	FPU_FSR_TYPE Fpu_fsr;//c
};
 
struct f_status {
  	union {
    		struct {    
   		   unsigned int
      		rd:2,
      		rp:2,
      		tem:5,
      		res:6,
      		ftt:3,
      		qne:1,
      		pr:1,
      		fcc:2,
      		aexc:5,
      		cexc:5;
		} Fpu_fsr_bits;//c
	} FPUREG;
};

#endif//HYS_ARCHITECTURE_SPARC_REG_H
