#ifndef HYS_DNSINFO_H
#define HYS_DNSINFO_H

#define	DNS_PTR(type, name)				\
	union {						\
		type		name;			\
		uint64_t	_ ## name ## _p;	\
	}//c

#define	DNS_VAR(type, name)				\
	type	name//c

///////////////////////////

typedef struct {
	struct in_addr	address;
	struct in_addr	mask;
} dns_sortaddr_t;//c

typedef struct {
	DNS_VAR(uint16_t,		port);//c
	DNS_VAR(int32_t,		n_nameserver);//c
	DNS_PTR(struct sockaddr **,	nameserver);//c
	DNS_VAR(int32_t,		n_search);//c
	DNS_PTR(char **,		search);//c
	DNS_PTR(char *,			domain);//c
	DNS_VAR(uint32_t,		timeout);//c
	DNS_VAR(uint32_t,		search_order);	//c
	DNS_VAR(int32_t,		n_sortaddr);//c
	DNS_PTR(dns_sortaddr_t **,	sortaddr);//c
	DNS_PTR(char *,			options);//c
} dns_resolver_t;

typedef struct {
	DNS_PTR(dns_resolver_t **,	resolver);//c
	DNS_VAR(int32_t,		n_resolver);//c
} dns_config_t;

#endif//HYS_DNSINFO_H
