#ifndef HYS_KERN_QUEUE_H
#define HYS_KERN_QUEUE_H

#define	queue_empty(a) queue_end((a), queue_first(a))	//c
#define	queue_end(a, b)	((a) == (b))//c

#define	queue_remove(a, b,c,d)	\
MACRO_BEGIN							\
	register queue_entry_t	__next, __prev;			\
								\
	__next = (b)->d.next;				\
	__prev = (b)->d.prev;				\
								\
	if ((a) == __next)					\
		(a)->prev = __prev;				\
	else							\
		((c)__next)->d.prev = __prev;		\
								\
	if ((a) == __prev)					\
		(a)->next = __next;				\
	else							\
		((c)__prev)->d.next = __next;		\
MACRO_END //c

#define queue_iterate(a, b, c,d)			\
	for ((b) = (c) queue_first(a);			\
	     !queue_end((a), (queue_entry_t)(b));		\
	     (b) = (c) queue_next(&(b)->d)) //c

#define	queue_first(a)	a//?
#define	queue_next(a)	a//?
#define queue_init(a) //?
#define queue_enter(a, b, c, d)	//?
#define	queue_remove_first(a, b, c, d)	//?
#define queue_new_head(a, b, c, d)//?
#define queue_enter_first(a, b, c, d) //?
#define	queue_prev(a) a	//?

struct queue_entry {
	struct queue_entry * next;//c
	struct queue_entry *prev;//c
};

typedef struct queue_entry queue_head_t;//c
typedef struct queue_entry *queue_entry_t;//c
typedef struct queue_entry  queue_chain_t;//c
typedef struct queue_entry *queue_t;//c

int dequeue_head(queue_t a);//?
int enqueue_tail(queue_t a, queue_entry_t b);//?

#endif //HYS_KERN_QUEUE_H
