#ifndef HYS_LIBKERN_OSBYTEORDER_H
#define HYS_LIBKERN_OSBYTEORDER_H

//#include <sys/types.h>//int32_t
//////////////hys add
#if (defined(__i386__) || defined(__x86_64__)) && !defined(__LITTLE_ENDIAN__)
    #define __LITTLE_ENDIAN__ 1
#endif//add

#ifndef __LITTLE_ENDIAN__
#define __BIG_ENDIAN__
#endif
////////////////////

enum {
	OSLittleEndian,//?
	OSBigEndian,//?
};

////////////////////////

#if		defined(__BIG_ENDIAN__)

#define OSWriteLittleInt32(base, byteOffset, data) OSWriteSwapInt32(base, byteOffset, data)//c
#define OSReadLittleInt16(base, byteOffset) OSReadSwapInt16(base, byteOffset)//c
#define OSReadLittleInt32(base, byteOffset) OSReadSwapInt32(base, byteOffset)//c
#define OSWriteLittleInt16(base, byteOffset, data) OSWriteSwapInt16(base, byteOffset, data)//c
#define OSWriteLittleInt16(base, byteOffset, data) OSWriteSwapInt16(base, byteOffset, data)//c
#define OSSwapHostToLittleInt32(x) OSSwapInt32(x)//c
#define OSSwapHostToLittleConstInt32(x) OSSwapConstInt32(x) //c
#define OSSwapLittleToHostInt32(x) OSSwapInt32(x)//c
#define OSSwapBigToHostInt16(x) ((uint16_t)(x))//c
#define OSSwapBigToHostInt32(x) ((uint32_t)(x))//c
#define OSReadLittleInt64(base, byteOffset) OSReadSwapInt64(base, byteOffset)//c
#define OSSwapHostToLittleConstInt16(x) OSSwapConstInt16(x)//c
#define OSWriteLittleInt64(base, byteOffset, data) OSWriteSwapInt64(base, byteOffset, data)//c
#define OSReadBigInt32(base, byteOffset) _OSReadInt32(base, byteOffset)//c
#define OSSwapHostToLittleInt16(x) OSSwapInt16(x)//c
#define OSWriteBigInt32(base, byteOffset, data) _OSWriteInt32(base, byteOffset, data)//c
#define OSSwapHostToBigInt32(x) ((uint32_t)(x))//c
#define OSSwapHostToBigInt16(x) ((uint16_t)(x))//c
#define OSSwapLittleToHostInt16(x) OSSwapInt16(x)//c
#define OSSwapHostToBigInt64(x) ((uint64_t)(x))//c
#define OSReadBigInt16(base, byteOffset) _OSReadInt16(base, byteOffset)//c
#define OSSwapLittleToHostInt64(x) OSSwapInt64(x)//c
#define OSSwapHostToLittleInt64(x) OSSwapInt64(x)//c
#define OSSwapBigToHostInt64(x) ((uint64_t)(x))//c
#define OSWriteBigInt16(base, byteOffset, data) _OSWriteInt16(base, byteOffset, data)//c
#define OSReadBigInt64(base, byteOffset) _OSReadInt64(base, byteOffset)//c
#define OSWriteBigInt64(base, byteOffset, data) _OSWriteInt64(base, byteOffset, data)//c

#elif		defined(__LITTLE_ENDIAN__)

#define OSWriteBigInt64(base, byteOffset, data) OSWriteSwapInt64(base, byteOffset, data)//c
#define OSReadBigInt64(base, byteOffset) OSReadSwapInt64(base, byteOffset)//c
#define OSWriteLittleInt32(base, byteOffset, data) _OSWriteInt32(base, byteOffset, data)//c
#define OSReadLittleInt16(base, byteOffset) _OSReadInt16(base, byteOffset)//c
#define OSReadLittleInt32(base, byteOffset) _OSReadInt32(base, byteOffset)//c
#define OSWriteLittleInt16(base, byteOffset, data) _OSWriteInt16(base, byteOffset, data)//c
#define OSWriteLittleInt16(base, byteOffset, data) _OSWriteInt16(base, byteOffset, data)//c
#define OSSwapHostToLittleInt32(x) ((uint32_t)(x))//c
#define OSSwapHostToLittleConstInt32(x) (x)//c
#define OSSwapLittleToHostInt32(x) ((uint32_t)(x))//c
#define OSSwapBigToHostInt16(x) OSSwapInt16(x)//c
#define OSSwapBigToHostInt32(x) OSSwapInt32(x)//c
#define OSReadLittleInt64(base, byteOffset) _OSReadInt64(base, byteOffset)//c
#define OSSwapHostToLittleConstInt16(x) (x)//c
#define OSWriteLittleInt64(base, byteOffset, data) _OSWriteInt64(base, byteOffset, data)//c
#define OSReadBigInt32(base, byteOffset) OSReadSwapInt32(base, byteOffset)//c
#define OSSwapHostToLittleInt16(x) ((uint16_t)(x))//c
#define OSWriteBigInt32(base, byteOffset, data) OSWriteSwapInt32(base, byteOffset, data)//c
#define OSSwapHostToBigInt32(x) OSSwapInt32(x)//c
#define OSSwapHostToBigInt16(x) OSSwapInt16(x)//c
#define OSSwapLittleToHostInt16(x) ((uint16_t)(x))//c
#define OSSwapHostToBigInt64(x) OSSwapInt64(x)//c
#define OSReadBigInt16(base, byteOffset) OSReadSwapInt16(base, byteOffset)//c
#define OSSwapLittleToHostInt64(x) ((uint64_t)(x))//c
#define OSSwapHostToLittleInt64(x) ((uint64_t)(x))//c
#define OSSwapBigToHostInt64(x) OSSwapInt64(x)//c
#define OSWriteBigInt16(base, byteOffset, data) OSWriteSwapInt16(base, byteOffset, data)//c

#else
#error Unknown endianess.
#endif
////////////////////////////////
#define OSSwapInt32(x)	__DARWIN_OSSwapInt32(x)//c
#define OSSwapInt64(x)	__DARWIN_OSSwapInt64(x)//c
#define OSSwapInt16(x)	__DARWIN_OSSwapInt16(x)//c
#define OSSwapConstInt32(x)	__DARWIN_OSSwapConstInt32(x)//c
#define OSSwapConstInt16(x)	__DARWIN_OSSwapConstInt16(x)//c
#define OSSwapConstInt64(x)	__DARWIN_OSSwapConstInt64(x)//c

///////////////////

OS_INLINE
int32_t
OSHostByteOrder(void) { };//c?

OS_INLINE
uint16_t
_OSReadInt16(
    const volatile void               * base,
    uintptr_t                     byteOffset
) {};//c?

OS_INLINE
void
_OSWriteInt16(
    volatile void               * base,
    uintptr_t                     byteOffset,
    uint16_t                      data
) {};//c?

OS_INLINE
uint32_t
_OSReadInt32(
    const volatile void               * base,
    uintptr_t                     byteOffset
) {};//c?

OS_INLINE
void
_OSWriteInt32(
    volatile void               * base,
    uintptr_t                     byteOffset,
    uint32_t                      data
) {};//c?

OS_INLINE
uint64_t
_OSReadInt64(
    const volatile void               * base,
    uintptr_t                     byteOffset
) {};//c?

OS_INLINE
void
_OSWriteInt64(
    volatile void               * base,
    uintptr_t                     byteOffset,
    uint64_t                      data
) {};//c?

#endif//HYS_LIBKERN_OSBYTEORDER_H
