#ifndef HYS_LIBKERN__OSBYTEORDER_H
#define HYS_LIBKERN__OSBYTEORDER_H

#define __DARWIN_OSSwapConstInt32(x) \
    ((__uint32_t)((((__uint32_t)(x) & 0xff000000) >> 24) | \
                (((__uint32_t)(x) & 0x00ff0000) >>  8) | \
                (((__uint32_t)(x) & 0x0000ff00) <<  8) | \
                (((__uint32_t)(x) & 0x000000ff) << 24)))//c

#define __DARWIN_OSSwapConstInt64(x) \
    ((__uint64_t)((((__uint64_t)(x) & 0xff00000000000000ULL) >> 56) | \
                (((__uint64_t)(x) & 0x00ff000000000000ULL) >> 40) | \
                (((__uint64_t)(x) & 0x0000ff0000000000ULL) >> 24) | \
                (((__uint64_t)(x) & 0x000000ff00000000ULL) >>  8) | \
                (((__uint64_t)(x) & 0x00000000ff000000ULL) <<  8) | \
                (((__uint64_t)(x) & 0x0000000000ff0000ULL) << 24) | \
                (((__uint64_t)(x) & 0x000000000000ff00ULL) << 40) | \
                (((__uint64_t)(x) & 0x00000000000000ffULL) << 56)))//c

#define __DARWIN_OSSwapConstInt16(x) \
    ((__uint16_t)((((__uint16_t)(x) & 0xff00) >> 8) | \
                (((__uint16_t)(x) & 0x00ff) << 8)))//c

////////////////////////
#if defined(__GNUC__)

#define __DARWIN_OSSwapInt32(x) \
    (__builtin_constant_p(x) ? __DARWIN_OSSwapConstInt32(x) : _OSSwapInt32(x))//c

#define __DARWIN_OSSwapInt32(x) \
    (__builtin_constant_p(x) ? __DARWIN_OSSwapConstInt32(x) : _OSSwapInt32(x))//c

#define __DARWIN_OSSwapInt64(x)    (__builtin_constant_p(x) ? __DARWIN_OSSwapConstInt64(x) : _OSSwapInt64(x))//c

#define __DARWIN_OSSwapInt16(x) (__builtin_constant_p(x) ? __DARWIN_OSSwapConstInt16(x) : _OSSwapInt16(x))//c

#else /* ! __GNUC__ */

#define __DARWIN_OSSwapInt32(x) _OSSwapInt32(x)//c
#define __DARWIN_OSSwapInt32(x) _OSSwapInt32(x)//c
#define __DARWIN_OSSwapInt64(x) _OSSwapInt64(x)//c
#define __DARWIN_OSSwapInt16(x) _OSSwapInt16(x)//c

#endif /* __GNUC__ */

#if !defined(__DARWIN_OS_INLINE)
# if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#        define __DARWIN_OS_INLINE static inline
# elif defined(__MWERKS__) || defined(__cplusplus)
#        define __DARWIN_OS_INLINE static inline
# else
#        define __DARWIN_OS_INLINE static __inline__
# endif
#endif//c

////////////////

__DARWIN_OS_INLINE
uint32_t _OSSwapInt32(   uint32_t			data) {};//c?

__DARWIN_OS_INLINE
uint64_t _OSSwapInt64(    uint64_t			data) {};//c?

__DARWIN_OS_INLINE
uint16_t _OSSwapInt16( uint16_t			data) {};//c?

#endif//HYS_LIBKERN__OSBYTEORDER_H
