#ifndef HYS_MACH_O_DYLD_H
#define HYS_MACH_O_DYLD_H

#define NSADDIMAGE_OPTION_NONE 1//?
#define NSLINKMODULE_OPTION_RETURN_ON_ERROR 2//?
#define NSADDIMAGE_OPTION_RETURN_ON_ERROR 3//?
#define NSADDIMAGE_OPTION_MATCH_FILENAME_BY_INSTALLNAME 4//?
#define NSADDIMAGE_OPTION_RETURN_ONLY_IF_LOADED 5//?
#define NSADDIMAGE_OPTION_WITH_SEARCHING 6//?
#define NSLOOKUPSYMBOLINIMAGE_OPTION_BIND 7//?
#define NSLOOKUPSYMBOLINIMAGE_OPTION_RETURN_ON_ERROR 8//?

///////////////////////////////////////////////

typedef enum {
    NSLinkEditFileAccessError,
    NSLinkEditFileFormatError,
    NSLinkEditMachResourceError,
    NSLinkEditUnixResourceError,
    NSLinkEditOtherError,
    NSLinkEditWarningError,
    NSLinkEditMultiplyDefinedError,
    NSLinkEditUndefinedError
} NSLinkEditErrors;//c

//#ifndef ENUM_DYLD_BOOL
//#define ENUM_DYLD_BOOL

  #undef FALSE
  #undef TRUE
 enum DYLD_BOOL {
	#ifndef OC_FALSE
	#define OC_FALSE
	 FALSE, 
	#endif
	#ifndef OC_TRUE
	#define OC_TRUE
	TRUE,
	#endif
	#if defined (OC_FALSE) && defined (OC_TRUE)
	enum_DYLD_BOOL,//dummy
	#endif
 };//c


//#endif /* ENUM_DYLD_BOOL */

//////////////////////
typedef struct __NSObjectFileImage*  NSObjectFileImage;//c
typedef struct __NSModule* NSModule;//c
typedef struct __NSSymbol* NSSymbol;//c

struct NSLinkEditErrorHandlers {
    	 void  (*undefined)(const char* symbolName);//c
     	NSModule (*multiple)(NSSymbol s, NSModule oldModule, NSModule newModule); //c
     	void  (*linkEdit)(NSLinkEditErrors errorClass, int errorNumber, const char* fileName, const char* errorString);//c
};
typedef struct NSLinkEditErrorHandlers NSLinkEditErrorHandlers;

/////////////////


extern void NSLinkEditError(NSLinkEditErrors *c, int *errorNumber, const char** fileName, const char** errorString);//c 

extern int _dyld_func_lookup(const char* dyld_func_name, void **address);

#endif//HYS_MACH_O_DYLD_H
