#ifndef HYS_MACH_O_DYLD_DEBUG_H
#define HYS_MACH_O_DYLD_DEBUG_H

enum dyld_debug_return { 
	DYLD_FAILURE,//?
	DYLD_INVALID_ARGUMENTS,//?
	DYLD_SUCCESS,//?
	DYLD_INCONSISTENT_DATA,//?
};

enum dyld_event_type {
	DYLD_IMAGE_ADDED,//?
	DYLD_MODULE_BOUND,//?
	DYLD_PAST_EVENTS_END,//?
	DYLD_MODULE_REMOVED,//?
    	DYLD_IMAGE_REMOVED,//?
};

////////////////////

struct _debug_task_state {};

struct _dyld_debug_task_state {
    	mach_port_t	   debug_port;//c
    	mach_port_t   *threads;//c
    	unsigned int   thread_count;//c
    	mach_port_t    debug_thread;//c
   	unsigned int   debug_thread_resume_count;//c
    	unsigned int   task_resume_count;//c
};

struct dyld_debug_module {
 	struct mach_header *header;//c
    	unsigned long vmaddr_slide;//C
    	unsigned long module_index;//c
};

struct dyld_event {
    	enum dyld_event_type type;//c
    	struct dyld_debug_module arg[2];//c
};

struct _dyld_event_message_request {
#ifdef __MACH30__
    mach_msg_header_t head;//c
#else
    msg_header_t head;//c
#endif
};

struct _dyld_event_message_reply {
#ifdef __MACH30__
    mach_msg_header_t head;//c
#else
    msg_header_t head;//c
#endif
};

struct dyld_debug_error_data {
    	enum dyld_debug_return dyld_debug_return;//c
    	kern_return_t mach_error;//c
    	int dyld_debug_errno;//c
    	unsigned long local_error;//c
    	char *file_name;//c
    	unsigned long line_number;//c
};

/////////////////

extern enum dyld_debug_return _dyld_debug_make_runnable(
    mach_port_t target_task,
    struct _dyld_debug_task_state *state);//c

extern enum dyld_debug_return _dyld_debug_restore_runnable(
    mach_port_t target_task,
    struct _dyld_debug_task_state *state);//c

#endif//HYS_MACH_O_DYLD_DEBUG_H
