#ifndef HYS_MACH_O_DYLD_IMAGES_H
#define HYS_MACH_O_DYLD_IMAGES_H


#include <machine/types.h>//uintptr_t-add

#include <stdbool.h>//bool-add


////////////////////////
enum dyld_image_mode {
	dyld_image_adding,//?
	dyld_image_removing,//?
};

////////////////

struct dyld_image_info {
	const char* imageFilePath;//c
	const struct mach_header*	imageLoadAddress;//c
	uintptr_t					imageFileModDate;//c
};

typedef void (*dyld_image_notifier)(enum dyld_image_mode mode, uint32_t infoCount, const struct dyld_image_info info[]);//c

struct dyld_shared_cache_ranges {
	uintptr_t					sharedRegionsCount;//c
	struct {
		uintptr_t	start;//c
		uintptr_t	length;//c
	}ranges[4];
};
extern struct dyld_shared_cache_ranges dyld_shared_cache_ranges;

struct dyld_all_image_infos {
	uint32_t						version;
	uint32_t						infoArrayCount;
	const struct dyld_image_info*	infoArray;
	dyld_image_notifier				notification;		
	bool							processDetachedFromSharedRegion;
};//c
extern struct dyld_all_image_infos  dyld_all_image_infos;//c

#endif//HYS_MACH_O_DYLD_IMAGES_H
