#ifndef HYS_MACH_O_LOADER_H
#define HYS_MACH_O_LOADER_H

#define LC_REQ_DYLD 0x80000000//c
#define	SECT_TEXT	"__text"//c
#define	LC_LOAD_WEAK_DYLIB (0x18 | LC_REQ_DYLD)//c
#define LC_REEXPORT_DYLIB (0x1f | LC_REQ_DYLD) //c
#define LC_RPATH       (0x1c | LC_REQ_DYLD)//c
#define SEG_UNIXSTACK	"__UNIXSTACK"//c
#define	SEG_PAGEZERO	"__PAGEZERO"	//c
#define SEG_IMPORT	"__IMPORT"//c
#define	SECT_DATA	"__data"//c
#define SECT_OBJC_SYMBOLS "__symbol_table"	//c
#define	SEG_OBJC	"__OBJC"//c
#define SECT_OBJC_MODULES "__module_info"//c
#define SECT_OBJC_STRINGS "__selector_strs"//c
#define	SECT_BSS	"__bss"//c
#define SECT_COMMON	"__common"//c
#define SECT_FVMLIB_INIT0 "__fvmlib_init0"//c

#ifndef S_ATTR_DEBUG
#define	S_ATTR_DEBUG		 0x02000000
#endif

#define	SEG_TEXT	"__TEXT"//c
#define	SEG_DATA	"__DATA"	//c
#define	SEG_LINKEDIT	"__LINKEDIT"//c

/////////////////////////
#define LC_LOAD_DYLIB 1//?
#define LC_SEGMENT_64 2//?
#define LC_SEGMENT 3//?
#define MH_MAGIC 4//?
#define MH_CIGAM 5//?
#define MH_CORE 6//?
#define MH_EXECUTE 7//?
#define MH_MAGIC_64 8//?
#define MH_CIGAM_64 9//?
#define MH_OBJECT 10//?
#define MH_DYLIB 11//?
#define MH_BUNDLE 12//?
#define LC_SYMTAB 13//?
#define LC_DYSYMTAB 14//?
#define LC_THREAD 15//?
#define LC_SUB_UMBRELLA 16//?
#define LC_UNIXTHREAD 17//?
#define LC_UUID 18//?
#define MH_INCRLINK 19//?
#define MH_DYLINKER 20//?
#define MH_DYLIB_STUB 21//?
#define S_ZEROFILL 22//?
#define LC_ROUTINES 23//?
#define LC_ROUTINES_64 24//?
#define LC_TWOLEVEL_HINTS 25//?
#define LC_CODE_SIGNATURE 26//?
#define LC_SEGMENT_SPLIT_INFO 27//?
#define LC_SUB_CLIENT 28//?
#define LC_PREBIND_CKSUM 29//?
#define LC_SYMSEG 30//?
#define LC_IDFVMLIB 31//?
#define LC_LOADFVMLIB 32//?
#define LC_ID_DYLIB 33//?
#define LC_SUB_FRAMEWORK 35//?
#define LC_SUB_LIBRARY 36//?
#define LC_PREBOUND_DYLIB 37//?
#define LC_ID_DYLINKER 38//?
#define LC_LOAD_DYLINKER 39//?
#define LC_IDENT 40//?
#define SECTION_TYPE 41//?
#define S_COALESCED 42//?
#define SG_FVMLIB 43//?
#define MH_FVMLIB 44//?
#define S_LAZY_SYMBOL_POINTERS 46//?
#define S_NON_LAZY_SYMBOL_POINTERS 47//?
#define S_SYMBOL_STUBS 48//?
#define INDIRECT_SYMBOL_LOCAL 49//?
#define INDIRECT_SYMBOL_ABS 50//?
#define S_REGULAR 51//?
#define S_ATTR_NO_TOC 52//?
#define S_ATTR_SOME_INSTRUCTIONS 53//?
#define MH_PRELOAD 54//?
#define MH_DYLDLINK 55//?
#define MH_TWOLEVEL 56//?
#define MH_ALLOW_STACK_EXECUTION 57//?
#define MH_BINDATLOAD 58//?
#define MH_SPLIT_SEGS 59//?
#define MH_SUBSECTIONS_VIA_SYMBOLS 60//?
#define MH_NOFIXPREBINDING 61//?
#define MH_FORCE_FLAT 62//?
#define MH_NOMULTIDEFS 63//?
#define MH_PREBOUND 64//?
#define MH_NOUNDEFS 65//?
#define S_CSTRING_LITERALS 66//?
#define S_4BYTE_LITERALS 67//?
#define S_8BYTE_LITERALS 68//?
#define SECTION_ATTRIBUTES 69//?
#define S_ATTR_EXT_RELOC 70//?
#define S_ATTR_LOC_RELOC 71//?
#define S_MOD_INIT_FUNC_POINTERS 72//?
#define S_LITERAL_POINTERS 73//?
#define S_MOD_TERM_FUNC_POINTERS 74//?
#define LC_FVMFILE 75//?
#define LC_PREPAGE 76//?
#define S_ATTR_PURE_INSTRUCTIONS 77//?
#define SG_NORELOC 78//?
#define S_ATTR_NO_DEAD_STRIP 79//?
#define S_ATTR_SELF_MODIFYING_CODE 80//?
#define S_ATTR_LIVE_SUPPORT 81//?
#define S_ATTR_STRIP_STATIC_SYMS 82//?
#define MH_WEAK_DEFINES 83//?
#define MH_BINDS_TO_WEAK 84//?
#define S_16BYTE_LITERALS 85//?
#define S_INTERPOSING 86//?
#define MH_PREBINDABL 87//?
#define MH_PREBINDABLE 88//?
#define MH_CANONICAL 89//?
#define MH_ALLMODSBOUND 90//?
#define MH_DSYM 91//?
#define MH_LAZY_INIT 92//?
#define MH_PIE 93//?
#define MH_NO_REEXPORTED_DYLIBS 94//?
#define SG_HIGHVM 95//?
#define SG_PROTECTED_VERSION_1 96//?
#define MH_ROOT_SAFE 97//?
#define MH_SETUID_SAFE 98//?

//////////////////////////////////

struct dysymtab_command { 
  	uint32_t nmodtab;//c
    	uint32_t modtaboff;//c
    	uint32_t cmdsize;//c
 	uint32_t tocoff;//c
  	uint32_t ntoc;//c
   	uint32_t extrefsymoff;//c
   	uint32_t nextrefsyms;//c
    	uint32_t indirectsymoff;//c
    	uint32_t nindirectsyms;//c
    	uint32_t extreloff;//c
    	uint32_t nextrel;//c
  	uint32_t locreloff;//c
 	uint32_t nlocrel;//c
  	uint32_t nlocalsym;//c
    	uint32_t ilocalsym;//c
    	uint32_t nextdefsym;//c
  	uint32_t iextdefsym;//c
	uint32_t nundefsym;//c
    	uint32_t iundefsym;//c
  	uint32_t cmd;//c
};

struct dylib_module {
    	uint32_t module_name;//c
    	uint32_t nextdefsym;//c
   	uint32_t iextdefsym;//c
  	uint32_t nlocalsym;//c
	uint32_t ilocalsym;//c
   	uint32_t nrefsym;//c
   	uint32_t irefsym;//c
  	uint32_t nextrel;//c
	uint32_t iextrel;//c
    	uint32_t ninit_nterm;//c
    	uint32_t iinit_iterm;	//c
    	uint32_t  objc_module_info_addr;//c
    	uint32_t	 objc_module_info_size;//c
};

struct dylib_module_64 {
 	uint32_t module_name;	//c
   	uint32_t nextdefsym;//c
  	uint32_t iextdefsym;//c
    	uint32_t nlocalsym;//c
   	uint32_t ilocalsym;//c
    	uint32_t nrefsym;//c
 	uint32_t irefsym;//c
    	uint32_t nextrel;//c
    	uint32_t iextrel;//c
    	uint32_t objc_module_info_size;//c
    	uint64_t objc_module_info_addr;//c
   	uint32_t iinit_iterm;//c
 	uint32_t ninit_nterm;//c
};

struct dylib_table_of_contents {
    	uint32_t symbol_index;//c
    	uint32_t module_index;	//c
};

struct dylib_reference {
    uint32_t isym:24,	//c
    		  flags:8;//c
};

struct routines_command {
	uint32_t	cmdsize;//c
	uint32_t	init_module;//c
	uint32_t	cmd;	//c
	uint32_t	init_address;//c
	uint32_t	reserved1;//c
	uint32_t	reserved2;//c
	uint32_t	reserved3;//c
	uint32_t	reserved4;//c
	uint32_t	reserved5;//c
	uint32_t	reserved6;//c
};

struct routines_command_64 {
	uint32_t	cmdsize;	//c
	uint64_t	init_module;//c
	uint32_t	cmd;//c
	uint64_t	init_address;//c
	uint64_t	reserved1;//c
	uint64_t	reserved2;//c
	uint64_t	reserved3;//c
	uint64_t	reserved4;//c
	uint64_t	reserved5;//c
	uint64_t	reserved6;//c
};

struct twolevel_hints_command {
  	uint32_t cmdsize;//c
 	uint32_t offset;//c
    	uint32_t nhints;//c
   	uint32_t cmd;//c
};

struct twolevel_hint {
    	uint32_t isub_image:8,
	itoc:24;	
};//c

struct linkedit_data_command {
	uint32_t	cmdsize;	//c
 	uint32_t	dataoff;//c
    	uint32_t	datasize;//c
    	uint32_t	cmd;	//c
};

struct prebind_cksum_command {
   	uint32_t cmdsize;//c
    	uint32_t cmd;//c
    	uint32_t cksum;//c
};

struct symseg_command {
	uint32_t	cmdsize;//c
	uint32_t	offset;//c
	uint32_t	size;	//c
	uint32_t	cmd;	//c
};

struct ident_command {
	uint32_t cmdsize;//c
	uint32_t cmd;	//c
};

#endif//HYS_MACH_O_LOADER_H
///////////////////////////////
#ifdef HYS_MACH_O_LOADER_H_END
#undef HYS_MACH_O_LOADER_H_END

struct fvmlib {
	union lc_str	name;//c
	uint32_t	minor_version;//c
	uint32_t	header_addr;//c
};

struct fvmlib_command {
	uint32_t	cmd;	//c
	uint32_t	cmdsize;	//c
	struct fvmlib	fvmlib;//c
};

struct sub_framework_command {
	uint32_t	cmdsize;//c
	union lc_str 	umbrella;//c
	uint32_t	cmd;	//c
};

struct sub_umbrella_command {
	uint32_t	cmdsize;//c
	union lc_str 	sub_umbrella;	//c
	uint32_t	cmd;	//c
};

struct sub_library_command {
	uint32_t	cmdsize;//c
	union lc_str 	sub_library;	//c
	uint32_t	cmd;	//c
};

struct sub_client_command {
	uint32_t	cmdsize;//c
	union lc_str 	client;//c
	uint32_t	cmd;	//c
};

struct prebound_dylib_command {
	uint32_t	cmdsize;//c
	union lc_str	name;//c
	union lc_str	linked_modules;//c
	uint32_t	nmodules;//c
	uint32_t	cmd;	//c
};

struct dylinker_command {
	uint32_t	cmdsize;//c
	uint32_t	cmd;	//c
	union lc_str    name;//c
};

struct rpath_command {
  	uint32_t	 cmdsize;	//c
    	union lc_str path;//c
    	uint32_t	 cmd;//c
};


struct fvmfile_command {
	uint32_t cmd;//c
	uint32_t cmdsize;//c
	union lc_str	name;//c
	uint32_t	header_addr;//c
};

#endif//HYS_MACH_O_LOADER_H_END
