#ifndef HYS_MACH_O_NLIST_H
#define HYS_MACH_O_NLIST_H

#define	N_SECT	0xe//c
#define GET_LIBRARY_ORDINAL(n_desc) (((n_desc) >> 8) & 0xff)//c
#define GET_COMM_ALIGN(n_desc) (((n_desc) >> 8) & 0x0f)//c

#define SET_COMM_ALIGN(n_desc,align) \
    (n_desc) = (((n_desc) & 0xf0ff) | (((align) & 0x0f) << 8))//c

#define SET_LIBRARY_ORDINAL(n_desc,ordinal) \
	(n_desc) = (((n_desc) & 0x00ff) | (((ordinal) & 0xff) << 8))//c

/////////////////////////
#define N_TYPE 1//?
#define N_STAB 3//?
#define N_UNDF 4//?
#define N_ABS 5//?
#define N_EXT 6//?
#define N_INDR 7//?
#define NO_SECT 8//?
#define N_PEXT 9//?
#define N_PBUD 10//?
#define N_WEAK_DEF 11//?
#define REFERENCE_FLAG_UNDEFINED_LAZY 12//?
#define REFERENCE_FLAG_UNDEFINED_NON_LAZY 13//?
#define MAX_SECT 14//?
#define REFERENCE_FLAG_PRIVATE_UNDEFINED_NON_LAZY 15//?
#define REFERENCE_FLAG_PRIVATE_UNDEFINED_LAZY 16//?
#define REFERENCE_TYPE 17//?
#define REFERENCED_DYNAMICALLY 18//?
#define MAX_LIBRARY_ORDINAL 19//?
#define EXECUTABLE_ORDINAL 20//?
#define SELF_LIBRARY_ORDINAL 21//?
#define DYNAMIC_LOOKUP_ORDINAL 22//?
#define REFERENCE_FLAG_DEFINED 23//?
#define N_WEAK_REF 24//?
#define REFERENCE_FLAG_PRIVATE_DEFINED 25//?
#define N_NO_DEAD_STRIP 26//?
#define N_REF_TO_WEAK 27//?
#define N_DESC_DISCARDED 28//?

////////////////////////////t

struct nlist {
	union {
#ifndef __LP64__
		char *n_name;//c
#endif
	int32_t n_strx;//c
	} n_un;
	uint8_t n_type;//c
	uint8_t n_sect;	//c
	int16_t n_desc;	//c
	uint32_t n_value;//c
};
struct nlist_64 {
   	union {
     		uint32_t  n_strx;//c
    	} n_un;
	uint8_t n_type;  //c
    	uint8_t n_sect; //c
    	uint64_t n_value;//c
    	uint16_t n_desc;//c
};

#endif//HYS_MACH_O_NLIST_H
