#ifndef HYS_MACH_I386__STRUCTS_H
#define HYS_MACH_I386__STRUCTS_H

#define FP_PREC_24B 1//?
#define FP_PREC_53B 2//?
#define FP_PREC_64B 3//?
#define FP_RND_NEAR 4//?
#define FP_RND_DOWN 5//?
#define FP_RND_UP 6//?
#define FP_CHOP 7//?

//////////////

#if __DARWIN_UNIX03
#define	_STRUCT_X86_THREAD_STATE32	struct __darwin_i386_thread_state
_STRUCT_X86_THREAD_STATE32{
};
#else /* !__DARWIN_UNIX03 */
#define	_STRUCT_X86_THREAD_STATE32	struct i386_thread_state
_STRUCT_X86_THREAD_STATE32 {
    unsigned int	eax;
    unsigned int	ebx;
    unsigned int	ecx;
    unsigned int	edx;
    unsigned int	edi;
    unsigned int	esi;
    unsigned int	ebp;
    unsigned int	esp;
    unsigned int	ss;
    unsigned int	eflags;
    unsigned int	eip;
    unsigned int	cs;
    unsigned int	ds;
    unsigned int	es;
    unsigned int	fs;
    unsigned int	gs;
};//c
#endif /* !__DARWIN_UNIX03 */

#if __DARWIN_UNIX03
#define _STRUCT_X86_EXCEPTION_STATE32	struct __darwin_i386_exception_state
_STRUCT_X86_EXCEPTION_STATE32
{

};
#else /* !__DARWIN_UNIX03 */
#define _STRUCT_X86_EXCEPTION_STATE32	struct i386_exception_state
_STRUCT_X86_EXCEPTION_STATE32{
    unsigned int	trapno;
    unsigned int	err;
    unsigned int	faultvaddr;
};//c
#endif /* !__DARWIN_UNIX03 */

#if __DARWIN_UNIX03
#define _STRUCT_FP_CONTROL	struct __darwin_fp_control
_STRUCT_FP_CONTROL
{

};
typedef _STRUCT_FP_CONTROL	__darwin_fp_control_t;
#else /* !__DARWIN_UNIX03 */
#define _STRUCT_FP_CONTROL	struct fp_control
_STRUCT_FP_CONTROL {
    unsigned short		invalid	:1,
    				denorm	:1,
				zdiv	:1,
				ovrfl	:1,
				undfl	:1,
				precis	:1,
					:2,
				pc	:2,
				rc	:2,
				/*inf*/	:1,
					:3;
};//c
typedef _STRUCT_FP_CONTROL	fp_control_t;
#endif /* !__DARWIN_UNIX03 */

#if __DARWIN_UNIX03
#define _STRUCT_FP_STATUS	struct __darwin_fp_status
_STRUCT_FP_STATUS
{

};
typedef _STRUCT_FP_STATUS	__darwin_fp_status_t;
#else /* !__DARWIN_UNIX03 */
#define _STRUCT_FP_STATUS	struct fp_status
_STRUCT_FP_STATUS {
    unsigned short		invalid	:1,
    				denorm	:1,
				zdiv	:1,
				ovrfl	:1,
				undfl	:1,
				precis	:1,
				stkflt	:1,
				errsumm	:1,
				c0	:1,
				c1	:1,
				c2	:1,
				tos	:3,
				c3	:1,
				busy	:1;
};//c
typedef _STRUCT_FP_STATUS	fp_status_t;
#endif /* !__DARWIN_UNIX03 */
	
#if __DARWIN_UNIX03
#define _STRUCT_MMST_REG	struct __darwin_mmst_reg
_STRUCT_MMST_REG
{

};
#else /* !__DARWIN_UNIX03 */
#define _STRUCT_MMST_REG	struct mmst_reg
_STRUCT_MMST_REG {
	char	mmst_reg[10];
	char	mmst_rsrv[6];
};//c
#endif /* !__DARWIN_UNIX03 */

#if __DARWIN_UNIX03
#define _STRUCT_XMM_REG		struct __darwin_xmm_reg
_STRUCT_XMM_REG {

};
#else /* !__DARWIN_UNIX03 */
#define _STRUCT_XMM_REG		struct xmm_reg
_STRUCT_XMM_REG {
	char		xmm_reg[16];
};//c
#endif /* !__DARWIN_UNIX03 */

#if __DARWIN_UNIX03
#define	_STRUCT_X86_FLOAT_STATE32	struct __darwin_i386_float_state
_STRUCT_X86_FLOAT_STATE32
{

};
#else /* !__DARWIN_UNIX03 */
#define	_STRUCT_X86_FLOAT_STATE32	struct i386_float_state

_STRUCT_X86_FLOAT_STATE32 {
	int 			fpu_reserved[2];
	_STRUCT_FP_CONTROL	fpu_fcw;		
	_STRUCT_FP_STATUS	fpu_fsw;		
	__uint8_t		fpu_ftw;		
	__uint8_t		fpu_rsrv1;		
	__uint16_t		fpu_fop;		
	__uint32_t		fpu_ip;		
	__uint16_t		fpu_cs;		
	__uint16_t		fpu_rsrv2;		
	__uint32_t		fpu_dp;		
	__uint16_t		fpu_ds;		
	__uint16_t		fpu_rsrv3;		
	__uint32_t		fpu_mxcsr;	
	__uint32_t		fpu_mxcsrmask;
	_STRUCT_MMST_REG	fpu_stmm0;		
	_STRUCT_MMST_REG	fpu_stmm1;	
	_STRUCT_MMST_REG	fpu_stmm2;		
	_STRUCT_MMST_REG	fpu_stmm3;	
	_STRUCT_MMST_REG	fpu_stmm4;		
	_STRUCT_MMST_REG	fpu_stmm5;	
	_STRUCT_MMST_REG	fpu_stmm6;	
	_STRUCT_MMST_REG	fpu_stmm7;		
	_STRUCT_XMM_REG		fpu_xmm0;	
	_STRUCT_XMM_REG		fpu_xmm1;		
	_STRUCT_XMM_REG		fpu_xmm2;		
	_STRUCT_XMM_REG		fpu_xmm3;	
	_STRUCT_XMM_REG		fpu_xmm4;		
	_STRUCT_XMM_REG		fpu_xmm5;		
	_STRUCT_XMM_REG		fpu_xmm6;	
	_STRUCT_XMM_REG		fpu_xmm7;		
	char			fpu_rsrv4[14*16];	
	int 			fpu_reserved1;
};//c
#endif /* !__DARWIN_UNIX03 */

#if __DARWIN_UNIX03
#define	_STRUCT_X86_THREAD_STATE64	struct __darwin_x86_thread_state64
_STRUCT_X86_THREAD_STATE64 {

};
#else /* !__DARWIN_UNIX03 */
#define	_STRUCT_X86_THREAD_STATE64	struct x86_thread_state64
_STRUCT_X86_THREAD_STATE64 {
};
#endif /* !__DARWIN_UNIX03 */

#endif//HYS_MACH_I386__STRUCTS_H
