#ifndef HYS_MACH_KMOD_H
#define HYS_MACH_KMOD_H
////////////

#define KMOD_INFO_VERSION 1//?
#define KMOD_MAX_NAME 2//?
#define KMOD_CNTL_GET_UUID 3//?
#define KMOD_CNTL_GET_KERNEL_SYMBOLS 4//?
#define KMOD_CNTL_RETAIN 5//?
#define KMOD_CNTL_START 6//?
#define KMOD_CNTL_FREE_LINKEDIT_DATA 7//?
#define KMOD_CNTL_GET_CMD 8//?
#define KMOD_IOKIT_END_RANGE_PACKET 9//?
#define KMOD_LOAD_EXTENSION_PACKET 10//?

//////////////////

typedef int kmod_t;//c
typedef void* kmod_args_t;//c

typedef struct kmod_reference {
	struct kmod_reference	*next;
	struct kmod_info	*info;
} kmod_reference_t;//c

typedef kern_return_t kmod_start_func_t(struct kmod_info *ki, void *data);//c
typedef kern_return_t kmod_stop_func_t(struct kmod_info *ki, void *data);//c

typedef struct kmod_info {
	struct kmod_info 	*next;
	int			info_version;		
	int			id;
	char			name[KMOD_MAX_NAME];
	char			version[KMOD_MAX_NAME];
	int			reference_count;	
	kmod_reference_t	*reference_list;	
	vm_address_t		address;		
	vm_size_t		size;			
	vm_size_t		hdr_size;		
        kmod_start_func_t	*start;
        kmod_stop_func_t	*stop;
} kmod_info_t;//c

typedef struct kmod_load_extension_cmd {
	int	type;//c
	char	name[KMOD_MAX_NAME];//c
} kmod_load_extension_cmd_t;

#endif //HYS_MACH_KMOD_H
