#ifndef HYS_MACH_MACHINE_H
#define HYS_MACH_MACHINE_H

#define CPU_SUBTYPE_INTEL(f, m)	((cpu_subtype_t) (f) + ((m) << 4))//c
#define CPU_SUBTYPE_VEO_ALL	CPU_SUBTYPE_VEO_2//c
#define CPU_TYPE_I386		CPU_TYPE_X86//c
#define	CPU_TYPE_X86_64		(CPU_TYPE_X86 | CPU_ARCH_ABI64)//c
#define CPU_TYPE_POWERPC64		(CPU_TYPE_POWERPC | CPU_ARCH_ABI64)//c
#define CPU_TYPE_MC680x0	((cpu_type_t) 6)//c
#define CPU_SUBTYPE_MC680x0_ALL		((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_MC68030_ONLY	((cpu_subtype_t) 3)//c
#define CPU_SUBTYPE_MC68040		((cpu_subtype_t) 2) //c
#define CPU_TYPE_POWERPC		((cpu_type_t) 18)//c
#define CPU_SUBTYPE_POWERPC_ALL		((cpu_subtype_t) 0)//c
#define CPU_SUBTYPE_POWERPC_601		((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_POWERPC_603		((cpu_subtype_t) 3)//c
#define CPU_SUBTYPE_POWERPC_603e	((cpu_subtype_t) 4)//c
#define CPU_SUBTYPE_POWERPC_603ev	((cpu_subtype_t) 5)//c
#define CPU_SUBTYPE_POWERPC_604		((cpu_subtype_t) 6)//c
#define CPU_SUBTYPE_POWERPC_604e	((cpu_subtype_t) 7)//c
#define CPU_SUBTYPE_POWERPC_750		((cpu_subtype_t) 9)//c
#define CPU_SUBTYPE_POWERPC_7400	((cpu_subtype_t) 10)//c
#define CPU_SUBTYPE_POWERPC_7450	((cpu_subtype_t) 11)//c
#define	CPU_SUBTYPE_SPARC_ALL		((cpu_subtype_t) 0)//c
#define CPU_SUBTYPE_POWERPC_970		((cpu_subtype_t) 100)//c
#define CPU_TYPE_SPARC		((cpu_type_t) 14)//c
#define CPU_SUBTYPE_HPPA_7100LC		((cpu_subtype_t) 1)//c
#define	CPU_SUBTYPE_HPPA_ALL		((cpu_subtype_t) 0)//c
#define CPU_TYPE_HPPA           ((cpu_type_t) 11)//c
#define CPU_SUBTYPE_I860_860	((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_I860_ALL	((cpu_subtype_t) 0)//c
#define CPU_TYPE_I860		((cpu_type_t) 15)//c
#define CPU_SUBTYPE_PENTIUM_4			CPU_SUBTYPE_INTEL(10, 0)//c
#define CPU_TYPE_VEO		((cpu_type_t) 255)//c
#define CPU_SUBTYPE_VEO_1	((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_VEO_2	((cpu_subtype_t) 2)//c
#define CPU_SUBTYPE_PENTII_M3	CPU_SUBTYPE_INTEL(6, 3)//c
#define CPU_SUBTYPE_PENTII_M5	CPU_SUBTYPE_INTEL(6, 5)//c
#define CPU_SUBTYPE_VEO_3	((cpu_subtype_t) 3)//c
#define CPU_SUBTYPE_PENTPRO	CPU_SUBTYPE_INTEL(6, 1)//c
#define CPU_SUBTYPE_VEO_4	((cpu_subtype_t) 4)//c
#define CPU_SUBTYPE_PENT	CPU_SUBTYPE_INTEL(5, 0)//c
#define CPU_TYPE_MC88000	((cpu_type_t) 13)//c
#define CPU_SUBTYPE_486SX				CPU_SUBTYPE_INTEL(4, 8)//c
#define	CPU_SUBTYPE_MC88000_ALL	((cpu_subtype_t) 0)//c
#define CPU_SUBTYPE_486					CPU_SUBTYPE_INTEL(4, 0)//c
#define CPU_SUBTYPE_MC88110	((cpu_subtype_t) 2)//c
#define	CPU_SUBTYPE_I386_ALL			CPU_SUBTYPE_INTEL(3, 0)//c
#define CPU_TYPE_X86		((cpu_type_t) 7)//c
#define CPU_ARCH_ABI64	0x01000000//c
#define CPU_SUBTYPE_X86_64_ALL		((cpu_subtype_t)3)//c
#define CPU_TYPE_ANY		((cpu_type_t) -1)//c
#define	CPU_SUBTYPE_MULTIPLE		((cpu_subtype_t) -1)//c
#define CPU_SUBTYPE_LITTLE_ENDIAN	((cpu_subtype_t) 0)//c
#define CPU_SUBTYPE_BIG_ENDIAN		((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_586					CPU_SUBTYPE_INTEL(5, 0)//c
#define CPU_SUBTYPE_POWERPC_602		((cpu_subtype_t) 2)//c
#define CPU_SUBTYPE_POWERPC_620		((cpu_subtype_t) 8)//c
#define CPU_TYPE_VAX		((cpu_type_t) 1)//c
#define CPU_SUBTYPE_VAX780	((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_VAX785	((cpu_subtype_t) 2)//c
#define CPU_SUBTYPE_VAX750	((cpu_subtype_t) 3)//c
#define CPU_SUBTYPE_VAX730	((cpu_subtype_t) 4)//c
#define CPU_SUBTYPE_UVAXI	((cpu_subtype_t) 5)//c
#define CPU_SUBTYPE_UVAXII	((cpu_subtype_t) 6)//c
#define CPU_SUBTYPE_VAX8200	((cpu_subtype_t) 7)//c
#define CPU_SUBTYPE_VAX8500	((cpu_subtype_t) 8)//c
#define CPU_SUBTYPE_VAX8600	((cpu_subtype_t) 9)//c
#define CPU_SUBTYPE_VAX8650	((cpu_subtype_t) 10)//c
#define CPU_SUBTYPE_VAX8800	((cpu_subtype_t) 11)//c
#define CPU_SUBTYPE_UVAXIII	((cpu_subtype_t) 12)//c
#define CPU_TYPE_ROMP		((cpu_type_t) 2)//c
#define CPU_SUBTYPE_RT_PC	((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_RT_APC	((cpu_subtype_t) 2)//c
#define CPU_SUBTYPE_RT_135	((cpu_subtype_t) 3)//c
#define CPU_TYPE_NS32032	((cpu_type_t) 4)//c
#define CPU_TYPE_NS32332        ((cpu_type_t) 5)//c
#define CPU_SUBTYPE_MMAX_DPC	    ((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_SQT		    ((cpu_subtype_t) 2)//c
#define CPU_SUBTYPE_MMAX_APC_FPU    ((cpu_subtype_t) 3)//c
#define CPU_SUBTYPE_MMAX_APC_FPA    ((cpu_subtype_t) 4)//c
#define CPU_SUBTYPE_MMAX_XPC	    ((cpu_subtype_t) 5)//c
#define CPU_SUBTYPE_MC88100	((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_MC68030		((cpu_subtype_t) 1)//c
#define CPU_SUBTYPE_HPPA_7100		((cpu_subtype_t) 0) //c

/////////////
#define CPU_STATE_NICE 6//?
#define CPU_STATE_MAX 7//?
#define CPU_SUBTYPE_MASK 9//?
#define CPU_SUBTYPE_INTEL_FAMILY_MAX 10//?
#define CPU_SUBTYPE_LIB64 11//?

/////////////////////
typedef integer_t	cpu_type_t;//c
typedef integer_t	cpu_subtype_t;//c

#endif//HYS_MACH_MACHINE_H
