#ifndef HYS_MACH_MESSAGE_H
#define HYS_MACH_MESSAGE_H

#define MACH_RCV_TRAILER_ELEMENTS(x) (((x) & 0xf) << 24)  //c
#define MACH_RCV_TRAILER_TYPE(x)     (((x) & 0xf) << 28) //c
#define MACH_MSGH_BITS(remote, local) ((remote) | ((local) << 8))//c
#define round_msg(x)	(((mach_msg_size_t)(x) + sizeof (natural_t) - 1) & ~(sizeof (natural_t) - 1))//c

#define MACH_MSG_TRAILER_FORMAT_0_SIZE sizeof(mach_msg_format_0_trailer_t)//c
#define	MACH_MSGH_BITS_REMOTE(bits) ((bits) & MACH_MSGH_BITS_REMOTE_MASK)//c
#define MACH_MSG_TYPE_POLYMORPHIC	((mach_msg_type_name_t) -1)//c
#define MACH_MSG_TYPE_PORT_SEND		MACH_MSG_TYPE_MOVE_SEND//c
#define MACH_MSG_TYPE_PORT_RECEIVE	MACH_MSG_TYPE_MOVE_RECEIVE//c
#define MAX_TRAILER_SIZE sizeof(mach_msg_max_trailer_t)//c

/////////////////////

#define MACH_MSG_VIRTUAL_COPY 13//?
#define MACH_MSG_OOL_DESCRIPTOR 14//?
#define MACH_RCV_TRAILER_AUDIT 18//?
#define MACH_MSG_TRAILER_FORMAT_0 19//?
#define MACH_MSG_TYPE_COPY_SEND 20//?
#define MACH_SEND_TIMED_OUT 21//?
#define MACH_MSG_SUCCESS 22//?
#define MACH_RCV_MSG 23//?
#define MACH_RCV_TIMEOUT 24//?
#define MACH_SEND_INVALID_DEST 25//?
#define MACH_MSGH_BITS_COMPLEX 26//?
#define MACH_SEND_MSG 27//?
#define MACH_MSG_TIMEOUT_NONE 28//?
#define MACH_SEND_TIMEOUT 29//?
#define MACH_RCV_TIMED_OUT 30//?
#define MACH_MSG_TYPE_MAKE_SEND 31//?
#define MACH_MSG_TYPE_MOVE_SEND_ONCE 32//?
#define MACH_MSG_TYPE_MAKE_SEND_ONCE 33//?
#define MACH_RCV_LARGE 34//?
#define MACH_RCV_TOO_LARGE 35//?
#define MACH_RCV_TRAILER_SENDER 36//?
#define MACH_MSG_PORT_DESCRIPTOR 37//?
#define MACH_MSG_OOL_PORTS_DESCRIPTOR 38//?
#define MACH_MSG_TYPE_MOVE_SEND 39//?
#define MACH_MSG_TYPE_MOVE_RECEIVE 40//?
#define MACH_MSG_OPTION_NONE 41//?
#define RCV_SUCCESS 42//?
#define MSG_TYPE_NORMAL 43//?
#define MSG_TYPE_INTEGER_32 44//?
#define MSG_TYPE_CHAR 45//??
#define MSG_OPTION_NONE 46//?
#define RPC_SUCCESS 47//?
#define SEND_SUCCESS 48//
#define MACH_MSGH_BITS_REMOTE_MASK 49//?
#define MACH_RCV_PORT_CHANGED 50//?

////////////////////

typedef unsigned int mach_msg_type_name_t;//c
typedef natural_t mach_msg_size_t;//c
typedef natural_t mach_msg_type_number_t;//c
typedef natural_t mach_msg_timeout_t;//c
typedef kern_return_t mach_msg_return_t;//c
typedef integer_t mach_msg_options_t;//c
typedef integer_t mach_msg_id_t;//c
typedef unsigned int mach_msg_bits_t;//c
typedef	unsigned int mach_msg_trailer_type_t;//c
typedef	unsigned int mach_msg_trailer_size_t;//c
typedef integer_t mach_msg_option_t;//c
typedef unsigned int mach_msg_descriptor_type_t;//c
typedef unsigned int mach_msg_copy_options_t;//c
typedef int msg_return_t;//c
typedef unsigned int    msg_size_t;//c
typedef natural_t       msg_timeout_t;//c

////////////////////////////////////////////

typedef struct
{
        mach_msg_size_t msgh_descriptor_count;
} mach_msg_body_t;//c

typedef struct{
  void*				address;
#if !defined(__LP64__)
  mach_msg_size_t       	size;
#endif
  boolean_t     		deallocate: 8;
  mach_msg_copy_options_t       copy: 8;
  unsigned int     		pad1: 8;
  mach_msg_descriptor_type_t    type: 8;
#if defined(__LP64__)
  mach_msg_size_t       	size;
#endif
} mach_msg_ool_descriptor_t;//c

typedef union{
	mach_msg_ool_descriptor_t		out_of_line;//c
} mach_msg_descriptor_t;

typedef struct {
  unsigned int			val[2];
} security_token_t;//c

typedef struct {
} mach_msg_audit_trailer_t;

typedef	struct {
  	mach_msg_size_t	msgh_size;//c
  	mach_port_t		msgh_remote_port;//c
  	mach_msg_id_t		msgh_id;//c
  	mach_msg_bits_t	msgh_bits;//c
  	mach_port_t		msgh_local_port;//c
  	mach_msg_size_t 	msgh_reserved;//c
} mach_msg_header_t;

typedef struct {
        mach_msg_header_t       header;
        mach_msg_body_t         body;
} mach_msg_base_t;//c

typedef struct {
  mach_msg_header_t	header;
} mach_msg_empty_send_t;//.c

typedef struct {
} mach_msg_trailer_t;

typedef struct {
  	mach_port_t			name;//c
} mach_msg_port_descriptor_t;

typedef struct {
  	mach_msg_trailer_type_t	msgh_trailer_type;//c
  	mach_msg_trailer_size_t	msgh_trailer_size;//c
	security_token_t msgh_sender;//c
} mach_msg_security_trailer_t;

typedef mach_msg_security_trailer_t mach_msg_format_0_trailer_t;//c

typedef struct {
} audit_token_t;

typedef struct {
	mach_msg_header_t	header;//c
} mach_msg_empty_rcv_t;


typedef struct {
        port_t          msg_local_port;//c
        msg_size_t      msg_size;//c
        unsigned int    msg_unused : 24,
		                  msg_simple : 8;//c
        integer_t       msg_type;//c
 	port_t          msg_remote_port;//c
      	integer_t       msg_id;//c
} msg_header_t;

typedef struct  {
  	unsigned int    msg_type_name : 8,
  	msg_type_size : 8,
  	msg_type_number : 12,
  	msg_type_inline : 1,
        msg_type_longform : 1, 
        msg_type_deallocate : 1,        
        msg_type_unused : 1;
} msg_type_t;//c

typedef struct  {
} mach_msg_type_long_t;

typedef union {
} mach_msg_empty_t;


typedef struct {
 	mach_msg_trailer_size_t       msgh_trailer_size;//c
  	audit_token_t			msgh_audit;//c
} mach_msg_mac_trailer_t;
typedef mach_msg_mac_trailer_t mach_msg_max_trailer_t;

///////////////////////////////////
////func

extern mach_msg_return_t	mach_msg(
					mach_msg_header_t *msg,
					mach_msg_option_t option,
					mach_msg_size_t send_size,
					mach_msg_size_t rcv_size,
					mach_port_name_t rcv_name,
					mach_msg_timeout_t timeout,
					mach_port_name_t notify);//c

#endif//HYS_MACH_MESSAGE_H
