#ifndef HYS_MACH_PORT_H
#define HYS_MACH_PORT_H

/////////////////////////////////
#define MACH_PORT_NULL 0//c
#define PORT_NULL		((port_t) 0)//c

#define MACH_PORT_RECEIVE_STATUS_COUNT	((natural_t) \
	(sizeof(mach_port_status_t)/sizeof(natural_t)))//c

#define MACH_PORT_LIMITS_INFO_COUNT	((natural_t) \
	(sizeof(mach_port_limits_t)/sizeof(natural_t)))//c

#define MACH_PORT_RIGHT_RECEIVE		((mach_port_right_t) 1)//c
#define MACH_PORT_RIGHT_SEND		((mach_port_right_t) 0)//c
#define MACH_PORT_RIGHT_PORT_SET	((mach_port_right_t) 3)//c
#define MACH_PORT_TYPE_SEND	    MACH_PORT_TYPE(MACH_PORT_RIGHT_SEND)//c
#define MACH_PORT_TYPE_RECEIVE	  MACH_PORT_TYPE(MACH_PORT_RIGHT_RECEIVE)//c
#define MACH_PORT_TYPE_DEAD_NAME    MACH_PORT_TYPE(MACH_PORT_RIGHT_DEAD_NAME)//c
#define MACH_PORT_RIGHT_DEAD_NAME	((mach_port_right_t) 4)//c

/////////////////////////////

#define MACH_PORT_RECEIVE_STATUS 5//?
#define MACH_PORT_LIMITS_INFO 6//?
#define PORT_TYPE_RECEIVE_OWN 12//?

///////////////
typedef natural_t mach_port_name_t;//c
typedef mach_port_name_t	port_name_t;//c
typedef integer_t       port_type_t;  //c
typedef port_type_t     *port_type_array_t;//c
typedef port_name_t     port_set_name_t; //c
typedef natural_t mach_port_type_t;//c
typedef port_name_t     port_t;   //c
typedef int	mach_port_flavor_t;//c
typedef natural_t mach_port_mscount_t;	//c
typedef integer_t *mach_port_info_t;//c
typedef natural_t mach_port_right_t;//c
typedef natural_t mach_port_urefs_t;//c
//////////////////////////

#ifdef	KERNEL

	#ifndef	MACH_KERNEL_PRIVATE
	struct ipc_port ;
	#endif	/* MACH_KERNEL_PRIVATE */

	typedef struct ipc_port	        *ipc_port_t;
	typedef ipc_port_t 		mach_port_t;

#else	/* KERNEL */

	#ifndef _MACH_PORT_T
	#define _MACH_PORT_T
	typedef mach_port_name_t 		mach_port_t;
	#endif

#endif	/* KERNEL */
////////////////
struct mach_port_limits {
	int mpl_qlimit;//?
};
typedef struct mach_port_limits mach_port_limits_t;


typedef natural_t mach_port_msgcount_t;//c

struct mach_port_status_t {
	mach_port_msgcount_t mps_msgcount;//c
};
typedef struct mach_port_status_t mach_port_status_t;

typedef mach_port_name_t* mach_port_name_array_t;//c
typedef mach_port_t *mach_port_array_t;//c

/////////////////

#endif//HYS_MACH_PORT_H
