#ifndef HYS_MNTOPTS_H
#define HYS_MNTOPTS_H

#define MOPT_STDOPTS							\
	MOPT_USERQUOTA,							\
	MOPT_GROUPQUOTA,						\
	MOPT_FSTAB_COMPAT,						\
	MOPT_NOCOREDUMP,						\
	MOPT_NODEV,							\
	MOPT_NOEXEC,							\
	MOPT_NOSUID,							\
	MOPT_RDONLY,							\
	MOPT_UNION,							\
	MOPT_IGNORE,							\
	MOPT_SYMPERM//c

#define MOPT_FSTAB_COMPAT						\
	MOPT_RO,							\
	MOPT_RW,							\
	MOPT_AUTO//c

#define MOPT_USERQUOTA		{ "userquota",	0, 0, 0 }//c
#define MOPT_GROUPQUOTA		{ "groupquota",	0, 0, 0 }//c
#define MOPT_RO			{ "ro",		0, MNT_RDONLY, 0 }//c
#define MOPT_RW			{ "rw",		1, MNT_RDONLY, 0 }//c
#define MOPT_AUTO		{ "auto",	0, 0, 0 }//c
#define MOPT_NOCOREDUMP		{ "coredump",	1, MNT_NOCOREDUMP, 0 }//c
#define MOPT_NODEV		{ "dev",	1, MNT_NODEV, 0 }//c
#define MOPT_NOEXEC		{ "exec",	1, MNT_NOEXEC, 0 }//c
#define MOPT_NOSUID		{ "suid",	1, MNT_NOSUID, 0 }//c
#define MOPT_RDONLY		{ "rdonly",	0, MNT_RDONLY, 0 }//c
#define MOPT_UNION		{ "union",	0, MNT_UNION, 0 }//c
#define MOPT_IGNORE		{ "hidden",	0, MNT_IGNORE, 0 }//c
#define MOPT_SYMPERM		{ "symperm",	0, MNT_SYMPERM, 0 }//c

////////////

#ifndef OC_mntopt_struct
#define OC_mntopt_struct

struct mntopt {
	const char *m_option;//c
	int m_inverse;	//c
	int m_flag;	//c
	int m_altloc;//c

};
#endif//OC_mntopt_struct


typedef struct mntoptparse *mntoptparse_t;//c
////////////

extern int getmnt_silent;//c
mntoptparse_t getmntopts(const char *, const struct mntopt *, int *, int *);//c
void freemntopts(mntoptparse_t);//c

#endif//HYS_MNTOPTS_H
