#ifndef HYS_NET_IF_MEDIA_H
#define HYS_NET_IF_MEDIA_H

#define IFM_SUBTYPE_SHARED_DESCRIPTIONS {           \
    { IFM_AUTO,     "autoselect" },                 \
    { IFM_MANUAL,   "manual" },                     \
    { IFM_NONE,     "none" },                       \
    { 0, NULL },                                    \
}//c

#define IFM_SUBTYPE_ETHERNET_DESCRIPTIONS {         \
    { IFM_10_T,     "10baseT/UTP" },                \
    { IFM_10_2,     "10base2/BNC" },                \
    { IFM_10_5,     "10base5/AUI" },                \
    { IFM_100_TX,   "100baseTX"   },                \
    { IFM_100_FX,   "100baseFX"   },                \
    { IFM_100_T4,   "100baseT4"   },                \
    { IFM_100_VG,   "100baseVG"   },                \
    { IFM_100_T2,   "100baseT2"   },                \
    { IFM_1000_SX,  "1000baseSX"  },                \
    { IFM_10_STP,   "10baseSTP"   },                \
    { IFM_10_FL,    "10baseFL"    },                \
    { IFM_1000_LX,  "1000baseLX"  },                \
    { IFM_1000_CX,  "1000baseCX"  },                \
    { IFM_1000_T,   "1000baseT"   },                \
    { IFM_HPNA_1,   "HomePNA1"    },                \
    { IFM_10G_SR,   "10GbaseSR"   },                \
    { IFM_10G_LR,   "10GbaseLR"   },                \
    { 0, NULL },                                    \
}//c

#define IFM_SUBTYPE_IEEE80211_DESCRIPTIONS {        \
    { IFM_IEEE80211_FH1,  "FH1"  },                 \
    { IFM_IEEE80211_FH2,  "FH2"  },                 \
    { IFM_IEEE80211_DS1,  "DS1"  },                 \
    { IFM_IEEE80211_DS2,  "DS2"  },                 \
    { IFM_IEEE80211_DS5,  "DS5"  },                 \
    { IFM_IEEE80211_DS11, "DS11" },                 \
    { IFM_IEEE80211_DS22, "DS22" },                 \
    { 0, NULL },                                    \
}//c

#define IFM_SHARED_OPTION_DESCRIPTIONS {            \
    { IFM_FDX,      "full-duplex" },                \
    { IFM_HDX,      "half-duplex" },                \
    { IFM_FLOW,     "flow-control" },               \
    { IFM_FLAG0,    "flag0" },                      \
    { IFM_FLAG1,    "flag1" },                      \
    { IFM_FLAG2,    "flag2" },                      \
    { IFM_LOOP,     "hw-loopback" },                \
    { 0, NULL },                                    \
}//c

#define IFM_SUBTYPE_ETHERNET_OPTION_DESCRIPTIONS {  \
    { 0, NULL },                                    \
}//c

#define IFM_SUBTYPE_IEEE80211_OPTION_DESCRIPTIONS { \
    { IFM_IEEE80211_ADHOC,  "adhoc" },              \
    { 0, NULL },                                    \
}//c

#define	IFM_10_T	3//c
#define IFM_ETHER	0x00000020//c
#define	IFM_HDX		0x00200000//c
#define	IFM_FLOW	0x00400000//c

//////////////////////////////////
#define IFM_TMASK 1//?
#define IFM_NMASK 2//?
#define IFM_NONE 3//?
#define IFM_FDX 4//?
#define IFM_AVALID 5//?
#define IFM_ACTIVE 6//?
#define IFM_10_5 9//?
#define IFM_100_T4 10//?
#define IFM_1000_SX 11//?
#define IFM_AUTO 12//?
#define IFM_10_2 13//?
#define IFM_1000_T 14//?
#define IFM_100_FX 16//?
#define IFM_LOOP 17//?
#define IFM_100_TX 18//?
#define IFM_MANUAL 20//?
#define IFM_100_VG 21//?
#define IFM_100_T2 22//?
#define IFM_10_STP 23//?
#define IFM_10_FL 24//?
#define IFM_1000_LX 25//?
#define IFM_1000_CX 26//?
#define IFM_HPNA_1 27//?
#define IFM_10G_SR 28//?
#define IFM_10G_LR 29 //?
#define IFM_IEEE80211_FH1 30//?
#define IFM_IEEE80211_FH2 31//?
#define IFM_IEEE80211_DS1 32//?
#define IFM_IEEE80211_DS2 33//?
#define IFM_IEEE80211_DS5 34//?
#define IFM_IEEE80211_DS11 35//?
#define IFM_IEEE80211_DS22 36//?
#define IFM_FLAG0 37//?
#define IFM_FLAG1 38//?
#define IFM_FLAG2 39//?
#define IFM_IEEE80211_ADHOC 40//?
#define IFM_IEEE80211 41//?
#define IFM_OMASK 42//?
#define IFM_GMASK 43//?

////////////

struct ifmedia_description {
	int	ifmt_word;	
	const char *ifmt_string;	
};//c

#endif//HYS_NET_IF_MEDIA_H
