#ifndef HYS_NETAT_AT_VAR_H
#define HYS_NETAT_AT_VAR_H

#define AIOCSTARTROUTER _IOR('a',10, at_kern_err_t)	//c
#define AIOCSETROUTER	_IOW('a', 7, at_router_params_t)//c
#define AIOCSIFADDR	_IOW('a', 9, at_if_cfg_t)//c
#define AIOCSETZNUSAGE  _IOW('a',12, zone_usage_t)//c
#define AIOCREGLOCALZN  _IOW('a',11, at_nvestr_t)//c
#define AIOCSETDEFZONE	_IOW('a', 6, at_def_zone_t)//c
#define AIOCSTOPATALK	_IOWR('a',  1, int)	//c

/////////////////
#define AIOCGETSTATE 1 //?
#define AIOCGETIFCFG 2//?
#define IFNAMESIZ 3//?
#define ELAP_CFG_HOME 4//?
#define IF_TOTAL_MAX 5//?
#define AIOCNBPREG 6//?
#define AIOCNBPREMOVE 7//?
#define AIOCGETZNUSAGE 8//?
#define KE_CONF_RANGE 9//?
#define KE_CONF_SEED_RNG 10//?
#define KE_CONF_SEED1 11//?
#define KE_CONF_SEED_NODE 12//?
#define KE_NO_ZONES_FOUND 13//?
#define KE_NO_SEED 14//?
#define KE_INVAL_RANGE 15//?
#define KE_SEED_STARTUP 16//?
#define KE_BAD_VER 17//?
#define KE_RTMP_OVERFLOW 18//?
#define KE_ZIP_OVERFLOW 19//?
#define AT_IFF_DEFAULT 20//?
#define LAP_STATE_MASK 21//?
#define LAP_OFFLINE 22//?
#define LAP_ONLINE 23//?
#define LAP_ONLINE_FOR_ZIP 24//?
#define LAP_ONLINE_ZONELESS 25//?
#define KEV_ATALK_ZONELISTCHANGED 26//?
#define KEV_ATALK_SUBCLASS 27//?
#define KEV_ATALK_ENABLED 28//?
#define KEV_ATALK_DISABLED 29//?
#define KEV_ATALK_ZONEUPDATED 30//?
#define KEV_ATALK_ROUTERUP 31//?
#define KEV_ATALK_ROUTERUP_INVALID 32//?
#define KEV_ATALK_ROUTERDOWN 33//?

////////////////
typedef char if_name_t[IFNAMESIZ];//c
//////////////////
struct at_if_cfg_t{
#ifdef __linux__
#ifdef ifr_name
	#undef ifr_name//linux/if.h
#endif
#endif//__linux__
	char		ifr_name[IFNAMESIZ];//c
	struct at_addr router;//c
	struct at_addr node;//c
	at_nvestr_t zonename;//c
	u_int		flags;//c
	u_short		netStart;	//c
	u_short		netEnd;	//c
};
typedef struct at_if_cfg_t at_if_cfg_t;

struct at_ifname_list{
	if_name_t at_if[1];//c
};
typedef struct at_ifname_list at_ifnames_t;

struct zone_usage{
	at_nvestr_t zone_name;//c
	at_ifnames_t zone_iflist;//c
	int zone_home;//c
	int zone_index;//c
};
typedef struct zone_usage zone_usage_t;

struct at_nbp_reg_t{
	at_inet_t addr;//c
	u_char		ddptype;//c
	at_entity_t name;//c
};
typedef struct at_nbp_reg_t at_nbp_reg_t;

struct at_router_params_t {
	short multihome;//c
	short router_mix;//c
	short rtmp_table_sz;//c
	short zone_table_sz;//c
};
typedef struct at_router_params_t at_router_params_t;

struct at_kern_err {
	int		error;//c
	int		port1;//c
	int		port2;//c
	char	name1[IFNAMESIZ];//c
	char	name2[IFNAMESIZ];//c
	u_short netr1b, netr1e;//c
	u_short netr2b, netr2e;//c
	u_short net;//c
	u_char	node;//c
	u_char	rtmp_id;//c
};
typedef struct at_kern_err at_kern_err_t;

struct at_def_zone_t {
	char		ifr_name[IFNAMESIZ];//c
	at_nvestr_t	zonename;//c
};
typedef struct at_def_zone_t at_def_zone_t;

struct kev_atalk_data {
	struct	net_event_data	link_data;//c
 	union { 
		struct	at_addr		address;//c
		at_nvestr_t			zone;//c
	} node_data;
};

#endif//HYS_NETAT_AT_VAR_H
