#ifndef HYS_NETINET6_IN6_VAR_H
#define HYS_NETINET6_IN6_VAR_H

///////////////

#define KEV_INET6_DEFROUTER 1//?
#define KEV_INET6_NEW_USER_ADDR 2//?
#define KEV_INET6_CHANGED_ADDR 3//?
#define KEV_INET6_ADDR_DELETED 4//?
#define KEV_INET6_NEW_LL_ADDR 5//?
#define KEV_INET6_NEW_RTADV_ADDR 6//?
#define IN6_IFF_AUTOCONF 7//?
#define IN6_IFF_DUPLICATED 8//?
#define IN6_IFF_TENTATIVE 9//?

////////////////////

#define SIOCGIFAFLAG_IN6	_IOWR('i', 73, struct in6_ifreq)
#define KEV_INET6_SUBCLASS 6//c
#define SIOCDIFADDR_IN6		 _IOW('i', 25, struct in6_ifreq)//c
#define SIOCAIFADDR_IN6		 _IOW('i', 26, struct in6_aliasreq)//c
#define SIOCSPFXFLUSH_IN6	_IOWR('i', 79, struct in6_ifreq)//c
#define SIOCSRTRFLUSH_IN6	_IOWR('i', 80, struct in6_ifreq)//c
#define IN6_IFF_NOTREADY (IN6_IFF_TENTATIVE|IN6_IFF_DUPLICATED)//c
#define SIOCAUTOCONF_START _IOWR('i', 132, struct in6_ifreq)  //c
#define SIOCAUTOCONF_STOP _IOWR('i', 133, struct in6_ifreq) //c
#define SIOCPROTOATTACH_IN6 _IOWR('i', 110, struct in6_aliasreq)  //c
#define SIOCPROTODETACH_IN6 _IOWR('i', 111, struct in6_ifreq)//c
#define SIOCLL_START _IOWR('i', 130, struct in6_aliasreq) //c
#define SIOCLL_STOP _IOWR('i', 131, struct in6_ifreq) //c

///////////////////////////
struct	in6_ifreq { 
	char	ifr_name[IFNAMSIZ];//c
	union {
		struct	sockaddr_in6 ifru_addr;//c
		int	ifru_flags6;//c
		short	ifru_flags;//c
	} ifr_ifru;
};

struct kev_in6_data {
       struct net_event_data   link_data;//c
};

struct  in6_addrlifetime {
	u_int32_t ia6t_vltime;	//c
	u_int32_t ia6t_pltime;//c
};

struct in6_aliasreq {
	char	ifra_name[IFNAMSIZ];//c
	struct in6_addrlifetime ifra_lifetime;//c
	struct	sockaddr_in6 ifra_addr;//c
	struct	sockaddr_in6 ifra_dstaddr;//c
	struct	sockaddr_in6 ifra_prefixmask;//c
};
#endif//HYS_NETINET6_IN6_VAR_H
