
#ifndef HYS_OBJC_RUNTIME_H
#define HYS_OBJC_RUNTIME_H

#define CLS_META 1//?
#define CLS_CLASS 2//?

///////////////////////////

#ifndef OC_Symtab
#define OC_Symtab
typedef struct objc_symtab *Symtab;//c
#endif

/////////////

#ifndef OC_struct_objc_class
#define OC_struct_objc_class
struct objc_class {
    Class isa;

#if !__OBJC2__
    Class super_class                                        OBJC2_UNAVAILABLE;
    const char *name                                         OBJC2_UNAVAILABLE;
    long version                                             OBJC2_UNAVAILABLE;
    long info                                                OBJC2_UNAVAILABLE;
    long instance_size                                       OBJC2_UNAVAILABLE;
    struct objc_ivar_list *ivars                             OBJC2_UNAVAILABLE;
    struct objc_method_list **methodLists                    OBJC2_UNAVAILABLE;
    struct objc_cache *cache                                 OBJC2_UNAVAILABLE;
    struct objc_protocol_list *protocols                     OBJC2_UNAVAILABLE;
#endif
} OBJC2_UNAVAILABLE;//c
#endif//OC_struct_objc_class

#ifndef OC_objc_module
#define OC_objc_module
struct objc_module {
  	unsigned long version;//c
   	unsigned long size;//c
    	const char *name;//c
   	Symtab symtab;//c
};
#endif

#ifndef OC_objc_symtab
#define OC_objc_symtab
struct objc_symtab {
    	unsigned long sel_ref_cnt;//c
  	SEL *refs;//c
  	unsigned short cls_def_cnt;//c
    	unsigned short cat_def_cnt;//c
};
#endif

#ifndef OC_objc_category
#define OC_objc_category
struct objc_category {
	char *category_name;//c
  	char *class_name;//c
 	struct objc_method_list *instance_methods;//c
    	struct objc_method_list *class_methods;//c
 	struct objc_protocol_list *protocols;//c
};
#endif

#ifndef OC_objc_ivar_list 
#define OC_objc_ivar_list 
struct objc_ivar_list {
    	int ivar_count;//c
};
#endif

#ifndef OC_objc_ivar 
#define OC_objc_ivar
struct objc_ivar {
   	char *ivar_name;//c
    	char *ivar_type;//c
    	int ivar_offset;//c
};
#endif

#ifndef OC_objc_method_list
#define OC_objc_method_list
struct objc_method_list {
    	struct objc_method_list *obsolete;//c
    	int method_count;//c
};
#endif

#ifndef OC_objc_method
#define  OC_objc_method
struct objc_method {
    	SEL method_name;//c
 	char *method_types;//c
    	IMP method_imp;//c
};
#endif

#ifndef OC_objc_protocol_list
#define OC_objc_protocol_list
struct objc_protocol_list {
 	struct objc_protocol_list *next;//c
    	long count;//c
};
#endif

struct objc_method_description_list  {
	int count;//c
};

#ifndef OC_objc_method_description
#define OC_objc_method_description
struct objc_method_description {
	SEL name;
	char *types;
};//c
#endif

typedef struct objc_property *objc_property_t;//c

typedef struct objc_method *Method;//c
typedef struct objc_cache *Cache                             OBJC2_UNAVAILABLE;//c
typedef struct objc_ivar *Ivar;//c
typedef struct objc_category *Category;//c
typedef struct objc_module *Module                           OBJC2_UNAVAILABLE;//c

//////////////////

OBJC_EXPORT Class object_getClass(id obj) 
     AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

OBJC_EXPORT id objc_getClass(const char *name);//c

OBJC_EXPORT const char *class_getName(Class cls) 
     AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

OBJC_EXPORT IMP method_getImplementation(Method m) 
     AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

OBJC_EXPORT IMP method_setImplementation(Method m, IMP imp) 
     AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

OBJC_EXPORT Method class_getInstanceMethod(Class cls, SEL name);//c
OBJC_EXPORT Class class_poseAs(Class imposter, Class original) OBJC2_UNAVAILABLE;//c
OBJC_EXPORT int class_getVersion(Class cls);//c

OBJC_EXPORT Class class_getSuperclass(Class cls)   AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

OBJC_EXPORT BOOL class_isMetaClass(Class cls) 
     AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

OBJC_EXPORT id objc_lookUpClass(const char *name);//c
OBJC_EXPORT void class_setVersion(Class cls, int version);//c
OBJC_EXPORT BOOL class_respondsToMethod(Class, SEL)          OBJC2_UNAVAILABLE;//c
OBJC_EXPORT IMP class_lookupMethod(Class, SEL)               OBJC2_UNAVAILABLE;//c
OBJC_EXPORT const char *sel_getName(SEL sel);//c
OBJC_EXPORT unsigned int method_getSizeOfArguments(Method m) OBJC2_UNAVAILABLE;//c

OBJC_EXPORT BOOL class_conformsToProtocol(Class cls, Protocol *protocol)
     AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

OBJC_EXPORT struct objc_method_list *class_nextMethodList(Class, void **) OBJC2_UNAVAILABLE;//c

#endif//HYS_OBJC_RUNTIME_H
//////////////////////////////////////////////


#ifdef OC_objc_method_need
#undef OC_objc_method_need

#ifndef OC_objc_method
#define  OC_objc_method
struct objc_method {
    	SEL method_name;//c
 	char *method_types;//c
    	IMP method_imp;//c
};
#endif

#endif//OC_objc_method_need

#ifdef OC_struct_objc_class_need
#undef OC_struct_objc_class_need

#ifndef OC_struct_objc_class
#define OC_struct_objc_class
struct objc_class {
    Class isa;

#if !__OBJC2__
    Class super_class                                        ;
    const char *name                                         ;
    long version                                             ;
    long info                                                ;
    long instance_size                                ;
    struct objc_ivar_list *ivars                             ;
    struct objc_method_list **methodLists          ;
    struct objc_cache *cache                            ;
    struct objc_protocol_list *protocols               ;
#endif
} ;//c
#endif//OC_struct_objc_class

#endif //OC_struct_objc_class_need

///////////////////////////
