#ifndef HYS_SECURITY_CDSA_CLIENT_ACLCLIENT_H
#define HYS_SECURITY_CDSA_CLIENT_ACLCLIENT_H

namespace Security {
namespace CssmClient {

class AclFactory_HYS{
public:

	class NobodySubject_HYS {
	public:
	#define Security_CssmClient_AclFactory_NobodySubject_NobodySubject \
	NobodySubject(Allocator &alloc) : Subject(alloc, CSSM_ACL_SUBJECT_TYPE_COMMENT) { };//c
	};

	class Subject_HYS {
	public:
	#define Security_CssmClient_AclFactory_Subject_Subject \
	Subject(Allocator &alloc, CSSM_ACL_SUBJECT_TYPE type);

	#define Security_CssmClient_AclFactory_Subject \
	Subject(){};//add
	};

	class AnySubject_HYS {
	public:
		#define Security_CssmClient_AclFactory_AnySubject_AnySubject \
		AnySubject(Allocator &alloc) : Subject(alloc, CSSM_ACL_SUBJECT_TYPE_ANY) { };//c
	};

	class PinSubject_HYS {
	public:
		#define Security_CssmClient_AclFactory_PinSubject_PinSubject \
		PinSubject(Allocator &alloc, uint32 slot);//c
	};
	
	class PWSubject_HYS  {
	public:
		#define Security_CssmClient_AclFactory_PWSubject_PWSubject \
		PWSubject(Allocator &alloc);//c

		#define Security_CssmClient_AclFactory_PWSubject_PWSubject_const_CssmData \
		PWSubject(Allocator &alloc, const CssmData &secret);//c
	};

	class PromptPWSubject_HYS {
	public:
	
		#define Security_CssmClient_AclFactory_PromptPWSubject_PromptPWSubject \
		PromptPWSubject(Allocator &alloc, const CssmData &prompt);//c

		#define Security_CssmClient_AclFactory_PromptPWSubject_PromptPWSubject_const_CssmData  \
		PromptPWSubject(Allocator &alloc, const CssmData &prompt, const CssmData &secret);//c

	};
};

}//CssmClient
}//Security

#endif//HYS_SECURITY_CDSA_CLIENT_ACLCLIENT_H
