#ifndef HYS_SECURITY_CDSA_CLIENT_DLCIIENT_H
#define HYS_SECURITY_CDSA_CLIENT_DLCIIENT_H

namespace Security {
namespace CssmClient {

class  DL_HYS{

public://operator

#define  Security_CssmClient_DL_OPERATOR \
operator DbMaker &() const {  };//c

public://datatype

#define Security_CssmClient_DL_DL_Impl_TYPE \
typedef DLImpl Impl;

public://func

#define Security_CssmClient_DL_DL_Impl \
explicit DL(Impl *impl) : Attachment(impl) {};//c

#define Security_CssmClient_DL_DL \
DL() : Attachment(NULL) {};//c

#define Security_CssmClient_DL_DL_const_Guid \
DL(const Guid &guid) : Attachment(new Impl(guid)) {};//c

#define Security_CssmClient_DL_DL_const_Module \
DL(const Module &module) : Attachment(new Impl(module)) {};//c

};

class  DLImpl_HYS {
public:

#define Security_CssmClient_DLImpl_DLImpl_const_Guid \
DLImpl(const Guid &guid);//c

#define Security_CssmClient_DLImpl_DLImpl_const_Module \
DLImpl(const Module &module);//c

#define Security_CssmClient_DLImpl_newDb \
virtual DbImpl *newDb(const char *inDbName, const CSSM_NET_ADDRESS *inDbLocation);//c


};

class  Db_HYS {

public://operator

#define Securit_CssmClient_Db_OPERATOR \
Impl *operator ->() const { };//c

public:	//datatype

#define Securit_CssmClient_Db_Db_Impl_DATATYPE \
typedef DbImpl Impl;

public://func
#define Securit_CssmClient_Db_Db_Impl \
explicit Db(Impl *impl) : Object(impl) {};//c

#define Securit_CssmClient_Db_Db \
Db() : Object(NULL) {};

#define Securit_CssmClient_Db_DbMaker \
Db(DbMaker &maker, const char *inDbName, const CSSM_NET_ADDRESS *inDbLocation = NULL): Object(maker.newDb(inDbName, inDbLocation)) {};//c

};

class  DbMaker_HYS {
public:

#define Security_CssmClient_DbMaker_newDb \
virtual DbImpl *newDb(const char *inDbName, const CSSM_NET_ADDRESS *inDbLocation) = 0;//c

};

class  DbImpl_HYS {
public:

#define Security_CssmClient_DbImpl_create \
virtual void create();//c

#define Security_CssmClient_DbImpl_openParameters \
const void *openParameters() const {  };//c

#define Security_CssmClient_DbImpl_openParameters_const_void \
void openParameters(const void *inOpenParameters){  };//c

};

class DbCursorMaker_HYS{
public:

#define Security_CssmClient_DbCursorMaker_newDbCursor_const_CSSM_QUERY \
virtual DbCursorImpl *newDbCursor(const CSSM_QUERY &query, Allocator &allocator) = 0;

#define Security_CssmClient_DbCursorMaker_newDbCursor_uint32 \
virtual DbCursorImpl *newDbCursor(uint32 capacity, Allocator &allocator) = 0;
   
};

class  DbUniqueRecordMaker_HYS {
public:

#define Security_CssmClient_DbUniqueRecordMaker_newDbUniqueRecord \
virtual DbUniqueRecordImpl *newDbUniqueRecord() = 0;
   
};


class  DbCursor_HYS{
public://datatype

#define  Security_CssmClient_DbCursor_DbCursor_Impl_DATATYPE \
typedef DbCursorImpl Impl;

public://func

#define Security_CssmClient_DbCursor_DbCursor_Impl \
explicit DbCursor(Impl *impl) : Object(impl) {};//c

#define Security_CssmClient_DbCursor_DbCursor \
DbCursor() : Object(NULL) {};//c

#define Security_CssmClient_DbCursor_DbCursor_DbCursorMaker \
DbCursor(DbCursorMaker &maker, const CSSM_QUERY &query,Allocator &allocator = Allocator::standard()): Object(maker.newDbCursor(query, allocator)) {};//c

#define Security_CssmClient_DbCursor_DbCursor_DbCursorMaker_uint32 \
 DbCursor(DbCursorMaker &maker, uint32 capacity = 0,Allocator &allocator = Allocator::standard()): Object(maker.newDbCursor(capacity, allocator)) {};//c
  
};


class  DbUniqueRecord_HYS {
public:

#define Security_CssmClient_DbUniqueRecord_DbUniqueRecord_Impl_DATATYPE \
typedef DbUniqueRecordImpl Impl;

#define Security_CssmClient_DbUniqueRecord_DbUniqueRecord_Impl  \
explicit DbUniqueRecord(Impl *impl) : Object(impl) {};//c

#define Security_CssmClient_DbUniqueRecord_DbUniqueRecord \
DbUniqueRecord() : Object(NULL) {};//c

#define Security_CssmClient_DbUniqueRecord_DbUniqueRecord_DbUniqueRecordMaker \
DbUniqueRecord(DbUniqueRecordMaker &maker) : Object(maker.newDbUniqueRecord()) {};//c

};

}//CssmClient
}//Security

#endif//HYS_SECURITY_CDSA_CLIENT_DLCIIENT_H
