#ifndef HYS_SECURITY_CDSA_UTILITES_CSSMDATA_H
#define HYS_SECURITY_CDSA_UTILITES_CSSMDATA_H

namespace Security {


class CssmData_HYS {

public://operator

#define Security_CssmData_operator  \
bool operator < (const CssmData &other) const;//c

#define Security_CssmData_operator1 \
bool operator == (const CssmData &other) const{};//.c

#define Security_CssmData_operator2 \
bool operator != (const CssmData &other) const {};//c

#define Security_CssmData_operator3 \
operator bool () const { };//c

#define Security_CssmData_operator4 \
operator signed char * () const {};//c

#define Security_CssmData_operator5 \
operator unsigned char * () const {};//c

#define Security_CssmData_operator6 \
operator char * () const {};//c

#define Security_CssmData_operator7 \
operator void * () const {};//c

#define Security_CssmData_operator8 \
bool operator ! () const {};//c

public://func

#define Security_CssmData_toHex \
string toHex() const;	//c

#define Security_CssmData_data \
void *data() const {  };//c

#define Security_CssmData_CssmData_void \
CssmData(void *data, size_t length){ };//c

#define Security_CssmData_CssmData_char \
CssmData(char *data, size_t length){};//c

#define Security_CssmData_CssmData_unsigned_char \
CssmData(unsigned char *data, size_t length) {};//c
	
#define Security_CssmData_CssmData_signed_char \
CssmData(signed char *data, size_t length){ };//c
		
#define Security_CssmData_length_size_t \
void length(size_t newLength) {};//c

#define Security_CssmData_length \
size_t length() const {};//c

#define Security_CssmData_CssmData \
CssmData() { };//c

#define Security_CssmData_fromHex \
void fromHex(const char *a); //c

#define Security_CssmData_wrap \
template <class T> \
static CssmData wrap(const T &a){ };//c
	

};

class  CssmDataContainer_HYS {
public://data

#define Security_CssmDataContainer_mAllocator \
Allocator &mAllocator;//c

public://operator

#define Security_CssmDataContainer_operator \
CssmDataContainer & operator = (const CSSM_DATA &other) {};

#define Security_CssmDataContainer_operator1 \
operator CssmDataContainer * () const;//c

public://func

#define Security_CssmDataContainer_CssmDataContainer_Allocator \
CssmDataContainer(Allocator &inAllocator = Allocator::standard()) :CssmData(), mAllocator(inAllocator) {};//c

#define Security_CssmDataContainer_CssmDataContainer_const_T \
template <class T> \
CssmDataContainer(const T *data, size_t length, Allocator &inAllocator = Allocator::standard()) :CssmData(inAllocator.malloc(length), length), mAllocator(inAllocator) {};//c
	
#define Security_CssmDataContainer_CssmDataContainer_const_CssmDataContainer  \
CssmDataContainer(const CssmDataContainer &other): mAllocator(other.mAllocator) {};//c

};

class CssmBuffer_HYS {

public:

#define Security_CssmBuffer_CssmBuffer \
CssmBuffer() : RefPointer<Container>(new Container()) {};//c

#define Security_CssmBuffer_CssmBuffer_const_T \
template <class T> \
CssmBuffer(const T *data, size_t length, Allocator &inAllocator = Allocator::standard()) :RefPointer<Container>(new Container(data, length, inAllocator)) {};//c

#define Security_CssmBuffer_CssmBuffer_const_CSSM_DATA  \
CssmBuffer(const CSSM_DATA &data, Allocator &inAllocator = Allocator::standard()) :RefPointer<Container>(new Container(data.Data, data.Length, inAllocator)) {};//c

#define Security_CssmBuffer_CssmBuffer_const_CssmBuffer \
CssmBuffer(const CssmBuffer& other) : RefPointer<Container>(other) {};//c

#define Security_CssmBuffer_CssmBuffer_Container \
CssmBuffer(Container *p) : RefPointer<Container>(p) {};//c

};

}//Security

#endif//HYS_SECURITY_CDSA_UTILITES_CSSMDATA_H

#ifdef   HYS_SECURITY_CDSA_UTILITES_CSSMDATA_H_END
#undef HYS_SECURITY_CDSA_UTILITES_CSSMDATA_H_END

namespace Security {

typedef CssmData CssmOid;//c
typedef CssmDataContainer CssmOidContainer;//c

inline bool CssmData::operator < (const CssmData &other) const {};//c

}//Security

#endif//HYS_SECURITY_CDSA_UTILITES_CSSMDATA_H_END
