#ifndef HYS_SECURITY_TOKEND_CLIENT_TDSCLIENT_H
#define HYS_SECURITY_TOKEND_CLIENT_TDSCLIENT_H

namespace Security {
namespace Tokend {


class  ClientSession_HYS {

public://data

typedef uint32 Score;//c

#define Security_Tokend_ClientSession_mReplyPort \
ReceivePort mReplyPort;//c

#define Security_Tokend_ClientSession_mServicePort \
Port mServicePort;//c

public://func

#define Security_Tokend_ClientSession_isLocked \
bool isLocked();//c

#define Security_Tokend_ClientSession_changeOwner \
void changeOwner(AclKind kind, GenericHandle key, const AccessCredentials &cred, const AclOwnerPrototype &edit);//c

#define Security_Tokend_ClientSession_getOwner \
void getOwner(AclKind kind, GenericHandle key, AclOwnerPrototype *&owner);//c

#define Security_Tokend_ClientSession_changeAcl \
void changeAcl(AclKind kind, GenericHandle key, const AccessCredentials &cred, const AclEdit &edit);//c

#define Security_Tokend_ClientSession_getAcl \
void getAcl(AclKind kind, GenericHandle key, const char *tag, uint32 &count, AclEntryInfo * &info);//c

#define Security_Tokend_ClientSession_decrypt \
void decrypt(const Security::Context &context, KeyHandle key, const CssmData &in, CssmData &out);//c

#define Security_Tokend_ClientSession_generateMac \
void generateMac(const Security::Context &context, KeyHandle key, const CssmData &data, CssmData &mac);//c

#define Security_Tokend_ClientSession_releaseSearch \
void releaseSearch(SearchHandle hSeearch);//c

#define Security_Tokend_ClientSession_deleteRecord \
void deleteRecord(RecordHandle hRecord);//c

#define Security_Tokend_ClientSession_modifyRecord \
void modifyRecord(CSSM_DB_RECORDTYPE recordType, RecordHandle &hRecord, const CssmDbRecordAttributeData *attributes, size_t attributesLength, const CssmData *data, CSSM_DB_MODIFY_MODE modifyMode);//c

#define Security_Tokend_ClientSession_generateKey \
void generateKey(const Security::Context &context, const AccessCredentials *cred, const AclEntryPrototype *owner, uint32 keyUsage, uint32 keyAttr, KeyHandle &hKey, CssmKey *&key);//c

#define Security_Tokend_ClientSession_generateKey_CSSM_KEYUSE \
void generateKey(const Security::Context &context, const AccessCredentials *cred, const AclEntryPrototype *owner, CSSM_KEYUSE pubKeyUsage, CSSM_KEYATTR_FLAGS pubKeyAttr, CSSM_KEYUSE privKeyUsage, CSSM_KEYATTR_FLAGS privKeyAttr, KeyHandle &hPublic, CssmKey *&publicKey, KeyHandle &hPrivate, CssmKey *&privateKey);//c

#define Security_Tokend_ClientSession_encrypt \
void encrypt(const Security::Context &context, KeyHandle key,const CssmData &in, CssmData &out);//c

#define Security_Tokend_ClientSession_verifyMac \
void verifyMac(const Security::Context &context, KeyHandle key, const CssmData &data, const CssmData &mac);//c

#define Security_Tokend_ClientSession_verifySignature \
void verifySignature(const Security::Context &context, KeyHandle key, const CssmData &data, const CssmData &signature, CSSM_ALGORITHMS verifyOnlyAlgorithm = CSSM_ALGID_NONE);//c

#define Security_Tokend_ClientSession_generateSignature \
void generateSignature(const Security::Context &context, KeyHandle key, const CssmData &data, CssmData &signature, CSSM_ALGORITHMS signOnlyAlgorithm = CSSM_ALGID_NONE);//c

#define Security_Tokend_ClientSession_getOutputSize \
void getOutputSize(const Security::Context &context, KeyHandle key, uint32 inputSize, bool encrypt, uint32 &result);//c

#define Security_Tokend_ClientSession_queryKeySizeInBits \
void queryKeySizeInBits(KeyHandle key, CssmKeySize &result);//c

#define Security_Tokend_ClientSession_releaseKey \
void releaseKey(KeyHandle key);//c

#define Security_Tokend_ClientSession_releaseRecord \
void releaseRecord(RecordHandle hRecord);//c

#define Security_Tokend_ClientSession_findRecordHandle \
void findRecordHandle(RecordHandle record, CssmDbRecordAttributeData *inAttributes, size_t inAttributesLength, CssmData *inOutData, KeyHandle &hKey, CssmDbRecordAttributeData *&outAttributes, mach_msg_type_number_t &outAttributesLength);//c

#define Security_Tokend_ClientSession_deriveKey \
void deriveKey(DbHandle db, const Security::Context &context, KeyHandle hBaseKey, const CssmKey *baseKey, uint32 keyUsage, uint32 keyAttr, CssmData &param, const AccessCredentials *cred, const AclEntryPrototype *owner, KeyHandle &hDerivedKey, CssmKey *&derivedKey);//c

#define Security_Tokend_ClienSession_wrapKey \
void wrapKey(const Security::Context &context, const AccessCredentials *cred, KeyHandle hWrappingKey, const CssmKey *wrappingKey, KeyHandle hSubjectKey, const CssmKey *subjectKey, const CssmData &descriptiveData, CssmWrappedKey *&wrappedKey);//c

#define Security_Tokend_ClientSession_unwrapKey  \
void unwrapKey(const Security::Context &context, const AccessCredentials *cred, const AclEntryPrototype *owner, KeyHandle hSourceKey, const CssmKey *sourceKey, KeyHandle hPublicKey, const CssmKey *publicKey, const CssmWrappedKey &wrappedKey, uint32 keyUsage, uint32 keyAttr, CssmData &data, KeyHandle &hUnwrappedKey, CssmKey *&unwrappedKey);//c

#define Security_Tokend_ClientSession_authenticate \
void authenticate(CSSM_DB_ACCESS_TYPE mode, const AccessCredentials *cred);//c

#define Security_Tokend_ClientSession_insertRecord \
void insertRecord(CSSM_DB_RECORDTYPE recordType, const CssmDbRecordAttributeData *attributes, size_t attributesLength, const CssmData &data, RecordHandle &hRecord);//c

#define Security_Tokend_ClientSession_findNext \
RecordHandle findNext(SearchHandle hSearch, CssmDbRecordAttributeData *inAttributes, size_t inAttributesLength, CssmData *outData, KeyHandle &hKey, CssmDbRecordAttributeData *&outAttributes, mach_msg_type_number_t &outAttributesLength);//c

#define Security_Tokend_ClientSession_findFirst \
RecordHandle findFirst(const CssmQuery &query, CssmDbRecordAttributeData *inAttributes, size_t inAttributesLength, SearchHandle &hSearch, CssmData *outData, KeyHandle &hKey, CssmDbRecordAttributeData *&outAttributes, mach_msg_type_number_t &outAttributesLength);//c


#define Security_Tokend_ClientSession_terminate \
void terminate(uint32 reason, uint32 options);//c

#define Security_Tokend_ClientSession_establish \
void establish(Guid &guid, uint32 subserviceID,uint32 flags, const char *cacheDirectory, const char *workDirectory, char mdsDirectory[PATH_MAX], char printName[PATH_MAX]);//c

#define Security_Tokend_ClientSession_probe \
void probe(Score &score, std::string &tokenUid);//c

#define Security_Tokend_ClientSession_check \
void check(kern_return_t rc);//c

#define Security_Tokend_ClientSession_servicePort_Port \
void servicePort(Port p);//c

#define Security_Tokend_ClientSession_servicePort \
Port servicePort() const {};//c

#define Security_Tokend_ClientSession_fault \
virtual void fault();//c

#define Security_Tokend_ClientSession_ClientSession \
ClientSession(Allocator &a, Allocator &b);//c

#define Security_Tokend_ClientSession__ClientSession \
virtual ~ClientSession();//c


};


} // end namespace Tokend
} // end namespace Security

#endif//HYS_SECURITY_TOKEND_CLIENT_TDSCLIENT_H
