#ifndef HYS_SECURITY_UTILITIES_DEBUGGING_H
#define HYS_SECURITY_UTILITIES_DEBUGGING_H

#include <stddef.h>//size_t

#ifdef __cplusplus
namespace Security {
namespace Debug {

#undef DEBUGGING
#if !defined(NDEBUG)
# define DEBUGGING 1
# define secdebug(scope, format...)	Security::Debug::debug(scope, ## format)//c
# define DEBUGDUMP  1
#else //NDEBUG
# define DEBUGGING 0
# define secdebug(scope, format...)	//c
#endif //NDEBUG

#if defined(DEBUGDUMP)
# define IFDUMP(code)				code
# define IFDUMPING(scope,code)		if (Debug::dumping(scope)) code; else //c
#else//
# define IFDUMP(code)//c
# define IFDUMPING(scope,code)//c
#endif

#undef DEBUGGING
#if !defined(NDEBUG)
# define DEBUGGING 1
# define secdebug(scope, format...)	Security::Debug::debug(scope, ## format)
# define secdelay(file) Security::Debug::delay(file)
// Enable debug dumping
# define DEBUGDUMP  1
#else //NDEBUG
# define DEBUGGING 0
# define secdebug(scope, format...)	/* nothing */
# define secdelay(file) /* nothing */
#endif //NDEBUG
////////

void debug(const char *a, const char *b, ...) __attribute__((format(printf,2,3)));//c
bool dumping(const char *scope);//c
void dump(const char *format, ...) __attribute((format(printf,1,2)));//c
void delay(const char *file);//c
void dumpData(const void *data, size_t length);//c
void dumpData(const char *title, const void *data, size_t length);//c

template <class Data> inline void dumpData(const Data &obj) {};//c

template <class Data> inline void dumpData(const char *title, const Data &obj) {};//c 


};//Debug
};//Security

#endif //__cplusplus

#endif//HYS_SECURITY_UTILITIES_DEBUGGING_H
