#ifndef HYS_SECURITY_UTILITIES_PCSCPP_H
#define HYS_SECURITY_UTILITIES_PCSCPP_H

namespace Security {
namespace PCSC {


class  ReaderState_HYS {
public:

#define Security_PCSC_ReaderState_name \
const char *name() const {};//c

#define Security_PCSC_ReaderState_name_const_char \
void name(const char *a) {  };//c

};

class  Transaction_HYS {

public://data

#define Security_PCSC_Transaction_mDisposition \
unsigned long mDisposition;//c

public://func

#define Security_PCSC_Transaction_Transaction \
Transaction(Card &card, Outcome outcome = conditional):ManagedTransaction<Card>(card, outcome), mDisposition(SCARD_LEAVE_CARD) { };//c

};


class Error_HYS {
public:

#define Security_PCSC_Error_error \
const unsigned long error;//c

#define Security_PCSC_Error_throwMe \
static void throwMe(unsigned long err);//c

};

class  Card_HYS {

public:
static const unsigned long defaultProtocols = SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1;//c

public:

#define Security_PCSC_Card_didDisconnect \
virtual void didDisconnect();

#define Security_PCSC_Card_didEnd \
virtual void didEnd();//c

#define Security_PCSC_Card_end \
void end(unsigned long disposition = SCARD_LEAVE_CARD);//c

#define Security_PCSC_Card_begin \
void begin();//c

#define Security_PCSC_Card_disconnect \
void disconnect(unsigned long disposition = SCARD_LEAVE_CARD);//c

#define Security_PCSC_Card_isInTransaction \
bool isInTransaction() const {};//c

#define Security_PCSC_Card_transmit \
void transmit(const unsigned char *pbSendBuffer, size_t cbSendLength,unsigned char *pbRecvBuffer, size_t &pcbRecvLength);//c

#define Security_PCSC_Card_isConnected \
bool isConnected() const { };//c

#define Security_PCSC_Card_connect \
void connect(Session &session, const char *reader, unsigned long share = SCARD_SHARE_SHARED, unsigned long protocols = defaultProtocols);//c

};

class  Session_HYS{

public:

#define Security_PCSC_Session_open \
void open();//c

};

}//PCSC
}//Security

#endif//HYS_SECURITY_UTILITIES_PCSCPP_H
