#ifndef HYS_STUFF_BREAKOUT_H
#define HYS_STUFF_BREAKOUT_H

struct member {
    	unsigned long member_name_size;//c
  	char         *member_name;//c
    	enum ofile_type type;//c
    	struct object *object;	//c
	struct ar_hdr *ar_hdr;//c
   	enum bool     member_long_name;//c
    	char *unknown_addr;//c
    	unsigned long unknown_size;//c
    	unsigned long offset;//c
    	struct ar_hdr *input_ar_hdr;//c
    	char *input_file_name;//c
};

struct arch {
  	char *file_name;//c
    	char *fat_arch_name;//c
  	struct fat_arch *fat_arch;//c
    	enum ofile_type type;//c
	unsigned long library_size;//c
	unsigned long  toc_size;//c
  	struct object *object;//c
 	unsigned long unknown_size;//c
    	unsigned long ntocs;//c
   	unsigned long nmembers;//c
  	struct member *members;//c
    	struct ar_hdr  toc_ar_hdr;//c
    	enum bool      toc_long_name;//c
    	char	  *toc_name;//c
   	unsigned long  toc_name_size;//c
    	struct ranlib *toc_ranlibs;//c
    	unsigned long  toc_strsize;//c
    	char	  *toc_strings;//c
    	enum bool dont_update_LC_ID_DYLIB_timestamp;//c
    	char *unknown_addr;//c
    	struct toc_entry  *toc_entries;//c
};

struct object {
   	unsigned long object_size;//c
    	unsigned long input_sym_info_size;//c
 	unsigned long output_sym_info_size;//c
   	enum byte_sex object_byte_sex; //c
   	struct dysymtab_command *dyst;//c
    	struct twolevel_hints_command *hints_cmd;//c
    	struct mach_header *mh;//c
    	struct load_command	 *load_commands;//c
   	unsigned long output_nsymbols;//c
    	struct nlist *output_symbols;//c
    	struct mach_header_64 *mh64; //c
    	struct nlist_64 *output_symbols64;//c
    	char *object_addr;//c
    	uint32_t mh_filetype;//c
    	cpu_type_t mh_cputype;//c
   	struct relocation_info *output_loc_relocs;//c
 	char *output_split_info_data;//c
    	unsigned long output_split_info_data_size;//c
    	struct twolevel_hint *output_hints;//c
    	struct relocation_info *output_ext_relocs;//c
	uint32_t *output_indirect_symtab;//c
   	unsigned long input_indirectsym_pad;//c
    	struct dylib_table_of_contents *output_tocs;//c
    	unsigned long output_ntoc;//c
    	struct dylib_module *output_mods;//c
    	unsigned long output_nmodtab;//c
    	struct dylib_module_64 *output_mods64;//c
    	struct dylib_reference *output_refs;//c
    	unsigned long output_nextrefsyms;//c
    	char	 *output_strings;//c
    	unsigned long output_strings_size;//c
    	unsigned long output_code_sig_data_size;//c
    	char *output_code_sig_data;//c
  	struct section **sections;//c
    	struct section_64 **sections64;//c
    	struct symtab_command *st;//c
    	unsigned long output_ilocalsym;//c
    	unsigned long output_nlocalsym;//c
    	unsigned long output_iextdefsym;//c
    	unsigned long output_nextdefsym;//c
    	unsigned long output_iundefsym;//c
   	unsigned long output_nundefsym;//c
    	struct linkedit_data_command *split_info_cmd;//c
     	struct linkedit_data_command *code_sig_cmd;//c
    	struct segment_command	*seg_linkedit;	//c
    	struct segment_command_64 *seg_linkedit64;//c
    	cpu_subtype_t mh_cpusubtype; //c
    	struct prebind_cksum_command *cs;//c
    	unsigned long calculated_input_prebind_cksum;//c
};//struct object

struct toc_entry {
    	char *symbol_name;//c
    	long member_index;//c
};
////////////////////////

 void writeout_to_mem(
    struct arch *archs,
    unsigned long narchs,
    char *filename,
    void **outputbuf,
    unsigned long *length,
    enum bool sort_toc,
    enum bool commons_in_toc,
    enum bool library_warning,
    enum bool *seen_archive);//c

#endif//HYS_STUFF_BREAKOUT_H
