#ifndef HYS_STUFF_OFILE_H
#define HYS_STUFF_OFILE_H

#ifndef AR_EFMT1
#define	AR_EFMT1	"#1/"	//c
#endif

/////////////////

enum ofile_type {
    OFILE_UNKNOWN,
    OFILE_FAT,
    OFILE_ARCHIVE,
    OFILE_Mach_O
};//c

struct ofile {
    	enum ofile_type file_type;//c
    	cpu_type_t mh_cputype;	//c
    	struct mach_header *mh;//c
    	struct mach_header_64 *mh64;  //c
   	uint32_t mh_filetype;//c
    	struct load_command *load_commands;//c
    	char *object_addr;//c
    	struct arch_flag arch_flag;//c
    	enum ofile_type arch_type;//c
   	enum bool headers_swapped;//c
   	enum ofile_type member_type; //c
   	char *file_name;//c
  	struct fat_header *fat_header; //c
    	cpu_type_t archive_cputype;//c
    	enum byte_sex object_byte_sex; //c
    	cpu_subtype_t		archive_cpusubtype;//c
    	cpu_subtype_t mh_cpusubtype;//c
    	char *file_addr;//c
   	unsigned long file_size;//c
    	struct fat_arch *fat_archs;//c
 	unsigned long narch;//c
    	unsigned long object_size;//c
   	struct dylib_module *dylib_module;//c
  	unsigned long member_offset; //c
    	char *member_addr;   //c
  	unsigned long member_size;//c
  	struct ar_hdr *member_ar_hdr;//c
    	char *member_name;//c
  	unsigned long member_name_size;//c
 	struct dylib_module *modtab;//c
    	struct dylib_module_64 *modtab64;//c
 	unsigned long nmodtab;//c
    	struct dylib_module_64 *dylib_module64;//c
    	char *dylib_module_name;//c
};
///////////////////////////////

#ifdef OFI
 NSObjectFileImageReturnCode ofile_map(
#else
enum bool ofile_map(
#endif
    const char *file_name,
    const struct arch_flag *arch_flag,
    const char *object_name,		
    struct ofile *ofile,
    enum bool archives_with_fat_objects);//c

#ifdef OFI
 NSObjectFileImageReturnCode ofile_map_from_memory(
#else
 enum bool ofile_map_from_memory(
#endif
    char *addr,
    unsigned long size,
    const char *file_name,
    const struct arch_flag *arch_flag,	
    const char *object_name,		
    struct ofile *ofile,
    enum bool archives_with_fat_objects);//c

 void ofile_unmap(
    struct ofile *ofile);//c

 enum bool ofile_first_arch(
    struct ofile *ofile);//c

 enum bool ofile_next_arch(
    struct ofile *ofile);//c

 enum bool ofile_first_member(
    struct ofile *ofile);//c

enum bool ofile_next_member(
    struct ofile *ofile);//c

enum bool ofile_specific_member(
    const char *object_name,
    struct ofile *ofile);//c

enum bool ofile_first_module(
    struct ofile *ofile);//c

 enum bool ofile_next_module(
    struct ofile *ofile);//c

 enum bool ofile_specific_module(
    const char *module_name,
    struct ofile *ofile);//c

 unsigned long size_ar_name(
    const struct ar_hdr *ar_hdr);//c

#endif//HYS_STUFF_OFILE_H
