#ifndef HYS_SYS_ACL_H
#define HYS_SYS_ACL_H

#ifndef OC_acl_type_t
#define OC_acl_type_t
typedef enum {
	ACL_TYPE_EXTENDED,//?
} acl_type_t;
#endif//OC

///////////////////////
#ifndef OC_acl_perm_t
#define OC_acl_perm_t
typedef enum  {
	ACL_WRITE_ATTRIBUTES	= KAUTH_VNODE_WRITE_ATTRIBUTES,//c
	ACL_WRITE_DATA		= KAUTH_VNODE_WRITE_DATA,//c
	ACL_READ_DATA		= KAUTH_VNODE_READ_DATA,//c
	ACL_WRITE_EXTATTRIBUTES	= KAUTH_VNODE_WRITE_EXTATTRIBUTES,//c
	ACL_LIST_DIRECTORY	= KAUTH_VNODE_LIST_DIRECTORY,//c
	ACL_ADD_FILE		= KAUTH_VNODE_ADD_FILE,//c
	ACL_SEARCH		= KAUTH_VNODE_SEARCH,//c
	ACL_DELETE		= KAUTH_VNODE_DELETE,//c
	ACL_APPEND_DATA		= KAUTH_VNODE_APPEND_DATA,//c
	ACL_ADD_SUBDIRECTORY	= KAUTH_VNODE_ADD_SUBDIRECTORY,//c
	ACL_DELETE_CHILD	= KAUTH_VNODE_DELETE_CHILD,//c
	ACL_READ_ATTRIBUTES	= KAUTH_VNODE_READ_ATTRIBUTES,//c
	ACL_READ_EXTATTRIBUTES	= KAUTH_VNODE_READ_EXTATTRIBUTES,//c
	ACL_READ_SECURITY	= KAUTH_VNODE_READ_SECURITY,//c
	ACL_WRITE_SECURITY	= KAUTH_VNODE_WRITE_SECURITY,//c
	ACL_CHANGE_OWNER	= KAUTH_VNODE_CHANGE_OWNER,//c
} acl_perm_t;
#endif

typedef enum {
	ACL_ENTRY_INHERITED		= KAUTH_ACE_INHERITED,//c
	ACL_ENTRY_DIRECTORY_INHERIT	= KAUTH_ACE_DIRECTORY_INHERIT,//c
	ACL_ENTRY_FILE_INHERIT		= KAUTH_ACE_FILE_INHERIT,//c
	ACL_ENTRY_LIMIT_INHERIT		= KAUTH_ACE_LIMIT_INHERIT,//c
	ACL_ENTRY_ONLY_INHERIT		= KAUTH_ACE_ONLY_INHERIT,//c
} acl_flag_t;

#ifndef OC_acl_tag_t
#define OC_acl_tag_t
typedef enum  {
	ACL_EXTENDED_ALLOW	= KAUTH_ACE_PERMIT,//c
	ACL_EXTENDED_DENY	= KAUTH_ACE_DENY,//c
} acl_tag_t;
#endif

#ifdef ACL_FIRST_ENTRY
	#undef ACL_FIRST_ENTRY
#endif

#ifdef ACL_NEXT_ENTRY
	#undef ACL_NEXT_ENTRY
#endif

typedef enum  {
	ACL_FIRST_ENTRY		= 0,//c
	ACL_NEXT_ENTRY		= -1,//c
} acl_entry_id_t;

/////////////////////
struct _acl_flagset;
typedef struct _acl_flagset	*acl_flagset_t;//c

struct _acl;

#ifndef OC_acl_t
#define OC_acl_t
typedef struct _acl		*acl_t;//c
#endif

struct _acl_entry;

#ifndef OC_acl_entry_t
#define OC_acl_entry_t
typedef struct _acl_entry	*acl_entry_t;//c
#endif

struct _acl_permset;

#ifndef OC_acl_permset_t
#define OC_acl_permset_t
typedef struct _acl_permset	*acl_permset_t;//c
#endif

////////////////////
//func
extern int	acl_get_flag_np(acl_flagset_t flagset_d, acl_flag_t flag);//c

#ifdef __CYGWIN__
extern int	acl_get_entry(acl_t acl, int entry_id, acl_entry_t *entry_p);//c
extern int	acl_delete_entry(acl_t acl, acl_entry_t entry_d);//c
extern int	acl_free(void *obj_p);//c
extern int	acl_set_qualifier(acl_entry_t entry_d, const void *tag_qualifier_p);//c
extern int 	acl_get_permset(acl_entry_t entry_d, acl_permset_t *permset_p);//c
extern int	acl_add_perm(acl_permset_t permset_d, acl_perm_t perm);//c
extern int	acl_set_permset(acl_entry_t entry_d, acl_permset_t permset_d);//c
extern int	acl_set_tag_type(acl_entry_t entry_d, acl_tag_t tag_type);//c
extern acl_t	acl_init(int count);//c
#endif //__CYGWIN__

#endif//HYS_SYS_ACL_H
