#ifndef HYS_SYS_ATTR_H
#define HYS_SYS_ATTR_H

#define VOL_CAPABILITIES_FORMAT 1//?
#define VOL_CAP_FMT_NO_ROOT_TIMES 2//?
#define VOL_CAP_FMT_NO_ROOT_TIMES 2//?
#define VOL_CAP_FMT_CASE_SENSITIVE 3//?
#define VOL_CAP_FMT_CASE_PRESERVING 4//?
#define VOL_CAP_FMT_FAST_STATFS 5//?
#define VOL_CAP_FMT_2TB_FILESIZ 6//?
#define VOL_CAP_FMT_PERSISTENTOBJECTIDS 7//?
#define VOL_CAP_FMT_2TB_FILESIZE 8//?
#define VOL_CAP_FMT_SYMBOLICLINKS 9//?
#define VOL_CAP_FMT_HARDLINKS 10//?
#define VOL_CAP_FMT_JOURNAL 11//?
#define VOL_CAP_FMT_JOURNAL_ACTIVE 12//?
#define VOL_CAP_FMT_SPARSE_FILES 13//?
#define ATTR_CMN_NAME 14//?
#define ATTR_VOL_MOUNTPOINT 15//?
#define VOL_CAP_FMT_ZERO_RUNS 16//?
#define VOL_CAP_INT_READDIRATTR 17//?
#define VOL_CAPABILITIES_INTERFACES 18//?
#define ATTR_VOL_SIZE 19//?
#define VOL_CAP_INT_ATTRLIST 20//?
#define ATTR_VOL_FSTYPE 21//?
#define VOL_CAP_INT_SEARCHFS 22//?
#define VOL_CAP_INT_NFSEXPORT 23//.?
#define VOL_CAP_INT_EXCHANGEDATA 24//?
#define VOL_CAP_INT_ALLOCATE 25//?
#define VOL_CAP_INT_COPYFILE 26//?
#define ATTR_CMN_DEVID 27//?
#define VOL_CAP_INT_VOL_RENAME 28//?
#define VOL_CAP_INT_ADVLOCK 29//?
#define VOL_CAP_INT_FLOCK 30//?
#define VOL_CAP_INT_EXTENDED_SECURITY 31//?
#define VOL_CAP_INT_USERACCESS 32//?
#define ATTR_CMN_FSID 33//?
#define ATTR_CMN_OBJTYPE 34//?
#define ATTR_CMN_OBJID 35//?
#define ATTR_CMN_PAROBJID 36//?
#define ATTR_FILE_TOTALSIZE 37//?
#define ATTR_CMN_CRTIME 38//?
#define ATTR_CMN_OWNERID 39//?
#define ATTR_CMN_GRPID 40//?
#define ATTR_CMN_ACCESSMASK 41//?
#define ATTR_CMN_FLAGS 42//?
#define ATTR_VOL_SPACEFREE 43//?
#define ATTR_FILE_IOBLOCKSIZE 44//?
#define ATTR_VOL_SPACEAVAIL 45//?
#define ATTR_VOL_IOBLOCKSIZE 46//?
#define ATTR_VOL_OBJCOUNT 47//?
#define ATTR_FILE_DATALENGTH 48//?
#define ATTR_FILE_DATAALLOCSIZE 49//?
#define ATTR_VOL_FILECOUNT 50//?
#define ATTR_VOL_DIRCOUNT 51//?
#define ATTR_VOL_MAXOBJCOUNT 52//?
#define ATTR_VOL_NAME 53//?
#define ATTR_VOL_MOUNTFLAGS 54//?
#define ATTR_VOL_MOUNTEDDEVICE 55//?
#define ATTR_VOL_CAPABILITIES 56//?
#define ATTR_VOL_ATTRIBUTES 57//?
#define VOL_CAPABILITIES_RESERVED1 58//?
#define VOL_CAPABILITIES_RESERVED2 59//?
#define ATTR_CMN_OBJPERMANENTID 60//?
#define ATTR_CMN_MODTIME 61//?
#define ATTR_VOL_SIGNATURE 62//?
#define ATTR_CMN_BKUPTIME 63//?
#define ATTR_CMN_FNDRINFO 64//?
#define ATTR_VOL_MINALLOCATION 65//?
#define ATTR_FILE_RSRCALLOCSIZE 66//?
#define ATTR_FILE_RSRCLENGTH 67//?
#define ATTR_FILE_ALLOCSIZE 68//?
#define ATTR_FILE_LINKCOUNT 69//?
#define ATTR_FILE_DEVTYPE 70//?
#define ATTR_DIR_ENTRYCOUNT 71//?
#define ATTR_VOL_ALLOCATIONCLUMP 72//?
#define ATTR_VOL_ENCODINGSUSED 73//?
#define ATTR_DIR_LINKCOUNT 74//?
#define ATTR_BIT_MAP_COUNT 75//?
#define ATTR_CMN_SCRIPT 76//?
#define ATTR_VOL_INFO 77//?
#define ATTR_FILE_DATAEXTENTS 78//?
#define ATTR_CMN_OBJTAG 79//?
#define ATTR_CMN_CHGTIME 80//?
#define ATTR_CMN_ACCTIME 81//?
#define ATTR_CMN_USERACCESS 82//?
#define ATTR_DIR_MOUNTSTATUS 83//?
#define ATTR_FILE_CLUMPSIZE 84//?
#define VOL_CAP_FMT_PATH_FROM_ID 85//?
#define VOL_CAP_INT_EXTENDED_ATTR 86//?

///////////////////////////
typedef u_int32_t vol_capabilities_set_t[4];//C
typedef u_int32_t text_encoding_t;//c
typedef u_int32_t attrgroup_t;//c
////////////////////////////////
struct vol_capabilities_attr {
	vol_capabilities_set_t capabilities;//c
	vol_capabilities_set_t valid;//c
};
typedef struct vol_capabilities_attr  vol_capabilities_attr_t;

struct attribute_set {
	attrgroup_t commonattr;//c
	attrgroup_t volattr;//c
	attrgroup_t dirattr;//c
	attrgroup_t fileattr;//c
	attrgroup_t forkattr;//c
};
typedef struct attribute_set attribute_set_t;

struct vol_attributes_attr {
	attribute_set_t validattr;//c
	attribute_set_t nativeattr;//c
};
typedef struct vol_attributes_attr vol_attributes_attr_t;

struct attrlist {
	u_short bitmapcount;//c
	attrgroup_t commonattr;//c
	attrgroup_t dirattr;//c
	attrgroup_t fileattr;//c
	attrgroup_t forkattr;//c
	attrgroup_t volattr;//c
	u_int16_t reserved;//C
};

struct attrreference {
	int32_t     attr_dataoffset;//c
	u_int32_t   attr_length;//c
};
typedef struct attrreference attrreference_t;

struct fsobj_id { 
	u_int32_t		fid_objno;//c
};
typedef struct fsobj_id  fsobj_id_t;

#endif //HYS_SYS_ATTR_H
