#ifndef HYS_SYS_CONF_H
#define HYS_SYS_CONF_H

#ifdef __linux__

//#include <sys/buf_internal.h>//struct buf
//#include <sys/tty.h>//struct tty
//#include <sys/uio_internal.h>//struct  uio

#endif//__linux__

//#include <sys/proc_internal.h>//struct proc
#include <stdlib.h>//dev_t

/////////////////////
#define eno_mmap ((mmap_fcn_t *)&enodev)//c
#define eno_strat		((strategy_fcn_t *)&enodev_strat)//c
#define eno_getc		((getc_fcn_t *)&enodev)//c
#define eno_putc		((putc_fcn_t *)&enodev)//c
#define eno_dump		((dump_fcn_t *)&enodev)//c
#define eno_stop		((stop_fcn_t *)&enodev)//c
#define eno_reset		((reset_fcn_t *)&enodev)//c
#define eno_select		((select_fcn_t *)&enodev)//c
#define	d_open_t	open_close_fcn_t//c
#define	d_close_t	open_close_fcn_t//c
#define	d_ioctl_t	ioctl_fcn_t//c
#define eno_rdwrt		((read_write_fcn_t *)&enodev)//c
#define eno_ioctl		((ioctl_fcn_t *)&enodev)//c

////////////////////

#define D_TTY 1//?
#define D_DISK 2//?
#define D_TAPE 3//?

////////////////
typedef int  ioctl_fcn_t(dev_t dev, u_long cmd, caddr_t data,int fflag, struct proc *p);//c
typedef	int  reset_fcn_t(int uban);//c
typedef	int  mmap_fcn_t(void);//c
typedef	void strategy_fcn_t(struct buf *bp);//c
typedef	int  getc_fcn_t(dev_t dev);//c
typedef	int  putc_fcn_t(dev_t dev, char c);//c
typedef int  open_close_fcn_t(dev_t dev, int flags, int devtype,struct proc *p);//c
typedef int  read_write_fcn_t(dev_t dev, struct uio *uio, int ioflag);//c
typedef	int  stop_fcn_t(struct tty *tp, int rw);//c
typedef	int  select_fcn_t(dev_t dev, int which, void * wql, struct proc *p);//c
typedef	int  psize_fcn_t(dev_t dev);//c
typedef int  dump_fcn_t(void); //c
typedef int  l_open_t (dev_t dev, struct tty *tp);//c
typedef int  l_close_t(struct tty *tp, int flags);//c
typedef int  l_read_t (struct tty *tp, struct uio *uio, int flag);//c
typedef int  l_write_t(struct tty *tp, struct uio *uio, int flag);//c
typedef int  l_ioctl_t(struct tty *tp, u_long cmd, caddr_t data, int flag,struct proc *p);//c
typedef int  l_rint_t (int c, struct tty *tp);//c
typedef void l_start_t(struct tty *tp);//c
typedef int  l_modem_t(struct tty *tp, int flag);//c

/////////////////

struct bdevsw {
	open_close_fcn_t	*d_open;//c
	open_close_fcn_t	*d_close;//c
	strategy_fcn_t		*d_strategy;//c
	ioctl_fcn_t		*d_ioctl;//c
	dump_fcn_t		*d_dump;//c
	psize_fcn_t		*d_psize;//c
	int			d_type;//c
};

struct cdevsw {
	open_close_fcn_t	*d_open;//c
	open_close_fcn_t	*d_close;//c
	read_write_fcn_t	*d_read;//c
	read_write_fcn_t	*d_write;//c
	ioctl_fcn_t			*d_ioctl;//c
	stop_fcn_t			*d_stop;//c
	reset_fcn_t			*d_reset;//c
	struct	tty 		**d_ttys;//c
	select_fcn_t		*d_select;//c
	mmap_fcn_t			*d_mmap;//c
	strategy_fcn_t		*d_strategy;//c
	getc_fcn_t			*d_getc;//c
	putc_fcn_t			*d_putc;//c
	int					d_type;//c
};//c

struct linesw {
	l_open_t	*l_open;//c
	l_close_t	*l_close;//c
	l_read_t	*l_read;//c
	l_write_t	*l_write;//c
	l_ioctl_t	*l_ioctl;//c
	l_rint_t	*l_rint;//c
	l_start_t	*l_start;//c
	l_modem_t	*l_modem;//c
};

////////////////////////////
extern struct linesw linesw[];//c
int		enodev(void);	//c	
void	enodev_strat(void);//c
int  cdevsw_add(int, struct cdevsw *);//c
int  cdevsw_remove(int, struct cdevsw *);//c
int  bdevsw_add(int, struct bdevsw *);//c
int  bdevsw_remove(int, struct bdevsw *);//c

#endif //HYS_SYS_CONF_H
