#ifndef HYS_SYS_EVENT_H
#define HYS_SYS_EVENT_H

#define EV_SET(kevp, a, b, c, d, e, f) do {	\
	struct kevent *__kevp__ = (kevp);	\
	__kevp__->ident = (a);			\
	__kevp__->filter = (b);			\
	__kevp__->flags = (c);			\
	__kevp__->fflags = (d);			\
	__kevp__->data = (e);			\
	__kevp__->udata = (f);			\
} while(0)//c

#define EVFILT_TIMER		(-7)//c
#define EVFILT_READ		(-1)//c
#define EVFILT_WRITE		(-2)//c
#define EVFILT_AIO		(-3)//c
#define EVFILT_PROC		(-5)//c
#define EVFILT_SIGNAL		(-6)//c
#define EVFILT_MACHPORT		(-8)//c
#define EVFILT_FS		(-9)	//c

//////////////////

#define EV_EOF 1//?
#define EV_ERROR 2//?
#define EV_CLEAR 3//?
#define EV_ADD 4//?
#define EV_DELETE 5//?
#define EV_SYSFLAGS 6//?
#define EV_ONESHOT 7//?
#define EV_ENABLE 8//?
#define EV_DISABLE 9//?
#define NOTE_DELETE 10//?
#define NOTE_WRITE 11//?
#define NOTE_EXTEND 12//?
#define NOTE_REVOKE 13//?
#define NOTE_ATTRIB 14//?
#define NOTE_LINK 15//?
#define NOTE_RENAME 16//?
#define EVFILT_VNODE 17//?
#define NOTE_SECONDS 18//?
#define NOTE_ABSOLUTE 19//?
#define EV_RECEIPT 20//?
#define NOTE_EXIT 21//?
#define NOTE_REAP 22//?
#define NOTE_FORK 23//?
#define NOTE_EXEC 24//?
#define NOTE_SIGNAL 25//?
#define NOTE_TRACK 26//?
#define NOTE_TRACKERR 27//?
#define NOTE_CHILD 28//?
#define NOTE_USECONDS 29//?
#define NOTE_NSECONDS 30//?

////////////////////////
struct knote;
SLIST_HEAD(klist, knote);//c

struct filterops {
	int	f_isfd;
	int	(*f_attach)(struct knote *kn);
	void	(*f_detach)(struct knote *kn);
	int	(*f_event)(struct knote *kn, long hint);
};//c

#endif//HYS_SYS_EVENT_H

#ifdef HYS_SYS_EVENT_H_END
#undef HYS_SYS_EVENT_H_END

struct knote {
	caddr_t			kn_hook;//c
	int			kn_hookid;//c
	int			kn_sfflags;//c
	struct 			kevent kn_kevent;//c
	struct			filterops *kn_fop;//c
};
#define kn_fflags	kn_kevent.fflags//c
#define kn_flags	kn_kevent.flags//c
#define kn_filter	kn_kevent.filter//c

#endif//HYS_SYS_EVENT_H_END
