#ifndef HYS_SYS_MOUNT_H
#define HYS_SYS_MOUNT_H

#define VFSATTR_IS_ACTIVE(s, a)		((s)->f_active & VFSATTR_ ## a)//c

#define VFSATTR_RETURN(s, a, x)		do { (s)-> a = (x); VFSATTR_SET_SUPPORTED(s, a);} while(0)//c

#define VFSATTR_SET_SUPPORTED(s, a)	((s)->f_supported |= VFSATTR_ ## a)//c
#define VFSATTR_INIT(s)			((s)->f_supported = (s)->f_active = 0LL)//c
#define VFSATTR_WANTED(s, a)		((s)->f_active |= VFSATTR_ ## a)//c
#define VFSATTR_IS_SUPPORTED(s, a)	((s)->f_supported & VFSATTR_ ## a)//c

#define MNT_CMDFLAGS	(MNT_UPDATE|MNT_RELOAD|MNT_FORCE) //c
#define VFSATTR_f_filecount		(1LL<<  1)//c

#ifdef __CYGWIN__
#define	MNT_FORCE	0x00080000//c
#endif //__CYGWIN__

#define VFSATTR_f_blocks		(1LL<<  6)//c
#define VFSATTR_f_objcount		(1LL<<  0)//c
#define VFSATTR_f_dircount		(1LL<<  2)//c
#define VFSATTR_f_maxobjcount		(1LL<<  3)//c
#define VFSATTR_f_bused			(1LL<<  9)//c
#define VFSATTR_f_create_time		(1LL<< 16)//c
#define VFSATTR_f_modify_time		(1LL<< 17)//c
#define VFSATTR_f_backup_time		(1LL<< 19)//c
#define VFSATTR_f_vol_name		(1LL<< 21)//c
#define VFSATTR_f_fsid			(1LL<< 12)//c
#define VFSATTR_f_signature		(1LL<< 22)//c
#define VFSATTR_f_carbon_fsid		(1LL<< 23)//c
#define VFSATTR_f_capabilities		(1LL<< 14)//c
#define VFSATTR_f_attributes		(1LL<< 15)//c

///////////////
#define VFS_TBLTHREADSAFE 1////////?
#define VFS_TBLFSNODELOCK 2//?
#define VFS_TBLNOTYPENUM 3//?
#define MNT_IGNORE_OWNERSHIP 5//?
#define VFS_TBL64BITREADY 6//?
#define VFS_TBLLOCALVOL 7//?
#define MNT_RDONLY 8//?
#define MNT_NOEXEC 9//?
#define MNT_NOSUID 10//?
#define MNT_NODEV 11//?
#define MNT_DOVOLFS 12//?
#define MNT_NOWAIT 13//?
#define MNT_AUTOMOUNTED 14//?
#define MNT_UNION 15//?
#define MNT_LOCAL 16//?
#define MFSTYPENAMELEN 17//?
#define VFS_GENERIC 18//?
#define MFSNAMELEN 19//?
#define VFS_MAXTYPENUM 20//?
#define VFS_CONF 21//?
#define MNT_SYNCHRONOUS 22//?
#define MNT_ASYNC 23//?
#define MNT_EXPORTED 24//?
#define MNT_QUOTA 25//?
#define MNT_ROOTFS 26//?
#define MNT_UPDATE 27//?
#define MNT_RELOAD 28//?
#define MNT_WAIT 29//?
#define MNT_DONTBROWSE 30//?
#define VFS_CTL_VERS1 31//?
#define MNT_QUARANTINE 32//?
#define VFS_CTL_UMOUNT 33//?
#define VFSATTR_f_bsize 34//?
#define VFSATTR_f_iosize 35//?
#define VFSATTR_f_bfree 37//?
#define VFSATTR_f_bavail 38//?
#define VFSATTR_f_files 39//?
#define VFSATTR_f_ffree 40//?
#define MNT_NOCOREDUMP 41//?
#define MNT_IGNORE 42//?
#define MNT_SYMPERM 43//?
#define MNT_JOURNALED 44//?
#define VQ_NOTRESP 45//?
#define VQ_NEEDAUTH 46//?
#define VQ_LOWDISK 47//?
#define VQ_MOUNT 48//?
#define VQ_UNMOUNT 49//?
#define VQ_DEAD 50//?
#define VQ_ASSIST 51//?
#define VQ_NOTRESPLOCK 52//?
#define VQ_UPDATE 53//?

/////////////////////////////
struct vfs_attr {
	vol_capabilities_attr_t f_capabilities;//c
	vol_attributes_attr_t f_attributes;//c
	uint64_t	f_objcount;//c
	uint64_t	f_filecount;//c
	uint64_t	f_dircount;//c
	uint64_t	f_maxobjcount;	//c
	uint32_t	f_bsize;//c
	size_t		f_iosize;//c
	uint64_t	f_blocks;//c
	uint64_t	f_bfree;//c
	uint64_t	f_bavail;//c
	uint64_t	f_bused;//c
	uint64_t	f_files;//c
	uint64_t	f_ffree;//c
	fsid_t f_fsid;//c
	struct timespec	f_create_time;//c
	uint32_t	f_fssubtype;//c
	char		*f_vol_name;//c
	struct timespec f_modify_time;//c
	struct timespec f_access_time;//c
	struct timespec	f_backup_time;	//c
	uint64_t	f_supported;//c
	uint64_t	f_active;//c
	uint16_t	f_signature;//c
	uint16_t	f_carbon_fsid;//c
};

struct vfsops {
	int a;//dummy
	int b;//dummy
	int c;//dummy
	int d;//dummy
	int e;//dummy
	int f;//dummy
	int g;//dummy
	int h;//dummy
	int i;//dummy
	int j;//dummy
	int k;//dummy
	int l;//dummt
	int m;//dummy
	int n;//dummy
};

struct vfs_fsentry {
	struct vfsops * vfe_vfsops;//c
	int		vfe_vopcnt;//c
	struct vnodeopv_desc ** vfe_opvdescs;//c
	uint32_t	vfe_flags;//c
	char		vfe_fsname[MFSNAMELEN];//c
};

struct vfsstatfs {
	char		f_fstypename[MFSTYPENAMELEN];//c
	uint32_t	f_bsize;	//c
	size_t		f_iosize;//c
	uint64_t	f_blocks;	//c
	uint64_t	f_bfree;//c
	uint64_t	f_bavail;//c
	uint64_t	f_bused;//c
	uint64_t	f_files;//c
	uint64_t	f_ffree;//c
	fsid_t f_fsid;//c
	char		f_mntfromname[MAXPATHLEN];//c
	char		f_mntonname[MAXPATHLEN];//c
};

struct vfsconf {
	char	vfc_name[MFSNAMELEN];//c
	int	vfc_refcount;//c
	int	vfc_flags;//c
	int	vfc_typenum;//c
};

struct vfsidctl {
	int		vc_vers;//c
	fsid_t	vc_fsid;//c
	void		*vc_ptr;//c
	size_t		vc_len;//c
};

struct statfs {
	short	f_otype;
	short	f_oflags;
	long	f_bsize;		
	long	f_iosize;		
	long	f_blocks;		
	long	f_bfree;		
	long	f_bavail;		
	long	f_files;		
	long	f_ffree;		
	fsid_t	f_fsid;	
	uid_t	f_owner;		
	short	f_reserved1;
	short	f_type;	
	long	f_flags;		
	long    f_reserved2[2];
	char	f_fstypename[MFSNAMELEN]; 
	char	f_mntonname[MNAMELEN];	
	char	f_mntfromname[MNAMELEN];
#if COMPAT_GETFSSTAT
	char	f_reserved3[0];	
	long	f_reserved4[0];	
#else
	char	f_reserved3;	
	long	f_reserved4[4];	
#endif
};//c

////////////

#ifndef OC_mount_t
#define OC_mount_t
struct mount;
typedef struct mount * mount_t;//c
#endif

#ifndef OC_vnode_t
#define OC_vnode_t
struct vnode;
typedef struct vnode * vnode_t;//c
#endif

/////////
void *	vfs_fsprivate(mount_t);//c
int	vfs_typenum(mount_t);//c
int vfs_fsremove(vfstable_t);//c
int vfs_fsadd(struct vfs_fsentry *, vfstable_t *);//c
int	vfs_isupdate(mount_t); //c
void	vfs_setfsprivate(mount_t, void *mntdata);//c
struct vfsstatfs *	vfs_statfs(mount_t);//c
void	vfs_setflags(mount_t, uint64_t);//c
int	getvfsbyname(const char *, struct vfsconf *);//c

#endif //HYS_SYS_MOUNT_H
