#ifndef HYS_SYS_STAT_H
#define HYS_SYS_STAT_H

#define __DARWIN_STRUCT_STAT64 { \
	dev_t		st_dev;		\
	mode_t		st_mode;		 \
	nlink_t		st_nlink;		 \
	__darwin_ino64_t st_ino;		 \
	uid_t		st_uid;			 \
	gid_t		st_gid;			\
	dev_t		st_rdev;		\
	__DARWIN_STRUCT_STAT64_TIMES \
	off_t		st_size;		 \
	blkcnt_t	st_blocks;		 \
	blksize_t	st_blksize;	\
	__uint32_t	st_flags;		 \
	__uint32_t	st_gen;		 \
	__int32_t	st_lspare;		 \
	__int64_t	st_qspare[2];		 \
}//c

#if !defined(_POSIX_C_SOURCE) || defined(_DARWIN_C_SOURCE)
#define __DARWIN_STRUCT_STAT64_TIMES \
	struct timespec st_atimespec;		 \
	struct timespec st_mtimespec;		\
	struct timespec st_ctimespec;		\
	struct timespec st_birthtimespec;	

#else /* (_POSIX_C_SOURCE && !_DARWIN_C_SOURCE) */

#define __DARWIN_STRUCT_STAT64_TIMES \
	time_t		st_atime;	\
	long		st_atimensec;	 \
	time_t		st_mtime;		\
	long		st_mtimensec;		\
	time_t		st_ctime;		 \
	long		st_ctimensec;		\
	time_t		st_birthtime;		\
	long		st_birthtimensec;

#endif//c /* (!_POSIX_C_SOURCE || _DARWIN_C_SOURCE) */

#ifndef ALLPERMS
#define	ALLPERMS	(S_ISUID|S_ISGID|S_ISTXT|S_IRWXU|S_IRWXG|S_IRWXO)//c
#endif

#ifndef S_IRWXU
#define	S_IRWXU		0000700//c
#endif

#ifndef S_IXOTH
#define	S_IXOTH		0000001	//c
#endif

#ifndef S_IROTH
#define	S_IROTH		0000004//c
#endif

#ifndef S_IRWXG
#define	S_IRWXG		0000070//c
#endif

#ifndef S_IXGRP
#define	S_IXGRP		0000010//c	
#endif

#ifndef S_IRGRP
#define	S_IRGRP		0000040//c
#endif

/////////////////
#define UF_IMMUTABLE 2//?

////////////

#ifndef __blksize_t_defined
#define __blksize_t_defined
#ifndef _BLKSIZE_T
typedef	__darwin_blksize_t	blksize_t;
#define	_BLKSIZE_T
#endif//_BLKSIZE_T
#endif//__blksize_t_defined

#ifndef _FILESEC_T
struct _filesec;
typedef struct _filesec	*filesec_t;//c
#define _FILESEC_T
#endif

#ifndef __blkcnt_t_defined
#define __blkcnt_t_defined
#ifndef _BLKCNT_T
typedef	__darwin_blkcnt_t	blkcnt_t;//c
#define	_BLKCNT_T
#endif
#endif
/////////////////////

#if __DARWIN_64_BIT_INO_T

struct stat __DARWIN_STRUCT_STAT64;

#else//__DARWIN_64_BIT_INO_T

#ifdef __linux__
#ifdef st_atime
	#undef st_atime
#endif

#ifdef st_ctime
	#undef st_ctime
#endif

#endif//__linux__

struct stat {
#if !defined(_POSIX_C_SOURCE) || defined(_DARWIN_C_SOURCE)
	struct	timespec st_mtimespec;//c
	struct	timespec st_atimespec;//c
	struct	timespec st_ctimespec;//c
#else
#define  st_mtimespec st_mtime//add
	time_t		st_mtime;//c
#define st_atimespec st_atime//add
	time_t		st_atime;//c
	long		st_mtimensec;//c
	long		st_atimensec;//c
	time_t	st_ctime;//c
	long		st_ctimensec;//c
#endif
	dev_t	 	st_dev;//c
	ino_t	  	st_ino;//c
	off_t		st_size;//.c
	uid_t		st_uid;//c
	gid_t		st_gid;//c
	dev_t		st_rdev;//c
	blksize_t	st_blksize;//c
	blkcnt_t	st_blocks;//c
	nlink_t		st_nlink;//c
	mode_t	 	st_mode;//c
	__uint32_t	st_flags;//c
	__uint32_t	st_gen;//c
};
#endif //__DARWIN_64_BIT_INO_T

#if !defined(_POSIX_C_SOURCE) || defined(_DARWIN_C_SOURCE)
#define st_mtime st_mtimespec.tv_sec//c
#define st_atime st_atimespec.tv_sec//c
#define st_ctime st_ctimespec.tv_sec//c
#endif /* (!_POSIX_C_SOURCE || _DARWIN_C_SOURCE) */

#ifndef OC_struct_stat64
#define OC_struct_stat64
struct stat64 __DARWIN_STRUCT_STAT64;
#endif

////////////////////

int	lstatx_np(const char *, struct stat *, filesec_t) __DARWIN_INODE64(lstatx_np);//c
int	fstatx_np(int, struct stat *, filesec_t) __DARWIN_INODE64(fstatx_np);//c
int	statx_np(const char *, struct stat *, filesec_t) __DARWIN_INODE64(statx_np);//c

#endif //HYS_SYS_STAT_H
