#ifndef HYS_SYS_SYSCTL_H
#define HYS_SYS_SYSCTL_H

////////////////////
#define KERN_PROC 1//?
#define KERN_PROC_ALL 2//?
#define KERN_PROC_PID 3//?
#define CTL_HW 4//?
#define HW_MEMSIZE 5//?
#define KERN_SAFEBOOT 6//?
#define CTL_KERN 7//?
#define CTL_VFS 8//?
#define KERN_VNODE 9//?
#define KERN_FILE 10//?
#define KERN_ARGMAX 11//?
#define KERN_PROCARGS2 12//?
#define EPROC_SLEADER 13//?
#define EPROC_CTTY 14//?
#define WMESGLEN 15//?
#define KERN_PROC_PGRP 16//?
#define KERN_PROC_RUID 17//?
#define KERN_PROC_SESSION 18//?
#define KERN_PROC_TTY 19//?
#define KERN_PROC_UID 20//?
#define HW_EPOCH 21//?
#define KERN_CLOCKRATE 22//?
#define KERN_BOOTTIME 23//?
#define KERN_TRANSLATE 24//?
#define KERN_HOSTID 25//?
#define KERN_HOSTNAME 26//?
#define VM_METER 27//?
#define KERN_NETBOOT 28//?
#define KERN_MAXPROC 29//?
#define KERN_MAXPROCPERUID 30//?
#define KERN_MAXFILES 31//?
#define KERN_MAXFILESPERPROC 32//?
#define HW_MACHINE 33//?
#define HW_MODEL 34//?
#define KERN_OSVERSION 35//?

///////////
#define SYSCTL_HANDLER_ARGS (struct sysctl_oid *oidp, void *arg1, int arg2, struct sysctl_req *req)//c

#define SYSCTL_OID(parent, nbr, name, kind, a1, a2, handler, fmt, descr) \
	struct sysctl_oid sysctl_##parent##_##name = {			 \
		&sysctl_##parent##_children, { 0 },			 \
		nbr, kind, a1, a2, #name, handler, fmt };		 \
	SYSCTL_LINKER_SET_ENTRY(__sysctl_set, sysctl_##parent##_##name)//c

#define SYSCTL_PROC(parent, nbr, name, access, ptr, arg, handler, fmt, descr) \
	SYSCTL_OID(parent, nbr, name, access, \
		ptr, arg, handler, fmt, descr)//c

#define KERN_CLASSIC	   	KERN_TRANSLATE//c
/////////////////////////////
struct _ucred {
	uid_t	cr_uid;//c
};

struct _pcred {
	gid_t	p_rgid;//c
	uid_t	p_ruid;//c
	gid_t	p_svgid;//c
	uid_t	p_svuid;//c
};

struct ki_ucred {
	gid_t		cr_gid;//c
	uid_t		cr_uid;//c
};//etc

struct kinfo_proc{
	struct extern_proc kp_proc;//c
	struct	eproc {
		#ifdef OC_BSD
			struct	ki_ucred e_ucred;
		#else
			struct	_ucred e_ucred;//c
		#endif

		short	e_jobc;//c
		struct	proc *e_paddr;//c
		pid_t	e_pgid;//c
		pid_t	e_ppid;//c
		struct	_pcred e_pcred;//c
		struct	session *e_sess;//c
		pid_t	e_tpgid;//c
		struct	session *e_tsess;//c
		int32_t	e_flag;//c
		dev_t	e_tdev;//c
		char	e_wmesg[WMESGLEN+1];//c
	} kp_eproc;
};
///////////////////

#endif //HYS_SYS_SYSCTL_H
