#ifndef HYS_SYS_VNODE_H
#define HYS_SYS_VNODE_H

struct vnodeop_desc;

#define VATTR_RETURN(v, a, x)		do { (v)-> a = (x); VATTR_SET_SUPPORTED(v, a);} while(0)//c

#define VATTR_INIT(v)			do {(v)->va_supported = (v)->va_active = 0ll; (v)->va_vaflags = 0;} while(0)//c

#define VATTR_SET_ACTIVE(v, a)		((v)->va_active |= VNODE_ATTR_ ## a)//c
#define VATTR_WANTED(v, a)		VATTR_SET_ACTIVE(v, a)//c
#define VATTR_SET_SUPPORTED(v, a)	((v)->va_supported |= VNODE_ATTR_ ## a)//c
#define VATTR_IS_ACTIVE(v, a)		((v)->va_active & VNODE_ATTR_ ## a)//c
#define VCREATESIZE sizeof(struct vnode_fsparam)//c
#define	NULLVP	((struct vnode *)NULL)//c

#ifndef DELETE
	#define DELETE 2//c
#endif

#define VNODE_ATTR_va_parentid		(1LL<<19)//c
#define VNODE_ATTR_va_create_time	(1LL<<12)//c
#define VNODE_ATTR_va_backup_time	(1LL<<16)//c
#define VNODE_ATTR_va_gen		(1LL<<22)//c
#define VNODE_ATTR_va_encoding		(1LL<<23)//c
#define VNODE_ATTR_va_nchildren		(1LL<<28)//c
#define VNODE_ATTR_va_data_alloc	(1LL<< 5)//c

/////////////
#define VNFS_NOCACHE 1//?
#define VNFS_CANTCACHE 2//?
#define VNCREATE_FLAVOR 3//?
#define ISDOTDOT 4//?
#define VNODE_READDIR_EXTENDED 5//?
#define VNODE_READDIR_REQSEEKOFF 6//?
#define FORCECLOSE 7//?
#define VNODE_READ 8//?
#define ISLASTCN 9//?
#define RENAME 11//?
#define IO_NDELAY 12//?
#define IO_SYNC 13//?
#define IO_APPEND 14//?
#define IO_UNIT 15//?
#define IO_NODELOCKED 16//?
#define VNODE_WRITE 17//?
#define VXLOCK 18//?
#define VXWANT 19//?
#define VNODE_ATTR_va_rdev 20//?
#define VNODE_ATTR_va_nlink 21//?
#define VNODE_ATTR_va_data_size 22//?
#define VNODE_ATTR_va_gid 23//?
#define VNODE_ATTR_va_total_size 24//?
#define VNODE_ATTR_va_iosize 25//?
#define VNODE_ATTR_va_uid 26//?
#define VNODE_ATTR_va_mode 27//?
#define VNODE_ATTR_va_flags 28//?
#define VNODE_ATTR_va_access_time 29//?
#define VNODE_ATTR_va_modify_time 30//?
#define VNODE_ATTR_va_change_time 31//?
#define VNODE_ATTR_va_fileid 32//?
#define VNODE_ATTR_va_fsid 33//?
#define VNODE_ATTR_va_filerev 34//?
#define VNODE_ATTR_va_type 35//?
#define LOOKUP 36//?
#define NOTRIGGER 37//?
#define MAKEENTRY 38//?
#define CREATE 39//?

///////////
enum vtype	{ VNON, VREG, VDIR, VBLK, VCHR, VLNK, VSOCK, VFIFO, VBAD, VSTR,
			  VCPLX };//c

struct vnode_fsparam {
	struct mount * vnfs_mp;//c
	enum vtype	vnfs_vtype;//c
	const char * vnfs_str;//c
	struct vnode * vnfs_dvp;	//c
	void * vnfs_fsnode;//c
	int (**vnfs_vops)(void *);	//c
	int vnfs_markroot;//c
	int vnfs_marksystem;//c
	dev_t vnfs_rdev;//c
	off_t vnfs_filesize;//c
	struct componentname * vnfs_cnp;//c
	uint32_t vnfs_flags;//c
};

struct componentname {
	u_long	cn_flags;//c
	long	cn_namelen;//c
	char	*cn_nameptr;//c
	long	cn_consume;//c
	u_long	cn_nameiop;//c
	char	*cn_pnbuf;//c
	long	cn_pnlen;//c
	u_long	cn_hash;//c
};

struct vnode_attr {
	struct timespec va_access_time;//c
	struct timespec va_modify_time;//c
	struct timespec va_change_time;//c
	uint64_t	va_fileid;//c
	struct timespec	va_create_time;//c
	struct timespec	va_backup_time;//c
	char *	va_name;//c
	dev_t		va_rdev;//c
	uint64_t	va_supported;//c
	uint64_t	va_nlink;//c
	uint64_t	va_data_size;	//c
	uint64_t	va_total_size;//c
	uint32_t	va_iosize;	//c
	uid_t		va_uid;//c
	gid_t		va_gid;//c
	uint32_t	va_flags;//c
	mode_t	va_mode;//c
	uint64_t	va_active;//c
	uint32_t	va_fsid;//c
	enum vtype	va_type;//c
	uint64_t	va_filerev;//c
	uint64_t	va_parentid;//c
	uint32_t	va_gen;//c
	uint32_t	va_encoding;//c
	uint64_t	va_nchildren;//c
	uint64_t	va_data_alloc;//c
};

struct vnodeopv_desc {
	int (***opv_desc_vector_p)(void *);//c
	struct vnodeopv_entry_desc *opv_desc_ops; //c
};//c

struct  vnodeopv_entry_desc {
	struct vnodeop_desc *opve_op;  //c
	int (*opve_impl)(void *);	//c
};//c

struct vattr {
	long		va_fileid;//c
	mode_t	va_mode;//c
	dev_t	va_rdev;//c
};//etc

/////////////
extern int desiredvnodes;//c

errno_t	vnode_create(int, size_t, void  *, vnode_t *);//c
int	vnode_addfsref(vnode_t);//c
uint32_t	vnode_vid(vnode_t);//c
int 	vnode_getwithvid(vnode_t, int);//c
int	vnode_removefsref(vnode_t);//c
mount_t	vnode_mount(vnode_t);//c
int	vnode_isdir(vnode_t);//c
int 	vnode_get(vnode_t);//c
int 	vnode_ref(vnode_t);//c
dev_t	vnode_specrdev(vnode_t);//c
int	vflush(struct mount *mp, struct vnode *skipvp, int flags);//c
void 	vnode_rele(vnode_t);//c
int	vnode_isreg(vnode_t);//c
int 	vnode_put(vnode_t);//c
int	vnode_isnocache(vnode_t);//c
int	vnode_ischr(vnode_t);//c
int	vnode_isvroot(vnode_t);//c
int vn_default_error(void);//c
void *	vnode_fsnode(vnode_t);//c
void	vnode_clearfsnode(vnode_t);//c

#endif //HYS_SYS_VNODE_H
