#ifndef HYS_SYS_VNODE_IF_H
#define HYS_SYS_VNODE_IF_H

struct vnop_lookup_args {
	vnode_t a_dvp;//c
	vnode_t *a_vpp;//c
	struct componentname * a_cnp;//c
	vfs_context_t a_context;//c
};

struct vnop_close_args {
	vnode_t a_vp;//c
	int a_fflag;//c
	vfs_context_t a_context;//c
};

struct vnop_open_args {
	vnode_t a_vp;//c
	int a_mode;//c
	vfs_context_t a_context;//c
};

struct vnop_getattr_args {
	vnode_t a_vp;//c
	struct vnode_attr *a_vap;//c
	vfs_context_t a_context;//c
};

struct vnop_reclaim_args {
	vnode_t a_vp;//c
	vfs_context_t a_context;//c
};

struct vnop_readdir_args {
	vnode_t a_vp;//c
	struct uio * a_uio;//c
	int a_flags;//c
	int *a_eofflag;//c
	int *a_numdirent;//c
	vfs_context_t a_context;//c
};

struct vnop_offtoblk_args {
	vnode_t a_vp;//c
	off_t a_offset;//?
	daddr64_t *a_lblkno;//c
};

struct vnop_pagein_args {
	vnode_t a_vp;//c
	upl_t  a_pl;//c
	vm_offset_t  a_pl_offset;//c
	off_t a_f_offset;//c
	size_t a_size;//c
	int a_flags;//c
	vfs_context_t a_context;//c
};

struct vnop_pathconf_args {
	vnode_t a_vp;//c
	int a_name;//c
	register_t *a_retval;//c
	vfs_context_t a_context;//c
};

struct  vnop_mmap_args {
	vnode_t a_vp;//c
	int a_fflags;//c
	vfs_context_t a_context;//c
};

struct vnop_mnomap_args {
	vnode_t a_vp;//c
	vfs_context_t a_context;//c
};

struct vnop_read_args {
	vnode_t a_vp;//c
	struct uio *a_uio;//c
	int a_ioflag;//c
	vfs_context_t a_context;//c
};

struct vnop_blktooff_args {
	vnode_t a_vp;//c
	daddr64_t a_lblkno;//c
	off_t * a_offset;//c
};

struct vnop_strategy_args {
	struct buf *a_bp;//c
};

struct vnop_blockmap_args {
	vnode_t a_vp;//c
	off_t a_foffset;//c
	size_t a_size;//c
	daddr64_t * a_bpn;//c
	size_t* a_run;//c
	void* a_poff;//c
	int a_flags;//c
	vfs_context_t a_context;//c
};

struct vnop_listxattr_args {
	vnode_t a_vp;//c
	uio_t a_uio;//c
	size_t* a_size;//c
	int a_options;//c
	vfs_context_t a_context;//c
};

struct vnop_getxattr_args {
	vnode_t a_vp;//c
	const char * a_name;//c
	uio_t a_uio;//c
	size_t* a_size;//c
	int a_options;//?c\
	vfs_context_t a_context;//c
};

struct vnop_setattr_args {
	vnode_t a_vp;//c
	struct vnode_attr *a_vap;//c
};
struct vnop_readlink_args {
	vnode_t a_vp;//c
	struct uio *a_uio;//c
};
struct vnop_setxattr_args {
	vnode_t a_vp;//c
	uio_t a_uio;//c
	const char * a_name;//c
	int a_options;//c
};
struct vnop_removexattr_args {
	vnode_t a_vp;//c
	const char * a_name;//c
};
struct vnop_inactive_args {
	vnode_t a_vp;//c
};
struct vnop_kqfilt_add_args {
	struct vnode *a_vp;//c
	struct knote *a_kn;//c
};

struct vnop_kqfilt_remove_args {};

struct vnop_fsync_args {};

struct vnop_remove_args {};

struct vnop_rmdir_args {};

//////////////

extern struct vnodeop_desc vnop_close_desc;//c
extern struct vnodeop_desc vnop_default_desc;//c
extern struct vnodeop_desc vnop_open_desc;//c
extern struct vnodeop_desc vnop_lookup_desc;//c
extern struct vnodeop_desc vnop_exchange_desc;//c
extern struct vnodeop_desc vnop_access_desc;//c
extern struct vnodeop_desc vnop_getxattr_desc;//c
extern struct vnodeop_desc vnop_blockmap_desc;//c
extern struct vnodeop_desc vnop_strategy_desc;//c
extern struct vnodeop_desc vnop_readdir_desc;//c
extern struct vnodeop_desc vnop_reclaim_desc;//c
extern struct vnodeop_desc vnop_mmap_desc;//c
extern struct vnodeop_desc vnop_pagein_desc;//c
extern struct vnodeop_desc vnop_blktooff_desc;//c
extern struct vnodeop_desc vnop_getattr_desc;//c
extern struct vnodeop_desc vnop_listxattr_desc;//c
extern struct vnodeop_desc vnop_mnomap_desc;//c
extern struct vnodeop_desc vnop_offtoblk_desc;//c
extern struct vnodeop_desc vnop_pathconf_desc;//c
extern struct vnodeop_desc vnop_read_desc;//c
extern struct vnodeop_desc vnop_setattr_desc;//c
extern struct vnodeop_desc vnop_fsync_desc;//c
extern struct vnodeop_desc vnop_readlink_desc;//c
extern struct vnodeop_desc vnop_setxattr_desc;//c
extern struct vnodeop_desc vnop_removexattr_desc;//c
extern struct vnodeop_desc vnop_inactive_desc;//c
extern struct vnodeop_desc vnop_kqfilt_add_desc;//c
extern struct vnodeop_desc vnop_kqfilt_remove_desc;//c
extern struct vnodeop_desc vnop_remove_desc;//c
extern struct vnodeop_desc vnop_rmdir_desc;//c

extern errno_t VNOP_READ(vnode_t, struct uio *, int, vfs_context_t);//c
extern errno_t VNOP_IOCTL(vnode_t, u_long, caddr_t, int, vfs_context_t);//c

#endif //HYS_SYS_VNODE_IF_H
