
#ifndef _IOKIT_IOCATALOGUE_H
#define _IOKIT_IOCATALOGUE_H

#include <libkern/c++/OSObject.h>
#include <libkern/c++/OSCollectionIterator.h>
#include <libkern/c++/OSArray.h>
#include <libkern/c++/OSDictionary.h>
#include <IOKit/IOLocks.h>
#include <sys/cdefs.h>

#include <IOKit/IOKitServer.h>

class IOService;
class IOCatalogue : public OSObject
{
    OSDeclareDefaultStructors(IOCatalogue)

private:
private:
public:
/*addExtensionsFromArchive


Records an archive of extensions, as from device ROM. 

This function is currently for internal use. Kernel extensions should never call it. 

public

virtual bool addExtensionsFromArchive(
    OSData *mkext); 
Parameters
mkext
An OSData object containing a multikext archive.
Return Value

Returns true if mkext was properly unserialized and its contents recorded, false if not.*/
virtual bool addExtensionsFromArchive(
    OSData *mkext); 

};

__BEGIN_DECLS
__END_DECLS

/*(gIOCatalogue


Deprecated API. 

See Also:
IOKitRelocStart
IOKitRelocStop
gIOClassKey
gIOProbeScoreKey
IOKitRelocStop
extern IOCatalogue * gIOCatalogue;  */
extern IOCatalogue * gIOCatalogue;

#endif // _IOKIT_IOCATALOGUE_H 
