#ifndef _IOKIT_IOFILTERINTERRUPTEVENTSOURCE_H
#define _IOKIT_IOFILTERINTERRUPTEVENTSOURCE_H

#include <IOKit/IOInterruptEventSource.h>

#ifdef _APPLEK2SATA_
class IOPMrootDomain;
#endif

class IOService;
class IOFilterInterruptEventSource : public IOInterruptEventSource
{
  OSDeclareDefaultStructors(IOFilterInterruptEventSource)
private:

public:

//#include <HYS/IOKit/IOFilterInterruptEventSource_IOFilterInterruptEventSource.h>

/*Filter


public

typedef bool ( *Filter)(
    OSObject *,
    IOFilterInterruptEventSource *); 
Parameters
owner
Pointer to the owning/client instance.
sender
Where is the interrupt comming from.
Return Value

false if this interrupt can be ignored. 
Discussion 

C Function pointer to a routine to call when an interrupt occurs.*/
typedef bool ( *Filter)(
    OSObject *,
    IOFilterInterruptEventSource *); 

/*signalInterrupt


Cause the work loop to schedule the action. 

public

virtual void signalInterrupt(); 
Discussion 

Cause the work loop to schedule the interrupt action even if the filter routine returns 'false'. Note well the interrupting condition MUST be cleared from the hardware otherwise an infinite process interrupt loop will occur. Use this function when 'SoftDMA' is desired. See IOFilterInterruptSource::Filter*/
virtual void signalInterrupt(); 

/*filterInterruptEventSource


Factor method to create and initialise an IOFilterInterruptEventSource. See init. 

public

static IOFilterInterruptEventSource * filterInterruptEventSource(
    OSObject *owner, 
    IOInterruptEventSource::Action action, 
    Filter filter, 
    IOService *provider, 
    int intIndex = 0); 
Parameters
owner
Owner/client of this event source.
action
'C' Function to call when something happens.
filter
'C' Function to call when interrupt occurs.
provider
Service that provides interrupts.
intIndex
Defaults to 0.
Return Value

a new event source if succesful, 0 otherwise.*/
static IOFilterInterruptEventSource * filterInterruptEventSource(
    OSObject *owner, 
    IOInterruptEventSource::Action action, 
    Filter filter, 
    IOService *provider, 
    int intIndex = 0); 

};

#endif 
