#ifndef IOTYPES_H
#define IOTYPES_H

#if KERNEL
#include <IOKit/system.h>
#else
#include <mach/message.h>
#include <mach/vm_types.h>
#endif

#include <IOKit/IOReturn.h>

//#ifndef __MACTYPES__	/* CF MacTypes.h */
//#ifndef __TYPES__	/* guess... Mac Types.h */

#include <stdbool.h>
#include <libkern/OSTypes.h>

//#endif /* __TYPES__ */
//#endif /* __MACTYPES__ */

//#if KERNEL
#include <libkern/OSBase.h>
//#endif

#include <HYS/IOKit/IOTypes.h>

#ifdef __cplusplus
extern "C" {
#endif

/*Scale Factors


enum { 
    kNanosecondScale = 1, 
    kMicrosecondScale = 1000, 
    kMillisecondScale = 1000 * 1000, 
    kSecondScale = 1000 * 1000 * 1000, 
    kTickScale = (
        kSecondScale / 100) 
};  
Constants
kNanosecondScale
Scale factor for nanosecond based times.
kMicrosecondScale
Scale factor for microsecond based times.
kMillisecondScale
Scale factor for millisecond based times.
kTickScale
Scale factor for the standard (100Hz) tick.
kSecondScale
Scale factor for second based times.
Discussion 

Used when a scale_factor parameter is required to define a unit of time.*/

enum { 
    kNanosecondScale = 1, 
    kMicrosecondScale = 1000, 
    kMillisecondScale = 1000 * 1000, 
    kSecondScale = 1000 * 1000 * 1000, 
    kTickScale = (
        kSecondScale / 100) 
};  

/*Object Reference-Counting and Introspection
FunctionsintheIOKitLibcommunicatewithin-kernelobjectsusingtheMachporttransportmechanism
to cross the user-kernel boundary. The file
IOTypes.h
, located in the I/O Kit framework, defines the
objects you use with IOKitLib functions to communicate with such in-kernel entities as I/O Registry
Object Reference-Counting and Introspection
43
2007-02-08 | © 2001, 2007 Apple Inc. All Rights Reserved.
C H A P T E R
4
The IOKitLib APIPage 44

entries (objects of class IORegistryEntry) or iterators (objects of class IOIterator). Notice in Listing
4-1 (page 44), however, that
IOTypes.h
seems to define all these objects in the same way, specifically,
as
mach_port_t
objects (
mach_port_t
is defined in
mach/port.h
in the Kernel framework).
Listing 4-1
Object definitions in IOTypes.h
typedef mach_port_t io_object_t;
typedef io_object_t io_connect_t;
typedef io_object_t io_iterator_t;
typedef io_object_t io_registry_entry_t;
typedef io_object_t io_service_t;
typedef io_object_t io_enumerator_t;
To understand why this is so, recall that a Mach port is the communication transport mechanism an
application uses to communicate with the I/O Kit. As far as the kernel is concerned, every time your
application communicates with any in-kernel object using one of the object types defined in
IOTypes.h
,
it’s using the same generic mechanism (namely, a Mach port) to cross the user-kernel boundary.
From the application’s point of view, however, the transport mechanism is unimportant and what
matters is the type of object on the other side of the port. The fact that an
io_iterator_t
object, for
example, encapsulates the association of a Mach port with an in-kernel IOIterator object is not as
important to the application as the fact that an
io_iterator_t
object refers to an in-kernel object that
knows how to iterate over the I/O Registry.
The
io_object_t
objects in user space not only refer to the in-kernel objects, they also reflect the
in-kernel C++ class hierarchy. Because IOService is a subclass of IORegistryEntry, for example, you
can use an
io_service_t
object with any IOKitLib function that expects an
io_registry_entry_t
object, such as
IORegistryEntryGetPath
.
With few exceptions (such as getting the I/O Kit master port to initiate communication with the I/O
Kit and reference-counting of the
io_object_t
objects themselves) you should not concern yourself
with the cross-boundary communication mechanism. Rather, you should focus on the specific in-kernel
object you are working with, making sure you use each object type appropriately*/

#ifndef	__IOKIT_PORTS_DEFINED__
#define __IOKIT_PORTS_DEFINED__
typedef mach_port_t io_object_t;
#endif//__IOKIT_PORTS_DEFINED__

/*Listing 4-1  Object definitions in IOTypes.htypedef mach_port_t io_object_t;
 
typedef io_object_t io_connect_t;
typedef io_object_t io_iterator_t;
typedef io_object_t io_registry_entry_t;
typedef io_object_t io_service_t;
typedef io_object_t io_enumerator_t;


To understand why this is so, recall that a Mach port is the communication transport mechanism an application uses to communicate with the I/O Kit. As far as the kernel is concerned, every time your application communicates with any in-kernel object using one of the object types defined in IOTypes.h, it’s using the same generic mechanism (namely, a Mach port) to cross the user-kernel boundary. 

From the application’s point of view, however, the transport mechanism is unimportant and what matters is the type of object on the other side of the port. The fact that an io_iterator_t object, for example, encapsulates the association of a Mach port with an in-kernel IOIterator object is not as important to the application as the fact that an io_iterator_t object refers to an in-kernel object that knows how to iterate over the I/O Registry.

The io_object_t objects in user space not only refer to the in-kernel objects, they also reflect the in-kernel C++ class hierarchy. Because IOService is a subclass of IORegistryEntry, for example, you can use an io_service_t object with any IOKitLib function that expects an io_registry_entry_t object, such as IORegistryEntryGetPath.

With few exceptions (such as getting the I/O Kit master port to initiate communication with the I/O Kit and reference-counting of the io_object_t objects themselves) you should not concern yourself with the cross-boundary communication mechanism. Rather, you should focus on the specific in-kernel object you are working with, making sure you use each object type appropriately.*/

typedef io_object_t io_connect_t;
typedef io_object_t io_iterator_t;
typedef io_object_t io_registry_entry_t;
typedef io_object_t io_service_t;
typedef io_object_t io_enumerator_t;
	

#ifdef __cplusplus
}
#endif


#endif//IOTYPES_H
