
#ifndef __OPEN_SOURCE__
#endif


#ifndef _IOATABUSCOMMAND_H
#define _IOATABUSCOMMAND_H

#include <IOKit/IOTypes.h>
#include "IOATATypes.h"
#include "IOATACommand.h"
#include <IOKit/IOSyncer.h>

#include <HYS/IOKit/ata/IOATABusCommand.h>

class IOATABusCommand : public IOATACommand,public IOATABusCommand_HYS
 {

	OSDeclareDefaultStructors( IOATABusCommand )
	
public:

/*getUnit


Returns the unit ID (0 master, 1 slave). 

public

virtual ataUnitID getUnit(
    void ); */
virtual ataUnitID getUnit(
    void );

/*getPacketData


Returns pointer to the array of packet data. 

public

virtual UInt16* getPacketData(
    void); */
virtual UInt16* getPacketData(
    void); 
/*getPacketSize


Returns the size of ATAPI packet if any. 

public

virtual UInt16 getPacketSize(
    void); */
virtual UInt16 getPacketSize(
    void);

/*getBuffer


Gets pointer to the memory descriptor for this transaction. 

public

virtual IOMemoryDescriptor* getBuffer (
    void); */
virtual IOMemoryDescriptor* getBuffer (
    void); 

/*getRegMask


Gets the register mask for desired regs 

public

virtual ataRegMask getRegMask(
    void ); */

virtual ataRegMask getRegMask(
    void );

/*getTimeoutMS


Returns the timeout value for this command. 

public

virtual UInt32 getTimeoutMS (
    void ); */
virtual UInt32 getTimeoutMS (
    void );

/*getTaskFilePtr


Returns the taskfile structure pointer. 

public

virtual ataTaskFile* getTaskFilePtr(
    void); */
virtual ataTaskFile* getTaskFilePtr(
    void); 

/*setCommandInUse


Marks the command as being in progress. 

public

virtual void setCommandInUse(
    bool inUse = true); */
virtual void setCommandInUse(
    bool inUse = true);

/*getOpcode


Returns the command opcode. 

public

virtual ataOpcode getOpcode(
    void ); */
virtual ataOpcode getOpcode(
    void );

/*getFlags


Returns the flags for this command. 

public

virtual ataFlags getFlags (
    void ); */
virtual ataFlags getFlags (
    void ); 

/*getPosition


Gets the position within the memory buffer for the transaction. 

public

virtual IOByteCount getPosition (
    void); */

virtual IOByteCount getPosition (
    void); 

/*getByteCount


Returns the byte count for this transaction to transfer. 

public

virtual IOByteCount getByteCount (
    void); */

virtual IOByteCount getByteCount (
    void); 

/*executeCallback


Calls the completion callback function. 

public

virtual void executeCallback(
    void); */

virtual void executeCallback(
    void); 

/*setResult


Sets the result code. 

public

virtual void setResult(
    IOReturn ); */
virtual void setResult(
    IOReturn );

private:
};

#include <IOKit/IODMACommand.h>

class IOATABusCommand64 : public IOATABusCommand,public IOATABusCommand64_HYS
{

	OSDeclareDefaultStructors( IOATABusCommand64 )
	
	public:
	protected:
};

#endif /*_IOATABUSCOMMAND_H*/
