
#ifndef __OPEN_SOURCE__
#endif


#ifndef _IOATABUSINFO_H
#define _IOATABUSINFO_H

#include <libkern/c++/OSObject.h>
#include <IOKit/IOTypes.h>
#include "IOATATypes.h"

class IOATABusInfo : public OSObject
{
	OSDeclareDefaultStructors( IOATABusInfo )
	
public:

/*getSocketType


Returns the socket type, internal fixed, media-bay, PC-Card. 

public

ataSocketType getSocketType(
    void ); 
Discussion 

This method is used by clients of ATAControllers to find out about the bus.*/
ataSocketType getSocketType(
    void ); 

/*atabusinfo


Factory method. 

public

static IOATABusInfo* atabusinfo(
    void); */
static IOATABusInfo* atabusinfo(
    void); 

/*setMaxBlocksExtended


Sets the maximum number of blocks allowed in a single transfer of data. 

public

void setMaxBlocksExtended(
    UInt16 inMaxBlocks); 
Discussion 

Set by controllers, this indicates the maximum number of blocks allowed in a single transfer of data. Some dma engines may not be capable of supporting the full 16-bit worth of sector count allowed under 48 bit extended LBA. Default is 256 blocks, same as standard ATA.*/

void setMaxBlocksExtended(
    UInt16 inMaxBlocks); 

/*setExtendedLBA


Sets true for support of 48-bit LBA. 

public

void setExtendedLBA(
    bool inState ); 
Discussion 

Set by ATAControllers.*/

void setExtendedLBA(
    bool inState ); 

/*setUltraModes


Sets bit-significant map of supported transfer modes. 

public

void setUltraModes(
    UInt8 inModeBitMap ); 
Discussion 

Set by ATAControllers.*/

void setUltraModes(
    UInt8 inModeBitMap ); 

/*setDMAModes


Sets bit-significant map of supported transfer modes. 

public

void setDMAModes(
    UInt8 inModeBitMap ); 
Discussion 

Set by ATAControllers.*/
void setDMAModes(
    UInt8 inModeBitMap ); 

/*setPIOModes


Sets bit-significant map of supported transfer modes. 

public

void setPIOModes(
    UInt8 inModeBitMap); 
Discussion 

Set by ATAControllers.*/
void setPIOModes(
    UInt8 inModeBitMap); 

/*setUnits


Sets how many devices are on this bus. 

public

void setUnits(
    UInt8 inNumUnits ); 
Discussion 

Set by ATAControllers.*/
void setUnits(
    UInt8 inNumUnits ); 

/*zeroData


Sets this object to a blank state. 

public

virtual void zeroData(
    void); */
virtual void zeroData(
    void);


/*setSocketType


Sets socket type. 

public

void setSocketType(
    ataSocketType inSocketType ); 
Discussion 

Set by ATAControllers: internal fixed, media-bay, PC-Card.*/
void setSocketType(
    ataSocketType inSocketType ); 

protected:
private:
};






#endif /* !_IOATABUSINFO_H */
