
#ifndef __OPEN_SOURCE__
#endif
 
 
#ifndef _IOATACONTROLLER_H
#define _IOATACONTROLLER_H

#include <IOKit/IOTypes.h>
#include <IOKit/IOCommandGate.h>
#include <IOKit/IOService.h>
#include <IOKit/IOWorkLoop.h>
#include "ATATimerEventSource.h"

#include <IOKit/ata/IOATATypes.h>//IOATARegPtr8

class IOATADevice;
class IOATABusCommand;
class IOATABusInfo;
class IOATADevConfig;

#include <HYS/IOKit/ata/IOATAController.h>

class IOATAController : public IOService,public IOATAController_HYS
{
    OSDeclareDefaultStructors(IOATAController)


protected://data
    struct ExpansionData { };
    ExpansionData *reserved;


IOATAController__doubleBuffer
IOATAController__cmdGate

protected://func

/*busCanDispatch


Answers whether the bus is in state such that the next command can be dispatched. 

protected

virtual bool busCanDispatch(
    void ); 
Return Value

Returns true if bus is free to issue commands. Returns false if bus cannot issue commands at this time.*/
virtual bool busCanDispatch(
    void ); 

/*dispatchNext


Causes the command at the front of the queue to dequeue, made the current command and begin execution. 

protected

virtual IOReturn dispatchNext(
    void ); 
Return Value

Returns noErr if successful dispatch.*/

virtual IOReturn dispatchNext(
    void ); 

/*handleCommand


Handles the client command from the workloop context. 

protected

virtual IOReturn handleCommand(
    void *command, 
    void *param1 = 0, 
    void *param2 = 0, 
    void *param3 = 0); 
Parameters
client
The client object.
command
The command code.
param0
Command parameter.
param1
Command parameter.
param2
Command parameter.
param3
Command parameter.
Return Value

Returns kIOReturnSuccess on success, or an error code otherwise. 
Discussion 

This method is called by executeCommand() to handle the client command from the workloop context.*/
virtual IOReturn handleCommand(
    void *command, 
    void *param1 = 0, 
    void *param2 = 0, 
    void *param3 = 0); 

private:
public:
IOATAController_determineATAPIState
IOATAController_scanForDrive 
IOATAController_synchronousIO
IOATAController_bitSigToNumeric
IOATAController_dequeueFirstCommand 
IOATAController_ATAPISlaveExists
IOATAController_completeIO
IOATAController_handleDeviceInterrupt 
IOATAController_issueCommand 
IOATAController_selectDevice
IOATAController_handleExecIO
IOATAController_executeEventCallouts
IOATAController_startTimer
IOATAController_stopTimer 
IOATAController_handleTimeout
IOATAController_asyncStatus 
IOATAController_checkTimeout 
IOATAController_executeCommand 
IOATAController_asyncData
IOATAController_asyncCommand 
IOATAController_waitForU8Status
IOATAController_softResetBus

};
#endif /* !_IOATACONTROLLER_H */
