

#ifndef _IOATATYPES_H
#define _IOATATYPES_H

#include <IOKit/IOTypes.h>


#ifdef __ppc__
	#ifdef __i386__
		#undef __i386__
		#define OC__i386
	#endif

	#include <HYS/IOKit/ata/IOATATypes.h>

#elif defined( __i386__ )
	#include <IOKit/ata/IOATARegI386.h>
#else
	#error Unknown machine architecture
#endif

#include <HYS/IOKit/ata/IOATATypes.h>

/*The ATADevInfo structure holds information about a specific ATA device on a bus. Your

struct ATADevInfo {
    UInt8                           devType;
    SInt8                           devID;
};
typedef struct ATADevInfo ATADevInfo;
 
enum {
    kATAInvalidDeviceID         = -1,
    kATADevice0DeviceID         =  0,
    kATADevice1DeviceID         =  1
};




The fields have the following meaning:
devType
Your AIM must set this field to indicate the type of the attached device. Possible ATA device types are listed in "ATA.h" (current kATADeviceUnknown, kATADeviceATA, kATADeviceATAPI, and kATADeviceReserved).
devID
Your AIM must set this field to indicate the ATA device ID of the attached device. Possible device IDs are kATAInvalidDeviceID, kATADevice0DeviceID and kATADevice1DeviceID.

If your AIM wants to indicate that no ATA device is attach, it must set devType to kATADeviceUnknown and devID to kATAInvalidDeviceID.

If your AIM initialization routine returns an error, or it indicates that there are no devices on the bus, ATA Manager fails the request to register the ATA bus, unloads your AIM, and dispose of all references to it.*/
enum ataUnitID{
    kATAInvalidDeviceID         = -1,
    kATADevice0DeviceID         =  0,
    kATADevice1DeviceID         =  1
};

/*setLBA28


Convenience method that sets the taskfile registers into a 28-bit LBA address, with unit selected and LBA bit set. 

public

virtual IOReturn setLBA28(
    UInt32 lba,
    ataUnitID inUnit); 
Discussion 

This method returns err if param out of range; returns kIOSuccess (kATANoErr) = 0 on return if successful.*/
enum {
kATANoErr=0
};

#endif /* !_IOATATYPES_H */
