#ifndef _IOAUDIODEFINES_H
#define _IOAUDIODEFINES_H

#include <HYS/IOKit/audio/IOAudioDefines.h>

/*kIOAudioControlChannelNameLeft


The value for the kIOAudioControlChannelNameKey in the IORegistry representing the channel name for the left channel. 

#define kIOAudioControlChannelNameLeft "Left" */
#define kIOAudioControlChannelNameLeft "Left" 

/*kIOAudioControlChannelNameAll


The value for the kIOAudioControlChannelNameKey in the IORegistry representing the channel name for all channels. 

#define kIOAudioControlChannelNameAll "All Channels" */
#define kIOAudioControlChannelNameAll "All Channels" 

/*kIOAudioControlChannelNameRight


The value for the kIOAudioControlChannelNameKey in the IORegistry representing the channel name for the right channel. 

#define kIOAudioControlChannelNameRight "Right" */
#define kIOAudioControlChannelNameRight "Right" 

/*kIOAudioDeviceNameKey


The key in the IORegistry for the IOAudioDevice name attribute. 

#define kIOAudioDeviceNameKey "IOAudioDeviceName" */
#define kIOAudioDeviceNameKey "IOAudioDeviceName" 

/*kIOAudioControlTypeKey


The key in the IORegistry for the IOAudioCntrol type attribute.

#define kIOAudioControlTypeKey "IOAudioControlType" 
Discussion 

The value of this text attribute may be defined by the driver, however system-defined types recognized by the upper-level software are "Level", "Mute", "Selector"*/

#define kIOAudioControlTypeKey "IOAudioControlType" 

/*kIOAudioControlChannelNameKey


The key in the IORegistry for the IOAudioControl name attribute.

#define kIOAudioControlChannelNameKey "IOAudioControlChannelName" 
Discussion 

This name should be a human-readable name for the channel(s) represented by the port. *** NOTE *** We really need to make all of the human-readable attributes that have potential to be used in a GUI localizable. There will need to be localized strings in the kext bundle matching the text*/
#define kIOAudioControlChannelNameKey "IOAudioControlChannelName" 

/*kIOAudioControlValueIsReadOnlyKey


The key in the IORegistry for the IOAudioControl value-is-read-only attribute.

#define kIOAudioControlValueIsReadOnlyKey "IOAudioControlValueIsReadOnly" 
Discussion 

The value returned by this key is a 32-bit integer but the value doesn't have any direct meaning. Instead, the presence of this key indicates that the value for the control is read-only*/
#define kIOAudioControlValueIsReadOnlyKey "IOAudioControlValueIsReadOnly" 

/*kIOAudioControlValueKey


The key in the IORegistry for the IOAudioControl value attribute.

#define kIOAudioControlValueKey "IOAudioControlValue" 
Discussion 

The value returned by this key is a 32-bit integer representing the current value of the IOAudioControl.*/
#define kIOAudioControlValueKey "IOAudioControlValue" 

/*kIOAudioControlChannelIDKey


The key in the IORegistry for the IOAudioControl channel ID attribute

#define kIOAudioControlChannelIDKey "IOAudioControlChannelID" 
Discussion 

The value for this key is an integer which may be driver defined. Default values for common channel types are provided in the following defines.*/
#define kIOAudioControlChannelIDKey "IOAudioControlChannelID" 

/*kIOAudioSampleRateKey


The key in the IORegistry for the IOAudioEngine sample rate attribute

#define kIOAudioSampleRateKey "IOAudioSampleRate" 
Discussion 

This value is represented as an integer in samples per second.*/
#define kIOAudioSampleRateKey "IOAudioSampleRate" 

/*kIOAudioStreamSampleLatencyKey


The key in the IORegistry for the IOAudioStream output sample latency key

#define kIOAudioStreamSampleLatencyKey "IOAudioStreamSampleLatency" 
Discussion 

Tells the HAL how much latency is on a particular stream. If two streams on the same engine have different latencies (e.g. one is analog, one is digital), then set this property on both streams to inform the HAL of the latency differences. Alternately, you can set the engine latency, and just include the latency additional to that for the particular stream. The HAL will add the engine and stream latency numbers together to get the total latency.*/
#define kIOAudioStreamSampleLatencyKey "IOAudioStreamSampleLatency" 

/*kIOAudioStreamDirectionKey


The key in the IORegistry for the IOAudioStream direction attribute.

#define kIOAudioStreamDirectionKey "IOAudioStreamDirection" 
Discussion 

The value for this key may be either "Output" or "Input".*/
#define kIOAudioStreamDirectionKey "IOAudioStreamDirection" 

/*kIOAudioDeviceManufacturerNameKey


The key in the IORegistry for the IOAudioDevice manufacturer name attribute. 

#define kIOAudioDeviceManufacturerNameKey "IOAudioDeviceManufacturerName" */
#define kIOAudioDeviceManufacturerNameKey "IOAudioDeviceManufacturerName" 

/*kIOAudioLevelControlMinValueKey


The key in the IORegistry for the IOAudioControl minimum value attribute.

#define kIOAudioLevelControlMinValueKey "IOAudioLevelControlMinValue" 
Discussion 

The value returned by this key is a 32-bit integer representing the minimum value for the IOAudioControl. This is currently only valid for Level controls or other driver-defined controls that have a minimum and maximum value.*/
#define kIOAudioLevelControlMinValueKey "IOAudioLevelControlMinValue" 

/*IOAudioLevelControlMaxValueKey


The key in the IORegistry for the IOAudioControl maximum value attribute.

#define kIOAudioLevelControlMaxValueKey "IOAudioLevelControlMaxValue" 
Discussion 

The value returned by this key is a 32-bit integer representing the maximum value for the IOAudioControl. This is currently only valid for Level controls or other driver-defined controls that have a minimum and maximum value.*/
#define kIOAudioLevelControlMaxValueKey "IOAudioLevelControlMaxValue" 

/*kIOAudioLevelControlMinDBKey


The key in the IORgistry for the IOAudioControl minimum db value attribute.

#define kIOAudioLevelControlMinDBKey "IOAudioLevelControlMinDB" 
Discussion 

The value returned by this key is a fixed point value in 16.16 format represented as a 32-bit integer. It represents the minimum value in db for the IOAudioControl. This value matches the minimum value attribute. This is currently valid for Level controls or other driver-defined controls that have a minimum and maximum db value.*/
#define kIOAudioLevelControlMinDBKey "IOAudioLevelControlMinDB" 

/*kIOAudioLevelControlMaxDBKey


The key in the IORgistry for the IOAudioControl maximum db value attribute.

#define kIOAudioLevelControlMaxDBKey "IOAudioLevelControlMaxDB" 
Discussion 

The value returned by this key is a fixed point value in 16.16 format represented as a 32-bit integer. It represents the maximum value in db for the IOAudioControl. This value matches the maximum value attribute. This is currently valid for Level controls or other driver-defined controls that have a minimum and maximum db value.*/
#define kIOAudioLevelControlMaxDBKey "IOAudioLevelControlMaxDB" 

/*kIOAudioEngineStateKey


The key in the IORegistry for the IOAudioEngine state atrribute

#define kIOAudioEngineStateKey "IOAudioEngineState" 
Discussion 

The value for this key may be one of: "Running", "Stopped" or "Paused". Currently the "Paused" state is unimplemented.*/
#define kIOAudioEngineStateKey "IOAudioEngineState" 

/*kIOAudioEngineOutputSampleLatencyKey


The key in the IORegistry for the IOAudioEngine output sample latency key

#define kIOAudioEngineOutputSampleLatencyKey "IOAudioEngineOutputSampleLatency" */
#define kIOAudioEngineOutputSampleLatencyKey "IOAudioEngineOutputSampleLatency"

/*kIOAudioPortTypeKey


The key in the IORegistry for the IOAudioPort type attribute.

#define kIOAudioPortTypeKey "IOAudioPortType" 
Discussion 

This is a driver-defined text attribute that may contain any type. Common types are defined as: "Speaker", "Headphones", "Microphone", "CD", "Line", "Digital", "Mixer", "PassThru".*/
#define kIOAudioPortTypeKey "IOAudioPortType" 

/*kIOAudioPortSubTypeKey


The key in the IORegistry for the IOAudioPort subtype attribute.

#define kIOAudioPortSubTypeKey "IOAudioPortSubType" 
Discussion 

The IOAudioPort subtype is a driver-defined text attribute designed to complement the type attribute.*/
#define kIOAudioPortSubTypeKey "IOAudioPortSubType" 

/*kIOAudioPortNameKey


The key in the IORegistry for the IOAudioPort name attribute. 

#define kIOAudioPortNameKey "IOAudioPortName" */
#define kIOAudioPortNameKey "IOAudioPortName" 

#endif /* _IOAUDIODEFINES_H */
