
#ifndef _IOKIT_IOFIREWIREAVCTARGETSPACE_H
#define _IOKIT_IOFIREWIREAVCTARGETSPACE_H

#include <IOKit/IOUserClient.h>
#include <IOKit/IOBufferMemoryDescriptor.h>

#include <IOKit/firewire/IOFWAddressSpace.h>
#include <IOKit/firewire/IOLocalConfigDirectory.h>
#include <IOKit/avc/IOFireWireAVCConsts.h>
#include <IOKit/avc/IOFireWireAVCUserClientCommon.h>

class IOFireWireAVCProtocolUserClient;
class AVCCommandHandlerInfo;
class AVCSubunitInfo;

#include <HYS/IOKit/avc/IOFireWireAVCTargetSpace.h>

class AVCCommandHandlerInfo : public OSObject,public AVCCommandHandlerInfo_HYS
{
    OSDeclareDefaultStructors(AVCCommandHandlerInfo)
public:
};


class AVCSubunitInfo : public OSObject,public AVCSubunitInfo_HYS
{
    OSDeclareDefaultStructors(AVCSubunitInfo)
public:

AVCSubunitInfo_init
AVCSubunitInfo_free

};

class UCInfo : public OSObject,public UCInfo_HYS
{
    OSDeclareDefaultStructors(UCInfo)
public:

};

class AVCConnectionRecord : public OSObject,public AVCConnectionRecord_HYS
{
    OSDeclareDefaultStructors(AVCConnectionRecord)
public:
};

class IOFireWireAVCTargetSpace : public IOFWPseudoAddressSpace,public IOFireWireAVCTargetSpace_HYS
{
    OSDeclareDefaultStructors(IOFireWireAVCTargetSpace)

protected:
private:
public:

IOFireWireAVCTargetSpace_doWrite
IOFireWireAVCTargetSpac_findAVCRequestHandler
IOFireWireAVCTargetSpace_activateWithUser
IOFireWireAVCTargetSpace_deactivateWithUserClient
IOFireWireAVCTargetSpace_pcrModified
IOFireWireAVCTargetSpace_targetSendAVCResponse
IOFireWireAVCTargetSpace_canConnectDestPlug
IOFireWireAVCTargetSpace_subUnitOfTypeCount
IOFireWireAVCTargetSpace_handleConnectCommand
IOFireWireAVCTargetSpace_setSubunitPlugSignalFormat
IOFireWireAVCTargetSpace_connectTargetPlugs
IOFireWireAVCTargetSpace_addSubunit
IOFireWireAVCTargetSpace_installAVCCommandHandler
IOFireWireAVCTargetSpace_getSubunitPlugSignalFormat
IOFireWireAVCTargetSpace_disconnectTargetPlugs
IOFireWireAVCTargetSpace_getSubunitInfo
IOFireWireAVCTargetSpace_handleSignalSourceCommand
IOFireWireAVCTargetSpace_handleConnectionsCommand
IOFireWireAVCTargetSpace_handleOutputPlugSignalFormatCommand
IOFireWireAVCTargetSpace_handleInputPlugSignalFormatCommand
IOFireWireAVCTargetSpace_handleDisconnectCommand
IOFireWireAVCTargetSpace_handlePowerCommand
IOFireWireAVCTargetSpace_handlePlugInfoCommand
IOFireWireAVCTargetSpace_handleSubUnitInfoCommand
IOFireWireAVCTargetSpace_handleUnitInfoCommand
IOFireWireAVCTargetSpace_getTargetPlugConnection

/*init


initializes the IOFireWireAVCTargetSpace object 

public

virtual bool init(
    IOFireWireController *controller); */
virtual bool init(
    IOFireWireController *controller); 

/*publishAVCUnitDirectory


Creates a local AVC Unit directory if it doesn't already exist 

public

virtual IOReturn publishAVCUnitDirectory(
    void); */
virtual IOReturn publishAVCUnitDirectory(
    void);

/*getAVCTargetSpace


returns the IOFireWireAVCTargetSpace object for the given FireWire bus 

public

static IOFireWireAVCTargetSpace *getAVCTargetSpace(
    IOFireWireController *controller); 
Parameters
bus
The FireWire bus*/
static IOFireWireAVCTargetSpace *getAVCTargetSpace(
    IOFireWireController *controller); 

};

#endif /*_IOKIT_IOFIREWIREAVCTARGETSPACE_H */
