
#ifndef __IOCONFIGDIRECTORY_H__
#define __IOCONFIGDIRECTORY_H__

#include <libkern/c++/OSObject.h>
#include <IOKit/IOReturn.h>

#include <IOKit/firewire/IOFireWireFamilyCommon.h>

class OSData;
class OSString;
class OSIterator;
class IOFireWireDevice;

#include <HYS/IOKit/firewire/IOConfigDirectory.h>

class IOConfigDirectory : public OSObject,public IOConfigDirectory_HYS
{
    OSDeclareAbstractStructors(IOConfigDirectory);
private:
protected:
public:

IOConfigDirectory_initWithOffset
IOConfigDirectory_createIterator
IOConfigDirectory_getKeyValue
IOConfigDirectory_getKeyValue_IOConfigDirectory
IOConfigDirectory_getKeyOffset
IOConfigDirectory_getIndexOffset
IOConfigDirectory_getType
IOConfigDirectory_getNumEntries
IOConfigDirectory_getIndexValue_OSData
IOConfigDirectory_getIndexOffset_UInt32
IOConfigDirectory_getIndexValue_OSString
IOConfigDirectory_getIndexValue_IOConfigDirectory

/*getKeySubdirectories


public

virtual IOReturn getKeySubdirectories(
    int key,
    OSIterator *&iterator); 
Parameters
key
type of subdirectory to iterate over
iterator
on return, set to point to an OSIterator
Return Value

kIOReturnSuccess if the iterator could be created 
Discussion 

Creates an iterator over subdirectories of a given type of the directory.*/
virtual IOReturn getKeySubdirectories(
    int key,
    OSIterator *&iterator); 

/*getIndexKey


public

virtual IOReturn getIndexKey(
    int index,
    int &key); 
Parameters
key
on return, set to the key
Return Value

kIOReturnSuccess if the index exists in the dictionary 
Discussion 

Gets the key for entry at the specified index*/
virtual IOReturn getIndexKey(
    int index,
    int &key); 

/*getIndexEntry


public

virtual IOReturn getIndexEntry(
    int index,
    UInt32 &value); 
Parameters
entry
on return, set to the entry value
value
reference to variable to store the entry's value
Return Value

kIOReturnSuccess if the index exists in the dictionary 
Discussion 

Gets the entry at the specified index of the directory, as a raw UInt32.*/
virtual IOReturn getIndexEntry(
    int index,
    UInt32 &value); 

/*getSubdirectories


public

virtual IOReturn getSubdirectories(
    OSIterator *&iterator); 
Parameters
iterator
on return, set to point to an OSIterator
Return Value

kIOReturnSuccess if the iterator could be created 
Discussion 

Creates an iterator over the subdirectories of the directory.*/
virtual IOReturn getSubdirectories(
    OSIterator *&iterator); 

/*getIndexValue


public

virtual IOReturn getIndexValue(
    int index,
    UInt32 &value); 
Parameters
type
on return, set to the data type
value
reference to variable to store the entry's value
Return Value

kIOReturnSuccess if the index exists in the dictionary and is of a type appropriate for the value parameter 
Discussion 

Gets the value at the specified index of the directory, in a variety of forms.*/
virtual IOReturn getIndexValue(
    int index,
    UInt32 &value); 

/*getIndexType


public

virtual IOReturn getIndexType(
    int index,
    IOConfigKeyType &type); 
Parameters
type
on return, set to the data type
Return Value

kIOReturnSuccess if the index exists in the dictionary 
Discussion 

Gets the data type for entry at the specified index*/
virtual IOReturn getIndexType(
    int index,
    IOConfigKeyType &type); 

/*getKeyValue


public

virtual IOReturn getKeyValue(
    int key,
    UInt32 &value,
    OSString ** text = NULL); 
Parameters
value
on return, set to the data type
text
if non-zero, on return points to the string description of the field, or NULL if no text found.
value
reference to variable to store the entry's value
Return Value

kIOReturnSuccess if the key exists in the dictionary and is of a type appropriate for the value parameter 
Discussion 

Gets the value for the specified key, in a variety of forms*/

virtual IOReturn getKeyValue(
    int key,
    UInt32 &value,
    OSString ** text = NULL); 

/*getKeyType


public

virtual IOReturn getKeyType(
    int key,
    IOConfigKeyType &type); 
Parameters
type
on return, set to the data type
Return Value

kIOReturnSuccess if the key exists in the dictionary 
Discussion 

Gets the data type for the specified key*/
virtual IOReturn getKeyType(
    int key,
    IOConfigKeyType &type); 

};

#endif /* __IOCONFIGDIRECTORY_H__ */
