 
#ifndef _IOKIT_IOFWPHYSICALADDRESSSPACE_H
#define _IOKIT_IOFWPHYSICALADDRESSSPACE_H

#include <IOKit/firewire/IOFWAddressSpace.h>
#include <IOKit/IODMACommand.h>


class IOFWPhysicalAddressSpace;

#include <HYS/IOKit/firewire/IOFWPhysicalAddressSpace.h>
class IOFWPhysicalAddressSpaceAux : public IOFWAddressSpaceAux,public IOFWPhysicalAddressSpaceAux_HYS
{
    OSDeclareDefaultStructors(IOFWPhysicalAddressSpaceAux)

	friend class IOFWAddressSpace;
	friend class IOFWPhysicalAddressSpace;
	
protected:
public:
IOFWPhysicalAddressSpaceAux_complete
IOFWPhysicalAddressSpaceAux_getPhysicalSegment
IOFWPhysicalAddressSpaceAux_setDMACommand
IOFWPhysicalAddressSpaceAux_init
IOFWPhysicalAddressSpaceAux_free
IOFWPhysicalAddressSpaceAux_isPrepared
IOFWPhysicalAddressSpaceAux_synchronize
IOFWPhysicalAddressSpaceAux_getSegments
IOFWPhysicalAddressSpaceAux_prepare
IOFWPhysicalAddressSpaceAux_getDMACommand

private:
};

class IOFWPhysicalAddressSpace : public IOFWAddressSpace,public IOFWPhysicalAddressSpace_HYS
{
    OSDeclareDefaultStructors(IOFWPhysicalAddressSpace)

	friend class IOFWPhysicalAddressSpaceAux;

protected:
public:

IOFWPhysicalAddressSpace_createAuxiliary
IOFWPhysicalAddressSpace_free

/*isPrepared


Inspects whether the IODMACommand was prepared in this PhysicalAddressSpace. 

inline bool isPrepared(
    void ) ;
Parameters
none.
Return Value

returns true if prepared, else false*/
bool isPrepared(
    void ) ;

/*synchronize


synchronize the IODMACommand used by this PhysicalAddressSpace. 

inline IOReturn synchronize(
    IOOptionBits options ) ;
Parameters
none.
Return Value

returns kIOReturnSuccess on success*/
 IOReturn synchronize(
    IOOptionBits options ) ;

/*complete

complete the IODMACommand used by this PhysicalAddressSpace. 

inline IOReturn complete(
    void ) ;
Parameters
none.
Return Value

returns kIOReturnSuccess on success*/
IOReturn complete(
    void ) ;

/*prepare


Prepare the IODMACommand used by this PhysicalAddressSpace. 

inline IOReturn prepare(
    void ) ;
Parameters
none.
Return Value

returns kIOReturnSuccess on success*/
IOReturn prepare(
    void ) ;

/*getDMACommand


Get the DMACommand from this PhysicalAddressSpace. 

inline IODMACommand * getDMACommand(
    void ) ;
Parameters
none.
Return Value

return previously assigned IODMACommand, null if not initialized*/
IODMACommand * getDMACommand(
    void ) ;

/*getLength


Get the length of the memory backed by PhysicalAddressSpace. 

UInt64 getLength(
    void );  
Parameters
none.
Return Value

returns the length*/
UInt64 getLength(
    void );  

/*setMemoryDescriptor


Sets the memory descriptor, which will be associated to this PhysicalAddressSpace. 

IOReturn setMemoryDescriptor(
    IOMemoryDescriptor *descriptor );  
Parameters
none.
Return Value

returns the IOMemoryDescriptor*/
IOReturn setMemoryDescriptor(
    IOMemoryDescriptor *descriptor );  

/*initWithDMACommand


Initialize physical address space with IODMACommand. 

virtual bool initWithDMACommand(
    IOFireWireBus *control,
    IODMACommand *command );  
Parameters
bus
Points to IOFireWireBus object.
command
Points to IODMACommand.
Return Value

returns true if success, else false*/
virtual bool initWithDMACommand(
    IOFireWireBus *control,
    IODMACommand *command );  

/*doWrite


A method for processing an address space write request 

virtual UInt32 doWrite(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 len, 
    const void *buf,
    IOFWRequestRefCon refcon);  
Parameters
nodeID
FireWire Write to nodeID.
speed
at this 'speed'.
addr
with FireWire address 'addr'.
len
write 'len' bytes to nodeID.
buf
obtain bytes from location given by 'buf'.
reqrefcon
Can be queried for extra info about the request.
Return Value

UIn32 returns kFWResponseComplete on success*/
virtual UInt32 doWrite(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 len, 
    const void *buf,
    IOFWRequestRefCon refcon);  

/*doRead


A method for processing an address space read request 

virtual UInt32 doRead(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 len, 
    IOMemoryDescriptor **buf,
    IOByteCount *offset, 
    IOFWRequestRefCon refcon);  
Parameters
nodeID
FireWire Read from nodeID.
speed
at this 'speed'.
addr
with FireWire address 'addr'.
len
read 'len' bytes from nodeID.
buf
points to a memory descriptor containing the packet data.
offset
start from this 'offset' in 'buf'.
refcon
Can be queried for extra info about the request.
Return Value

UIn32 returns kFWResponseComplete on success*/
virtual UInt32 doRead(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 len, 
    IOMemoryDescriptor **buf,
    IOByteCount *offset, 
    IOFWRequestRefCon refcon);  

/*setDMACommand


Set the DMACommand for this PhysicalAddressSpace. 

inline void setDMACommand(
    IODMACommand *dma_command ) ;
Parameters
dma_command
Points to IODMACommand object.
Return Value

none*/
void setDMACommand(
    IODMACommand *dma_command ) ;

/*getMemoryDescriptor


Gets the memory descriptor, which is associated to this PhysicalAddressSpace. 

IOMemoryDescriptor * getMemoryDescriptor(
    void );  
Parameters
none.
Return Value

returns the IOMemoryDescriptor*/
IOMemoryDescriptor * getMemoryDescriptor(
    void );  

/*initWithDesc


Initialize physical address space with IOMemoryDescriptor. 

virtual bool initWithDesc(
    IOFireWireBus *bus, 
    IOMemoryDescriptor *mem);  
Parameters
bus
Points to IOFireWireBus object.
mem
Points to IOMemoryDescriptor.
Return Value

returns true if success, else false*/
virtual bool initWithDesc(
    IOFireWireBus *bus, 
    IOMemoryDescriptor *mem);  

/*checkMemoryInRange


Validates the IOMemoryDescriptor, which is used to initialize the PhysicalAddressSpace. 

IOReturn checkMemoryInRange(
    IOMemoryDescriptor *memory );  
Parameters
memory
Points to a valid IOMemoryDescriptor.
Return Value

returns kIOReturnSuccess on success*/
IOReturn checkMemoryInRange(
    IOMemoryDescriptor *memory );  

/*init


Initialize physical address space. 

virtual bool init(
    IOFireWireBus *bus );  
Parameters
bus
Points to IOFireWireBus object.
Return Value

returns true if success, else false*/
virtual bool init(
    IOFireWireBus *bus );  


};

#endif//_IOKIT_IOFWPHYSICALADDRESSSPACE_H
