#ifndef _IOKIT_IOFIREWIRECONTROLLER_H
#define _IOKIT_IOFIREWIRECONTROLLER_H

#include <IOKit/IOEventSource.h>
#include <IOKit/firewire/IOFireWireBus.h>
#include <IOKit/firewire/IOFireWireFamilyCommon.h>
#include <IOKit/firewire/IOFireWireIRMAllocation.h>
#include <IOKit/firewire/IOFWPHYPacketListener.h>

class OSData;
class IOWorkLoop;
class IOEventSource;
class IOFWQEventSource;
class IOTimerEventSource;
class IOMemoryDescriptor;
class IOFireWireController;
class IOFWAddressSpace;
class IOFWPseudoAddressSpace;
class IOFireWireNub;
class IOFireWireDevice;
class IOFireWireDeviceAux;
class IOFireWireUnit;
class IODCLProgram;
class IOLocalConfigDirectory;
class IOFireWireLink;
class IOFireWireSBP2ORB;
class IOFireWireSBP2Login;
class IOFireWireROMCache;
class IOFireWireLocalNode;
class IOFWWorkLoop;
class IOFireWireIRM;
class IOFireWirePowerManager;
class IOFWSimplePhysicalAddressSpace;
class IOFWSimpleContiguousPhysicalAddressSpace;
class IOFWAsyncStreamReceiver;
class IOFWAsyncStreamListener;
class IOFWUserVectorCommand;
class IOFWAsyncPHYCommand;
class IOFWPHYPacketListener;
class IOFWUserPHYPacketListener;

#if FIRELOGCORE
class IOFireLog;
class IOFireLogPublisher;
#endif

#include <HYS/IOKit/firewire/IOFireWireController.h>
class IOFireWireDuplicateGUIDList : public OSObject,public IOFireWireDuplicateGUIDList_HYS
{
    OSDeclareDefaultStructors(IOFireWireDuplicateGUIDList);

private:
protected:
public:
IOFireWireDuplicateGUIDList_removeDuplicateGUID
IOFireWireDuplicateGUIDList_create
IOFireWireDuplicateGUIDList_free
IOFireWireDuplicateGUIDList_addDuplicateGUID
IOFireWireDuplicateGUIDList_findDuplicateGUID

};


class IOFireWireController;

class IOFireWireControllerAux : public IOFireWireBusAux,public IOFireWireControllerAux_HYS
{
    OSDeclareDefaultStructors(IOFireWireControllerAux)

	friend class IOFireWireController;
	
protected:
private:

public://add

IOFireWireControllerAux_init 
IOFireWireControllerAux_free 
IOFireWireControllerAux_createDCLPool 
IOFireWireControllerAux_getMaxRec
IOFireWireControllerAux_createSimpleContiguousPhysicalAddressSpace
IOFireWireControllerAux_getFireWirePhysicalAddressBits
IOFireWireControllerAux_createBufferFillIsochPort
IOFireWireControllerAux_getFireWirePhysicalAddressMask
IOFireWireControllerAux_getFireWirePhysicalBufferMask
IOFireWireControllerAux_getFireWirePhysicalBufferBits
IOFireWireControllerAux_createSimplePhysicalAddressSpace

};

class IOFireWireController : public IOFireWireBus,public IOFireWireController_HYS
{
    OSDeclareAbstractStructors(IOFireWireController)

protected:
	friend class IOFireWireLink;
	friend class IOFWAddressSpace;
	friend class IOFWPseudoAddressSpace;
 	friend class IOFireWireSBP2ORB;
	friend class IOFireWireSBP2Login;
	friend class IOFWLocalIsochPort;
	friend class IOFWCommand;
	friend class IOFireWireDevice;
	friend class IOFireWireDeviceAux;
    friend class IOFireWireUnit;
	friend class IOFireWirePCRSpace;
    friend class IOFireWireROMCache;
    friend class IOFWAsyncStreamCommand;
	friend class IOFWAddressSpaceAux;
	friend class IOFireWireAVCLocalUnit;
	friend class IOFireWireAVCUnit;
    friend class IOFireWireAVCCommand;
	friend class IOFireWirePowerManager;
	friend class IOFWWriteQuadCommand;
	friend class IOFWWriteCommand;
	friend class IOFWCompareAndSwapCommand;
	friend class IOFWAsyncCommand;
	friend class IOFireWireAVCTargetSpace ;
	
#if FIRELOGCORE
	friend class IOFireLog;
#endif

protected:	
public:

IOFireWireController_getGeneration
IOFireWireController_setNodeSpeed_IOFWSpeed
IOFireWireController_hopCount_UInt16
IOFireWireController_getLocalNode
IOFireWireController_deactivatePHYPacketListener
IOFireWireController_releaseIRMBandwidthInGeneration
IOFireWireController_addIRMAllocation
IOFireWireController_removeAllocatedChannel
IOFireWireController_addAllocatedChannel
IOFireWireController_createLocalIsochPort
IOFireWireController_createIsochChannel
IOFireWireController_createDelayedCmd
IOFireWireController_asyncLockResponse
IOFireWireController_getExtendedTCode
IOFireWireController_isCompleteRequest
IOFireWireController_isQuadRequest
IOFireWireController_deactivateAsyncStreamReceivers
IOFireWireController_isLockRequest
IOFireWireController_allocateIRMChannelInGeneration
IOFireWireController_createPHYPacketListener
IOFireWireController_activatePHYPacketListener
IOFireWireController_createIRMAllocation
IOFireWireController_releaseIRMChannelInGeneration
IOFireWireController_getLink
IOFireWireController_getBusPowerManager
IOFireWireController_maxPackLog_UInt16
IOFireWireController_maxPackLog
IOFireWireController_nodeIDtoDevice
IOFireWireController_getIRMNodeID
IOFireWireController_freePseudoAddress
IOFireWireController_allocAddress
IOFireWireController_freeAddress
IOFireWireController_allocatePseudoAddress
IOFireWireController_getAddressSpace
IOFireWireController_createInitialAddressSpace
IOFireWireController_createPseudoAddressSpace
IOFireWireController_removeAsyncStreamListener
IOFireWireController_asyncReadResponse
IOFireWireController_FWSpeed
IOFireWireController_FWSpeed_UInt16
IOFireWireController_clipMaxRec2K
IOFireWireController_removeAsyncStreamReceiver
IOFireWireController_getAsyncStreamReceiver
IOFireWireController_allocAsyncStreamReceiver
IOFireWireController_makeRoot
IOFireWireController_createAsyncStreamListener
IOFireWireController_createPhysicalAddressSpace
IOFireWireController_processPHYPacket
IOFireWireController_processRcvPacket
IOFireWireController_createAsyncPHYCommand
IOFireWireController_createAsyncStreamCommand
IOFireWireController_handleAsyncCompletion
IOFireWireController_handleAsyncTimeout
IOFireWireController_asyncLock_UInt32
IOFireWireController_doWriteSpace
IOFireWireController_createPendingQ
IOFireWireController_destroyPendingQ
IOFireWireController_processTimeout
IOFireWireController_destroyTimeoutQ
IOFireWireController_createTimeoutQ
IOFireWireController_clockTick
IOFireWireController_allocTrans
IOFireWireController_allocTrans_IOFWAsyncCommand
IOFireWireController_getResetTime
IOFireWireController_delayedStateCommandInUse
IOFireWireController_checkProgress
IOFireWireController_enterLoggingMode
IOFireWireController_useHalfSizePackets
IOFireWireController_getWorkLoop
IOFireWireController_getCycleTime
IOFireWireControlle_disableSoftwareBusResets
IOFireWireController_suspendBus
IOFireWireController_init
IOFireWireController_endIOCriticalSection
IOFireWireController_enterBusResetDisabledState
IOFireWireController_createAuxiliary
IOFireWireController_free
IOFireWireController_enableSoftwareBusResets
IOFireWireController_delayedStateChange
IOFireWireController_resetStateChange
IOFireWireController_start
IOFireWireController_getPortNumberFromIndex
IOFireWireController_asyncStreamWrite
IOFireWireController_asyncLock
IOFireWireController_updateDevice
IOFireWireController_updatePlane
IOFireWireController_terminateDevice
IOFireWireController_setPhysicalAccessMode
IOFireWireController_poweredStart
IOFireWireController_requestTerminate
IOFireWireController_initSecurity
IOFireWireController_getBusCycleTime
IOFireWireController_hopCount
IOFireWireController_getCycleTimeAndUpTime
IOFireWireController_finalize
IOFireWireController_stop
IOFireWireController_setPowerState
IOFireWireController_systemWillShutdown
IOFireWireController_processBusReset
IOFireWireController_freeSecurity
IOFireWireController_freeAllAsyncStreamReceiver
IOFireWireController_activateAsyncStreamReceivers
IOFireWireController_resetBus
IOFireWireController_UpdateROM
IOFireWireController_scanningBus
IOFireWireController_beginIOCriticalSection
IOFireWireController_doBusReset
IOFireWireController_startBusScan
IOFireWireController_readDeviceROM
IOFireWireController_readROMGlue
IOFireWireController_physicalAccessProcessBusReset
IOFireWireController_processSelfI
IOFireWireController_closeGate
IOFireWireController_getPendingQ
IOFireWireController_disablePhyPortOnSleepForNodeID
IOFireWireController_processWriteRequest
IOFireWireController_processCycle64Int
IOFireWireController_AssignCycleMaster
IOFireWireController_buildTopology
IOFireWireController_handleARxReqIntComplete
IOFireWireController_doLockSpace
IOFireWireController_AddUnitDirectory
IOFireWireController_RemoveUnitDirectory
IOFireWireController_getRootDir
IOFireWireController_freeTrans
IOFireWireController_asyncRead
IOFireWireController_asyncRead_IOFWReadFlags
IOFireWireController_checkForDuplicateGUID
IOFireWireController_getAfterResetHandledQ
IOFireWireController_nodeMustNotBeRoot
IOFireWireController_setGapCount
IOFireWireController_openGate
IOFireWireController_inGate
IOFireWireController_getTimeoutQ
IOFireWireController_nodeMustBeRoot
IOFireWireController_setNodeIDPhysicalFilter
IOFireWireController_processLockRequest
IOFireWireController_allocateIRMBandwidthInGeneration
IOFireWireController_removeIRMAllocation
IOFireWireController_getLocalNodeID
IOFireWireController_asyncPHYPacket
IOFireWireController_setNodeSpeed
IOFireWireController_setNodeSpeed_UInt16
IOFireWireController_finishedBusScan
IOFireWireController_createDummyRegistryEntry
IOFireWireController_countNodeIDChildren
IOFireWireController_getPhysicalAccessMode
IOFireWireController_isPhysicalAccessEnabledForNodeID
IOFireWireController_findKeyswitchDevice
IOFireWireController_serverKeyswitchCallback
IOFireWireController_setSecurityMode
IOFireWireController_getSecurityMode
IOFireWireController_checkGeneration
IOFireWireController_doReadSpace
IOFireWireController_asyncWrite_UInt32
IOFireWireController_asyncWrite_IOMemoryDescriptor
IOFireWireController_asyncWrite

private:
};

#endif /* ! _IOKIT_IOFIREWIRECONTROLLER_H */
