#ifndef _IOKIT_IOFIREWIREDEVICE_H
#define _IOKIT_IOFIREWIREDEVICE_H

#include <IOKit/firewire/IOFireWireNub.h>

class IOFireWireROMCache;

struct IOFWNodeScan;
struct RomScan;

class IOFireWireDevice;

#include <HYS/IOKit/firewire/IOFireWireDevice.h>
class IOFireWireDeviceAux : public IOFireWireNubAux,public IOFireWireDeviceAux_HYS
{
    OSDeclareDefaultStructors(IOFireWireDeviceAux)

	friend class IOFireWireDevice;
	
protected:
private:
public://add

IOFireWireDeviceAux_getResumeTime
IOFireWireDeviceAux_createSimplePhysicalAddressSpace
IOFireWireDeviceAux_latchResumeTime
IOFireWireDeviceAux_getOpenUnitSet
IOFireWireDeviceAux_free
IOFireWireDeviceAux_createSimpleContiguousPhysicalAddressSpace
IOFireWireDeviceAux_isPhysicalAccessEnabled
IOFireWireDeviceAux_getUnitCount
IOFireWireDeviceAux_setTerminationState
IOFireWireDeviceAux_setMaxSpeed
IOFireWireDeviceAux_setUnitCount
IOFireWireDeviceAux_init
IOFireWireDeviceAux_isTerminated

};

class IOFireWireDevice : public IOFireWireNub,public IOFireWireDevice_HYS
{
    OSDeclareDefaultStructors(IOFireWireDevice)

    friend class IOFireWireController;
	friend class IOFireWireDeviceAux;
protected:
private:
public:

IOFireWireDevice_handleOpen
IOFireWireDevice_handleIsOpen
IOFireWireDevice_matchPropertyTable
IOFireWireDevice_setRegistrationState
IOFireWireDevice_getROMBase
IOFireWireDevice_handleClose
IOFireWireDevice_message
IOFireWireDevice_cacheROM
IOFireWireDevice_processUnitDirectories
IOFireWireDevice_processRootDirectory
IOFireWireDevice_preprocessDirectories
IOFireWireDevice_readUnitDirectories
IOFireWireDevice_configurePhysicalFilter
IOFireWireDevice_readRootDirectory
IOFireWireDevice_processROM
IOFireWireDevice_readROMDirGlue
IOFireWireDevice_readROMThreadFunc
IOFireWireDevice_setNodeROM
IOFireWireDevice_finalize
IOFireWireDevice_attach
IOFireWireDevice_free
IOFireWireDevice_terminateDevice
IOFireWireDevice_createAuxiliary
IOFireWireDevice_configureNode

/*getUnitCount


Returns number of units attached to this device. 

public

inline UInt32 getUnitCount(
    void ) 
Return Value

UInt32 The number of units attached to this device.*/
inline UInt32 getUnitCount(
    void ){};
 
/*clearNodeFlags


Resets the node's characteristics. 

public

virtual void clearNodeFlags(
    UInt32 flags ); 
Parameters
flags
Refer to "node flags" in IOFireWireFamilyCommon.h.*/
virtual void clearNodeFlags(
    UInt32 flags ); 

/*setNodeFlags


Sets the node's characteristics. 

public

virtual void setNodeFlags(
    UInt32 flags ); 
Parameters
flags
Refer to "node flags" in IOFireWireFamilyCommon.h.*/
virtual void setNodeFlags(
    UInt32 flags ); 

/*getNodeFlags


Retrieves the node's characteristics. 

public

virtual UInt32 getNodeFlags(
    void ); 
Parameters
flags
Refer to "node flags" in IOFireWireFamilyCommon.h.
Return Value

UInt32 The flags set for a particular node.*/
virtual UInt32 getNodeFlags(
    void ); 

/*createPhysicalAddressSpace


Creates local physical FireWire address spaces for the device to access. 

public

virtual IOFWPhysicalAddressSpace *createPhysicalAddressSpace(
    IOMemoryDescriptor *mem); 
Parameters
mem
Memory area allocated to back the physical access by Link hardware.
Return Value

A valid IOFWPhysicalAddressSpace object on success; NULL on failure.*/
virtual IOFWPhysicalAddressSpace *createPhysicalAddressSpace(
    IOMemoryDescriptor *mem); 

/*init


Initializes the nub. 

public

virtual bool init(
    OSDictionary *propTable,
    const IOFWNodeScan *scan); 
Parameters
propTable
Property table passed to the standard nub initialization.
scan
Pointer to the node scan structure.
Return Value

Returns true if initialization was successful; false otherwise.*/
virtual bool init(
    OSDictionary *propTable,
    const IOFWNodeScan *scan); 

/*createPseudoAddressSpace


Creates local pseudo FireWire address spaces for the device to access. 

public

virtual IOFWPseudoAddressSpace *createPseudoAddressSpace(
    FWAddress *addr,
    UInt32 len, 
    FWReadCallback reader,
    FWWriteCallback writer,
    void *refcon); 
Parameters
addr
The FireWire address that is mapped to the pseudo address access.
len
Size of the address space to allocate.
reader
Read callback, when the device reads from this address space.
writer
Write callback, when the device writes to this address space.
refcon
Client's callback object returned during reader/writer callbacks.
Return Value

A valid IOFWPseudoAddressSpace object on success; NULL on failure.*/
virtual IOFWPseudoAddressSpace *createPseudoAddressSpace(
    FWAddress *addr,
    UInt32 len, 
    FWReadCallback reader,
    FWWriteCallback writer,
    void *refcon); 

};

#endif /* ! _IOKIT_IOFIREWIREDEVICE_H */
