
#ifndef _IOKIT_HID_IOHIDINTERFACE_H
#define _IOKIT_HID_IOHIDINTERFACE_H

#include <IOKit/IOService.h>
#include <IOKit/hid/IOHIDKeys.h>

#ifdef __cplusplus
class IOHIDDevice;
#endif //__cplusplus

#include <HYS/IOKit/hid/IOHIDInterface.h>

#ifdef __cplusplus

class IOHIDInterface: public IOService,public IOHIDInterface_HYS
{
    OSDeclareDefaultStructors( IOHIDInterface )

private:
protected:
public://data

/*InterruptReportAction


Callback to handle an asynchronous report received from the HID device. 

See Also:
InterruptReportAction
public

typedef void ( *InterruptReportAction)( 
    OSObject *target, 
    AbsoluteTime timestamp, 
    IOMemoryDescriptor *report, 
    IOHIDReportType type, 
    UInt32 reportID, 
    void *refcon); 
Parameters
target
Pointer to your data object.
timestamp
Time when the report was delivered.
report
A memory descriptor that describes the report.
reportType
The type of report.
reportID
The ID of the report.
refcon
void * pointer to more data.
Discussion 

This callback is set when calling IOHIDInterface::open.*/
typedef void ( *InterruptReportAction)( 
    OSObject *target, 
    AbsoluteTime timestamp, 
    IOMemoryDescriptor *report, 
    IOHIDReportType type, 
    UInt32 reportID, 
    void *refcon); 

public://func

IOHIDInterface_open

};

#endif//__cplusplus

#endif//_IOKIT_HID_IOHIDINTERFACE_H

