
#ifndef _IOKIT_HID_IOHIDLIBOBSOLETE_H_
#define _IOKIT_HID_IOHIDLIBOBSOLETE_H_

#include <sys/cdefs.h>

__BEGIN_DECLS
#include <CoreFoundation/CoreFoundation.h>
#if COREFOUNDATION_CFPLUGINCOM_SEPARATE
#include <CoreFoundation/CFPlugInCOM.h>
#endif //COREFOUNDATION_CFPLUGINCOM_SEPARATE

#include <IOKit/IOTypes.h>
#include <IOKit/IOReturn.h>

#include <IOKit/hid/IOHIDKeys.h>

/*kIOHIDDeviceInterfaceID121


#define kIOHIDDeviceInterfaceID121 CFUUIDGetConstantUUIDWithBytes(NULL, \ 
    0x7d, 0xb, 0x51, 0xe, 0x16, 0xd5, 0x11, 0xd7, \ 
    0x9e, 0x9b, 0x0, 0x3, 0x93, 0x99, 0x2e, 0x38) 
Discussion 

Interface ID for the IOHIDDeviceInterface121. Corresponds to an available HID device that includes methods from IOHIDDeviceInterface. This interface is available on IOHIDLib 1.2.1 and Mac OS X 10.2.3 or later.*/
#define kIOHIDDeviceInterfaceID121 CFUUIDGetConstantUUIDWithBytes(NULL, \
    0x7d, 0xb, 0x51, 0xe, 0x16, 0xd5, 0x11, 0xd7, \
    0x9e, 0x9b, 0x0, 0x3, 0x93, 0x99, 0x2e, 0x38) 

/*kIOHIDQueueInterfaceID


#define kIOHIDQueueInterfaceID CFUUIDGetConstantUUIDWithBytes(NULL, \ 
    0x81, 0x38, 0x62, 0x9E, 0x6F, 0x14, 0x11, 0xD4, \ 
    0x97, 0x0E, 0x00, 0x05, 0x02, 0x8F, 0x18, 0xD5) 
Discussion 

Interface ID for the kIOHIDQueueInterfaceID. Corresponds to a queue for a specific HID device.*/

#define kIOHIDQueueInterfaceID CFUUIDGetConstantUUIDWithBytes(NULL, \
    0x81, 0x38, 0x62, 0x9E, 0x6F, 0x14, 0x11, 0xD4, \
    0x97, 0x0E, 0x00, 0x05, 0x02, 0x8F, 0x18, 0xD5) 

/*kIOHIDOutputTransactionInterfaceID


#define kIOHIDOutputTransactionInterfaceID CFUUIDGetConstantUUIDWithBytes(NULL,\ 
    0x80, 0xCD, 0xCC, 0x00, 0x75, 0x5D, 0x11, 0xD4, \ 
    0x80, 0xEF, 0x00, 0x05, 0x02, 0x8F, 0x18, 0xD5) 
Discussion 

Interface ID for the kIOHIDOutputTransactionInterfaceID. Corresponds to an output transaction for one or more report IDs on a specific device.*/
#define kIOHIDOutputTransactionInterfaceID CFUUIDGetConstantUUIDWithBytes(NULL,\
    0x80, 0xCD, 0xCC, 0x00, 0x75, 0x5D, 0x11, 0xD4, \
    0x80, 0xEF, 0x00, 0x05, 0x02, 0x8F, 0x18, 0xD5) 

/*kIOHIDDeviceInterfaceID122


#define kIOHIDDeviceInterfaceID122 CFUUIDGetConstantUUIDWithBytes(NULL, \ 
    0xb7, 0xa, 0xbf, 0x31, 0x16, 0xd5, 0x11, 0xd7, \ 
    0xab, 0x35, 0x0, 0x3, 0x93, 0x99, 0x2e, 0x38) 
Discussion 

Interface ID for the IOHIDDeviceInterface122. Corresponds to an available HID device that includes methods from IOHIDDeviceInterface and IOHIDDeviceInterface121. This interface is available on IOHIDLib 1.2.2 and Mac OS X 10.3 or later.*/
#define kIOHIDDeviceInterfaceID122 CFUUIDGetConstantUUIDWithBytes(NULL, \
    0xb7, 0xa, 0xbf, 0x31, 0x16, 0xd5, 0x11, 0xd7, \
    0xab, 0x35, 0x0, 0x3, 0x93, 0x99, 0x2e, 0x38) 


__END_DECLS

#endif /* !_IOKIT_HID_IOHIDLIBOBSOLETE_H_ */
