
#ifndef _IOETHERNETSTATS_H
#define _IOETHERNETSTATS_H


/*IODot3StatsEntry


typedef struct { 
    UInt32 alignmentErrors; 
    UInt32 fcsErrors; 
    UInt32 singleCollisionFrames; 
    UInt32 multipleCollisionFrames; 
    UInt32 sqeTestErrors; 
    UInt32 deferredTransmissions; 
    UInt32 lateCollisions; 
    UInt32 excessiveCollisions; 
    UInt32 internalMacTransmitErrors; 
    UInt32 carrierSenseErrors; 
    UInt32 frameTooLongs; 
    UInt32 internalMacReceiveErrors; 
    UInt32 etherChipSet; 
    UInt32 missedFrames; 
} IODot3StatsEntry;  
Fields
alignmentErrors
dot3StatsAlignmentErrors.
fcsErrors
dot3StatsFCSErrors.
singleCollisionFrames
dot3StatsSingleCollisionFrames.
multipleCollisionFrames
dot3StatsMultipleCollisionFrames.
sqeTestErrors
dot3StatsSQETestErrors.
deferredTransmissions
dot3StatsDeferredTransmissions.
lateCollisions
dot3StatsLateCollisions.
excessiveCollisions
dot3StatsExcessiveCollisions.
internalMacTransmitErrors
dot3StatsInternalMacTransmitErrors.
carrierSenseErrors
dot3StatsCarrierSenseErrors.
frameTooLongs
dot3StatsFrameTooLongs.
internalMacReceiveErrors
dot3StatsInternalMacReceiveErrors.
etherChipSet
dot3StatsEtherChipSet.
missedFrames
dot3StatsMissedFrames (not in RFC1650).
Discussion 

Ethernet MIB statistics structure.*/
typedef struct { 
    UInt32 alignmentErrors; 
    UInt32 fcsErrors; 
    UInt32 singleCollisionFrames; 
    UInt32 multipleCollisionFrames; 
    UInt32 sqeTestErrors; 
    UInt32 deferredTransmissions; 
    UInt32 lateCollisions; 
    UInt32 excessiveCollisions; 
    UInt32 internalMacTransmitErrors; 
    UInt32 carrierSenseErrors; 
    UInt32 frameTooLongs; 
    UInt32 internalMacReceiveErrors; 
    UInt32 etherChipSet; 
    UInt32 missedFrames; 
} IODot3StatsEntry;  

/*IODot3CollEntry


typedef struct { 
    UInt32 collFrequencies[16]; 
} IODot3CollEntry;  
Fields
collFrequencies
dot3StatsCollFrequencies.
Discussion 

Collision statistics structure.*/
typedef struct { 
    UInt32 collFrequencies[16]; 
} IODot3CollEntry;  

/*IODot3RxExtraEntry


typedef struct { 
    UInt32 overruns; 
    UInt32 watchdogTimeouts; 
    UInt32 frameTooShorts; 
    UInt32 collisionErrors; 
    UInt32 phyErrors; 
    UInt32 timeouts; 
    UInt32 interrupts; 
    UInt32 resets; 
    UInt32 resourceErrors; 
    UInt32 reserved[4]; 
} IODot3RxExtraEntry;  
Fields
overruns
receiver overruns.
watchdogTimeouts
watchdog timer expirations.
frameTooShorts
runt frames.
collisionErrors
frames damages by late collision.
phyErrors
PHY receive errors.
timeouts
receiver timeouts.
interrupts
receiver interrupts.
resets
receiver resets.
resourceErrors
receiver resource shortages.
Discussion 

Extra receiver statistics not defined by RFC1650.*/

typedef struct { 
    UInt32 overruns; 
    UInt32 watchdogTimeouts; 
    UInt32 frameTooShorts; 
    UInt32 collisionErrors; 
    UInt32 phyErrors; 
    UInt32 timeouts; 
    UInt32 interrupts; 
    UInt32 resets; 
    UInt32 resourceErrors; 
    UInt32 reserved[4]; 
} IODot3RxExtraEntry; 

/*IODot3TxExtraEntry


typedef struct { 
    UInt32 underruns; 
    UInt32 jabbers; 
    UInt32 phyErrors; 
    UInt32 timeouts; 
    UInt32 interrupts; 
    UInt32 resets; 
    UInt32 resourceErrors; 
    UInt32 reserved[4]; 
} IODot3TxExtraEntry;  
Fields
underruns
transmit underruns.
jabbers
jabber events.
phyErrors
PHY transmit errors.
timeouts
transmitter timeouts.
interrupts
transmitter interrupts.
resets
transmitter resets.
resourceErrors
transmitter resource shortages.
Discussion 

Extra transmitter statistics not defined by RFC1650.*/
typedef struct { 
    UInt32 underruns; 
    UInt32 jabbers; 
    UInt32 phyErrors; 
    UInt32 timeouts; 
    UInt32 interrupts; 
    UInt32 resets; 
    UInt32 resourceErrors; 
    UInt32 reserved[4]; 
} IODot3TxExtraEntry; 

/*IOEthernetStats


typedef struct { 
    IODot3StatsEntry dot3StatsEntry; 
    IODot3CollEntry dot3CollEntry; 
    IODot3RxExtraEntry dot3RxExtraEntry; 
    IODot3TxExtraEntry dot3TxExtraEntry; 
} IOEthernetStats;  
Fields
dot3StatsEntry
IODot3StatsEntry statistics group.
dot3CollEntry
IODot3CollEntry statistics group.
dot3RxExtraEntry
IODot3RxExtraEntry statistics group.
dot3TxExtraEntry
IODot3TxExtraEntry statistics group.
Discussion 

Aggregate Ethernet statistics structure.*/

typedef struct { 
    IODot3StatsEntry dot3StatsEntry; 
    IODot3CollEntry dot3CollEntry; 
    IODot3RxExtraEntry dot3RxExtraEntry; 
    IODot3TxExtraEntry dot3TxExtraEntry; 
} IOEthernetStats; 

/*kIOEthernetStatsKey


#define kIOEthernetStatsKey "IOEthernetStatsKey" 
Discussion 

Defines the name of an IONetworkData that contains an IOEthernetStat*/
#define kIOEthernetStatsKey "IOEthernetStatsKey" 

#endif 
