
#ifndef _IONETWORKSTATS_H
#define _IONETWORKSTATS_H

#include <HYS/IOKit/network/IONetworkStats.h>

/*IONetworkStats


typedef struct { 
    UInt32 inputPackets; 
    UInt32 inputErrors; 
    UInt32 outputPackets; 
    UInt32 outputErrors; 
    UInt32 collisions; 
} IONetworkStats;  
Fields
inputPackets
count input packets.
inputErrors
count input errors.
outputPackets
count output packets.
outputErrors
count output errors.
collisions
count collisions on CDMA networks.
Discussion 

Generic network statistics structure.*/

typedef struct { 
    UInt32 inputPackets; 
    UInt32 inputErrors; 
    UInt32 outputPackets; 
    UInt32 outputErrors; 
    UInt32 collisions; 
} IONetworkStats;  

/*kIONetworkStatsKey


#define kIONetworkStatsKey "IONetworkStatsKey" 
Discussion 

Defines the name of an IONetworkData that contains an IONetworkStats.*/
#define kIONetworkStatsKey "IONetworkStatsKey" 

/*IOutputQueueStats


typedef struct { 
    UInt32 capacity; 
    UInt32 size; 
    UInt32 peakSize; 
    UInt32 dropCount; 
    UInt32 outputCount; 
    UInt32 retryCount; 
    UInt32 stallCount; 
    UInt32 reserved[4]; 
} IOOutputQueueStats;  
Fields
capacity
queue capacity.
size
current size of the queue.
peakSize
peak size of the queue.
dropCount
number of packets dropped.
outputCount
number of output packets.
retryCount
number of retries.
stallCount
number of queue stalls.
Discussion 

Statistics recorded by IOOutputQueue objects.*/
typedef struct { 
    UInt32 capacity; 
    UInt32 size; 
    UInt32 peakSize; 
    UInt32 dropCount; 
    UInt32 outputCount; 
    UInt32 retryCount; 
    UInt32 stallCount; 
    UInt32 reserved[4]; 
} IOOutputQueueStats;  

/*kIOOutputQueueStatsKey


#define kIOOutputQueueStatsKey "IOOutputQueueStatsKey" 
Discussion 

Defines the name of an IONetworkData that contains an IOOutputQueueStats.*/
#define kIOOutputQueueStatsKey "IOOutputQueueStatsKey" 

#endif //_IONETWORKSTATS_H
