
#ifndef _IOKIT_IOCARDBUSDEVICE_H
#define _IOKIT_IOCARDBUSDEVICE_H

#include <IOKit/pci/IOPCIDevice.h>//add
#include <IOKit/pccard/cs_types.h>//add
#include <IOKit/pccard/cs.h>//add

#include <HYS/IOKit/pccard/IOCardBusDevice.h>
class IOCardBusDevice : public IOPCIDevice,public IOCardBusDevice_HYS
{
    OSDeclareDefaultStructors(IOCardBusDevice);

private:
protected:
public:

IOCardBusDevice_setPowerState
IOCardBusDevice_bindCardServices
IOCardBusDevice_setProperties
IOCardBusDevice_eventHandler
IOCardBusDevice_unbindCardServices
IOCardBusDevice_finalize
IOCardBusDevice_matchPropertyTable
IOCardBusDevice_matchLocation

/*cardServices


Makes a call to Card Services. 

public

virtual int cardServices(
    int func,
    void *arg1 = 0,
    void *arg2 = 0,
    void *arg3 = 0); 
Parameters
func
The Card Services function index.
arg1
Argument number one.
arg2
Argument number two.
arg3
Argument number three.
Return Value

See "IOKit/pccard/cs.h" for return codes. 
Discussion 

This method is used to directly make calls to Card Services. You should always call Card Services using this method. This will ensure that it is run on the correct IOPCCardBridge workloop. See the file "doc/PCMCIA-PROG" in the IOPCCardFamily Darwin project and header file "IOKit/pccard/cs.h" for more info.

In most cases, you should never need to use this method and its misuse will cause problems.*/
virtual int cardServices(
    int func,
    void *arg1 = 0,
    void *arg2 = 0,
    void *arg3 = 0); 

/*getState


Returns the current state of the card. 

public

virtual u_int getState(
    void); 
Return Value

Current state of card. 
Discussion 

This method returns the current state of the card.*/
virtual u_int getState(
    void); 

/*getCardServicesHandle


Returns the Card Services client handle for this card. 

public

virtual client_handle_t getCardServicesHandle(
    void); 
Return Value

Returns Card Services client handle. This should always be successful. 
Discussion 

This method returns the Card Services client handle for this card. This handle is created for the driver when the card was bound to Card Services. This handle is needed to make most Card Services calls. In most cases you should not need to use this method*/
virtual client_handle_t getCardServicesHandle(
    void); 

};

#endif //_IOKIT_IOCARDBUSDEVICE_H

