

#ifndef _IOKIT_IOPCCARD16DEVICE_H
#define _IOKIT_IOPCCARD16DEVICE_H

#include <IOKit/IOService.h>//add
#include <IOKit/pccard/cs_types.h>//add
#include <IOKit/pccard/cs.h>//add

//client_handle_t

/*Power States


enum { 
    kIOPCCard16DeviceOffState = 0, 
    kIOPCCard16DeviceDozeState = 1, 
    kIOPCCard16DeviceOnState = 2, 
    kIOPCCard16DevicePowerStateCount = 3, 
};  
Constants
kIOPCCard16DeviceOffState
No power to the socket.
kIOPCCard16DeviceDozeState
Power to the socket, the device can shut down all or parts of the device. If you don't support this, you can treat this the same as the "on" state.
kIOPCCard16DeviceOnState
The socket is powered up.
Discussion 

These are the supported power management states for 16-bit PC Cards.*/
enum { 
    kIOPCCard16DeviceOffState = 0, 
    kIOPCCard16DeviceDozeState = 1, 
    kIOPCCard16DeviceOnState = 2, 
    kIOPCCard16DevicePowerStateCount = 3, 
};

class IOPCCard16Enabler;
class IODeviceMemory;

#include <HYS/IOKit/pccard/IOPCCard16Device.h>

class IOPCCard16Device : public IOService,public IOPCCard16Device_HYS
{
    OSDeclareDefaultStructors(IOPCCard16Device);

private:
protected:

public:
IOPCCard16Device_bindCardServices
IOPCCard16Device_unbindCardServices
IOPCCard16Device_attach
IOPCCard16Device_detach
IOPCCard16Device_setPowerState
IOPCCard16Device_setProperties
IOPCCard16Device_eventHandler
IOPCCard16Device_finalize
IOPCCard16Device_matchPropertyTable
IOPCCard16Device_matchLocation

/*ioWrite16


Writes a 16-bit value to an I/O space aperture. 

public

virtual void ioWrite16(
    UInt16 offset,
    UInt16 value,
    IOMemoryMap *map = 0 ); 
Parameters
offset
An offset into a bus or device's I/O space aperture.
value
The value to be written in host byte order (big endian on PPC).
map
If the offset is relative to the beginning of a device's aperture, an IOMemoryMap object for that object should be passed in. Otherwise, passing zero will write the value relative to the beginning of the bus's I/O space.
Discussion 

This method will write a 16-bit value to a 2-byte aligned offset in an I/O space aperture. If a map object is passed in, the value is written relative to it, otherwise the value is written relative to the I/O space aperture for the bus. This function encapsulates the differences between architectures in generating I/O space operations. An eieio instruction is included on PPC. */
virtual void ioWrite16(
    UInt16 offset,
    UInt16 value,
    IOMemoryMap *map = 0 ); 

/*ioWrite32


Writes a 32-bit value to an I/O space aperture. 

public

virtual void ioWrite32(
    UInt16 offset,
    UInt32 value,
    IOMemoryMap *map = 0 ); 
Parameters
offset
An offset into a bus or device's I/O space aperture.
value
The value to be written in host byte order (big endian on PPC).
map
If the offset is relative to the beginning of a device's aperture, an IOMemoryMap object for that object should be passed in. Otherwise, passing zero will write the value relative to the beginning of the bus's I/O space.
Discussion 

This method will write a 32-bit value to a 4-byte aligned offset in an I/O space aperture. If a map object is passed in, the value is written relative to it, otherwise the value is written relative to the I/O space aperture for the bus. This function encapsulates the differences between architectures in generating I/O space operations. An eieio instruction is included on PPC.*/
virtual void ioWrite32(
    UInt16 offset,
    UInt32 value,
    IOMemoryMap *map = 0 ); 

/*ioRead16


Reads a 16-bit value from an I/O space aperture. 

public

virtual UInt16 ioRead16(
    UInt16 offset,
    IOMemoryMap *map = 0 ); 
Parameters
offset
An offset into a bus or device's I/O space aperture.
map
If the offset is relative to the beginning of a device's aperture, an IOMemoryMap object for that object should be passed in. Otherwise, passing zero will write the value relative to the beginning of the bus's I/O space.
Return Value

The value read in host byte order (big endian on PPC). 
Discussion 

This method will read a 16-bit value from a 2-byte aligned offset in an I/O space aperture. If a map object is passed in, the value is read relative to it, otherwise the value is read relative to the I/O space aperture for the bus. This function encapsulates the differences between architectures in generating I/O space operations. An eieio instruction is included on PPC.*/
virtual UInt16 ioRead16(
    UInt16 offset,
    IOMemoryMap *map = 0 ); 

/*ioRead32


Reads a 32-bit value from an I/O space aperture. 

public

virtual UInt32 ioRead32(
    UInt16 offset,
    IOMemoryMap *map = 0 ); 
Parameters
offset
An offset into a bus or device's I/O space aperture.
map
If the offset is relative to the beginning of a device's aperture, an IOMemoryMap object for that object should be passed in. Otherwise, passing zero will write the value relative to the beginning of the bus's I/O space.
Return Value

The value read in host byte order (big endian on PPC). 
Discussion 

This method will read a 32-bit value from a 4-byte aligned offset in an I/O space aperture. If a map object is passed in, the value is read relative to it, otherwise the value is read relative to the I/O space aperture for the bus. This function encapsulates the differences between architectures in generating I/O space operations. An eieio instruction is included on PPC.*/
virtual UInt32 ioRead32(
    UInt16 offset,
    IOMemoryMap *map = 0 ); 

/*setWindowOffset


Sets the offset for this window. 

public

virtual bool setWindowOffset(
    UInt32 index,
    UInt32 newOffset); 
Parameters
index
Index of window.
offset
The new offset for this window.
Return Value

Returns true if the window offset was successfully updated. 
Discussion 

This method updates the offset into the card's memory space for this window. This call is only valid for memory windows.*/
virtual bool setWindowOffset(
    UInt32 index,
    UInt32 newOffset); 

/*getWindowOffset


Returns the offset that this window is currently at. 

public

virtual bool getWindowOffset(
    UInt32 index,
    UInt32 *offset); 
Parameters
index
Index of window.
offset
The current offset for this window.
Return Value

Returns true if the returned window offset is valid. 
Discussion 

This method returns the current offset for this window into the card's memory space. This call is only valid for memory windows.*/
virtual bool getWindowOffset(
    UInt32 index,
    UInt32 *offset); 

/*getWindowHandle


Returns the Card Services handle for this window. 

public

virtual bool getWindowHandle(
    UInt32 index,
    window_handle_t *handle); 
Parameters
index
Index to window.
handle
Pointer to the window_handle_t structure to be filled in.
Return Value

Returns true if the window handle was found. 
Discussion 

This method returns the Card Services handle for the window requested. This call is only valid for memory windows. Normally this call is not needed.*/
virtual bool getWindowHandle(
    UInt32 index,
    window_handle_t *handle); 

/*getWindowSize


Returns the size of this window. 

public

virtual UInt32 getWindowSize(
    UInt32 index); 
Parameters
index
Index of window.
Return Value

Returns the size of the window in bytes. 
Discussion 

This method returns the size of the window in bytes.*/
virtual UInt32 getWindowSize(
    UInt32 index); 

/*getConfigurationInfo


Returns information on the card's current configuration. 

public

virtual bool getConfigurationInfo(
    config_info_t *config); 
Parameters
config
Pointer to config_info_t structure to be filled in.
Return Value

Returns true on success. 
Discussion 

This is a convenience method used to call the Card Services call GetConfigurationInfo. Normally this call is not needed.*/
virtual bool getConfigurationInfo(
    config_info_t *config); 

/*installEnabler


Installs an alternate 16-bit PC Card enabler. 

public

virtual bool installEnabler(
    IOPCCard16Enabler *customEnabler = 0); 
Parameters
customEnabler
Pointer in the instance of an alternate enabler.
Return Value

Returns true if the enabler was successfully installed. 
Discussion 

This method switches out the default enabler for a user-supplied enabler. It is not necessary to call this method if the default enabler is going to be used.*/
virtual bool installEnabler(
    IOPCCard16Enabler *customEnabler = 0); 

/*getState


Returns the current state of the card. 

public

virtual u_int getState(
    void); 
Return Value

Current state of card. Returns zero if the enabler has not been installed. 
Discussion 

This method returns the current state of the card by asking the enabler.*/
virtual u_int getState(
    void); 

/*ioDeviceMemory


Accessor to the I/O space aperture for this bus. 

public

virtual IODeviceMemory * ioDeviceMemory(
    void); 
Return Value

A pointer to an IODeviceMemory object for the I/O aperture. The IODeviceMemory is retained by the provider, so is valid while attached, or while any mappings to it exist. It should not be released by the caller. 
Discussion 

This method will return a reference to the IODeviceMemory for the I/O aperture of the bus the device is on.*/
virtual IODeviceMemory * ioDeviceMemory(
    void); 

/*getCardServicesHandle


Returns the Card Services client handle for this card. 

public

virtual client_handle_t getCardServicesHandle(
    void); 
Return Value

Returns Card Services client handle. This should always be successful. 
Discussion 

This method returns the Card Services client handle for this card. This handle is created for the driver when the card was bound to Card Services. This handle is needed to make most Card Services calls. In most cases you should not need to use this method.*/
virtual client_handle_t getCardServicesHandle(
    void); 

/*cardServices


Makes a call to Card Services. 

public

virtual int cardServices(
    int func,
    void *arg1 = 0,
    void *arg2 = 0,
    void *arg3 = 0); 
Parameters
func
The Card Services function index.
arg1
Argument number one.
arg2
Argument number two.
arg3
Argument number three.
Return Value

See "IOKit/pccard/cs.h" for return codes. 
Discussion 

This method is used to directly make calls to Card Services. You should always call Card Services using this method. This will ensure that it is run on the correct IOPCCardBridge workloop. See the file "doc/PCMCIA-PROG" in the IOPCCardFamily Darwin project and header file "IOKit/pccard/cs.h" for more info.

In most cases, you should never need to use this method and its misuse will cause problems.*/
virtual int cardServices(
    int func,
    void *arg1 = 0,
    void *arg2 = 0,
    void *arg3 = 0); 

/*unconfigure


Unconfigures a card. 

public

virtual bool unconfigure(
    void); 
Return Value

Returns true if the card was successfully unconfigured. 
Discussion 

This method releases resources that were previously allocated back to Card Services. It does not unmap windows. Virtual-to-physical mappings need to be released separately.*/
virtual bool unconfigure(
    void); 

/*configure


Selects a 16-bit card configuration and enables it for use. 

public

virtual bool configure(
    UInt32 index = 0); 
Parameters
index
Index of configuration to try. If no index is given then try all indexes, one by one, until successful.
Return Value

Returns true if the card configuration was successful. 
Discussion 

This method uses the indicated index from the 16-bit PC Card Configuration Table Entry Tuple, CISTPL_CFTABLE_ENTRY, to allocate resources and properly configure the card. If the index is not specified, the currently installed enabler will decide the order in which configuration entries are to be tried. If no index is given, configuration entries are tried one by one until the card is successfully configured. The default enabler sorts entries first by looking for the least number of windows, preferring memory windows over I/O windows.

After making this call, windows need to be mapped into the kernel virtual address space by using the mapDeviceMemoryWithIndex(). This step is the same as the one you would take in a PCI or Cardbus based driver. Additional information about the configured windows can be obtained from this class. This information is sometimes needed when writing a generic driver that matches against multiple cards.*/

virtual bool configure(
    UInt32 index = 0); 

/*getWindowCount


Returns the number of windows that have been configured. 

public

virtual UInt32 getWindowCount(
    void); 
Return Value

Returns the number of windows. 
Discussion 

This method returns the number of windows in this configuration.*/
virtual UInt32 getWindowCount(
    void); 

/*getWindowType


Returns the window type. 

public

virtual UInt32 getWindowType(
    UInt32 index); 
Parameters
index
Index of window.
Return Value

Returns IOPCCARD16_MEMORY_WINDOW, IOPCCARD16_IO_WINDOW or IOPCCARD16_BAD_INDEX. 
Discussion 

This method is used to find the type of window given its index. There are two types of windows, I/O and memory. if they are available in a specific configuration, memory windows will always come first in the list of windows.*/
virtual UInt32 getWindowType(
    UInt32 index); 

/*getWindowAttributes


Returns the attributes of this window. 

public

virtual bool getWindowAttributes(
    UInt32 index,
    UInt32 *attributes); 
Parameters
index
Index of window.
attributes
Pointer to the attribute flags to be filled in.
Return Value

Returns attributes for the window. 
Discussion 

This method returns the attributes for the specified window. The meaning of the attributes flags varies depending on the type of window. The most useful attributes are the data access width flags for I/O windows. For definitions of these flags for both types of windows see "IOKit/pccard/cs.h".*/
virtual bool getWindowAttributes(
    UInt32 index,
    UInt32 *attributes); 

/*ioRead8


Reads an 8-bit value from an I/O space aperture. 

public

virtual UInt8 ioRead8(
    UInt16 offset,
    IOMemoryMap *map = 0 ); 
Parameters
offset
An offset into a bus or device's I/O space aperture.
map
If the offset is relative to the beginning of a device's aperture, an IOMemoryMap object for that object should be passed in. Otherwise, passing zero will write the value relative to the beginning of the bus's I/O space.
Return Value

The value read in host byte order (big endian on PPC). 
Discussion 

This method will read an 8-bit value from an offset in an I/O space aperture. If a map object is passed in, the value is read relative to it, otherwise the value is read relative to the I/O space aperture for the bus. This function encapsulates the differences between architectures in generating I/O space operations. An eieio instruction is included on PPC.*/
virtual UInt8 ioRead8(
    UInt16 offset,
    IOMemoryMap *map = 0 ); 

/*ioWrite8


Writes an 8-bit value to an I/O space aperture. 

public

virtual void ioWrite8(
    UInt16 offset,
    UInt8 value,
    IOMemoryMap *map = 0 ); 
Parameters
offset
An offset into a bus or device's I/O space aperture.
value
The value to be written in host byte order (big endian on PPC).
map
If the offset is relative to the beginning of a device's aperture, an IOMemoryMap object for that object should be passed in. Otherwise, passing zero will write the value relative to the beginning of the bus's I/O space.
Discussion 

This method will write a 8-bit value to an offset in an I/O space aperture. If a map object is passed in, the value is written relative to it, otherwise the value is written relative to the I/O space aperture for the bus. This function encapsulates the differences between architectures in generating I/O space operations. An eieio instruction is included on PPC.*/
virtual void ioWrite8(
    UInt16 offset,
    UInt8 value,
    IOMemoryMap *map = 0 ); 

};


#endif //_IOKIT_IOPCCARD16DEVICE_H

