
#ifndef _IOKIT_IOPCCARD16ENABER_H
#define _IOKIT_IOPCCARD16ENABER_H

#include <libkern/c++/OSObject.h>//add
#include <libkern/OSTypes.h>//add
#include <IOKit/pccard/cs_types.h>//add
#include <IOKit/pccard/cistpl.h>//add
#include <IOKit/pccard/cs.h>//add
#include <IOKit/IOReturn.h>//add

/*kMaxConfigurations


The maximum number of configurations that can be handled. 

#define kMaxConfigurations 32 */
#define kMaxConfigurations 32 

class IOPCCard16Device;//add
class IOService;//add

#include <HYS/IOKit/pccard/IOPCCard16Enabler.h>

class IOPCCard16Enabler : public OSObject,public IOPCCard16Enabler_HYS
{
    OSDeclareDefaultStructors(IOPCCard16Enabler);

 protected:

/*map


protected

memreq_t map[CISTPL_MEM_MAX_WIN]; 
Discussion 

Tracks the current common memory mapping*/
memreq_t map[CISTPL_MEM_MAX_WIN]; 

/*device


protected

IOPCCard16Device * device; 
Discussion 

Pointer to the provider nub*/
IOPCCard16Device * device; 

/*handle


protected

client_handle_t handle; 
Discussion 

Stores the Card Services handle for this socket*/
client_handle_t handle; 

/*state


protected

u_int state; 
Discussion 

Stores the current state of this socket*/
u_int state; 

/*tableEntryCount


protected

u_int tableEntryCount; 
Discussion 

Number of entries stored in the configTable*/
u_int tableEntryCount; 

/*configTable


protected

cistpl_cftable_entry_t * configTable[32]; 
Discussion 

Stores the expanded information from the CIS configuration tuples*/
cistpl_cftable_entry_t * configTable[32]; 

/*configuration


protected

config_req_t configuration; 
Discussion 

Stores the configuration reserved from Card Services*/
config_req_t configuration; 

/*irq


protected

irq_req_t irq; 
Discussion 

Tracks the current IRQ reservations*/

irq_req_t irq; 

/*memoryWindowCount


protected

UInt32 memoryWindowCount; 
Discussion 

Number of reserved memory windows*/
UInt32 memoryWindowCount; 

/*win


protected

window_handle_t win[CISTPL_MEM_MAX_WIN]; 
Discussion 

Stores the Card Services handle for a memory window*/
window_handle_t win[CISTPL_MEM_MAX_WIN]; 

/*req


protected

win_req_t req[CISTPL_MEM_MAX_WIN]; 
Discussion 

Tracks the current common memory reservations*/
win_req_t req[CISTPL_MEM_MAX_WIN]; 

/*ioWindowCount


protected

UInt32 ioWindowCount; 
Discussion 

Number of reserved I/O windows*/
UInt32 ioWindowCount; 

/*io


protected

io_req_t io; 
Discussion 

Tracks the current I/O reservations*/
io_req_t io; 

 public:
IOPCCard16Enabler_init
IOPCCard16Enabler_attach
IOPCCard16Enabler_detach
IOPCCard16Enabler_free

/*setWindowOffset


Sets the offset for this window. 

public

virtual bool setWindowOffset(
    UInt32 index,
    UInt32 newOffset); 
Parameters
index
Index of window.
offset
The new offset for this window.
Return Value

Returns true if the window offset was successfully updated. 
Discussion 

This method updates the offset into the card's memory space for this window. This call is only valid for memory windows.*/
virtual bool setWindowOffset(
    UInt32 index,
    UInt32 newOffset); 

/*getWindowOffset


Returns the offset that this window is currently at. 

public

virtual bool getWindowOffset(
    UInt32 index,
    UInt32 *offset); 
Parameters
index
Index of window.
offset
The current offset for this window.
Return Value

Returns true if the returned window offset is valid. 
Discussion 

This method returns the current offset for this window into the card's memory space. This call is only valid for memory windows.*/
virtual bool getWindowOffset(
    UInt32 index,
    UInt32 *offset); 

/*getWindowHandle


Returns the Card Services handle for this window. 

public

virtual bool getWindowHandle(
    UInt32 index,
    window_handle_t *handle); 
Parameters
index
Index to window.
handle
Pointer to the window_handle_t structure to be filled in.
Return Value

Returns true if the window handle was found. 
Discussion 

This method returns the Card Services handle for the window requested. This call is only valid for memory windows.*/
virtual bool getWindowHandle(
    UInt32 index,
    window_handle_t *handle); 

/*getWindowAttributes


Returns the attributes of this window. 

public

virtual bool getWindowAttributes(
    UInt32 index,
    UInt32 *attributes); 
Parameters
index
Index of window.
attributes
Pointer to the attribute flags to be filled in.
Return Value

Returns attributes for the window. 
Discussion 

This method returns the attributes for the specified window. The meaning of the attributes flags varies depending on the type of window. The most useful attributes are the data access width flags for I/O windows. For definitions of these flags for both types of windows see "IOKit/pccard/cs.h".*/
virtual bool getWindowAttributes(
    UInt32 index,
    UInt32 *attributes); 

/*getWindowSize


Returns the size of this window. 

public

virtual UInt32 getWindowSize(
    UInt32 index); 
Parameters
index
Index of window.
Return Value

Returns the size of the window in bytes. 
Discussion 

This method returns the size of the window in bytes.*/
virtual UInt32 getWindowSize(
    UInt32 index); 

/*getWindowType


Returns the window type. 

public

virtual UInt32 getWindowType(
    UInt32 index); 
Parameters
index
Index of window.
Return Value

Returns IOPCCARD16_MEMORY_WINDOW, IOPCCARD16_IO_WINDOW or IOPCCARD16_BAD_INDEX. 
Discussion 

This method is used to find the type of window given its index. There are two types of windows, I/O and memory. If they are available in a specific configuration, memory windows will always come first in the list of windows.*/
virtual UInt32 getWindowType(
    UInt32 index); 

/*getWindowCount


Returns the number of windows that have been configured. 

public

virtual UInt32 getWindowCount(
    void); 
Return Value

Returns the number of windows. 
Discussion 

This method returns the number of windows that have been reserved in this configuration.*/
virtual UInt32 getWindowCount(
    void); 

/*getConfigurationInfo


Returns information on the card's current configuration. 

public

virtual bool getConfigurationInfo(
    config_info_t *config); 
Parameters
config
Pointer to config_info_t structure to be filled in.
Return Value

Returns true on success. 
Discussion 

This is a convenience method used to call the Card Services call GetConfigurationInfo.*/
virtual bool getConfigurationInfo(
    config_info_t *config); 

/*getState


Returns the current state of the card. 

public

virtual u_int getState(
    void); 
Return Value

Current state of card. 
Discussion 

This method returns the current state of the card enabler.*/
virtual u_int getState(
    void); 

/*sortConfigurations


Sorts configurations in the selection order. 

public

virtual bool sortConfigurations(
    void); 
Return Value

Returns true if any configurations were successfully found. 
Discussion 

This method sorts configurations into the order in which they should be tried. This method can also be used to eliminate configurations that might not be valid.*/
virtual bool sortConfigurations(
    void); 

/*tryConfiguration


Tests if a configuration can be used. 

public

virtual bool tryConfiguration(
    UInt32 index); 
Return Value

Returns true if any configurations were successfully found. 
Discussion 

This method is used to test if a configuration can be reserved from Card Services. If all resources are successfully reserved, the configuration is kept. The configure method enables the configuration later on. The built configuration is kept in the state variable, configuration.*/

virtual bool tryConfiguration(
    UInt32 index); 

/*getConfigurations

virtual bool tryConfiguration(
    UInt32 index); 
Adds configuration data from the card's CIS to the configTable array. 

public

virtual bool getConfigurations(
    void); 
Return Value

Returns true if any configurations were successfully found. 
Discussion 

This method fetches configuration data from the card's CIS and expands them out into a form that is easier to use.*/
virtual bool getConfigurations(
    void); 

/*configure


Selects a 16-bit card configuration and enables it for use. 

public

virtual bool configure(
    UInt32 index=0); 
Parameters
index
Index of configuration to try. If no index is given then it is up to the enabler to decide.
Return Value

Returns true if the card configuration was successful. 
Discussion 

This method uses the indicated index from the 16-bit PC Card Configuration Table Entry Tuple, CISTPL_CFTABLE_ENTRY, to allocate resources and properly configure the card. If the index is not specified, the enabler will decide which configuration entries are to be tried.*/
virtual bool configure(
    UInt32 index=0); 

/*setPowerState


Hook for power management state changes. 

public

virtual IOReturn setPowerState(
    unsigned long,
    IOService *); 
Return Value

The return value is currently ignored. 
Discussion 

This method allows the enabler to catch power management events. This may be helpful if you need to do addition work or clean up for certain events. The default enabler uses this to track the state of power management.*/
virtual IOReturn setPowerState(
    unsigned long,
    IOService *); 

/*eventHandler


Hook for Card Services events. 

public

virtual int eventHandler(
    cs_event_t event,
    int priority,
    event_callback_args_t *args); 
Return Value

A return value of non-zero prevents the event from being passed on to the socket drivers. 
Discussion 

This method allows the enabler to catch Card Services events prior to routing them to the attached driver(s). This may be helpful if you need to do addition work or clean up for certain events. The default enabler does nothing.*/
virtual int eventHandler(
    cs_event_t event,
    int priority,
    event_callback_args_t *args); 

/*unconfigure


Unconfigures a card. 

public

virtual bool unconfigure(); 
Return Value

Returns true if the card was successfully unconfigured. 
Discussion 

This method releases resources that were previously allocated back to Card Services.*/
virtual bool unconfigure();

/*withDevice


Sets up a new enabler. 

public

static IOPCCard16Enabler * withDevice(
    IOPCCard16Device *provider); 
Return Value

Returns the address of the new enabler. 
Discussion 

This factory method creates and connects an enabler to a 16-bit PC Card provider nub.*/
static IOPCCard16Enabler * withDevice(
    IOPCCard16Device *provider); 

};

#endif //_IOKIT_IOPCCARD16ENABER_H
