

#ifndef _IOKIT_IOPCCARDBRIDGE_H
#define _IOKIT_IOPCCARDBRIDGE_H

#include <libkern/OSByteOrder.h>
#include <libkern/c++/OSContainers.h>

#include <IOKit/assert.h>
#include <IOKit/system.h>
#include <IOKit/IOLib.h>
#include <IOKit/IOService.h>

#include <IOKit/IODeviceMemory.h>
#include <IOKit/IODeviceTreeSupport.h>
#include <IOKit/IOInterruptEventSource.h>
#include <IOKit/IOPlatformExpert.h>
#include <IOKit/IOMessage.h>
#include <IOKit/IOWorkLoop.h>

#include <IOKit/pci/IOPCIBridge.h>
#include <IOKit/pci/IOPCIDevice.h>

#include <IOKit/pccard/IOCardBusDevice.h>//add
#include <IOKit/pccard/IOPCCard16Device.h>//add
#include <IOKit/pccard/cs.h>//add

class IOPCCardInterruptController;
class IOPCCardEjectController;

#include <HYS/IOKit/pccard/IOPCCardBridge.h>

class IOPCCardBridge : public IOPCI2PCIBridge,public IOPCCardBridge_HYS
{
    OSDeclareDefaultStructors(IOPCCardBridge)

private:
protected:
public:

IOPCCardBridge_requestCardEjection
IOPCCardBridge_getWorkLoop
IOPCCardBridge_unconfigureSocket
IOPCCardBridge_configureSocket
IOPCCardBridge_restoreBridgeState
IOPCCardBridge_saveBridgeState
IOPCCardBridge_setPowerState
IOPCCardBridge_addCSCInterruptHandler
IOPCCardBridge_createCardBusNub
IOPCCardBridge_setBridgePowerState
IOPCCardBridge_createPCCard16Nub
IOPCCardBridge_releaseBridgeRanges
IOPCCardBridge_publishCardBusNub
IOPCCardBridge_publishPCCard16Nub
IOPCCardBridge_addNubInterruptProperties
IOPCCardBridge_constructCardBusProperties
IOPCCardBridge_constructPCCard16Properties
IOPCCardBridge_initializeDriverServices
IOPCCardBridge_initializeSocketServices
IOPCCardBridge_configureInterruptController
IOPCCardBridge_configureBridgeRanges
IOPCCardBridge_getConfigurationSettings
IOPCCardBridge_getOFConfigurationSettings
IOPCCardBridge_getModuleParameters
IOPCCardBridge_getNubResources
IOPCCardBridge_probeBus
IOPCCardBridge_lastBusNum
IOPCCardBridge_constructCardBusCISProperties
IOPCCardBridge_metaInit
IOPCCardBridge_cardServicesGate
IOPCCardBridge_free
IOPCCardBridge_firstBusNum
IOPCCardBridge_interruptDispatcher
IOPCCardBridge_cardRemovalHandler
IOPCCardBridge_cardEventHandler
IOPCCardBridge_removeCSCInterruptHandler
IOPCCardBridge_probe
IOPCCardBridge_start
IOPCCardBridge_configure
IOPCCardBridge_stop

};

class IOPCCardInterruptController : public IOInterruptController,public IOPCCardInterruptController_HYS
{
    OSDeclareDefaultStructors(IOPCCardInterruptController);
 
private:
public:

IOPCCardInterruptController_getVectorType
IOPCCardInterruptController_enableVector
IOPCCardInterruptController_causeVector
IOPCCardInterruptController_getInterruptType
IOPCCardInterruptController_vectorCanBeShared
IOPCCardInterruptController_disableVectorHard
IOPCCardInterruptController_handleInterrupt
IOPCCardInterruptController_updateCSCInterruptHandlers
IOPCCardInterruptController_getInterruptHandlerAddress
IOPCCardInterruptController_initInterruptController

};

#endif //_IOKIT_IOPCCARDBRIDGE_H



