
#ifndef _IOKIT_IOPCCARDEJECTDEVICE_H
#define _IOKIT_IOPCCARDEJECTDEVICE_H

#include <IOKit/IOService.h>//add

#include <HYS/IOKit/pccard/IOPCCardEjectController.h>

class IOPCCardEjectController : public IOService,public IOPCCardEjectController_HYS
{
    OSDeclareDefaultStructors(IOPCCardEjectController);

protected:
public:
IOPCCardEjectController_start
IOPCCardEjectController_stop


/*requestCardEjection


Makes a request for a card to be ejected. 

public

virtual bool requestCardEjection(); 
Return Value

Returns true if the ejection request was accepted by all drivers and the ejection was successful. 
Discussion 

This method is used to start a request for a card ejection by routing Card Services EjectCard call to the driver(s) for this socket. Normally, this would be called after an external event was detected, such as a platform-specific PC Card eject button press.*/
virtual bool requestCardEjection(); 

/*ejectCard


Physically ejects a card from its socket. 

public

virtual IOReturn ejectCard(); 
Return Value

Returns kIOReturnSuccess if the card is ejected. 
Discussion 

This method is called to initiate the physical ejection of a card. It is called by its peer, the IOPCCardBridge driver, after the bridge driver has terminated the socket's driver(s) and the socket has been powered down.*/
virtual IOReturn ejectCard(); 

};


#endif //_IOKIT_IOPCCARDEJECTDEVICE_H
