
#ifndef _IOKIT_IOPCIBRIDGE_H
#define _IOKIT_IOPCIBRIDGE_H

#include <IOKit/IOService.h>
#include <IOKit/IODeviceMemory.h>
#include <IOKit/IOFilterInterruptEventSource.h>
#include <IOKit/pci/IOAGPDevice.h>

class IOPCIConfigurator;
class IOPCIDevice;

#include <HYS/IOKit/pci/IOPCIBridge.h>

class IOPCIBridge : public IOService,public IOPCIBridge_HYS
{
    OSDeclareAbstractStructors(IOPCIBridge)
    friend class IOPCIDevice;
    friend class IOPCIConfigurator;

private:

protected:

/*ExpansionData


protected

struct ExpansionData { 
    IORangeAllocator *cardBusMemoryRanges; 
}; 
Discussion 

This structure will be used to expand the capablilties of the IOPCIBridge in the future.*/
struct ExpansionData { 
	friend class IOPCIConfigurator;
        IORangeAllocator * cardBusMemoryRanges;
	IOPCIRange *       rangeLists[kIOPCIResourceTypeCount];
}; 

/*reserved


protected

ExpansionData *reserved; 
Discussion 

Reserved for future use. (Internal use only)*/
ExpansionData *reserved; 

public:
IOPCIBridge_initialize
IOPCIBridge_setDevicePowerState
IOPCIBridge_configWrite32
IOPCIBridge_start
IOPCIBridge_firstBusNum
IOPCIBridge_probeBus
IOPCIBridge_free
IOPCIBridge_stop
IOPCIBridge_saveDeviceState
IOPCIBridge__restoreDeviceState
IOPCIBridge_restoreMachineState
IOPCIBridge_restoreDeviceState
IOPCIBridge_configure
IOPCIBridge_compareAddressCell
IOPCIBridge_nvLocation
IOPCIBridge_spaceFromProperties
IOPCIBridge_findMatching
IOPCIBridge_checkProperties
IOPCIBridge_constructProperties
IOPCIBridge_configRead32
IOPCIBridge_createNub
IOPCIBridge_initializeNub
IOPCIBridge_removeDevice
IOPCIBridge_publishNub
IOPCIBridge_lastBusNum
IOPCIBridge_addBridgeMemoryRange
IOPCIBridge_addBridgePrefetchableMemoryRange
IOPCIBridge_addBridgeIORange
IOPCIBridge_constructRange
IOPCIBridge_getDTNubAddressing
IOPCIBridge_getNubAddressing
IOPCIBridge_isDTNub
IOPCIBridge_getNubResources
IOPCIBridge_resolveMSIInterrupts
IOPCIBridge_resolveLegacyInterrupts
IOPCIBridge_matchKeys
IOPCIBridge_pciMatchNub
IOPCIBridge_matchNubWithPropertyTable
IOPCIBridge_compareNubName
IOPCIBridge_findPCICapability
IOPCIBridge_extendedFindPCICapability
IOPCIBridge_createAGPSpace
IOPCIBridge_destroyAGPSpace
IOPCIBridge_getAGPRangeAllocator
IOPCIBridge_getAGPStatus
IOPCIBridge_commitAGPMemory
IOPCIBridge_releaseAGPMemory
IOPCIBridge_resetAGPDevice
IOPCIBridge_getAGPSpace

};


class IOPCI2PCIBridge : public IOPCIBridge,public IOPCI2PCIBridge_HYS
{
    OSDeclareDefaultStructors(IOPCI2PCIBridge)

private:

protected:

/*ExpansionData


protected

struct ExpansionData { 
    // /hotp 
    IOByteCount xpressCapability; 
    IOFilterInterruptEventSource *bridgeInterruptSource; 
    IOWorkLoop *workLoop; 
    uint32_t hotplugCount; 
    uint8_t presence; 
    uint8_t waitingLinkEnable; 
    uint8_t linkChangeOnly; 
    uint8_t interruptEnablePending; 
    uint8_t __reserved[4]; 
    // hotp/ 
}; 
Discussion 

This structure will be used to expand the capablilties of the IOWorkLoop in the future. */
struct ExpansionData { 
    // /hotp 
    IOByteCount xpressCapability; 
    IOFilterInterruptEventSource *bridgeInterruptSource; 
    IOWorkLoop *workLoop; 
    uint32_t hotplugCount; 
    uint8_t presence; 
    uint8_t waitingLinkEnable; 
    uint8_t linkChangeOnly; 
    uint8_t interruptEnablePending; 
    uint8_t __reserved[4]; 
    // hotp/ 
}; 

/*reserved


protected

ExpansionData *reserved; 
Discussion 

Reserved for future use. (Internal use only)*/
ExpansionData *reserved; 

public:
IOPCI2PCIBridge_saveBridgeState
IOPCI2PCIBridge_restoreBridgeState
IOPCI2PCIBridge_configRead32
IOPCI2PCIBridge_ioDeviceMemory
IOPCI2PCIBridge_probe
IOPCI2PCIBridge_serializeProperties
IOPCI2PCIBridge_filterInterrupt
IOPCI2PCIBridge_handleInterrupt
IOPCI2PCIBridge_probeBus
IOPCI2PCIBridge_start
IOPCI2PCIBridge_configure
IOPCI2PCIBridge_requestProbe
IOPCI2PCIBridge_setPowerState
IOPCI2PCIBridge_stop
IOPCI2PCIBridge_free
IOPCI2PCIBridge_firstBusNum
IOPCI2PCIBridge_lastBusNum
IOPCI2PCIBridge_getBridgeSpace
IOPCI2PCIBridge_configWrite32
IOPCI2PCIBridge_configRead16
IOPCI2PCIBridge_configWrite16
IOPCI2PCIBridge_configRead8
IOPCI2PCIBridge_configWrite8
IOPCI2PCIBridge_publishNub

};

#endif //_IOKIT_IOPCIBRIDGE_H

