 
#ifndef _IOKIT_PM_IOUPSPLUGIN_H
#define _IOKIT_PM_IOUPSPLUGIN_H

#include <CoreFoundation/CoreFoundation.h>
#include <IOKit/IOCFPlugIn.h>


/*kIOUPSPlugInInterfaceID_v140


#define kIOUPSPlugInInterfaceID_v140 CFUUIDGetConstantUUIDWithBytes(NULL, \ 
    0xe6, 0xe, 0x7, 0x99, 0x9a, 0xa6, 0x49, 0xdf, \ 
    0xb5, 0x5b, 0xa5, 0xc9, 0x4b, 0xa0, 0x7a, 0x4a) 
Discussion 

Interface ID for the IOUPSPlugInInterface. Corresponds to an available UPS device.*/

#define kIOUPSPlugInInterfaceID_v140 CFUUIDGetConstantUUIDWithBytes(NULL, \
    0xe6, 0xe, 0x7, 0x99, 0x9a, 0xa6, 0x49, 0xdf, \
    0xb5, 0x5b, 0xa5, 0xc9, 0x4b, 0xa0, 0x7a, 0x4a) 

/*kIOUPSPlugInInterfaceID


#define kIOUPSPlugInInterfaceID CFUUIDGetConstantUUIDWithBytes(NULL, \ 
    0x63, 0xf8, 0xbf, 0xc4, 0x26, 0xa0, 0x11, 0xd8, \ 
    0x88, 0xb4, 0x0, 0xa, 0x95, 0x8a, 0x2c, 0x78) 
Discussion 

Interface ID for the IOUPSPlugInInterface. Corresponds to an available UPS device.*/
#define kIOUPSPlugInInterfaceID CFUUIDGetConstantUUIDWithBytes(NULL, \
    0x63, 0xf8, 0xbf, 0xc4, 0x26, 0xa0, 0x11, 0xd8, \
    0x88, 0xb4, 0x0, 0xa, 0x95, 0x8a, 0x2c, 0x78) 

/*IOUPSEventCallbackFunction


typedef void ( *IOUPSEventCallbackFunction) (
    void *target, 
    IOReturn result, 
    void *refcon, 
    void *sender, 
    CFDictionaryRef event);  
Parameters
target
void * pointer to your data, often a pointer to an object.
result
Completion result of desired operation.
refcon
void * pointer to more data.
sender
Interface instance sending the completion routine.
event
CFDictionaryRef containing event data.
Discussion 

Type and arguments of callout C function that is used when a completion routine is called. This function pointer is set via setEventCallback and is called when an event is available from the UPS.*/
typedef void ( *IOUPSEventCallbackFunction) (
    void *target, 
    IOReturn result, 
    void *refcon, 
    void *sender, 
    CFDictionaryRef event);  

#include <HYS/IOKit/ps/IOUPSPlugIn.h>

#endif /* !_IOKIT_PM_IOUPSPLUGIN_H */
