#ifndef _IOPMPowerSource_h_
#define _IOPMPowerSource_h_

#include <libkern/c++/OSObject.h>
#include <IOKit/pwr_mgt/IOPM.h>
#include <IOKit/IOTypes.h>
#include <IOKit/IOReturn.h>
#include <IOKit/IOService.h>

#include <HYS/IOKit/pwr_mgt/IOPMPowerSource.h>
class IOPMPowerSource : public IOService,public IOPMPowerSource_HYS
{
    OSDeclareDefaultStructors(IOPMPowerSource)
    friend class IOPMPowerSourceList;

 protected:
 public:

IOPMPowerSource_setExternalConnected
IOPMPowerSource_setExternalChargeCapable
IOPMPowerSource_setBatteryInstalled
IOPMPowerSource_setIsCharging
IOPMPowerSource_setErrorCondition
IOPMPowerSource_setPSProperty
IOPMPowerSource_setManufacturer
IOPMPowerSource_setSerial
IOPMPowerSource_setLocation
IOPMPowerSource_setCurrentCapacity
IOPMPowerSource_setMaxCapacity
IOPMPowerSource_setAmperage
IOPMPowerSource_setTimeRemaining
IOPMPowerSource_setVoltage
IOPMPowerSource_setCycleCount
IOPMPowerSource_setAdapterInfo
IOPMPowerSource_externalConnected
IOPMPowerSource_batteryInstalled
IOPMPowerSource_isCharging
IOPMPowerSource_setLegacyIOBatteryInfo
IOPMPowerSource_manufacturer
IOPMPowerSource_getPSProperty

/*powerSource


Creates a new IOPMPowerSource nub. Must be attached to IORegistry, and registered by provider. 

static IOPMPowerSource *powerSource(
    void);  */

static IOPMPowerSource *powerSource(
    void); 

/*updateStatus


Must be called by physical battery controller when battery state has changed significantly. 

virtual void updateStatus(
    void);  
Discussion 

The system will not poll this object for battery updates. Rather \ the battery's controller must call updateStatus() every time state changes \ and the settings will be relayed to higher levels of power management. \ The subclassing driver should override this only if the driver needs to add \ new settings to the base class.*/
virtual void updateStatus(
    void); 

};

#endif//_IOPMPowerSource_h_
