#ifndef	_IODVDBLOCKSTORAGEDRIVER_H
#define	_IODVDBLOCKSTORAGEDRIVER_H

#include <IOKit/IOTypes.h>
#include <IOKit/storage/IOCDBlockStorageDriver.h>
#include <IOKit/storage/IODVDBlockStorageDevice.h>
#include <IOKit/storage/IODVDTypes.h>

class IODVDBlockStorageDevice;

#include <HYS/IOKit/storage/IODVDBlockStorageDriver.h>
class IODVDBlockStorageDriver : public IOCDBlockStorageDriver {

    OSDeclareDefaultStructors(IODVDBlockStorageDriver)

protected:
public:
IODVDBlockStorageDriver_getProvider
IODVDBlockStorageDriver_acceptNewMedia
IODVDBlockStorageDriver_getDeviceTypeName
IODVDBlockStorageDriver_instantiateDesiredMediaObject
IODVDBlockStorageDriver_instantiateMediaObject

/*reportKey


Get key info from the DVD drive. 

public

virtual IOReturn reportKey(
    IOMemoryDescriptor *buffer,
    const DVDKeyClass keyClass, 
    const UInt32 lba,
    const UInt8 agid,
    const DVDKeyFormat keyFormat); 
Parameters
buffer
A buffer containing information, as documented in the specification "MtFuji Commands For Multimedia Devices."
keyClass
As documented by MtFuji. See DVDKeyClass.
lba
As documented by MtFuji.
agid
As documented by MtFuji.
keyFormat
As documented by MtFuji. See DVDKeyFormat.
Discussion 

This function handles the getting of key- and encryption-related data for the drive.*/

virtual IOReturn reportKey(
    IOMemoryDescriptor *buffer,
    const DVDKeyClass keyClass, 
    const UInt32 lba,
    const UInt8 agid,
    const DVDKeyFormat keyFormat); 

/*sendKey


Send key info to the DVD drive. 

public

virtual IOReturn sendKey(
    IOMemoryDescriptor *buffer,
    const DVDKeyClass keyClass, 
    const UInt8 agid,
    const DVDKeyFormat keyFormat); 
Parameters
buffer
A buffer containing information, as documented in the specification "MtFuji Commands For Multimedia Devices."
keyClass
As documented by MtFuji. See DVDKeyClass.
agid
As documented by MtFuji.
keyFormat
As documented by MtFuji. See DVDKeyFormat.
Discussion 

This function handles the setting of key- and encryption-related data for the drive.*/
virtual IOReturn sendKey(
    IOMemoryDescriptor *buffer,
    const DVDKeyClass keyClass, 
    const UInt8 agid,
    const DVDKeyFormat keyFormat); 

/*readStructure


Get control structures from the DVD media. 

public

virtual IOReturn readStructure(
    IOMemoryDescriptor *buffer,
    const DVDStructureFormat format, 
    const UInt32 address,
    const UInt8 layer,
    const UInt8 agid); 
Parameters
buffer
A buffer containing information, as documented in the specification "MtFuji Commands For Multimedia Devices."
format
As documented by MtFuji. See DVDStructureFormat.
address
As documented by MtFuji.
layer
As documented by MtFuji.
agid
As documented by MtFuji.
Discussion 

This function handles the getting of control structure data for the media.*/
virtual IOReturn readStructure(
    IOMemoryDescriptor *buffer,
    const DVDStructureFormat format, 
    const UInt32 address,
    const UInt8 layer,
    const UInt8 agid); 

};
#endif//_IODVDBLOCKSTORAGEDRIVER_H
