
#ifndef _IODVDMEDIA_H
#define _IODVDMEDIA_H

/*kIODVDMediaTypePlusRW


#define kIODVDMediaTypePlusRW "DVD+RW" 
Discussion 

The kIODVDMediaTypeKey constant for DVD "Plus" ReWritable (DVD+RW) media.*/
#define kIODVDMediaTypePlusRW "DVD+RW" 

/*kIODVDMediaTypePlusR


#define kIODVDMediaTypePlusR "DVD+R" 
Discussion 

The kIODVDMediaTypeKey constant for DVD "Plus" Recordable (DVD+R) media.*/
#define kIODVDMediaTypePlusR "DVD+R" 

/*kIODVDMediaTypeHDRAM


#define kIODVDMediaTypeHDRAM "HD DVD-RAM" 
Discussion 

The kIODVDMediaTypeKey constant for HD DVD-RAM media.*/
#define kIODVDMediaTypeHDRAM "HD DVD-RAM" 

/*kIODVDMediaTypeHDR


#define kIODVDMediaTypeHDR "HD DVD-R" 
Discussion 

The kIODVDMediaTypeKey constant for HD DVD Recordable (HD DVD-R) media.*/
#define kIODVDMediaTypeHDR "HD DVD-R" 

/*UkIODVDMediaTypeHDRW


#define kIODVDMediaTypeHDRW "HD DVD-RW" 
Discussion 

The kIODVDMediaTypeKey constant for HD DVD ReWritable (HD DVD-RW) media.*/
#define kIODVDMediaTypeHDRW "HD DVD-RW" 

/*kIODVDMediaTypeHDROM


#define kIODVDMediaTypeHDROM "HD DVD-ROM" 
Discussion 

The kIODVDMediaTypeKey constant for HD DVD-ROM media.*/
#define kIODVDMediaTypeHDROM "HD DVD-ROM" 

/*kIODVDMediaTypeRW


#define kIODVDMediaTypeRW "DVD-RW" 
Discussion 

The kIODVDMediaTypeKey constant for DVD ReWritable (DVD-RW) media.*/
#define kIODVDMediaTypeRW "DVD-RW" 

/*kIODVDMediaTypeR


#define kIODVDMediaTypeR "DVD-R" 
Discussion 

The kIODVDMediaTypeKey constant for DVD Recordable (DVD-R) media.*/
#define kIODVDMediaTypeR "DVD-R" 

/*kIODVDMediaTypeRAM


#define kIODVDMediaTypeRAM "DVD-RAM" 
Discussion 

The kIODVDMediaTypeKey constant for DVD-RAM media.*/
#define kIODVDMediaTypeRAM "DVD-RAM" 

/*kIODVDMediaTypeROM


#define kIODVDMediaTypeROM "DVD-ROM" 
Discussion 

The kIODVDMediaTypeKey constant for DVD-ROM media.*/
#define kIODVDMediaTypeROM "DVD-ROM" 

/*kIODVDMediaClass


kIODVDMediaClass is the name of the IODVDMedia class.
#define kIODVDMediaClass "IODVDMedia" 
Discussion 

kIODVDMediaClass is the name of the IODVDMedia class.*/
#define kIODVDMediaClass "IODVDMedia" 

/*kIODVDMediaTypeKey


kIODVDMediaTypeKey is a property of IODVDMedia objects. It has an OSString value.

#define kIODVDMediaTypeKey "Type" 
Discussion 

The kIODVDMediaTypeKey property identifies the DVD media type (DVD-ROM, DVD-R, DVD-RW, DVD+RW, DVD-RAM, etc). See the kIODVDMediaType contants for possible values.*/

#define kIODVDMediaTypeKey "Type" 

//#ifdef KERNEL
#ifdef __cplusplus

#include <IOKit/storage/IODVDBlockStorageDriver.h>
#include <IOKit/storage/IOMedia.h>

#include <HYS/IOKit/storage/IODVDMedia.h>
class IODVDMedia : public IOMedia
{
    OSDeclareDefaultStructors(IODVDMedia)

protected:
public:
IODVDMedia_getProvider
IODVDMedia_matchPropertyTable

/*setSpeed


public

virtual IOReturn setSpeed(
    UInt16 kilobytesPerSecond); 
Parameters
kilobytesPerSecond
Speed to be used for data transfers, in kB/s.
kDVDSpeedMin specifies the minimum speed for all DVD media (1X). kDVDSpeedMax specifies the maximum speed supported in hardware.
Return Value

Returns the status of the operation. 
Discussion 

Set the speed to be used for data transfers.*/
virtual IOReturn setSpeed(
    UInt16 kilobytesPerSecond); 

/*getSpeed


public

virtual IOReturn getSpeed(
    UInt16 *kilobytesPerSecond); 
Parameters
kilobytesPerSecond
Returns the current speed used for data transfers, in kB/s.
kDVDSpeedMin specifies the minimum speed for all DVD media (1X). kDVDSpeedMax specifies the maximum speed supported in hardware.
Return Value

Returns the status of the operation. 
Discussion 

Get the current speed used for data transfers.*/

virtual IOReturn getSpeed(
    UInt16 *kilobytesPerSecond); 

/*readStructure


public

virtual IOReturn readStructure(
    IOMemoryDescriptor *buffer, 
    const DVDStructureFormat format, 
    const UInt32 address, 
    const UInt8 layer, 
    const UInt8 grantID ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
format
As documented by MMC.
address
As documented by MMC.
layer
As documented by MMC.
grantID
As documented by MMC.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC READ DVD STRUCTURE command.*/
virtual IOReturn readStructure(
    IOMemoryDescriptor *buffer, 
    const DVDStructureFormat format, 
    const UInt32 address, 
    const UInt8 layer, 
    const UInt8 grantID ); 

/*sendKey


public

virtual IOReturn sendKey(
    IOMemoryDescriptor *buffer, 
    const DVDKeyClass keyClass, 
    const UInt8 grantID, 
    const DVDKeyFormat format ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer. Pass null for the kDVDKeyFormatAGID_Invalidate format case.
keyClass
As documented by MMC.
grantID
As documented by MMC.
format
As documented by MMC.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC SEND KEY command.*/
virtual IOReturn sendKey(
    IOMemoryDescriptor *buffer, 
    const DVDKeyClass keyClass, 
    const UInt8 grantID, 
    const DVDKeyFormat format ); 

/*reportKey


public

virtual IOReturn reportKey(
    IOMemoryDescriptor *buffer, 
    const DVDKeyClass keyClass, 
    const UInt32 address, 
    const UInt8 grantID, 
    const DVDKeyFormat format ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer. Pass null for the kDVDKeyFormatAGID_Invalidate format case.
keyClass
As documented by MMC.
address
As documented by MMC.
grantID
As documented by MMC.
format
As documented by MMC.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC REPORT KEY command.*/
virtual IOReturn reportKey(
    IOMemoryDescriptor *buffer, 
    const DVDKeyClass keyClass, 
    const UInt32 address, 
    const UInt8 grantID, 
    const DVDKeyFormat format ); 

/*readDiscInfo


public

virtual IOReturn readDiscInfo(
    IOMemoryDescriptor *buffer, 
    UInt16 *actualByteCount ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
actualByteCount
Returns the actual number of bytes transferred in the data transfer.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC READ DISC INFORMATION command.*/

virtual IOReturn readDiscInfo(
    IOMemoryDescriptor *buffer, 
    UInt16 *actualByteCount ); 

/*readRZoneInfo


public

virtual IOReturn readRZoneInfo(
    IOMemoryDescriptor *buffer, 
    UInt32 address, 
    DVDRZoneInfoAddressType addressType, 
    UInt16 *actualByteCount ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
address
As documented by MMC.
addressType
As documented by MMC.
actualByteCount
Returns the actual number of bytes transferred in the data transfer.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC READ RZONE INFORMATION (READ TRACK INFORMATION) command.*/
virtual IOReturn readRZoneInfo(
    IOMemoryDescriptor *buffer, 
    UInt32 address, 
    DVDRZoneInfoAddressType addressType, 
    UInt16 *actualByteCount ); 

};

#endif /* __cplusplus */
//#endif /* KERNEL */
#endif /* !_IODVDMEDIA_H */
