#ifndef _IOKIT_IO_STORAGE_DEVICE_CHARACTERISTICS_H_
#define _IOKIT_IO_STORAGE_DEVICE_CHARACTERISTICS_H_

#include <IOKit/storage/IOStorageProtocolCharacteristics.h>

/*kIOPropertyProductNameKey

#define kIOPropertyProductNameKey "Product Name" 
Discussion 

This key is used to define the Product Name for a particular device and it has an associated string. 

Requirement: Mandatory 

Example: 
<dict>
	<key>Device Characteristics</key>
	<dict>
		<key>Vendor Name</key>
		<string>Apple</string>
		<key>Product Name</key>
		<string>iPod</string>
		<key>Product Revision Level</key>
		<string>1.0</string>
	</dict>
</dict>*/
#define kIOPropertyProductNameKey "Product Name" 

/*kIOPropertyDeviceCharacteristicsKey


#define kIOPropertyDeviceCharacteristicsKey "Device Characteristics" 
Discussion 

This key is used to define Device Characteristics for a particular device and it has an associated dictionary which lists the device characteristics. The device characteristics are Command Set specific and are listed in the header files for each command set. 

Requirement: Mandatory 

Example: 


<dict>
	<key>Device Characteristics</key>
	<dict>
		<key>Vendor Name</key>
		<string>Apple</string>
		<key>Product Name</key>
		<string>iPod</string>
		<key>Product Revision Level</key>
		<string>1.0</string>
	</dict>
</dict>*/
#define kIOPropertyDeviceCharacteristicsKey "Device Characteristics" 

/*kIOPropertyProductRevisionLevelKey


#define kIOPropertyProductRevisionLevelKey "Product Revision Level" 
Discussion 

This key is used to define the Product Revision Level for a particular device and it has an associated string. 

Requirement: Mandatory 

Example: 


<dict>
	<key>Device Characteristics</key>
	<dict>
		<key>Vendor Name</key>
		<string>Apple</string>
		<key>Product Name</key>
		<string>iPod</string>
		<key>Product Revision Level</key>
		<string>1.0</string>
	</dict>
</dict>
*/
#define kIOPropertyProductRevisionLevelKey "Product Revision Level" 

/*kIOPropertyVendorNameKey


#define kIOPropertyVendorNameKey "Vendor Name" 
Discussion 

This key is used to define the Vendor Name for a particular device and it has an associated string. 

Requirement: Mandatory 

Example: 


<dict>
	<key>Device Characteristics</key>
	<dict>
		<key>Vendor Name</key>
		<string>Apple</string>
		<key>Product Name</key>
		<string>iPod</string>
		<key>Product Revision Level</key>
		<string>1.0</string>
	</dict>
</dict>
*/
#define kIOPropertyVendorNameKey "Vendor Name" 

#endif//_IOKIT_IO_STORAGE_DEVICE_CHARACTERISTICS_H_
