#ifndef _IOKIT_IOUSBCompositeDriver_H
#define _IOKIT_IOUSBCompositeDriver_H

#include <libkern/OSByteOrder.h>
#include <IOKit/IOLib.h>
#include <IOKit/IONotifier.h>
#include <IOKit/IOService.h>
#include <IOKit/IOMessage.h>
#include <IOKit/usb/IOUSBBus.h>
#include <IOKit/usb/IOUSBDevice.h>
#include <IOKit/usb/IOUSBInterface.h>
#include <IOKit/usb/IOUSBLog.h>
#include <IOKit/usb/USB.h>

#include <HYS/IOKit/usb/IOUSBCompositeDriver.h>
class IOUSBCompositeDriver : public IOService,public IOUSBCompositeDriver_HYS
{
    OSDeclareDefaultStructors(IOUSBCompositeDriver)
    
public:

IOUSBCompositeDriver_start
IOUSBCompositeDriver_message
IOUSBCompositeDriver_willTerminate
IOUSBCompositeDriver_didTerminate
IOUSBCompositeDriver_ConfigureDevice
IOUSBCompositeDriver_CompositeDriverInterestHandler
IOUSBCompositeDriver_ReConfigureDevice

/*SetConfiguration


Call IOUSBDevice to do a SetConfiguration call to the device. 

virtual IOReturn SetConfiguration(
    UInt8 configValue,
    bool startInterfaceMatching=true);  
Parameters
configValue
The desired configuration value.
startInterfaceMatching
A boolean specifying whether IOKit should begin the process of finding matching drivers for the new IOUSBInterface objects.*/
virtual IOReturn SetConfiguration(
    UInt8 configValue,
    bool startInterfaceMatching=true);  

};

#endif// _IOKIT_IOUSBCompositeDriver_H
