#ifndef _IOKIT_IOUSBHUBDEVICE_H
#define _IOKIT_IOUSBHUBDEVICE_H

#include <IOKit/usb/IOUSBDevice.h>	

class IOUSBHubPolicyMaker;

#include <HYS/IOKit/usb/IOUSBHubDevice.h>

class IOUSBHubDevice : public IOUSBDevice,public IOUSBHubDevice_HYS
{
 OSDeclareDefaultStructors(IOUSBHubDevice)
	friend class IOUSBHubPolicyMaker;
	friend class AppleUSBHub;
	friend class IOUSBController;								
	
private:
protected:
public:

IOUSBHubDevice_InitializeCharacteristics
IOUSBHubDevice_SetHubCharacteristics
IOUSBHubDevice_init
IOUSBHubDevice_SetPolicyMaker
IOUSBHubDevice_ReturnExtraPower
IOUSBHubDevice_RequestExtraPower
IOUSBHubDevice_start
IOUSBHubDevice_free
IOUSBHubDevice_stop
IOUSBHubDevice_NewHubDevice

/*RequestProvidedPower


public

virtual UInt32 RequestProvidedPower(
    UInt32 requestedPower); 
Parameters
requestedPower
- the amount of power requested in milliamps (usually 100ma or 500 ma)
Return Value

the amount of power allocated for this driver in milliamps (usually 100ma or 500 ma) 
Discussion 

requests power from the hub device*/
virtual UInt32 RequestProvidedPower(
    UInt32 requestedPower); 

/*GetPolicyMaker


public

virtual IOUSBHubPolicyMaker *GetPolicyMaker(
    void); 
Return Value

returns an IOUSBHubPolicyMaker* pointing to the policy maker for this hub. returns NULL is no policy maker is active on the hub device. 
Discussion 

returns a pointer to the policy maker for the hub, which can be used as the power plane parent.*/
virtual IOUSBHubPolicyMaker *GetPolicyMaker(
    void); 

/*GetMaxProvidedPower


public

virtual UInt32 GetMaxProvidedPower(); 
Return Value

the power is returned in milliamps - usually 100ma or 500 ma. 
Discussion 

returns the maximum amount of power available on any downstream port of this hub*/
virtual UInt32 GetMaxProvidedPower(); 

/*GetHubCharacteristics


public

virtual UInt32 GetHubCharacteristics(); 
Return Value

returns a bitmap of characteristics 
Discussion 

returns characteristics of the hub device which might be useful for the driver of a device connected to the hub. kIOUSBHubDeviceIsRootHub indicates that the hub is a root hub kIOUSBHubDeviceIsOnHighSpeedBus indicates that the hub is running on a High Speed bus. If this bit is set and kIOUSBHubDeviceIsHighSpeed is clear, then this is a Classic Speed hub running on a High Speed bus, which means that Split Transactions will be used to communicate with downstream devices.*/
virtual UInt32 GetHubCharacteristics(); 

};

#endif /* _IOKIT_IOUSBROOTHUBDEVICE_H */

