#ifndef IOKIT_USB_IOUSBINTERFACEUSERCLIENT_H
#define IOKIT_USB_IOUSBINTERFACEUSERCLIENT_H

#include <libkern/OSByteOrder.h>

#include <IOKit/IOUserClient.h>
#include <IOKit/assert.h>
#include <IOKit/IOLib.h>
#include <IOKit/IOBufferMemoryDescriptor.h>
#include <IOKit/IOMessage.h>
#include <IOKit/usb/IOUSBUserClient.h>
#include <IOKit/usb/IOUSBControllerV2.h>
#include <IOKit/usb/IOUSBDevice.h>
#include <IOKit/usb/IOUSBInterface.h>
#include <IOKit/usb/IOUSBPipe.h>
#include <IOKit/usb/IOUSBLog.h>
#include <IOKit/IOCommandPool.h>
/*
#include <libkern/OSByteOrder.h>

#include <IOKit/assert.h>
#include <IOKit/IOLib.h>
#include <IOKit/IOMessage.h>
#include <IOKit/IOMemoryDescriptor.h>

#include <IOKit/IOUserClient.h>
#include <IOKit/usb/IOUSBUserClient.h>
#include <IOKit/usb/IOUSBDevice.h>
#include <IOKit/usb/IOUSBInterface.h>
#include <IOKit/usb/IOUSBPipe.h>
#include <IOKit/usb/IOUSBLog.h>
#include <IOKit/IOCommandPool.h>
#include <IOKit/usb/IOUSBControllerV2.h>
*/

#include <HYS/IOKit/usb/IOUSBInterfaceUserClient.h>

class IOUSBLowLatencyCommand : public IOCommand,public IOUSBLowLatencyCommand_HYS
{
    OSDeclareAbstractStructors(IOUSBLowLatencyCommand)

private:
public:
IOUSBLowLatencyCommand_SetAsyncReference
IOUSBLowLatencyCommand_SetAsyncCount
IOUSBLowLatencyCommand_NewCommand

};

class IOUSBInterfaceUserClientV2 : public IOUserClient,public IOUSBInterfaceUserClientV2_HYS
{
    OSDeclareDefaultStructors(IOUSBInterfaceUserClientV2)

private:
protected:
public:
IOUSBInterfaceUserClientV2_sMethods

IOUSBInterfaceUserClientV2__open
IOUSBInterfaceUserClientV2__close
IOUSBInterfaceUserClientV2__GetDevice
IOUSBInterfaceUserClientV2__GetBandwidthAvailable
IOUSBInterfaceUserClientV2_LowLatencyReleaseBuffer
IOUSBInterfaceUserClientV2__ReadIsochPipe
IOUSBInterfaceUserClientV2__LowLatencyReleaseBuffer
IOUSBInterfaceUserClientV2_LowLatencyPrepareBuffer
IOUSBInterfaceUserClientV2__LowLatencyPrepareBuffer
IOUSBInterfaceUserClientV2_externalMethod
IOUSBInterfaceUserClientV2__SetAsyncPort
IOUSBInterfaceUserClientV2_LowLatencyIsoReqComplete
IOUSBInterfaceUserClientV2_GetPipeStatus
IOUSBInterfaceUserClientV2_start
IOUSBInterfaceUserClientV2_initWithTask
IOUSBInterfaceUserClientV2_IsoReqComplete
IOUSBInterfaceUserClientV2_DoLowLatencyIsochPipeAsync
IOUSBInterfaceUserClientV2__LowLatencyWriteIsochPipe
IOUSBInterfaceUserClientV2_AddDataBufferToList
IOUSBInterfaceUserClientV2_finalize
IOUSBInterfaceUserClientV2_FindBufferCookieInList
IOUSBInterfaceUserClientV2_SetAsyncReference
IOUSBInterfaceUserClientV2__SetAlternateInterface
IOUSBInterfaceUserClientV2__GetFrameNumber
IOUSBInterfaceUserClientV2_SetAsyncPort
IOUSBInterfaceUserClientV2__GetPipeProperties
IOUSBInterfaceUserClientV2_ReqComplete
IOUSBInterfaceUserClientV2__ReadPipe
IOUSBInterfaceUserClientV2_open
IOUSBInterfaceUserClientV2__WritePipe
IOUSBInterfaceUserClientV2__GetPipeStatus
IOUSBInterfaceUserClientV2__AbortPipe
IOUSBInterfaceUserClientV2__ResetPipe
IOUSBInterfaceUserClientV2_DecrementOutstandingIO
IOUSBInterfaceUserClientV2__ClearPipeStall
IOUSBInterfaceUserClientV2__ControlRequestOut
IOUSBInterfaceUserClientV2__ControlRequestIn
IOUSBInterfaceUserClientV2__SetPipePolicy
IOUSBInterfaceUserClientV2__GetEndpointProperties
IOUSBInterfaceUserClientV2__GetMicroFrameNumber
IOUSBInterfaceUserClientV2__GetFrameListTime
IOUSBInterfaceUserClientV2__GetFrameNumberWithTime
IOUSBInterfaceUserClientV2__WriteIsochPipe
IOUSBInterfaceUserClientV2__LowLatencyReadIsochPipe
IOUSBInterfaceUserClientV2__GetConfigDescriptor
IOUSBInterfaceUserClientV2_IncrementOutstandingIO
IOUSBInterfaceUserClientV2_close
IOUSBInterfaceUserClientV2_GetOutstandingIO
IOUSBInterfaceUserClientV2_AbortPipe
IOUSBInterfaceUserClientV2_SetAlternateInterface
IOUSBInterfaceUserClientV2_GetDevice
IOUSBInterfaceUserClientV2_GetFrameNumber
IOUSBInterfaceUserClientV2_GetMicroFrameNumber
IOUSBInterfaceUserClientV2_GetFrameNumberWithTime
IOUSBInterfaceUserClientV2_GetBandwidthAvailable
IOUSBInterfaceUserClientV2_GetFrameListTime
IOUSBInterfaceUserClientV2_GetEndpointProperties
IOUSBInterfaceUserClientV2_GetConfigDescriptor
IOUSBInterfaceUserClientV2_GetConfigDescriptor_UInt8
IOUSBInterfaceUserClientV2_ReadPipe
IOUSBInterfaceUserClientV2_ReadPipe_UInt8
IOUSBInterfaceUserClientV2_ReadPipe_UInt8_UInt32
IOUSBInterfaceUserClientV2_GetPipeObj
IOUSBInterfaceUserClientV2_WritePipe
IOUSBInterfaceUserClientV2_WritePipe_UInt8
IOUSBInterfaceUserClientV2_WritePipe_UInt8_UInt32
IOUSBInterfaceUserClientV2_GetPipeProperties
IOUSBInterfaceUserClientV2_didTerminate
IOUSBInterfaceUserClientV2_ClearPipeStall
IOUSBInterfaceUserClientV2_ResetPipe
IOUSBInterfaceUserClientV2_SetPipePolicy
IOUSBInterfaceUserClientV2_ControlRequestOut
IOUSBInterfaceUserClientV2_ControlRequestOut_UInt8
IOUSBInterfaceUserClientV2_ControlRequestOut_UInt8_UInt8
IOUSBInterfaceUserClientV2_ControlRequestIn
IOUSBInterfaceUserClientV2_ControlRequestIn_UInt8
IOUSBInterfaceUserClientV2_ControlRequestIn_UInt8_UInt8
IOUSBInterfaceUserClientV2_DoIsochPipeAsync
IOUSBInterfaceUserClientV2_IncreaseCommandPool
IOUSBInterfaceUserClientV2_RemoveDataBufferFromList
IOUSBInterfaceUserClientV2_ChangeOutstandingIO
IOUSBInterfaceUserClientV2_GetGatedOutstandingIO
IOUSBInterfaceUserClientV2_ReleasePreparedDescriptors
IOUSBInterfaceUserClientV2_clientDied
IOUSBInterfaceUserClientV2_clientClose
IOUSBInterfaceUserClientV2_stop
IOUSBInterfaceUserClientV2_free
IOUSBInterfaceUserClientV2_willTerminate
IOUSBInterfaceUserClientV2_message
IOUSBInterfaceUserClientV2_PrintExternalMethodArgs

};

#endif//IOKIT_USB_IOUSBINTERFACEUSERCLIENT_H
