#ifndef _MSCWRAPPERS_H_
#define _MSCWRAPPERS_H_

#include <PCSC/musclecard.h>
#include <security_utilities/utilities.h>

#ifdef _DEBUG_OSTREAM
	#include <ostream>
#endif

#include <Security/cssmerr.h>
#include <security_cdsa_utilities/cssmbridge.h>
#include <security_cdsa_utilities/cssmerrors.h>

#include <HYS/Msc/MscWrappers.h>

class MscKeyACL : public Security::PodWrapper<MscKeyACL, MSCKeyACL>,public MscKeyACL_HYS {
public:

MscKeyACL_read
MscKeyACL_write
MscKeyACL_use

};

class MscObjectACL : public Security::PodWrapper<MscObjectACL, MSCObjectACL> {
public:

};

class MscKeyPolicy : public Security::PodWrapper<MscKeyPolicy, MSCKeyPolicy> ,public MscKeyPolicy_HYS {
public:

MscKeyPolicy_direction

};

class MscKeyInfo : public Security::PodWrapper<MscKeyInfo, MSCKeyInfo>,public MscKeyInfo_HYS{
public:

MscKeyInfo_MscKeyInfo
MscKeyInfo_MscKeyInfo_const_MSCKeyInfo

MscKeyInfo_acl
MscKeyInfo_acl_const
MscKeyInfo_policy
MscKeyInfo_policy_const 
MscKeyInfo_size
MscKeyInfo_type
MscKeyInfo_number

};

class MscObjectInfo : public Security::PodWrapper<MscObjectInfo, MSCObjectInfo>,public MscObjectInfo_HYS {
public:

MscObjectInfo_MscObjectInfo
MscObjectInfo_MscObjectInfo_const_MSCObjectInfo
MscObjectInfo_size
MscObjectInfo_objid

};

class MscTokenInfo : public Security::PodWrapper<MscTokenInfo, MSCTokenInfo>,public MscTokenInfo_HYS {
public:

MscTokenInfo_MscTokenInfo
MscTokenInfo_MscTokenInfo_const_MSCTokenInfo
MscTokenInfo_MscTokenInfo_const_SCARD_READERSTATE

MscKeyInfo_operator

};

class MscStatusInfo : public Security::PodWrapper<MscStatusInfo, MSCStatusInfo> {
public:

};

#endif /* !_MSCWRAPPERS_H_ */

