
#ifndef __NS_SYSTEM_DIRECTORIES_H__
#define __NS_SYSTEM_DIRECTORIES_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <HYS/NSSystemDirectories.h>

/*NSSearchPathDirectory

These constants specify the location of a variety of directories.

typedef enum {
   NSApplicationDirectory = 1,
   NSDemoApplicationDirectory,
   NSDeveloperApplicationDirectory,
   NSAdminApplicationDirectory,
   NSLibraryDirectory,
   NSDeveloperDirectory,
   NSUserDirectory,
   NSDocumentationDirectory,
   NSDocumentDirectory,
   NSCoreServiceDirectory,
   NSDesktopDirectory = 12,
   NSCachesDirectory = 13,
   NSApplicationSupportDirectory = 14,
   NSDownloadsDirectory = 15,
   NSAllApplicationsDirectory = 100,
   NSAllLibrariesDirectory = 101
} NSSearchPathDirectory;

Constants
NSApplicationDirectory

Supported applications (/Applications).

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSDemoApplicationDirectory

Unsupported applications and demonstration versions.

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSDeveloperApplicationDirectory

Developer applications (/Developer/Applications).

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSAdminApplicationDirectory

System and network administration applications. 

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSLibraryDirectory

Various user-visible documentation, support, and configuration files (/Library).

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSDeveloperDirectory

Developer resources (/Developer).

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSUserDirectory

User home directories (/Users).

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSDocumentationDirectory

Documentation.

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSDocumentDirectory

Document directory.

Available in Mac OS X v10.2 and later.

Declared in NSPathUtilities.h.
NSCoreServiceDirectory

Location of core services (System/Library/CoreServices).

Available in Mac OS X v10.4 and later.

Declared in NSPathUtilities.h.
NSDesktopDirectory

Location of user’s desktop directory.

Available in Mac OS X v10.4 and later.

Declared in NSPathUtilities.h.
NSCachesDirectory

Location of discardable cache files (Library/Caches).

Available in Mac OS X v10.4 and later.

Declared in NSPathUtilities.h.
NSApplicationSupportDirectory

Location of application support files (Library/Application Support).

Available in Mac OS X v10.4 and later.

Declared in NSPathUtilities.h.
NSDownloadsDirectory

Location of the user’s downloads directory. 

The NSDownloadsDirectory flag will only produce a path only when the NSUserDomainMask is provided.

Available in Mac OS X v10.5 and later.

Declared in NSPathUtilities.h.
NSAllApplicationsDirectory

All directories where applications can occur.

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSAllLibrariesDirectory

All directories where resources can occur.

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
Availability
Available in Mac OS X v10.0 and later.
Declared In
NSPathUtilities.h*/
typedef enum {
   NSApplicationDirectory = 1,
   NSDemoApplicationDirectory,
   NSDeveloperApplicationDirectory,
   NSAdminApplicationDirectory,
   NSLibraryDirectory,
   NSDeveloperDirectory,
   NSUserDirectory,
   NSDocumentationDirectory,
   NSDocumentDirectory,
   NSCoreServiceDirectory,
   NSDesktopDirectory = 12,
   NSCachesDirectory = 13,
   NSApplicationSupportDirectory = 14,
   NSDownloadsDirectory = 15,
   NSAllApplicationsDirectory = 100,
   NSAllLibrariesDirectory = 101
} NSSearchPathDirectory;

/*NSSearchPathDomainMask

Search path domain constants specifying base locations for the NSSearchPathDirectory type.

typedef enum {
   NSUserDomainMask = 1,
   NSLocalDomainMask = 2,
   NSNetworkDomainMask = 4,
   NSSystemDomainMask = 8,
   NSAllDomainsMask = 0x0ffff,
} NSSearchPathDomainMask;
Constants
NSUserDomainMask

The user’s home directory—the place to install user’s personal items (~).

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSLocalDomainMask

Local to the current machine—the place to install items available to everyone on this machine.

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSNetworkDomainMask

Publicly available location in the local area network—the place to install items available on the network (/Network).

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSSystemDomainMask

Provided by Apple — can’t be modified (/System) .

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
NSAllDomainsMask

All domains. 

Includes all of the above and future items.

Available in Mac OS X v10.0 and later.

Declared in NSPathUtilities.h.
Availability
Available in Mac OS X v10.0 and later.
Declared In
NSPathUtilities.h*/
typedef enum {
   NSUserDomainMask = 1,
   NSLocalDomainMask = 2,
   NSNetworkDomainMask = 4,
   NSSystemDomainMask = 8,
   NSAllDomainsMask = 0x0ffff,
} NSSearchPathDomainMask;

#ifdef __cplusplus
}
#endif

#endif //__NS_SYSTEM_DIRECTORIES_H__

