#ifndef POWER_H
#define POWER_H

#ifndef MACTYPES_H
#include <CarbonCore/MacTypes.h>
#endif

#ifndef MIXEDMODE_H
#include <CarbonCore/MixedMode.h>
#endif

#ifndef MULTIPROCESSING_H
#include <CarbonCore/Multiprocessing.h>
#endif

#ifndef NAMEREGISTRY_H
#include <CarbonCore/NameRegistry.h>
#endif

#ifndef MACERRORS_H
#include <CarbonCore/MacErrors.h>
#endif



#include <AvailabilityMacros.h>

#if PRAGMA_ONCE
#pragma once
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*System Activity Selectors

enum {
   OverallAct = 0,
   UsrActivity = 1,
   NetActivity = 2,
   HDActivity = 3,
   IdleActivity = 4
};

Constants
OverallAct

Delays idle sleep by a small amount. This will only delay power cycling if it's enabled, and will delay sleep by a small amount when hasAggressiveIdling is set.

Available in Mac OS X v10.0 and later.

Declared in Power.h
UsrActivity

Delays idle sleep and dimming by timeout time.

Available in Mac OS X v10.0 and later.

Declared in Power.h
NetActivity

Delays idle sleep and power cycling by small amount.

Available in Mac OS X v10.0 and later.

Declared in Power.h
HDActivity

Delays hard drive spindown and idle sleep by small amount.

Available in Mac OS X v10.0 and later.

Declared in Power.h
IdleActivity

Delays idle sleep by timeout time. The IdleActivity selector is not available unless the hasAggressiveIdling bit is set. Use IdleActivity where you used to use OverallAct if necessary. Don't use IdleActivity unless hasAggressiveIdling is set; when hasAggressiveIdling is not set, the use of IdleActivity is undefined, and will do different things depending on which Power Manager is currently running.

Available in Mac OS X v10.1 and later.

Declared in Power.h*/

enum {
   OverallAct = 0,
   UsrActivity = 1,
   NetActivity = 2,
   HDActivity = 3,
   IdleActivity = 4
};

//func

/*UpdateSystemActivity


OSErr UpdateSystemActivity (
   UInt8 activity
);

Return Value

A result code. See “Power Manager Result Codes.”
Availability
Available in Mac OS X v10.0 and later.
Declared In
Power.h*/
OSErr UpdateSystemActivity (
   UInt8 activity
);


#ifdef __cplusplus
}
#endif

#endif
