#ifndef GLU_H
#define GLU_H

#include <OpenGL/gl.h>

#ifndef __glu_h__
#include <GL/glu.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif

/*GLUCHECKEXTENSION(3G)                                                                  GLUCHECKEXTENSION(3G)



NAME
       gluCheckExtension - determines if an extension name is supported


C SPECIFICATION
       GLboolean gluCheckExtension( const GLubyte *extName,
                                    const GLubyte *extString )


PARAMETERS
       extName    Specifies an extension name.

       extString  Specifies a space-separated list of extension names supported.

DESCRIPTION
       gluCheckExtension returns GL_TRUE if extName is supported otherwise GL_FALSE is returned.

       This  is  used to check for the presence for OpenGL, GLU or GLX extension names by passing the exten-sion extension
       sion strings returned by glGetString, gluGetString, glXGetClientString, glXQueryExtensionsString,  or
       glXQueryServerString, respectively, as extString.

NOTES
       Cases where one extension name is a substring of another are correctly handled.

       There may or may not be leading or trailing blanks in extString.

       Extension names should not contain embedded spaces.

       All strings are null-terminated.

SEE ALSO
       glGetString(3G), gluGetString(3G), glXGetClientString(3G), glXQueryExtensionsString(3G), glXQueryServerString(3G)




                                                                                       GLUCHECKEXTENSION(3G)*/
       GLboolean gluCheckExtension( const GLubyte *extName,
                                    const GLubyte *extString );

#ifdef __cplusplus
}
#endif


#endif
