#import "PDFAnnotation.h"


@class PDFDestination, PDFAnnotationLinkPrivateVars;


@interface PDFAnnotationLink : PDFAnnotation

/*URL

Gets the destination for the link when the destination was specified as a URL.

- (NSURL *)URL
Availability
Available in Mac OS X v10.4 and later.
See Also
– setURL:*/
- (NSURL *)URL;

/*destination

Gets the destination for the link when the destination was specified as a PDFDestination object.

- (PDFDestination *)destination
Availability
Available in Mac OS X v10.4 and later.
See Also
– setDestination:*/
- (PDFDestination *)destination;

/*setURL:

Sets the destination for the link as a URL.

- (void)setURL:(NSURL *)url
Availability
Available in Mac OS X v10.4 and later.
See Also
– URL*/
- (void)setURL:(NSURL *)url;

/*setDestination:

Sets the destination for the link as a PDFDestination object.

- (void)setDestination:(PDFDestination *)destination
Availability
Available in Mac OS X v10.4 and later.
See Also
– destination*/

- (void)setDestination:(PDFDestination *)destination;

@end
