#ifndef AUTHORIZATIONTAGS_H
#define AUTHORIZATIONTAGS_H

/*Name Tags

Specify the type of environment data or right.

   #define kAuthorizationEnvironmentUsername ";username"
#define kAuthorizationEnvironmentPassword ";password"
#define kAuthorizationEnvironmentShared ";shared"
#define kAuthorizationRightExecute ";system.privilege.admin"
#define kAuthorizationEnvironmentPrompt ";prompt"
#define kAuthorizationEnvironmentIcon ";icon"

Constants
kAuthorizationEnvironmentUsername

Specifies a user name.

Available in Mac OS X v10.0 and later.

Declared in AuthorizationTags.h.
kAuthorizationEnvironmentPassword

Specifies a password.

Available in Mac OS X v10.0 and later.

Declared in AuthorizationTags.h.
kAuthorizationEnvironmentShared

Specifies a shared right.

Available in Mac OS X v10.0 and later.

Declared in AuthorizationTags.h.
kAuthorizationRightExecute

Specifies the name of the right associated with the function AuthorizationExecuteWithPrivileges.

Available in Mac OS X v10.0 and later.

Declared in AuthorizationTags.h.
kAuthorizationEnvironmentPrompt

Specifies the name of the authorization item that should be passed into the environment when specifying invocation-specific additional text. The value should be a localized UTF8 string.

Available in Mac OS X v10.3 and later.

Declared in AuthorizationTags.h.
kAuthorizationEnvironmentIcon

Specifies the name of the authorization item that should be passed into the environment when specifying an alternate icon. The value should be a full path to an image compatible with the NSImage class.

Available in Mac OS X v10.3 and later.

Declared in AuthorizationTags.h.
Discussion

These tags are possible values for the name field of an authorization item. This is not an all-inclusive set. You determine the name of the right to request. These environment tags are for future use.*/
   #define kAuthorizationEnvironmentUsername ";username"
#define kAuthorizationEnvironmentPassword ";password"
#define kAuthorizationEnvironmentShared ";shared"
#define kAuthorizationRightExecute ";system.privilege.admin"
#define kAuthorizationEnvironmentPrompt ";prompt"
#define kAuthorizationEnvironmentIcon ";icon"

#endif//AUTHORIZATIONTAGS_H 
