
#ifndef __STANDARDFILE__
#define __STANDARDFILE__


#include <MacTypes.h>
#include <Dialogs.h>
#include <Files.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <HYS/StandardFile.h>

		
/* Constants

//Gestalt selector and reply//
#define gestaltStandardFileAttr  'stdf'
#define gestaltStandardFile58    0
//standard dialog resource IDs//
enum {sfPutDialogID           = (-6043)}; //Save dialog box//
enum {sfGetDialogID           = (-6042)}; //Open dialog box//
//items that appear in both the Open and Save dialog boxes//
enum {sfItemOpenButton        = 1};    //Save or Open button//
enum {sfItemCancelButton      = 2};    //Cancel button//
enum {sfItemBalloonHelp       = 3};    //Balloon Help//
enum {sfItemVolumeUser        = 4};    //volume icon and name//
enum {sfItemEjectButton       = 5};    //Eject button//
enum {sfItemDesktopButton     = 6};    //Desktop button//
enum {sfItemFileListUser      = 7};    //display list//
enum {sfItemPopUpMenuUser     = 8};    //directory pop-up menu//
enum {sfItemDividerLinePict   = 9};    //dividing line between buttons//
//items that appear in Save dialog boxes only//
enum {sfItemFileNameTextEdit  = 10};   //filename field//
enum {sfItemPromptStaticText  = 11};   //filename prompt text area//
enum {sfItemNewFolderUser     = 12};   //New Folder button//
//pseudo-items available prior to version 7.0//
enum {sfHookFirstCall         = (-1)}; //initialize display//
enum {sfHookCharOffset        = 0x1000};//offset for character input//
enum {sfHookNullEvent         = 100};  //null event//
enum {sfHookRebuildList       = 101};  //redisplay list//
enum {sfHookFolderPopUp       = 102};  //display parent-directory menu//
enum {sfHookOpenFolder        = 103};  //display contents of selected //
                                       // folder or volume//
//additional pseudo-items introduced in version 7.0//
enum {sfHookLastCall          = (-2)}; //clean up after display//
enum {sfHookOpenAlias         = 104};  //resolve alias//
enum {sfHookGoToDesktop       = 105};  //display contents of desktop//
enum {sfHookGoToAliasTarget   = 106};  //select target of alias//
enum {sfHookGoToParent        = 107};  //display contents of parent//
enum {sfHookGoToNextDrive     = 108};  //display contents of next drive//
enum {sfHookGoToPrevDrive     = 109};  //display contents of previous drive//
enum {sfHookChangeSelection   = 110};  //select target of reply record//
enum {sfHookSetActiveOffset   = 200};  //switch active item//
//refCon field in the window record in the dialog record//
#define sfMainDialogRefCon       'stdf'   //main dialog box//
#define sfNewFolderDialogRefCon  'nfdr'   //New Folder dialog box//
#define sfReplaceDialogRefCon    'rplc'   //name conflict dialog box//
#define sfStatWarnDialogRefCon   'stat'   //stationery warning//
#define sfErrorDialogRefCon      'err '   //general error report//
#define sfLockWarnDialogRefCon   'lock'   //software lock warning//
//resource IDs and item numbers of pre-7.0 dialog boxes//
enum {putDlgID                = -3999};   //Save dialog box//
enum {putSave                 = 1};       //Save button//
enum {putCancel               = 2};       //Cancel button//
enum {putEject                = 5};       //Eject button//
enum {putDrive                = 6};       //Drive button//
enum {putName                 = 7};       //filename field//

enum {getDlgID                = -4000};   //Open dialog box//
enum {getOpen                 = 1};       //Open button//
enum {getCancel               = 3};       //Cancel button//
enum {getEject                = 5};       //Eject button//
enum {getDrive                = 6};       //Drive button//
enum {getNmList               = 7};       //list of names//
enum {getScroll               = 8};       //scroll bar// */
enum {sfHookFirstCall         = (-1)}; //initialize display//
enum {sfHookRebuildList       = 101};  //redisplay list//
#define sfMainDialogRefCon       'stdf'   //main dialog box//

/*Callback Routine Pointer Types


//dialog hook function//
typedef pascal short (/DlgHookProcPtr)
   		(short item, DialogPtr theDialog);
//dialog hook function with data//
typedef pascal short (/DlgHookYDProcPtr)
   		(short item, DialogPtr theDialog, 
		void /yourDataPtr);
//file filter function//
typedef pascal Boolean (/FileFilterProcPtr)
   		(ParmBlkPtr PB);
//file filter function with data//
typedef pascal Boolean (/FileFilterYDProcPtr)
   		(ParmBlkPtr PB, void /yourDataPtr);
//modal-dialog filter//
typedef pascal ProcPtr ModalFilterProcPtr;
   		(DialogPtr theDialog, EventRecord /theEvent, 
		short /itemHit);
//modal-dialog filter with data//
typedef pascal Boolean (/ModalFilterYDProcPtr)
   		(DialogPtr theDialog, EventRecord /theEvent, 
		short /itemHit, void /yourDataPtr);
//activation procedure//
typedef pascal void (/ActivateYDProcPtr)
   		(DialogPtr theDialog, 
		short itemNo, Boolean activating, 
		void *yourDataPtr);
*/
typedef pascal Boolean (*FileFilterProcPtr)(ParmBlkPtr PB);
//dialog hook function with data//
typedef pascal short (*DlgHookYDProcPtr)
   		(short item, DialogPtr theDialog, 
		void *yourDataPtr);
		//activation procedure//
typedef pascal void (*ActivateYDProcPtr)
   		(DialogPtr theDialog, 
		short itemNo, Boolean activating, 
		void *yourDataPtr);
typedef pascal short (*DlgHookProcPtr)
   		(short item, DialogPtr theDialog);
		
/*Standard File Type List

typedef OSType SFTypeList[4];
*/		
typedef OSType SFTypeList[4];
	
/*Standard File Reply Records

struct StandardFileReply {       //enhanced standard file reply record//
      Boolean        sfGood;     //TRUE if user did not cancel//
      Boolean        sfReplacing;//TRUE if replacing file with same name//
      OSType         sfType;     //file type//
      FSSpec         sfFile;     //selected file, folder, or volume//
      ScriptCode     sfScript;   //script of file, folder, or volume name//
      short          sfFlags;    //Finder flags of selected item//
      Boolean        sfIsFolder; //selected item is a folder//
      Boolean        sfIsVolume; //selected item is a volume//
      long           sfReserved1;//reserved//
      short          sfReserved2;//reserved//
};

typedef struct StandardFileReply StandardFileReply;

struct SFReply {                 //original standard file reply record//
      Boolean        good;       //TRUE if user did not cancel//
      Boolean        copy;       //reserved//
      OSType         fType;      //file type//
      short          vRefNum;    //working directory reference number//
      short          version;    //reserved//
      Str63          fName;      //filename//
};

typedef struct SFReply SFReply;
*/	

struct StandardFileReply {       //enhanced standard file reply record//
      Boolean        sfGood;     //TRUE if user did not cancel//
      Boolean        sfReplacing;//TRUE if replacing file with same name//
      OSType         sfType;     //file type//
      FSSpec         sfFile;     //selected file, folder, or volume//
      ScriptCode     sfScript;   //script of file, folder, or volume name//
      short          sfFlags;    //Finder flags of selected item//
      Boolean        sfIsFolder; //selected item is a folder//
      Boolean        sfIsVolume; //selected item is a volume//
      long           sfReserved1;//reserved//
      short          sfReserved2;//reserved//
};

typedef struct StandardFileReply StandardFileReply;
	
struct SFReply {                 //original standard file reply record//
      Boolean        good;       //TRUE if user did not cancel//
      Boolean        copy;       //reserved//
      OSType         fType;      //file type//
      short          vRefNum;    //working directory reference number//
      short          version;    //reserved//
      Str63          fName;      //filename//
};

typedef struct SFReply SFReply;	
	
//func

/*Opening Files

pascal void StandardGetFile	(const Str255 prompt,
				FileFilterProcPtr fileFilter, 
				short numTypes, SFTypeList typeList, 
				StandardFileReply *reply);
pascal void CustomGetFile	(FileFilterYDProcPtr fileFilter, 
				short numTypes, SFTypeList typeList, 
				StandardFileReply *reply, short dlgID, 
				Point where, DlgHookYDProcPtr dlgHook, 
				ModalFilterYDProcPtr filterProc, 
				short *activeList, 
				ActivateYDProcPtr activateProc, 
				void *yourDataPtr);
pascal void SFGetFile		(Point where, const Str255 prompt, 
				FileFilterProcPtr fileFilter, short numTypes,
				SFTypeList typeList, DlgHookProcPtr dlgHook,
				SFReply *reply);
pascal void SFPGetFile		(Point where, const Str255 prompt,
				FileFilterProcPtr fileFilter,
				short numTypes, SFTypeList typeList,
				DlgHookProcPtr dlgHook, SFReply *reply, 
				short dlgID, ModalFilterProcPtr filterProc);*/
				
/*StandardGetFile
You can use the StandardGetFile procedure to display the default Open dialog box when the user is opening a file.

PROCEDURE StandardGetFile (fileFilter: FileFilterProcPtr;
                           numTypes: Integer; 
                           typeList: SFTypeList; 
                           VAR reply: StandardFileReply);

fileFilter
    A pointer to an optional file filter function, provided by your application, through which StandardGetFile passes files of the specified types. 
numTypes
    The number of file types to be displayed. If you specify a numTypes value of -1, the first filtering passes files of all types. 
typeList
    A list of file types to be displayed. 
reply
    The reply record, which StandardGetFile fills in before returning. 

DESCRIPTION
The StandardGetFile procedure presents a dialog box through which the user specifies the name and location of a file to be opened. While the dialog box is active, StandardGetFile gets and handles events until the user completes the interaction, either by selecting a file to open or by canceling the operation. StandardGetFile returns the user's input in a record of type StandardFileReply.

The fileFilter, numTypes, and typeList parameters together determine which files appear in the displayed list. The first filtering is by file type, which you specify in the numTypes and typeList parameters. The numTypes parameter specifies the number of file types to be displayed. You can specify one or more types. If you specify a numTypes value of -1, the first filtering passes files of all types.

The fileFilter parameter points to an optional file filter function, provided by your application, through which StandardGetFile passes files of the specified types. See "Writing a File Filter Function" on page 3-20 for a description of the file filter function.

ASSEMBLY-LANGUAGE INFORMATION
The trap macro and routine selector for StandardGetFile are
Trap macro	Selector
_Pack3	$0006

SPECIAL CONSIDERATIONS
The StandardGetFile procedure is not available in all versions of system software. Use the Gestalt function to determine whether StandardGetFile is available before calling it.

Because StandardGetFile may move memory, you should not call it at interrupt time.*/
				

pascal void StandardGetFile	(FileFilterProcPtr fileFilter, 
				short numTypes, 
				SFTypeList typeList, 
				StandardFileReply *reply);

/* Standard File Package Routines
Saving Files

pascal void StandardPutFile	(const Str255 prompt, const Str255 defaultName, 
				StandardFileReply *reply);
pascal void CustomPutFile	(const Str255 prompt, const Str255 defaultName, 
				StandardFileReply *reply, short dlgID, 
				Point where, DlgHookYDProcPtr dlgHook, 
				ModalFilterYDProcPtr filterProc, 
				short *activeList, 
				ActivateYDProcPtr activateProc, 
				void *yourDataPtr);
pascal void SFPutFile		(Point where, const Str255 prompt, 
				const Str255 origName, DlgHookProcPtr dlgHook, 
				SFReply *reply);
pascal void SFPPutFile		(Point where, const Str255 prompt, 
				const Str255 origName, DlgHookProcPtr dlgHook, 
				SFReply *reply, short dlgID, 
				ModalFilterProcPtr filterProc);

Opening Files

pascal void StandardGetFile	(const Str255 prompt,
				FileFilterProcPtr fileFilter, 
				short numTypes, SFTypeList typeList, 
				StandardFileReply *reply);
pascal void CustomGetFile	(FileFilterYDProcPtr fileFilter, 
				short numTypes, SFTypeList typeList, 
				StandardFileReply *reply, short dlgID, 
				Point where, DlgHookYDProcPtr dlgHook, 
				ModalFilterYDProcPtr filterProc, 
				short *activeList, 
				ActivateYDProcPtr activateProc, 
				void *yourDataPtr);
pascal void SFGetFile		(Point where, const Str255 prompt, 
				FileFilterProcPtr fileFilter, short numTypes,
				SFTypeList typeList, DlgHookProcPtr dlgHook,
				SFReply *reply);
pascal void SFPGetFile		(Point where, const Str255 prompt,
				FileFilterProcPtr fileFilter,
				short numTypes, SFTypeList typeList,
				DlgHookProcPtr dlgHook, SFReply *reply, 
				short dlgID, ModalFilterProcPtr filterProc); */

pascal void SFPutFile		(Point where, const Str255 prompt, 
				const Str255 origName, DlgHookProcPtr dlgHook, 
				SFReply *reply);
				
/* 				StandardPutFile
You can use the StandardPutFile procedure to display the default Save dialog box when the user is saving a file.

PROCEDURE StandardPutFile (prompt: Str255; defaultName: Str255;
                           VAR reply: StandardFileReply);

prompt
    The prompt message to be displayed over the text field. 
defaultName

    The initial name of the file. 
reply
    The reply record, which StandardPutFile fills in before returning. 

DESCRIPTION
The StandardPutFile procedure presents a dialog box through which the user specifies the name and location of a file to be written to. The dialog box is centered on the screen. While the dialog box is active, StandardPutFile gets and handles events until the user completes the interaction, either by selecting a name and authorizing the save or by canceling the save. The StandardPutFile procedure returns the user's input in a record of type StandardFileReply.

ASSEMBLY-LANGUAGE INFORMATION
The trap macro and routine selector for StandardPutFile are
Trap macro	Selector
_Pack3	$0005

SPECIAL CONSIDERATIONS
The StandardPutFile procedure is not available in all versions of system software. Use the Gestalt function to determine whether StandardPutFile is available before calling it.

Because StandardPutFile may move memory, you should not call it at interrupt time. */
pascal void StandardPutFile	(const Str255 prompt, const Str255 defaultName, 
				StandardFileReply *reply);
				
				
/* 				CustomPutFile
Use the CustomPutFile procedure when your application requires more control over
the Save dialog box than is possible using StandardPutFile.

PROCEDURE CustomPutFile (prompt: Str255; defaultName: Str255; 
                           VAR reply: StandardFileReply; 
                           dlgID: Integer; where: Point; 
                           dlgHook: DlgHookYDProcPtr; 
                           filterProc: ModalFilterYDProcPtr;
                           activeList: Ptr; 
                           activateProc: ActivateYDProcPtr;
                           yourDataPtr: UNIV Ptr);

prompt
    The prompt message to be displayed over the text field. 
defaultName

    The initial name of the file. 
reply
    The reply record, which CustomPutFile fills in before returning. 
dlgID
    The resource ID of a customized dialog template. To use the standard template, set this parameter to 0. 
where
    The upper-left corner of the dialog box, in global coordinates. If you
    specify the point (-1,-1), CustomPutFile automatically centers the
    dialog box on the screen. 
dlgHook
    A pointer to your dialog hook function, which handles item selections received from the Dialog Manager. Specify a value of NIL if you have not added any items to the dialog box and want the standard items handled
    in the standard ways. See "Writing a Dialog Hook Function" on page 3-21 for a description of the dialog hook function. 
filterProc
    A pointer to your modal-dialog filter function, which determines how the ModalDialog procedure filters events when called by the CustomPutFile procedure. Specify a value of NIL if you are not supplying your own function. See "Writing a Modal-Dialog Filter Function" on page 3-28 for a description of the modal-dialog filter function. 
activeList
    A pointer to a list of all dialog items that can be activated--that is, can be
    the target of keyboard input. If you supply an activeList parameter of NIL, CustomPutFile uses the default targets (the filename field and the
    list of files and folders). If you have added any fields that can accept keyboard input, you must modify the list. The list is stored as an array of 16-bit integers. The first integer is the number of items in the list. The remaining integers are the item numbers of all possible keyboard targets,
    in the order that they are activated by the Tab key. 
activateProc

    A pointer to your activation procedure, which controls the highlighting of dialog items that are defined by your application and that can receive keyboard input. See "Writing an Activation Procedure" on page 3-30 for a description of the activation procedure. 
yourDataPtr

    Any 4-byte value; usually, a pointer to optional data supplied by your application. When CustomPutFile calls any of your callback routines,
    it adds this parameter, making the data available to your callback routines. If you are not supplying any data of your own, you can specify
    a value of NIL. 

DESCRIPTION
The CustomPutFile procedure is an alternative to StandardPutFile when you want to display a customized Save dialog box or handle the default dialog box in a customized way. During the dialog, CustomPutFile gets and handles events (possibly with the assistance of application-defined callback routines) until the user completes the interaction, either by selecting a name and authorizing the save operation or by canceling the save operation. The CustomPutFile procedure returns the user's input in a record of type StandardFileReply.

ASSEMBLY-LANGUAGE INFORMATION
The trap macro and routine selector for CustomPutFile are
Trap macro	Selector
_Pack3	$0007

SPECIAL CONSIDERATIONS
The CustomPutFile procedure is not available in all versions of system software.
Use the Gestalt function to determine whether CustomPutFile is available before calling it.

Because CustomPutFile may move memory, you should not call it at interrupt time. */

pascal void CustomPutFile	(const Str255 prompt, const Str255 defaultName, 
				StandardFileReply *reply, short dlgID, 
				Point where, 
				DlgHookYDProcPtr dlgHook, 
				ModalFilterYDProcPtr filterProc, 
				short *activeList, 
				ActivateYDProcPtr activateProc, 
				void *yourDataPtr);
						   
#ifdef __cplusplus
}
#endif

#endif 
