#ifndef  SCNETWORKCONFIGURATION_H
#define SCNETWORKCONFIGURATION_H

#include <AvailabilityMacros.h>
#include <sys/cdefs.h>
#include <CoreFoundation/CoreFoundation.h>
#include <SystemConfiguration/SystemConfiguration.h>


/*Ethernet Bond Aggregation Status (kSCBondStatusDeviceAggregationStatus) codes


enum { 
    kSCBondStatusOK = 0, // enabled, active, running, ... //
    kSCBondStatusLinkInvalid = 1, // The link state was not valid (i.e. down, half-duplex, wrong speed) //
    kSCBondStatusNoPartner = 2, // The port on the switch that the device is connected doesn't seem to have 802.3ad Link Aggregation enabled //
    kSCBondStatusNotInActiveGroup = 3, // We're talking to a partner, but the link aggregation group is different from the one that's active //
    kSCBondStatusUnknown = 999 // Non-specific failure //
};  
Constants
kSCBondStatusOK
Enabled, active, running, ...
kSCBondStatusLinkInvalid
The link state was not valid (i.e. down, half-duplex, wrong speed)
kSCBondStatusNoPartner
The port on the switch that the device is connected doesn't seem to have 802.3ad Link Aggregation enabled
kSCBondStatusNotInActiveGroup
We're talking to a partner, but the link aggregation group is different from the one that's active
kSCBondStatusUnknown
Non-specific failure
Discussion 

Returned status codes. 

Availability
Introduced in Mac OS X v10.4.*/
enum { 
    kSCBondStatusOK = 0, /* enabled, active, running, ... */
    kSCBondStatusLinkInvalid = 1, /* The link state was not valid (i.e. down, half-duplex, wrong speed) */
    kSCBondStatusNoPartner = 2, /* The port on the switch that the device is connected doesn't seem to have 802.3ad Link Aggregation enabled */
    kSCBondStatusNotInActiveGroup = 3, /* We're talking to a partner, but the link aggregation group is different from the one that's active */
    kSCBondStatusUnknown = 999 /* Non-specific failure */
};  

///////////////
/*SCNetworkInterfaceRef

typedef const struct __SCNetworkInterface * SCNetworkInterfaceRef;  
Discussion 

This is the type of a reference to an object that represents a network interface. 
Availability
Introduced in Mac OS X v10.4.*/
typedef const struct __SCNetworkInterface * SCNetworkInterfaceRef;  

/*SCNetworkServiceRef


typedef const struct __SCNetworkService * SCNetworkServiceRef;  
Discussion 

This is the type of a reference to an object that represents a network service. 

Availability
Introduced in Mac OS X v10.4.*/
typedef const struct __SCNetworkService * SCNetworkServiceRef;  

/*SCBondInterfaceRef


typedef SCNetworkInterfaceRef SCBondInterfaceRef;  
Discussion 

This is the type of a reference to an object that represents an Ethernet Bond interface. 

Availability
Introduced in Mac OS X v10.5.*/
typedef SCNetworkInterfaceRef SCBondInterfaceRef;  

/*SCVLANInterfaceRef


typedef SCNetworkInterfaceRef SCVLANInterfaceRef;  
Discussion 

This is the type of a reference to an object that represents a Virtual LAN (VLAN) interface. 

Availability
Introduced in Mac OS X v10.5.*/
typedef SCNetworkInterfaceRef SCVLANInterfaceRef;  

/*SCBondStatusRef


typedef const struct __SCBondStatus * SCBondStatusRef;  
Discussion 

This is the type of a reference to an object that represents the status of an Ethernet Bond interface. 

Availability
Introduced in Mac OS X v10.5.*/
typedef const struct __SCBondStatus * SCBondStatusRef;  

/*SCNetworkSetRef


typedef const struct __SCNetworkSet * SCNetworkSetRef;  
Discussion 

This is the type of a reference to an object that represents a network set. 

Availability
Introduced in Mac OS X v10.4.*/
typedef const struct __SCNetworkSet * SCNetworkSetRef;  

/*SCNetworkProtocolRef


typedef const struct __SCNetworkProtocol * SCNetworkProtocolRef;  
Discussion 

This is the type of a reference to an object that represents a network protocol. 

Availability
Introduced in Mac OS X v10.4.*/
typedef const struct __SCNetworkProtocol * SCNetworkProtocolRef;  

//func

/*SCNetworkInterfaceCopyAll

CFArrayRef // of SCNetworkInterfaceRef's 
SCNetworkInterfaceCopyAll (
    void);  
Return Value

The list of SCNetworkInterface devices on the system. You must release the returned value. 
Discussion 

Returns all network capable devices on the system. 
Availability
Introduced in Mac OS X v10.4.*/
CFArrayRef // of SCNetworkInterfaceRef's 
SCNetworkInterfaceCopyAll (
    void);  

/*SCNetworkInterfaceGetInterfaceType

CFStringRef SCNetworkInterfaceGetInterfaceType (
    SCNetworkInterfaceRef interface);  
Parameters
interface
The network interface.
Return Value

The interface type. 
Discussion 

Returns the associated network interface type. 
Availability
Introduced in Mac OS X v10.4.*/

CFStringRef SCNetworkInterfaceGetInterfaceType (
    SCNetworkInterfaceRef interface);  

/*SCNetworkInterfaceGetBSDName

CFStringRef SCNetworkInterfaceGetBSDName (
    SCNetworkInterfaceRef interface);  
Parameters
interface
The network interface.
Return Value

The BSD name associated with the interface (e.g. "en0"); NULL if no BSD name is available. 
Discussion 

Returns the BSD interface (en0) or device name (modem) for the interface. 
Availability
Introduced in Mac OS X v10.4.*/

CFStringRef SCNetworkInterfaceGetBSDName (
    SCNetworkInterfaceRef interface);  

/*SCNetworkInterfaceGetHardwareAddressString

CFStringRef SCNetworkInterfaceGetHardwareAddressString (
    SCNetworkInterfaceRef interface);  
Parameters
interface
The network interface.
Return Value

A string representing the hardware (MAC) address for the interface. 
Discussion 

Returns a displayable link layer address for the interface. 
Availability
Introduced in Mac OS X v10.4.*/
CFStringRef SCNetworkInterfaceGetHardwareAddressString (
    SCNetworkInterfaceRef interface); 

/*SCNetworkInterfaceGetLocalizedDisplayName

CFStringRef SCNetworkInterfaceGetLocalizedDisplayName (
    SCNetworkInterfaceRef interface);  
Parameters
interface
The network interface.
Return Value

A localized, display name for the interface; NULL if no name is available. 
Discussion 

Returns the localized name (e.g. "Built-in Ethernet") for the interface. 
Availability
Introduced in Mac OS X v10.4.*/
CFStringRef SCNetworkInterfaceGetLocalizedDisplayName (
    SCNetworkInterfaceRef interface);  

/*kSCNetworkInterfaceTypeModem

extern const CFStringRef kSCNetworkInterfaceTypeModem;  
Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeModem;  

/*kSCNetworkInterfaceTypeIEEE80211

extern const CFStringRef kSCNetworkInterfaceTypeIEEE80211;  // IEEE 802.11, AirPort 
Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeIEEE80211;  // IEEE 802.11, AirPort 

/*kSCNetworkInterfaceTypeFireWire

extern const CFStringRef kSCNetworkInterfaceTypeFireWire;  
Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeFireWire;  

/*kSCNetworkInterfaceTypeEthernet

extern const CFStringRef kSCNetworkInterfaceTypeEthernet;  
Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeEthernet;  

/*kSCNetworkInterfaceTypeBluetooth

extern const CFStringRef kSCNetworkInterfaceTypeBluetooth;  
Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeBluetooth;  

/*kSCNetworkInterfaceTypeBond


extern const CFStringRef kSCNetworkInterfaceTypeBond;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeBond;  

/*SCBondInterfaceGetMemberInterfaces


CFArrayRef // of SCNetworkInterfaceRef's 
SCBondInterfaceGetMemberInterfaces (
    SCBondInterfaceRef bond);  
Parameters
bond
The SCBondInterface interface.
Return Value

The list of interfaces. 
Discussion 

Returns the member interfaces for the specified Ethernet Bond interface. 

Availability
Introduced in Mac OS X v10.5.*/
CFArrayRef //*of SCNetworkInterfaceRef's*/
SCBondInterfaceGetMemberInterfaces (
    SCBondInterfaceRef bond);  

/*SCBondInterfaceSetLocalizedDisplayName


Boolean SCBondInterfaceSetLocalizedDisplayName (
    SCBondInterfaceRef bond, 
    CFStringRef newName);  
Parameters
bond
The SCBondInterface interface.
newName
The new display name.
Return Value

TRUE if the configuration was stored; FALSE if an error was encountered. 
Discussion 

Sets the localized display name for the specified Ethernet Bond interface. 

Availability
Introduced in Mac OS X v10.5.*/
Boolean SCBondInterfaceSetLocalizedDisplayName (
    SCBondInterfaceRef bond, 
    CFStringRef newName);  

/*SCBondInterfaceSetOptions


Boolean SCBondInterfaceSetOptions (
    SCBondInterfaceRef bond, 
    CFDictionaryRef newOptions);  
Parameters
bond
The SCBondInterface interface.
newOptions
The new configuration settings.
Return Value

TRUE if the configuration was stored; FALSE if an error was encountered. 
Discussion 

Sets the configuration settings for the specified Ethernet Bond interface. 

Availability
Introduced in Mac OS X v10.5.*/
Boolean SCBondInterfaceSetOptions (
    SCBondInterfaceRef bond, 
    CFDictionaryRef newOptions);  

/*SCBondStatusGetTypeID


CFTypeID SCBondStatusGetTypeID (
    void);  
Discussion 

Returns the type identifier of all SCBondStatus instances. 

Availability
Introduced in Mac OS X v10.5.*/
CFTypeID SCBondStatusGetTypeID (
    void);  

/*kSCNetworkInterfaceTypePPP


extern const CFStringRef kSCNetworkInterfaceTypePPP;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypePPP;  

/*kSCNetworkInterfaceTypeL2TP


extern const CFStringRef kSCNetworkInterfaceTypeL2TP;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeL2TP;  

/*kSCNetworkProtocolTypeAppleTalk


extern const CFStringRef kSCNetworkProtocolTypeAppleTalk;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkProtocolTypeAppleTalk;  

/*kSCNetworkProtocolTypeDNS


extern const CFStringRef kSCNetworkProtocolTypeDNS;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkProtocolTypeDNS;  

/*kSCNetworkProtocolTypeIPv4


extern const CFStringRef kSCNetworkProtocolTypeIPv4;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkProtocolTypeIPv4;  

/*kSCNetworkProtocolTypeIPv6


extern const CFStringRef kSCNetworkProtocolTypeIPv6;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkProtocolTypeIPv6;  

/*kSCNetworkProtocolTypeProxies


extern const CFStringRef kSCNetworkProtocolTypeProxies;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkProtocolTypeProxies;  

/*kSCNetworkProtocolTypeSMB


extern const CFStringRef kSCNetworkProtocolTypeSMB;  

Availability
Introduced in Mac OS X v10.5.*/
extern const CFStringRef kSCNetworkProtocolTypeSMB;  

/*SCNetworkInterfaceCreateWithInterface


SCNetworkInterfaceRef SCNetworkInterfaceCreateWithInterface (
    SCNetworkInterfaceRef interface, 
    CFStringRef interfaceType);  
Parameters
interface
The network interface.
interfaceType
The type of SCNetworkInterface to be layered on top of the provided interface.
Return Value

A reference to the new SCNetworkInterface. You must release the returned value. 
Discussion 

Create a new network interface layered on top of another. For example, this function would be used to create a "PPP" interface on top of a "modem". 

Availability
Introduced in Mac OS X v10.4.*/
SCNetworkInterfaceRef SCNetworkInterfaceCreateWithInterface (
    SCNetworkInterfaceRef interface, 
    CFStringRef interfaceType); 

/*SCNetworkInterfaceGetInterface


SCNetworkInterfaceRef SCNetworkInterfaceGetInterface (
    SCNetworkInterfaceRef interface);  
Parameters
interface
The network interface.
Return Value

The underlying network interface; NULL if this is a leaf interface. 
Discussion 

For layered network interfaces, return the underlying interface. 

Availability
Introduced in Mac OS X v10.4.*/
SCNetworkInterfaceRef SCNetworkInterfaceGetInterface (
    SCNetworkInterfaceRef interface);  

/*SCNetworkServiceCopyProtocol


SCNetworkProtocolRef SCNetworkServiceCopyProtocol (
    SCNetworkServiceRef service, 
    CFStringRef protocolType);  
Parameters
service
The network service.
Return Value

A reference to the SCNetworkProtocol associated with the service; NULL if this protocol has not been added or if an error was encountered. You must release the returned value. 
Discussion 

Returns the network protocol of the specified type for the service. 

Availability
Introduced in Mac OS X v10.4.*/
SCNetworkProtocolRef SCNetworkServiceCopyProtocol (
    SCNetworkServiceRef service, 
    CFStringRef protocolType);  

/*kSCNetworkInterfaceTypeIrDA


extern const CFStringRef kSCNetworkInterfaceTypeIrDA;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeIrDA;  

/*kSCNetworkInterfaceTypeSerial


extern const CFStringRef kSCNetworkInterfaceTypeSerial;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeSerial;  

/*kSCNetworkInterfaceTypeWWAN


extern const CFStringRef kSCNetworkInterfaceTypeWWAN;  

Availability
Introduced in Mac OS X v10.5.*/
extern const CFStringRef kSCNetworkInterfaceTypeWWAN;  

/*SCNetworkServiceGetInterface


SCNetworkInterfaceRef SCNetworkServiceGetInterface (
    SCNetworkServiceRef service);  
Parameters
service
The network service.
Return Value

A reference to the SCNetworkInterface associated with the service; NULL if an error was encountered. 
Discussion 

Returns the network interface associated with the service. 

Availability
Introduced in Mac OS X v10.4.*/
SCNetworkInterfaceRef SCNetworkServiceGetInterface (
    SCNetworkServiceRef service);  

/*SCNetworkServiceGetName


CFStringRef SCNetworkServiceGetName (
    SCNetworkServiceRef service);  
Parameters
service
The network service.
Return Value

The [user specified] name. 
Discussion 

Returns the [user specified] name associated with the service. 

Availability
Introduced in Mac OS X v10.4.*/
CFStringRef SCNetworkServiceGetName (
    SCNetworkServiceRef service);  

/*SCNetworkServiceSetName


Boolean SCNetworkServiceSetName (
    SCNetworkServiceRef service, 
    CFStringRef name);  
Parameters
service
The network service.
name
The [user defined] name to associate with the service.
Return Value

TRUE if the name was saved; FALSE if an error was encountered. 

Note: although not technically required, the [user specified] names for all services within any given set should be unique. As such, an error will be returned if you attemp to name two services with the same string. 
Discussion 

Stores the [user specified] name for the service. 

Availability
Introduced in Mac OS X v10.4.*/
Boolean SCNetworkServiceSetName (
    SCNetworkServiceRef service, 
    CFStringRef name); 

/*kSCNetworkInterfaceTypePPTP


extern const CFStringRef kSCNetworkInterfaceTypePPTP;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypePPTP;  

/*SCNetworkSetCopyServices


CFArrayRef // of SCNetworkServiceRef's 
SCNetworkSetCopyServices (
    SCNetworkSetRef set);  
Parameters
set
The network set.
Return Value

The list of SCNetworkService services associated with the set. You must release the returned value. 
Discussion 

Returns all network services associated with the set. 

Availability
Introduced in Mac OS X v10.4.*/
CFArrayRef /* of SCNetworkServiceRef's */
SCNetworkSetCopyServices (
    SCNetworkSetRef set);  

/*SCNetworkSetGetServiceOrder


CFArrayRef // of serviceID CFStringRef's 
SCNetworkSetGetServiceOrder (
    SCNetworkSetRef set);  
Parameters
set
The network set.
Return Value

The ordered list of CFStringRef service identifiers associated with the set; NULL if no service order has been specified or if an error was encountered. 
Discussion 

Returns the [user specified] ordering of network services within the set. 

Availability
Introduced in Mac OS X v10.4.*/
CFArrayRef /* of serviceID CFStringRef's */
SCNetworkSetGetServiceOrder (
    SCNetworkSetRef set);  

/*SCNetworkSetSetServiceOrder


Boolean SCNetworkSetSetServiceOrder (
    SCNetworkSetRef set, 
    CFArrayRef newOrder);  //
    serviceID CFStringRef's 
Parameters
set
The network set.
newOrder
The ordered list of CFStringRef service identifiers for the set.
Return Value

TRUE if the new service order was saved; FALSE if an error was encountered. 
Discussion 

Stores the [user specified] ordering of network services for the set. 

Availability
Introduced in Mac OS X v10.4.*/
Boolean SCNetworkSetSetServiceOrder (
    SCNetworkSetRef set, 
    CFArrayRef newOrder);  /* 
    serviceID CFStringRef's */

/*kSCNetworkInterfaceTypeVLAN


extern const CFStringRef kSCNetworkInterfaceTypeVLAN;  

Availability
Introduced in Mac OS X v10.4.*/
extern const CFStringRef kSCNetworkInterfaceTypeVLAN;  

/*SCVLANInterfaceCopyAll


CFArrayRef / /of SCVLANInterfaceRef's 
SCVLANInterfaceCopyAll (
    SCPreferencesRef prefs);  
Return Value

The list of VLAN interfaces on the system. You must release the returned value. 
Discussion 

Returns all VLAN interfaces on the system. 

Availability
Introduced in Mac OS X v10.5.*/
CFArrayRef /* of SCVLANInterfaceRef's */
SCVLANInterfaceCopyAll (
    SCPreferencesRef prefs);  

/*SCVLANInterfaceGetPhysicalInterface


SCNetworkInterfaceRef SCVLANInterfaceGetPhysicalInterface (
    SCVLANInterfaceRef vlan);  
Parameters
vlan
The SCVLANInterface interface.
Return Value

The list of interfaces. 
Discussion 

Returns the physical interface for the specified VLAN interface. 

Availability
Introduced in Mac OS X v10.5.*/
SCNetworkInterfaceRef SCVLANInterfaceGetPhysicalInterface (
    SCVLANInterfaceRef vlan);  

/*SCVLANInterfaceGetTag


CFNumberRef SCVLANInterfaceGetTag (
    SCVLANInterfaceRef vlan);  
Parameters
vlan
The SCVLANInterface interface.
Return Value

The tag. 
Discussion 

Returns the tag for the specified VLAN interface. 

Availability
Introduced in Mac OS X v10.5.*/
CFNumberRef SCVLANInterfaceGetTag (
    SCVLANInterfaceRef vlan);  

/*SCVLANInterfaceSetPhysicalInterfaceAndTag


Boolean SCVLANInterfaceSetPhysicalInterfaceAndTag (
    SCVLANInterfaceRef vlan, 
    SCNetworkInterfaceRef physical, 
    CFNumberRef tag);  
Parameters
vlan
The SCVLANInterface interface.
physical
The physical interface to associate with the VLAN.
tag
The tag to associate with the VLAN.
Return Value

TRUE if the configuration was stored; FALSE if an error was encountered. 

Note: the tag must be in the range (1 <= tag <= 4094) 
Discussion 

Updates the specified VLAN interface. 

Availability
Introduced in Mac OS X v10.5.*/
Boolean SCVLANInterfaceSetPhysicalInterfaceAndTag (
    SCVLANInterfaceRef vlan, 
    SCNetworkInterfaceRef physical, 
    CFNumberRef tag);  

/*SCVLANInterfaceSetLocalizedDisplayName


Boolean SCVLANInterfaceSetLocalizedDisplayName (
    SCVLANInterfaceRef vlan, 
    CFStringRef newName);  
Parameters
vlan
The SCVLANInterface interface.
newName
The new display name.
Return Value

TRUE if the configuration was stored; FALSE if an error was encountered. 
Discussion 

Sets the localized display name for the specified VLAN interface. 

Availability
Introduced in Mac OS X v10.5.*/
Boolean SCVLANInterfaceSetLocalizedDisplayName (
    SCVLANInterfaceRef vlan, 
    CFStringRef newName);  

/*SCVLANInterfaceSetOptions


Boolean SCVLANInterfaceSetOptions (
    SCVLANInterfaceRef vlan, 
    CFDictionaryRef newOptions);  
Parameters
vlan
The SCVLANInterface interface.
newOptions
The new configuration settings.
Return Value

TRUE if the configuration was stored; FALSE if an error was encountered. 
Discussion 

Sets the configuration settings for the specified VLAN interface. 

Availability
Introduced in Mac OS X v10.5.*/
Boolean SCVLANInterfaceSetOptions (
    SCVLANInterfaceRef vlan, 
    CFDictionaryRef newOptions);  

/*kSCNetworkInterfaceIPv4


extern const SCNetworkInterfaceRef kSCNetworkInterfaceIPv4;  
Discussion 

A network interface that can used for layering other interfaces (e.g. 6to4, PPTP, L2TP) over an existing IPv4 network. 

Availability
Introduced in Mac OS X v10.4.*/
extern const SCNetworkInterfaceRef kSCNetworkInterfaceIPv4;  

#endif//SCNETWORKCONFIGURATION_H

