#import <Foundation/Foundation.h>
#import <WebKit/WebScriptObject.h>

@class DOMDocument; 
@class DOMDocumentType;
@class DOMElement;
@class DOMNamedNodeMap;
@class DOMNodeList;

@protocol DOMEventTarget;

@interface DOMObject : WebScriptObject <NSCopying>
@end

@interface DOMImplementation : DOMObject
@end

@interface DOMNode : DOMObject <DOMEventTarget>
@end

@interface DOMNodeList : DOMObject
@end

@interface DOMNamedNodeMap : DOMObject
@end

@interface DOMCharacterData : DOMNode
@end

@interface DOMAttr : DOMNode
@end

@interface DOMElement : DOMNode
@end

@interface DOMText : DOMCharacterData
@end

@interface DOMComment : DOMCharacterData
@end

@interface DOMCDATASection : DOMText
@end

@interface DOMDocumentType : DOMNode
@end

@interface DOMNotation : DOMNode
@end

@interface DOMEntity : DOMNode
@end

@interface DOMEntityReference : DOMNode
@end

@interface DOMProcessingInstruction : DOMNode
@end

@interface DOMDocumentFragment : DOMNode
@end

@interface DOMDocument : DOMNode
@end
