#import <Cocoa/Cocoa.h>
#import <WebKit/WebDocument.h>

@class NSMutableURLRequest;
@class NSURLConnection;
@class NSURLRequest;
@class NSURLResponse;
@class WebArchive;
@class WebDataSourcePrivate;
@class WebFrame;
@class WebResource;

@interface WebDataSource : NSObject

/*request

Returns the request that was used to create the receiver.

-(NSMutableURLRequest *)request
Discussion

The URL returned may be different from the original request. A WebView’s resource load delegate may modify requests by implementing webView:resource:willSendRequest:redirectResponse:fromDataSource:.
Availability
Available in Mac OS X v10.2 with Safari 1.0 and later.
Available in Mac OS X v10.2.7 and later.
See Also
– initialRequest
– response*/
-(NSMutableURLRequest *)request;

/*pageTitle

Returns the title of the receiver’s page.

- (NSString *)pageTitle
Discussion

May return nil if the page has no title, or the page title hasn’t been loaded yet. The WebView will notify its frame load delegate when the page title is loaded by invoking the webView:didReceiveTitle:forFrame: delegate method.
Availability
Available in Mac OS X v10.2 with Safari 1.0 and later.
Available in Mac OS X v10.2.7 and later.
See Also
– data
– isLoading
– representation*/

- (NSString *)pageTitle;

@end

