#ifndef _WINDEF_
#define _WINDEF_


#ifdef __cplusplus
extern "C" {
#endif

#include <Wine/winnt.h>

# ifndef __declspec
#  define __declspec(x)   __ONLY_IN_WINELIB(/* nothing */)
# endif

#ifdef __WINESRC__
#define __ONLY_IN_WINELIB(x)	do_not_use_this_in_wine
#else
#define __ONLY_IN_WINELIB(x)	x
#endif

#define APIENTRY    WINAPI
#define WINAPI      __stdcall
#define CALLBACK    __stdcall

#ifndef __stdcall
# ifdef __i386__
#  ifdef __GNUC__
#   ifdef __APPLE__ /* Mac OS X uses a 16-byte aligned stack and not a 4-byte one */
#    define __stdcall __attribute__((__stdcall__)) __attribute__((__force_align_arg_pointer__))
#   else
#    define __stdcall __attribute__((__stdcall__))
#   endif
#  elif defined(_MSC_VER)
    /* Nothing needs to be done. __stdcall already exists */
#  else
#   error You need to define __stdcall for your compiler
#  endif
# elif defined(__x86_64__) && defined (__GNUC__)
#  define __stdcall __attribute__((ms_abi))
# else  /* __i386__ */
#  define __stdcall
# endif  /* __i386__ */
#endif /* __stdcall */

#ifdef TRUE
#undef TRUE
#endif
#define TRUE  1


#ifdef MAX_PATH /* Work-around for Mingw */ 
#undef MAX_PATH
#endif /* MAX_PATH */

#define MAX_PATH        260
#define PASCAL      __stdcall
#define HIWORD(l)              ((WORD)((DWORD_PTR)(l) >> 16))
#define LOWORD(l)              ((WORD)((DWORD_PTR)(l) & 0xFFFF))

/////////////////////////////////

DECLARE_HANDLE(HWND);
DECLARE_HANDLE(HKEY);
DECLARE_HANDLE(HINSTANCE);
DECLARE_HANDLE(HHOOK);
DECLARE_HANDLE(HRGN);
DECLARE_HANDLE(HDC);
DECLARE_HANDLE(HBITMAP);

typedef int             BOOL,       *PBOOL,    *LPBOOL;
typedef unsigned int    UINT,       *PUINT;
typedef void                                   *LPVOID;
typedef unsigned short  WORD,       *PWORD,    *LPWORD;
typedef int             INT,        *PINT,     *LPINT;
typedef unsigned char   BYTE,       *PBYTE,    *LPBYTE;

typedef LONG_PTR        LRESULT;
typedef LONG_PTR        LPARAM;
typedef UINT_PTR        WPARAM;

#ifdef _MSC_VER
typedef unsigned long   DWORD,      *PDWORD,   *LPDWORD;
typedef unsigned long   ULONG,      *PULONG;
#else
typedef unsigned int    DWORD,      *PDWORD,   *LPDWORD;
typedef unsigned int    ULONG,      *PULONG;
#endif

////////////////////
typedef struct _FILETIME {
#ifdef WORDS_BIGENDIAN
    DWORD  dwHighDateTime;
    DWORD  dwLowDateTime;
#else
    DWORD  dwLowDateTime;
    DWORD  dwHighDateTime;
#endif
} FILETIME, *PFILETIME, *LPFILETIME;
#define _FILETIME_

typedef struct tagPOINT
{
    LONG  x;
    LONG  y;
} POINT, *PPOINT, *LPPOINT;

typedef struct _POINTL
{
    LONG x;
    LONG y;
} POINTL, *PPOINTL;

#ifdef __cplusplus
}
#endif

#endif /* _WINDEF_ */
