#ifndef _WINNT_
#define _WINNT_

#include <Wine/basetsd.h>
#include <Wine/guiddef.h>

#ifndef RC_INVOKED
#include <ctype.h>
#include <stddef.h>
#include <string.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif

#ifdef STRICT
#define DECLARE_HANDLE(a) typedef struct a##__ { int unused; } *a
#else /*STRICT*/
#define DECLARE_HANDLE(a) typedef HANDLE a
#endif /*STRICT*/

#define	DLL_PROCESS_ATTACH	1
#define STDMETHODIMP            HRESULT STDMETHODCALLTYPE
#define STDMETHODCALLTYPE       __stdcall
#define STDMETHODIMP_(type)     type STDMETHODCALLTYPE

#ifdef __cplusplus
# define EXTERN_C    extern "C"
#else
# define EXTERN_C    extern
#endif

#if defined(__MSC_VER) || defined(__MINGW32__) || defined(__CYGWIN__)
# define DECLSPEC_HIDDEN
#elif defined(__GNUC__) && ((__GNUC__ > 3) || ((__GNUC__ == 3) && (__GNUC_MINOR__ >= 3)))
# define DECLSPEC_HIDDEN __attribute__((visibility ("hidden")))
#else
# define DECLSPEC_HIDDEN
#endif

///////////////
#ifndef VOID
#define VOID void
#endif
typedef VOID           *PVOID;

typedef void *HANDLE;
typedef char            CHAR,       *PCHAR;
#ifdef _MSC_VER
typedef long            LONG,       *PLONG;
#else
typedef int             LONG,       *PLONG;
#endif

typedef const CHAR     *PCSTR,      *LPCSTR;
typedef CHAR           *PSTR,       *LPSTR,     *NPSTR;
typedef WORD            LANGID;

# ifdef UNICODE

#  define __TEXT(string) L##string

# ifndef _TCHAR_DEFINED
typedef WCHAR           TCHAR,      *PTCHAR;
# define _TCHAR_DEFINED
#endif

typedef LPCWSTR         PCTSTR,      LPCTSTR;
# else  /* UNICODE */
#  define __TEXT(string) string

# ifndef _TCHAR_DEFINED
typedef CHAR            TCHAR,      *PTCHAR;
# define _TCHAR_DEFINED
#endif

typedef LPCSTR          PCTSTR,      LPCTSTR;
# endif /* UNICODE */
# define TEXT(quote) __TEXT(quote)

#ifndef _HRESULT_DEFINED
#define _HRESULT_DEFINED
typedef LONG            HRESULT;
#endif

#ifdef __cplusplus
}
#endif

#endif  /* _WINNT_ */
