#import <Foundation/Foundation.h>
#import <XgridFoundation/XGResource.h>


//#import <HYS/XgridFoundation/XGJob.h>
//#import <APPLE/XgridFoundation/XGJob.h>

/* Data Types & Constants

All of the new data types and constants in this header file are listed alphabetically, with links to documentation and abstracts, if available.
XGJobSpecificationApplicationIdentifierKey	
XGJobSpecificationArgumentsKey	
XGJobSpecificationArgumentTypeKey	
XGJobSpecificationCommandKey	
XGJobSpecificationDependsOnJobsKey	
XGJobSpecificationDependsOnTasksKey	
XGJobSpecificationEnvironmentKey	
XGJobSpecificationFileDataKey	
XGJobSpecificationGridIdentifierKey	
XGJobSpecificationInputFileMapKey	
XGJobSpecificationInputFilesKey	
XGJobSpecificationInputStreamKey	
XGJobSpecificationIsExecutableKey	
XGJobSpecificationNameKey	
XGJobSpecificationNotificationEmailKey	
XGJobSpecificationPathIdentifierKey	
XGJobSpecificationSchedulerParametersKey	
XGJobSpecificationSubmissionIdentifierKey	
XGJobSpecificationTaskPrototypeIdentifierKey	
XGJobSpecificationTaskPrototypesKey	
XGJobSpecificationTaskSpecificationsKey	
XGJobSpecificationTypeKey	
XGJobSpecificationTypeTaskListValue	 */

extern NSString * const XGJobSpecificationApplicationIdentifierKey;
extern NSString * const XGJobSpecificationArgumentsKey	;
extern NSString * const XGJobSpecificationArgumentTypeKey;	
extern NSString * const XGJobSpecificationCommandKey	;
extern NSString * const XGJobSpecificationDependsOnJobsKey	;
extern NSString * const XGJobSpecificationDependsOnTasksKey	;
extern NSString * const XGJobSpecificationEnvironmentKey	;
extern NSString * const XGJobSpecificationFileDataKey	;
extern NSString * const XGJobSpecificationGridIdentifierKey	;
extern NSString * const XGJobSpecificationInputFileMapKey	;
extern NSString * const XGJobSpecificationInputFilesKey	;
extern NSString * const XGJobSpecificationInputStreamKey;	
extern NSString * const XGJobSpecificationIsExecutableKey;	
extern NSString * const XGJobSpecificationNameKey	;
extern NSString * const XGJobSpecificationNotificationEmailKey	;
extern NSString * const XGJobSpecificationPathIdentifierKey	;
extern NSString * const XGJobSpecificationSchedulerParametersKey	;
extern NSString * const XGJobSpecificationSubmissionIdentifierKey	;
extern NSString * const XGJobSpecificationTaskPrototypeIdentifierKey;	
extern NSString * const XGJobSpecificationTaskPrototypesKey	;
extern NSString * const XGJobSpecificationTaskSpecificationsKey	;
extern NSString * const XGJobSpecificationTypeKey	;
extern NSString * const XGJobSpecificationTypeTaskListValue;

@class XGJobInternal;

@interface XGJob : XGResource

/*performStopAction


Attempts to stop the job represented by the receiver. 
- (XGActionMonitor *)performStopAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performStopAction;

/*performDeleteAction


Attempts to delete the job represented by the receiver. 
- (XGActionMonitor *)performDeleteAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performDeleteAction;

/*performGetSpecificationAction


Attempts to retrieve the specification used to submit the job represented by the reciever. 
- (XGActionMonitor *)performGetSpecificationAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performGetSpecificationAction;

/*performGetOutputStreamsAction


Attempts to retrieve a list of output streams for the job represented by the receiver. 
- (XGActionMonitor *)performGetOutputStreamsAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performGetOutputStreamsAction;

/*performGetOutputFilesAction


Attempts to retrieve a list of output files for the job represented by the receiver. 
- (XGActionMonitor *)performGetOutputFilesAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performGetOutputFilesAction;

@end

