#ifndef HFS_FORMAT_H
#define HFS_FORMAT_H

#include <sys/types.h>
#include <sys/appleapiopts.h>
#include <HYS/hfs/hfs_format.h>


#ifdef __cplusplus
extern "C" {
#endif

/*Journal Info Block

The journal info block describes where the journal header and journal buffer are stored. The journal info block is stored at the beginning of the allocation block whose number is stored in the journalInfoBlock field of the volume header. The journal info block is described by the data type JournalInfoBlock.struct JournalInfoBlock {
    UInt32    flags;
    UInt32    device_signature[8];
    UInt64    offset;
    UInt64    size;
    UInt32    reserved[32];
};
typedef struct JournalInfoBlock JournalInfoBlock;


The fields have the following meaning:*/
struct JournalInfoBlock {
    UInt32    flags;
    UInt32    device_signature[8];
    UInt64    offset;
    UInt64    size;
    UInt32    reserved[32];
};
typedef struct JournalInfoBlock JournalInfoBlock;

#ifdef __cplusplus
}
#endif

#endif //HFS_FORMAT_H

