#ifndef OS_OSBOOLEAN_H
#define OS_OSBOOLEAN_H

#include <libkern/c++/OSObject.h>

#ifdef __cplusplus
class OSString;
#endif //__cplusplus

#include <HYS/libkern/c++/OSBoolean.h>

#ifdef __cplusplus
class OSBoolean : public OSObject,public OSBoolean_HYS
{
    OSDeclareDefaultStructors(OSBoolean)

protected:
public:
 
/*isFalse


Tests if the Boolean object is false. 

public

virtual bool isFalse() const; 
Return Value

Returns true if the OSBoolean object is false, false otherwise.*/
virtual bool isFalse() const; 

/*getValue


Obtains the value of the OSBoolean object as the standard C++ type bool. 

public

virtual bool getValue() const; 
Return Value

The value of the OSBoolean object.*/
virtual bool getValue() const; 

/*&isTrue


A member function to test if the Boolean object is true. 

public

virtual bool isTrue() const; 
Return Value

Returns true if the OSBoolean object is true, false otherwise.*/
virtual bool isTrue() const; 

};


/*kOSBooleanTrue


The OSBoolean constant for "true". 
extern OSBoolean * const & kOSBooleanTrue;  
Discussion 

The OSBoolean constant for "true". The object does not need to be retained or released. Comparisons of the form (booleanObject == kOSBooleanTrue) are acceptable and would be equivalent to (booleanObject->getValue() == true).*/
extern OSBoolean * const & kOSBooleanTrue;

/*kOSBooleanFalse


The OSBoolean constant for "false". 

extern OSBoolean * const & kOSBooleanFalse;  
Discussion 

The OSBoolean constant for "false". The object does not need to be retained or released. Comparisons of the form (booleanObject == kOSBooleanFalse) are acceptable and would be equivalent to (booleanObject->getValue() == false).*/

extern OSBoolean * const & kOSBooleanFalse;  
#endif //__cplusplus

#endif//OS_OSBOOLEAN_H
