#ifndef OC_LINUX_TYPES_H
#define OC_LINUX_TYPES_H

#ifdef OC_fd_set
	#define fd_set org_fd_set
#else
	#define OC_fd_set
#endif

#ifdef __dev_t_defined
	#define  dev_t org_dev_t
#else
	#define OC_dev_t
#endif

#ifdef __mode_t_defined
	#define mode_t org_mode_t
#else
	#define OC_mode_t
#endif

#ifdef __nlink_t_defined
	#define nlink_t org_nlink_t
#else
	#define OC_nlink_t
#endif

#ifdef __pid_t_defined
	#define  pid_t org_pid_t
#else
	#define OC_pid_t
#endif

#ifdef __timer_t_defined
	#define timer_t org_timer_t
#else
	#define OC_timer_t
#endif

#ifdef __clockid_t_defined
	#define clockid_t org_clockid_t
#else
	#define OC_clockid_t
#endif

#ifdef __uid_t_defined
	#define  uid_t org_uid_t
#else
	#define OC_uid_t
#endif

#ifdef __gid_t_defined
	#define gid_t org_gid_t
#else
	#define OC_gid_t
#endif

#ifdef __time_t_defined
	#define _TIME_T
#endif

#ifdef __clock_t_defined
	#define _CLOCK_T
#endif

#ifdef __blkcnt_t_defined
	#define blkcnt_t org_blkcnt_t
#else
	#ifndef HAVE_BLKCNT_T
		#define OC_blkcnt_t
	#endif
#endif

#define OC_int8_t
#define OC_int16_t
#define OC_int32_t
#define OC_suseconds_t

/////////////////

#ifndef OC_LINUX_TYPES_H_DEF
#define OC_LINUX_TYPES_H_DEF

#ifdef _LINUX_TYPES_H
	#undef _LINUX_TYPES_H
#endif//_LINUX_TYPES_H

#include "/usr/include/linux/types.h"

#endif//OC_LINUX_TYPES_H


//////////////////////

#ifdef blkcnt_t
	#undef blkcnt_t
#endif

#ifdef gid_t
	#undef gid_t
#endif

#ifdef uid_t
	#undef uid_t
#endif

#ifdef clockid_t
	#undef clockid_t
#endif

#ifdef timer_t
	#undef timer_t
#endif

#ifdef pid_t
	#undef pid_t
#endif

#ifdef nlink_t
	#undef nlink_t
#endif

#ifdef mode_t
	#undef mode_t
#endif

#ifdef dev_t
	#undef dev_t
#endif

#ifdef fd_set
	#undef fd_set
#endif

#define OC_uint8_t
#define OC_uint16_t
#define OC_uint32_t
#define OC_uint64_t
#define OC_u_char
#define OC_u_short
#define OC_u_int
#define OC_u_long
#define OC_loff_t
#define OC_ino_t
#define OC_dev_t
#define OC_off_t
#define OC_daddr_t
#define OC_key_t
#define OC_ulong
#define OC_ushort
#define OC_uint
#define OC_u_int8_t
#define OC_u_int16_t
#define OC_u_int32_t
#define OC_u_int64_t
#define OC_int64_t

#ifdef __KERNEL_STRICT_NAMES_DEF
	//#define __KERNEL_STRICT_NAMES
//	#undef  __KERNEL_STRICT_NAMES_DEF
#endif

#endif//OC_LINUX_TYPES_H
