
#ifndef _MALLOC_MALLOC_H_
#define _MALLOC_MALLOC_H_

#include <stddef.h>
#include <mach/mach_types.h>
#include <sys/cdefs.h>
#include <HYS/malloc/malloc.h>

/*MALLOC_SIZE(3)           BSD Library Functions Manual           MALLOC_SIZE(3)

NAME
     malloc_good_size, malloc_size -- memory allocation information

SYNOPSIS
     #include <malloc/malloc.h>

     size_t
     malloc_good_size(size_t size);

     size_t
     malloc_size(const void *ptr);

DESCRIPTION
     The malloc_size() function returns the size of the memory block that
     backs the allocation pointed to by ptr.  The memory block size is always
     at least as large as the allocation it backs, and may be larger.

     The malloc_good_size() function rounds size up to a value that the allo-cator allocator
     cator implementation can allocate without adding any padding; it then
     returns that rounded-up value.

SEE ALSO
     malloc(3)

BSD                              May 23, 2006                              BSD*/

     size_t     malloc_size(const void *ptr);

#endif 
