#ifndef OC_POSIX_PTHREAD_H
#define OC_POSIX_PTHREAD_H

//#include <time.h>//struct timespec

#ifdef __linux__
#define __sigsetjmp orig__sigsetjmp
#define __sigsetjmp_DEF
#endif

#include "/usr/include/pthread.h"

#ifdef __sigsetjmp_DEF
#undef __sigsetjmp
#undef __sigsetjmp_DEF
#endif

//#undef PTHREAD_MUTEX_RECURSIVE //cygwin have this.

#include <HYS/pthread.h>
//func

/*NAME    [Toc]    [Back]

     pthread_main_np -- identify the initial thread

LIBRARY    [Toc]    [Back]

     Reentrant C Library (libc_r, -lc_r)

SYNOPSIS    [Toc]    [Back]

     #include <pthread_np.h>

     int
     pthread_main_np(void);

DESCRIPTION    [Toc]    [Back]

     The pthread_main_np() function is used in userland threads environment to
     identify the initial thread.  Its semantics is similar to the Solaris's
     thr_main() function.

RETURN VALUES    [Toc]    [Back]

     The pthread_main_np() function returns 1 if the calling thread is the
     initial thread, 0 if the calling thread is not the initial thread, and -1
     if the thread's initialization has not yet completed.

SEE ALSO    [Toc]    [Back]

     pthread_create(3), pthread_equal(3), pthread_self(3)

AUTHORS    [Toc]    [Back]

     This manual page was written by Alexey Zelkin <phantom@FreeBSD.org>.


FreeBSD 5.2.1		       February 13, 2003		 FreeBSD 5.2.1*/
int pthread_main_np(void);

#endif //OC_POSIX_PTHREAD_H


