#ifndef _H_CDSA_CLIENT_ACLCLIENT
#define _H_CDSA_CLIENT_ACLCLIENT  1

#include <security_cdsa_utilities/cssmaclpod.h>
#include <security_cdsa_utilities/cssmacl.h>
#include <security_cdsa_utilities/cssmcred.h>
#include <security_utilities/refcount.h>
#include <security_utilities/globalizer.h>

#include <HYS/security_cdsa_client/aclclient.h>

namespace Security {
namespace CssmClient {

class CSP;

class AclBearer : public virtual RefCount {
public:
};


class KeyAclBearer : public AclBearer {
public:
protected:
};


class AclFactory :public AclFactory_HYS{
public:
protected:
	class KeychainCredentials {
	public:
    	protected:
	};//KeychainCredentials
    
public:
    
    class PassphraseUnlockCredentials : public KeychainCredentials {
    public:
    
    };//PassphraseUnlockCredentials
        
	
    class PasswordChangeCredentials : public KeychainCredentials {
    public:
    };//PasswordChangeCredentials
	
public:
	class AnyResourceContext : public ResourceControlContext {
	public:
		
	private:
	};//AnyResourceContext

public:

	struct Subject : public TypedList ,public AclFactory_HYS::Subject_HYS{
	Security_CssmClient_AclFactory_Subject_Subject
	Security_CssmClient_AclFactory_Subject
	};
	

	struct AnySubject : public Subject ,public AclFactory_HYS::AnySubject_HYS{
	Security_CssmClient_AclFactory_AnySubject_AnySubject
	};
	

	struct NobodySubject : public Subject,public AclFactory_HYS::NobodySubject_HYS {
	Security_CssmClient_AclFactory_NobodySubject_NobodySubject

	};

	struct PWSubject : public Subject,public AclFactory_HYS::PWSubject_HYS {
	Security_CssmClient_AclFactory_PWSubject_PWSubject
	Security_CssmClient_AclFactory_PWSubject_PWSubject_const_CssmData

	};

	struct PromptPWSubject : public Subject,public AclFactory_HYS::PromptPWSubject_HYS {
	Security_CssmClient_AclFactory_PromptPWSubject_PromptPWSubject
	Security_CssmClient_AclFactory_PromptPWSubject_PromptPWSubject_const_CssmData
	};

	struct ProtectedPWSubject : public Subject {

	};
	

	struct PinSubject : public Subject,public AclFactory_HYS::PinSubject_HYS {
		Security_CssmClient_AclFactory_PinSubject_PinSubject
	};
	
	
	struct PinSourceSubject : public Subject {
	
	};
};


} // end namespace CssmClient
} // end namespace Security

#endif // _H_CDSA_CLIENT_ACLCLIENT
