#ifndef _H_CDSA_CLIENT_CSSMCLIENT
#define _H_CDSA_CLIENT_CSSMCLIENT  1

#include <security_utilities/threading.h>
#include <security_utilities/globalizer.h>
#include <security_utilities/refcount.h>
#include <security_cdsa_utilities/cssmalloc.h>
#include <security_cdsa_utilities/cssmpods.h>
#include <map>

#include <HYS/security_cdsa_client/cssmclient.h>

namespace Security {
namespace CssmClient {


class Cssm;
class Module;
class Attachment;

class HasGuid {
public:
protected:
private:
};

class Error : public CssmError {
public:
};


class Object;

class ObjectImpl : virtual public RefCount ,public ObjectImpl_HYS{
public:
Security_CssmClient_ObjectImpl_ObjectImpl
Security_CssmClient_ObjectImpl_ObjectImpl_const_Object

protected:
private:
};


class Object:public Object_HYS {
	friend class ObjectImpl;
public:

Security_CssmClient_Object_Impl

Security_CssmClient_Object_Object
Security_CssmClient_Object_mImpl

protected:
public:
private:

};


class ModuleImpl;

class RawModuleEvents {
	friend class ModuleImpl;
public:
private:
};

class ModuleEvents : public RawModuleEvents {
public:
protected:

};

class ModuleImpl : public ObjectImpl, public HasGuid,public ModuleImpl_HYS {
public:

Security_CssmClient_ModuleImpl_ModuleImpl_const_Guid
Security_CssmClient_ModuleImpl_ModuleImpl_const_Guid_const_Cssm

protected:
};

class Module : public Object,public Module_HYS {
public:

Security_CssmClient_Module_Impl

Security_CssmClient_Module_Module_Impl
Security_CssmClient_Module_Module
Security_CssmClient_Module_Module_const_Guid
Security_CssmClient_Module_Module_const_Guid_const_Cssm

};



class AttachmentImpl : public ObjectImpl,public AttachmentImpl_HYS {
public:

Security_CssmClient_AttachmentImpl_AttachmentImpl_const_Guid
Security_CssmClient_AttachmentImpl_AttachmentImpl_const_Module
Security_CssmClient_Attachment_AttachmentImpl

protected:
private:
};

class Attachment : public Object,public Attachment_HYS {
public:

Security_CssmClient_Attachment_Attachment_Impl_DATATYPE

Security_CssmClient_Attachment_Attachment_Impl
Security_CssmClient_Attachment_Attachment_const_Guid
Security_CssmClient_Attachment_Attachment_const_Module

};

class Cssm;

class CssmImpl : public ObjectImpl {
    class StandardCssm; friend class StandardCssm;
public:
protected:
private:
public:
private:

    class StandardCssm : public Mutex {
    public:
    private:
    };//StandardCssm
    
};

class Cssm : public Object, Cssm_HYS{
public:

Security_CssmClient_Cssm_Impl

Security_CssmClient_Cssm_Cssm_Impl
Security_CssmClient_Cssm_Cssm

};

} // end namespace CssmClient 

} // end namespace Security

#endif // _H_CDSA_CLIENT_CSSMCLIENT
