#ifndef _CSSMACLPOD
#define _CSSMACLPOD

#include <security_utilities/utilities.h>
#include <security_cdsa_utilities/cssmlist.h>
#include <security_cdsa_utilities/cssmalloc.h>

#include <HYS/security_cdsa_utilities/cssmaclpod.h>

namespace Security {

class AclAuthorizationSet : public std::set<AclAuthorization>,public AclAuthorizationSet_HYS {
public:

Security_AclAuthorizationSet_AclAuthorizationSet
Security_AclAuthorizationSet_AclAuthorizationSet_AclAuthorization
Security_AclAuthorizationSet_AclAuthorizationSet_AclAuthorization_AclAuthorization
Security_AclAuthorizationSet_AclAuthorizationSet_AclAuthorization_AclAuthorization___

};

class AuthorizationGroup : public PodWrapper<AuthorizationGroup, CSSM_AUTHORIZATIONGROUP> {
public:
};

class AclOwnerPrototype;

class AclEntryPrototype : public PodWrapper<AclEntryPrototype, CSSM_ACL_ENTRY_PROTOTYPE> ,public AclEntryPrototype_HYS {
public:

Security_AclEntryPrototype_subject
Security_AclEntryPrototype_subject_const

};

class AclOwnerPrototype : public PodWrapper<AclOwnerPrototype, CSSM_ACL_OWNER_PROTOTYPE> {
public:
};

class AclEntryInfo : public PodWrapper<AclEntryInfo, CSSM_ACL_ENTRY_INFO> {
public:
};

class AclEntryInput : public PodWrapper<AclEntryInput, CSSM_ACL_ENTRY_INPUT>,public AclEntryInput_HYS {
public:
Security_AclEntryInput_proto
Security_AclEntryInput_proto_const

};

class AclEdit : public PodWrapper<AclEdit, CSSM_ACL_EDIT>,public AclEdit_HYS {
public:
Security_AclEdit_AclEdit_SSM_ACL_EDIT
Security_AclEdit_AclEdit_const_AclEntryInput
Security_AclEdit_AclEdit_CSSM_ACL_HANDLE_const_AclEntryInput
Security_AclEdit_AclEdit_CSSM_ACL_HANDLE

Security_AclEdit_mode
Security_AclEdit_handle
Security_AclEdit_newEntry

};

class AutoAclOwnerPrototype :public AutoAclOwnerPrototype_HYS {
	NOCOPY(AutoAclOwnerPrototype)
public:

Security_AutoAclOwnerPrototype_operator
Security_AutoAclOwnerPrototype_operator1
Security_AutoAclOwnerPrototype_operator2
Security_AutoAclOwnerPrototype_operator3
Security_AutoAclOwnerPrototype_operator4
Security_AutoAclOwnerPrototype_operator5

Security_AutoAclOwnerPrototype_AutoAclOwnerPrototype
Security_AutoAclOwnerPrototype_allocator
Security_AutoAclOwnerPrototype_allocator_Allocator

private:

Security_AutoAclOwnerPrototype_mAclOwnerPrototype
Security_AutoAclOwnerPrototype_mAllocator

};


class AutoAclEntryInfoList :public  AutoAclEntryInfoList_HYS{
	NOCOPY(AutoAclEntryInfoList)
public:
Security_AutoAclEntryInfoList_operator
Security_AutoAclEntryInfoList_operator1
Security_AutoAclEntryInfoList_operator2
Security_AutoAclEntryInfoList_operator3
Security_AutoAclEntryInfoList_operator4
Security_AutoAclEntryInfoList_operator5

Security_AutoAclEntryInfoList_AutoAclEntryInfoList
Security_AutoAclEntryInfoList_allocator
Security_AutoAclEntryInfoList_allocator_Allocator
Security_AutoAclEntryInfoList_add
Security_AutoAclEntryInfoList_size
Security_AutoAclEntryInfoList_size_uint32
Security_AutoAclEntryInfoList_entries
Security_AutoAclEntryInfoList_addPin
Security_AutoAclEntryInfoList_clear
Security_AutoAclEntryInfoList_addPinState
Security_AutoAclEntryInfoList_addPinState_uint32

private:
Security_AutoAclEntryInfoList_mEntries
Security_AutoAclEntryInfoList_mCount
Security_AutoAclEntryInfoList_mAllocator

};


class AutoAuthorizationGroup : public AuthorizationGroup {
public:
};

namespace DataWalkers {

} // end namespace DataWalkers

} // end namespace Security

#define  HYS_SECURITYT_CDSA_UTILTIES_CSSMACLPOD_H_END
#include <HYS/security_cdsa_utilities/cssmaclpod.h>
#undef HYS_SECURITYT_CDSA_UTILTIES_CSSMACLPOD_H_END

#endif //_CSSMACLPOD
