#ifndef _H_CDSA_UTILITIES_CSSMDATA
#define _H_CDSA_UTILITIES_CSSMDATA

#include <security_utilities/alloc.h>
#include <security_utilities/refcount.h>
#include <security_cdsa_utilities/cssmerrors.h>
#include <Security/cssmerr.h>

#include <HYS/security_cdsa_utilities/cssmdata.h>

namespace Security {

class CssmData : public PodWrapper<CssmData, CSSM_DATA>,public CssmData_HYS {
public:

Security_CssmData_operator 
Security_CssmData_operator1
Security_CssmData_operator2
Security_CssmData_operator3
Security_CssmData_operator4
Security_CssmData_operator5
Security_CssmData_operator6
Security_CssmData_operator7
Security_CssmData_operator8

Security_CssmData_CssmData
Security_CssmData_CssmData_signed_char
Security_CssmData_CssmData_unsigned_char
Security_CssmData_CssmData_char
Security_CssmData_CssmData_void

Security_CssmData_wrap
Security_CssmData_fromHex
Security_CssmData_length
Security_CssmData_length_size_t
Security_CssmData_data
Security_CssmData_toHex

};

class StringData : public CssmData {
public:
};


class CssmManagedData {
public:
};

class CssmOwnedData : public CssmManagedData {
public:
protected:

};

class CssmAutoData : public CssmOwnedData {
public:
private:

};

class CssmRemoteData : public CssmOwnedData {
public:
private:

};

class CssmPolyData : public CssmData {
public:
};

class CssmDateData : public CssmData {
public:

private:
	
};

class CssmDataContainer : public CssmData, public RefCount,public CssmDataContainer_HYS {
public:

Security_CssmDataContainer_operator

Security_CssmDataContainer_CssmDataContainer_Allocator
Security_CssmDataContainer_CssmDataContainer_const_T
Security_CssmDataContainer_CssmDataContainer_const_CssmDataContainer 

public:

Security_CssmDataContainer_mAllocator

private:
Security_CssmDataContainer_operator1

};

template <class Container>
class CssmBuffer : public RefPointer<Container>,public CssmBuffer_HYS {
public:

Security_CssmBuffer_CssmBuffer
Security_CssmBuffer_CssmBuffer_const_T
Security_CssmBuffer_CssmBuffer_const_CSSM_DATA 
Security_CssmBuffer_CssmBuffer_const_CssmBuffer
Security_CssmBuffer_CssmBuffer_Container

};


} // end namespace Security

#define  HYS_SECURITY_CDSA_UTILITES_CSSMDATA_H_END
#include <HYS/security_cdsa_utilities/cssmdata.h>
#undef HYS_SECURITY_CDSA_UTILITES_CSSMDATA_H_END

#endif // _H_CDSA_UTILITIES_CSSMDATA
