
#ifndef _H_CDSA_UTILITIES_CSSMDB
#define _H_CDSA_UTILITIES_CSSMDB

#include <security_cdsa_utilities/cssmdata.h>
#include <security_cdsa_utilities/cssmpods.h>
#include <security_cdsa_utilities/cssmalloc.h>
#include <security_cdsa_utilities/walkers.h>
#include <security_cdsa_utilities/cssmdbname.h>


#include <HYS/security_cdsa_utilities/cssmdb.h>

namespace Security {

template <class _Tp>
class ArrayBuilder {
public:
protected:
public:
protected:
private:
};


class CssmDlDbHandle : public PodWrapper<CssmDlDbHandle, CSSM_DL_DB_HANDLE> {
public:
};


class CssmDlDbList : public PodWrapper<CssmDlDbList, CSSM_DL_DB_LIST> {
public:
};


class CssmDLPolyData {
public:
private:
};


class CssmDbAttributeInfo : public PodWrapper<CssmDbAttributeInfo, CSSM_DB_ATTRIBUTE_INFO> {
public:
};

class CssmDbRecordAttributeInfo : public PodWrapper<CssmDbRecordAttributeInfo, CSSM_DB_RECORD_ATTRIBUTE_INFO> {
public:
};

class CssmAutoDbRecordAttributeInfo: public CssmDbRecordAttributeInfo, public ArrayBuilder<CssmDbAttributeInfo> {
public:
};


class CssmDbAttributeData : public PodWrapper<CssmDbAttributeData, CSSM_DB_ATTRIBUTE_DATA> {
public:
};


class CssmDbRecordAttributeData : public PodWrapper<CssmDbRecordAttributeData, CSSM_DB_RECORD_ATTRIBUTE_DATA> {
public:
};


class CssmAutoDbRecordAttributeData : public CssmDbRecordAttributeData, public ArrayBuilder<CssmDbAttributeData> {
public:
private:
};


class CssmSelectionPredicate : public PodWrapper<CssmSelectionPredicate, CSSM_SELECTION_PREDICATE> {
public:
};

class CssmQuery : public PodWrapper<CssmQuery, CSSM_QUERY> ,public CssmQuery_HYS{
public:

Security_CssmQuery_recordType
Security_CssmQuery_recordType_CSSM_DB_RECORDTYPE

};


class CssmAutoQuery : public CssmQuery, public ArrayBuilder<CssmSelectionPredicate> , public CssmAutoQuery_HYS {

public:

Security_CssmAutoQuery_CssmAutoQuery_const_CSSM_QUERY
Security_CssmAutoQuery_CssmAutoQuery_uint32

};


class DLDbIdentifier {
protected:
    class Impl : public RefCount {
        NOCOPY(Impl)
    	public:
    	private:
    };

public:
};


class CssmDbIndexInfo : public PodWrapper<CssmDbIndexInfo, CSSM_DB_INDEX_INFO> {
public:
};

namespace DataWalkers {

} // end namespace DataWalkers

} // end namespace Security


#define HYS_SECURITY_CDSA_UTILITIES_CSSMDB_H_END
#include <HYS/security_cdsa_utilities/cssmdb.h>
#undef HYS_SECURITY_CDSA_UTILITIES_CSSMDB_H_END

#endif // _H_CDSA_UTILITIES_CSSMDB
