#ifndef _H_CSSMKEY
#define _H_CSSMKEY

#include <security_utilities/utilities.h>
#include <security_cdsa_utilities/cssmpods.h>
#include <security_cdsa_utilities/cssmerrors.h>
#include <Security/cssm.h>

#include <HYS/security_cdsa_utilities/cssmkey.h>

namespace Security {

class CssmKey : public PodWrapper<CssmKey, CSSM_KEY>,public CssmKey_HYS {
public:
public:
    class Header : public PodWrapper<Header, CSSM_KEYHEADER>,CssmKey_HYS::Header_HYS {
    public:

	Security_CssmKey_Header_cspGuid
	Security_CssmKey_Header_cspGuid_const_Guid
	Security_CssmKey_Header_blobType
	Security_CssmKey_Header_blobType_CSSM_KEYBLOB_TYPE
	Security_CssmKey_Header_algorithm
	Security_CssmKey_Header_algorithm_CSSM_KEY_TYPE
	Security_CssmKey_Header_keyClass
	Security_CssmKey_Header_keyClass_CSSM_KEYCLASS
	Security_CssmKey_Header_blobFormat
	Security_CssmKey_Header_blobFormat_CSSM_KEYBLOB_FORMAT
    };
public:

Security_CssmKey_header
Security_CssmKey_header_const
Security_CssmKey_blobType
Security_CssmKey_blobType_CSSM_KEYBLOB_TYPE
Security_CssmKey_blobFormat
Security_CssmKey_blobFormat_CSSM_KEYBLOB_FORMAT
Security_CssmKey_algorithm
Security_CssmKey_algorithm_CSSM_KEY_TYPE
Security_CssmKey_keyClass
Security_CssmKey_keyClass_CSSM_KEYCLASS
Security_CssmKey_keyData
Security_CssmKey_keyData_const 
Security_CssmKey_length
Security_CssmKey_setAttribute
Security_CssmKey_clearAttribute
Security_CssmKey_usage
Security_CssmKey_usage_uint32 

};



} // end namespace Security


#define HYS_SECURITY_CDSA_UTILITIES_CSSMKIEY_H_END
#include <HYS/security_cdsa_utilities/cssmkey.h>
#undef HYS_SECURITY_CDSA_UTILITIES_CSSMKIEY_H_END

#endif //_H_CSSMUTILITIES
