#ifndef _H_PCSC_PP
#define _H_PCSC_PP

#include <security_utilities/utilities.h>
#include <security_utilities/errors.h>
#include <security_utilities/transactions.h>
#include <security_utilities/debugging.h>
#include <PCSC/winscard.h>
#include <vector>
#include <string>

#include <cstdio>

#include <HYS/security_utilities/pcsc++.h>

namespace Security {
namespace PCSC {

class Error : public CommonError,public Error_HYS {
public:

Security_PCSC_Error_throwMe
Security_PCSC_Error_error

private:

};

class ReaderState : public PodWrapper<ReaderState, SCARD_READERSTATE>,public ReaderState_HYS {
public:

Security_PCSC_ReaderState_name
Security_PCSC_ReaderState_name_const_char

};

class Session :public Session_HYS{
	friend class Card;
public:

Security_PCSC_Session_open

private:
private:

};

class Card:public Card_HYS {
public:

Security_PCSC_Card_connect
Security_PCSC_Card_isConnected
Security_PCSC_Card_transmit
Security_PCSC_Card_isInTransaction
Security_PCSC_Card_disconnect
Security_PCSC_Card_begin
Security_PCSC_Card_end
Security_PCSC_Card_didEnd
Security_PCSC_Card_didDisconnect

protected:
private:
};

class Transaction : public ManagedTransaction<Card>,public Transaction_HYS {
public:

Security_PCSC_Transaction_Transaction

protected:
private:

Security_PCSC_Transaction_mDisposition

};


}   // namespce PCSC
}   // namespace Security


#endif //_H_PCSC_PP
