#ifndef OC_SYS_MOUNT_H
#define OC_SYS_MOUNT_H

#include <sys/appleapiopts.h>
#include <sys/cdefs.h>
#include <sys/attr.h>	
#include <stdint.h>
#include <sys/ucred.h>
#include <sys/queue.h>	
#include <sys/kernel_types.h>
//#include <sys/fstypes.h>//add


///////////////////
#ifdef __CYGWIN__
//#define __flags ,int


#endif//__CYGWIN__

//#if defined  (__linux__)||(__CYGWIN__)
	#define mount orig_mount
//#endif
////////////////////////
#include "/usr/include/sys/mount.h"
////////////

#ifdef mount
	#undef mount
#endif


#ifdef __CYGWIN__
//#undef __flags
#endif

//#include <sys/statfs.h>//fstatfs&statfs
/////////////////////////////////////////////////


/*STATFS(2)                   BSD System Calls Manual                  STATFS(2)

NAME
     statfs, statfs64, fstatfs, fstatfs64 -- get file system statistics

SYNOPSIS
     #include <sys/param.h>
     #include <sys/mount.h>

     int
     statfs(const char *path, struct statfs *buf);

     int
     statfs64(const char *path, struct statfs64 *buf);

     int
     fstatfs(int fd, struct statfs *buf);

     int
     fstatfs64(int fd, struct statfs64 *buf);

DESCRIPTION
     Statfs() returns information about a mounted file system.  Path is the path name of any file within the
     mounted file system.  Buf is a pointer to a statfs or statfs64 structure defined as follows:

     typedef struct { int32_t val[2]; } fsid_t;

     #define MFSNAMELEN      15 // length of fs type name, not inc. nul //
     #define MNAMELEN        90 // length of buffer for returned name //
     #define MFSTYPENAMELEN  16 // length of fs type name including null //
     #define MAXPATHLEN      1024

     struct statfs {
         short   f_otype;    // type of file system (reserved: zero) //
         short   f_oflags;   // copy of mount flags (reserved: zero) //
         long    f_bsize;    // fundamental file system block size //
         long    f_iosize;   // optimal transfer block size //
         long    f_blocks;   // total data blocks in file system //
         long    f_bfree;    // free blocks in fs //
         long    f_bavail;   // free blocks avail to non-superuser //
         long    f_files;    // total file nodes in file system //
         long    f_ffree;    // free file nodes in fs //
         fsid_t  f_fsid;     // file system id //
         uid_t   f_owner;    // user that mounted the file system //
         short   f_reserved1;        // reserved for future use //
         short   f_type;     // type of file system (reserved) //
         long    f_flags;    // copy of mount flags (reserved) //
         long    f_reserved2[2];     // reserved for future use //
         char    f_fstypename[MFSNAMELEN]; // fs type name //
         char    f_mntonname[MNAMELEN];    // directory on which mounted //
         char    f_mntfromname[MNAMELEN];  // mounted file system //
         char    f_reserved3;        // reserved for future use //
         long    f_reserved4[4];     // reserved for future use //
     };

     struct statfs64 {
         uint32_t        f_bsize;        // fundamental file system block size //
         int32_t         f_iosize;       // optimal transfer block size //
         uint64_t        f_blocks;       // total data blocks in file system //
         uint64_t        f_bfree;        // free blocks in fs //
         uint64_t        f_bavail;       // free blocks avail to non-superuser //
         uint64_t        f_files;        // total file nodes in file system //
         uint64_t        f_ffree;        // free file nodes in fs //
         fsid_t          f_fsid;         // file system id //
         uid_t           f_owner;        // user that mounted the filesystem //
         uint32_t        f_type;         // type of filesystem //
         uint32_t        f_flags;        // copy of mount exported flags //
         uint32_t        f_fssubtype;    // fs sub-type (flavor) //
         char            f_fstypename[MFSTYPENAMELEN];   // fs type name //
         char            f_mntonname[MAXPATHLEN];        // directory on which mounted //
         char            f_mntfromname[MAXPATHLEN];      // mounted filesystem //
         uint32_t        f_reserved[8];  // For future use //
     };

     Fields that are undefined for a particular file system are set to -1.  Fstatfs() returns the same
     information about an open file referenced by descriptor fd.

FLAGS
     These are some of the flags that may be present in the f_flags field.

     MNT_RDONLY             A read-only filesystem

     MNT_SYNCHRONOUS        File system is written to synchronously

     MNT_NOEXEC             Can't exec from filesystem

     MNT_NOSUID             Setuid bits are not honored on this filesystem

     MNT_NODEV              Don't interpret special files

     MNT_UNION              Union with underlying filesysten

     MNT_ASYNC              File system written to asynchronously

     MNT_EXPORTED           File system is exported File system is stored locally

     MNT_QUOTA              Quotas are enabled on this file system

     MNT_ROOTFS             This file system is the root of the file system

     MNT_DOVOLFS            File system supports volfs

     MNT_DONTBROWSE         File system is not appropriate path to user data

     MNT_UNKNOWNPERMISSIONS
                            VFS will ignore ownership information on filesystem objects

     MNT_AUTOMOUNTED        File system was mounted by automounter

     MNT_JOURNALED          File system is journaled

     MNT_DEFWRITE           File system should defer writes

     MNT_MULTILABEL         MAC support for individual labels

CAVEATS
     In Mac OS X versions before 10.4, f_iosize is 4096. On these older systems, use MAXBSIZE instead.

RETURN VALUES
     Upon successful completion, a value of 0 is returned.  Otherwise, -1 is returned and the global vari-able variable
     able errno is set to indicate the error.

ERRORS
     Statfs() fails if one or more of the following are true:

     [ENOTDIR]          A component of the path prefix of Path is not a directory.

     [ENAMETOOLONG]     The length of a component of path exceeds {NAME_MAX} characters, or the length of
                        path exceeds {PATH_MAX} characters.

     [ENOENT]           The file referred to by path does not exist.

     [EACCES]           Search permission is denied for a component of the path prefix of path.

     [ELOOP]            Too many symbolic links were encountered in translating path.

     [EFAULT]           Buf or path points to an invalid address.

     [EIO]              An I/O error occurred while reading from or writing to the file system.

     Fstatfs() fails if one or more of the following are true:

     [EBADF]            fd is not a valid open file descriptor.

     [EFAULT]           Buf points to an invalid address.

     [EIO]              An I/O error occurred while reading from or writing to the file system.

HISTORY
     The statfs() function first appeared in 4.4BSD. The statfs64() and fstatfs64() first appeared in Max OS
     X 10.5 (Leopard).

BSD                            February 11, 1994                           BSD*/
   #define MNAMELEN        90 // length of buffer for returned name //

/*MOUNT(2)                    BSD System Calls Manual                   MOUNT(2)

NAME
     mount, unmount -- mount or dismount a filesystem

SYNOPSIS
     #include <sys/param.h>
     #include <sys/mount.h>

     int
     mount(const char *type, const char *dir, int flags, void *data);

     int
     unmount(const char *dir, int flags);

DESCRIPTION
     The mount() function grafts a filesystem object onto the system file tree at the point dir.  The argu-ment argument
     ment data describes the filesystem object to be mounted.  The argument type tells the kernel how to
     interpret data (See type below).  The contents of the filesystem become available through the new mount
     point dir.  Any files in dir at the time of a successful mount are swept under the carpet so to speak,
     and are unavailable until the filesystem is unmounted.

     The following flags may be specified to suppress default semantics which affect filesystem access.

     MNT_RDONLY       The filesystem should be treated as read-only; Even the super-user may not write on
                      it.

     MNT_NOEXEC       Do not allow files to be executed from the filesystem.

     MNT_NOSUID       Do not honor setuid or setgid bits on files when executing them.

     MNT_NODEV        Do not interpret special files on the filesystem.

     MNT_UNION        Union with underlying filesystem instead of obscuring it.

     MNT_SYNCHRONOUS  All I/O to the filesystem should be done synchronously.

     The flag MNT_UPDATE indicates that the mount command is being applied to an already mounted filesystem.
     This allows the mount flags to be changed without requiring that the filesystem be unmounted and
     remounted.  Some filesystems may not allow all flags to be changed.  For example, most filesystems will
     not allow a change from read-write to read-only.

     The flag MNT_RELOAD causes the vfs subsystem to update its data structures pertaining to the specified
     already mounted filesystem.

     The type argument defines the type of the filesystem.

     Data is a pointer to a structure that contains the type specific arguments to mount.  The format for
     these argument structures is described in the manual page for each filesystem.

     The umount() function call disassociates the filesystem from the specified mount point dir.

     The flags argument may specify MNT_FORCE to specify that the filesystem should be forcibly unmounted
     even if files are still active.  Active special devices continue to work, but any further accesses to
     any other active files result in errors even if the filesystem is later remounted.

RETURN VALUES
     The mount() returns the value 0 if the mount was successful, otherwise -1 is returned and the variable
     errno is set to indicate the error.

     Umount returns the value 0 if the umount succeeded; otherwise -1 is returned and the variable errno is
     set to indicate the error.

ERRORS
     Mount() will fail when one of the following occurs:

     [EPERM]         The caller is not the super-user, and the device-node and the mountpoint do not have
                     adequate ownership and permissions.

     [ENAMETOOLONG]  A component of a pathname exceeded {NAME_MAX} characters, or an entire path name
                     exceeded {PATH_MAX} characters.

     [ELOOP]         Too many symbolic links were encountered in translating a pathname.

     [ENOENT]        A component of dir does not exist.

     [ENOTDIR]       A component of name is not a directory, or a path prefix of special is not a directory.

     [EINVAL]        A pathname contains a character with the high-order bit set.

     [EBUSY]         Another process currently holds a reference to dir.

     [EFAULT]        Dir points outside the process's allocated address space.

     Umount may fail with one of the following errors:

     [EPERM]         The caller is not the super-user, and the mount() was not done by the user.

     [ENOTDIR]       A component of the path is not a directory.

     [EINVAL]        The pathname contains a character with the high-order bit set.

     [ENAMETOOLONG]  A component of a pathname exceeded {NAME_MAX} characters, or an entire path name
                     exceeded {PATH_MAX} characters.

     [ELOOP]         Too many symbolic links were encountered in translating the pathname.

     [EINVAL]        The requested directory is not in the mount table.

     [EBUSY]         A process is holding a reference to a file located on the filesystem.

     [EIO]           An I/O error occurred while writing cached filesystem information.

     [EFAULT]        Dir points outside the process's allocated address space.

SEE ALSO
     mount(8), umount(8)

BUGS
     Some of the error codes need translation to more obvious messages.

HISTORY
     Mount() and umount() function calls appeared in Version 6 AT&T UNIX.

4th Berkeley Distribution      December 11, 1993     4th Berkeley Distribution*/

    int mount(const char *type, const char *dir, int flags, void *data);
     int      unmount(const char *dir, int flags);

#include <HYS/sys/mount.h>

//#ifdef OC_MOUNT_INTERNAL
#include <sys/mount_internal.h>//add
//#endif //OC_MOUNT_INTERNAL

#endif//OC_SYS_MOUNT_H
