#ifndef OC_SYS_TYPES_H
#define OC_SYS_TYPES_H

#include <sys/appleapiopts.h>
#include <sys/cdefs.h>
#include <machine/types.h>
#include <sys/_types.h>
#include <machine/endian.h>

/////////////////////////////////////////////////////


#ifdef OC_u_char
	#define u_char org_u_char
#else
	#ifdef __linux__
	#ifdef	__USE_BSD//linux
	#define OC_u_char
	#endif //__USE_BSD
	#else//__linux__
	#define OC_u_char
	#endif//__linux__
#endif

#ifdef  OC_u_short
	#define u_short org_u_short
#else
	#ifdef __linux__
	#ifdef	__USE_BSD//linux
	#define OC_u_short
	#endif //__USE_BSD
	#else//__linux__
	#define OC_u_short
	#endif//__linux__
#endif
	
#ifdef OC_u_int
	#define u_int org_u_int
#else
	#ifdef __linux__
	#ifdef	__USE_BSD//linux
	#define OC_u_int
	#endif //__USE_BSD
	#else//__linux__
	#define OC_u_int
	#endif//__linux__
#endif
	
#ifdef OC_u_long
	#define u_long org_u_long
#endif

#ifdef OC_loff_t
	#define loff_t org_loff_t
#endif

#ifdef OC_ino_t
	#define  __ino_t_defined
#endif

#ifdef OC_dev_t
	#define __dev_t_defined
#endif

#ifdef OC_gid_t
 	#define __gid_t_defined
#endif

#ifdef OC_mode_t
	#define __mode_t_defined
#endif

#ifdef  OC_nlink_t
	#define __nlink_t_defined
#endif

#ifdef OC_uid_t
	#define __uid_t_defined
#endif

#ifdef OC_off_t
	#define __off_t_defined
#endif

#ifdef OC_pid_t
	#define __pid_t_defined
#endif

#ifdef _SSIZE_T
	#define __ssize_t_defined
#endif

#ifdef OC_daddr_t
	#define __daddr_t_defined
#endif

#ifdef OC_key_t
	#define __key_t_defined
#endif

#ifdef  OC_ulong
	#define  ulong org_ulong
#endif

#ifdef OC_ushort
	#define ushort org_ushort
#endif

#ifdef OC_uint
	#define uint org_uint
#endif

#ifdef  OC_u_int8_t
	#define u_int8_t org_u_int8_t
#endif

#ifdef OC_u_int16_t
	#define u_int16_t org_u_int16_t
#endif

#ifdef OC_u_int32_t
	#define u_int32_t org_u_int32_t
#endif

#ifdef OC_u_int64_t
	#define u_int64_t org_u_int64_t
#endif

#ifdef __BIT_TYPES_DEFINED__
	#undef __BIT_TYPES_DEFINED__
	#define __BIT_TYPES_DEFINED__DEF
#endif

#ifdef OC_blkcnt_t
	#define __blkcnt_t_defined
#endif

#ifdef  OC_u_int64_t
	#define u_int64_t org_u_int64_t
#else
	#define OC_u_int64_t
#endif

#ifndef OC_caddr_t
	#ifdef __linux__
	#ifdef	__USE_BSD//linux
	#define OC_caddr_t
	#endif //__USE_BSD
	#else//__linux__
	#define OC_caddr_t
	#endif//__linux__
#endif
/////////////////////////////////////////////
#ifdef __CYGWIN__
 	#ifdef OC_struct_timespec
	#define timespec org_timespec
	#else
 	#define OC_struct_timespec
	#endif
	
#ifdef _PID_T
	#define pid_t org_pid_t
#else
	#define _PID_T
#endif

#ifndef OC_fd_mask
#define OC_fd_mask
#endif

#endif//__CYGWIN__

/////////////////
#if defined  (__linux__)
	#define int64_t orig_int64_t
	#ifdef _OFF_T
		#define  __off_t_defined 1
	#endif //_OFF_T

#ifndef OC_fsid_t
#define OC_fsid_t
#else 
#define  fsid_t org_fsid_t
#endif

#define OC_u_int32_t

#endif//__linux__

/////
////////////////////////////////////////////
#include "/usr/include/sys/types.h"
#include <HYS/sys/types.h>

///////////////////////////

#undef fsid_t
#ifdef pid_t
#undef  pid_t
#endif

#ifdef timespec
	#undef timespec
#endif

#ifdef u_int64_t
	#undef u_int64_t
#endif
	
#ifdef __BIT_TYPES_DEFINED__DEF
	#ifndef __BIT_TYPES_DEFINED__
		#define __BIT_TYPES_DEFINED__
	#endif
#endif

#ifdef u_int64_t
	#undef u_int64_t
#endif

#ifdef u_int32_t
	#undef u_int32_t
#endif

#ifdef u_int16_t
	#undef u_int16_t
#endif

#ifdef u_int8_t
	#undef u_int8_t
#endif

#ifdef uint
	#undef uint
#endif

#ifdef ushort
	#undef ushort
#endif

#ifdef ulong
	#undef ulong
#endif

#ifdef loff_t
	#undef loff_t
#endif

#ifdef u_long
	#undef u_long
#endif

#ifdef u_int
	#undef u_int
#endif

#ifdef u_short
	#undef u_short
#endif

#ifdef u_char
	#undef u_char
#endif

#ifdef int64_t
	#undef int64_t
#endif



/////////////////////////////////
#include <sys/_structs.h>




/*TYPES(5)                    BSD File Formats Manual                   TYPES(5)

NAME
     types -- system data types

SYNOPSIS
     #include <sys/types.h>

DESCRIPTION
     The file sys/types.h contains the defined data types used in the kernel (most are used through out the
     system).

     #ifndef _TYPES_H_
     #define _TYPES_H_

     typedef short   dev_t;
     #ifndef _POSIX_SOURCE
                                             // major part of a device //
     #define major(x)        ((int)(((unsigned)(x)>>8)&0377))
                                             // minor part of a device //
     #define minor(x)        ((int)((x)&0377))
                                             // make a device number //
     #define makedev(x,y)    ((dev_t)(((x)<<8) | (y)))
     #endif

     typedef unsigned char   u_char;
     typedef unsigned short  u_short;
     typedef unsigned int    u_int;
     typedef unsigned long   u_long;
     typedef unsigned short  ushort;         // Sys V compatibility //

     #if !defined(_ANSI_SOURCE) && !defined(_POSIX_C_SOURCE)
     #include <machine/types.h>
     #endif

     #ifdef  _CLOCK_T_
     typedef _CLOCK_T_       clock_t;
     #undef  _CLOCK_T_
     #endif

     #ifdef  _SIZE_T_
     typedef _SIZE_T_        size_t;
     #undef  _SIZE_T_
     #endif

     #ifdef  _TIME_T_
     typedef _TIME_T_        time_t;
     #undef  _TIME_T_
     #endif

     #ifndef _POSIX_SOURCE
     typedef struct  _uquad { unsigned long val[2]; } u_quad;
     typedef struct  _quad { long val[2]; } quad;
     #endif
     typedef long *  qaddr_t;        // should be typedef quad * qaddr_t; //

     typedef long    daddr_t;
     typedef char *  caddr_t;
     typedef u_long  ino_t;
     typedef long    swblk_t;
     typedef long    segsz_t;
     typedef long    off_t;
     typedef u_short uid_t;
     typedef u_short gid_t;
     typedef short   pid_t;
     typedef u_short nlink_t;
     typedef u_short mode_t;
     typedef u_long  fixpt_t;

     #ifndef _POSIX_SOURCE
     #define NBBY    8               // number of bits in a byte //

     //
      * Select uses bit masks of file descriptors in longs.  These macros
      * manipulate such bit fields (the filesystem macros use chars).
      * FD_SETSIZE may be defined by the user, but the default here should
      * be >= NOFILE (param.h).
      //
     #ifndef FD_SETSIZE
     #define FD_SETSIZE      1024
     #endif

     typedef long    fd_mask;
     #define NFDBITS (sizeof(fd_mask) * NBBY)        // bits per mask //

     #ifndef howmany
     #define howmany(x, y)   (((x)+((y)-1))/(y))
     #endif

     typedef struct fd_set {
             fd_mask fds_bits[howmany(FD_SETSIZE, NFDBITS)];
     } fd_set;

     #define FD_SET(n, p)    ((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
     #define FD_CLR(n, p)    ((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
     #define FD_ISSET(n, p)  ((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
     #define FD_COPY(f, t)   bcopy(f, t, sizeof(*(f)))
     #define FD_ZERO(p)      bzero((char *)(p), sizeof(*(p)))

     #endif // !_POSIX_SOURCE //
     #endif // !_TYPES_H_ //

SEE ALSO
     adb(1), lseek(2), time(3), fs(5)

HISTORY
     A types file appeared in Version 7 AT&T UNIX.

Darwin                          AUGUST 2, 2001                          Darwin*/

//#ifndef howmany
     #define howmany(x, y)   (((x)+((y)-1))/(y))
//#endif

 #define FD_COPY(f, t)   bcopy(f, t, sizeof(*(f)))

#ifndef OC_caddr_t
#define OC_caddr_t
 typedef char *  caddr_t;
#endif
	
#endif//OC_SYS_TYPES_H

