#ifndef _XLOCALE__STRING_H_
#define _XLOCALE__STRING_H_


#include <HYS/xlocale/_string.h>

#ifndef OC_locale_t
#include <xlocale.h>//add-locale_t
#endif

#ifndef	_SIZE_T
#include <string.h>//add
#endif//Make Error


__BEGIN_DECLS

/*STRCASECMP(3)            BSD Library Functions Manual            STRCASECMP(3)

NAME
     strcasecmp, strcasecmp_l, strncasecmp, strncasecmp_l -- compare strings, ignoring case

LIBRARY
     Standard C Library (libc, -lc)

SYNOPSIS
     #include <strings.h>

     int
     strcasecmp(const char *s1, const char *s2);

     int
     strncasecmp(const char *s1, const char *s2, size_t n);

     #include <strings.h>
     #include <xlocale.h>

     int
     strcasecmp_l(const char *s1, const char *s2, locale_t loc);

     int
     strncasecmp_l(const char *s1, const char *s2, size_t n, locale_t loc);

DESCRIPTION
     The strcasecmp() and strncasecmp() functions compare the null-terminated strings s1 and s2.

     The strncasecmp() compares at most n characters.

     Although the strcasecmp() and strncasecmp() functions use the current locale, the strcasecmp_l() and
     strncasecmp_l() functions may be passed locales directly. See xlocale(3) for more information.

RETURN VALUES
     The strcasecmp() and strncasecmp() return an integer greater than, equal to, or less than 0, according
     as s1 is lexicographically greater than, equal to, or less than s2 after translation of each corre-sponding corresponding
     sponding character to lower-case.  The strings themselves are not modified.  The comparison is done
     using unsigned characters, so that `\200' is greater than `\0'.

SEE ALSO
     bcmp(3), memcmp(3), strcmp(3), strcoll(3), strxfrm(3), tolower(3), xlocale(3)

HISTORY
     The strcasecmp() and strncasecmp() functions first appeared in 4.4BSD.  Their prototypes existed previ-ously previously
     ously in <string.h> before they were moved to <strings.h> for IEEE Std 1003.1-2001 (``POSIX.1'') com-pliance. compliance.
     pliance.

BSD                              June 9, 1993                              BSD*/

#ifndef OC_strncasecmp_l
#define OC_strncasecmp_l
 int strncasecmp_l(const char *s1, const char *s2, size_t n, locale_t loc);
#endif

__END_DECLS

#endif /* _XLOCALE__STRING_H_ */
