#include <AddressBook/ABGlobalsC.h>

/*Person Properties

CFPlugIn defines the following domain qualifier constants.

CFStringRef kABFirstNameProperty;
CFStringRef kABLastNameProperty;
CFStringRef kABFirstNamePhoneticProperty;
CFStringRef kABLastNamePhoneticProperty;
CFStringRef kABBirthdayProperty;
CFStringRef kABOrganizationProperty;
CFStringRef kABJobTitleProperty;
CFStringRef kABHomePageProperty;
CFStringRef kABURLsProperty;
CFStringRef kABEmailProperty;
CFStringRef kABAddressProperty;
CFStringRef kABPhoneProperty;
CFStringRef kABAIMInstantProperty;
CFStringRef kABJabberInstantProperty;
CFStringRef kABMSNInstantProperty;
CFStringRef kABYahooInstantProperty;
CFStringRef kABICQInstantProperty;
CFStringRef kABNoteProperty;
CFStringRef kABMiddleNameProperty;
CFStringRef kABMiddleNamePhoneticProperty;
CFStringRef kABTitleProperty;
CFStringRef kABSuffixProperty;
CFStringRef kABNicknameProperty;
CFStringRef kABMaidenNameProperty;
CFStringRef kABOtherDatesProperty;
CFStringRef kABRelatedNamesProperty;
CFStringRef kABDepartmentProperty;
CFStringRef kABPersonFlags;
Constants
kABFirstNameProperty

First name (string).

Available in Mac OS X v10.2 and later.
kABLastNameProperty

Last name (string).

Available in Mac OS X v10.2 and later.
kABFirstNamePhoneticProperty

First name phonetic (string).

Available in Mac OS X v10.2 and later.
kABLastNamePhoneticProperty

Last name phonetic (string).

Available in Mac OS X v10.2 and later.
kABBirthdayProperty

Birth date (date).

Available in Mac OS X v10.2 and later.
kABOrganizationProperty

Company name (string)

Available in Mac OS X v10.2 and later.
kABJobTitleProperty

Job Title (string).

Available in Mac OS X v10.2 and later.
kABHomePageProperty

Home Web page (string). Deprecated in Mac OS X version 10.4.

Available in Mac OS X v10.2 and later.
kABURLsProperty

Web pages (multi-string). 

Available in Mac OS X v10.4 and later.
kABEmailProperty

email(s) (multi-string).

Available in Mac OS X v10.2 and later.
kABAddressProperty

Street Addresses (multi-dictionary).

Available in Mac OS X v10.2 and later.
kABPhoneProperty

Generic phone number (multi-string).

Available in Mac OS X v10.2 and later.
kABAIMInstantProperty

AIM Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABJabberInstantProperty

Jabber Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABMSNInstantProperty

MSN Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABYahooInstantProperty

Yahoo Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABICQInstantProperty

ICQ Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABNoteProperty

Note (string).

Available in Mac OS X v10.2 and later.
kABMiddleNameProperty

Middle name (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABMiddleNamePhoneticProperty

Middle name phonetic (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABTitleProperty

Title as in “Sir”, “Duke”, “General”, “Cardinal”, or “Lord” (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABSuffixProperty

Suffix as in “Sr.”, “Jr.”, “III”, or “Esq.” (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABNicknameProperty

Nickname (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABMaidenNameProperty

Maiden name (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABOtherDatesProperty

Dates associated with a person (ABMultiDateProperty containing dates).

Available in Mac OS X v10.3 and later.
kABRelatedNamesProperty

Names of people related to a person (ABMultiStringProperty containing names).

Available in Mac OS X v10.3 and later.
kABDepartmentProperty

Department name (string).

Available in Mac OS X v10.3 and later.
kABPersonFlags

Property that specifies the name ordering and user configuration of a record in the Address Book application.

Available in Mac OS X v10.3 and later.*/

 CFStringRef  const kABFirstNameProperty;
 CFStringRef const kABLastNameProperty;
 CFStringRef const kABFirstNamePhoneticProperty;
 CFStringRef const kABLastNamePhoneticProperty;
 CFStringRef const kABBirthdayProperty;
 CFStringRef const kABOrganizationProperty;
 CFStringRef const kABJobTitleProperty;
 CFStringRef const kABHomePageProperty;
 CFStringRef const kABURLsProperty;
 CFStringRef const kABEmailProperty;
 CFStringRef const kABAddressProperty;
 CFStringRef const kABPhoneProperty;
 CFStringRef const kABAIMInstantProperty;
 CFStringRef const kABJabberInstantProperty;
 CFStringRef const kABMSNInstantProperty;
 CFStringRef const kABYahooInstantProperty;
 CFStringRef const kABICQInstantProperty;
 CFStringRef const kABNoteProperty;
 CFStringRef const kABMiddleNameProperty;
 CFStringRef const kABMiddleNamePhoneticProperty;
 CFStringRef const kABTitleProperty;
 CFStringRef const  kABSuffixProperty;
 CFStringRef const kABNicknameProperty;
 CFStringRef const kABMaidenNameProperty;
 CFStringRef const kABOtherDatesProperty;
 CFStringRef const kABRelatedNamesProperty;
 CFStringRef const kABDepartmentProperty;
 CFStringRef const kABPersonFlags;


/*Address Keys

Keys used by the address property.

CFStringRef kABAddressStreetKey;
CFStringRef kABAddressCityKey;
CFStringRef kABAddressStateKey;
CFStringRef kABAddressZIPKey;
CFStringRef kABAddressCountryKey;
CFStringRef kABAddressCountryCodeKey;
Constants
kABAddressStreetKey

Street (string).

Available in Mac OS X v10.2 and later.
kABAddressCityKey

City (string).

Available in Mac OS X v10.2 and later.
kABAddressStateKey

State (string).

Available in Mac OS X v10.2 and later.
kABAddressZIPKey

Zip (string).

Available in Mac OS X v10.2 and later.
kABAddressCountryKey

Country (string).

Available in Mac OS X v10.2 and later.
kABAddressCountryCodeKey

Country Code (string).

Available in Mac OS X v10.2 and later.*/
 CFStringRef kABAddressStreetKey;
 CFStringRef kABAddressCityKey;
 CFStringRef kABAddressStateKey;
 CFStringRef kABAddressZIPKey;
 CFStringRef kABAddressCountryKey;
  CFStringRef kABAddressCountryCodeKey;

/*Address Labels

Labels used by the address property.

CFStringRef kABAddressWorkLabel;
CFStringRef kABAddressHomeLabel;

Constants
kABAddressWorkLabel

Work address.

Available in Mac OS X v10.2 and later.
kABAddressHomeLabel

Home address.

Available in Mac OS X v10.2 and later.*/

 CFStringRef kABAddressWorkLabel;
 CFStringRef kABAddressHomeLabel;



/*Phone Labels

Labels used by the phone property.

CFStringRef kABPhoneWorkLabel;
CFStringRef kABPhoneHomeLabel;
CFStringRef kABPhoneMobileLabel;
CFStringRef kABPhoneMainLabel;
CFStringRef kABPhoneHomeFAXLabel;
CFStringRef kABPhoneWorkFAXLabel;
CFStringRef kABPhonePagerLabel;

Constants
kABPhoneWorkLabel

Work phone.

Available in Mac OS X v10.2 and later.
kABPhoneHomeLabel

Home phone.

Available in Mac OS X v10.2 and later.
kABPhoneMobileLabel

Cell phone.

Available in Mac OS X v10.2 and later.
kABPhoneMainLabel

Main phone.

Available in Mac OS X v10.2 and later.
kABPhoneHomeFAXLabel

FAX number.

Available in Mac OS X v10.2 and later.
kABPhoneWorkFAXLabel

FAX number.

Available in Mac OS X v10.2 and later.
kABPhonePagerLabel

Pager number.

Available in Mac OS X v10.2 and later.*/
 CFStringRef kABPhoneWorkLabel;
 CFStringRef kABPhoneHomeLabel;
 CFStringRef kABPhoneMobileLabel;
 CFStringRef kABPhoneMainLabel;
 CFStringRef kABPhoneHomeFAXLabel;
 CFStringRef kABPhoneWorkFAXLabel;
 CFStringRef kABPhonePagerLabel;


