#import <AppKit/NSApplication.h>



/*Runtime Version Check
There are several ways to check for new features provided by the Cocoa frameworks at runtime. One is to look for a given new class or method dynamically, and not use it if not there. Another is to use the global variable NSAppKitVersionNumber (or, in Foundation, NSFoundationVersionNumber):
APPKIT_EXTERN double NSAppKitVersionNumber;
#define NSAppKitVersionNumber10_0 577
#define NSAppKitVersionNumber10_1 620
#define NSAppKitVersionNumber10_2 663
#define NSAppKitVersionNumber10_3 743
#define NSAppKitVersionNumber10_4 824
One typical use of this is to floor() the value, and check against the values provided in NSApplication.h:
if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_0) {
  // On a 10.0.x or earlier system //
} else if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_1) {
  // On a 10.1 - 10.1.x system //
} else if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_2) {
  // On a 10.2 - 10.2.x system //
} else if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_3) {
  // On a 10.3 - 10.3.x system //
} else if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_4) {
  // On a 10.4 - 10.4.x system //
} else {
  // Leopard or later system //
}
Special cases or situations for version checking are also discussed in the release notes as appropriate. For instance some individual headers may also declare the versions numbers for NSAppKitVersionNumber where some bug fix or functionality is available in a given update, for example:
#define NSAppKitVersionWithSuchAndSuchBadBugFix 582.1*/

 
 double NSAppKitVersionNumber;//?


/* NSApplicationLoad

Startup function to call when running Cocoa code from a Carbon application.

BOOL NSApplicationLoad (
   void
);

Discussion

If NSApplication is not already initialized, initializes it and sets up event handlers for Cocoa. You typically call this before calling other Cocoa code in a plug-in loaded into a primarily Carbon application. A return value of YES indicates that NSApplication was successfully initialized for the Carbon application.
Availability

    * Available in Mac OS X v10.2 and later.

Declared In
NSApplication.h */
BOOL NSApplicationLoad (
   void
){};
