#import <AppKit/NSDatePicker.h>

@implementation   NSDatePicker 

/* setDrawsBackground:

- (void)setDrawsBackground:(BOOL)flag
Discussion

Sets whether the receiver draws the background.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? drawsBackground

Declared In
NSDatePicker.h */
- (void)setDrawsBackground:(BOOL)flag{}

/* setBackgroundColor:

Sets the receivers background color to color.

- (void)setBackgroundColor:(NSColor *)color
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? calendar

Declared In
NSDatePicker.h
 */
- (void)setBackgroundColor:(NSColor *)color{}

/* setDatePickerStyle:

Sets the receivers date picker style to newStyle.

- (void)setDatePickerStyle:(NSDatePickerStyle)newStyle
Discussion

See Constants for a description of the possible values.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? datePickerStyle

Declared In
NSDatePicker.h */
- (void)setDatePickerStyle:(NSDatePickerStyle)newStyle{}

/* setDateValue:

Sets the date of the receiver to newStartDate.

- (void)setDateValue:(NSDate *)newStartDate
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? dateValue

Declared In
NSDatePicker.h */
- (void)setDateValue:(NSDate *)newStartDate{}

/* setBordered:

Specifies whether the receiver draws a plain border.

- (void)setBordered:(BOOL)flag
Discussion

The flag parameter specifies the Boolean value.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? isBordered

Declared In
NSDatePicker.h */
- (void)setBordered:(BOOL)flag{}

/* setTextColor:

Sets the text color of the receiver to color.

- (void)setTextColor:(NSColor *)color
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? textColor

Declared In
NSDatePicker.h */
- (void)setTextColor:(NSColor *)color{}

/* setBezeled:

Specifies whether the receiver has a bezeled border.

- (void)setBezeled:(BOOL)flag
Discussion

The flag parameter specifies the Boolean value.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? isBezeled

Declared In
NSDatePicker.h */
- (void)setBezeled:(BOOL)flag{}


/* setDatePickerElements:

Sets the date picker elements displayed by the receiver to those specified by elementFlags.

- (void)setDatePickerElements:(NSDatePickerElementFlags)elementFlags
Discussion

See Constants for a description of the possible values.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? datePickerElements

Declared In
NSDatePicker.h */
- (void)setDatePickerElements:(NSDatePickerElementFlags)elementFlags{}


/* dateValue

Returns the receivers date.

- (NSDate *)dateValue
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? setDateValue:

Declared In
NSDatePicker.h */
- (NSDate *)dateValue{}

/* datePickerStyle

Returns the receivers date picker style.

- (NSDatePickerStyle)datePickerStyle
Discussion

See Constants for a description of the possible values.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? datePickerStyle

Declared In
NSDatePicker.h */
- (NSDatePickerStyle)datePickerStyle{}


/* datePickerElements

Returns the receivers date picker elements flags.

- (NSDatePickerElementFlags)datePickerElements
Discussion

See Constants for a description of the possible values.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? setDatePickerElements:

Declared In
NSDatePicker.h */
- (NSDatePickerElementFlags)datePickerElements{}

/* setMinDate:

Sets the minimum date allowed as input by the receiver to date.

- (void)setMinDate:(NSDate *)date
Discussion

Passing nil for date allows any date as the minimum value.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? minDate

Declared In
NSDatePicker.h */
- (void)setMinDate:(NSDate *)date{}

/* setMaxDate:

Sets the maximum date allowed as input by the receiver to date.

- (void)setMaxDate:(NSDate *)date
Discussion

Passing nil for date allows any date as the maximum value.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? maxDate

Declared In
NSDatePicker.h */
- (void)setMaxDate:(NSDate *)date{}

/* setTimeInterval:

Sets the time interval of the date range to newTimeInterval.

- (void)setTimeInterval:(NSTimeInterval)newTimeInterval
Discussion

The time interval is only applicable when the receiver is in NSRangeDateMode.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? timeInterval

Declared In
NSDatePicker.h */
- (void)setTimeInterval:(NSTimeInterval)newTimeInterval{}

/* setDatePickerMode:

Sets the receivers date picker mode to newMode.

- (void)setDatePickerMode:(NSDatePickerMode)newMode
Discussion

See Constants for a description of the possible values.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? datePickerMode

Declared In
NSDatePicker.h */
- (void)setDatePickerMode:(NSDatePickerMode)newMode{}

/* datePickerMode

Returns the receivers date picker mode.

- (NSDatePickerMode)datePickerMode
Discussion

See Constants for a description of the possible values.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * ? setDatePickerMode:

Declared In
NSDatePicker.h */
- (NSDatePickerMode)datePickerMode{}

@end


@implementation NSDatePicker (HYS)

-(int) setDelegate:(int)a{}//?

@end
