#include <CoreFoundation/CoreFoundation.h>

/*CFBinaryHeapGetValues

Copies all the values from a binary heap into a sorted C array.

void CFBinaryHeapGetValues (
   CFBinaryHeapRef heap,
   const void **values
);
Parameters
heap

The binary heap to use.
values

On return, the memory pointed to by this argument holds a C array of all the values in heap, sorted from minimum to maximum values. You must allocate sufficient memory to hold all the values in heap before calling this function. If the values are Core Foundation objects, ownership follows the Get Rule.
Availability
Available in Mac OS X v10.0 and later. 
Declared In
CFBinaryHeap.h*/
#ifdef OC_CF
void CFBinaryHeapGetValues (
   CFBinaryHeapRef heap,
   const void **values
){};
#endif

/*CFBinaryHeapRemoveAllValues

Removes all values from a binary heap, making it empty.

void CFBinaryHeapRemoveAllValues (
   CFBinaryHeapRef heap
);

Parameters
heap

The binary heap to use.
Availability
Available in Mac OS X v10.0 and later. 
Declared In
CFBinaryHeap.h*/
#ifdef OC_CF
void CFBinaryHeapRemoveAllValues (
   CFBinaryHeapRef heap
){};
#endif

/*CFBinaryHeapAddValue

Adds a value to a binary heap.

void CFBinaryHeapAddValue (
   CFBinaryHeapRef heap,
   const void *value
);

Parameters
heap

The binary heap to use.
value

The value to add to the binary heap. The value is retained by the binary heap using the retain callback provided in the CFBinaryHeapCallBacks structure when the binary heap was created.
Availability
Available in Mac OS X v10.0 and later. 
Declared In
CFBinaryHeap.h*/
#ifdef OC_CF
void CFBinaryHeapAddValue (
   CFBinaryHeapRef heap,
   const void *value
){};
#endif

/*CFBinaryHeapRemoveMinimumValue

Removes the minimum value from a binary heap.

void CFBinaryHeapRemoveMinimumValue (
   CFBinaryHeapRef heap
);
Parameters
heap

The binary heap to use.
Discussion

If heap contains several equal minimum values, only one of them is removed. If heap is empty, this function does nothing.
Availability
Available in Mac OS X v10.0 and later. 
Declared In
CFBinaryHeap.h*/
#ifdef OC_CF
void CFBinaryHeapRemoveMinimumValue (
   CFBinaryHeapRef heap
){};
#endif




