#include <CoreFoundation/CoreFoundation.h>


/*CFCalendarSetLocale

Sets the locale for a calendar.

void CFCalendarSetLocale (
   CFCalendarRef calendar,
   CFLocaleRef locale
);
Parameters
calendar

The calendar to modify. 
locale

The locale to set for calendar.
Availability
Available in Mac OS X v10.4 and later.
Declared In
CFCalendar.h*/
#ifdef OC_CF
void CFCalendarSetLocale (
   CFCalendarRef calendar,
   CFLocaleRef locale
){};
#endif

/*CFCalendarCreateWithIdentifier

Returns a calendar object for the calendar identified by a calendar identifier.

CFCalendarRef CFCalendarCreateWithIdentifier (
   CFAllocatorRef allocator,
   CFStringRef identifier
);
Parameters
alloc

The allocator to use to allocate memory for the new object. Pass NULL or kCFAllocatorDefault to use the current default allocator. 
ident

A calendar identifier. Calendar identifier constants are given in CFLocaleRef.
Return Value

A calendar object for the calendar identified by ident. If the identifier is unknown (if, for example, it is either an unrecognized string, or the calendar is not supported by the current version of the operating system), returns NULL. Ownership follows the Create Rule.
Availability
Available in Mac OS X v10.4 and later.
Declared In
CFCalendar.h*/
#ifdef OC_CF
CFCalendarRef CFCalendarCreateWithIdentifier (
   CFAllocatorRef allocator,
   CFStringRef identifier
){};
#endif

/*CFCalendarGetIdentifier

Returns the given calendar’s identifier.

CFStringRef CFCalendarGetIdentifier (
   CFCalendarRef calendar
);
Parameters
calendar

The calendar to examine.
Return Value

A string representation of calendar’s identifier. Calendar identifier constants can be found in CFLocaleRef. Ownership follows the Get Rule.
Availability
Available in Mac OS X v10.4 and later.
Declared In
CFCalendar.h*/
#ifdef OC_CF
CFStringRef CFCalendarGetIdentifier (
   CFCalendarRef calendar
){};
#endif
