#import <Foundation/NSData.h>

@implementation NSData (NSDataCreation)
/*dataWithContentsOfFile:options:error:

Creates and returns a data object by reading every byte from the file specified by a given path.

+ (id)dataWithContentsOfFile:(NSString *)path options:(NSUInteger)mask error:(NSError **)errorPtr
Parameters
path

The absolute path of the file from which to read data.
mask

A mask that specifies options for reading the data. Constant components are described in "Options for NSData writing methods."
errorPtr

If an error occurs, upon return contains an NSError object that describes the problem.
Return Value

A data object by reading every byte from the file specified by path. Returns nil if the data object could not be created.
Availability
Available in Mac OS X v10.4 and later.
Declared In
NSData.h*/
+ (id)dataWithContentsOfFile:(NSString *)path options:(NSUInteger)mask error:(NSError **)errorPtr{}

@end
