#import <Foundation/NSDateFormatter.h>

@implementation  NSDateFormatter (OC)

/*setDateStyle:

Sets the date style of the receiver.

- (void)setDateStyle:(NSDateFormatterStyle)style
Parameters
style

The date style of the receiver. For possible values, see NSDateFormatterStyle.
Availability
Available in Mac OS X v10.4 and later.
See Also
– dateStyle.
Declared In
NSDateFormatter.h*/

- (void)setDateStyle:(NSDateFormatterStyle)style{}

/*setTimeStyle:

Sets the time style of the receiver.

- (void)setTimeStyle:(NSDateFormatterStyle)style
Parameters
style

The time style for the receiver. For possible values, see NSDateFormatterStyle.
Availability
Available in Mac OS X v10.4 and later.
See Also
– timeStyle
Declared In
NSDateFormatter.h*/
- (void)setTimeStyle:(NSDateFormatterStyle)style{}


/*setDefaultFormatterBehavior:

Sets the default formatting behavior for instances of the class.

+ (void)setDefaultFormatterBehavior:(NSDateFormatterBehavior)behavior
Parameters
behavior

The default formatting behavior for instances of the class. For possible values, see NSDateFormatterBehavior.
Availability
Available in Mac OS X v10.4 and later.
See Also
+ defaultFormatterBehavior
– formatterBehavior
– setFormatterBehavior:
Declared In
NSDateFormatter.h*/
+ (void)setDefaultFormatterBehavior:(NSDateFormatterBehavior)behavior{}

/* stringFromDate:

Returns a string representation of a given date formatted using the receiver’s current settings.

- (NSString *)stringFromDate:(NSDate *)date
Parameters

date

    The date to format.

Return Value

A string representation of date formatted using the receiver’s current settings.
Availability

    * Available in Mac OS X v10.4 and later.

See Also

    * – dateFromString:

Declared In
NSDateFormatter.h */
- (NSString *)stringFromDate:(NSDate *)date{}

@end
