//#include <HIToolbox/MacHelp.h>
#include <HIToolbox/HIToolbox.h>


//work



/*HMGetHelpMenu

Returns a reference to the Help menu.

extern OSStatus HMGetHelpMenu (
MenuRef *outHelpMenu,
MenuItemIndex         *outFirstCustomItemIndex
);
Parameters
outHelpMenu

On return, a pointer to a menu reference to the Help menu.
outFirstCustomItemIndex

On return, a pointer to the menu item index that will be used by the first application-supplied item added to the menu. This parameter may be NULL.
Return Value

A result code. See “Result Codes”.
Discussion

The HMGetHelpMenu function returns a reference to the Help menu, to which you can add your own custom menu items. 
Availability
Available in CarbonLib 1.1 and later.
Available in Mac OS X 10.0 and later.*/
OSStatus HMGetHelpMenu (
MenuRef *outHelpMenu,
MenuItemIndex         *outFirstCustomItemIndex
){};




/*HMDisplayTag

Displays a help tag at an application-defined location.

OSStatus HMDisplayTag (
   const HMHelpContentRec *inContent
);
Parameters
inContent

A pointer to a help tag structure that describes the help tag you want to display.
Return Value

A result code. See “Result Codes”.
Discussion

Use the HMDisplayTag function to display a help tag at a location not associated with a control, window, or menu.
Availability
Available in CarbonLib 1.5 and later.
Available in Mac OS X 10.0 and later.*/

OSStatus HMDisplayTag (
   const HMHelpContentRec *inContent
){};


/*HMSetControlHelpContent

Associates a help tag with a control.

OSStatus HMSetControlHelpContent (
   ControlRef     inControl,
   const HMHelpContentRec                 *inContent
);

Parameters
inControl

A reference to the control with which you want to associate the help tag.
inContent

A pointer to a help tag structure that describes the help tag for the control. 
Return Value

A result code. See “Result Codes”.
Discussion

Once you attach a help tag to a control using the HMSetControlHelpContent function, this help tag is displayed by the Carbon Help Manager whenever the user hovers the mouse over the control while help tags are enabled. 

Use HMSetControlHelpContent to supply the content for a help tag when you create a control. To supply the content for a help tag only when the tag is about to be displayed to the user, install a help tag callback for the control with the function HMInstallControlContentCallback.
Availability
Available in CarbonLib 1.0.2 and later.
Available in Mac OS X 10.0 and later.*/

OSStatus HMSetControlHelpContent (
   ControlRef     inControl,
   const HMHelpContentRec                 *inContent
){};



/*HMInstallControlContentCallback

Installs a help tag callback for a control.

OSStatus HMInstallControlContentCallback (
   ControlRef     inControl,
   HMControlContentUPP             inContentUPP
);

Parameters
inControl

A reference to the control for which to install the help tag callback.
inContentUPP

A universal procedure pointer to the help tag callback.
Return Value

A result code. See “Result Codes”.
Discussion

HMInstallControlContentCallback associates your help tag callback with the control specified in the inControl parameter. Thereafter, whenever the user hovers the mouse over this control, the Carbon Help Manager calls your callback to determine the content to display in the help tag for the control. For a description of the help tag callback for a control, see HMControlContentProcPtr.
Availability
Available in CarbonLib 1.0.2 and later.
Available in Mac OS X 10.0 and later.*/
OSStatus HMInstallControlContentCallback (
   ControlRef     inControl,
   HMControlContentUPP             inContentUPP
){};


/*NewHMControlContentUPP

Creates a new universal procedure pointer (UPP) to a help tag callback for a control.

HMControlContentUPP NewHMControlContentUPP (
   HMControlContentProcPtr userRoutine
);

Parameters
userRoutine

A pointer to your help tag callback. See HMControlContentProcPtr data type fir a description.
Return Value

On return, a UPP to the help tag callback. See HMControlContentUPP data type for a description.
Discussion

Pass the UPP returned by NewHMControlContentUPP to the HMInstallControlContentCallback function to install your help tag callback with a control. When you are finished with the help tag callback?for example, when you dispose of the control?you should dispose of the UPP with the DisposeHMControlContentUPP function.
Availability
Available in CarbonLib 1.0.2 and later.
Available in Mac OS X 10.0 and later.*/
HMControlContentUPP NewHMControlContentUPP (
   HMControlContentProcPtr userRoutine
){};

/*HMSetWindowHelpContent

Associates a help tag with a window.

OSStatus HMSetWindowHelpContent (
   WindowRef          inWindow,
   const HMHelpContentRec              *inContent
);

Parameters
inWindow

A reference to the window with which to associate the help tag.
inContent

A pointer to a help tag structure that describes the help tag for the window.
Return Value

A result code. See “Result Codes”.
Discussion

Once you attach a help tag to a window using the HMSetWindowHelpContent function, this help tag is displayed by the Carbon Help Manager whenever the user hovers the mouse over the window while help tags are enabled. 

Use HMSetWindowHelpContent to supply the content for a help tag when you create a window. To supply the content for a help tag only when the tag is about to be displayed to the user, install a help tag callback for the window with the function HMInstallWindowContentCallback.
Availability
Available in CarbonLib 1.0.2 and later.
Available in Mac OS X 10.0 and later.*/

OSStatus HMSetWindowHelpContent (
   WindowRef          inWindow,
   const HMHelpContentRec              *inContent
){};




