#include <IOKit/IOCommandPool.h>

/*getCommand


public

virtual IOCommand *getCommand(
    bool blockForCommand = true); 
Parameters
blockForCommand
If the caller would like to have its thread slept until a command is available, it should pass true, else false.
Return Value

If the caller passes true in blockForCommand, getCommand guarantees that the result will be a pointer to an IOCommand object from the pool. If the caller passes false, s/he is responsible for checking whether a non-NULL pointer was returned. 
Discussion 

The getCommand method is used to get a pointer to an object of type IOCommand from the pool.*/
IOCommand *IOCommandPool::getCommand(
    bool blockForCommand ){}; 

/*withWorkLoop(IOWorkLoop *)


Primary factory method for the IOCommandPool class 

public

static IOCommandPool *withWorkLoop(
    IOWorkLoop *inWorkLoop); 
Parameters
inWorkLoop
The workloop that this command pool should synchronize with.
Return Value

Returns a pointer to an instance of IOCommandPool if successful, otherwise NULL. 
Discussion 

The withWorkLoop method is what is known as a factory method. It creates a new instance of an IOCommandPool and returns a pointer to that object.*/
 IOCommandPool *IOCommandPool::withWorkLoop(
    IOWorkLoop *inWorkLoop){}; 

/*withWorkLoop(IOService *, IOWorkLoop *, UInt32)


Should never be used, obsolete. See IOCommandPool::withWorkLoop. 

public

static IOCommandPool *commandPool(
    IOService *inOwner, 
    IOWorkLoop *inWorkLoop, 
    UInt32 inSize = kIOCommandPoolDefaultSize); */
 IOCommandPool * IOCommandPool::commandPool(
    IOService *inOwner, 
    IOWorkLoop *inWorkLoop, 
    UInt32 inSize ){};

/*returnCommand


public

virtual void returnCommand(
    IOCommand *command); 
Parameters
commmand
The command to place in the pool.
Discussion 

The returnCommand method is used to place an object of type IOCommand into the pool, whether it be the first time, or the 1000th time.*/
 void IOCommandPool::returnCommand(
    IOCommand *command){}; 
