#include <IOKit/IODMACommand.h>

 bool IODMACommand:: initWithSpecification( SegmentFunction  outSegFunc,UInt8     numAddressBits,UInt64    maxSegmentSize,MappingOptions mappingOptions,UInt64    maxTransferSize ,UInt32    alignment,IOMapper *mapper,void     *refCon){};//c
	
 const IOMemoryDescriptor *IODMACommand::getMemoryDescriptor() const{};//c
 IOReturn IODMACommand::synchronize(IOOptionBits options){};//c
 	      UInt64 IODMACommand::writeBytes(UInt64 offset, const void *bytes, UInt64 length){};
		  
 IOReturn IODMACommand::clearMemoryDescriptor(bool autoComplete ){};//c
	 IOReturn IODMACommand::complete(bool invalidateCache , bool synchronize ){};//c
IOReturn IODMACommand::setMemoryDescriptor(const IOMemoryDescriptor *mem, bool autoPrepare ){};//c
IOReturn IODMACommand::prepare(UInt64 offset , UInt64 length , bool flushCache , bool synchronize ){};//c
			
//////////////

/*withSpecification


Creates and initializes an IODMACommand in one operation. 

public

static IODMACommand * withSpecification(
    SegmentFunction outSegFunc, 
    UInt8 numAddressBits, 
    UInt64 maxSegmentSize, 
    MappingOptions mappingOptions = kMapped, 
    UInt64 maxTransferSize = 0, 
    UInt32 alignment = 1, 
    IOMapper *mapper = 0, 
    void *refCon = 0); 
Parameters
outSegFunc
SegmentFunction to call to output one physical segment. A set of nine commonly required segment functions are provided.
numAddressBits
Number of bits that the hardware uses on its internal address bus. Typically 32 but may be more on modern hardware. A 0 implies no restriction other than that implied by the output segment function.
maxSegmentSize
Maximum allowable size for one segment. Defaults to 0, which means any size.
mappingOptions
The type of mapping that is required to translate an IOMemoryDescriptor into the desired number of bits. For example, if your hardware only supports 32 bits but must run on machines with > 4G of RAM some mapping will be required. Number of bits will be specified in numAddressBits, see below. This parameter can take 3 values: kNonCoherent - used for non-coherent hardware transfers, Mapped - validates that all I/O bus generated addresses are within the number of addressing bits specified, Bypassed - bypassed addressing is required (this is used when the hardware transfers are into coherent memory but no mapping is required). See prepare for failure cases.
maxTransferSize
Maximum size of an entire transfer. Defaults to 0 indicating no maximum.
alignment
Alignment restriction, in bytes, on I/O bus addresses. Defaults to single byte alignment. Not currently implemented.
mapper
For mapping types kMapped and kBypassed mapper is used to define the hardware that will perform the mapping. Defaults to the system mapper.
Return Value

Returns a new IODMACommand object if successfully created and initialized, 0 otherwise. 
Discussion 

Factory function to create and initialize an IODMACommand in one operation.*/
IODMACommand * IODMACommand::withSpecification(
    SegmentFunction outSegFunc, 
    UInt8 numAddressBits, 
    UInt64 maxSegmentSize, 
    MappingOptions mappingOptions, 
    UInt64 maxTransferSize , 
    UInt32 alignment , 
    IOMapper *mapper , 
    void *refCon ){}; 


/*OutputHost32


Output host natural Segment32 output segment function. 

public

static bool OutputHost32(
    IODMACommand *target, 
    Segment64 seg,
    void *segs,
    UInt32 ind); */

bool IODMACommand::OutputHost32(
    IODMACommand *target, 
    Segment64 seg,
    void *segs,
    UInt32 ind){};

/*OutputHost64


Output host natural Segment64 output segment function. 

public

static bool OutputHost64(
    IODMACommand *target, 
    Segment64 seg,
    void *segs,
    UInt32 ind); */
bool IODMACommand::OutputHost64(
    IODMACommand *target, 
    Segment64 seg,
    void *segs,
    UInt32 ind){};
