#include <IOKit/IOFilterInterruptEventSource.h>



/*filterInterruptEventSource


Factor method to create and initialise an IOFilterInterruptEventSource. See init. 

public

static IOFilterInterruptEventSource * filterInterruptEventSource(
    OSObject *owner, 
    IOInterruptEventSource::Action action, 
    Filter filter, 
    IOService *provider, 
    int intIndex = 0); 
Parameters
owner
Owner/client of this event source.
action
'C' Function to call when something happens.
filter
'C' Function to call when interrupt occurs.
provider
Service that provides interrupts.
intIndex
Defaults to 0.
Return Value

a new event source if succesful, 0 otherwise.*/
 IOFilterInterruptEventSource * IOFilterInterruptEventSource:: filterInterruptEventSource(
    OSObject *owner, 
    IOInterruptEventSource::Action action, 
    Filter filter, 
    IOService *provider, 
    int intIndex ){};


/*signalInterrupt


Cause the work loop to schedule the action. 

public

virtual void signalInterrupt(); 
Discussion 

Cause the work loop to schedule the interrupt action even if the filter routine returns 'false'. Note well the interrupting condition MUST be cleared from the hardware otherwise an infinite process interrupt loop will occur. Use this function when 'SoftDMA' is desired. See IOFilterInterruptSource::Filter*/
 void IOFilterInterruptEventSource::signalInterrupt(){};
