#include <IOKit/ata/IOATADevConfig.h>

/*setPIOMode


public

void setPIOMode(
    UInt8 inModeBitMap); 
Parameters
inModeBitMap
Bit-significant map of PIO mode.*/
void IOATADevConfig:: setPIOMode(
    UInt8 inModeBitMap){};

/*setDMAMode


public

void setDMAMode(
    UInt8 inModeBitMap ); 
Parameters
inModeBitMap
Bit-significant map of DMA mode.*/
void IOATADevConfig::setDMAMode(
    UInt8 inModeBitMap ){};


/*setUltraMode


public

void setUltraMode(
    UInt8 inModeBitMap ); 
Parameters
inModeBitMap
Bit-significant map of Ultra mode.*/

void IOATADevConfig::setUltraMode(
    UInt8 inModeBitMap ){};

/*setPIOCycleTime


public

void setPIOCycleTime(
    UInt16 inNS ); 
Parameters
inNS
PIO cycle time in nanoseconds.*/

void IOATADevConfig::setPIOCycleTime(
    UInt16 inNS ){};



/*setDMACycleTime


public

void setDMACycleTime(
    UInt16 inNS ); 
Parameters
inNS
Reported multiword DMA Cycle time in nanoseconds.*/
void IOATADevConfig::setDMACycleTime(
    UInt16 inNS ){};


/*setPacketConfig


Tells the bus controller whether to wait for packet acceptance or set pending interrupt. 

public

void setPacketConfig (
    atapiConfig packetConfig); 
Parameters
packetConfig
Discussion 

For ATAPI devices, if the device asserts interrupt after the Packet Command when it is ready to accept the packet, set this value to true (mostly older devices). If the device accepts the packet only by asserting DRQ bit in status, then set this value false.*/

void IOATADevConfig::setPacketConfig (
    atapiConfig packetConfig){}; 


/*getPIOMode


public

UInt8 getPIOMode(
    void ); 
Return Value

Returns bit-significant map of PIO mode.*/

UInt8 IOATADevConfig::getPIOMode(
    void ){};



/*bitSigToNumeric


Converts a bit-significant field to a numerical value. 

public

virtual UInt8 bitSigToNumeric(
    UInt16 binary); 
Parameters
binary
the bit significant field.
Return Value

Returns the numerical value of the highest bit set in the field. 
Discussion 

Note that a bit field of 0x00 has no defined result.*/
 UInt8 IOATADevConfig:: bitSigToNumeric(
    UInt16 binary){};

/*getPIOCycleTime


public

UInt16 getPIOCycleTime(
    void ); 
Return Value

Returns reported PIO CycleTime in nanoseconds.*/
UInt16 IOATADevConfig::getPIOCycleTime(
    void ){};


/*getDMAMode


public

UInt8 getDMAMode(
    void ); 
Return Value

Returns bit-significant map of DMA mode.*/
UInt8 IOATADevConfig::getDMAMode(
    void ){};


/*getDMACycleTime


public

UInt16 getDMACycleTime(
    void ); 
Return Value

Returns reported multiword DMA cycle time in nanoseconds.*/
UInt16 IOATADevConfig::getDMACycleTime(
    void ){};

/*getUltraMode


public

UInt8 getUltraMode(
    void ); 
Return Value

Returns bit-significant map of Ultra mode.*/
UInt8 IOATADevConfig::getUltraMode(
    void ){};

/*getPacketConfig


public

atapiConfig getPacketConfig(
    void ); 
Return Value

Returns atapiConfig as defined in IOATATypes.h*/

atapiConfig IOATADevConfig::getPacketConfig(
    void ){};

/*atadevconfig


Static creator function. 

public

static IOATADevConfig* atadevconfig(
    void); */
 IOATADevConfig* IOATADevConfig::atadevconfig(
    void){}; 

/*initWithBestSelection


Handy initializer. 

public

IOReturn initWithBestSelection(
    const UInt16 *identifyData,
    IOATABusInfo *busInfo); 
Parameters
identifyData
512 Bytes of data obtained from the device via IDENTIFY DEVICE or IDENTIFY PACKET DEVICE command.
busInfo
Pointer to an IOATAbusInfo object obtained from a previous atanub->provideBusInfo() call.
Return Value

Returns kIOSuccess (0) when a matching transfer mode is available between the device and controller. 
Discussion 

Pass the 512-byte result of the Identify Device or Identify Packet Device in endian-order for your platform (byte-swapped on PPC) and the IOATABusInfo object for the bus. The object will initialize all fields and select the best transfer modes that match on bus and device. If the return value was 0 (success or noErr), then a matching mode is supported. Examine the PIO and UDMA/DMA fields and to generate the apropriate SET FEATURES parameters for your drive and send this initialized object to the IOATAController when requesting a speed configuration. Failure of this method means no supported transfer modes matched between bus and device info.*/
IOReturn IOATADevConfig::initWithBestSelection(
    const UInt16 *identifyData,
    IOATABusInfo *busInfo){}; 
