#include <IOKit/audio/IOAudioStream.h>

bool IOAudioStream::validateFormat(IOAudioStreamFormat *a, IOAudioStreamFormatExtension *b, IOAudioStreamFormatDesc *c, const IOAudioSampleRate *d){};//?
void IOAudioStream::setDirection(IOAudioStreamDirection a){};//?

/*setTerminalType


public

virtual void setTerminalType(
    const UInt32 terminalType); 
Discussion 

Sets the terminal type of the current stream.*/

 void IOAudioStream::setTerminalType(
    const UInt32 terminalType){}; 

/*initWithAudioEngine


public

virtual bool initWithAudioEngine(
    IOAudioEngine *engine,
    IOAudioStreamDirection dir,
    UInt32 startChannelID,
    const char *streamDescription = NULL,
    OSDictionary *properties = 0); 
Discussion 

Initializes a stream object.*/
 bool IOAudioStream::initWithAudioEngine(
    IOAudioEngine *engine,
    IOAudioStreamDirection dir,
    UInt32 startChannelID,
    const char *streamDescription,
    OSDictionary *properties ){};

/*setSampleBuffer


public

virtual void setSampleBuffer(
    void *buffer,
    UInt32 size); 
Discussion 

Assigns a sample buffer of a given size to the stream.*/

void IOAudioStream::setSampleBuffer(
    void *buffer,
    UInt32 size){};

/*addAvailableFormat(const IOAudioStreamFormat *, const IOAudioSampleRate *, const IOAudioSampleRate *, AudioIOFunction)


public

virtual void addAvailableFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioSampleRate *minRate,
    const IOAudioSampleRate *maxRate,
    AudioIOFunction ioFunction); 
Discussion 

Adds a single available sample format to an audio stream. */
 void IOAudioStream:: addAvailableFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioSampleRate *minRate,
    const IOAudioSampleRate *maxRate,
    AudioIOFunction ioFunction){}; 

/*addAvailableFormat(const IOAudioStreamFormat *, const IOAudioSampleRate *, const IOAudioSampleRate *, const AudioIOFunction *, UInt32)


public

virtual void addAvailableFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioSampleRate *minRate,
    const IOAudioSampleRate *maxRate,
    const AudioIOFunction *ioFunctionList = NULL,
    UInt32 numFunctions = 0); 
Discussion 

Adds a list of available sample formats to an audio stream. */
 void  IOAudioStream::addAvailableFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioSampleRate *minRate,
    const IOAudioSampleRate *maxRate,
    const AudioIOFunction *ioFunctionList ,
    UInt32 numFunctions ){};

/*addAvailableFormat(const IOAudioStreamFormat *, const IOAudioStreamFormatExtension *, const IOAudioSampleRate *, const IOAudioSampleRate *, AudioIOFunction)


public

virtual void addAvailableFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    const IOAudioSampleRate *minRate,
    const IOAudioSampleRate *maxRate,
    AudioIOFunction ioFunction); 
Discussion 

Adds a single available format to the list of supported formats. 

addAvailableFormat(const IOAudioStreamFormat *, const IOAudioStreamFormatExtension *, const IOAudioSampleRate *, const IOAudioSampleRate *, const AudioIOFunction *, UInt32)


public

virtual void addAvailableFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    const IOAudioSampleRate *minRate,
    const IOAudioSampleRate *maxRate,
    const AudioIOFunction *ioFunctionList = NULL,
    UInt32 numFunctions = 0); 
Discussion 

Adds multiple available formats to the list of supported formats in a single call.*/
void IOAudioStream::addAvailableFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    const IOAudioSampleRate *minRate,
    const IOAudioSampleRate *maxRate,
    AudioIOFunction ioFunction){}; 

/*setFormat


public

virtual IOReturn setFormat(
    const IOAudioStreamFormat *streamFormat,
    OSDictionary *formatDict,
    bool callDriver = true); 
Discussion 

Sets the current stream format and stream format dictionary. */

 IOReturn IOAudioStream::setFormat(
    const IOAudioStreamFormat *streamFormat,
    OSDictionary *formatDict,
    bool callDriver ){}; 

/*setFormat(const IOAudioStreamFormat *, bool)


public

virtual IOReturn setFormat(
    const IOAudioStreamFormat *streamFormat,
    bool callDriver = true); 
Discussion 

Sets the current stream format. */
 IOReturn IOAudioStream:: setFormat(
    const IOAudioStreamFormat *streamFormat,
    bool callDriver ){}; 

/*setFormat(const IOAudioStreamFormat *, const IOAudioStreamFormatExtension *, bool)


public

virtual IOReturn setFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    bool callDriver = true); 
Discussion 

Sets the current audio format. */

 IOReturn IOAudioStream::setFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    bool callDriver ){}; 

/*setFormat(const IOAudioStreamFormat *, const IOAudioStreamFormatExtension *, OSDictionary *, bool)


public

virtual IOReturn setFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    OSDictionary *formatDaict,
    bool callDriver = true); 
Discussion 

Sets the current audio format using a format dictionary. */
 IOReturn IOAudioStream::setFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    OSDictionary *formatDict,
    bool callDriver ){}; 

/*setFormat(OSDictionary *)


public

virtual IOReturn setFormat(
    OSDictionary *formatDict); 
Discussion 

Sets the current stream format dictionary.*/
IOReturn IOAudioStream::setFormat(
    OSDictionary *formatDict){};


/*clearAvailableFormats


public

virtual void clearAvailableFormats(); 
Discussion 

Clears the list of available formats.*/
 void IOAudioStream::clearAvailableFormats(){};

/*addAvailableFormat(const IOAudioStreamFormat *, const IOAudioStreamFormatExtension *, const IOAudioSampleRate *, const IOAudioSampleRate *, const AudioIOFunction *, UInt32)


public

virtual void addAvailableFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    const IOAudioSampleRate *minRate,
    const IOAudioSampleRate *maxRate,
    const AudioIOFunction *ioFunctionList = NULL,
    UInt32 numFunctions = 0); 
Discussion 

Adds multiple available formats to the list of supported formats in a single call.*/

void IOAudioStream::addAvailableFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    const IOAudioSampleRate *minRate,
    const IOAudioSampleRate *maxRate,
    const AudioIOFunction *ioFunctionList ,
    UInt32 numFunctions ){}; 

/*hardwareFormatChanged


public

virtual IOReturn hardwareFormatChanged(
    const IOAudioStreamFormat *streamFormat); 
Discussion 

Notifies the Audio HAL that the hardware has requested an audio format change (such as when an external clock source changes rates).*/
IOReturn IOAudioStream::hardwareFormatChanged(
    const IOAudioStreamFormat *streamFormat){};


/*getFormat


public

virtual const IOAudioStreamFormat *getFormat(); 
Discussion 

Returns the current audio stream format.*/
 const IOAudioStreamFormat * IOAudioStream::getFormat(){};

/*createFormatFromDictionary


public

static IOAudioStreamFormat *createFormatFromDictionary(
    const OSDictionary *formatDict,
    IOAudioStreamFormat *streamFormat = 0,
    IOAudioStreamFormatExtension *formatExtension = 0); 
Discussion 

Creates an audio format value from an OSDictionary object.*/
IOAudioStreamFormat * IOAudioStream::createFormatFromDictionary(
    const OSDictionary *formatDict,
    IOAudioStreamFormat *streamFormat ,
    IOAudioStreamFormatExtension *formatExtension ){};


/*getDirection


public

virtual IOAudioStreamDirection getDirection(); 
Discussion 

Gets the direction of a stream.*/
IOAudioStreamDirection  IOAudioStream::getDirection(){}; 


/*getSampleBufferSize


public

virtual UInt32 getSampleBufferSize(); 
Discussion 

Returns the size of the current sample buffer.*/

 UInt32 IOAudioStream::getSampleBufferSize(){}; 


/*getSampleBuffer


public

virtual void *getSampleBuffer(); 
Discussion 

Returns the current sample buffer. */
void *IOAudioStream::getSampleBuffer(){}; 


/*removeClient


protected

virtual void removeClient(
    IOAudioClientBuffer *clientBuffer); 
Discussion 

Removes a client of this stream.*/
void IOAudioStream::removeClient(
    IOAudioClientBuffer *clientBuffer){}; 


/*lockStreamForIO


protected

virtual void lockStreamForIO(); 
Discussion 

Locks the stream for I/O.*/
void IOAudioStream::lockStreamForIO(){}; 

/*unlockStreamForIO


protected

virtual void unlockStreamForIO(); 
Discussion 

Unlocks the stream for I/O.*/
void IOAudioStream::unlockStreamForIO(){}; 

/*addClient


protected

virtual IOReturn addClient(
    IOAudioClientBuffer *clientBuffer); 
Discussion 

Adds a new client to this stream..*/

IOReturn IOAudioStream::addClient(
    IOAudioClientBuffer *clientBuffer){}; 

/*getNumClients


protected

virtual UInt32 getNumClients(); 
Discussion 

Returns the current number of clients of this stream..*/
UInt32 IOAudioStream::getNumClients(){}; 

/*processOutputSamples


protected

virtual IOReturn processOutputSamples(
    IOAudioClientBuffer *clientBuffer,
    UInt32 firstSampleFrame,
    UInt32 loopCount,
    bool samplesAvailable); 
Discussion 

Calls functions to mix source material into the mix buffer and, if necessary, clip the results.*/
 IOReturn IOAudioStream::processOutputSamples(
    IOAudioClientBuffer *clientBuffer,
    UInt32 firstSampleFrame,
    UInt32 loopCount,
    bool samplesAvailable){}; 

/*setDefaultNumSampleFramesRead


public

virtual void setDefaultNumSampleFramesRead(
    UInt32); 
Discussion 

Sets the default number of sample frames read.*/

void IOAudioStream::setDefaultNumSampleFramesRead(
    UInt32 a){}; 


/*readInputSamples


protected

virtual IOReturn readInputSamples(
    IOAudioClientBuffer *clientBuffer,
    UInt32 firstSampleFrame); 
Discussion 

Calls I/O functions to read input samples from hardware.*/
 IOReturn IOAudioStream:: readInputSamples(
    IOAudioClientBuffer *clientBuffer,
    UInt32 firstSampleFrame){}; 

/*getNumSampleFramesRead


public

virtual UInt32 getNumSampleFramesRead(); 
Discussion 

Returns the number of sample frames read.*/
 UInt32 IOAudioStream::getNumSampleFramesRead(){}; 


/*clipOutputSamples


protected

virtual void clipOutputSamples(
    UInt32 startingSampleFrame,
    UInt32 numSampleFrames); 
Discussion 

Generally, this function calls the audio engine's clipOutputSamples function. This can, however, be overridden on a per-stream basis.*/

void IOAudioStream::clipOutputSamples(
    UInt32 startingSampleFrame,
    UInt32 numSampleFrames){}; 


/*validateFormat(IOAudioStreamFormat *, IOAudioStreamFormatExtension *, IOAudioStreamFormatDesc *)


public

virtual bool validateFormat(
    IOAudioStreamFormat *streamFormat,
    IOAudioStreamFormatExtension *formatExtension,
    IOAudioStreamFormatDesc *formatDesc); 
Discussion 

Validates an audio format format (with format extension).*/
bool IOAudioStream::validateFormat(
    IOAudioStreamFormat *streamFormat,
    IOAudioStreamFormatExtension *formatExtension,
    IOAudioStreamFormatDesc *formatDesc){};

/*validateFormat(IOAudioStreamFormat *, IOAudioStreamFormatDesc *)


public

virtual bool validateFormat(
    IOAudioStreamFormat *streamFormat,
    IOAudioStreamFormatDesc *formatDesc); 
Discussion 

Validates an audio format. */
bool IOAudioStream::validateFormat(
    IOAudioStreamFormat *streamFormat,
    IOAudioStreamFormatDesc *formatDesc){}; 


/*setStartingChannelNumber


protected

virtual void setStartingChannelNumber(
    UInt32 channelNumber); 
Discussion 

Sets the starting channel number for this stream.*/
void IOAudioStream::setStartingChannelNumber(
    UInt32 channelNumber){}; 

/*removeDefaultAudioControls


public

virtual void removeDefaultAudioControls(); 
Discussion 

Removes all default audio controls.*/
void IOAudioStream::removeDefaultAudioControls(){}; 

/*resetClipInfo


protected

virtual void resetClipInfo(); 
Discussion 

Resets clip position information to zero.*/
void IOAudioStream::resetClipInfo(){};
 
/*getStreamAvailable


public

virtual bool getStreamAvailable(); 
Discussion 

Returns the stream's availability as set by setStreamAvailable.*/
bool IOAudioStream::getStreamAvailable(){};


/*setIOFunctionList


public

virtual void setIOFunctionList(
    const AudioIOFunction *ioFunctionList,
    UInt32 numFunctions); 
Discussion 

Assigns a list of I/O functions to the stream.*/
void IOAudioStream:: setIOFunctionList(
    const AudioIOFunction *ioFunctionList,
    UInt32 numFunctions){}; 

/*setMixBuffer


public

virtual void setMixBuffer(
    void *buffer,
    UInt32 size); 
Discussion 

Assigns a mix buffer of a given size to the stream.*/
void IOAudioStream::setMixBuffer(
    void *buffer,
    UInt32 size){}; 

/*free


public

virtual void free(); 
Discussion 

Frees a stream object and its instance variables.*/
void IOAudioStream::free(){}; 

/*getWorkLoop


public

virtual IOWorkLoop *getWorkLoop() const; 
Discussion 

Returns the workloop associated with the stream.*/
IOWorkLoop * IOAudioStream::getWorkLoop() const{}; 


/*setFormatAction


public

static IOReturn setFormatAction(
    OSObject *owner,
    void *arg1,
    void *arg2,
    void *arg3,
    void *arg4); 
Discussion 

Assigns a format action callback. This function will be called when a format change occurs.*/
IOReturn IOAudioStream:: setFormatAction(
    OSObject *owner,
    void *arg1,
    void *arg2,
    void *arg3,
    void *arg4){}; 


/*addDefaultAudioControl


public

virtual IOReturn addDefaultAudioControl(
    IOAudioControl *defaultAudioControl); 
Discussion 

Adds a default audio control.*/

IOReturn IOAudioStream:: addDefaultAudioControl(
    IOAudioControl *defaultAudioControl){}; 

/*initKeys


public

static void initKeys(); 
Discussion 

Initializes keys to default values.*/
void IOAudioStream:: initKeys(){}; 


/*createDictionaryFromFormat


public

static OSDictionary *createDictionaryFromFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    OSDictionary *formatDict = 0); 
Discussion 

Creates an OSDictionary object from audio format values.*/
OSDictionary * IOAudioStream::createDictionaryFromFormat(
    const IOAudioStreamFormat *streamFormat,
    const IOAudioStreamFormatExtension *formatExtension,
    OSDictionary *formatDict ){}; 

/*setStreamAvailable


public

virtual void setStreamAvailable(
    bool available); 
Discussion 

Marks a stream as available or unavailable for use.*/
void IOAudioStream::setStreamAvailable(
    bool available){}; 

/*clipIfNecessary


protected

virtual void clipIfNecessary(); 
Discussion 

Calls clipOutputSamples if there are frames in the mix buffer that have not been clipped.*/
void  IOAudioStream::clipIfNecessary(){}; 


/*getFormatExtension


public

virtual const IOAudioStreamFormatExtension *getFormatExtension(); 
Discussion 

Gets the current format extension.*/
const IOAudioStreamFormatExtension *IOAudioStream::getFormatExtension(){}; 

/*mixOutputSamples


public

virtual IOReturn mixOutputSamples(
    const void *sourceBuf,
    void *mixBuf,
    UInt32 firstSampleFrame,
    UInt32 numSampleFrames,
    const IOAudioStreamFormat *streamFormat,
    IOAudioStream *audioStream); 
Discussion 

Calls the Audio Engine's mixOutputSamples function. This may be overridden on a stream-by-stream basis by subclassing IOAudioStream.*/
IOReturn IOAudioStream::mixOutputSamples(
    const void *sourceBuf,
    void *mixBuf,
    UInt32 firstSampleFrame,
    UInt32 numSampleFrames,
    const IOAudioStreamFormat *streamFormat,
    IOAudioStream *audioStream){}; 

/*setSampleLatency


public

virtual void setSampleLatency(
    UInt32 numSamples); 
Discussion 

Calls the Audio Engine's setSampleLatency function. This may be overridden on a stream-by-stream basis by subclassing IOAudioStream.*/
void IOAudioStream::setSampleLatency(
    UInt32 numSamples){}; 


/*stop


public

virtual void stop(
    IOService *provider); 
Discussion 

Stops an audio stream.*/
void IOAudioStream::stop(
    IOService *provider){}; 

/*updateNumClients


protected

virtual void updateNumClients(); 
Discussion 

Iterates the stream's client list and updates the current count of clients.*/
void IOAudioStream::updateNumClients(){}; 

/*setProperties


public

virtual IOReturn setProperties(
    OSObject *properties); 
Discussion 

Sets properties on a stream.*/
IOReturn IOAudioStream::setProperties(
    OSObject *properties){}; 

/*getMixBuffer


public

virtual void *getMixBuffer(); 
Discussion 

Returns the current mix buffer.*/
void *IOAudioStream::getMixBuffer(){}; 

/*getMaxNumChannels


public

virtual UInt32 getMaxNumChannels(); 
Discussion 

Returns the maximum number of channels for any format that this stream supports. The next audio stream created should start at getStartingChannelID() + getMaxNumChannels().*/
UInt32 IOAudioStream:: getMaxNumChannels(){}; 

/*getStartingChannelID


public

virtual UInt32 getStartingChannelID(); 
Discussion 

Returns the first channel ID for this stream. Each successive channel has an ID that is one higher than the last, up to getStartingChannelID() + getMaxNumChannels() - 1.*/
UInt32 IOAudioStream::getStartingChannelID(){}; 

/*getMixBufferSize


public

virtual UInt32 getMixBufferSize(); 
Discussion 

Returns the size of the current mix buffer.*/
UInt32 IOAudioStream:: getMixBufferSize(){}; 


/*numSampleFramesPerBufferChanged


public

virtual void numSampleFramesPerBufferChanged(); 
Discussion 

This function should be called if you change the number of sample frames in the buffer.*/
void IOAudioStream::numSampleFramesPerBufferChanged(){}; 

/*clearSampleBuffer


public

virtual void clearSampleBuffer(); 
Discussion 

This function zeroes the sample buffer. You should call this prior to starting the audio engine.*/
void IOAudioStream::clearSampleBuffer(){}; 


/*setIOFunction


public

virtual void setIOFunction(
    AudioIOFunction ioFunction); 
Discussion 

Assigns an I/O function to the stream.*/
void IOAudioStream::setIOFunction(
    AudioIOFunction ioFunction){}; 

