#include <IOKit/firewire/IOFWPhysicalAddressSpace.h>

IOFWAddressSpaceAux * IOFWPhysicalAddressSpace::createAuxiliary(){};//?
void IOFWPhysicalAddressSpace:: free(){};//?
IOReturn IOFWPhysicalAddressSpaceAux::complete(){};//?
UInt64 IOFWPhysicalAddressSpaceAux::getPhysicalSegment( UInt64 a, UInt64 * b){};//?
void IOFWPhysicalAddressSpaceAux::setDMACommand( IODMACommand * a){};//?
bool IOFWPhysicalAddressSpaceAux::init( IOFWAddressSpace * a){};//?
void IOFWPhysicalAddressSpaceAux:: free(){};//?
bool IOFWPhysicalAddressSpaceAux::isPrepared(){};//?
IOReturn IOFWPhysicalAddressSpaceAux::synchronize( IOOptionBits a ){};//?
IOReturn IOFWPhysicalAddressSpaceAux::getSegments( UInt64 * a, FWSegment * b, UInt32 * c ){};//?

IOReturn IOFWPhysicalAddressSpaceAux::prepare( ){};//?
IODMACommand * IOFWPhysicalAddressSpaceAux::getDMACommand(){}; //?

/////////
int IOFWPhysicalAddressSpace_HYS::getPhysicalSegment(int a,UInt64 *b){};//?

int IOFWPhysicalAddressSpace_HYS::getSegments(UInt64 * a,FWSegment * b,UInt32 *c){};//?

/*init


Initialize physical address space. 

virtual bool init(
    IOFireWireBus *bus );  
Parameters
bus
Points to IOFireWireBus object.
Return Value

returns true if success, else false*/
bool IOFWPhysicalAddressSpace:: init(
    IOFireWireBus *bus ){};  

/*checkMemoryInRange


Validates the IOMemoryDescriptor, which is used to initialize the PhysicalAddressSpace. 

IOReturn checkMemoryInRange(
    IOMemoryDescriptor *memory );  
Parameters
memory
Points to a valid IOMemoryDescriptor.
Return Value

returns kIOReturnSuccess on success*/
IOReturn IOFWPhysicalAddressSpace::checkMemoryInRange(
    IOMemoryDescriptor *memory ){};  

/*initWithDesc


Initialize physical address space with IOMemoryDescriptor. 

virtual bool initWithDesc(
    IOFireWireBus *bus, 
    IOMemoryDescriptor *mem);  
Parameters
bus
Points to IOFireWireBus object.
mem
Points to IOMemoryDescriptor.
Return Value

returns true if success, else false*/
bool IOFWPhysicalAddressSpace::initWithDesc(
    IOFireWireBus *bus, 
    IOMemoryDescriptor *mem){};  

/*getMemoryDescriptor


Gets the memory descriptor, which is associated to this PhysicalAddressSpace. 

IOMemoryDescriptor * getMemoryDescriptor(
    void );  
Parameters
none.
Return Value

returns the IOMemoryDescriptor*/
IOMemoryDescriptor * IOFWPhysicalAddressSpace:: getMemoryDescriptor(
    void ){};  

/*doRead


A method for processing an address space read request 

virtual UInt32 doRead(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 len, 
    IOMemoryDescriptor **buf,
    IOByteCount *offset, 
    IOFWRequestRefCon refcon);  
Parameters
nodeID
FireWire Read from nodeID.
speed
at this 'speed'.
addr
with FireWire address 'addr'.
len
read 'len' bytes from nodeID.
buf
points to a memory descriptor containing the packet data.
offset
start from this 'offset' in 'buf'.
refcon
Can be queried for extra info about the request.
Return Value

UIn32 returns kFWResponseComplete on success*/
UInt32 IOFWPhysicalAddressSpace::doRead(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 len, 
    IOMemoryDescriptor **buf,
    IOByteCount *offset, 
    IOFWRequestRefCon refcon){};  


/*doWrite


A method for processing an address space write request 

virtual UInt32 doWrite(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 len, 
    const void *buf,
    IOFWRequestRefCon refcon);  
Parameters
nodeID
FireWire Write to nodeID.
speed
at this 'speed'.
addr
with FireWire address 'addr'.
len
write 'len' bytes to nodeID.
buf
obtain bytes from location given by 'buf'.
reqrefcon
Can be queried for extra info about the request.
Return Value

UIn32 returns kFWResponseComplete on success*/
UInt32 IOFWPhysicalAddressSpace::doWrite(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 len, 
    const void *buf,
    IOFWRequestRefCon refcon){};  

/*initWithDMACommand


Initialize physical address space with IODMACommand. 

virtual bool initWithDMACommand(
    IOFireWireBus *control,
    IODMACommand *command );  
Parameters
bus
Points to IOFireWireBus object.
command
Points to IODMACommand.
Return Value

returns true if success, else false*/
bool IOFWPhysicalAddressSpace::initWithDMACommand(
    IOFireWireBus *control,
    IODMACommand *command ){};  

/*setMemoryDescriptor


Sets the memory descriptor, which will be associated to this PhysicalAddressSpace. 

IOReturn setMemoryDescriptor(
    IOMemoryDescriptor *descriptor );  
Parameters
none.
Return Value

returns the IOMemoryDescriptor*/
IOReturn IOFWPhysicalAddressSpace::setMemoryDescriptor(
    IOMemoryDescriptor *descriptor ){};  

/*setDMACommand


Set the DMACommand for this PhysicalAddressSpace. 

inline void setDMACommand(
    IODMACommand *dma_command ) ;
Parameters
dma_command
Points to IODMACommand object.
Return Value

none*/
void IOFWPhysicalAddressSpace::setDMACommand(
    IODMACommand *dma_command ){} ;

/*getLength


Get the length of the memory backed by PhysicalAddressSpace. 

UInt64 getLength(
    void );  
Parameters
none.
Return Value

returns the length*/
UInt64 IOFWPhysicalAddressSpace::getLength(
    void ){};  

/*getDMACommand


Get the DMACommand from this PhysicalAddressSpace. 

inline IODMACommand * getDMACommand(
    void ) ;
Parameters
none.
Return Value

return previously assigned IODMACommand, null if not initialized*/
IODMACommand * IOFWPhysicalAddressSpace::getDMACommand(
    void ){} ;


/*prepare


Prepare the IODMACommand used by this PhysicalAddressSpace. 

inline IOReturn prepare(
    void ) ;
Parameters
none.
Return Value

returns kIOReturnSuccess on success*/
IOReturn IOFWPhysicalAddressSpace::prepare(
    void ) {};

/*complete

complete the IODMACommand used by this PhysicalAddressSpace. 

inline IOReturn complete(
    void ) ;
Parameters
none.
Return Value

returns kIOReturnSuccess on success*/
IOReturn IOFWPhysicalAddressSpace::complete(
    void ) {};

/*synchronize


synchronize the IODMACommand used by this PhysicalAddressSpace. 

inline IOReturn synchronize(
    IOOptionBits options ) ;
Parameters
none.
Return Value

returns kIOReturnSuccess on success*/
 IOReturn IOFWPhysicalAddressSpace::synchronize(
    IOOptionBits options ){} ;

/*isPrepared


Inspects whether the IODMACommand was prepared in this PhysicalAddressSpace. 

inline bool isPrepared(
    void ) ;
Parameters
none.
Return Value

returns true if prepared, else false*/
bool IOFWPhysicalAddressSpace::isPrepared(
    void ){};
