#include <IOKit/hid/IOHIDDevice.h>

/*handleStart


Prepare the hardware and driver to support I/O operations. 

protected

virtual bool handleStart(
    IOService *provider ); 
Parameters
provider
The provider argument passed to start().
Return Value

True on success, or false otherwise. Returning false will cause start() to fail and return false. 
Discussion 

IOHIDDevice will call this method from start() before any I/O operations are issued to the concrete subclass. Methods such as newReportDescriptor() are only called after handleStart() has returned true. A subclass that overrides this method should begin its implementation by calling the version in super, and then check the return value.*/
bool IOHIDDevice::handleStart(
    IOService *provider ){}; 

/*handleStop


Quiesce the hardware and stop the driver. 

protected

virtual void handleStop(
    IOService *provider ); 
Parameters
provider
The provider argument passed to stop().
Discussion 

IOHIDDevice will call this method from stop() to signal that the hardware should be quiesced and the driver stopped. A subclass that overrides this method should end its implementation by calling the version in super.*/
 void IOHIDDevice::handleStop(
    IOService *provider ){}; 


/*handleReport


Handle an asynchronous report received from the HID device. 

public

virtual IOReturn handleReport( 
    IOMemoryDescriptor *report, 
    IOHIDReportType reportType = kIOHIDReportTypeInput, 
    IOOptionBits options = 0 ); 
Parameters
report
A memory descriptor that describes the report.
reportType
The type of report.
options
Options to specify the request. No options are currently defined, and the default value is 0.
Return Value

kIOReturnSuccess on success, or an error return otherwise.*/

 IOReturn IOHIDDevice::handleReport( 
    IOMemoryDescriptor *report, 
    IOHIDReportType reportType , 
    IOOptionBits options ){}; 
