#include <IOKit/hid/IOHIDQueue.h>

/*IOHIDQueueGetTypeID


Returns the type identifier of all IOHIDQueue instances. 

CF_EXPORT CFTypeID IOHIDQueueGetTypeID(
    void) ;  

Availability
Introduced in Mac OS X v10.5.*/
 CFTypeID IOHIDQueueGetTypeID(
    void){} ;  

/*IOHIDQueueCopyNextValueWithTimeout


Dequeues a retained copy of an element value from the head of an IOHIDQueue. This method will block until either a value is available or it times out. 

CF_EXPORT IOHIDValueRef IOHIDQueueCopyNextValueWithTimeout( 
    IOHIDQueueRef queue, 
    CFTimeInterval timeout) ;  
Parameters
queue
IOHIDQueue object to be queried.
timeout
Timeout before aborting an attempt to dequeue a value from the head of a queue.
Return Value

Returns valid IOHIDValueRef if data is available. 
Discussion 

Because the value is a retained copy, it is up to the caller to release the value using CFRelease. Use with setValueCallback to avoid polling the queue for data. 

Availability
Introduced in Mac OS X v10.5.*/
IOHIDValueRef IOHIDQueueCopyNextValueWithTimeout( 
    IOHIDQueueRef queue, 
    CFTimeInterval timeout){} ;  
