#include <IOKit/hid/IOHIDValue.h>


/*IOHIDValueGetElement


Returns the element value associated with this IOHIDValueRef. 

CF_EXPORT IOHIDElementRef IOHIDValueGetElement(
    IOHIDValueRef value) ;  
Parameters
value
The value to be queried. If this parameter is not a valid IOHIDValueRef, the behavior is undefined.
Return Value

Returns a IOHIDElementRef referenced by this value. 

Availability
Introduced in Mac OS X v10.5.*/
CF_EXPORT IOHIDElementRef IOHIDValueGetElement(
    IOHIDValueRef value){} ;  



/*IOHIDValueGetTimeStamp


Returns the timestamp value contained in this IOHIDValueRef. 

CF_EXPORT uint64_t IOHIDValueGetTimeStamp(
    IOHIDValueRef value) ;  
Parameters
value
The value to be queried. If this parameter is not a valid IOHIDValueRef, the behavior is undefined.
Return Value

Returns a uint64_t representing the timestamp of this value. 
Discussion 

The timestamp value returned represents OS AbsoluteTime, not CFAbsoluteTime. 

Availability
Introduced in Mac OS X v10.5.*/

CF_EXPORT uint64_t IOHIDValueGetTimeStamp(
    IOHIDValueRef value){} ;  

/*IOHIDValueGetBytePtr


Returns a byte pointer to the value contained in this IOHIDValueRef. 

CF_EXPORT const uint8_t * IOHIDValueGetBytePtr(
    IOHIDValueRef value) ;  
Parameters
value
The value to be queried. If this parameter is not a valid IOHIDValueRef, the behavior is undefined.
Return Value

Returns a pointer to the value. 

Availability
Introduced in Mac OS X v10.5.*/
CF_EXPORT const uint8_t * IOHIDValueGetBytePtr(
    IOHIDValueRef value) {};  


/*IOHIDValueGetIntegerValue


Returns an integer representaion of the value contained in this IOHIDValueRef. 

CF_EXPORT CFIndex IOHIDValueGetIntegerValue(
    IOHIDValueRef value) ;  
Parameters
value
The value to be queried. If this parameter is not a valid IOHIDValueRef, the behavior is undefined.
Return Value

Returns an integer representation of the value. 
Discussion 

The value is based on the logical element value contained in the report returned by the device. 

Availability
Introduced in Mac OS X v10.5.*/
CF_EXPORT CFIndex IOHIDValueGetIntegerValue(
    IOHIDValueRef value) {};  

/*IOHIDValueGetLength


Returns the size, in bytes, of the value contained in this IOHIDValueRef. 

CF_EXPORT CFIndex IOHIDValueGetLength(
    IOHIDValueRef value) ;  
Parameters
value
The value to be queried. If this parameter is not a valid IOHIDValueRef, the behavior is undefined.
Return Value

Returns length of the value. 

Availability
Introduced in Mac OS X v10.5.*/
CF_EXPORT CFIndex IOHIDValueGetLength(
    IOHIDValueRef value) {};  
