#include <IOKit/network/IOBasicOutputQueue.h>

IOReturn IOBasicOutputQueue::dispatchNetworkDataNotification(void *a, void *b, IONetworkData *c, UInt32 d){};//c

void IOBasicOutputQueue::dequeue(){};//c

/*withTarget(IONetworkController *, UInt32)


Factory method that constructs and initializes an IOBasicOutputQueue object. 

public

static IOBasicOutputQueue * withTarget(
    IONetworkController *target, 
    UInt32 capacity = 0); 
Parameters
target
An IONetworkController object that will handle packets removed from the queue.
capacity
The initial capacity of the output queue.
Return Value

Returns an IOBasicOutputQueue object on success, or 0 otherwise.*/
 IOBasicOutputQueue * IOBasicOutputQueue::withTarget(
    IONetworkController *target, 
    UInt32 capacity ){};

/*getSize


Gets the number of packets currently held in the queue. 

public

virtual UInt32 getSize() const; 
Return Value

Returns the size of the queue.*/
UInt32  IOBasicOutputQueue::getSize() const{}; 

/*getState


Gets the state of the queue object. 

public

virtual UInt32 getState() const; 
Return Value

Returns the current state of the queue object.*/
 UInt32 IOBasicOutputQueue::getState() const{}; 

/*getStallCount


Gets the number of instances when the target has stalled the queue. 

public

virtual UInt32 getStallCount(); 
Return Value

Returns the number of times that kIOOutputCommandStall is returned by the target.*/
UInt32 IOBasicOutputQueue::getStallCount(){}; 


/*getRetryCount


Gets the number of instances when the target has refused to accept the packet provided. 

public

virtual UInt32 getRetryCount(); 
Return Value

Returns the number of times that kIOOutputStatusRetry is returned by the target.*/
 UInt32 IOBasicOutputQueue::getRetryCount(){};
 
/*enqueue


Adds a packet, or a chain of packets, to the queue. 

public

virtual UInt32 enqueue(
    mbuf_t m,
    void *param); 
Parameters
m
A single packet, or a chain of packets.
param
A parameter provided by the caller.
Return Value

Always returns 0. 
Discussion 

This method is called by a client to add a packet, or a chain of packets, to the queue. A packet is described by an mbuf chain, while a chain of packets is constructed by linking multiple mbuf chains via the m_nextpkt field. This method can be called by multiple client threads*/
 UInt32 IOBasicOutputQueue::enqueue(
    mbuf_t m,
    void *param){}; 

/*service


Services a queue that was stalled by the target. 

public

virtual bool service(
    IOOptionBits options = 0); 
Return Value

Returns true if the queue was stalled and there were packets sitting in the queue awaiting delivery, false otherwise. 
Discussion 

A target that stalls the queue must call service() when it becomes ready to accept more packets. Calling this method when the queue is not stalled is harmless.*/
 bool IOBasicOutputQueue::service(
    IOOptionBits options ){}; 


/*start


Starts up the packet flow between the queue and its target. 

public

virtual bool start(); 
Return Value

Returns true if the queue was started successfully, false otherwise. 
Discussion 

Called by the target to start the queue. This will allow packets to be removed from the queue, and then delivered to the target.*/
 bool IOBasicOutputQueue:: start(){}; 

/*stop


Stops the packet flow between the queue and its target. 

public

virtual bool stop(); 
Return Value

Returns the previous running state of the queue, true if the queue was running, false if the queue was already stopped. 
Discussion 

This method stops the queue and prevents it from sending packets to its target. This call is synchronous and it may block. After this method returns, the queue will no longer call the registered target/action, even as new packets are added to the queue. The queue will continue to absorb new packets until the size of the queue reaches its capacity. The registered action must never call stop(), or a deadlock will occur.*/
 bool IOBasicOutputQueue::stop(){}; 

/*setCapacity


Changes the number of packets that the queue can hold before it begins to drop excess packets. 

public

virtual bool setCapacity(
    UInt32 capacity); 
Parameters
capacity
The new desired capacity.
Return Value

Returns true if the new capacity was accepted, false otherwise.*/
bool IOBasicOutputQueue::setCapacity(
    UInt32 capacity){};

/*flush


Drops and frees all packets currently held by the queue. 

public

virtual UInt32 flush(); 
Return Value

Returns the number of packets that were dropped and freed. 
Discussion 

To ensure that all packets are removed from the queue, stop() should be called prior to flush(), to make sure there are no packets in-flight and being delivered to the target.*/
 UInt32 IOBasicOutputQueue::flush(){}; 

/*handleNetworkDataAccess


Handles an external access to the IONetworkData object returned by getStatisticsData(). 

protected

virtual IOReturn handleNetworkDataAccess(
    IONetworkData *data, 
    UInt32 type, 
    void *param); 
Parameters
data
The IONetworkData object being accessed.
type
Description of the type of access being performed.
param
An optional parameter for the handler.
Return Value

Returns kIOReturnSuccess on success, or an error code otherwise.*/

IOReturn IOBasicOutputQueue::handleNetworkDataAccess(
    IONetworkData *data, 
    UInt32 type, 
    void *param){}; 

/*init


Initializes an IOBasicOutputQueue object. 

public

virtual bool init(
    OSObject *target, 
    IOOutputAction action, 
    UInt32 capacity = 0); 
Parameters
target
The object that will handle packets removed from the queue, which is usually a subclass of IONetworkController.
action
The function that will handle packets removed from the queue.
capacity
The initial capacity of the output queue.
Return Value

Returns true if initialized successfully, false otherwise.*/
 bool IOBasicOutputQueue::init(
    OSObject *target, 
    IOOutputAction action, 
    UInt32 capacity ){}; 

/*withTarget(OSObject *, IOOutputAction, UInt32)


Factory method that constructs and initializes an IOBasicOutputQueue object. 

public

static IOBasicOutputQueue * withTarget(
    OSObject *target, 
    IOOutputAction action, 
    UInt32 capacity = 0); 
Parameters
target
The object that will handle packets removed from the queue.
action
The function that will handle packets removed from the queue.
capacity
The initial capacity of the output queue.
Return Value

Returns an IOBasicOutputQueue object on success, or 0 otherwise.*/
 IOBasicOutputQueue * IOBasicOutputQueue::withTarget(
    OSObject *target, 
    IOOutputAction action, 
    UInt32 capacity ){}; 

/*free


Frees the IOBasicOutputQueue object. 

protected

virtual void free(); 
Discussion 

This function releases allocated resources, then call super::free().*/
 void IOBasicOutputQueue::free(){}; 

/*serviceThread


Provides an implementation for the serviceThread() method defined in IOOutputQueue. 

protected

virtual void serviceThread(
    void *param); 
Parameters
param
A parameter that was given to scheduleServiceThread(). This parameter is not used.
Discussion 

This method is called by the scheduled service thread when it starts to run. The service thread is scheduled by service() to restart a stalled queue when the kServiceAsync option is given.*/
void IOBasicOutputQueue::serviceThread(
    void *param){}; 

/*output


Transfers all packets in the mbuf queue to the target. 

protected

virtual void output(
    IOMbufQueue *queue,
    UInt32 *state); 
Parameters
queue
A queue of output packets.
state
Returns a state bit defined by IOBasicOutputQueue that declares the new state of the queue following this method call. A kStateStalled is returned if the queue should stall, otherwise 0 is returned.*/
 void IOBasicOutputQueue::output(
    IOMbufQueue *queue,
    UInt32 *state){}; 

/*getCapacity


Gets the number of packets that the queue can hold. 

public

virtual UInt32 getCapacity() const; 
Return Value

Returns the current queue capacity. 
Discussion 

The queue will begin to drop incoming packets when the size of the queue reaches its capacity.*/
 UInt32 IOBasicOutputQueue::getCapacity() const{}; 

/*getDropCount


Gets the number of packets dropped by the queue. 

public

virtual UInt32 getDropCount(); 
Return Value

Returns the number of packets dropped due to over-capacity, or by external calls to the flush() method.*/
UInt32 IOBasicOutputQueue:: getDropCount(){};

/*getOutputCount


Gets the number of packets accepted by the target. 

public

virtual UInt32 getOutputCount(); 
Return Value

Returns the number of times that kIOOutputStatusAccepted is returned by the target.*/
UInt32 IOBasicOutputQueue::getOutputCount(){}; 

/*getStatisticsData


Returns an IONetworkData object containing statistics counters updated by the queue. 

public

virtual IONetworkData * getStatisticsData() const; 
Return Value

Returns an IONetworkData object.*/
 IONetworkData * IOBasicOutputQueue::getStatisticsData() const{}; 


