#include <sys/kernel_types.h>
#include <IOKit/network/IOMbufMemoryCursor.h>

bool IOMbufMemoryCursor:: initWithSpecification(OutputSegmentFunc a, UInt32 b, UInt32 c, UInt32 d){};//?

/*withSpecification


Factory function that creates and initializes an IOMbufLittleMemoryCursor in one operation. 

public

static IOMbufLittleMemoryCursor * withSpecification(
    UInt32 maxSegmentSize, 
    UInt32 maxNumSegments); 
Parameters
maxSegmentSize
Maximum allowable size for one segment.
maxNumSegments
Maximum number of segments.
Return Value

Returns a new mbuf cursor if successfully created and initialized, 0 otherwise. 
Discussion 

See also IOMbufMemoryCursor::initWithSpecification.*/
 IOMbufLittleMemoryCursor *IOMbufLittleMemoryCursor:: withSpecification(
    UInt32 maxSegmentSize, 
    UInt32 maxNumSegments){};

/*getPhysicalSegmentsWithCoalesce


Generates a little endian physical scatter/gather list from a given mbuf. 

public

UInt32 getPhysicalSegmentsWithCoalesce(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments = 0); 
Parameters
packet
The mbuf packet.
vector
Pointer to an array of IOPhysicalSegments for the output physical scatter/gather list.
numVectorSegments
Maximum number of IOPhysicalSegments accepted.
Return Value

Returns the number of segments that were filled in, or 0 if an error occurred. 
Discussion 

Generate a little endian physical scatter/gather list from a given mbuf. Coalesce mbuf chain when the number of segments in the scatter/gather list exceeds numVectorSegments.*/
UInt32  IOMbufLittleMemoryCursor::getPhysicalSegmentsWithCoalesce(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments ){}; 

/*getPhysicalSegments


Generates a little endian physical scatter/gather list from a given mbuf. 

public

UInt32 getPhysicalSegments(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments = 0); 
Parameters
packet
The mbuf packet.
vector
Pointer to an array of IOPhysicalSegments for the output physical scatter/gather list.
numVectorSegments
Maximum number of IOPhysicalSegments accepted.
Return Value

Returns the number of segments that were filled in, or 0 if an error occurred.*/

UInt32 IOMbufLittleMemoryCursor::getPhysicalSegments(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments ){}; 

/*withSpecification


Factory function that creates and initializes an IOMbufBigMemoryCursor in one operation. 

public

static IOMbufBigMemoryCursor * withSpecification(
    UInt32 maxSegmentSize, 
    UInt32 maxNumSegments); 
Parameters
maxSegmentSize
Maximum allowable size for one segment.
maxNumSegments
Maximum number of segments.
Return Value

Returns a new mbuf cursor if successfully created and initialized, 0 otherwise. 
Discussion 

See also IOMbufMemoryCursor::initWithSpecification.*/
 IOMbufBigMemoryCursor * IOMbufBigMemoryCursor::withSpecification(
    UInt32 maxSegmentSize, 
    UInt32 maxNumSegments){};


/*getPhysicalSegments


Generates a big endian physical scatter/gather list from a given mbuf. 

public

UInt32 getPhysicalSegments(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments = 0); 
Parameters
packet
The mbuf packet.
vector
Pointer to an array of IOPhysicalSegments for the output physical scatter/gather list.
numVectorSegments
Maximum number of IOPhysicalSegments accepted.
Return Value

Returns the number of segments that were filled in, or 0 if an error occurred.*/
UInt32 IOMbufBigMemoryCursor:: getPhysicalSegments(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments ){};

/*initWithSpecification


Primary initializer for the IOMbufMemoryCursor class. 

public

virtual bool initWithSpecification(
    IOMemoryCursor::SegmentFunction outSeg, 
    UInt32 maxSegmentSize, 
    UInt32 maxNumSegments); 
Parameters
outSeg
Function to call to output one physical segment.
maxSegmentSize
Maximum allowable size for one segment.
maxNumSegments
Maximum number of segments.
Return Value

Returns true if the inherited classes and this instance initialized successfully.*/
bool IOMbufMemoryCursor::initWithSpecification(
    IOMemoryCursor::SegmentFunction outSeg, 
    UInt32 maxSegmentSize, 
    UInt32 maxNumSegments){}; 

/*genPhysicalSegments


Generates a physical scatter/gather list given a mbuf packet. 

public

virtual UInt32 genPhysicalSegments(
    mbuf_t packet,
    void *vector, 
    UInt32 maxSegs,
    bool doCoalesce); 
Parameters
packet
The mbuf packet.
vector
Void pointer to base of output physical scatter/gather list. Always passed directly onto the OutputSegmentFunc without interpretation by the cursor.
maxSegs
Maximum number of segments that can be written to segments array.
doCoalesce
Set to true to perform coalescing when the required number of segments exceeds the specified limit, otherwise abort and return 0.
Return Value

Returns the number of segments that were filled in, or 0 if an error occurred. 
Discussion 

Generates a list of physical segments from the given mbuf.*/
 UInt32 IOMbufMemoryCursor::genPhysicalSegments(
    mbuf_t packet,
    void *vector, 
    UInt32 maxSegs,
    bool doCoalesce){}; 

/*getAndResetCoalesceCount


Returns a count of the total number of mbuf chains coalesced by genPhysicalSegments(). 

public

UInt32 getAndResetCoalesceCount(); 
Return Value

Returns the coalesce count. 
Discussion 

This method returns a count of the total number of mbuf chains coalesced by genPhysicalSegments(). The counter is then reset to 0.*/
UInt32 IOMbufMemoryCursor::getAndResetCoalesceCount(){}; 

/*getPhysicalSegmentsWithCoalesce


Generates a big endian physical scatter/gather list from a given mbuf. 

public

UInt32 getPhysicalSegmentsWithCoalesce(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments = 0); 
Parameters
packet
The mbuf packet.
vector
Pointer to an array of IOPhysicalSegments for the output physical scatter/gather list.
numVectorSegments
Maximum number of IOPhysicalSegments accepted.
Return Value

Returns the number of segments that were filled in, or 0 if an error occurred. 
Discussion 

Generate a big endian physical scatter/gather list from a given mbuf. Coalesce mbuf chain when the number of segments in the scatter/gather list exceeds numVectorSegments.*/
UInt32 IOMbufBigMemoryCursor::getPhysicalSegmentsWithCoalesce(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments ){}; 

/*withSpecification


Factory function that creates and initializes an IOMbufNaturalMemoryCursor in one operation. 

public

static IOMbufNaturalMemoryCursor * withSpecification(
    UInt32 maxSegmentSize, 
    UInt32 maxNumSegments); 
Parameters
maxSegmentSize
Maximum allowable size for one segment.
maxNumSegments
Maximum number of segments.
Return Value

Returns a new mbuf cursor if successfully created and initialized, 0 otherwise. 
Discussion 

See also IOMbufMemoryCursor::initWithSpecification.*/
 IOMbufNaturalMemoryCursor * IOMbufNaturalMemoryCursor ::withSpecification(
    UInt32 maxSegmentSize, 
    UInt32 maxNumSegments){}; 

/*getPhysicalSegments


Generates a cpu natural physical scatter/gather list from a given mbuf. 

public

UInt32 getPhysicalSegments(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments = 0); 
Parameters
packet
The mbuf packet.
vector
Pointer to an array of IOPhysicalSegments for the output physical scatter/gather list.
numVectorSegments
Maximum number of IOPhysicalSegments accepted.
Return Value

Returns the number of segments that were filled in, or 0 if an error occurred.*/

UInt32 IOMbufNaturalMemoryCursor::getPhysicalSegments(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments ){}; 

/*getPhysicalSegmentsWithCoalesce


Generates a cpu natural physical scatter/gather list from a given mbuf. 

public

UInt32 getPhysicalSegmentsWithCoalesce(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments = 0); 
Parameters
packet
The mbuf packet.
vector
Pointer to an array of IOPhysicalSegments for the output physical scatter/gather list.
numVectorSegments
Maximum number of IOPhysicalSegments accepted.
Return Value

Returns the number of segments that were filled in, or 0 if an error occurred. 
Discussion 

Generate a cpu natural physical scatter/gather list from a given mbuf. Coalesce mbuf chain when the number of segments in the scatter/gather list exceeds numVectorSegments.*/
UInt32 IOMbufNaturalMemoryCursor::getPhysicalSegmentsWithCoalesce(
    mbuf_t packet, 
    struct IOMemoryCursor::PhysicalSegment *vector, 
    UInt32 numVectorSegments ){}; 

