#include <IOKit/network/IOOutputQueue.h>

void IOOutputQueue::runServiceThread(thread_call_param_t a, thread_call_param_t b){};//c

/*service


Services the queue. 

public

virtual bool service(
    IOOptionBits options = 0) = 0; 
Parameters
options
Options for the service request.
Return Value

Returns a return value to indicate the service result. 
Discussion 

Manage the queue after it has been started.*/
 bool  IOOutputQueue ::service(
    IOOptionBits options ){};
 

/*start


Starts up the queue. 

public

virtual bool start() = 0; 
Return Value

Returns true if the queue was started successfully, false otherwise. 
Discussion 

This method is called by the target to start the queue. This will allow packets to be removed from the queue, then delivered to the target.*/
 bool  IOOutputQueue::start() {};

/*stop


Stops the queue. 

public

virtual bool stop() = 0; 
Return Value

Returns the previous running state of the queue, true if the queue was running, false if the queue was already stopped. 
Discussion 

Stop the queue and prevent it from sending packets to its target.*/
 bool  IOOutputQueue::stop() {};

/*setCapacity


Changes the number of packets that the queue can hold before it begins to drop excess packets. 

public

virtual bool setCapacity(
    UInt32 capacity) = 0; 
Parameters
capacity
The new desired capacity.
Return Value

Returns true if the new capacity was accepted, false otherwise.*/
bool IOOutputQueue:: setCapacity(
    UInt32 capacity){};

/*flush


Drops and frees all packets currently held by the queue. 

public

virtual UInt32 flush() = 0; 
Return Value

Returns the number of packets that were dropped and freed.*/

 UInt32 IOOutputQueue:: flush() {};
 

/*getOutputHandler


Returns the address of a function that is designated to handle incoming packets sent to the queue object. 

public

virtual IOOutputAction getOutputHandler() const; 
Return Value*/
 IOOutputAction IOOutputQueue::getOutputHandler() const{}; 

/*getStatisticsData


Returns an IONetworkData object containing statistics counters updated by the queue. 

public

virtual IONetworkData * getStatisticsData() const; 
Return Value

Returns an IONetworkData object. This implementation will always return 0.*/

 IONetworkData * IOOutputQueue::getStatisticsData() const{}; 

/*init


Initializes an IOOutputQueue object. 

protected

virtual bool init(); 
Return Value

Returns true if initialized successfully, false otherwise.*/
 bool IOOutputQueue::init(){}; 

/*free


Frees the IOOutputQueue object. 

protected

virtual void free(); 
Discussion 

Release allocated resources, then call super::free().*/
 void IOOutputQueue:: free(){}; 

/*cancelServiceThread


Cancels any pending service thread callout. 

protected

virtual bool cancelServiceThread(); 
Return Value

Returns true if a previously scheduled thread callout was canceled, false otherwise.*/
 bool IOOutputQueue::cancelServiceThread(){}; 

/*scheduleServiceThread


Schedules a service thread callout. 

protected

virtual bool scheduleServiceThread(
    void *param); 
Parameters
param
A parameter to pass to the serviceThread() method.
Return Value

Returns true if a thread callout was scheduled, false otherwise. 
Discussion 

This method can be called by service() to schedule a thread that will call serviceThread() when it starts running.*/
 bool IOOutputQueue:: scheduleServiceThread(
    void *param){}; 

/*serviceThread


Method called by the scheduled service thread when it starts to run. 

protected

virtual void serviceThread(
    void *param); 
Parameters
param
A parameter that was given to scheduleServiceThread() when the service thread was scheduled.
Discussion 

Must be implemented by a subclass that calls scheduleServiceThread(). The default implementation does nothing.*/
 void IOOutputQueue::serviceThread(
    void *param){}; 

/*enqueue


Adds a packet, or a chain of packets, to the queue. 

public

virtual UInt32 enqueue(
    mbuf_t m,
    void *param) = 0; 
Parameters
m
A single packet, or a chain of packets.
param
A parameter provided by the caller.
Return Value

Returns a return code. 
Discussion 

This method is called by a client to add a packet, or a chain of packets, to the queue. A packet is described by an mbuf chain, while a chain of packets is constructed by linking multiple mbuf chains via the m_nextpkt field.*/
 UInt32  IOOutputQueue::enqueue(
    mbuf_t m,
    void *param) {}; 

