#include <IOKit/pccard/IOPCCard16Enabler.h>

bool		IOPCCard16Enabler::init(IOPCCard16Device * a){};//?
bool	IOPCCard16Enabler::	attach(IOPCCard16Device * a){};//?
bool	IOPCCard16Enabler::	detach(IOPCCard16Device * a){};//?
 void	IOPCCard16Enabler::	free(void){};//?

/*withDevice


Sets up a new enabler. 

public

static IOPCCard16Enabler * withDevice(
    IOPCCard16Device *provider); 
Return Value

Returns the address of the new enabler. 
Discussion 

This factory method creates and connects an enabler to a 16-bit PC Card provider nub.*/
IOPCCard16Enabler * IOPCCard16Enabler::withDevice(
    IOPCCard16Device *provider){}; 

/*unconfigure


Unconfigures a card. 

public

virtual bool unconfigure(); 
Return Value

Returns true if the card was successfully unconfigured. 
Discussion 

This method releases resources that were previously allocated back to Card Services.*/
 bool IOPCCard16Enabler::unconfigure(){};


/*eventHandler


Hook for Card Services events. 

public

virtual int eventHandler(
    cs_event_t event,
    int priority,
    event_callback_args_t *args); 
Return Value

A return value of non-zero prevents the event from being passed on to the socket drivers. 
Discussion 

This method allows the enabler to catch Card Services events prior to routing them to the attached driver(s). This may be helpful if you need to do addition work or clean up for certain events. The default enabler does nothing.*/
 int IOPCCard16Enabler:: eventHandler(
    cs_event_t event,
    int priority,
    event_callback_args_t *args){}; 

/*setPowerState


Hook for power management state changes. 

public

virtual IOReturn setPowerState(
    unsigned long,
    IOService *); 
Return Value

The return value is currently ignored. 
Discussion 

This method allows the enabler to catch power management events. This may be helpful if you need to do addition work or clean up for certain events. The default enabler uses this to track the state of power management.*/
 IOReturn IOPCCard16Enabler::setPowerState(
    unsigned long a,
    IOService *b){}; 


/*configure


Selects a 16-bit card configuration and enables it for use. 

public

virtual bool configure(
    UInt32 index=0); 
Parameters
index
Index of configuration to try. If no index is given then it is up to the enabler to decide.
Return Value

Returns true if the card configuration was successful. 
Discussion 

This method uses the indicated index from the 16-bit PC Card Configuration Table Entry Tuple, CISTPL_CFTABLE_ENTRY, to allocate resources and properly configure the card. If the index is not specified, the enabler will decide which configuration entries are to be tried.*/
 bool IOPCCard16Enabler:: configure(
    UInt32 index){}; 

/*getConfigurations


Adds configuration data from the card's CIS to the configTable array. 

public

virtual bool getConfigurations(
    void); 
Return Value

Returns true if any configurations were successfully found. 
Discussion 

This method fetches configuration data from the card's CIS and expands them out into a form that is easier to use.*/
 bool IOPCCard16Enabler::getConfigurations(
    void){};

 

/*tryConfiguration


Tests if a configuration can be used. 

public

virtual bool tryConfiguration(
    UInt32 index); 
Return Value

Returns true if any configurations were successfully found. 
Discussion 

This method is used to test if a configuration can be reserved from Card Services. If all resources are successfully reserved, the configuration is kept. The configure method enables the configuration later on. The built configuration is kept in the state variable, configuration.*/

 bool IOPCCard16Enabler::tryConfiguration(
    UInt32 index){}; 

/*sortConfigurations


Sorts configurations in the selection order. 

public

virtual bool sortConfigurations(
    void); 
Return Value

Returns true if any configurations were successfully found. 
Discussion 

This method sorts configurations into the order in which they should be tried. This method can also be used to eliminate configurations that might not be valid.*/
 bool IOPCCard16Enabler:: sortConfigurations(
    void){}; 

/*getState


Returns the current state of the card. 

public

virtual u_int getState(
    void); 
Return Value

Current state of card. 
Discussion 

This method returns the current state of the card enabler.*/
 u_int  IOPCCard16Enabler::getState(
    void){}

; 
/*getConfigurationInfo


Returns information on the card's current configuration. 

public

virtual bool getConfigurationInfo(
    config_info_t *config); 
Parameters
config
Pointer to config_info_t structure to be filled in.
Return Value

Returns true on success. 
Discussion 

This is a convenience method used to call the Card Services call GetConfigurationInfo.*/
 bool IOPCCard16Enabler::getConfigurationInfo(
    config_info_t *config){}; 

/*getWindowCount


Returns the number of windows that have been configured. 

public

virtual UInt32 getWindowCount(
    void); 
Return Value

Returns the number of windows. 
Discussion 

This method returns the number of windows that have been reserved in this configuration.*/
 UInt32 IOPCCard16Enabler::getWindowCount(
    void){}; 

/*getWindowType


Returns the window type. 

public

virtual UInt32 getWindowType(
    UInt32 index); 
Parameters
index
Index of window.
Return Value

Returns IOPCCARD16_MEMORY_WINDOW, IOPCCARD16_IO_WINDOW or IOPCCARD16_BAD_INDEX. 
Discussion 

This method is used to find the type of window given its index. There are two types of windows, I/O and memory. If they are available in a specific configuration, memory windows will always come first in the list of windows.*/
UInt32 IOPCCard16Enabler::getWindowType(
    UInt32 index){}; 


/*getWindowSize


Returns the size of this window. 

public

virtual UInt32 getWindowSize(
    UInt32 index); 
Parameters
index
Index of window.
Return Value

Returns the size of the window in bytes. 
Discussion 

This method returns the size of the window in bytes.*/
 UInt32 IOPCCard16Enabler::getWindowSize(
    UInt32 index){}; 

/*getWindowAttributes


Returns the attributes of this window. 

public

virtual bool getWindowAttributes(
    UInt32 index,
    UInt32 *attributes); 
Parameters
index
Index of window.
attributes
Pointer to the attribute flags to be filled in.
Return Value

Returns attributes for the window. 
Discussion 

This method returns the attributes for the specified window. The meaning of the attributes flags varies depending on the type of window. The most useful attributes are the data access width flags for I/O windows. For definitions of these flags for both types of windows see "IOKit/pccard/cs.h".*/
 bool IOPCCard16Enabler::getWindowAttributes(
    UInt32 index,
    UInt32 *attributes){}; 

/*getWindowHandle


Returns the Card Services handle for this window. 

public

virtual bool getWindowHandle(
    UInt32 index,
    window_handle_t *handle); 
Parameters
index
Index to window.
handle
Pointer to the window_handle_t structure to be filled in.
Return Value

Returns true if the window handle was found. 
Discussion 

This method returns the Card Services handle for the window requested. This call is only valid for memory windows.*/
bool IOPCCard16Enabler::getWindowHandle(
    UInt32 index,
    window_handle_t *handle){}; 


/*getWindowOffset


Returns the offset that this window is currently at. 

public

virtual bool getWindowOffset(
    UInt32 index,
    UInt32 *offset); 
Parameters
index
Index of window.
offset
The current offset for this window.
Return Value

Returns true if the returned window offset is valid. 
Discussion 

This method returns the current offset for this window into the card's memory space. This call is only valid for memory windows.*/
 bool IOPCCard16Enabler::getWindowOffset(
    UInt32 index,
    UInt32 *offset){}; 

/*setWindowOffset


Sets the offset for this window. 

public

virtual bool setWindowOffset(
    UInt32 index,
    UInt32 newOffset); 
Parameters
index
Index of window.
offset
The new offset for this window.
Return Value

Returns true if the window offset was successfully updated. 
Discussion 

This method updates the offset into the card's memory space for this window. This call is only valid for memory windows.*/
bool IOPCCard16Enabler::setWindowOffset(
    UInt32 index,
    UInt32 newOffset){};
