#include <IOKit/storage/IOBlockStorageDevice.h>

OSObject *IOBlockStorageDevice::	getProperty(const OSSymbol * a) const{};//?
 IOReturn	IOBlockStorageDevice::setProperties(OSObject * a){};//?

IOReturn	IOBlockStorageDevice::doSyncReadWrite(IOMemoryDescriptor *a, UInt32 b, UInt32 c){};//?

IOReturn	IOBlockStorageDevice::doAsyncReadWrite(IOMemoryDescriptor *a, UInt64 b, UInt64 c, IOStorageAttributes *d,  IOStorageCompletion *e){};//?

////////////////

///////////////////
/*doAsyncReadWrite(IOMemoryDescriptor *, UInt64, UInt64, IOStorageCompletion)


Starts an asynchronous read or write operation. 

public

virtual IOReturn doAsyncReadWrite(
    IOMemoryDescriptor *buffer, 
    UInt64 block,
    UInt64 nblks, 
    IOStorageCompletion completion); 
Parameters
buffer
An IOMemoryDescriptor describing the data-transfer buffer. The data direction is contained in the IOMemoryDescriptor. Responsibility for releasing the descriptor rests with the caller.
block
The starting block number of the data transfer.
nblks
The integral number of blocks to be transferred.
completion
The completion routine to call once the data transfer is complete.*/
IOReturn IOBlockStorageDevice::doAsyncReadWrite(
    IOMemoryDescriptor *buffer, 
    UInt64 block,
    UInt64 nblks, 
    IOStorageCompletion completion){}; 


/*doAsyncReadWrite(IOMemoryDescriptor *, UInt32, UInt32, IOStorageCompletion)


Starts an asynchronous read or write operation. 

public

virtual IOReturn doAsyncReadWrite(
    IOMemoryDescriptor *buffer, 
    UInt32 block,
    UInt32 nblks, 
    IOStorageCompletion completion) = 0; 
Parameters
buffer
An IOMemoryDescriptor describing the data-transfer buffer. The data direction is contained in the IOMemoryDescriptor. Responsibility for releasing the descriptor rests with the caller.
block
The starting block number of the data transfer.
nblks
The integral number of blocks to be transferred.
completion
The completion routine to call once the data transfer is complete.*/
IOReturn IOBlockStorageDevice:: doAsyncReadWrite(
    IOMemoryDescriptor *buffer, 
    UInt32 block,
    UInt32 nblks, 
    IOStorageCompletion completion) {}; 

/*getVendorString


Returns Vendor Name string for the device. 

public

virtual char * getVendorString(
    void) = 0; 
Return Value

A pointer to a static character string.*/
 char * IOBlockStorageDevice::getVendorString(
    void){}; 


/*getProductString


Returns Product Name string for the device. 

public

virtual char * getProductString(
    void) = 0; 
Return Value

A pointer to a static character string.*/
 char * IOBlockStorageDevice::getProductString(
    void) {}; 


/*reportMediaState


Reports the device's media state. 

public

virtual IOReturn reportMediaState(
    bool *mediaPresent,
    bool *changedState) = 0; 
Parameters
mediaPresent
Pointer to returned media state. True indicates media is present in the device; False indicates no media is present.
changedState
Pointer to returned result. True indicates a change of state since prior calls, False indicates that the state has not changed.
Discussion 

This method reports whether we have media in the drive or not, and whether the state has changed from the previously reported state.
A result of kIOReturnSuccess is always returned if the test for media is successful, regardless of media presence. The mediaPresent result should be used to determine whether media is present or not. A return other than kIOReturnSuccess indicates that the Transport Driver was unable to interrogate the device. In this error case, the outputs mediaPresent and changedState will *not* be stored.*/
 IOReturn IOBlockStorageDevice:: reportMediaState(
    bool *mediaPresent,
    bool *changedState) {}; 


/*doEjectMedia


Ejects the media. 

public

virtual IOReturn doEjectMedia(
    void) = 0; */
 IOReturn  IOBlockStorageDevice::doEjectMedia(
    void) {};

/*doFormatMedia


Formats the media to the specified byte capacity. 

public

virtual IOReturn doFormatMedia(
    UInt64 byteCapacity) = 0; 
Parameters
byteCapacity
The byte capacity to which the device is to be formatted, if possible.
Discussion 

The specified byte capacity must be one supported by the device. Supported capacities can be obtained by calling doGetFormatCapacities.*/
 IOReturn IOBlockStorageDevice::doFormatMedia(
    UInt64 byteCapacity) {}; 

/*doGetFormatCapacities


Returns the allowable formatting byte capacities. 

public

virtual UInt32 doGetFormatCapacities(
    UInt64 *capacities, 
    UInt32 capacitiesMaxCount) const = 0; 
Parameters
capacities
Pointer for returning the list of capacities.
capacitiesMaxCount
The number of capacity values returned in "capacities," or if no buffer is given, the total number of capacity values available.
Discussion 

This function returns the supported byte capacities for the device.*/
UInt32 IOBlockStorageDevice:: doGetFormatCapacities(
    UInt64 *capacities, 
    UInt32 capacitiesMaxCount) const {}; 

/*reportRemovability


Reports whether the media is removable or not. 

public

virtual IOReturn reportRemovability(
    bool *isRemovable) = 0; 
Parameters
isRemovable
Pointer to returned result. True indicates that the media is removable; False indicates the media is not removable.
Discussion 

This method reports whether the media is removable, but it does not provide detailed information regarding software eject or lock/unlock capability.*/
 IOReturn IOBlockStorageDevice:: reportRemovability(
    bool *isRemovable) {}; 

/*reportPollRequirements


Reports if it's necessary to poll for media insertion, and if polling is expensive. 

public

virtual IOReturn reportPollRequirements(
    bool *pollRequired, 
    bool *pollIsExpensive) = 0; 
Parameters
pollRequired
Pointer to returned result. True indicates that polling is required; False indicates that polling is not required to detect media.
pollIsExpensive
Pointer to returned result. True indicates that the polling operation is expensive; False indicates that the polling operation is cheap.
Discussion 

This method reports whether the device must be polled to detect media insertion, and whether a poll is expensive to perform.
The term "expensive" typically implies a device that must be spun-up to detect media, as on a PC floppy. Most devices can detect media inexpensively.*/
IOReturn IOBlockStorageDevice::reportPollRequirements(
    bool *pollRequired, 
    bool *pollIsExpensive) {}; 


/*reportEjectability


Reports if the media is ejectable under software control. 

public

virtual IOReturn reportEjectability(
    bool *isEjectable) = 0; 
Parameters
isEjectable
Pointer to returned result. True indicates the media is ejectable, False indicates the media cannot be ejected under software control.
Discussion 

This method should only be called if the media is known to be removable.*/
 IOReturn IOBlockStorageDevice::reportEjectability(
    bool *isEjectable) {}; 

/*reportLockability


Reports if the media is lockable under software control. 

public

virtual IOReturn reportLockability(
    bool *isLockable) = 0; 
Parameters
isLockable
Pointer to returned result. True indicates the media can be locked in place; False indicates the media cannot be locked by software.
Discussion 

This method should only be called if the media is known to be removable.*/
 IOReturn IOBlockStorageDevice::reportLockability(
    bool *isLockable) {}; 

/*reportMaxReadTransfer


Reports the maximum allowed byte transfer for read operations. 

public

virtual IOReturn reportMaxReadTransfer (
    UInt64 blockSize,
    UInt64 *max) = 0; 
Parameters
blockSize
The block size desired for the transfer.
max
Pointer to returned result.
Discussion 

Some devices impose a maximum data transfer size. Because this limit may be determined by the size of a block-count field in a command, the limit may depend on the block size of the transfer.*/
 IOReturn IOBlockStorageDevice::reportMaxReadTransfer (
    UInt64 blockSize,
    UInt64 *max) {}; 

/*reportMaxWriteTransfer


Reports the maximum allowed byte transfer for write operations. 

public

virtual IOReturn reportMaxWriteTransfer(
    UInt64 blockSize,
    UInt64 *max) = 0; 
Parameters
blockSize
The block size desired for the transfer.
max
Pointer to returned result.
Discussion 

Some devices impose a maximum data transfer size. Because this limit may be determined by the size of a block-count field in a command, the limit may depend on the block size of the transfer.*/
IOReturn IOBlockStorageDevice::reportMaxWriteTransfer(
    UInt64 blockSize,
    UInt64 *max) {}; 

/*doLockUnlockMedia


Locks or unlock the (removable) media in the drive. 

public

virtual IOReturn doLockUnlockMedia(
    bool doLock) = 0; 
Parameters
doLock
True to lock the media, False to unlock.
Discussion 

This method should only be called if the media is known to be removable.*/
 IOReturn  IOBlockStorageDevice::doLockUnlockMedia(
    bool doLock) {}; 

/*reportBlockSize


Reports the block size for the device, in bytes. 

public

virtual IOReturn reportBlockSize(
    UInt64 *blockSize) = 0; 
Parameters
blockSize
Pointer to returned block size value.*/
 IOReturn IOBlockStorageDevice:: reportBlockSize(
    UInt64 *blockSize) {}; 

/*reportMaxValidBlock


Reports the highest valid block for the device. 

public

virtual IOReturn reportMaxValidBlock(
    UInt64 *maxBlock) = 0; 
Parameters
maxBlock
Pointer to returned result*/
 IOReturn IOBlockStorageDevice::reportMaxValidBlock(
    UInt64 *maxBlock) {}; 


/*reportWriteProtection


Reports whether the media is write-protected or not. 

public

virtual IOReturn reportWriteProtection(
    bool *isWriteProtected) = 0; 
Parameters
isWriteProtected
Pointer to returned result. True indicates that the media is write-protected (it cannot be written); False indicates that the media is not write-protected (it is permissible to write).*/
 IOReturn IOBlockStorageDevice:: reportWriteProtection(
    bool *isWriteProtected) {}; 

/*doSynchronizeCache


Forces data blocks in the hardware's buffer to be flushed to the media. 

public

virtual IOReturn doSynchronizeCache(
    void) = 0; 
Discussion 

This method should only be called if the media is writable.*/
 IOReturn  IOBlockStorageDevice::doSynchronizeCache(
    void) {}; 

/*init


Allows IOBlockStorageDevice to set a property (not usually overridden by developers). 

public

virtual bool init(
    OSDictionary *properties); 
Discussion 

This function is overridden so that IOBlockStorageDevice can set a property, used by IOBlockStorageDriver for matching. Since the concrete subclass of IOBlockStorageDevice can be of any class type, the property is used for matching.
This function is usually not overridden by developers.*/
 bool IOBlockStorageDevice::init(
    OSDictionary *properties){}; 

/*getWriteCacheState


Reports the current write cache state of the device. 

public

virtual IOReturn getWriteCacheState(
    bool *enabled); 
Parameters
enabled
Pointer to returned result. True indicates the write cache is enabled; False indicates the write cache is disabled.
Discussion 

Reports the current write cache state of the device. The write cache state is not guaranteed to persist across reboots and detaches.*/
 IOReturn IOBlockStorageDevice::getWriteCacheState(
    bool *enabled){};
 
/*setWriteCacheState


Sets the write cache state of the device. 

public

virtual IOReturn setWriteCacheState(
    bool enabled); 
Parameters
enabled
True to enable the write cache; False to disable the write cache.
Discussion 

Sets the write cache state of the device. The write cache state is not guaranteed to persist across reboots and detaches.*/
 IOReturn IOBlockStorageDevice::setWriteCacheState(
    bool enabled){};
 
