#include <stdio.h>
#include <IOKit/storage/IOMedia.h>

void IOMedia::detachFromChild(IORegistryEntry *       client, const IORegistryPlane * plane){};//c
bool IOMedia:: attachToChild(IORegistryEntry *       client,const IORegistryPlane * plane){};//c
IOStorage *  IOMedia::getProvider() const{};//c
 bool IOMedia:: matchPropertyTable(OSDictionary * table, SInt32 * score){};//c
void IOMedia::free(){};//c

bool IOMedia::init(UInt64         base, UInt64         size, UInt64         preferredBlockSize, bool           isEjectable,bool           isWhole,bool           isWritable, const char *   contentHint ,OSDictionary * properties  ) {};//c
///////////////////


/////////////////

/*getSize

public

virtual UInt64 getSize() const; 
Return Value

Media size, in bytes. 
Discussion 

Ask the media object for its total length in bytes.*/
UInt64 IOMedia::getSize() const{
printf ("getSize");
};

/*isEjectable

public

virtual bool isEjectable() const; 
Return Value

Returns true if the media is ejectable, false otherwise. 
Discussion 

Ask the media object whether it is ejectable.*/
bool IOMedia::isEjectable() const{
printf ("isEjectable");
}; 

/*isWritable

public

virtual bool isWritable() const; 
Return Value

Returns true if the media is writable, false otherwise. 
Discussion 

Ask the media object whether it is writable.*/
 bool IOMedia:: isWritable() const{
printf ("isWritable");
}; 

/*write

public

virtual void write(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    IOStorageCompletion completion); 
Parameters
client
Client requesting the write.
byteStart
Starting byte offset for the data transfer.
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
completion
Completion routine to call once the data transfer is complete.
Discussion 

Write data into the storage object at the specified byte offset from the specified buffer, asynchronously. When the write completes, the caller will be notified via the specified completion action.
The buffer will be retained for the duration of the write.*/

void IOMedia::write(IOService *           client,
                       UInt64                byteStart,
                       IOMemoryDescriptor *  buffer,
                       IOStorageAttributes * attributes,
                       IOStorageCompletion * completion){};

/*read

public

virtual void read(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    IOStorageCompletion completion); 
Parameters
client
Client requesting the read.
byteStart
Starting byte offset for the data transfer.
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
completion
Completion routine to call once the data transfer is complete.
Discussion 

Read data from the storage object at the specified byte offset into the specified buffer, asynchronously. When the read completes, the caller will be notified via the specified completion action.
The buffer will be retained for the duration of the read.*/
 void IOMedia:: read(IOService *           client,
                      UInt64                byteStart,
                      IOMemoryDescriptor *  buffer,
                      IOStorageAttributes * attributes,
                      IOStorageCompletion * completion){};

/*synchronizeCache

public

virtual IOReturn synchronizeCache(
    IOService *client); 
Parameters
client
Client requesting the cache synchronization.
Return Value

Returns the status of the cache synchronization. 
Discussion 

Flush the cached data in the storage object, if any, synchronously.*/
IOReturn IOMedia:: synchronizeCache(
    IOService *client){
printf ("synchronizeCache",*client);
}; 

/*getPreferredBlockSize

public

virtual UInt64 getPreferredBlockSize() const; 
Return Value

Natural block size, in bytes. 
Discussion 

Ask the media object for its natural block size. This information is useful to clients that want to optimize access to the media.*/
 UInt64 IOMedia::getPreferredBlockSize() const{
printf ("getPreferredBlockSize");
}; 

/*init

public

virtual bool init(
    UInt64 base, 
    UInt64 size, 
    UInt64 preferredBlockSize, 
    IOMediaAttributeMask attributes, 
    bool isWhole, 
    bool isWritable, 
    const char *contentHint = 0, 
    OSDictionary *properties = 0); 
Parameters
base
Media offset, in bytes.
size
Media size, in bytes.
preferredBlockSize
Natural block size, in bytes.
attributes
Media attributes, such as ejectability and removability. See IOMediaAttributeMask.
isWhole
Indicates whether the media represents the whole disk.
isWritable
Indicates whether the media is writable.
contentHint
Hint of media's contents (optional). See getContentHint().
properties
Substitute property table for this object (optional).
Return Value

Returns true on success, false otherwise. 
Discussion 

Initialize this object's minimal state.*/

   bool IOMedia::init(UInt64               base,
                      UInt64               size,
                      UInt64               preferredBlockSize,
                      IOMediaAttributeMask attributes,
                      bool                 isWhole,
                      bool                 isWritable,
                      const char *         contentHint ,
                      OSDictionary *       properties  ){};

/*isFormatted


public

virtual bool isFormatted() const; 
Return Value

Returns true if the media is formatted, false otherwise. 
Discussion 

Ask the media object whether it is formatted.*/

 bool IOMedia::isFormatted() const{};

/*getContentHint


public

virtual const char * getContentHint() const; 
Return Value

Hint of media's contents. 
Discussion 

Ask the media object for a hint of its contents. The hint is set at the time of the object's creation, should the creator have a clue as to what it may contain. The hint string does not change for the lifetime of the object and is also formed in the likeness of Apple's "Apple_HFS" strings or in the likeness of a UUID.*/
 const char * IOMedia::getContentHint() const{}; 

/*handleOpen


protected

virtual bool handleOpen(
    IOService *client, 
    IOOptionBits options, 
    void *access); 
Parameters
client
Client requesting the open.
options
Options for the open. Set to zero.
access
Access level for the open. Set to kIOStorageAccessReader or kIOStorageAccessReaderWriter.
Return Value

Returns true if the open was successful, false otherwise. 
Discussion 

The handleOpen method grants or denies permission to access this object to an interested client. The argument is an IOStorageAccess value that specifies the level of access desired -- reader or reader-writer.
This method can be invoked to upgrade or downgrade the access level for an existing client as well. The previous access level will prevail for upgrades that fail, of course. A downgrade should never fail. If the new access level should be the same as the old for a given client, this method will do nothing and return success. In all cases, one, singular close-per-client is expected for all opens-per-client received.
This implementation replaces the IOService definition of handleOpen().*/
 bool IOMedia:: handleOpen(
    IOService *client, 
    IOOptionBits options, 
    void *access){}; 

/*getAttributes


public

virtual IOMediaAttributeMask getAttributes() const; 
Return Value

Media attributes, such as ejectability and removability. See IOMediaAttributeMask. 
Discussion 

Ask the media object for its attributes.*/
IOMediaAttributeMask  IOMedia::getAttributes() const{}; 

/*isWhole


public

virtual bool isWhole() const; 
Return Value

Returns true if the media represents the whole disk, false otherwise. 
Discussion 

Ask the media object whether it represents the whole disk.*/
 bool IOMedia::isWhole() const{}; 


/*getBase


public

virtual UInt64 getBase() const; 
Discussion 

Ask the media object for its byte offset relative to its provider media object below it in the storage hierarchy. Media offset, in bytes.*/

 UInt64 IOMedia:: getBase() const{}; 

/*handleIsOpen


protected

virtual bool handleIsOpen(
    const IOService *client) const; 
Parameters
client
Client to check the open state of. Set to zero to check the open state of all clients.
Return Value

Returns true if the client was (or clients were) open, false otherwise. 
Discussion 

The handleIsOpen method determines whether the specified client, or any client if none is specified, presently has an open on this object.
This implementation replaces the IOService definition of handleIsOpen().*/
 bool IOMedia::handleIsOpen(
    const IOService *client) const{}; 

/*handleClose


protected

virtual void handleClose(
    IOService *client,
    IOOptionBits options); 
Parameters
client
Client requesting the close.
options
Options for the close. Set to zero.
Discussion 

The handleClose method closes the client's access to this object.
This implementation replaces the IOService definition of handleClose().*/
 void  IOMedia::handleClose(
    IOService *client,
    IOOptionBits options){}; 

/*getContent


public

virtual const char * getContent() const; 
Return Value

Description of media's contents. 
Discussion 

Ask the media object for a description of its contents. The description is the same as the hint at the time of the object's creation, but it is possible that the description has been overridden by a client (which has probed the media and identified the content correctly) of the media object. It is more accurate than the hint for this reason. The string is formed in the likeness of Apple's "Apple_HFS" strings or in the likeness of a UUID.
The content description can be overridden by any client that matches onto this media object with a match category of kIOStorageCategory. The media object checks for a kIOMediaContentMaskKey property in the client, and if it finds one, it copies it into kIOMediaContentKey property.*/
 const char *IOMedia:: getContent() const{}; 
