#include <stdio.h>
#include <IOKit/storage/IOStorage.h>

 void IOStorage::read(IOService *          client, UInt64               byteStart, IOMemoryDescriptor * buffer, IOStorageCompletion  completion){}; //c

void IOStorage::write(IOService *          client, UInt64               byteStart, IOMemoryDescriptor * buffer,IOStorageCompletion  completion){};//c

void IOStorage::complete(IOStorageCompletion completion, IOReturn            status, UInt64              actualByteCount){};//c

bool IOStorage::init(OSDictionary * properties ){};//c

///////////////////
/*open

public

virtual bool open(
    IOService *client, 
    IOOptionBits options, 
    IOStorageAccess access); 
Parameters
client
Client requesting the open.
options
Options for the open. Set to zero.
access
Access level for the open. Set to kIOStorageAccessReader or kIOStorageAccessReaderWriter.
Return Value

Returns true if the open was successful, false otherwise. 
Discussion 

Ask the storage object for permission to access its contents; the method is equivalent to IOService::open(), but with the correct parameter types.
This method may also be invoked to upgrade or downgrade the access of an existing open (if it fails, the existing open prevails).*/ 
bool IOStorage::open(
    IOService *client, 
    IOOptionBits options, 
    IOStorageAccess access){
printf ("open",*client,options,access);
};


/*read(IOService *, UInt64, IOMemoryDescriptor *, IOStorageAttributes *, IOStorageCompletion *)


public

virtual void read(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    IOStorageAttributes *attributes, 
    IOStorageCompletion *completion); 
Parameters
client
Client requesting the read.
byteStart
Starting byte offset for the data transfer.
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
attributes
Attributes of the data transfer. See IOStorageAttributes. It is the responsibility of the callee to maintain the information for the duration of the data transfer, as necessary.
completion
Completion routine to call once the data transfer is complete. It is the responsibility of the callee to maintain the information for the duration of the data transfer, as necessary.
Discussion 

Read data from the storage object at the specified byte offset into the specified buffer, asynchronously. When the read completes, the caller will be notified via the specified completion action.
The buffer will be retained for the duration of the read.*/

 void  IOStorage::read(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    IOStorageAttributes *attributes, 
    IOStorageCompletion *completion){};


/*read(IOService *, UInt64, IOMemoryDescriptor *, UInt64 *)


public

virtual IOReturn read(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    UInt64 *actualByteCount = 0); 
Parameters
client
Client requesting the read.
byteStart
Starting byte offset for the data transfer.
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
actualByteCount
Returns the actual number of bytes transferred in the data transfer.
Return Value

Returns the status of the data transfer. 
Discussion 

Read data from the storage object at the specified byte offset into the specified buffer, synchronously. When the read completes, this method will return to the caller. The actual byte count field is optional.*/
 IOReturn IOStorage::read(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    UInt64 *actualByteCount ){};


/*write(IOService *, UInt64, IOMemoryDescriptor *, UInt64 *)


public

virtual IOReturn write(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    UInt64 *actualByteCount = 0); 
Parameters
client
Client requesting the write.
byteStart
Starting byte offset for the data transfer.
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
actualByteCount
Returns the actual number of bytes transferred in the data transfer.
Return Value

Returns the status of the data transfer. 
Discussion 

Write data into the storage object at the specified byte offset from the specified buffer, synchronously. When the write completes, this method will return to the caller. The actual byte count field is optional.*/
 IOReturn IOStorage:: write(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    UInt64 *actualByteCount ){};

/*write(IOService *, UInt64, IOMemoryDescriptor *, IOStorageAttributes *, IOStorageCompletion *)


public

virtual void write(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    IOStorageAttributes *attributes, 
    IOStorageCompletion *completion); 
Parameters
client
Client requesting the write.
byteStart
Starting byte offset for the data transfer.
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
attributes
Attributes of the data transfer. See IOStorageAttributes. It is the responsibility of the callee to maintain the information for the duration of the data transfer, as necessary.
completion
Completion routine to call once the data transfer is complete. It is the responsibility of the callee to maintain the information for the duration of the data transfer, as necessary.
Discussion 

Write data into the storage object at the specified byte offset from the specified buffer, asynchronously. When the write completes, the caller will be notified via the specified completion action.
The buffer will be retained for the duration of the write. */
 void IOStorage::write(
    IOService *client, 
    UInt64 byteStart, 
    IOMemoryDescriptor *buffer, 
    IOStorageAttributes *attributes, 
    IOStorageCompletion *completion){};


/*complete


public

static void complete(
    IOStorageCompletion *completion, 
    IOReturn status, 
    UInt64 actualByteCount = 0); 
Parameters
completion
Completion information for the data transfer.
status
Status of the data transfer.
actualByteCount
Actual number of bytes transferred in the data transfer.
Discussion 

Invokes the specified completion action of the read/write request. If the completion action is unspecified, no action is taken. This method serves simply as a convenience to storage subclass developers.*/
void IOStorage::complete(
    IOStorageCompletion *completion, 
    IOReturn status, 
    UInt64 actualByteCount ){};


/*synchronizeCache


public

virtual IOReturn synchronizeCache(
    IOService *client) = 0; 
Parameters
client
Client requesting the cache synchronization.
Return Value

Returns the status of the cache synchronization. 
Discussion 

Flush the cached data in the storage object, if any, synchronously.*/
IOReturn IOStorage::synchronizeCache(
    IOService *client) {};
