#include <stdio.h>
#include <Security/SecCertificate.h>

/*SecCertificateGetData

Retrieves the data for a certificate.

OSStatus SecCertificateGetData (
   SecCertificateRef certificate,
   CSSM_DATA_PTR data
);
Parameters
certificate

A certificate object for the certificate from which to retrieve the data.
data

On return, points to the data for the certificate specified. You must allocate the space for a CSSM_DATA structure before calling this function. This data pointer is only guaranteed to remain valid as long as the certificate remains unchanged and valid.
Return Value

A result code. See “Certificate, Key, and Trust Services Result Codes”.
Discussion

This function requires a certificate object, which can, for example, be created with the SecCertificateCreateFromData function, obtained from an identity with the SecIdentityCopyCertificate function, or obtained over a network (see Secure Transport Reference).
Availability
Available in Mac OS X v10.2 and later.
Declared In
SecCertificate.h*/
OSStatus SecCertificateGetData (
   SecCertificateRef certificate,
   CSSM_DATA_PTR data
){
printf ("SecCertificateGetData",certificate,data);
};

/*SecCertificateCreateFromData

Creates a certificate object based on the specified data, type, and encoding.

OSStatus SecCertificateCreateFromData (
   const CSSM_DATA *data,
   CSSM_CERT_TYPE type,
   CSSM_CERT_ENCODING encoding,
   SecCertificateRef *certificate
);
Parameters
data

A pointer to the certificate data. The data must be an X509 certificate in binary format.
type

The certificate type as defined in Security.framework/cssmtype.h. Permissible values are CSSM_CERT_X_509v1, CSSM_CERT_X_509v2, and CSSM_CERT_X_509v3. If you are unsure of the certificate type, use CSSM_CERT_X_509v3. 
encoding

The certificate encoding as defined in Security.framework/cssmtype.h. Permissible values are CSSM_CERT_ENCODING_BER and CSSM_CERT_ENCODING_DER. If you are unsure of the encoding, use CSSM_CERT_ENCODING_BER.
certificate

On return, points to the newly created certificate object. Call the CFRelease function to release this object when you are finished with it. 
Return Value

A result code. See “Certificate, Key, and Trust Services Result Codes.”
Discussion

The certificate object returned by this function is used as input to several other functions in the API.
Availability
Available in Mac OS X v10.2 and later.
Declared In
SecCertificate.h*/
OSStatus SecCertificateCreateFromData (
   const CSSM_DATA *data,
   CSSM_CERT_TYPE type,
   CSSM_CERT_ENCODING encoding,
   SecCertificateRef *certificate
){};
/*SecCertificateCopyCommonName

Retrieves the common name of the subject of a certificate.

OSStatus SecCertificateCopyCommonName(
   SecCertificateRef certificate,
   CFStringRef *commonName
);
Parameters
certificate

The certificate object from which to retrieve the common name.
commonName

On return, points to the common name. Call the CFRelease function to release this object when you are finished with it.
Return Value

A result code. See “Certificate, Key, and Trust Services Result Codes.”
Availability
Available in Mac OS X v10.5 and later.
Declared In
SecCertificate.h*/
OSStatus SecCertificateCopyCommonName(
   SecCertificateRef certificate,
   CFStringRef *commonName
){};

