#include <SystemConfiguration/SCDynamicStoreCopyDHCPInfo.h>


/*SCDynamicStoreCopyDHCPInfo


CFDictionaryRef SCDynamicStoreCopyDHCPInfo(
    SCDynamicStoreRef store,
    CFStringRef serviceID);  
Parameters
store
An SCDynamicStoreRef representing the dynamic store session that should be used for communication with the server. If NULL, a temporary session will be used.
serviceID
A CFStringRef containing the requested service. If NULL, returns information for the primary service.
Return Value

Returns a dictionary containing DHCP information if successful; NULL otherwise. Use the DHCPInfoGetOption function to retrieve individual options from the returned dictionary. 

A non-NULL return value must be released using CFRelease(). 
Discussion 

Copies the DHCP information for the requested serviceID, or the primary service if serviceID == NULL.*/
CFDictionaryRef SCDynamicStoreCopyDHCPInfo(
    SCDynamicStoreRef store,
    CFStringRef serviceID){};  

/*DHCPInfoGetOptionData


CFDataRef DHCPInfoGetOptionData(
    CFDictionaryRef info,
    UInt8 code);  
Parameters
info
The non-NULL DHCP information dictionary returned by calling SCDynamicStoreCopyDHCPInfo.
code
The DHCP option code (see RFC 2132) to return data for.
Return Value

Returns a non-NULL CFDataRef containing the option data; NULL if the requested option data is not present. 

The return value must NOT be released. 
Discussion 

Returns a non-NULL CFDataRef containing the DHCP option data, if present.*/
CFDataRef DHCPInfoGetOptionData(
    CFDictionaryRef info,
    UInt8 code){};  
