#include <SystemConfiguration/SCNetwork.h>

/*SCNetworkCheckReachabilityByAddress


Boolean SCNetworkCheckReachabilityByAddress ( 
    const struct sockaddr *address, 
    socklen_t addrlen, 
    SCNetworkConnectionFlags *flags );  
Parameters
address
The network address of the desired host.
addrlen
The length, in bytes, of the address.
flags
A pointer to memory that will be filled with a set of SCNetworkConnectionFlags detailing the reachability of the specified address.
Return Value

Returns TRUE if the network connection flags are valid; FALSE if the status could not be determined. 
Discussion 

Determines if the given network address is reachable using the current network configuration.*/

Boolean SCNetworkCheckReachabilityByAddress ( 
    const struct sockaddr *address, 
    socklen_t addrlen, 
    SCNetworkConnectionFlags *flags ){};  

/*SCNetworkCheckReachabilityByName


Boolean SCNetworkCheckReachabilityByName ( 
    const char *nodename, 
    SCNetworkConnectionFlags *flags );  
Parameters
nodename
The node name of the desired host. This name would be the same as that passed to the gethostbyname(3) or getaddrinfo(3) functions.
flags
A pointer to memory that will be filled with a set of SCNetworkConnectionFlags detailing the reachability of the specified node name.
Return Value

Returns TRUE if the network connection flags are valid; FALSE if the status could not be determined. 
Discussion 

Determines if the given network host or node name is reachable using the current network configuration.*/

Boolean SCNetworkCheckReachabilityByName ( 
    const char *nodename, 
    SCNetworkConnectionFlags *flags ){};  


