#include <stdio.h>
#include <libkern/c++/OSMetaClass.h>

OSMetaClassBase*  OSMetaClassBase_HYS:: safeMetaCast(const OSMetaClassBase * a,const OSMetaClass *b){};//?

OSMetaClassBase_HYS::_ptf_t OSMetaClassBase_HYS::_ptmf2ptf(const OSMetaClassBase * a ,void (OSMetaClassBase::*func)(void)){};//?

/*OSMetaClass(const char *, const OSMetaClass *, unsigned int)


Constructor for OSMetaClass objects. 
protected

OSMetaClass(
    const char *inClassName, 
    const OSMetaClass *inSuperClass, 
    unsigned int inClassSize); 
Parameters
inClassName
C string of the name of the class this metaclass represents.
inSuperClassName
C string of the name of the super class.
inClassSize
size of the class.
Discussion 

This constructor is protected and cannot be used to instantiate an OSMetaClass object, i.e. OSMetaClass is an abstract class. This function stores the currently constructing OSMetaClass instance away for later processing. See preModLoad and postModLoad.*/
OSMetaClass ::OSMetaClass(
    const char *inClassName, 
    const OSMetaClass *inSuperClass, 
    unsigned int inClassSize){
printf ("OSMetaClass",*inClassName,*inSuperClass,inClassSize);
}; 

/*instanceConstructed


Counts the instances of the class behind this metaclass. 
public

void instanceConstructed() const; 
Discussion 

Every non-abstract class that inherits from OSObject has a default constructor that calls its own metaclass's instanceConstructed function. This constructor is defined by the OSDefineMetaClassAndStructors macro (qv) that all OSObject subclasses must use. Also, if the instance count goes from 0 to 1, i.e. the first instance, then increment the instance count of the super class.*/
void OSMetaClass :: instanceConstructed() const{
printf ("instanceConstructed");
}; 

/*metaCast(const char *)


See OSMetaClassBase::metaCast(const OSMetaClass *). 

public

OSMetaClassBase *metaCast(
    const char *toMeta) const; 
Parameters
toMeta
const char * C String of the desired class' name.
Return Value

Returns 'this' if the object is of the desired type, otherwise 0.*/
OSMetaClassBase * OSMetaClassBase::metaCast(
    const char *toMeta) const{}; 

/*allocClassWithName


Looks up a metaclass in the runtime type information system and returns the results of an alloc call. 

public

static OSObject *allocClassWithName(
    const char *name); 
Parameters
name
Name of the desired class.
Return Value

Returns a pointer to a new object, 0 if not found or no memory.*/
 OSObject * OSMetaClass::allocClassWithName(
    const char *name){};

/*isEqualTo


Returns whether 'this' == anObj. 

public

virtual bool isEqualTo(
    const OSMetaClassBase *anObj) const; 
Parameters
anObj
Object to compare 'this' to.
Return Value

Returns true if the objects are equivalent, false otherwise. 
Discussion 

OSMetaClassBase::isEqualTo implements this as a shallow pointer comparison. The OS container classes do a more meaningful comparison. Your mileage may vary.*/
bool OSMetaClassBase::isEqualTo(
    const OSMetaClassBase *anObj) const{}; 

/*alloc


Allocates an instance of the class that this OSMetaClass instance represents. 

public

virtual OSObject *alloc() const = 0; 
Return Value

Returns a pointer to a new object with a retain count of 1. 
Discussion 

This alloc function is analogous to the old ObjC class alloc method. Typically not used by clients because the static function allocClassWithName is more generally useful. In fact, that function is implemented in terms of this virtual function. All subclasses of OSMetaClass must implement this function, but that is what the OSDefineMetaClassAndStructor's families of macros does for the developer automatically.*/
 OSObject * OSMetaClass::alloc() const {}; 

/*getClassName


'Get'ter for class name. 

public

const char *getClassName() const; 
Return Value

Returns a C string of the class name.*/
const char * OSMetaClass::getClassName() const{}; 


/*metaCast(const OSSymbol *)


See OSMetaClassBase::metaCast(const OSMetaClass *). 

public

OSMetaClassBase *metaCast(
    const OSSymbol *toMeta) const; 
Parameters
toMeta
OSSymbol of the desired class' name.
Return Value

Returns 'this' if the object is of the desired type, otherwise 0.*/
OSMetaClassBase * OSMetaClassBase::metaCast(
    const OSSymbol *toMeta) const{}; 

/*metaCast(const OSString *)


See OSMetaClassBase::metaCast(const OSMetaClass *). 

public

OSMetaClassBase *metaCast(
    const OSString *toMeta) const; 
Parameters
toMeta
OSString of the desired class' name.
Return Value

Returns 'this' if the object is of the desired type, otherwise 0. */
OSMetaClassBase *OSMetaClassBase::metaCast(
    const OSString *toMeta) const{}; 

/*metaCast(const OSMetaClass *)


Checks to see if this object is or inherits from the given type. 

public

OSMetaClassBase *metaCast(
    const OSMetaClass *toMeta) const; 
Parameters
toMeta
Pointer to a constant OSMetaClass for the desired target type.
Return Value

Returns 'this' if the object is of the desired type, otherwise 0. 
Discussion 

This function is the guts of the OSMetaClass system. IODynamicCast, qv, is implemented using this function. */
OSMetaClassBase *OSMetaClassBase::metaCast(
    const OSMetaClass *toMeta) const{}; 

/*getSuperClass


'Get'ter for the super class. 

public

const OSMetaClass *getSuperClass() const; 
Return Value

Returns a pointer to superclass, chain ends with 0 for OSObject.*/
const OSMetaClass * OSMetaClass::getSuperClass() const{}; 
