#include <stdio.h>
#include <libkern/c++/OSObject.h>

/*release


Releases a reference to this object. 
public

virtual void release() const; 
Discussion 

Removes a reference that is NULL tagged. See taggedRelease.*/
void OSObject::release() const{
printf ("release");
}; 

/*retain


Retains a reference to this object. 
public

virtual void retain() const; 
Discussion 

Takes a reference that is NULL tagged. See taggedRetain.*/
 void OSObject::retain() const{
printf ("retain");
}; 

/*init


Mac OS X kernel's primary mechanism for constructing objects. 

protected

virtual bool init(); 
Return Value

OSObject::init always returns true, but subclasses will return false on init failure. 
Discussion 

Your responsibility as a subclass author is to override the init method of your parent. In general, most of our implementations call super::init() before doing local initialization, if the parent fails then return false immediately. If you have a failure during your local initialization, then return false.*/
 bool OSObject::init(){};

/*free


The last reference is gone so clean up your resources. 

protected

virtual void free(); 
Discussion 

Release all resources held by the object, then call your parent's free(). 

Caution:
You cannot assume that you have completed initialization before your free is called, so be very careful in your implementation.
The implementation is OSObject::free() { delete this; } so do not call super::free() until just before you return.
Free is not allowed to fail; all resources must be released on completion.*/
void OSObject::free(){}; 

/*getRetainCount


Gets the number of times this object has been retained. 

public

virtual int getRetainCount() const; 
Return Value

Returns the current retain count.*/
 int OSObject::getRetainCount() const{}; 


/*release(int)


Implements the untagged release(when) mechanism. 

protected

virtual void release(
    int when) const; 
Parameters
when
Pass through to taggedRelease.*/
void OSObject::release(
    int when) const{}; 

/*serialize


Archives the receiver. 

public

virtual bool serialize(
    OSSerialize *s) const; 
Parameters
s
The OSSerialize object.
Return Value

Returns true if serialization was successful, false if not.*/
 bool OSObject:: serialize(
    OSSerialize *s) const{}; 
