#include <libkern/c++/OSOrderedSet.h>


/*withCapacity


Creates and initializes an instance of OSOrderedSet. 

public

static OSOrderedSet *withCapacity(
    unsigned int capacity, 
    OSOrderFunction orderFunc = 0, 
    void *orderingRef = 0); 
Parameters
capacity
The initial storage size in number of objects of the set.
orderFunc
A C-style function that implements the sorting algorithm for the set.
orderingRef
An ordering context used as a hint for ordering objects within the set.
Return Value

Returns an instance of OSOrderedSet, or 0 if a failure occurred.*/

OSOrderedSet * OSOrderedSet::withCapacity(
    unsigned int capacity, 
    OSOrderFunction orderFunc, 
    void *orderingRef ){}; 



/*getCount


Returns the number of objects within the collection. 

public

virtual unsigned int getCount() const; 
Return Value

Returns the number of items in the set.*/
 unsigned int  OSOrderedSet::getCount() const{}; 

/*setObject(unsigned int, const OSMetaClassBase *)


Places the specified object into the set at the specified index. 

public

virtual bool setObject(
    unsigned int index,
    const OSMetaClassBase *anObject); 
Parameters
index
The index in the set to place the object.
anObject
The object to be placed into the set.
Return Value

Returns true if the object was successfully placed into the collection, false otherwise.*/
bool OSOrderedSet::setObject(
    unsigned int index,
    const OSMetaClassBase *anObject){}; 


/*setObject(const OSMetaClassBase *)


Places an OSMetaClassBase-derived object into the set. 

public

virtual bool setObject(
    const OSMetaClassBase *anObject); 
Parameters
anObject
The object to be placed into the collection.
Return Value

Returns true if the object was successfully added to the collection, false otherwise. 
Discussion 

Note that the object will be automatically sorted in the set. */
 bool OSOrderedSet::setObject(
    const OSMetaClassBase *anObject){}; 

/*flushCollection


Removes and releases all items in the set. 

public

virtual void flushCollection(); */
void OSOrderedSet:: flushCollection(){}; 

/*removeObject


Removes and releases an object in the set. 

public

virtual void removeObject(
    const OSMetaClassBase *anObject); 
Parameters
anObject
The object to remove from the set.*/
void OSOrderedSet::removeObject(
    const OSMetaClassBase *anObject){}; 

/*getObject


Returns a reference to an object at the specified index. 

public

virtual OSObject *getObject(
    unsigned int index) const; 
Parameters
index
The index into the set.
Return Value

Returns a reference to the object at the given index, 0 if none exist at that location.*/

 OSObject *OSOrderedSet::getObject(
    unsigned int index) const{};

/*containsObject


Queries the set for the presence of the specified object. 

public

virtual bool containsObject(
    const OSMetaClassBase *anObject) const; 
Parameters
anObject
The object to be located.
Return Value

Returns true if the object is present in the set, false otherwise.*/
 bool OSOrderedSet::containsObject(
    const OSMetaClassBase *anObject) const{}; 

/*getLastObject


Returns the last object in the set. 

public

virtual OSObject *getLastObject() const; 
Return Value

Returns the object ordered last in the set or 0 if none exist.*/
 OSObject *OSOrderedSet::getLastObject() const{};
