#include <libkern/c++/OSSet.h>


/*withCapacity


Creates and initializes an instance of OSSet with the specified capacity. 

public

static OSSet *withCapacity(
    unsigned int capacity); 
Parameters
capacity
The initial capacity of the set. The capacity is the total number of objects that can be stored in the set.
Return Value

Returns an instance of OSSet or 0 on failure.*/
 OSSet * OSSet::withCapacity(
    unsigned int capacity){};


/*setObject


Places objects into the set. 

public

virtual bool setObject(
    const OSMetaClassBase *anObject); 
Parameters
anObject
The OSMetaClassBase-derived object to be placed into the set.
Return Value

Returns true if the object was successfully placed into the set, false otherwise. 
Discussion 

Note that the object added to the set is automatically retained.*/

 bool OSSet::setObject(
    const OSMetaClassBase *anObject){};


/*removeObject


Removes objects from the set. 

public

virtual void removeObject(
    const OSMetaClassBase *anObject); 
Parameters
anObject
The OSMetaClassBase-derived object to be removed from the set.
Discussion 

Note that the object removed from the set is automatically released.*/
void OSSet::removeObject(
    const OSMetaClassBase *anObject){};

/*getCount


Returns the number of objects currently in the set. 

public

virtual unsigned int getCount() const; 
Return Value

Returns the number of objects in the set.*/

 unsigned int OSSet::getCount() const{};


/*withObjects


Creates and initializes an instance of OSSet and populates it with the objects provided. 

public

static OSSet *withObjects(
    const OSObject *objects[], 
    unsigned int count, 
    unsigned int capacity = 0); 
Parameters
objects
A static array of OSMetaClassBase-derived objects which are used to populate the set.
count
The number of objects passed to the set.
capacity
The initial storage size of the set. The capacity is the total number of objects that can be stored in the set. This value must be equal to or larger than the count parameter.
Return Value

Returns an instance of OSSet or 0 on failure.*/
OSSet * OSSet::withObjects(
    const OSObject *objects[], 
    unsigned int count, 
    unsigned int capacity ){};


/*containsObject


Queries the set for the presence of the specified object. 

public

virtual bool containsObject(
    const OSMetaClassBase *anObject) const; 
Parameters
anObject
The OSMetaClassBase-derived object to be queried for in the set.
Return Value

Returns true if the object is present within the set, false otherwise.*/
 bool OSSet:: containsObject(
    const OSMetaClassBase *anObject) const{};

/*withSet


Creates an instance of OSSet and populates it with the objects from the specified OSSet object. 

public

static OSSet *withSet(
    const OSSet *set, 
    unsigned int capacity = 0); 
Parameters
set
An OSSet object containing OSMetaClassBase-derived objects which are used to initially populate the new OSSet object.
capacity
The initial storage size of the set. This value must be equal to or larger than the number of objects provided by the OSSet object passed as the first parameter.
Return Value

Returns an instance of OSSet or 0 on failure.*/
 OSSet * OSSet::withSet(
    const OSSet *set, 
    unsigned int capacity ){}; 

/*getAnyObject


Returns an arbitrary object from the set. 

public

virtual OSObject *getAnyObject() const; 
Return Value

Returns an object if one exists within the set.*/
 OSObject * OSSet::getAnyObject() const{}; 

/*flushCollection


Removes and releases all objects within the set. 

public

virtual void flushCollection(); */
void OSSet::flushCollection(){};

/*free


Releases all resources created or used by the OSSet instance. 

public

virtual void free(); 
Discussion 

This function should not be called directly, use release() instead.*/

void OSSet:: free(){}; 

/*getCapacity


Returns the storage capacity of the set. 

public

virtual unsigned int getCapacity() const; 
Return Value

Returns the storage size of the set.*/

 unsigned int OSSet::getCapacity() const{}; 

