#include <libkern/c++/OSSymbol.h>


/*withCString


Creates an OSSymbol instance from a simple C string or returns an existing OSSymbol object based on the string given. 

public

static const OSSymbol *withCString(
    const char *cString); 
Parameters
cString
A C string.
Return Value

Returns a unique OSSymbol object for the string given.*/
 const OSSymbol * OSSymbol::withCString(
    const char *cString){};

/*withString


Creates an OSSymbol instance from an OSString object or returns an existing OSSymbol object based on the OSString object given. 

public

static const OSSymbol *withString(
    const OSString *aString); 
Parameters
aString
An OSString object.
Return Value

Returns a unique OSSymbol object for the string given.*/
 const OSSymbol *OSSymbol::withString(
    const OSString *aString){};

/*isEqualTo(const OSSymbol *)


Tests the equality between two OSSymbol objects. 

public

virtual bool isEqualTo(
    const OSSymbol *aSymbol) const; 
Parameters
aSymbol
The OSSymbol object to be compared against the receiver.
Return Value

Returns true if the two objects are equivalent, false otherwise. 
Discussion 

Note that two OSSymbol objects are only equivalent when their references are identical.*/
 bool  OSSymbol::isEqualTo(
    const OSSymbol *aSymbol) const{};

/*isEqualTo(const char *)


Tests the equality between an OSSymbol object and a simple C string. 

public

virtual bool isEqualTo(
    const char *aCString) const; 
Parameters
aCString
The C string to be compared against the receiver.
Return Value

Returns true if the OSSymbol's internal string representation is equivalent to the C string it is being compared against, false otherwise.*/

bool OSSymbol::isEqualTo(
    const char *aCString) const{};


/*withCStringNoCopy


Creates an OSSymbol instance from a simple C string, but does not copy the string to the container. 

public

static const OSSymbol *withCStringNoCopy(
    const char *cString); 
Parameters
cString
A C string.
Return Value

Returns a unique OSSymbol object for the string given.*/
const OSSymbol * OSSymbol::withCStringNoCopy(
    const char *cString){};
