#include <mach-o/dyld.h>
//work

void NSLinkEditError(NSLinkEditErrors *c, int *errorNumber, const char** fileName, const char** errorString){};//c 

int _dyld_func_lookup(const char* dyld_func_name, void **address){};

////////////////////////
/*NSCreateObjectFileImageFromMemory

Creates an image reference for a Mach-O file currently in memory.

NSObjectFileImageReturnCode NSCreateObjectFileImageFromMemory(
   const void* address,
   size_t size,
   NSObjectFileImage* objectFileImage);
Parameters
address

A pointer to the memory block containing the Mach-O file contents. 
size

The size of the memory block, in bytes.
objectFileImage

On output, a pointer to an NSObjectFileImage opaque data structure.
Return Value

See Mach-O Image Creation Return Codes.
Discussion

Given a pointer to a Mach-O file in memory, this function creates and returns an NSObjectFileImage reference. The current implementation works only with bundles, so you must build the Mach-O executable file using the -bundle linker option.

The memory block that address points to, must be allocated with vm_allocate (/usr/include/mach/vm_map.h).

See also NSDestroyObjectFileImage.
Availability
Available in Mac OS X v10.3 and later.*/
NSObjectFileImageReturnCode NSCreateObjectFileImageFromMemory(
   const void* address,
   size_t size,
   NSObjectFileImage* objectFileImage){};

/*NSCreateObjectFileImageFromFile

Creates an image reference for a given Mach-O file.

NSObjectFileImageReturnCode NSCreateObjectFileImageFromFile(
   const char* pathName,
   NSObjectFileImage* objectFileImage);
Parameters
pathName

A C string. Pass the pathname to a Mach-O executable file. You must have previously built this file with the -bundle linker option; otherwise, this function returns an error.
objectFileImage

On output, a pointer to an NSObjectFileImage opaque data structure.
Return Value

See Mach-O Image Creation Return Codes.
Discussion

Given a pathname to a Mach-O executable, this function creates and returns a NSObjectFileImage reference. The current implementation works only with bundles, so you must build the Mach-O executable file using the -bundle linker option.

For portability and efficiency, consider using dlopen.*/
NSObjectFileImageReturnCode NSCreateObjectFileImageFromFile(
   const char* pathName,
   NSObjectFileImage* objectFileImage){};

/*NSLinkModule

Links the given object file image as a module into the current program.

NSModule NSLinkModule(
   NSObjectFileImage objectFileImage,
   const char* moduleName,
   uint32_t options);
Parameters
objectFileImage

An object file image reference. Pass a reference created using the NSCreateObjectFileImageFromFile function.
moduleName

A C string. Pass the absolute path to the object file image. GDB uses this path to retrieve debug symbol information from the library. 
options

An unsigned long value. Pass one or more of the following bit masks or NSLINKMODULE_OPTION_NONE to specify no options:
NSLINKMODULE_OPTION_BINDNOW

The dynamic linker binds all undefined references immediately, rather than waiting until the references are actually used. All dependent libraries are also bound.
NSLINKMODULE_OPTION_PRIVATE

Do not add the global symbols from the module to the global symbol list. Instead, you must use the NSLookupSymbolInModule function to obtain symbols from this module.
NSLINKMODULE_OPTION_RETURN_ON_ERROR

If an error occurs while binding the module, return NULL. You can then use the function NSLinkEditError to retrieve information about the error.

Without this option, this function calls the linkEdit error handler you have installed using the NSInstallLinkEditErrorHandlers function. If you have not installed a link edit error handler, this function prints a message to the standard error stream and causes a breakpoint trap to end the program.
Return Value

A reference to the linked module.
Discussion

When you call this function, all libraries referenced by the given module are added to the library search list. Unless you pass the NSLINKMODULE_OPTION_PRIVATE, NSLinkModule adds all global symbols in the module to the global symbol list.

For portability and efficiency, consider using dlopen.

See “Building Mach-O Files” in “Mach-O Programming Topics” for more information about modules.*/
NSModule NSLinkModule(
   NSObjectFileImage objectFileImage,
   const char* moduleName,
   uint32_t options){};

/*NSLookupSymbolInModule

Given a module reference, returns a reference to the symbol with the given name.

NSSymbol NSLookupSymbolInModule(
   NSModule module,
   const char* symbolName);
Parameters
module

A module reference. Pass the module that contains the symbol.
symbolname

A pointer to a C string. Pass the name of the symbol to look up.
Return Value

The symbol reference or NULL if the symbol cannot be found.
Discussion

For portability and efficiency, consider using dlsym.*/

NSSymbol NSLookupSymbolInModule(
   NSModule module,
   const char* symbolName){};

/*NSAddressOfSymbol

Returns the address in the program’s address space of the data represented by the given symbol. The data may be a variable, a constant, or the first instruction of a function.

void* NSAddressOfSymbol(
   NSSymbol symbol);
Parameters
symbol

A symbol reference. Pass the symbol whose address you wish to obtain.
Return Value

A pointer to the data represented by the given symbol.
Discussion

For portability and efficiency, consider using dlsym.*/
void* NSAddressOfSymbol(
   NSSymbol symbol){};

/*NSUnLinkModule

Unlinks the given module from the current program.

bool NSUnLinkModule(
   NSModule module,
   uint32_t options);
Parameters
module

A module reference. Pass a reference to a module that you have previously linked using the NSLinkModule function.
options

An unsigned long value. You can specify one or more of the following bit masks:
NSUNLINKMODULE_OPTION_NONE

Unlink the module and deallocate the memory it occupies.
NSUNLINKMODULE_OPTION_KEEP_MEMORY_MAPPED

Unlink the module, but do not deallocate the memory it occupies. Addresses that reside within the module remain valid. You cannot unmap this memory later; it’s released when the process exits or is terminated.
NSUNLINKMODULE_OPTION_RESET_LAZY_REFERENCES

Unlink the module and reset lazy references from other modules that are bound to the module. You can then link a new module that implements the same symbols, and the function call references are bound to the new module when accessed.
Discussion

For portability and efficiency, consider using dlopen in conduction with dlclose.

See “Building Mach-O Files” in “Mach-O Programming Topics” for more information about modules.
Special Considerations

In Mac OS X v10.2 and later, NSUNLINKMODULE_OPTION_RESET_LAZY_REFERENCES can be used only with PowerPC CPU executables.*/

bool NSUnLinkModule(
   NSModule module,
   uint32_t options){};

/*NSDestroyObjectFileImage

Releases the given object file image.

bool NSDestroyObjectFileImage(
   NSObjectFileImage objectFileImage);
Parameters
objectFileImage

A reference to the object file image to destroy.
Return Value

TRUE if the image was successfully destroyed, FALSE if not.
Discussion

When this function is called, the dynamic loader calls vm_deallocate (/usr/include/mach/vm_map.h) on the memory pointed to by the objectFileImage parameter.

For portability and efficiency, consider using dlopen in conjunction with dlclose.

See also NSCreateObjectFileImageFromMemory.*/
bool NSDestroyObjectFileImage(
   NSObjectFileImage objectFileImage){};

/*NSIsSymbolNameDefined

Returns TRUE if the given symbol is defined in the current program.

enum bool NSIsSymbolNameDefined(
   const char* symbolName);
Parameters
symbolName

A C string. Pass the name of the symbol whose definition status you wish to discover.
Return Value

TRUE when the symbol is defined by any image loaded in the current process; FALSE when the symbol cannot be found.
Discussion

Deprecated in Mac OS X v10.4. Use NSLookupSymbolInImage instead.

If you know the name of the library in which the symbol is likely to be located, you can use the NSIsSymbolNameDefinedWithHint function, which may be faster than this function. You should use the NSIsSymbolNameDefinedInImage function to perform a two-level namespace lookup*/
bool NSIsSymbolNameDefined(
   const char* symbolName){};

/*NSLookupAndBindSymbol

Given a symbol name, returns the corresponding symbol from the global symbol table.

NSSymbol NSLookupAndBindSymbol(
   const char* symbolName);
Parameters
symbolName

A pointer to a C string. Pass the name of the symbol you wish to find.
Return Value

The symbol reference for the requested symbol.
Discussion

Deprecated in Mac OS X v10.4. Use NSLookupSymbolInImage instead.

On error, if you have installed a link edit error handler, it is called; otherwise, this function writes an error message to file descriptor 2 (usually the standard error stream, stderr) and causes a breakpoint trap to end the program.

If you know the name of the library in which the symbol is likely to be located, you can use the NSLookupAndBindSymbolWithHint function, which may be faster than this function. You should use the NSLookupSymbolInImage function to perform a two-level namespace lookup.*/
NSSymbol NSLookupAndBindSymbol(
   const char* symbolName){};

/*_dyld_image_count

Returns the number of images that dyld has mapped into the address space of the current process.

uint32_t _dyld_image_count(void);
Return Value

A long integer containing the number of images that dyld has mapped into the address space of the current process.
Discussion

This function provides you with a count of the number of the images in the image list. You can use this number to iterate the images loaded into the address space of the current process, using functions such as _dyld_get_image_header and _dyld_get_image_name.*/
uint32_t _dyld_image_count(void){};


/*_dyld_get_image_header

Returns the data structure for the header of a specified image. The image is specified by index into the list of images maintained by dyld for the current process.

const struct mach_header* _dyld_get_image_header(
   uint32_t image_index);

Parameters
image_index

A long integer. Pass a zero-based index indicating the position of the image in the list of images loaded into the address space of the current process.
Return Value

A pointer to the mach_header data structure of the specified image. If image_index is greater than the number of loaded images, this pointer is null.*/

const struct mach_header* _dyld_get_image_header(
   uint32_t image_index){};

/*_dyld_get_image_vmaddr_slide

Returns the virtual memory address slide amount of an image.

intptr_t _dyld_get_image_vmaddr_slide(
   uint32_t image_index);

Parameters
image_index

A long integer. Pass a zero-based index indicating the position of the image in the list of images loaded into the address space of the current process.
Return Value

If image_index is greater than or equal to the value returned by _dyld_image_count, zero. Otherwise, the vmaddr_slide value for the specified image.
Discussion

When the dynamic linker loads an image, the image must be mapped into the virtual address space of the process at an unoccupied address. The dynamic linker accomplishes this by adding a value—the virtual memory slide amount—to the base address of the image.*/
intptr_t _dyld_get_image_vmaddr_slide(
   uint32_t image_index){};


/*dyld(3)                  BSD Library Functions Manual                  dyld(3)

NAME
     _dyld_image_count, _dyld_get_image_header, _dyld_get_image_vmaddr_slide,
     _dyld_get_image_name, _dyld_register_func_for_add_image,
     _dyld_register_func_for_remove_image, NSVersionOfRunTimeLibrary,
     NSVersionOfLinkTimeLibrary _NSGetExecutablePath

SYNOPSIS
     #include <mach-o/dyld.h>

     uint32_t
     _dyld_image_count(void);

     const struct mach_header*
     _dyld_get_image_header(uint32_t image_index);

     intptr_t
     _dyld_get_image_vmaddr_slide(uint32_t image_index);

     const char*
     _dyld_get_image_name(uint32_t image_index);

     void
     _dyld_register_func_for_add_image(void (*func)(const struct mach_header* mh, intptr_t vmaddr_slide));

     void
     _dyld_register_func_for_remove_image(void (*func)(const struct mach_header* mh, intptr_t vmaddr_slide));

     int32_t
     NSVersionOfRunTimeLibrary(const char* libraryName);

     int32_t
     NSVersionOfLinkTimeLibrary(const char* libraryName);

     int
     _NSGetExecutablePath(char* buf, uint32_t* bufsize);

DESCRIPTION
     These routines provide additional introspection of dyld beyond that pro-vided provided
     vided by dlopen() and dladdr()

     _dyld_image_count() returns the current number of images mapped in by
     dyld. Note that using this count to iterate all images is not thread
     safe, because another thread may be adding or removing images during the
     iteration.

     _dyld_get_image_header() returns a pointer to the mach header of the
     image indexed by image_index.  If image_index isout of range, NULL is
     returned.

     _dyld_get_image_vmaddr_slide() returns the virtural memory address slide
     amount of the image indexed by image_index. If image_index is out of
     range zero is returned.

     _dyld_get_image_name() returns the name of the image indexed by
     image_index. The C-string continues to be owned by dyld and should not
     deleted.  If image_index is out of range NULL is returned.
dyld(3)                  BSD Library Functions Manual                  dyld(3)

NAME
     _dyld_image_count, _dyld_get_image_header, _dyld_get_image_vmaddr_slide,
     _dyld_get_image_name, _dyld_register_func_for_add_image,
     _dyld_register_func_for_remove_image, NSVersionOfRunTimeLibrary,
     NSVersionOfLinkTimeLibrary _NSGetExecutablePath

SYNOPSIS
     #include <mach-o/dyld.h>

     uint32_t
     _dyld_image_count(void);

     const struct mach_header*
     _dyld_get_image_header(uint32_t image_index);

     intptr_t
     _dyld_get_image_vmaddr_slide(uint32_t image_index);

     const char*
     _dyld_get_image_name(uint32_t image_index);

     void
     _dyld_register_func_for_add_image(void (*func)(const struct mach_header* mh, intptr_t vmaddr_slide));

     void
     _dyld_register_func_for_remove_image(void (*func)(const struct mach_header* mh, intptr_t vmaddr_slide));

     int32_t
     NSVersionOfRunTimeLibrary(const char* libraryName);

     int32_t
     NSVersionOfLinkTimeLibrary(const char* libraryName);

     int
     _NSGetExecutablePath(char* buf, uint32_t* bufsize);

DESCRIPTION
     These routines provide additional introspection of dyld beyond that pro-vided provided
     vided by dlopen() and dladdr()

     _dyld_image_count() returns the current number of images mapped in by
     dyld. Note that using this count to iterate all images is not thread
     safe, because another thread may be adding or removing images during the
     iteration.

     _dyld_get_image_header() returns a pointer to the mach header of the
     image indexed by image_index.  If image_index isout of range, NULL is
     returned.

     _dyld_get_image_vmaddr_slide() returns the virtural memory address slide
     amount of the image indexed by image_index. If image_index is out of
     range zero is returned.

     _dyld_get_image_name() returns the name of the image indexed by
     image_index. The C-string continues to be owned by dyld and should not
     deleted.  If image_index is out of range NULL is returned.

     _dyld_register_func_for_add_image() registers the specified function to
     be called when a new image is added (a bundle or a dynamic shared
     library) to the program.  When this function is first registered it is
     called for once for each image that is currently part of the process.

     _dyld_register_func_for_remove_image() registers the specified function
     to be called when an image is removed (a bundle or a dynamic shared
     library) from the process.

     NSVersionOfRunTimeLibrary() returns the current_version number of the
     currently loaded dylib specifed by the libraryName.  The libraryName
     parameter would be "bar" for /path/libbar.3.dylib and "Foo" for
     /path/Foo.framework/Versions/A/Foo.  This function returns -1 if no such
     library is loaded.

     NSVersionOfLinkTimeLibrary() returns the current_version number that the
     main executable was linked against at build time.  The libraryName param-eter parameter
     eter would be "bar" for /path/libbar.3.dylib and "Foo" for
     /path/Foo.framework/Versions/A/Foo.  This function returns -1 if the main
     executable did not link against the specified library.

     _NSGetExecutablePath() copies the path of the main executable into the
     buffer buf.  The bufsize parameter should initially be the size of the
     buffer.  This function returns 0 if the path was successfully copied.  It
     returns -1 if the buffer is not large enough, and * bufsize is set to the
     size required.  Note that _NSGetExecutablePath() will return "a path" to
     the executable not a "real path" to the executable.  That is, the path
     may be a symbolic link and not the real file. With deep directories the
     total bufsize needed could be more than MAXPATHLEN.

SEE ALSO
     dlopen(3) dladdr(3) dyld(1) http://developer.apple.com/documenta-
     tion/DeveloperTools/Conceptual/MachOTopics/index.html

                                August 16, 2006
     _dyld_register_func_for_add_image() registers the specified function to
     be called when a new image is added (a bundle or a dynamic shared
     library) to the program.  When this function is first registered it is
     called for once for each image that is currently part of the process.

     _dyld_register_func_for_remove_image() registers the specified function
     to be called when an image is removed (a bundle or a dynamic shared
     library) from the process.

     NSVersionOfRunTimeLibrary() returns the current_version number of the
     currently loaded dylib specifed by the libraryName.  The libraryName
     parameter would be "bar" for /path/libbar.3.dylib and "Foo" for
     /path/Foo.framework/Versions/A/Foo.  This function returns -1 if no such
     library is loaded.

     NSVersionOfLinkTimeLibrary() returns the current_version number that the
     main executable was linked against at build time.  The libraryName param-eter parameter
     eter would be "bar" for /path/libbar.3.dylib and "Foo" for
     /path/Foo.framework/Versions/A/Foo.  This function returns -1 if the main
     executable did not link against the specified library.

     _NSGetExecutablePath() copies the path of the main executable into the
     buffer buf.  The bufsize parameter should initially be the size of the
     buffer.  This function returns 0 if the path was successfully copied.  It
     returns -1 if the buffer is not large enough, and * bufsize is set to the
     size required.  Note that _NSGetExecutablePath() will return "a path" to
     the executable not a "real path" to the executable.  That is, the path
     may be a symbolic link and not the real file. With deep directories the
     total bufsize needed could be more than MAXPATHLEN.

SEE ALSO
     dlopen(3) dladdr(3) dyld(1) http://developer.apple.com/documenta-
     tion/DeveloperTools/Conceptual/MachOTopics/index.html

                                August 16, 2006*/

   const char*    _dyld_get_image_name(uint32_t image_index){};
     int32_t     NSVersionOfLinkTimeLibrary(const char* libraryName){};
     int32_t NSVersionOfRunTimeLibrary(const char* libraryName){};

/*NSAddImage

Adds the specified Mach-O image to the currently running process.

const struct mach_header* NSAddImage(
   const char* image_name,
   uint32_t options);

Parameters
image_name

A pointer to a C string. Pass the pathname to a shared library on disk. For best performance, specify the full pathname of the shared library—not a symlink.
options

A bit mask. Pass one or more of the following options or NSADDIMAGE_OPTION_NONE to specify no options:
NSADDIMAGE_OPTION_RETURN_ON_ERROR

If an error occurs and you have specified this option, this function returns NULL. You can then use the function NSLinkEditError to retrieve information about the error.

If an error occurs, and you have not specified this option, this function calls the linkEdit error handler you have installed using the NSInstallLinkEditErrorHandlers function. If you have not installed a link edit error handler, this function prints an error to stderr and causes a breakpoint trap to end the program.
NSADDIMAGE_OPTION_WITH_SEARCHING

With this option, the image_name passed for the library and all its dependents is affected by the various dyld environment variables as if this library were linked into the program.
NSADDIMAGE_OPTION_RETURN_ONLY_IF_LOADED

With this option, this function returns NULL if the shared library was not loaded prior to the call to this function.
Return Value

A pointer to a mach_header (“Mac OS X ABI Mach-O File Format Reference”) data structure. This is a pointer to the start of the loaded image.
Discussion

This function loads the shared library specified by image_name into the current process, returning a pointer to the mach_header data structure of the loaded image. Any libraries that the specified library depends on are also loaded.

The linkEdit error handler is documented in the NSModule(3) man page.

For portability and efficiency, consider using dlopen.
Availability
Available in Mac OS X v10.1 and later.*/
const struct mach_header* NSAddImage(
   const char* image_name,
   uint32_t options){};

/*NSLookupSymbolInImage

Returns a reference to the specified symbol from the specified image.

NSSymbol NSLookupSymbolInImage(
   const struct mach_header* image,
   const char* symbolName
   uint32_t options);
Parameters
image

A pointer to a mach_header data structure. Pass a pointer to the start of the image that contains the symbol. You can get this pointer from a shared library name using NSAddImage.

If the process does not have a two-level namespace, NSLookupSymbolInImage ignores this argument and searches for the symbol in the global symbol table.
symbolName

A pointer to a C string. Pass the name of the symbol you wish to find.
options

A bit mask. Pass any of the following options:
NSLOOKUPSYMBOLINIMAGE_OPTION_BIND

Bind the nonlazy symbols of the module in the image that defines symbolName and let all lazy symbols in the module be bound on first call. You should pass this option when you expect the module to bind without errors (for example, a library supplied with the system). If, later, you call a lazy symbol, and the lazy symbol fails to bind, the runtime calls the link edit error handler you have installed using the NSInstallLinkEditErrorHandlers function.

If there is no link edit error handler installed, the runtime prints a message to the standard error stream and causes a breakpoint trap to end the program.
NSLOOKUPSYMBOLINIMAGE_OPTION_BIND_NOW

Bind all the nonlazy and lazy symbols of the module in the image that defines the symbol name, and bind symbols in the dependent libraries as needed. 

Pass this option for a library that might not be expected to bind without errors but that links against only system-supplied libraries that are themselves expected to bind without any errors.
NSLOOKUPSYMBOLINIMAGE_OPTION_BIND_FULLY

Bind all the symbols of the module that defines symbolName and all the dependent symbols of all needed libraries.

Because it may take a long time to fully bind the image, you should pass this option only for libraries that cannot bind other symbols once executed, such as code that implements signal handlers.
NSLOOKUPSYMBOLINIMAGE_OPTION_RETURN_ON_ERROR

Return NULL if the symbol cannot be bound.
Return Value

The symbol reference for the requested symbol, or NULL if the symbol cannot be found and you passed the option NSLOOKUPSYMBOLINIMAGE_OPTION_RETURN_ON_ERROR.
Discussion

On error, if you have installed a link edit error handler, it is called; otherwise, this function writes an error message to file descriptor 2 (usually the standard error stream, stderr) and causes a breakpoint trap to end the program.

For portability and efficiency, consider using dlsym.
Availability
Available in Mac OS X v10.1 and later.*/
NSSymbol NSLookupSymbolInImage(
   const struct mach_header* image,
   const char* symbolName,
   uint32_t options){};

/*NSLookupAndBindSymbolWithHint

Given a symbol name, returns the corresponding symbol from the global symbol table.

NSSymbol NSLookupAndBindSymbolWithHint(
   const char* symbolName,
   const char* libraryNameHint);

Parameters
symbolName

A pointer to a C string. Pass the name of the symbol you wish to find.
libraryNameHint

A pointer to a C string. Pass any part of the name of the library that the symbol is likely to be found in.
Return Value

The symbol reference for the requested symbol.
Discussion

On error, if you have installed a link edit error handler, it is called; otherwise, this function writes an error message to file descriptor 2 (usually the standard error stream, stderr), and causes a breakpoint trap to end the program.

Note that this function performs a flat lookup even if the symbol namespace of the current program has two levels. You should use the NSLookupSymbolInImage function to perform a two-level namespace lookup.

Deprecated in Mac OS X v10.4. Use NSLookupSymbolInImage instead.*/
NSSymbol NSLookupAndBindSymbolWithHint(
   const char* symbolName,
   const char* libraryNameHint){};


