#include <stdio.h>
#include <net/kpi_interface.h>

void* ifnet_lladdr(ifnet_t  a){};//?
int ifnet_eflags(ifnet_t a){};//?

/*ifnet_release

errno_t ifnet_release(
    ifnet_t interface);  
Parameters
interface
The interface to decrement the reference count of and possibly free.
Return Value

May return EINVAL if the interface is not valid. 
Discussion 

Release a reference of the ifnet, this may trigger a free if the reference count reaches 0.*/
errno_t ifnet_release(
    ifnet_t interface){
printf ("ifnet_release",interface);
};  

/*ifnet_find_by_name

errno_t ifnet_find_by_name(
    const char *ifname,
    ifnet_t *interface);  
Parameters
ifname
The name of the interface, including any unit number (i.e. "en0").
interface
A pointer to an interface reference. This will be filled in if a matching interface is found.
Return Value

0 on success otherwise the errno error. 
Discussion 

Find an interface by the name including the unit number. Caller must call ifnet_release on any non-null interface return value.*/
errno_t ifnet_find_by_name(
    const char *ifname,
    ifnet_t *interface){
printf ("ifnet_find_by_name",*ifname,*interface);
};  

/*ifnet_softc

void* ifnet_softc(
    ifnet_t interface);  
Parameters
interface
Interface to retrieve the storage from.
Return Value

Driver's private storage. 
Discussion 

Returns the driver's private storage on the interface.*/
void* ifnet_softc(
    ifnet_t interface){};  


/*ifnet_lladdr_copy_bytes

errno_t ifnet_lladdr_copy_bytes(
    ifnet_t interface,
    void*lladdr,
    size_t length);  
Parameters
interface
The interface to copy the link-layer address from.
lladdr
The buffer to copy the link-layer address in to.
length
The length of the buffer. This value must match the length of the link-layer address.
Discussion 

Copies the bytes of the link-layer address in to the specified buffer.*/
errno_t ifnet_lladdr_copy_bytes(
    ifnet_t interface,
    void*lladdr,
    size_t length){}; 


/*ifnet_get_address_list_family

errno_t ifnet_get_address_list_family(
    ifnet_t interface,
    ifaddr_t **addresses,
    sa_family_t family);  
Parameters
interface
The interface.
addresses
A pointer to a NULL terminated array of ifaddr_ts.
Return Value

0 on success otherwise the errno error. 
Discussion 

Get a list of addresses on the interface. Passing NULL for the interface will return a list of all addresses. The addresses will have their reference count bumped so they will not go away. Calling ifnet_free_address_list will decrement the refcount and free the array. If you wish to hold on to a reference to an ifaddr_t, be sure to bump the reference count before calling ifnet_free_address_list. Unlike ifnet_get_address_list, this function lets the caller specify the address family to get a list of only a specific address type. Old versions of this function erroneously returned EINVAL when passed NULL for the interface. Passing NULL will not work on some versions of MacOS X 10.4.*/
errno_t ifnet_get_address_list_family(
    ifnet_t interface,
    ifaddr_t **addresses,
    sa_family_t family){}; 

/*ifnet_free_address_list

void ifnet_free_address_list(
    ifaddr_t *addresses);  
Parameters
addresses
An array of ifaddr_ts.
Discussion 

Free a list of addresses returned from ifnet_get_address_list. Decrements the refcounts and frees the memory used for the array of references.*/
void ifnet_free_address_list(
    ifaddr_t *addresses){};  


/*ifnet_output_raw

errno_t ifnet_output_raw(
    ifnet_t interface,
    protocol_family_t protocol_family,
    mbuf_t packet);  
Parameters
interface
The interface.
protocol_family
The family of the protocol generating this packet (i.e. AF_INET).
packet
The fully formed packet to be transmitted.
Return Value

0 on success otherwise the errno error. 
Discussion 

Handles and outbond raw packet on the interface by calling any filters followed by the interface's output function. protocol_family may be zero. If the packet is from a specific protocol the protocol_family will be used to apply protocol filters. All interface filters will be applied to the outgoing packet. Processing, such as calling the protocol preoutput and interface framer functions will be bypassed. The packet will pass through the filters and be sent on the interface as is. ifnet_output_raw will always free the packet chain.*/
errno_t ifnet_output_raw(
    ifnet_t interface,
    protocol_family_t protocol_family,
    mbuf_t packet){}; 

/*ifnet_flags

u_int16_t ifnet_flags(
    ifnet_t interface);  
Parameters
interface
Interface to retrieve the flags from.
Return Value

Flags. These flags are defined in net/if.h 
Discussion 

Returns the interface flags that are set.*/
u_int16_t ifnet_flags(
    ifnet_t interface){};  

/*ifnet_output

errno_t ifnet_output(
    ifnet_t interface,
    protocol_family_t protocol_family,
    mbuf_t packet, 
    void*route,
    const struct sockaddr *dest);  
Parameters
interface
The interface.
protocol_family
The family of the protocol generating this packet (i.e. AF_INET).
packet
The packet to be transmitted.
route
A pointer to a routing structure for this packet. The preoutput function determines whether this value may be NULL or not.
dest
The destination address of protocol_family type. This will be passed to the preoutput function. If the preoutput function does not require this value, you may pass NULL.
Return Value

0 on success otherwise the errno error. 
Discussion 

Handles an outbound packet on the interface by calling any filters, a protocol preoutput function, the interface framer function, and finally the interface's output function. The protocol_family will be used to apply protocol filters and determine which preoutput function to call. The route and dest parameters will be passed to the preoutput function defined for the attachment of the specified protocol to the specified interface. ifnet_output will always free the mbuf chain.*/
errno_t ifnet_output(
    ifnet_t interface,
    protocol_family_t protocol_family,
    mbuf_t packet, 
    void*route,
    const struct sockaddr *dest){};  

/*ifnet_set_lladdr


errno_t ifnet_set_lladdr(
    ifnet_t interface,
    const void *lladdr,
    size_t lladdr_len);  
Parameters
interface
The interface the link layer address is being changed on.
lladdr
A pointer to the raw link layer address (pointer to the 6 byte ethernet address for ethernet).
lladdr_len
The length, in bytes, of the link layer address.
Discussion 

Sets the link-layer address for this interface.*/
errno_t ifnet_set_lladdr(
    ifnet_t interface,
    const void *lladdr,
    size_t lladdr_len){};  

/*ifnet_get_multicast_list


errno_t ifnet_get_multicast_list(
    ifnet_t interface,
    ifmultiaddr_t **addresses);  
Parameters
interface
The interface.
multicasts
A pointer to a NULL terminated array of references to the multicast addresses.
Return Value

0 on success otherwise the errno error. 
Discussion 

Retrieves a list of multicast address the interface is set to receive. This function allocates and returns an array of references to the various multicast addresses. The multicasts have their reference counts bumped on your behalf. Calling ifnet_free_multicast_list will decrement the reference counts and free the array.*/
errno_t ifnet_get_multicast_list(
    ifnet_t interface,
    ifmultiaddr_t **addresses){};

/*ifmaddr_address


errno_t ifmaddr_address(
    ifmultiaddr_t ifmaddr,
    struct sockaddr *out_multicast,
    u_int32_t addr_size);  
Parameters
out_multicast
Storage for a sockaddr.
addr_size
Size of the storage.
Return Value

0 on success. 
Discussion 

Copies the multicast address to out_multicast.*/
errno_t ifmaddr_address(
    ifmultiaddr_t ifmaddr,
    struct sockaddr *out_multicast,
    u_int32_t addr_size){};  


/*ifnet_free_multicast_list


void ifnet_free_multicast_list(
    ifmultiaddr_t *multicasts);  
Parameters
multicasts
An array of references to the multicast addresses.
Return Value

0 on success otherwise the errno error. 
Discussion 

Frees a list of multicasts returned by ifnet_get_multicast_list. Decrements the refcount on each multicast address and frees the array.*/
void ifnet_free_multicast_list(
    ifmultiaddr_t *multicasts){};  

/*ifnet_set_baudrate


errno_t ifnet_set_baudrate(
    ifnet_t interface,
    u_int64_t baudrate);  
Parameters
interface
The interface.
baudrate
The new baudrate.
Return Value

0 on success otherwise the errno error. 
Discussion 

This function is intended to be called by the driver. A kext must not call this function on an interface the kext does not own.*/
errno_t ifnet_set_baudrate(
    ifnet_t interface,
    u_int64_t baudrate){};  

/*ifnet_touch_lastchange


errno_t ifnet_touch_lastchange(
    ifnet_t interface);  
Parameters
interface
The interface.
Return Value

0 on success otherwise the errno error. 
Discussion 

Updates the lastchange value to now.*/
errno_t ifnet_touch_lastchange(
    ifnet_t interface){}  

/*ifnet_index


u_int32_t ifnet_index(
    ifnet_t interface);  
Parameters
interface
Interface to retrieve the index of.
Return Value

Index. 
Discussion 

Returns the index of the interface. This index value will match the index you would find in a sockaddr_dl or using if_nametoindex or if_indextoname in user space. The value of the interface index is undefined for an interface that is not currently attached.*/
u_int32_t ifnet_index(
    ifnet_t interface){};  


/*ifnet_attach_protocol


errno_t ifnet_attach_protocol(
    ifnet_t interface,
    protocol_family_t protocol_family, 
    const struct ifnet_attach_proto_param *proto_details);  
Parameters
interface
The interface.
protocol_family
The protocol family being attached (PF_INET/PF_APPLETALK/etc...).
proto_details
Details of the protocol being attached.
Return Value

0 on success otherwise the errno error. 
Discussion 

Attaches a protocol to an interface.*/
errno_t ifnet_attach_protocol(
    ifnet_t interface,
    protocol_family_t protocol_family, 
    const struct ifnet_attach_proto_param *proto_details){};  


/*ifnet_name


const char* ifnet_name(
    ifnet_t interface);  
Parameters
interface
Interface to retrieve the name from.
Return Value

Pointer to the name. 
Discussion 

Returns a pointer to the name of the interface.*/
const char* ifnet_name(
    ifnet_t interface){};  

/*ifnet_unit


u_int32_t ifnet_unit(
    ifnet_t interface);  
Parameters
interface
Interface to retrieve the unit number from.
Return Value

Unit number. 
Discussion 

Returns the unit number of the interface.*/
u_int32_t ifnet_unit(
    ifnet_t interface){};  

/*ifnet_set_mtu


errno_t ifnet_set_mtu(
    ifnet_t interface,
    u_int32_t mtu);  
Parameters
interface
The interface.
mtu
The new MTU.
Return Value

0 on success otherwise the errno error. 
Discussion 

Sets the value of the MTU in the interface structure. Calling this function will not notify the driver that the MTU should be changed. Use th*/
errno_t ifnet_set_mtu(
    ifnet_t interface,
    u_int32_t mtu){};  

/*ifnet_set_flags


errno_t ifnet_set_flags(
    ifnet_t interface,
    u_int16_t new_flags,
    u_int16_t mask);  
Parameters
interface
Interface to set the flags on.
new_flags
The new set of flags that should be set. These flags are defined in net/if.h
Return Value

0 on success otherwise the errno error. 
Discussion 

Sets the interface flags to new_flags. This function lets you specify which flags you want to change using the mask. The kernel will effectively take the lock, then set the interface's flags to (if_flags & ~mask) | (new_flags & mask).*/
errno_t ifnet_set_flags(
    ifnet_t interface,
    u_int16_t new_flags,
    u_int16_t mask){};  

/*ifnet_set_addrlen


errno_t ifnet_set_addrlen(
    ifnet_t interface,
    u_int8_t addrlen);  
Parameters
interface
The interface.
addrlen
The new address length.
Return Value

0 on success otherwise the errno error. 
Discussion 

This function is intended to be called by the driver. A kext must not call this function on an interface the kext does not own.*/
errno_t ifnet_set_addrlen(
    ifnet_t interface,
    u_int8_t addrlen){};  

/*ifnet_set_hdrlen


errno_t ifnet_set_hdrlen(
    ifnet_t interface,
    u_int8_t hdrlen);  
Parameters
interface
The interface.
hdrlen
The new header length.
Return Value

0 on success otherwise the errno error. 
Discussion 

This function is intended to be called by the driver. A kext must not call this function on an interface the kext does not own.*/
errno_t ifnet_set_hdrlen(
    ifnet_t interface,
    u_int8_t hdrlen){};  

/*ifnet_mtu


u_int32_t ifnet_mtu(
    ifnet_t interface);  
Parameters
interface
The interface.
Return Value

The MTU.*/
u_int32_t ifnet_mtu(
    ifnet_t interface){};  

/*ifnet_addrlen


u_int8_t ifnet_addrlen(
    ifnet_t interface);  
Parameters
interface
The interface.
Return Value

The address length.*/
u_int8_t ifnet_addrlen(
    ifnet_t interface){};  

/*ifnet_hdrlen


u_int8_t ifnet_hdrlen(
    ifnet_t interface);  
Parameters
interface
The interface.
Return Value

The header length.*/
u_int8_t ifnet_hdrlen(
    ifnet_t interface){};  

/*ifnet_input


errno_t ifnet_input(
    ifnet_t interface,
    mbuf_t first_packet, 
    const struct ifnet_stat_increment_param *stats);  
Parameters
interface
The interface.
first_packet
The first packet in a chain of packets.
stats
Counts to be integrated in to the stats. The interface statistics will be incremented by the amounts specified in stats. This parameter may be NULL.
Return Value

0 on success otherwise the errno error. 
Discussion 

Inputs packets from the interface. The interface's demux will be called to determine the protocol. Once the protocol is determined, the interface filters and protocol filters will be called. From there, the packet will be passed to the registered protocol. If there is an error, the mbuf chain will be freed.*/
errno_t ifnet_input(
    ifnet_t interface,
    mbuf_t first_packet, 
    const struct ifnet_stat_increment_param *stats){} ;

/*ifnet_family


ifnet_family_t ifnet_family(
    ifnet_t interface);  
Parameters
interface
Interface to retrieve the unit number from.
Return Value

Unit number. 
Discussion 

Returns the family of the interface.*/
ifnet_family_t ifnet_family(
    ifnet_t interface){}; 

/*ifnet_event


errno_t ifnet_event(
    ifnet_t interface,
    struct kern_event_msg *event_ptr);  
Parameters
interface
The interface.
event_ptr
Pointer to an kern_event structure describing the event.
Return Value

0 on success otherwise the errno error. 
Discussion 

Calls the interface's event function.*/
errno_t ifnet_event(
    ifnet_t interface,
    struct kern_event_msg *event_ptr){};  

/*ifnet_stat_increment_out


errno_t ifnet_stat_increment_out(
    ifnet_t interface, 
    u_int32_t packets_out,
    u_int32_t bytes_out, 
    u_int32_t errors_out);  
Parameters
interface
The interface.
packets_out
The number of additional packets sent.
bytes_out
The number of additional bytes sent.
errors_out
The number of additional send errors.
Return Value

0 on success otherwise the errno error. 
Discussion 

This function is intended to be called by the driver. This function allows a driver to update the outbound interface counts. 

A lock protects the counts, this makes the increment functions expensive. The increment function will update the lastchanged value.*/

errno_t ifnet_stat_increment_out(
    ifnet_t interface, 
    u_int32_t packets_out,
    u_int32_t bytes_out, 
    u_int32_t errors_out){};  

/*ifnet_allocate


errno_t ifnet_allocate(
    const struct ifnet_init_params *init,
    ifnet_t *interface);  
Parameters
init
The initial values for the interface. These values can not be changed after the interface has been allocated.
interface
The interface allocated upon success.
Return Value

May return ENOMEM if there is insufficient memory or EEXIST if an interface with the same uniqueid and family has already been allocated and is in use. 
Discussion 

Allocate an ifnet_t with an initial refcount of 1. Many parts of the stack do not properly refcount the ifnet_t. In order to avoid freeing the ifnet_t while some parts of the stack may contain a reference to it, the ifnet_ts are only recycled, never freed. A unique id is used to try and recycle the same ifnet_t when allocating an interface. For example, for an ethernet interface, the hardware address of the ethernet card is usually used for the uniqueid. If a PC Card is removed and inserted again, if the ethernet address of the PC card is used, the same ifnet_t will be used for the card the second time it is inserted. In the future, when the ifnet_t is correctly refcounted by all of the stack, the interfaces may be freed and the unique ids ignored.*/
errno_t ifnet_allocate(
    const struct ifnet_init_params *init,
    ifnet_t *interface){}; 

/*ifnet_set_offload


errno_t ifnet_set_offload(
    ifnet_t interface,
    ifnet_offload_t offload);  
Parameters
interface
The interface.
offload
The new set of flags indicating which offload options the device supports.
mask
The mask of flags to be modified.
Return Value

0 on success otherwise the errno error. 
Discussion 

Sets a bitfield to indicate special hardware offload support provided by the interface such as hardware checksums and VLAN. This replaces the if_hwassist flags field. Any flags unrecognized by the stack will not be set.*/
errno_t ifnet_set_offload(
    ifnet_t interface,
    ifnet_offload_t offload){};  

/*ifnet_attach


errno_t ifnet_attach(
    ifnet_t interface,
    const struct sockaddr_dl *ll_addr);  
Parameters
interface
The interface to attach.
ll_addr
The link layer address of the interface. This is used to fill out the first ifaddr in the list of addresses for the interface. This parameter is not required for interfaces such as PPP that have no link-layer address.
Return Value

Will return an error if there is anything wrong with the interface. 
Discussion 

Attaches an interface to the global interface list. The interface must be setup properly before calling attach. The stack will take a reference on the interface and hold it until ifnet_detach is called. 

This function is intended to be called by the driver. A kext must not call this function on an interface the kext does not own.*/
errno_t ifnet_attach(
    ifnet_t interface,
    const struct sockaddr_dl *ll_addr){};  

/*ifnet_detach


errno_t ifnet_detach(
    ifnet_t interface);  
Parameters
interface
The interface to detach.
Return Value

0 on success, otherwise errno error. 
Discussion 

Detaches the interface. 

Call this to indicate this interface is no longer valid (i.e. PC Card was removed). This function will begin the process of removing knowledge of this interface from the stack. 

The function will return before the interface is detached. The functions you supplied in to the interface may continue to be called. When the detach has been completed, your detached function will be called. Your kext must not unload until the detached function has been called. The interface will be properly freed when the reference count reaches zero. 

An interface may not be attached again. You must call ifnet_allocate to create a new interface to attach. 

This function is intended to be called by the driver. A kext must not call this function on an interface the kext does not own.*/
errno_t ifnet_detach(
    ifnet_t interface){}; 

/*ifnet_ioctl

errno_t ifnet_ioctl(
    ifnet_t interface,
    protocol_family_t protocol, 
    u_int32_t ioctl_code,
    void *ioctl_arg);  
Parameters
interface
The interface.
protocol
The protocol family of the protocol to send the ioctl to (may be zero). Some ioctls apply to a protocol while other ioctls apply to just an interface.
ioctl_code
The ioctl to perform.
ioctl_arg
Any parameters to the ioctl.
Return Value

0 on success otherwise the errno error. 
Discussion 

Calls the interface's ioctl function with the parameters passed. 

All undefined ioctls are reserved for future use by Apple. If you need to communicate with your kext using an ioctl, please use SIOCSIFKPI and SIOCGIFKPI.*/
errno_t ifnet_ioctl(
    ifnet_t interface,
    protocol_family_t protocol, 
    u_int32_t ioctl_code,
    void *ioctl_arg){};  

