#include <dlfcn.h>

/*DLOPEN_PREFLIGHT(3)      BSD Library Functions Manual      DLOPEN_PREFLIGHT(3)

NAME
     dlopen_preflight -- preflight the load of a dynamic library or bundle

SYNOPSIS
     #include <dlfcn.h>

     bool
     dlopen_preflight(const char* path);

DESCRIPTION
     dlopen_preflight() examines the mach-o file specified by path.  It checks
     if the file and libraries it depends on are all compatible with the cur-rent current
     rent process.  That is, they contain the correct architecture and are not
     otherwise ABI incompatible.

     dlopen_preflight() was first available in Mac OS X 10.5.

SEARCHING
     dlopen_preflight() uses the same steps as dlopen() to find a compatible
     mach-o file.

RETURN VALUES
     dlopen_preflight() returns true on if the mach-o file is compatible.  If
     the file is not compatible, it returns false and sets an error string
     that can be examined with dlerror().

SEE ALSO
     dlopen(3) dlerror(3)

BSD                             April 17, 2006                             BSD*/

     bool     dlopen_preflight(const char* path){};


/*DLADDR(3)                BSD Library Functions Manual                DLADDR(3)

NAME
     dladdr -- find the image containing a given address

SYNOPSIS
     #include <dlfcn.h>

     int
     dladdr(const void* addr, Dl_info* info);

DESCRIPTION
     The dladdr() function queries dyld (the dynamic linker) for information about the image containing the
     address addr.  The information is returned in the structure specified by info.  The structure contains
     at least the following members:

     const char* dli_fname     The pathname of the shared object containing the address.

     void* dli_fbase           The base address (mach_header) at which the image is mapped into the address
                               space of the calling process.

     const char* dli_sname     The name of the nearest run-time symbol with a value less than or equal to
                               addr.

     void* dli_saddr           The value of the symbol returned in dli_sname.

     The dladdr() function is available only in dynamically linked programs.

ERRORS
     If an image containing addr cannot be found, dladdr() returns 0.  On success, a non-zero value is
     returned.

     If the image containing addr is found, but no nearest symbol was found, the dli_sname and dli_saddr
     fields are set to NULL.

SEE ALSO
     dyld(3), dlopen(3)

HISTORY
     The dladdr() function first appeared in the Solaris operating system.

AUTHORS
     Mac OS X 10.3 incorporated the dlcompat package written by Jorge Acereda <jacereda@users.source-
     forge.net> and Peter O'Gorman <ogorman@users.sourceforge.net>.

     In Mac OS X 10.4, dlopen was rewritten to be a native part of dyld.

     This man page was borrowed from FreeBSD and modified.

BUGS
     This implementation is almost bug-compatible with the Solaris implementation.  The following bugs are
     present:

     oo   Returning 0 as an indication of failure goes against long-standing Unix tradition.

BSD                           September 24, 2004                           BSD*/
   int  dladdr(const void* addr, Dl_info* info){};
