#include <membership.h>


/*MBR_UID_TO_UUID(3)       BSD Library Functions Manual       MBR_UID_TO_UUID(3)

NAME
     mbr_uid_to_uuid, mbr_gid_to_uuid, mbr_uuid_to_id, mbr_sid_to_uuid,
     mbr_uuid_to_sid -- user and group identifier translation functions

SYNOPSIS
     #include <membership.h>

     int
     mbr_uid_to_uuid(uid_t id, uuid_t uu);

     int
     mbr_gid_to_uuid(gid_t id, uuid_t uu);

     int
     mbr_uuid_to_id(const uuid_t uu, uid_t *id, int *id_type);

     int
     mbr_sid_to_uuid(const nt_sid_t *sid, uuid_t uu);

     int
     mbr_uuid_to_sid(const uuid_t uu, nt_sid_t *sid);

DESCRIPTION
     Users and groups can be referred to in multiple ways.  In addition to the
     traditional uid and gid, every user or group can be referenced by a 128
     bit uuid.  Additionally, if the user or group is hosted on a PDC or
     Active Directory server, it will have a 128 bit or larger sid.

     These routines communicate with the DirectoryService(8) daemon.

     mbr_uid_to_uuid() takes a uid and looks up the associated user account.
     It provides the the uuid for that user as an output parameter.

     mbr_gid_to_uuid() similarly gets the uuid associated with a group.

     mbr_uuid_to_id() takes a uuid that refers to a user or group and fetches
     the corresponding uid or gid.  id_type is set to ID_TYPE_UID or
     ID_TYPE_GID to indicate which type was found.  Note that mbr_uuid_to_id()
     always returns an id even if the uuid is not found.  This returned id is
     not persistant, but can be used to map back to the uuid during runtime.
     To determine if the uuid exists, the returned id can be used in a call to
     getpwuid(3) or getgrgid(3).

     mbr_sid_to_uuid() takes a sid and returns the associated uuid.  Like
     mbr_uuid_to_id(), mbr_sid_to_uuid() always returns a uuid for the sid,
     even if the sid can not be found.

     mbr_uuid_to_sid() returns a sid for the associated uuid.

RETURN VALUES
     These functions return 0 on success, or EIO if communications with the
     DirectoryService(8) daemon fails.  ENOENT is returned if the mapping can
     not be performed.

SEE ALSO
     getpwuid(3), getgrgid(3), mbr_check_membership(3), DirectoryService(8)

Mac OS X                       February 3, 2005                       Mac OS X*/
     int   mbr_uid_to_uuid(uid_t id, uuid_t uu){};
int mbr_gid_to_uuid(gid_t id, uuid_t uu){};

