#include <stdio.h>

FILE __sF[]={};//c
int	 printf(const char * __restrict, ...) __DARWIN_LDBL_COMPAT(printf);//c

#ifndef native_snprintf
int	 snprintf(char * __restrict, size_t, const char * __restrict, ...) __DARWIN_LDBL_COMPAT(snprintf);//c
#endif

int	 fprintf(FILE * __restrict, const char * __restrict, ...) __DARWIN_LDBL_COMPAT(fprintf);//c

#ifndef native_sprintf
int	 sprintf(char * __restrict, const char * __restrict, ...) __DARWIN_LDBL_COMPAT(sprintf);//c
#endif

//////////////
/*FFLUSH(3)                BSD Library Functions Manual                FFLUSH(3)

NAME
     fflush, fpurge -- flush a stream

LIBRARY
     Standard C Library (libc, -lc)

SYNOPSIS
     #include <stdio.h>

     int
     fflush(FILE *stream);

     int
     fpurge(FILE *stream);

DESCRIPTION
     The function fflush() forces a write of all buffered data for the given output or update stream via the
     stream's underlying write function.  The open status of the stream is unaffected.

     If the stream argument is NULL, fflush() flushes all open output streams.

     The function fpurge() erases any input or output buffered in the given stream.  For output streams this
     discards any unwritten output.  For input streams this discards any input read from the underlying
     object but not yet obtained via getc(3); this includes any text pushed back via ungetc(3).

RETURN VALUES
     Upon successful completion 0 is returned.  Otherwise, EOF is returned and the global variable errno is
     set to indicate the error.

ERRORS
     [EBADF]            The stream argument is not an open stream, or, in the case of fflush(), not a stream
                        open for writing.

     The function fflush() may also fail and set errno for any of the errors specified for the routine
     write(2).

SEE ALSO
     write(2), fclose(3), fopen(3), setbuf(3)

STANDARDS
     The fflush() function conforms to ISO/IEC 9899:1990 (``ISO C90'').

BSD                              June 4, 1993                              BSD*/

     int fpurge(FILE *stream){};

/*FGETLN(3)                BSD Library Functions Manual                FGETLN(3)

NAME
     fgetln -- get a line from a stream

LIBRARY
     Standard C Library (libc, -lc)

SYNOPSIS
     #include <stdio.h>

     char *
     fgetln(FILE *stream, size_t *len);

DESCRIPTION
     The fgetln() function returns a pointer to the next line from the stream referenced by stream.  This
     line is not a C string as it does not end with a terminating NUL character.  The length of the line,
     including the final newline, is stored in the memory location to which len points.  (Note, however,
     that if the line is the last in a file that does not end in a newline, the returned text will not con-tain contain
     tain a newline.)

RETURN VALUES
     Upon successful completion a pointer is returned; this pointer becomes invalid after the next I/O oper-ation operation
     ation on stream (whether successful or not) or as soon as the stream is closed.  Otherwise, NULL is
     returned.  The fgetln() function does not distinguish between end-of-file and error; the routines
     feof(3) and ferror(3) must be used to determine which occurred.  If an error occurs, the global vari-able variable
     able errno is set to indicate the error.  The end-of-file condition is remembered, even on a terminal,
     and all subsequent attempts to read will return NULL until the condition is cleared with clearerr(3).

     The text to which the returned pointer points may be modified, provided that no changes are made beyond
     the returned size.  These changes are lost as soon as the pointer becomes invalid.

ERRORS
     [EBADF]            The argument stream is not a stream open for reading.

     The fgetln() function may also fail and set errno for any of the errors specified for the routines
     fflush(3), malloc(3), read(2), stat(2), or realloc(3).

SEE ALSO
     ferror(3), fgets(3), fgetwln(3), fopen(3), putc(3)

HISTORY
     The fgetln() function first appeared in 4.4BSD.

BSD                             April 19, 1994                             BSD*/
     char *fgetln(FILE *stream, size_t *len){};

