#include <sys/acl.h>
	 
int	acl_get_flag_np(acl_flagset_t flagset_d, acl_flag_t flag){};//c

#ifndef __CYGWIN__
int	acl_get_entry(acl_t acl, int entry_id, acl_entry_t *entry_p){};//c
int	acl_delete_entry(acl_t acl, acl_entry_t entry_d){};//c
 int	acl_free(void *obj_p){};//c
int	acl_set_qualifier(acl_entry_t entry_d, const void *tag_qualifier_p){};//c
int 	acl_get_permset(acl_entry_t entry_d, acl_permset_t *permset_p){};//c
 int	acl_add_perm(acl_permset_t permset_d, acl_perm_t perm){};//c
int	acl_set_permset(acl_entry_t entry_d, acl_permset_t permset_d){};//c
int	acl_set_tag_type(acl_entry_t entry_d, acl_tag_t tag_type){};//c
acl_t	acl_init(int count){};//c
#endif//__CYGWIN__

///////////////////
/*	 ACL_GET_FLAGSET_NP(3)    BSD Library Functions Manual    ACL_GET_FLAGSET_NP(3)

NAME
     acl_get_flagset_np -- retrieve flag set from an ACL or ACL entry

LIBRARY
     Standard C Library (libc, -lc)

SYNOPSIS
     #include <sys/types.h>
     #include <sys/acl.h>

     int
     acl_get_flagset_np(void *obj, acl_flagset_t *flagset_p);

DESCRIPTION
     The acl_get_flagset_np() function is a nonstandard extension that returns
     via flagset_p a descriptor to the flag set in the ACL or ACL entry obj.
     Subsequent operations using the returned flag set operate on the permis-sion permission
     sion set within the ACL or ACL entry.

RETURN VALUES
     The acl_get_flagset() function returns the value 0 if successful; other-wise otherwise
     wise the value -1 is returned and the global variable errno is set to
     indicate the error.

ERRORS
     The acl_get_flagset() function fails if:

     [EINVAL]           Argument obj is not a valid descriptor for an ACL or
                        ACL entry.

SEE ALSO
     acl(3), acl_add_flag_np(3), acl_clear_flags_np(3), acl_delete_flag_np(3),
     acl_set_flagset_np(3)

AUTHORS
     Michael Smith
     Chris D. Faulhaber

BSD                             March 10, 2001                             BSD*/
	
int acl_get_flagset_np(void *obj, acl_flagset_t *flagset_p){}; 


/*ACL_CREATE_ENTRY(3)      BSD Library Functions Manual      ACL_CREATE_ENTRY(3)

NAME
     acl_create_entry, acl_create_entry_np -- create a new ACL entry

LIBRARY
     Standard C Library (libc, -lc)

SYNOPSIS
     #include <sys/types.h>
     #include <sys/acl.h>

     int
     acl_create_entry(acl_t *acl_p, acl_entry_t *entry_p);

     int
     acl_create_entry_np(acl_t *acl_p, acl_entry_t *entry_p, int entry_index);

DESCRIPTION
     The acl_create_entry() function is a POSIX.1e call that creates a new ACL
     entry in the ACL pointed to by acl_p.

     The acl_create_entry_np() function is a non-portable extension which
     allows the caller to specify the position of the created entry within the
     ACL.  If entry_index is ACL_FIRST_ENTRY the entry will be created at the
     head of the ACL.  If entry_index is ACL_LAST_ENTRY the entry will be cre-ated created
     ated at the end of the ACL.  After inserting an ACL entry with an
     entry_index other than ACL_LAST_ENTRY the behaviour of any acl_entry_t's
     previously obtained from the ACL by acl_create_entry() or acl_get_entry()
     is undefined.

RETURN VALUES
     The acl_create_entry() function returns the value 0 if successful; other-wise otherwise
     wise the value -1 is returned and the global variable errno is set to
     indicate the error.

ERRORS
     The acl_create_entry() and acl_create_entry_np() functions fail if:

     [EINVAL]           Argument acl_p does not point to a pointer to a valid
                        ACL.

     [ENOMEM]           The ACL working storage requires more memory than is
                        allowed by the hardware or system-imposed memory man-agement management
                        agement constraints.

     [ERANGE]           The entry_index argument to acl_create_entry_np() is
                        greater than the number of entries in the ACL.

SEE ALSO
     acl(3), acl_delete_entry(3), acl_get_entry(3), posix1e(3)

STANDARDS
     POSIX.1e is described in IEEE POSIX.1e draft 17.

AUTHORS
     Michael Smith
     Chris D Fulhaber

BSD                             March 16, 2001                             BSD*/
   int acl_create_entry_np(acl_t *acl_p, acl_entry_t *entry_p, int entry_index){};
