//#include <stdio.h>
#include <xlocale/_stdio.h>


/*PRINTF_L(3)              BSD Library Functions Manual              PRINTF_L(3)

NAME
     asprintf_l, fprintf_l, printf_l, snprintf_l, sprintf_l, vasprintf_l, vfprintf_l, vprintf_l,
     vsnprintf_l, vsprintf_l -- formatted output conversion

LIBRARY
     Standard C Library (libc, -lc)

SYNOPSIS
     #include <stdio.h>
     #include <xlocale.h>

     int
     asprintf_l(char **ret, locale_t loc, const char *format, ...);

     int
     fprintf_l(FILE * restrict stream, locale_t loc, const char * restrict format, ...);

     int
     printf_l(locale_t loc, const char * restrict format, ...);

     int
     snprintf_l(char * restrict str, size_t size, locale_t loc, const char * restrict format, ...);

     int
     sprintf_l(char * restrict str, locale_t loc, const char * restrict format, ...);

     #include <stdarg.h>
     #include <xlocale.h>

     int
     vasprintf_l(char **ret, locale_t loc, const char *format, va_list ap);

     int
     vfprintf_l(FILE * restrict stream, locale_t loc, const char * restrict format, va_list ap);

     int
     vprintf_l(locale_t loc, const char * restrict format, va_list ap);

     int
     vsnprintf_l(char * restrict str, size_t size, locale_t loc, const char * restrict format, va_list ap);

     int
     vsprintf_l(char * restrict str, locale_t loc, const char * restrict format, va_list ap);

DESCRIPTION
     The printf_l(), fprintf_l(), sprintf_l(), snprintf_l(), asprintf_l(), vprintf_l(), vfprintf_l(),
     vsprintf_l(), vsnprintf_l(), and vasprintf_l() functions are extended locale versions of the printf(),
     fprintf(), sprintf(), snprintf(), asprintf(), vprintf(), vfprintf(), vsprintf(), vsnprintf(), and
     vasprintf() functions, respectively.  Refer to their manual pages for details.  Also, see xlocale(3)
     for more information about extended locales.

SEE ALSO
     printf(3), xlocale(3)

BSD                             March 11, 2005                             BSD*/
     int  fprintf_l(FILE *  stream, locale_t loc, const char *  format, ...){};
     int      snprintf_l(char *  str, size_t size, locale_t loc, const char *  format, ...){};

