#include <string.h>
#include <xlocale/_stdlib.h>


/*STRTOD_L(3)              BSD Library Functions Manual              STRTOD_L(3)

NAME
     strtod_l, strtof_l, strtold_l -- convert ASCII string to floating point

LIBRARY
     Standard C Library (libc, -lc)

SYNOPSIS
     #include <stdlib.h>
     #include <xlocale.h>

     double
     strtod_l(const char * restrict nptr, char ** restrict endptr, locale_t loc);

     float
     strtof_l(const char * restrict nptr, char ** restrict endptr, locale_t loc);

     long double
     strtold_l(const char * restrict nptr, char ** restrict endptr, locale_t loc);

DESCRIPTION
     The strtod_l(), strtof_l(), and strtold_l() functions are extended locale versions of the strtod(),
     strtof(), and strtold() functions, respectively.  Refer to their manual pages for details.  Also, see
     xlocale(3) for more information about extended locales.

SEE ALSO
     strtod(3), xlocale(3)

BSD                             March 11, 2005                             BSD*/

#ifndef native_strtod_l
     double strtod_l(const char *  nptr, char **  endptr, locale_t loc){};
#endif

/*STRTOL_L(3)              BSD Library Functions Manual              STRTOL_L(3)

NAME
     strtol_l, strtoll_l, strtoimax_l, strtoq_l, strtoul_l, strtoull_l, strtoumax_l, strtouq_l -- convert a
     string value to a long, long long, intmax_t, quad_t unsigned long, unsigned long long, uintmax_t, or
     u_quad_t integer

LIBRARY
     Standard C Library (libc, -lc)

SYNOPSIS
     #include <stdlib.h>
     #include <limits.h>
     #include <xlocale.h>

     long
     strtol_l(const char * restrict nptr, char ** restrict endptr, int base, locale_t loc);

     long long
     strtoll_l(const char * restrict nptr, char ** restrict endptr, int base, locale_t loc);

     unsigned long
     strtoul_l(const char * restrict nptr, char ** restrict endptr, int base, locale_t loc);

     unsigned long long
     strtoull_l(const char * restrict nptr, char ** restrict endptr, int base, locale_t loc);

     #include <inttypes.h>
     #include <xlocale.h>

     intmax_t
     strtoimax_l(const char * restrict nptr, char ** restrict endptr, int base, locale_t loc);

     uintmax_t
     strtoumax_l(const char * restrict nptr, char ** restrict endptr, int base, locale_t loc);

     #include <sys/types.h>
     #include <stdlib.h>
     #include <limits.h>
     #include <xlocale.h>

     quad_t
     strtoq_l(const char *nptr, char **endptr, int base, locale_t loc);

     u_quad_t
     strtouq_l(const char *nptr, char **endptr, int base, locale_t loc);

DESCRIPTION
     The strtol_l(), strtoll_l(), strtoimax_l(), strtoq_l(), strtoul_l(), strtoull_l(), strtoumax_l(), and
     strtouq_l() functions are extended locale versions of the strtol(), strtoll(), strtoimax(), strtoq(),
     strtoul(), strtoull(), strtoumax(), and strtouq() functions, respectively.  Refer to their manual pages
     for details.  Also, see xlocale(3) for more information about extended locales.

SEE ALSO
     strtol(3), strtoul(3), xlocale(3)

BSD                             March 11, 2005                             BSD*/

#ifndef native_strtoul_l
     unsigned long     strtoul_l(const char * nptr, char **  endptr, int base, locale_t loc){};
#endif

#ifndef native_strtol_l
     long     strtol_l(const char *nptr, char ** endptr, int base, locale_t loc){};
#endif
